==============================================================================

FILE:    README
UPDATED: 06/20/01  A.M.
         Aug 02    S.Z

==============================================================================

These files are provided as an aid to the user for examples in how to use the
HDF-EOS library.  The test drivers have been run on every platform supported
by the Toolkit.  Platforms supported by the Toolkit are listed in the 
README file located in doc directory.

NOTE:  YOU MUST HAVE ALL OF THE TEXT DATA FILES IN THE SAME DIRECTORY AS YOUR 
       POINT TEST DRIVERS.  THEY WILL CRASH WITHOUT THEM !
 
       THESE DATA FILES ARE:

							fixedBuoy0.txt
							fixedBuoy1s.txt
							floatBuoy1.txt
							fixedBuoy1.txt
							floatBuoy0.txt
							simple.txt



DRIVER(S)			    PLATFORM(S)
=========			    ===========

TestSwath.c			    C on all supported platforms
TestGrid.c
TestPoint.c
TestZa.c
TestProfile.c
TestAlias.c

testswath32.f			FORTRAN 77 on all supported platforms
testgrid32.f			FORTRAN 90 on SGI for 32-bit
testpoint32.f
testza32.f

testswath64.f			FORTRAN 90 on SGI for 64-bit
testgrid64.f
testpoint64.f
testza64.f


COMPILING TEST DRIVERS
======================

Below are samples of how the test driver can be compilied and linked to create 
executables.

The HDFSYS flag is set by the user.  The list below gives what it should be
for each supported platform:

PLATFORM		    HDFSYS FLAG
========		    ===========

Dec			        DEC_ALPHA
Sgi			        IRIX
Sgi Power Chall.	SGI64
Ibm			        IBM6000
Sun Solaris 2.5		SUN5
Hp			        HP9000
Linux               LINUX


==============================================================================
                              Swath/Point/ZA 
------------------------------------------------------------------------------

cc -DHDFSYS -o filename.o -I$HDFINC -I$HDFEOS_INC -c filename.c
cc -DHDFSYS -o filename filename.o -L$HDFLIB -L$HDFEOS_LIB \
        -lhe5_hdfeos -lhdf5 -lnsl -lm

NOTE: substitute "filename" with the name of a driver, AND THE ORDER OF THE 
      LIBRARIES IS IMPORTANT. 
      IN ADDITION: NOTICE THAT WE POINT TO BOTH STANDARD HDF AND HDFEOS 
      LIBRARIES. 
      THE "-lnsl" FLAG IS REQUIRED FOR THE SUN PLATFORMS ONLY	


==============================================================================
                                Grid 
------------------------------------------------------------------------------

cc -DHDFSYS -o filename.o -I$HDFINC -I$HDFEOS_INC -c filename.c
cc -DHDFSYS -o filename filename.o -L$HDFLIB -L$HDFEOS_LIB \
        -lhe5_hdfeos -lGctp -lhdf5 -lnsl -lm
       
NOTE: ON LINUX PLATFORM YOU ALSO NEED "-lz"
  
NOTE: subsitute "filename" with the name of a driver, AND THE ORDER OF THE 
      LIBRARIES IS IMPORTANT.  
      IN ADDITION:  NOTICE THAT THE GCTP LIBRARY IS SECOND IN THE LIBRARY 
      LIST.
      ALSO: YOU NEED TO POINT TO WHERE THE GEOLIB LIBRARY IS LOCATED ON 
      YOUR SYSTEM.
      THE "-lnsl" FLAG IS REQUIRED FOR THE SUN PLATFORMS ONLY


==============================================================================

Installing HDF-EOS5 using Autoconf/Automake
-------------------------------------------

Prerequisite
------------
The HDF-EOS5 library requires HDF5 library version 1.8.19 or later. You can download HDF5
from the HDF Group:

    https://www.hdfgroup.org/downloads/hdf5/

or, depending upon your system, you may be able to install it from a package. The HDF5
libary may depend upon other libraries, such as szip, z (compress). The HDF-EOS5
configure script will do its best to determine these dependencies and find the appropriate
libraries, but it may occasionally need help. Please refer to the troubleshooting section
at the bottom of this document.



Configuring
-----------
After downloading and unpacking the tar file, 'cd' into the hdfeos5 directory and type

    ./configure

This will run a series of tests to determine the necessary library dependencies, and
configure the makefiles accordingly. The configure script will output a summary of the
configuration options at completion. These can be useful for troubleshooting.

By default, the HDF-EOS5 libraries and include headers will be installed in /usr/local. This
can be changed by using the --prefix option when running configure, e.g.

    ./configure --prefix=/custom/install/location

A number of other options may be provided to the configure script. You can get details
of these options using the command:

    ./configure --help




Building
--------

Once configured, you can build HDF-EOS5 by simply type

    make

from the hdfeos5 directory.


Tests
-----
The HDF-EOS5 library comes with some tests. You can run these using the command

    make check

from the hdfeos5 directory. These test may provide useful examples, but USE AT YOUR
OWN RISK.



Installing
--------

To install HDF-EOS5, simply type

    make install

from the hdfeos5 directory. You need to make sure you have the necessary permissions to
install the files in the chosen location.





Troubleshooting
---------------

General
-------
This section contains general troubleshooting tips. Additional sections below detail
known issues for specific platforms.

* Determining HDF5 Dependencies

    It can be difficult to find out what additional libraries HDF5 depends upon. This is usually
    just libz, but may also include libsz. You can get an idea of the dependencies
    by using the h5cc tool (you may have to search for this):

        h5cc -show

    This will produce output similar to the following:

        gcc -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_BSD_SOURCE -O0 -g -pipe -Wall
            -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4
            -grecord-gcc-switches -m64 -mtune=generic -L/usr/lib64 /usr/lib64/libhdf5_hl.a
            /usr/lib64/libhdf5.a -Wl,-z,relro -lsz -lz -ldl -lm -Wl,-rpath -Wl,/usr/lib64

    It lists the libraries that HDF5 (and hence HDF-EOS5) programs will need to link against.
    In this case we can see both -lsz (libsz) and -lz (libz).


* Finding libraries

    Most of the libraries need by HDF5 and HDF-EOS5 should be found automatically by
    the configure script, but if it cannot find them, you will need to provide that
    information to the configure script explicitly. If you need to find a library on
    your system, you can do this with a simple command: e.g. To find the sz library:

        find / -name 'libsz.*'

    This might produce output as follows:

        /usr/lib64/libsz.so
        /usr/lib64/libsz.so.2
        /usr/lib64/libsz.so.2.0.1

    In this case, we have a dynamic (shared) sz library in /usr/lib64  We can tell configure
    where to find it as follows:

        ./configure --with-szlib=/usr/lib64

    If you cannot find a particular library, you will need to install the appropriate
    package.


* Installing missing packages

    Linux distributions generally use a package manager to install software packages, though
    the specific tool varies depending upon the distribution. For example, Centos may use
    'yum' while Ubuntu may use 'apt'.

    Max OSX systems, while 'Linux like', does not have an official package management tool like
    the Linux systems. However, there are independently developed tools such as
    MacPorts (https://www.macports.org/) and HomeBrew (https://brew.sh/) which are just
    as capable, and can provide everything you need.

    Packages often come in two different 'flavors' - regular, and 'devel'. The regular versions
    contain the libraries needed to run programs that use them. The 'devel' packages are
    developer oriented packages that include headers files needed to compile your own
    programs using that use the libraries. The following is a list of the key packages
    needed by HDF-EOS5:

        hdf5    The main HDF5 package. A 'devel' version is needed since HDF-EOS5 compiles
                against this library and needs the header files.

        zlib    Compression library. A regular version can be used since HDF-EOS5 does not
                explicity invoke compression functions.

        aec     Adaptive Entropy Encoding library (szip). This may or may not be needed,
                depending upon how HDF5 was built. If you have access to the h5cc commmand,
                you can use 'h5cc -show' to determine whether or not it is needed. If
                the output contains '-lsz', then you need aec. Most package versions of
                HDF5 do not use aec. If required, a regular version can be used.

    Examples of command to install packages on some of the common linux distributions are
    given below.




Linux (Ubuntu/Debian)
---------------------

* Finding/Installing packages

    These distributions tend to use 'apt' as the package manager. You can search for packages
    using apt as follows:

        apt-cache search hdf

    A package can be installed as follows:

        apt-get install libhdf4-dev

    One of the advantages of package managers is that if you install a package in this way, it
    will also install all the dependencies required by the package. You can see which additional
    packages a given package depends on as follows:

        apt-cache depends libhdf4-dev

    This is also a good way to determine whether or not aec is required.



Linux (Redhat/Centos)
---------------------

* Finding/Installing packages

    These distributions tend to use 'yum' as the package manager. You can search for packages
    using yum as follows:

        yum search hdf5

    A package can be installed as follows:

        yum install hdf5-devel

    One of the advantages of package managers is that if you install a package in this way, it
    will also install all the dependencies required by the package. You can see which additional
    packages a given package depends on as follows:

        yum deplist hdf5-devel

    This is also a good way to determine whether or not aec is required.



Mac OSX
-------

* Finding/Installing packages using MacPorts

    You can search for packages using MacPorts as follows:

        port search --name "*hdf5*"

    A package can be installed as follows (you may need to run this using sudo):

        port install hdf5

    As with Linux base package managers, MacPorts will also install all the depenencies required
    by a package. You can see which additional packages a given package depends on as follows:

        port info hdf5

    Look for a line beginning 'Library Dependencies'. You can ignore any line beginning with
    'Build Dependencies' since you will not be building HDF5.


* Missing library 'System'.

    If your build fails with a message indicating it cannot find a library called 'System',
    try adding the following configure option:

    ./configure LDFLAGS=-L/usr/local

    This gives the location of the library to the linker.

**********************************************************************
*    This directory provides sample programs for the user to run to  *
*    check if the HDFEOS_5 library installed correctly. Below is a   *
*     description of what routines are available and the order in    *
*                which the routines should be run.                   *
*    Updated: 06/20/01  A.M.                                         *
*             Aug 02    S.Z                                          *
**********************************************************************


                   Swath Demonstration Programs
                   ----------------------------

A. C - programs
~~~~~~~~~~~~~~~   
   	he5_sw_setup        --- creates HDFEOS_5 swath file "Swath.h5"; 
                            sets a single swath structure "Swath1"; 
                            defines dimensions and the geolocation 
                            relations between them.
	
	he5_sw_definefields	--- defines a number of fields within the swath.
	
	he5_sw_writedata    --- writes data to the "Longitude", "Latitude", 
                            and "Spectra" fields; sets up global, group, 
			                and local attributes.

	he5_sw_readdata     --- reads data from the "Longitude" field; reads 
                            global, group, and local attributes.

	he5_sw_info         --- retrieves and displays information on the 
                            swath dimensions, geolocation relations, 
                            swath fields, and (global/group/local) 
                            attributes.

    he5_sw_datainfo     --- retrieves data type information for a 
                            specified object (field, attribute).

	he5_sw_subset       --- demonstrates subsetting on the "Spectra" field.


    he5_sw_defunlimfld  --- same as 'he5_sw_definefields' but defines 
                            "Spectra" field as having unlimited dimension.

    he5_sw_wrunlimfld   --- same as 'he5_sw_writedata' but writes data to 
                            the "Spectra" field twice.

    he5_sw_wrextendrd   --- demonstrates usage of unlimited dimension for 
                            appendible field "Count".


    Sequence of calls:
                     
          1. he5_sw_setup
             he5_sw_definefields
             he5_sw_writedata 
             he5_sw_readdata 
             he5_sw_info 
             he5_sw_datainfo 
             he5_sw_subset   

          2. he5_sw_setup
             he5_sw_defunlimfld
             he5_sw_wrunlimfld
             he5_sw_subset

          3. he5_sw_setup
             he5_sw_definefields
             he5_sw_wrextendrd


	Example of working with external data files
    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	he5_sw_setup               ---   creates HDFEOS_5 swath file "Swath.h5"; 
                                     sets a single swath structure "Swath1"; 
                                     defines dimensions (including dimension 
                                     of external data set) and the geolocation 
                                     relations between them.
    he5_sw_defexternalfld      ---   defines external field (data set)
    he5_sw_rdexternaldata      ---   reads data from external data file(s) to 
                                     the external field
    he5_sw_wrexternaldata      ---   writes data to external field/data file(s)  



B. FORTRAN-77 programs
~~~~~~~~~~~~~~~~~~~~~~
	he5_sw_setupF_64          ---  see 'he5_sw_setup', creates "swath.h5" file.
	(he5_sw_setupF_32)
  
    he5_sw_definefieldsF_64   ---  see  'he5_sw_definefields'
    (he5_sw_definefieldsF_32)

    he5_sw_writedataF_64      ---  see  'he5_sw_writedata'
    (he5_sw_writedataF_32)

    he5_sw_readdataF_64       ---  see  'he5_sw_readdata'
    (he5_sw_readdataF_32)

    he5_sw_infoF_64           ---  see  'he5_sw_info'
    (he5_sw_infoF_32)

    he5_sw_subsetF_64         ---  see  'he5_sw_subset'
    (he5_sw_subsetF_32)
  

	Sequence of calls:

	      he5_sw_setupF_64         (...F_32)
          he5_sw_definefieldsF_64  (...F_32)
          he5_sw_writedataF_64     (...F_32)
          he5_sw_readdataF_64      (...F_32)
          he5_sw_infoF_64          (...F_32)
          he5_sw_subsetF_64        (...F_32)




===========================================================================

                   Grid Demonstration Programs
                   ---------------------------

A. C - programs
~~~~~~~~~~~~~~~   
   	he5_gd_setup        --- creates HDFEOS_5 grid file "Grid.h5"; 
                            sets two grid structures. 
	
	he5_gd_definefields	--- defines fields within the two grids.
	
	he5_gd_writedata    --- writes data to the fields within the two 
                            grids; sets up global, group, and local 
                            attributes. 

	he5_gd_readdata     --- reads data from the fields; reads 
                            global, group, and local attributes.

	he5_gd_info         --- retrieves and displays information on the 
                            grid dimensions, projections, grid fields, 
                            and (global/group/local) attributes.

    he5_gd_datainfo     --- retrieves data type information for a 
                            specified object (field, attribute).

	he5_gd_subset       --- demonstrates subsetting on the "Temperature" 
                            field in the "PolarGrid" grid.


    he5_gd_defunlimfld  --- defines "Vegetation" field having unlimited 
                            dimension.

    he5_gd_wrunlimfld   --- sequentially writes data buffers of different 
                            size to the "Vegetation" field.

    Sequence of calls:
                     
          1. he5_gd_setup
             he5_gd_definefields
             he5_gd_writedata 
             he5_gd_readdata 
             he5_gd_info 
             he5_gd_datainfo 
             he5_gd_subset   

          2. he5_gd_setup
             he5_gd_defunlimfld
             he5_gd_wrunlimfld


	Example of working with external data files
    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	he5_gd_setup               ---   creates HDFEOS_5 grid file "Grid.h5"; 
                                     sets two grid structures; defines 
                                     dimensions (including dimension of 
                                     external data set).
    he5_gd_defexternalfld      ---   defines external field (data set)
    he5_gd_rdexternaldata      ---   reads data from external data file(s) to 
                                     the external field
    he5_gd_wrexternaldata      ---   writes data to external field/data file(s)  


B. FORTRAN-77 programs
~~~~~~~~~~~~~~~~~~~~~~
	he5_gd_setupF_64          ---  see 'he5_gd_setup'; creates "grid.h5" file.
	(he5_gd_setupF_32)
  
    he5_gd_definefieldsF_64   ---  see  'he5_gd_definefields'
    (he5_gd_definefieldsF_32)

    he5_gd_writedataF_64      ---  see  'he5_gd_writedata'
    (he5_gd_writedataF_32)

    he5_gd_readdataF_64       ---  see  'he5_gd_readdata'
    (he5_gd_readdataF_32)

    he5_gd_infoF_64           ---  see  'he5_gd_info'
    (he5_gd_infoF_32)

    he5_gd_subsetF_64         ---  see  'he5_gd_subset'
    (he5_gd_subsetF_32)
  

	Sequence of calls:

	      he5_gd_setupF_64            (...F_32)
          he5_gd_definefieldsF_64     (...F_32)
          he5_gd_writedataF_64        (...F_32)
          he5_gd_readdataF_64         (...F_32)
          he5_gd_infoF_64             (...F_32)
          he5_gd_subsetF_64           (...F_32)

===========================================================================


                   Point Demonstration Programs
                   ----------------------------

The sample codes described below use the following input data files 
(make sure these files are in the same directory with the sample codes) :

	fixedBuoy0.txt
	fixedBuoy1s.txt
	floatBuoy1.txt
	fixedBuoy1.txt
	floatBuoy0.txt
	simple.txt


A. C - programs
~~~~~~~~~~~~~~~   
   	he5_pt_setup        --- creates HDFEOS_5 point file "Point.h5"; 
	
	he5_pt_definelevels	--- defines levels within the point.
	
	he5_pt_writedata    --- writes data to the specified levels.

	he5_pt_writeattrs   --- writes attributes.

	he5_pt_readdata     --- reads data from a level.

	he5_pt_readattrs    --- reads attributes.

	he5_pt_updatelevels --- updates level data.

    he5_pt_datainfo     --- retrieves data type information for a 
                            specified object within point.

    Sequence of calls:
                     
             he5_pt_setup
             he5_pt_definelevels
             he5_pt_writedata 
               he5_pt_writeattrs 
             he5_pt_readdata 
               he5_pt_readattrs 
             he5_pt_updatelevels
             he5_pt_datainfo 


B. FORTRAN-77 programs
~~~~~~~~~~~~~~~~~~~~~~
	he5_pt_setupF_64          ---  see 'he5_pt_setup'; creates "point.h5" file.
	(he5_pt_setupF_32)
  
    he5_pt_definelevelsF_64   ---  see  'he5_pt_definelevels'
    (he5_pt_definelevelsF_32)

    he5_pt_writedataF_64      ---  see  'he5_pt_writedata'
    (he5_pt_writedataF_32)

		he5_pt_writeattrsF_64      ---  see  'he5_pt_writeattrs'
		(he5_pt_writeattrsF_32)

    he5_pt_readdataF_64       ---  see  'he5_pt_readdata'
    (he5_pt_readdataF_32)

		he5_pt_readattrsF_64       ---  see  'he5_pt_readattrs'
		(he5_pt_readattrsF_32)

    he5_pt_updatelevelsF_64   ---  see  'he5_pt_updatelevels'
    (he5_pt_updatelevelsF_32)

    he5_pt_datainfoF_64       ---  see  'he5_pt_datainfo'
    (he5_pt_datainfoF_32)
  

	Sequence of calls:

	      he5_pt_setupF_64            (...F_32)
          he5_pt_definelevelsF_64     (...F_32)
          he5_pt_writedataF_64        (...F_32)
          he5_pt_writeattrsF_64       (...F_32)
          he5_pt_readdataF_64         (...F_32)
          he5_pt_readattrsF_64        (...F_32)
          he5_pt_updatelevelsF_64     (...F_32)
          he5_pt_datainfoF_64         (...F_32)


         
=====================================================================


                   ZA Demonstration Programs
                   -------------------------
 
A. C - programs
~~~~~~~~~~~~~~
        he5_za_setup        --- creates HDFEOS_5 za file "ZA.h5";
                            sets a single za structure "ZA1";
                            defines dimensions.
 
        he5_za_definefields --- defines a number of fields within the za.
 
        he5_za_writedata    --- writes data to the "Spectra" field;
                            sets up global, group, and local attributes.
 
        he5_za_readdata     --- reads data from the "Spectra" field; reads
                            global, group, and local attributes.
 
        he5_za_info         --- retrieves and displays information on the
                            za dimensions, and (global/group/local)
                            attributes.
 
        he5_za_datainfo     --- retrieves data type information for a
                            specified object (field, attribute).
 
 
    Sequence of calls:
 
        he5_za_setup
        he5_za_definefields
        he5_za_writedata
        he5_za_readdata
        he5_za_info
        he5_za_datainfo
 

    Example of working with external data files
    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    he5_za_setup               ---   creates HDFEOS_5 za file "ZA.h5";
                                     sets a single za structure "ZA1";
                                     defines dimensions (including dimension
                                     of external data set). 
    he5_za_defexternalfld      ---   defines external field (data set)
    he5_za_rdexternaldata      ---   reads data from external data file(s) to
                                     the external field
    he5_za_wrexternaldata      ---   writes data to external field/data file(s)
 

 
B. FORTRAN-77 programs
~~~~~~~~~~~~~~~~~~~~~
    he5_za_setupF_64          ---  see 'he5_za_setup', creates "za.he5" file.
    (he5_za_setupF_32)
 
    he5_za_definefieldsF_64   ---  see  'he5_za_definefields'
    (he5_za_definefieldsF_32)
 
    he5_za_writedataF_64      ---  see  'he5_za_writedata'
    (he5_za_writedataF_32)
 
    he5_za_readdataF_64       ---  see  'he5_za_readdata'
    (he5_za_readdataF_32)
 
    he5_za_infoF_64           ---  see  'he5_za_info'
    (he5_za_infoF_32)
 
 
 
        Sequence of calls:
 
          he5_za_setupF_64         (...F_32)
          he5_za_definefieldsF_64  (...F_32)
          he5_za_writedataF_64     (...F_32)
          he5_za_readdataF_64      (...F_32)
          he5_za_infoF_64          (...F_32)
 

======================================================================================

      program     he5_za_writedimscaleF_32

      implicit    none

      include     'hdfeos5.inc'

      integer     status
      integer     i, j
      integer     he5_zaopen
      integer     he5_zaattach
      integer     he5_zawrfld
      integer     he5_zawrattr
      integer     he5_zawrgattr
      integer     he5_ehwrglatt
      integer     he5_zawrlattr 
      integer     he5_zadetach
      integer     he5_zaclose
      integer     HE5_ZAsetdimscale
      integer     HE5_ZAwritedscaleattr

      integer     zafid,zaid1
      integer*4   datbuf_i1(1) 
      integer*4   datbuf_i(15)
      integer     count(2)
      integer*4   nbands
      integer     bands(3)
      integer*4   datbuf_i2(2)
      integer     xdim, ydim, ntime
      integer     data(15)
      integer     FAIL
      parameter   (FAIL=-1)



!  /*
!   * We first open the HDF-EOS zaath file, "za.he5".  Because this file
!   * already exist and we wish to write to it, we use the H5F_ACC_RDWR access
!   * code in the open statement.  The HE5_ZAopen routine returns the zaath file
!   * id, zafid, which is used to identify the file in subsequent routines.
!   */ 
      nbands = 15
      do j=1,nbands
         data(j)=(j+1)*2
      enddo

      zafid = HE5_ZAopen("za.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_zaopen(): ',zafid
!  /*
!   * If the zaath file cannot be found, HE5_ZAopen will return -1 for the file
!   * handle (zafid).  We there check that this is not the case before
!   * proceeding with the other routines.
!   * 
!   * The HE5_ZAattach routine returns the handle to the existing zaath "ZA1",
!   * ZAid.  If the zaath is not found, HE5_ZAattach returns -1 for the handle.
!   */ 

      if (zafid .ne. FAIL) then
 
         ZAid1 = HE5_ZAattach(zafid, "ZA1")
         write(*,*) 'Za ID returned by he5_zaattach(): ',zaid1

!      /* the field Spectra has Bands,Res2tr,Res2xtr dimensions. 
!	 xdim = 120;
!	 ydim = 200;
!	 Time dim is set to 10
!      */

         if (ZAid1 .eq. -1) then
            
            write(*,*) 'Error: Cannot attach to zaath ZA1. Stpped.'
            status = HE5_ZAclose(zafid)
            stop
            
         endif
                  
         status = HE5_ZAsetdimscale(ZAid1, "Spectra", "Bands", nbands,
     1                               HE5T_NATIVE_INT, data)
         write(*,*) 'Status returned by HE5_ZAsetdimscale: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale for Bands',
     1                 ' dimemnsion in field Vegetation'
            status = HE5_ZAdetach(ZAid1)
            status = HE5_ZAclose(zafid)
            stop
         endif

         count(1)= 12
         status = HE5_ZAwritedscaleattr(ZAid1, "Bands", "label", 
     1                         HE5T_NATIVE_CHAR, count, "Bands Dim")
         write(*,*) 'Status returned by HE5_ZAwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1                ' dimemnsion in field Spectra'
            status = HE5_ZAdetach(ZAid1)
            status = HE5_ZAclose(zafid)
            stop
         endif
         
         count(1)= 6
         status = HE5_ZAwritedscaleattr(ZAid1, "Bands", "unit", 
     1                              HE5T_NATIVE_CHAR, count, "None")
         write(*,*) 'Status returned by HE5_ZAwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1                 ' dimemnsion in field Spectra'
            status = HE5_ZAdetach(ZAid1)
            status = HE5_ZAclose(zafid)
            stop
         endif
         
         count(1)= 4
         status = HE5_ZAwritedscaleattr(ZAid1, "Bands", "format", 
     1                                 HE5T_NATIVE_CHAR, count, "I2")
         write(*,*) 'Status returned by HE5_ZAwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1                 ' dimemnsion in field Spectra'
            status = HE5_ZAdetach(ZAid1)
            status =  HE5_ZAclose(zafid)
            stop
         endif

         datbuf_i1(1) = -999
         count(1)= 1
         status = HE5_ZAwritedscaleattr(ZAid1, "Bands", "MissingValue",
     1                             HE5T_NATIVE_INT, count, datbuf_i1)
         write(*,*) 'Status returned by HE5_ZAwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1                 ' dimemnsion in field Spectra'
            status = HE5_ZAdetach(ZAid1)
            status = HE5_ZAclose(zafid)
            stop
         endif
         
         datbuf_i(1) =  -999
         datbuf_i(2) =  0
         datbuf_i(3) =  999


         count(1)= 3
         status = HE5_ZAwritedscaleattr(ZAid1, "Bands", "IntValues", 
     1                               HE5T_NATIVE_INT, count, datbuf_i)
         write(*,*) 'Status returned by HE5_ZAwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1         ' dimemnsion in field Spectra'
            status = HE5_ZAdetach(ZAid1)
            status = HE5_ZAclose(zafid)
            stop
         endif
         
         status = HE5_ZAdetach(ZAid1)
         write(*,*) 'Status returned by he5_zadetach(): ',status

         status = HE5_ZAclose(zafid)
         write(*,*) 'Status returned by he5_zaclose(): ',status

      endif
      stop
      end

!	  In this program we retrieve (1) information about the
!	  dimensions, (2) the za fields 

          program         he5_za_infoF_32

          implicit        none

          include         'hdfeos5.inc'

	  integer         i
          integer         status
	  integer         zafid, zaid
	  integer         he5_zaopen
	  integer         he5_zaattach
	  integer         he5_zainfo
          integer         he5_zachunkinfo
	  integer         he5_zadetach	  
	  integer         he5_zaclose
	  integer         rank(32)
	  integer         ntype(32)
	  integer         rk
	  integer         nt

	  integer*4       he5_zainqdims
          integer*4       he5_zainquire
          integer*4	  he5_zadiminfo
	  integer*4       ndims
	  integer*4       nflds
	  integer*4       dims(32)
	  integer*4       dimsize

	  character*72    dimname
          character*72    dimlist
          character*72    maxdimlst
          character*72    fieldlist

          integer         chunkrank
          integer*4       chunkdims(32)

	  integer         FAIL
	  parameter       (FAIL=-1)

      
!     Open the "za.he5" file for "read only" access
!     ---------------------------------------------
	  zafid = he5_zaopen("za.he5", HE5F_ACC_RDONLY)
      write(*,*) 'File ID returned by he5_zaopen():  ',zafid

	  if (zafid .NE. FAIL) then
	   
!     Attach the za
!     -------------
		 zaid = he5_zaattach(zafid, "ZA1")
         write(*,*) 'ZA ID returned by he5_zaattach():  ',zaid

		 if (zaid .NE. FAIL) then
		
!     Inquire Dimensions
!     ------------------			
			ndims = he5_zainqdims(zaid, dimname, dims)
			write(*,*) 'Dimension list: ', dimname
			do i = 1,ndims
			   write(*,*) 'dim size: ', dims(i)
			enddo
			write(*,*)	      
						
!     Inquire Data Fields	      
!     -------------------			
			nflds = he5_zainquire(zaid, fieldlist, rank, ntype)
			write(*,*) 'Data Fieldlist: ', fieldlist
			do i=1,nflds
			   write(*,*) 'field rank & datatype: ',rank(i),ntype(i)
			enddo
			write(*,*) 
			
!	  Get info on "MyTrack1" dim
!         --------------------------			
	      dimsize = he5_zadiminfo(zaid, "MyTrack1")
	      write(*,*) 'Size of MyTrack1: ', dimsize
	      write(*,*)
	      

!	  Get info on "Spectra" Field
!         ---------------------------		  
	      status = he5_zainfo(zaid,"Spectra",rk,dims,nt,
     1         dimlist,maxdimlst)
	      write(*,*) 'Spectra Rank: ', rk
	      write(*,*) 'Spectra NumberType: ', nt
	      write(*,*) 'Spectra Dimlist: ', dimlist
	      write(*,*) 'Spectra Max Dimlist: ', maxdimlst
	      do i=1,rk
			 write(*,*) 'Dimension ',i,dims(i)
	      enddo

              status = he5_zachunkinfo(zaid,"Spectra",chunkrank,
     1         chunkdims)
              write(*,*) 'Spectra Chunking Rank: ', chunkrank
              do i=1,chunkrank
                         write(*,*) 'Chunking Dimension ',i,chunkdims(i)
              enddo
		  
	   endif
	  endif
	  
!     Detach from the za
!     ------------------
	  status = he5_zadetach(zaid)
      write(*,*) 'Status returned by he5_zadetach():  ',status

!     Close the file
!     --------------
	  status = he5_zaclose(zafid)
      write(*,*) 'Status returned by he5_zaclose():  ',status

	  stop
	  end

      program     he5_pt_setupF_64

      implicit    none

      include     'hdfeos5.inc'

      integer     status 
      integer     ptfid 
      integer     ptid1
      integer     ptid2
      integer     ptid3

      integer     he5_ptopen
      integer     he5_ptcreate
      integer     he5_ptdetach
      integer     he5_ptclose

c --------------------------------------------------------------------------- c
c     We first open the HDF-EOS point file, "point.he5". Because this file    c
c     does not already exist, we use the "TRUNC" file access code in the      c
c     open statement.  The PTopen routine returns the point file id, ptfid,   c
c     which is used to identify the file in subsequent routines in the        c
c     library.                                                                c
c --------------------------------------------------------------------------- c

c     Open the HDF-EOS point file, "point.he5"
c     ----------------------------------------
      ptfid = he5_ptopen('point.he5',HE5F_ACC_TRUNC)
      write(*,*) 'File ID returned by he5_ptopen():  ',ptfid
     
      ptid1 = he5_ptcreate(ptfid, "Simple Point")
      write(*,*) 'Point ID returned by he5_ptcreate():   ',ptid1
      ptid2 = he5_ptcreate(ptfid, "FixedBuoy Point")
      write(*,*) 'Point ID returned by he5_ptcreate():   ',ptid2
      ptid3 = he5_ptcreate(ptfid, "FloatBuoy Point")
      write(*,*) 'Point ID returned by he5_ptcreate():   ',ptid3

c --------------------------------------------------------------------------- c
c     We now close the point interface with the he5_ptdetach routine.         c
c     This step is necessary to properly store the point information within   c
c     the file.                                                               c
c --------------------------------------------------------------------------- c

      status = he5_ptdetach(ptid1)
      write(*,*) 'Status returned by he5_ptdetach():  ',status
      status = he5_ptdetach(ptid2)
      write(*,*) 'Status returned by he5_ptdetach():  ',status
      status = he5_ptdetach(ptid3)
      write(*,*) 'Status returned by he5_ptdetach():  ',status

      status = he5_ptclose(ptfid)
      write(*,*) 'Status returned by he5_ptclose():  ',status

      stop
      end

!     In this program we (1) open the "za.he5" file, (2) attach to
!     the "ZA1" za, and (3) read data from the "Spectra" field
!     ============================================================

      program            he5_za_readdataF_32

      implicit           none

      include            'hdfeos5.inc'

      integer            status
      integer            he5_zaopen
      integer            he5_zaattach
      integer            he5_zaread
      integer            he5_zardattr
      integer            he5_zadetach
      integer            he5_zaclose
      integer            zafid, zaid
      integer            i,j,k

      integer*4          attr(4)

      integer*4          start(3)
      integer*4          stride(3)
      integer*4          count(3)
      
      real*8		 plane(800)

      integer            FAIL
      parameter          (FAIL=-1)
      
!     Open HDF-EOS za file, "za.he5"
!     ------------------------------
	  zafid = he5_zaopen("za.he5",HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_zaopen():  ',zafid

	  if (zafid .NE. FAIL) then
		 zaid = he5_zaattach(zafid, "ZA1")
         write(*,*) 'ZA ID returned by he5_zaattach():  ',zaid

		 if (zaid .NE. FAIL) then
			
	      
!     Read the entire Spectra field
!     -----------------------------
                        start(1)  = 0
                        start(2)  = 0
                        count(1)  = 20
                        count(2)  = 40
                        count(3)  = 1
			stride(1) = 1
			stride(2) = 1
                        stride(3) = 1
 
                        do i=1,15
                           start(3) = i - 1
                           do j=1,40
                                  do k=1,20
					plane((j-1)*20+k) = (j-1)*100 + i-1
                                  enddo
                           enddo
                           status = he5_zaread(zaid,"Spectra",start,
     1              stride,count,plane)
                        enddo


!     Read Attribute
!     --------------	      
			status = he5_zardattr(zaid, "TestAttr", attr)
			do i=1,4
			   write(*,*) 'Attribute Element', i, ':', attr(i)
			enddo	      
			
		 endif
	  endif
      
!    Detach from the za
!    ------------------
	  status = he5_zadetach(zaid)
      write(*,*) 'Status returned from he5_zadetach:  ',status

!     Close the file
!     --------------
	  status = he5_zaclose(zafid)
      write(*,*) 'Status returned from he5_zaclose:  ',status

	  stop
	  end

c----------------------------------------------------------------------------
c     Copyright (C) 2000   Emergent IT Inc. and Raytheon Systems Company    |
c----------------------------------------------------------------------------
c testswath64.f                                                             |
c In this program we create, define and write a simple swath hdfeos file    |
c using the swath interface                                                 |
c----------------------------------------------------------------------------

      program   testswath64
 
      implicit  none
 
      include   'hdfeos5.inc'
 
      integer   status
      integer   index1
      integer   index2
      integer   swfid
      integer   swid
      integer   swid2
      integer   rank
      integer   n, nt
      integer   dtype
      integer   classid
      integer   order
      integer   rdattr(4)
      integer   global_attr(4)
      integer   compparm(5)
      integer   cnkrank
      integer   rdcompparm(5)
      integer   compcode
      integer   regionid
      integer   regionid2
      integer   regionid3
      integer   ntype(5)
      integer   rnk(5)
      integer   ntyped(5)
      integer   rnkd(5)

      integer   he5_swopen
      integer   he5_swcreate
      integer   he5_swattach
      integer   he5_swdefdim
      integer   he5_swdefgfld
      integer   he5_swdefdfld
      integer   he5_swdefmap
      integer   he5_swdefchunk
      integer   he5_swdefcomp
      integer   he5_swsetfill
      integer   he5_swwrattr
      integer   he5_swdefimap
      integer   he5_swwrlattr
      integer   he5_swwrfld
      integer   he5_swrdfld
      integer   he5_swwrgattr
      integer   he5_swrdattr
      integer   he5_swrdgattr
      integer   he5_swrdlattr
      integer   he5_swdefvrtreg
      integer   he5_swdefboxreg
      integer   he5_swdeftmeper
      integer   he5_swgmapinfo
      integer   he5_swfldinfo 
      integer   he5_swcompinfo
      integer   he5_swmapinfo
      integer   he5_swattrinfo
      integer   he5_swgattrinfo
      integer   he5_swreginfo
      integer   he5_swextreg
      integer   he5_swregidx
      integer   he5_swperinfo
      integer   he5_swextper
      integer   he5_swlattrinfo
      integer   he5_swgetfill
      integer   he5_swidtype
      integer   he5_swdupreg
      integer   he5_swdetach
      integer   he5_swclose 

      integer*8 he5_swupimap
      integer*8 he5_swinqswath
      integer*8 he5_swnentries
      integer*8 he5_swinqmaps
      integer*8 he5_swinqimaps
      integer*8 he5_swinqdims
      integer*8 he5_swdiminfo
      integer*8 he5_swimapinfo
      integer*8 he5_swinqattrs
      integer*8 he5_swinqgattrs
      integer*8 he5_swinqlattrs
      integer*8 he5_swinqgflds
      integer*8 he5_swinqdflds
      integer*8 size
      integer*8 strbufsize
      integer*8 ndims
      integer*8 chunkdims(1)
      integer*8 start(2)
      integer*8 stride(2)
      integer*8 dataedge(2)
      integer*8 geoedge(2)
      integer*8 geostart(2)
      integer*8 istart(2)
      integer*8 iedge(2)
      integer*8 dedge(2)
      integer*8 sd_start(2)
      integer*8 sd_stride(2)
      integer*8 sd_edge(2)
      integer*8 rd_start(2)
      integer*8 rd_stride(2)
      integer*8 rd_edge(2)
      integer*8 indexmap(30)
      integer*8 dimsize
      integer*8 nattr
      integer*8 nswath
      integer*8 idxsz
      integer*8 nmaps
      integer*8 tstart(1)
      integer*8 tstride(1)
      integer*8 tedge(1)
      integer*8 strbufsz2
      integer*8 nflds
      integer*8 idxrange(2)
      integer*8 count(1)
      integer*8 offset
      integer*8 inc
      integer*8 status4
      integer*8 zero
      integer*8 ndxmap(2)
      integer*8 dims(5)
      integer*8 latdims(2)
      integer*8 upidxmap(50)
      integer*8 idxmap(50)
      integer*8 dim1
      integer*8 dim2
      integer*8 dim3
      integer*8 dim4

      real      grpattr(3)
      real      locattr(3)
      real      rdgnlattr(3)
      real      ray1(100,40)
      real      ray2(40,100)
      real      lat(40,50)
      real      lon(40,50)
      real      ray4(40,100)
      real      ray3(40,40)
      real      temp(40,100)
      real      idxlat(30,30)
      real      idxlon(30,30)
      real      latcnt
      real      loncnt
      real      raycnt
      real      idxlatcnt
      real      idxloncnt	
      real      fillvalue
      real      rdfilval
      real      tempbuf(4200)

      real*8    cornerlon(2)
      real*8    cornerlat(2)
      real*8    twodtime(40,50)
      real*8    onedtime(40)
      real*8    range(2)
      real*8    tmcnt
      real*8    starttime
      real*8    endtime

      character*(256)  geodim
      character*(256)  idxdimmap
      character*(256)  dimmap
      character*(256)  dimname
      character*(256)  fieldlist
      character*(256)  attrlist
      character*(256)  swathlist
      character*(256)  dimens
      character*(256)  maxdims

      dim1          = 30
      dim2          = 40
      dim3          = 50
      dim4          = 100
      count(1)      = 3
      compparm(1)   = 6
      compparm(2)   = 0
      compparm(3)   = 0
      compparm(4)   = 0
      compparm(5)   = 0
      cnkrank       = 1
      chunkdims(1)  = 10
      rdcompparm(1) = 1
      rdcompparm(2) = 1
      rdcompparm(3) = 1
      rdcompparm(4) = 1
      rdcompparm(5) = 1
      compcode      = -1
      raycnt        = -799.0
      tmcnt         = 46353400.0d0
      starttime     = 46353450.0d0
      endtime       = 46500000.0d0
      range(1)      = 46353450.0d0
      range(2)      = 46500000.0d0
      latcnt        = 39.8
      loncnt        = 78.0
      global_attr(1)= 11
      global_attr(2)= 33
      global_attr(3)= 66
      global_attr(4)= 99
      grpattr(1)    = 21.7
      grpattr(2)    = 24.3
      grpattr(3)    = 26.3
      locattr(3)    = 21.7
      locattr(2)    = 24.3
      locattr(1)    = 26.3
      start(1)      = 10
      start(2)      = 10
      tstart(1)     = 0
      tstride(1)    = 1
      tedge(1)      = 40
      geostart(1)   = 0
      geostart(2)   = 0 
      stride(1)     = 1
      stride(2)     = 1
      sd_start(1)   = 0
      sd_start(2)   = 0
      sd_stride(1)  = 1
      sd_stride(2)  = 1
      sd_edge(1)    = 100
      sd_edge(2)    = 40
      rd_start(1)   = 0
      rd_start(2)   = 0
      rd_stride(1)  = 1
      rd_stride(2)  = 1
      rd_edge(1)    = 40
      rd_edge(2)    = 100
      dataedge(1)   = 20
      dataedge(2)   = 50
      geoedge(1)    = 40
      geoedge(2)    = 50
      idxlatcnt     = 39.8
      idxloncnt     = 78.0
      istart(1)     = 0
      istart(2)     = 0
      iedge(1)      = 30
      iedge(2)      = 30
      dedge(1)      = 40
      dedge(2)      = 40
      rank          = 2
      fillvalue     = 16.0
      cornerlon(1)  = 75.0
      cornerlon(2)  = 78.0
      cornerlat(1)  = 38.0
      cornerlat(2)  = 39.8
      indexmap(1)   = 1
      indexmap(2)   = 2
      indexmap(3)   = 3
      indexmap(4)   = 4
      indexmap(5)   = 6
      indexmap(6)   = 7
      indexmap(7)   = 8
      indexmap(8)   = 9
      indexmap(9)   = 11
      indexmap(10)  = 12
      indexmap(11)  = 13
      indexmap(12)  = 14
      indexmap(13)  = 16
      indexmap(14)  = 17
      indexmap(15)  = 18
      indexmap(16)  = 19
      indexmap(17)  = 21
      indexmap(18)  = 22
      indexmap(19)  = 23
      indexmap(20)  = 24
      indexmap(21)  = 26
      indexmap(22)  = 27
      indexmap(23)  = 28
      indexmap(24)  = 29
      indexmap(25)  = 31
      indexmap(26)  = 32
      indexmap(27)  = 33
      indexmap(28)  = 34
      indexmap(29)  = 36
      indexmap(30)  = 37
      zero          = 0

c
c This section of the program just fills some arrays with data that will be
c used later in the program
c
      do 110 index1=1,100
         do 100 index2=1,40
            ray1(index1, index2)=raycnt
            ray2(index2, index1)=raycnt + 1.0
            ray4(index2,index1) = raycnt
            raycnt = raycnt +1.
  100    continue
  110 continue

      do 130 index1=1,40
         do 120 index2=1,50
            lat(index1, index2)=latcnt
            lon(index1, index2)=loncnt
            twodtime(index1,index2)=tmcnt
            loncnt=loncnt-.1
            tmcnt=tmcnt+5.0
  120    continue
         onedtime(index1)=tmcnt
         latcnt=latcnt-0.1
         loncnt = 78.0
  130 continue

      do 150 index1=1,30
         do 140 index2=1,30
            idxlat(index1, index2)=idxlatcnt
            idxlon(index1, index2)=idxloncnt
            idxloncnt=idxloncnt-.1
  140    continue
         idxlatcnt=idxlatcnt-.1
         idxloncnt=78.0
  150 continue


      do 170 index1=1,40
         do 160 index2=1,40
            ray3(index1, index2)=raycnt
            raycnt = raycnt+1.25
  160    continue
  170 continue

      do 987 index1=1,50
         idxmap(index1)=zero
         upidxmap(index1)=zero
  987 continue

  230 format('********Error unexpected**********')
  240 format('***********Passed Test*********')

      open(unit=1, file="testswath64_f.txtout", status = "UNKNOWN")

      write(*,*)'Testing he5_swath FORTRAN 77 interface'
      write(*,*)'======================================'
      write(1,*)'Testing he5_swath FORTRAN 77 interface'
      write(1,*)'======================================'
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swopen
c
      write(*,*)'Testing he5_swopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_swopen '
      write(1,*)'====================='
      swfid=he5_swopen('swath.he5',HE5F_ACC_TRUNC)
      if (swfid .lt. zero) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	swfid= he5_swopen("swath.he5",HE5F_ACC_TRUNC)'
         write(*,*)'	Value returned by he5_swopen ', swfid
         write(1,*)'	swfid= he5_swopen("swath.he5",HE5F_ACC_TRUNC)'
         write(1,*)'	Value returned by he5_swopen ', swfid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swcreate
c
      write(1,27)
      write(*,*)'Testing he5_swcreate '
      write(*,*)'====================='
      write(1,*)'Testing he5_swcreate '
      write(1,*)'====================='
      swid=he5_swcreate(swfid,'Simplef')
      if (swid .lt. zero) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swid=he5_swcreate(swfid, "Simplef")'
         write(*,*)'Value returned by he5_swcreate ', swid
         write(1,*)'swid= he5_swcreate(swfid, "Simplef")'
         write(1,*)'Value returned by he5_swcreate ', swid
      endif
      write(*,*)' '
      write(1,*)' '

      swid2=he5_swcreate(swfid,'Indexedf')
      if (swid2 .lt. zero) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swid2= he5_swcreate(swfid, "Indexedf")'
         write(*,*)'Value returned by he5_swcreate ', swid2
         write(1,*)'swid2= he5_swcreate(swfid, "Indexedf")'
         write(1,*)'Value returned by he5_swcreate ', swid2
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_swdefdim
c
      write(1,27)
      write(*,*)'Testing he5_swdefdim '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdefdim '
      write(1,*)'====================='
      status=he5_swdefdim(swid,'DataTrack',dim4)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_swdefdim(swid, "DataTrack", 100)'
         write(*,*)'	Value returned by he5_swdefdim ',status
         write(1,*)'	status= he5_swdefdim(swid, "DataTrack", 100)'
         write(1,*)'	Value returned by he5_swdefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdim(swid,'DataXtrack',dim2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_swdefdim(swid, "DataXtrack", 40)'
         write(*,*)'	Value returned by he5_swdefdim ',status
         write(1,*)'	status= he5_swdefdim(swid, "DataXtrack", 40)'
         write(1,*)'	Value returned by he5_swdefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdim(swid,'GeoTrack',dim3) 
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_swdefdim(swid, "GeoTrack", 50)'
         write(*,*)'	Value returned by he5_swdefdim ',status
         write(1,*)'	status= he5_swdefdim(swid, "GeoTrack", 50)'
         write(1,*)'	Value returned by he5_swdefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdim(swid,'GeoXtrack',dim2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_swdefdim(swid, "GeoXtrack", 40)'
         write(*,*)'	Value returned by he5_swdefdim ',status
         write(1,*)'	status= he5_swdefdim(swid, "GeoXtrack", 40)'
         write(1,*)'	Value returned by he5_swdefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdim(swid2,'DataTrack',dim2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_swdefdim(swid2, "DataTrack", 40)'
         write(*,*)'	Value returned by he5_swdefdim ', status
         write(1,*)'	status= he5_swdefdim(swid2, "DataTrack", 40)'
         write(1,*)'	Value returned by he5_swdefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdim(swid2,'DataXtrack',dim2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_swdefdim(swid2, "DataXtrack", 40)'
         write(*,*)'	Value returned by he5_swdefdim ', status
         write(1,*)'	status= he5_swdefdim(swid2, "DataXtrack", 40)'
         write(1,*)'	Value returned by he5_swdefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdim(swid2,'GeoTrack',dim1)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_swdefdim(swid2, "GeoTrack", 30)'
         write(*,*)'	Value returned by he5_swdefdim ', status
         write(1,*)'	status= he5_swdefdim(swid2, "GeoTrack", 30)'
         write(1,*)'	Value returned by he5_swdefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdim(swid2,'GeoXtrack',dim1)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_swdefdim(swid2, "GeoXtrack", 30)'
         write(*,*)'	Value returned by he5_swdefdim ', status
         write(1,*)'	status= he5_swdefdim(swid2, "GeoXtrack", 30)'
         write(1,*)'	Value returned by he5_swdefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdim(swid2,'Timedim',dim2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define dimension Timedim '
         write(*,*)'	Value returned by he5_swdefdim ', status
         write(1,*)'Define dimension Timedim '
         write(1,*)'	Value returned by he5_swdefdim ', status
      endif

      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swdefgfld
c
      write(1,27)
      write(*,*)'Testing he5_swdefgfld '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdefgfld '
      write(1,*)'====================='
      status=he5_swdefgfld(swid,'Latitude','GeoXtrack,GeoTrack',
     1' ',HE5T_NATIVE_FLOAT,0)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdefgfld(swid,"Latitude",
     1"GeoXtrack,GeoTrack"," ", HE5T_NATIVE_FLOAT, 0)'
         write(1,*)'status= he5_swdefgfld(swid,"Latitude",
     1"GeoXtrack,GeoTrack"," ", HE5T_NATIVE_FLOAT, 0)'
         write(1,*)'Value returned by he5_swdefgfld ',status
         write(*,*)'Value returned by he5_swdefgfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefgfld(swid,'Longitude','GeoXtrack,GeoTrack',
     1' ',HE5T_NATIVE_FLOAT, 0)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Value returned by he5_swdefgfld ',status
         write(1,*)'Value returned by he5_swdefgfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefgfld(swid2,'Latitude','GeoXtrack,GeoTrack',
     1' ',HE5T_NATIVE_FLOAT, 0)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Value returned by he5_swdefgfld ', status
         write(1,*)'Value returned by he5_swdefgfld ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefgfld(swid2,'Longitude','GeoXtrack,GeoTrack',
     1' ',HE5T_NATIVE_FLOAT, 0)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Value returned by he5_swdefgfld ', status
         write(1,*)'Value returned by he5_swdefgfld ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefgfld(swid2,'Time','Timedim',' ',
     1HE5T_NATIVE_DOUBLE, 0)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define field Time for swath Indexedf '
         write(*,*)'Status returned from call to he5_swdefgfld ',status
         write(1,*)'Define field Time for swath Indexedf '
         write(1,*)'Status returned from call to he5_swdefgfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefgfld(swid,'Time','GeoXtrack,GeoTrack',
     1' ', HE5T_NATIVE_DOUBLE, 0)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdefgfld(swid, "Time","GeoXtrack,GeoTrack",
     1"",HE5T_NATIVE_DOUBLE, 0)'
         write(*,*)'Value returned by he5_swdefgfld ',status
         write(1,*)'status= he5_swdefgfld(swid, "Time","GeoXtrack,GeoTrack",
     1"",HE5T_NATIVE_DOUBLE, 0)'
         write(1,*)'Value returned by he5_swdefgfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swdefdfld
c
      write(1,27)
      write(*,*)'Testing he5_swdefdfld '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdefdfld '
      write(1,*)'====================='

      status=he5_swdefdfld(swid,'SideA','DataXtrack,DataTrack',
     1' ', HE5T_NATIVE_FLOAT, 0)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
        
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define data field SideA '
         write(*,*)'Value returned by he5_swdefdfld ',status
         write(1,*)'Define data field SideA '
         write(1,*)'Value returned by he5_swdefdfld ',status
         write(*,*)' '
         write(1,*)' '
      endif

c Test Case  -- he5_swsetfill
c
      write(1,27)
      write(*,*)'Testing he5_swsetfill '
      write(*,*)'====================='
      write(1,*)'Testing he5_swsetfill '
      write(1,*)'====================='
      status= he5_swsetfill(swid,'Temperature',
     1HE5T_NATIVE_FLOAT, fillvalue)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swsetfill(swid,"Temperature",
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(*,*)'Value returned by he5_swsetfill ',status
         write(1,*)'status=he5_swsetfill(swid,"Temperature",
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(1,*)'Value returned by he5_swsetfill ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdfld(swid,'Temperature',
     1'DataXtrack,DataTrack',' ',HE5T_NATIVE_FLOAT, 0)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define data field Temperature '
         write(*,*)'Value returned by he5_swdefdfld ',status
         write(1,*)'Define data field Temperature '
         write(1,*)'Value returned by he5_swdefdfld ',status
         write(*,*)' '
         write(1,*)' '
      endif

      status= he5_swsetfill(swid,'Conduction',
     1HE5T_NATIVE_FLOAT,fillvalue)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swsetfill(swid,"Conduction",
     1HE5T_NATIVE_FLOAT,fillvalue)'
         write(*,*)'Value returned by he5_swsetfill ',status
         write(1,*)'status=he5_swsetfill(swid,"Conduction",
     1HE5T_NATIVE_FLOAT,fillvalue)'
         write(1,*)'Value returned by he5_swsetfill ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdfld(swid,'Conduction',
     1'DataXtrack,DataTrack',' ',HE5T_NATIVE_FLOAT,0)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdefdfld(swid,"Conduction",
     1"DataXtrack,DataTrack","",HE5T_NATIVE_FLOAT, 0)'
         write(*,*)'Value returned by he5_swdefdfld ',status
         write(1,*)'status= he5_swdefdfld(swid,"Conduction",
     1"DataXtrack,DataTrack","",HE5T_NATIVE_FLOAT, 0)'
         write(1,*)'Value returned by he5_swdefdfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdfld(swid2,'Sensor1',
     1'DataXtrack,DataTrack',' ',HE5T_NATIVE_FLOAT, 0)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swdefdfld(swid2, "Sensor1",
     1"DataTrack,DataXtrack","",HE5T_NATIVE_FLOAT, 0)'
         write(*,*)'Value returned by he5_swdefdfld ',status
         write(1,*)'status= he5_swdefdfld(swid2, "Sensor1",
     1"DataTrack,DataXtrack","",HE5T_NATIVE_FLOAT, 0)'
         write(1,*)'Value returned by he5_swdefdfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swdefchunk
c
      write(1,27)
      write(*,*)'Testing he5_swdefchunk'
      write(*,*)'======================'
      write(1,*)'Testing he5_swdefchunk'
      write(1,*)'======================'
      status=he5_swdefchunk(swid,cnkrank,chunkdims)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdefchunk(swid, cnkrank, chunkdims)'
         write(*,*)'Value returned by he5_swdefchunk ',status
         write(1,*)'status= he5_swdefchunk(swid, cnkrank, chunkdims)'
         write(1,*)'Value returned by he5_swdefchunk ',status
      endif
      write(*,*)' '
      write(1,*)' '
    
c Test Case -- he5_swdefcomp
c
      write(1,27)
      write(*,*)'Testing he5_swdefcomp'
      write(*,*)'====================='
      write(1,*)'Testing he5_swdefcomp'
      write(1,*)'====================='
      status=he5_swdefcomp(swid,HE5_HDFE_COMP_DEFLATE,compparm)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdefcomp(swid,HE5_HDFE_COMP_DEFLATE,
     1compparm)'
         write(*,*)'Value returned by he5_swdefcomp ',status
         write(1,*)'status= he5_swdefcomp(swid,HE5_HDFE_COMP_DEFLATE,
     1compparm)'
         write(1,*)'Value returned by he5_swdefcomp ',status
      endif
      write(*,*)' '
      write(1,*)' '


      status=he5_swdefdfld(swid,'CompChunk','GeoTrack',
     1' ',HE5T_NATIVE_FLOAT, 0)
      if (status .lt. zero) then
         write(*,230)
         write(1,230) 
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define data field CompChunk '
         write(*,*)'Value returned by he5_swdefdfld ',status
         write(1,*)'Define data field CompChunk '
         write(1,*)'Value returned by he5_swdefdfld ',status
         write(*,*)' '
         write(1,*)' '
      endif

c Test Case -- he5_swdetach
c
      write(1,27)
      write(*,*)'Testing he5_swdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdetach '
      write(1,*)'====================='
      status=he5_swdetach(swid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdetach(swid)'
         write(*,*)'Value returned by he5_swdetach ',status
         write(1,*)'status= he5_swdetach(swid)'
         write(1,*)'Value returned by he5_swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdetach(swid2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdetach(swid2)'
         write(*,*)'Value returned by he5_swdetach ',status
         write(1,*)'status= he5_swdetach(swid2)'
         write(1,*)'Value returned by he5_swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      swid=he5_swattach(swfid,'Simplef')
      if (swid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swid= he5_swattach(swfid, "Simplef")'
         write(*,*)'Value returned by he5_swattach ',swid
         write(1,*)'swid= he5_swattach(swfid, "Simplef")'
         write(1,*)'Value returned by he5_swattach ',swid
      endif
      write(*,*)' '
      write(1,*)' '

      swid2=he5_swattach(swfid,'Indexedf')
      if (swid2 .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swid2= he5_swattach(swfid, "Indexedf")'
         write(*,*)'Value returned by he5_swattach ',swid2
         write(1,*)'swid2= he5_swattach(swfid, "Indexedf")'
         write(1,*)'Value returned by he5_swattach ',swid2
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swdefmap
c
      write(1,27)
      write(*,*)'Testing he5_swdefmap '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdefmap '
      write(1,*)'====================='
      offset = 0
      inc    = 2
      status=he5_swdefmap(swid,'GeoTrack','DataTrack',
     1offset,inc)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdefmap(swid,"GeoTrack",
     1"DataTrack", offset, inc)'
         write(*,*)'Value returned by he5_swdefmap ',status
         write(1,*)'status= he5_swdefmap(swid,"GeoTrack",
     1"DataTrack", offset, inc)'
         write(1,*)'Value returned by he5_swdefmap ',status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swdefimap
c
      write(1,27)
      write(*,*)'Testing he5_swdefimap '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdefimap '
      write(1,*)'====================='
      status=he5_swdefimap(swid2,'GeoTrack','DataTrack',indexmap)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdefimap(swid2, "GeoTrack", 
     1"DataTrack",indexmap)'
         write(*,*)'Value returned by he5_swdefimap ',status
         write(1,*)'status= he5_swdefimap(swid2, "GeoTrack",
     1"DataTrack",indexmap)'
         write(1,*)'Value returned by he5_swdefimap ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefimap(swid2,'GeoXtrack','DataXtrack',
     1indexmap)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swdefimap(swid2, "GeoXtrack",
     1"DataXtrack",indexmap)'
         write(*,*)'Value returned by he5_swdefimap ',status
         write(1,*)'status=he5_swdefimap(swid2, "GeoXtrack",
     1"DataXtrack",indexmap)'
         write(1,*)'Value returned by he5_swdefimap ',status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_swdetach
c
      write(1,27)
      write(*,*)'Testing he5_swdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdetach '
      write(1,*)'====================='
      status= he5_swdetach(swid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdetach(swid)'
         write(*,*)'Value returned by he5_swdetach ',status
         write(1,*)'status= he5_swdetach(swid)'
         write(1,*)'Value returned by he5_swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_swdetach(swid2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdetach(swid2)'
         write(*,*)'Value returned by he5_swdetach ',status
         write(1,*)'status= he5_swdetach(swid2)'
         write(1,*)'Value returned by he5_swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_swclose(swfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)       
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swclose(swfid)'
         write(*,*)'Value returned by he5_swclose ',status
         write(1,*)'status= he5_swclose(swfid)'
         write(1,*)'Value returned by he5_swclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      swfid=he5_swopen('swath.he5',HE5F_ACC_RDWR)
      if (swfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swfid=he5_swopen("swath.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_swopen ',swfid
         write(1,*)'swfid=he5_swopen("swath.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_swopen ',swfid
      endif
      write(*,*)' '
      write(1,*)' '
 
c Test Case -- he5_swattach
c
      write(1,27)
      write(*,*)'Testing he5_swattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_swattach '
      write(1,*)'====================='

      swid=he5_swattach(swfid,'Simplef')
      if (swid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swid= he5_swattach(swfid, "Simplef")'
         write(*,*)'Value returned by he5_swattach ',swid
         write(1,*)'swid= he5_swattach(swfid, "Simplef")'
         write(1,*)'Value returned by he5_swattach ',swid
      endif
      write(*,*)' '
      write(1,*)' '

      swid2=he5_swattach(swfid,'Indexedf')
      if (swid2 .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swid2= he5_swattach(swfid, "Indexedf")'
         write(*,*)'Value returned by he5_swattach ',swid2
         write(1,*)'swid2= he5_swattach(swfid, "Indexedf")'
         write(1,*)'Value returned by he5_swattach ',swid2
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swwrfld
c
      write(1,27)
      write(*,*)'Testing he5_swwrfld '
      write(*,*)'==================='
      write(1,*)'Testing he5_swwrfld '
      write(1,*)'==================='

      status=he5_swwrfld(swid,'SideA',sd_start,stride, 
     1rd_edge, ray4)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Write data field SideA '
         write(*,*)'Value returned by he5_swwrfld ',status
         write(1,*)'Write data field SideA '
         write(1,*)'Value returned by he5_swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swwrfld(swid,'Temperature',start,stride, 
     1dataedge, ray4)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swwrfld(swid,"Temperature",start, 
     1stride,dataedge, ray1)'
         write(*,*)'Value returned by he5_swwrfld ',status
         write(1,*)'status=he5_swwrfld(swid,"Temperature",start, 
     1stride,dataedge, ray1)'
         write(1,*)'Value returned by he5_swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swwrfld(swid,'Conduction',start,stride, 
     1dataedge, ray2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swwrfld(swid,"Conduction",start, 
     1stride,dataedge, ray2)'
         write(*,*)'Value returned by he5_swwrfld ',status
         write(1,*)'status=he5_swwrfld(swid,"Conduction",start, 
     1stride,dataedge, ray2)'
         write(1,*)'Value returned by he5_swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swwrfld(swid,'Latitude',geostart,stride,
     1geoedge,lat)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swwrfld(swid, "Latitude", geostart, 
     1stride, geoedge, lat)'
         write(*,*)'Value returned by he5_swwrfld ',status
         write(1,*)'status= he5_swwrfld(swid, "Latitude", geostart, 
     1stride, geoedge, lat)'
         write(1,*)'Value returned by he5_swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swwrfld(swid,'Longitude',geostart,stride, 
     1geoedge,lon)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swwrfld(swid,"Longitude",geostart,
     1stride,geoedge, lon)'
         write(*,*)'Value returned by he5_swwrfld ',status
         write(1,*)'status= he5_swwrfld(swid,"Longitude",geostart,
     1stride,geoedge, lon)'
         write(1,*)'Value returned by he5_swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swwrfld(swid,'Time',geostart,stride,geoedge,
     1twodtime)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swwrfld(swid,"Time",geostart,stride, 
     1geoedge, twodtime)'
         write(*,*)'Value returned by he5_swwrfld for Time ',status
         write(1,*)'status= he5_swwrfld(swid, "Time", geostart, stride, 
     1geoedge, twodtime)'
         write(1,*)'Value returned by he5_swwrfld for Time ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swwrfld(swid2,'Latitude',istart,stride,
     1iedge,idxlat)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)       
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swwrfld(swid2,"Latitude", 
     1istart,stride,iedge,idxlat)'
         write(*,*)'Value returned by he5_swwrfld ',status
         write(1,*)'status= he5_swwrfld(swid2,"Latitude",
     1istart,stride,iedge,lat)'
         write(1,*)'Value returned by he5_swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swwrfld(swid2,'Longitude',istart,stride, 
     1iedge,idxlon)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swwrfld(swid2,"Longitude", 
     1istart,stride,iedge,idxlon)'
         write(*,*)'Value returned by he5_swwrfld ',status
         write(1,*)'status= he5_swwrfld(swid2,"Longitude",
     1istart,stride,iedge,idxlon)'
         write(1,*)'Value returned by he5_swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swwrfld(swid2,'Time',tstart,tstride,
     1tedge,onedtime)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Write field Time '
         write(*,*)'Status returned by he5_swwrfld ',status
         write(1,*)'Write field Time '
         write(1,*)'Status returned by he5_swwrfld ',status
         write(*,*)' '
         write(1,*)' '
      endif

      iedge(1)=40
      iedge(2)=40
      status=he5_swwrfld(swid2,'Sensor1',istart,stride, 
     1iedge,ray3)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swwrfld(swid2, "Sensor1", 
     1istart, stride, iedge, ray3)'
         write(*,*)'Value returned by he5_swwrfld ',status
         write(1,*)'status= he5_swwrfld(swid2, "Sensor1", 
     1istart, stride, iedge, ray3)'
         write(1,*)'Value returned by he5_swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swwrlattr
c
      write(1,27)
      write(*,*)'Testing he5_swwrlattr, Local Attribute '
      write(*,*)'================================== '
      write(1,*)'Testing he5_swwrlattr, Local Attribute '
      write(1,*)'================================== '
      status=he5_swwrlattr(swid2,'Sensor1','local',
     1HE5T_NATIVE_FLOAT,count,locattr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swwrlattr(swid2,"Sensor1","local",
     1HE5T_NATIVE_FLOAT,count,locattr)'
         write(*,*)'Value returned by he5_swwrlattr ',status
         write(1,*)'status=he5_swwrlattr(swid2,"Sensor1", "local", 
     1HE5T_NATIVE_FLOAT,count,locattr)'
         write(1,*)'Value returned by he5_swwrlattr ',status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_swwrattr
c
      count(1) = 4

      write(1,27)
      write(*,*)'Testing he5_swwrattr, Global Attribute '
      write(*,*)'====================================== '
      write(1,*)'Testing he5_swwrattr, Global Attribute '
      write(1,*)'======================================= '
      status=he5_swwrattr(swid,'Drift',HE5T_NATIVE_INT,count, 
     1global_attr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swwrattr(swid, "Drift", 
     1HE5T_NATIVE_INT, count, global_attr)'
         write(*,*)'Value returned by he5_swwrattr ',status
         write(1,*)'status=he5_swwrattr(swid, "Drift", 
     1HE5T_NATIVE_INT, count, global_attr)'
         write(1,*)'Value returned by he5_swwrattr ',status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swwrgattr
c
      count(1) = 3
     
      write(1,27)
      write(*,*)'Testing he5_swwrgattr, Group Attribute '
      write(*,*)'====================================== '
      write(1,*)'Testing he5_swwrgattr, Group Attribute '
      write(1,*)'====================================== '
      status=he5_swwrgattr(swid,'group',HE5T_NATIVE_FLOAT, 
     1count,grpattr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swwrgattr(swid, "group", 
     1HE5T_NATIVE_FLOAT,count,grpgattr)'
         write(*,*)'Value returned by he5_swwrgattr ',status
         write(1,*)'status=he5_swwrgattr(swid, "group", 
     1HE5T_NATIVE_FLOAT,count,grpattr)'
         write(1,*)'Value returned by he5_swwrgattr ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_swdetach(swid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
      write(*,*)'status= he5_swdetach(swid)'
      write(*,*)'Value returned by he5_swdetach ',status
      write(1,*)'status= he5_swdetach(swid)'
      write(1,*)'Value returned by he5_swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_swdetach(swid2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdetach(swid2)'
         write(*,*)'Value returned by he5_swdetach ',status
         write(1,*)'status= he5_swdetach(swid2)'
         write(1,*)'Value returned by he5_swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_swclose
c
      write(1,27)
      write(*,*)'Testing he5_swclose '
      write(*,*)'==================='
      write(1,*)'Testing he5_swclose '
      write(1,*)'==================='
      status= he5_swclose(swfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Value returned by he5_swclose ',status
         write(1,*)'status= he5_swclose(swfid)'
         write(1,*)'Value returned by he5_swclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      swfid= he5_swopen('swath.he5',HE5F_ACC_RDWR)
      if (swfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swfid= he5_swopen("swath.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_swopen ', swfid
         write(1,*)'swfid= he5_swopen("swath.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_swopen ', swfid
      endif
      write(*,*)' '
      write(1,*)' '

      swid= he5_swattach(swfid,'Simplef')
      if (swid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swid= he5_swattach(swfid, "Simplef")'
         write(*,*)'Value returned by he5_swattach ',swid
         write(1,*)'swid= he5_swattach(swfid, "Simplef")'
         write(1,*)'Value returned by he5_swattach ',swid
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_swdetach(swid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdetach(swid)'
         write(*,*)'Value returned by he5_swdetach ',status
         write(1,*)'status= he5_swdetach(swid)'
         write(1,*)'Value returned by he5_swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_swclose(swfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swclose(swfid)'
         write(*,*)'Value returned by he5_swclose ',status
         write(1,*)'status= he5_swclose(swfid)'
         write(1,*)'Value returned by he5_swclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      swfid= he5_swopen('swath.he5',HE5F_ACC_RDWR)
      if (swfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swfid= he5_swopen("swath.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_swopen ',swfid
         write(1,*)'swfid= he5_swopen("swath.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_swopen ',swfid
      endif
      write(*,*)' '
      write(1,*)' '

      swid=he5_swattach(swfid,'Simplef')
      if (swid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swid= he5_swattach(swfid, "Simplef")'
         write(*,*)'Value returned by he5_swattach ',swid
         write(1,*)'swid= he5_swattach(swfid, "Simplef")'
         write(1,*)'Value returned by he5_swattach ',swid
      endif
      write(*,*)' '
      write(1,*)' '

      swid2=he5_swattach(swfid,'Indexedf')
      if (swid2 .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swid2= he5_swattach(swfid, "Indexedf")'
         write(*,*)'Value returned by he5_swattach ',swid2
         write(1,*)'swid2= he5_swattach(swfid, "Indexedf")'
         write(1,*)'Value returned by he5_swattach ',swid2
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swdefvrtreg
c
      write(1,27)
      write(*,*)'Testing he5_swdefvrtreg'
      write(*,*)'======================='
      write(1,*)'Testing he5_swdefvrtreg'
      write(1,*)'======================='

      regionid=he5_swdefvrtreg(swid2,HE5_HDFE_NOPREVSUB,'Time',range)
      if (regionid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define region id for field Time '
         write(*,*)'Region id returned by he5_swdefvrtreg ',
     1regionid
         write(1,*)'Define region id for field Time '
         write(1,*)'Region id returned by he5_swdefvrtreg ',
     1regionid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swnentries
c
      write(1,27)
      write(*,*)'Testing he5_swnentries '
      write(*,*)'====================='
      write(1,*)'Testing he5_swnentries '
      write(1,*)'====================='

      nmaps=he5_swnentries(swid,1,strbufsize)
      if (nmaps .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'nmaps= he5_swnentries(swid, 1, strbufsize)'
         write(*,*)'Number of dimension mappings ',nmaps
         write(*,*)'Size of strbufsize ',strbufsize
         write(1,*)'nmaps= he5_swnentries(swid, 1, strbufsize)'
         write(1,*)'Number of dimension mappings ',nmaps
         write(1,*)'Size of strbufsize ',strbufsize
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swinqmaps
c
      write(1,27)
      write(*,*)'Testing he5_swinqmaps '
      write(*,*)'====================='
      write(1,*)'Testing he5_swinqmaps '
      write(1,*)'====================='
      offset = -1
      inc    = -1
      nmaps=he5_swinqmaps(swid, dimmap, offset, inc)
      if (nmaps .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'nmaps=he5_swinqmaps(swid,dimmap,offset,inc)'
         write(*,*)'Dimension mappings ',dimmap
         write(*,*)'offset ',offset
         write(*,*)'increment ',inc
         write(1,*)'nmaps=he5_swinqmaps(swid,dimmap,offset,inc)'
         write(1,*)'Dimension mappings ',dimmap
         write(1,*)'offset ',offset
         write(1,*)'increment ',inc
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swgmapinfo
c
      write(1,27)
      write(*,*)'Testing he5_swgmapinfo '
      write(*,*)'======================'
      write(1,*)'Testing he5_swgmapinfo '
      write(1,*)'======================'
      status = he5_swgmapinfo(swid2,'GeoTrack')
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status = he5_swgmapinfo(swid2, "GeoTrack")'
         write(1,*)'status = he5_swgmapinfo(swid2, "GeoTrack")'
         write(*,*)'Status returned by he5_swgmapinfo ',status
         write(1,*)'Status returned by he5_swgmapinfo ',status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swinqimaps
c
      write(1,27)
      write(*,*)'Testing he5_swinqimaps '
      write(*,*)'====================='
      write(1,*)'Testing he5_swinqimaps '
      write(1,*)'====================='
      nmaps=he5_swinqimaps(swid2, idxdimmap, ndxmap)
      if (nmaps .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'nmaps=he5_swinqimaps(swid2,idxdimmap,ndxmap)'
         write(*,*)'Number of indexed mappings ',nmaps
         write(*,*)'Indexed Dimension mappings ',idxdimmap
         write(*,*)'Index size ',ndxmap
         write(1,*)'nmaps=he5_swinqimaps(swid2,idxdimmap,ndxmap)'
         write(1,*)'Number of indexed mappings ',nmaps
         write(1,*)'Indexed Dimension mappings ',idxdimmap
         write(1,*)'Index size ',ndxmap
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swinqdims
c
      write(1,27)
      write(*,*)'Testing he5_swinqdims '
      write(*,*)'====================='
      write(1,*)'Testing he5_swinqdims '
      write(1,*)'====================='
      ndims=he5_swinqdims(swid,dimname,dims)
      if (ndims .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'ndims= he5_swinqdims(swid, dimname, dims)'
         write(*,*)'Number of dimesions ',ndims
         write(*,*)'Names of dimensions ',dimname
         write(*,*)'Size of dimensions ',dims
         write(1,*)'ndims= he5_swinqdims(swid, dimname, dims)'
         write(1,*)'Number of dimesions ',ndims
         write(1,*)'Names of dimensions ',dimname
         write(1,*)'Size of dimensions ',dims
      endif
      write(*,*)' '
      write(1,*)' '

      ndims= he5_swinqdims(swid2, dimname, dims)
      if (ndims .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'ndims=he5_swinqdims(swid2,dimname,dims)'
         write(*,*)'Number of dimesions ',ndims
         write(*,*)'Names of dimensions ',dimname
         write(*,*)'Size of dimensions ',dims
         write(1,*)'ndims=he5_swinqdims(swid2,dimname,dims)'
         write(1,*)'Number of dimesions ',ndims
         write(1,*)'Names of dimensions ',dimname
         write(1,*)'Size of dimensions ',dims
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swinqgflds
c
      write(1,27)
      write(*,*)'Testing he5_swinqgflds '
      write(*,*)'======================'
      write(1,*)'Testing he5_swinqgflds '
      write(1,*)'======================'

      nflds= he5_swinqgflds(swid,fieldlist,rnk,ntype)
      if (nflds .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'nflds=he5_swinqgflds(swid,fieldlist,rnk,ntype)'
         write(*,*)'Number of geolocation fields in swath ',nflds
         write(*,*)'Names of geolocation fields ',fieldlist
         write(*,*)'Rank of fields ',rnk
         write(*,*)'Number type of fields ',ntype
         write(1,*)'nflds=he5_swinqgflds(swid,fieldlist,rnk,ntype)'
         write(1,*)'Number of geolocation fields in swath ',nflds
         write(1,*)'Names of geolocation fields ',fieldlist
         write(1,*)'Rank of fields ',rnk
         write(1,*)'Number type of fields ',ntype
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swinqdflds
c
      write(1,27)
      write(*,*)'Testing he5_swinqdflds '
      write(*,*)'======================'
      write(1,*)'Testing he5_swinqdflds '
      write(1,*)'======================'
      nflds=he5_swinqdflds(swid,fieldlist,rnkd,ntyped)
      if (nflds .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'nflds=he5_swinqdflds(swid,fieldlist,rnkd,ntyped)'
         write(*,*)'Number of data fields in swath ',nflds
         write(*,*)'Names of data fields ',fieldlist
         write(*,*)'Rank of fields ',rnkd
         write(*,*)'Number type of fields ',ntyped
         write(1,*)'nflds=he5_swinqdflds(swid,fieldlist,rnkd,ntyped)'
         write(1,*)'Number of data fields in swath ',nflds
         write(1,*)'Names of data fields ',fieldlist
         write(1,*)'Rank of fields ',rnkd
         write(1,*)'Number type of fields ',ntyped
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swdiminfo
c
      write(1,27)
      write(*,*)'Testing he5_swdiminfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdiminfo '
      write(1,*)'====================='
      dimsize= he5_swdiminfo(swid,'DataTrack')
      if (dimsize .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'dimsize= he5_swdiminfo(swid, "DataTrack")'
         write(*,*)'Size of dimension DataTrack ',dimsize
         write(1,*)'dimsize= he5_swdiminfo(swid, "DataTrack")'
         write(1,*)'Size of dimension DataTrack ',dimsize
         write(*,*)' '
         write(1,*)' '
      endif

c Test Case -- he5_swrdfld
c
      write(1,27)
      write(*,*)'Testing he5_swrdfld '
      write(*,*)'==================='
      write(1,*)'Testing he5_swrdfld '
      write(1,*)'==================='

      rd_start(1)=0
      rd_start(2)=0
      rd_stride(1)=1
      rd_stride(2)=1
      rd_edge(1)=40
      rd_edge(2)=100
      status= he5_swrdfld(swid,'Conduction',rd_start,
     1rd_stride,rd_edge,temp)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Value returned by he5_swrdfld ',status
         write(*,*)'status= he5_swrdfld(swid, "Conduction", 
     1rd_start,rd_stride, rd_edge, temp)'
         write(1,*)'status= he5_swrdfld(swid, "Conduction", 
     1rd_start,rd_stride, rd_edge, temp)'
         write(1,*)'Value returned by he5_swrdfld ',status
         do 190 index1=10,15
            do 180 index2=10,15
               write(*,*)'value of conduction ',temp(index1,index2)
               write(1,*)'value of conduction ',temp(index1,index2)
  180       continue
  190    continue
      endif

      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swfldinfo
c
      write(1,27)
      write(*,*)'Testing he5_swfldinfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_swfldinfo '
      write(1,*)'====================='
      status=he5_swfldinfo(swid,'Latitude',rank,latdims,nt,
     1dimens,maxdims)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swfldinfo(swid, "Latitude", 
     1rank, latdims, nt, dimens, maxdims)'
         write(*,*)'Value returned by he5_swfldinfo ',status
         write(*,*)'Rank of field latitude ',rank
         write(*,*)'dimension list of field latitude ',dimens
         write(*,*)'Size of latitude dimensions ',latdims
         write(*,*)'number type of field latitude ',nt
         write(1,*)'status= he5_swfldinfo(swid, "Latitude", 
     1rank, latdims, nt, dimens, maxdims)'
         write(1,*)'Value returned by he5_swfldinfo ',status
         write(1,*)'Rank of field latitude ',rank
         write(1,*)'dimension list of field latitude ',dimens
         write(1,*)'Size of latitude dimensions ',latdims
         write(1,*)'number type of field latitude ',nt
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swmapinfo
c
      write(1,27)
      write(*,*)'Testing he5_swmapinfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_swmapinfo '
      write(1,*)'====================='
      status=he5_swmapinfo(swid,'GeoTrack','DataTrack',offset,inc)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swmapinfo(swid,"GeoTrack","DataTrack", 
     1offset,inc)'
         write(*,*)'Value returned by he5_swmapinfo ',status
         write(*,*)'Offset ',offset,' Increment ',inc
         write(1,*)'status=he5_swmapinfo(swid,"GeoTrack","DataTrack", 
     1offset,inc)'
         write(1,*)'Value returned by he5_swmapinfo ',status
         write(1,*)'Offset ',offset,' Increment ',inc
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swimapinfo
c
      write(1,27)
      write(*,*)'Testing he5_swimapinfo '
      write(*,*)'======================'
      write(1,*)'Testing he5_swimapinfo '
      write(1,*)'======================'
      status4=he5_swimapinfo(swid2,'GeoXtrack','DataXtrack',idxmap)
      if (status4 .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status4= he5_swimapinfo(swid2,"GeoXtrack",
     1"DataXtrack", idxmap)'
         write(*,*)'Value returned by he5_swimapinfo ',status4
         do 980 index1=1,30
            write(*,*)' Value of index array ',idxmap(index1)
            write(1,*)' Value of index array ',idxmap(index1)
  980    continue
         write(1,*)'status4= he5_swimapinfo(swid2, "GeoXtrack", 
     1"DataXtrack",idxmap)'
         write(1,*)'Value returned by he5_swimapinfo ',status4
         write(1,*)'Indexed map values ',idxmap
      endif
      write(*,*)' '
      write(1,*)' '
 
c Test Case -- he5_swinqattrs
c
      write(1,27)
      write(*,*)'Testing he5_swinqattrs Global attributes '
      write(*,*)'==================================== '
      write(1,*)'Testing he5_swinqattrs Global attributes '
      write(1,*)'==================================== '

      nattr = he5_swinqattrs(swid,attrlist,strbufsz2)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Number of global attributes in swath ',nattr
         write(*,*)'Attribute list of swath ',attrlist
         write(1,*)'Number of global attributes in swath ',nattr
         write(1,*)'Attribute list of swath ',attrlist
         write(*,*)' '
         write(1,*)' '
      endif

c Test Case -- he5_swattrinfo
c
      write(1,27)
      write(*,*)'Testing he5_swattrinfo Global attribute'
      write(*,*)'======================================='
      write(1,*)'Testing he5_swattrinfo Global attribute'
      write(1,*)'======================================='
      status= he5_swattrinfo(swid, attrlist, n, size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swattrinfo(swid,attrlist,n,size)'
         write(*,*)'Value returned by he5_swattrinfo ',status
         write(*,*)'Number type of attributes ',n,' Size ',size
         write(1,*)'status=he5_swattrinfo(swid,attrlist,n,size)'
         write(1,*)'Value returned by he5_swattrinfo ',status
         write(1,*)'Number type of attributes ',n,' Size ',size
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swrdattr
c
      write(1,27)
      write(*,*)'Testing he5_swrdattr, Global attribute '
      write(*,*)'======================================'
      write(1,*)'Testing he5_swrdattr, Global attribute '
      write(1,*)'======================================'

      status= he5_swrdattr(swid, attrlist, rdattr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swrdattr(swid,attrlist,rdattr)'
         write(*,*)'Value returned by he5_swrdattr ',status
         write(*,*)'attribute ',rdattr
         write(1,*)'status=he5_swrdattr(swid,attrlist,rdattr)'
         write(1,*)'Value returned by he5_swrdattr ',status
         write(1,*)'attribute ',rdattr
      endif
      write(*,*)' '
      write(1,*)' '

c     Test Case -- he5_swinqgattrs
c
      write(1,27)
      write(*,*)'Testing he5_swinqgattrs Group attributes '
      write(*,*)'==================================== '
      write(1,*)'Testing he5_swinqgattrs Group attributes '
      write(1,*)'==================================== '

      nattr = he5_swinqgattrs(swid,attrlist,strbufsz2)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Number of group attributes in swath ',nattr
         write(*,*)'Attribute list of swath ',attrlist
         write(1,*)'Number of group attributes in swath ',nattr
         write(1,*)'Attribute list of swath ',attrlist
         write(*,*)' '
         write(1,*)' '
      endif

c Test Case -- he5_swgattrinfo
c
      write(1,27)
      write(*,*)'Testing he5_swgattrinfo Group attribute'
      write(*,*)'======================================='
      write(1,*)'Testing he5_swgattrinfo Group attribute'
      write(1,*)'======================================='
      status= he5_swgattrinfo(swid, attrlist, n, size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swgattrinfo(swid,attrlist,n,size)'
         write(*,*)'Value returned by he5_swgattrinfo ',status
         write(*,*)'Number type of attributes ',n,' Size ',size
         write(1,*)'status=he5_swgattrinfo(swid,attrlist,n,size)'
         write(1,*)'Value returned by he5_swgattrinfo ',status
         write(1,*)'Number type of attributes ',n,' Size ',size
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swrdgattr
c
      write(1,27)
      write(*,*)'Testing he5_swrdgattr, Group attribute '
      write(*,*)'======================================'
      write(1,*)'Testing he5_swrdgattr, Group attribute '
      write(1,*)'======================================'

       status= he5_swrdgattr(swid,'group',rdgnlattr)
       if (status .lt. zero) then
          write(*,230)
          write(1,230)
       else
          write(*,*)'  '
          write(*,240)
          write(1,*)'  '
          write(1,240)
          write(*,*)'status=he5_swrdgattr(swid,attrlist,rdgnlattr)'
          write(*,*)'Value returned by he5_swrdgattr ',status
          write(*,*)'attribute ',rdgnlattr
          write(1,*)'status=he5_swrdgattr(swid,attrlist,rdgnlattr)'
          write(1,*)'Value returned by he5_swrdgattr ',status
          write(1,*)'attribute ',rdgnlattr
       endif
       write(*,*)' '
       write(1,*)' '

c Test Case -- he5_swinqlattrs
c
      write(1,27)
      write(*,*)'Testing he5_swinqlattrs Local attributes '
      write(*,*)'==================================== '
      write(1,*)'Testing he5_swinqlattrs Local attributes '
      write(1,*)'==================================== '

      nattr=he5_swinqlattrs(swid2,'Sensor1',attrlist,strbufsz2)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swinqlattrs(... "Sensor1" ...)'
         write(*,*)'Number of local attributes in field',nattr
         write(*,*)'Attribute list of field ',attrlist
         write(1,*)'swinqlattrs(... "Sensor1" ...)'
         write(1,*)'Number of local attributes in field',nattr
         write(1,*)'Attribute list of field ',attrlist
         write(*,*)' '
         write(1,*)' '
      endif

c Test Case -- he5_swlattrinfo
c
      write(1,27)
      write(*,*)'Testing he5_swlattrinfo Local attribute'
      write(*,*)'======================================='
      write(1,*)'Testing he5_swlattrinfo Local attribute'
      write(1,*)'======================================='
      status=he5_swlattrinfo(swid2,'Sensor1','local',n,size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swlattrinfo(... "Sensor1" ...)'
         write(*,*)'Value returned by he5_swlattrinfo ',status
         write(*,*)'Number type of attributes ',n,' Size ',size
         write(1,*)'swlattrinfo(... "Sensor1" ...)'
         write(1,*)'Value returned by he5_swlattrinfo ',status
         write(1,*)'Number type of attributes ',n,' Size ',size
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swidtype
c
      write(1,27)
      write(*,*)'Testing he5_swidtype, Inquire Datatype '
      write(*,*)'======================================='
      write(1,*)'Testing he5_swidtype, Inquire Datatype '
      write(1,*)'======================================='

      status= he5_swidtype(swid2,'Sensor1','local', 
     1HE5_HDFE_LOCATTRGROUP,dtype,classid, order, size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swidtype(swid2,"Sensor1","local", 
     1HE5_HDFE_LOCATTRGROUP,dtype, classid, order, size)'
         write(*,*)'Value returned by he5_swidtype ',status
         write(*,*)'Datatype of local attribute ',dtype
         write(*,*)'Class id and order ',classid, order
         write(*,*)'Size of attribute ',size
         write(1,*)'status= he5_swidtype(swid2,"Sensor1","local", 
     1HE5_HDFE_LOCATTRGROUP,dtype, classid, order, size)'
         write(1,*)'Value returned by he5_swidtype ',status
         write(1,*)'Datatype of local attribute ',dtype
         write(1,*)'Class id and order ',classid, order
         write(1,*)'Size of attribute ',size
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_swrdlattr
c
      write(1,27)
      write(*,*)'Testing he5_swrdlattr, Local attribute '
      write(*,*)'======================================'
      write(1,*)'Testing he5_swrdlattr, Local attribute '
      write(1,*)'======================================'

      status=he5_swrdlattr(swid2,'Sensor1','local',rdgnlattr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swrdlattr(swid2,"Sensor1","local", 
     1rdgnlattr)'
         write(*,*)'Value returned by he5_swrdlattr ',status
         write(*,*)'attribute ',rdgnlattr
         write(1,*)'status=he5_swrdlattr(swid2,"Sensor1","local", 
     1rdgnlattr)'
         write(1,*)'Value returned by he5_swrdlattr ',status
         write(1,*)'attribute ',rdgnlattr
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swgetfill
c
      write(1,27)
      write(*,*)'Testing he5_swgetfill '
      write(*,*)'====================='
      write(1,*)'Testing he5_swgetfill '
      write(1,*)'====================='
      status= he5_swgetfill(swid,'Conduction', rdfilval)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swgetfill(swid,"Conduction",rdfilval)'
         write(*,*)'Value returned by he5_swgetfill ',status
         write(*,*)'Value of fill ',rdfilval
         write(1,*)'status=he5_swgetfill(swid,"Conduction",rdfilval)'
         write(1,*)'Value returned by he5_swgetfill ',status
         write(1,*)'Value of fill ',rdfilval
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swdefboxreg
c
      write(1,27)
      write(*,*)'Testing he5_swdefboxreg '
      write(*,*)'======================='
      write(1,*)'Testing he5_swdefboxreg '
      write(1,*)'======================='

      regionid= he5_swdefboxreg(swid, cornerlon, cornerlat, 
     1HE5_HDFE_ENDPOINT)
      if (regionid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'regionid= he5_swdefboxreg(swid,cornerlon,
     1cornerlat, HE5_HDFE_ENDPOINT)'
         write(*,*)'Value returned by he5_swdefboxreg ',regionid
         write(1,*)'regionid= he5_swdefboxreg(swid, cornerlon, 
     1cornerlat, HE5_HDFE_ENDPOINT)'
         write(1,*)'Value returned by he5_swdefboxreg ',regionid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swregidx
c
      write(1,27)
      write(*,*)'Testing he5_swregidx '
      write(*,*)'===================='
      write(1,*)'Testing he5_swregidx '
      write(1,*)'===================='

      regionid3=he5_swregidx(swid, cornerlon, cornerlat, 
     1HE5_HDFE_ENDPOINT, geodim, idxrange)
      if (regionid3 .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'regionid3= he5_swregidx(swid, cornerlon, 
     1cornerlat, HE5_HDFE_ENDPOINT, geodim, idxrange)'
         write(*,*)'Region ID returned by he5_swregdex ',regionid3
         write(*,*)'Geodim of region ',geodim
         write(*,*)'indicies of region ',idxrange(1),idxrange(2)
         write(1,*)'regionid3= he5_swregidx(swid, cornerlon, 
     1cornerlat, HE5_HDFE_ENDPOINT, geodim, idxrange)'
         write(1,*)'Region ID returned by he5_swregdex ',regionid3
         write(1,*)'Geodim of region ',geodim
         write(1,*)'indicies of region ',idxrange(1),idxrange(2)
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_swdupreg
c
      write(1,27)
      write(*,*)'Testing he5_swdupreg '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdupreg '
      write(1,*)'====================='

      regionid2= he5_swdupreg(regionid)
      if (regionid2 .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Duplicate region id information '
         write(*,*)'Region ID returned by he5_swdupreg ',regionid2
         write(1,*)'Duplicate region id information '
         write(1,*)'Region ID returned by he5_swdupreg ',regionid2
         write(*,*)' '
         write(1,*)' '
      endif

c Test Case -- he5_swreginfo
c
      write(1,27)
      write(*,*)'Testing he5_swreginfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_swreginfo '
      write(1,*)'====================='
      status=he5_swreginfo(swid,regionid,'Temperature',nt,rank, 
     1dims,size)      
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swreginfo(swid,regionid,"Temperature", 
     1nt, rank, dims, size)'
         write(*,*)'Value returned by he5_swreginfo ',status
         write(*,*)'Number type of region ',nt,' Rank of region ',rank
         write(*,*)'Dimensions of region ',dims(1),' ',dims(2)
         write(*,*)'Value of size ',size
         write(1,*)'status=he5_swreginfo(swid,regionid,"Temperature", 
     1nt, rank, dims, size)'
         write(1,*)'Value returned by he5_swreginfo ',status
         write(1,*)'Number type of region ',nt,' Rank of region ',rank
         write(1,*)'Value of size ',size
         write(1,*)'Dimensions of region ',dims(1),' ',dims(2)
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swextreg
c
      write(1,27)
      write(*,*)'Testing he5_swextreg '
      write(*,*)'====================='
      write(1,*)'Testing he5_swextreg '
      write(1,*)'====================='
      status=he5_swextreg(swid,regionid,'Temperature', 
     1HE5_HDFE_INTERNAL, tempbuf) 
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status = he5_swextreg(swid, regionid, 
     1"Temperature", HE5_HDFE_INTERNAL, tempbuf)'
         write(*,*)'Value returned by he5_swextreg ', status
         write(1,*)'status = he5_swextreg(swid, regionid, 
     1"Temperature", HE5_HDFE_INTERNAL,tempbuf)'
         write(1,*)'Value returned by he5_swextreg ', status
         do 210 index1=100,115
            write(*,*)'region value at position ',tempbuf(index1)
            write(1,*)'region value at position ',tempbuf(index1)
  210    continue
      endif

      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swdeftmeper
c
      write(1,27)
      write(*,*)'Testing he5_swdeftmeper '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdeftmeper '
      write(1,*)'====================='
      regionid = he5_swdeftmeper(swid, starttime, endtime, 
     1HE5_HDFE_ENDPOINT)
      if (regionid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'regionid= he5_swdeftmeper(swid, starttime, 
     1endtime, HE5_HDFE_ENDPOINT)'
         write(*,*)'Value returned by he5_swdeftmeper ',regionid
         write(1,*)'regionid= he5_swdeftmeper(swid, starttime, 
     1endtime, HE5_HDFE_ENDPOINT)'
         write(1,*)'Value returned by he5_swdeftmeper ',regionid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swperinfo
c
      write(1,27)
      write(*,*)'Testing he5_swperinfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_swperinfo '
      write(1,*)'====================='
      status = he5_swperinfo(swid,regionid,'Temperature',nt,rank,
     1dims,size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status = he5_swperinfo(swid, regionid,
     1"Temperature",nt, rank, dims, size)'
         write(*,*)'Value returned by he5_swperinfo ',status
         write(*,*)'Rank of field ',rank,' Number type of region ',nt
         write(*,*)'Dimensions of region ',dims(1),' ',dims(2)
         write(*,*)'Value of size ',size
         write(1,*)'status = he5_swperinfo(swid, regionid,
     1"Temperature",nt, rank, dims, size)'
         write(1,*)'Value returned by he5_swperinfo ',status
         write(1,*)'Rank of field ',rank,' Number type of region ',nt
         write(1,*)'Dimensions of region ',dims(1),' ',dims(2)
         write(1,*)'Value of size ',size
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swextper
c
      write(1,27)
      write(*,*)'Testing he5_swextper '
      write(*,*)'===================='
      write(1,*)'Testing he5_swextper '
      write(1,*)'===================='
      status= he5_swextper(swid,regionid,'Temperature', 
     1HE5_HDFE_INTERNAL,tempbuf)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swextper(swid, regionid, 
     1"Temperature", HE5_HDFE_INTERNAL, tempbuf)'
         write(*,*)'Value returned by he5_swextper swath ',status
         write(1,*)'status= he5_swextper(swid, regionid, 
     1"Temperature", HE5_HDFE_INTERNAL, tempbuf) '
         write(1,*)'Value returned by he5_swextper swath ',status
         do 220 index1=1000,1015
            write(*,*)'region value at position ',tempbuf(index1)
            write(1,*)'region value at position ',tempbuf(index1)
  220    continue
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swupimap
c
      write(1,27)
      write(*,*)'Testing he5_swupimap '
      write(*,*)'====================='
      write(1,*)'Testing he5_swupimap '
      write(1,*)'====================='
      idxsz=he5_swupimap(swid2,regionid,idxmap,upidxmap,ndxmap)
      if (idxsz .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Size of index array in region ',idxsz
         write(1,*)'Size of index array in region ',idxsz
         write(*,*)'Indicies of updated index ',ndxmap(1),ndxmap(2)
         write(1,*)'Indicies of updated index ',ndxmap(1),ndxmap(2)
         do 380 index1=1,idxsz
            write(*,*)' Value of index array ',upidxmap(index1)
            write(1,*)' Value of index array ',upidxmap(index1)
  380    continue
      endif



c Test Case -- he5_swcompinfo
c
      write(1,27)
      write(*,*)'Testing he5_swcompinfo '
      write(*,*)'======================='
      write(1,*)'Testing he5_swcompinfo '
      write(1,*)'======================='
      status=he5_swcompinfo(swid,'CompChunk',compcode,rdcompparm)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swcompinfo(swid,"CompChunk",compcode, 
     1rdcompparm)'
         write(*,*)'Status returned by he5_swcompinfo ',status
         write(*,*)'Compression code ',compcode
         write(*,*)'Compression parameter ',rdcompparm(1)
         write(1,*)'status=he5_swcompinfo(swid,"CompChunk",compcode, 
     1rdcompparm)'
         write(1,*)'Status returned by he5_swcompinfo ',status
         write(1,*)'Compression code ',compcode
         write(1,*)'Compression parameter ',rdcompparm(1)
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_swdetach(swid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdetach(swid)'
         write(*,*)'Value returned by he5_swdetach ',status
         write(1,*)'status= he5_swdetach(swid)'
         write(1,*)'Value returned by he5_swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_swdetach(swid2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdetach(swid2)'
         write(*,*)'Value returned by he5_swdetach ',status
         write(1,*)'status= he5_swdetach(swid2)'
         write(1,*)'Value returned by he5_swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_swclose(swfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swclose(swfid)'
         write(*,*)'Value returned by he5_swclose ',status
         write(1,*)'status= he5_swclose(swfid)'
         write(1,*)'Value returned by he5_swclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      swfid= he5_swopen('swath.he5',HE5F_ACC_RDWR)
      if (swfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swfid= he5_swopen("swath.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_swopen ',swfid
         write(1,*)'swfid= he5_swopen("swath.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_swopen ',swfid
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_swinqswath
c
      write(1,27)
      write(*,*)'Testing he5_swinqswath '
      write(*,*)'======================'
      write(1,*)'Testing he5_swinqswath '
      write(1,*)'======================'

      nswath=he5_swinqswath('swath.he5',swathlist,strbufsz2)
      if (nswath .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Retrieve information on swaths in 
     1file swath.he5'
         write(*,*)'Number of swaths in file ', nswath
         write(*,*)'List of swaths ',swathlist
         write(1,*)'Retrieve information on swaths in 
     1file swath.he5'
         write(1,*)'Number of swaths in file ', nswath
         write(1,*)'List of swaths ',swathlist
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_swclose(swfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swclose(swfid)'
         write(*,*)'Value returned by he5_swclose ',status
         write(1,*)'status= he5_swclose(swfid)'
         write(1,*)'Value returned by he5_swclose ',status
      endif
      write(*,*)' '
      write(1,*)' '

      close(unit=1)
   27 format(' ')
      stop
      end

      program       he5_pt_readattrsF_32

      implicit      none

      include       'hdfeos5.inc'

      integer       status
      integer       ptfid 
      integer       ptid
      integer       he5_ptopen
      integer       he5_ptattach
      integer       he5_ptinqattrs
      integer       he5_ptinqgrpattrs
      integer       he5_ptinqlocattrs
      integer       he5_ptattrinfo
      integer       he5_ptgrpattrinfo
      integer       he5_ptlocattrinfo
      integer       he5_ptreadattr
      integer       he5_ptreadgrpattr
      integer       he5_ptreadlocattr
      integer       he5_ptdetach 
      integer       he5_ptclose
      integer       attr
      integer       attr1(5)
      integer       attr2(5)
      integer       ntype

      integer*4     sz
      integer*4     strbufsize
      integer*4     nattr

      real*4        flt      

      character*1   null_char_0
      character*80  attrname
      character*80  levelname
      character*240 attrlist

      null_char_0  = '0'

c     Open the HDF-EOS point file, "point.he5"
c     ----------------------------------------
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDONLY)
      write(*,*) 'File ID returned by he5_ptopen():  ',ptfid

c     Read FixedBuoy Point 
c     -------------------- 
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid

c     Global Attributes
c     -----------------
      attrname       = 'GlobalAttribute_int'
             
      print *,'Global Attribute:   '
      status   = he5_ptreadattr(ptid,attrname,attr)
      write(*,*) 'Status returned by he5_ptreadattr():  ',status
      print *,'Attribute value:    ',attr

     
      nattr   = he5_ptinqattrs(ptid,null_char_0,strbufsize)
      print *,'Number of attributes:  ',nattr
      print *,'Size (in bytes) of attribute list:  ',strbufsize

      nattr   = he5_ptinqattrs(ptid,attrlist,strbufsize)
      print *,'Number of attributes:  ',nattr
      print *,'Attribute list:  ',attrlist

      attrname       = 'GlobalAttribute_int'

      status   = he5_ptattrinfo(ptid,attrname,ntype,sz)
      write(*,*) 'Status returned by he5_ptattrinfo():  ',status
      print *,'Data type of attribute:        ',ntype
      print *,'Number of attribute elements:  ',sz

      print *,'   '
      attrname       = 'GlobalAttribute_float'
      print *,'attrname:    ',attrname

      status   = he5_ptattrinfo(ptid,attrname,ntype,sz)
      write(*,*) 'Status returned by he5_ptattrinfo():  ',status
      print *,'Data type of attribute:        ',ntype
      print *,'Number of attribute elements:  ',sz

      status   = he5_ptreadattr(ptid,attrname,flt)
      write(*,*) 'Status returned by he5_ptreadattr():  ',status
      print *,'Attribute value:    ',flt

      attrname       = 'GroupAttribute'

c     Global Attributes
c     -----------------
      print *, 'Group Attribute:'
      status = he5_ptreadgrpattr(ptid,attrname,attr1)
      print *,'Status returned by he5_ptreadgrpattr():  ',status
      print *,'Attribute values:  ',attr1


      nattr = he5_ptinqgrpattrs(ptid,null_char_0,strbufsize)
      print *,'Number of attributes:               ',nattr
      print *,'Size (in bytes) of attribute list:  ',strbufsize
      nattr = he5_ptinqgrpattrs(ptid,attrlist,strbufsize)
      print *,'Attribute list:  ',attrlist

      attrname       = 'GroupAttribute'

      status   = he5_ptgrpattrinfo(ptid,attrname,ntype,sz)
      write(*,*) 'Status returned by he5_ptgrpattrinfo():  ',status
      print *,'Data type of attribute:        ',ntype
      print *,'Number of attribute elements:  ',sz
     
c     Local Attributes
c     ----------------
      print *, 'Local Attribute:'

      attrname       = 'LocalAttribute'
      levelname      = 'Observations'

      status = he5_ptreadlocattr(ptid,levelname,attrname,attr2)
      print *,'Status returned by he5_ptreadlocattr():  ',status
      print *,'Attribute values:  ',attr2

      nattr = he5_ptinqlocattrs(ptid,levelname,null_char_0,strbufsize)
      print *,'Status returned by he5_ptinqlocattrs():  ',status
      print *,'Number of attributes:               ',nattr
      print *,'Size (in bytes) of attribute list:  ',strbufsize

      nattr = he5_ptinqlocattrs(ptid,levelname,attrlist,strbufsize)
      print *,'Attribute list:  ',attrlist

      status = he5_ptlocattrinfo(ptid,levelname,attrname,ntype,sz)
      print *,'Data type of attribute:        ',ntype
      print *,'Number of attribute elements:  ',sz


c.....Close out the point interface
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status

      status = he5_ptclose(ptfid)
      write(*,*) 'Status returned by he5_ptclose():  ',status

      stop
      end

      program       he5_gd_readdataF_64

      implicit      none

      include       'hdfeos5.inc'

	  integer       status
	  integer       gdfid 
      integer       gdid
	  integer       he5_gdopen
      integer       he5_gdattach
      integer       he5_gdrdfld
      integer       he5_gdrdattr
      integer       he5_gddetach 
	  integer       he5_gdclose

	  integer*8     start(2)
      integer*8     stride(2)
      integer*8     count(2)

	  real*4        f
      real*4        veg(120,200)

      integer       FAIL
      parameter     (FAIL=-1)

c     Open HDF-EOS "grid.he5" file
c     -----------------------------
	  gdfid = he5_gdopen("grid.he5",HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_gdopen():  ',gdid
  
	  if (gdfid .ne. FAIL) then 
		 
c        Attach to the UTM grid 
c        ----------------------
		 gdid = he5_gdattach(gdfid, "UTMGrid")
         write(*,*) 'Grid ID returned by he5_gdattach():  ',gdid
		 
		 if (gdid .ne. FAIL) then			
			start(1)  = 0
			start(2)  = 0
			stride(1) = 1
			stride(2) = 1
			count(1)  = 120
			count(2)  = 200

c           Read the data from "Vegetation" field
c           -------------------------------------
			status = he5_gdrdfld(gdid,"Vegetation",
     1           start,stride,count,veg)
            write(*,*) 'Status returned by he5_gdrdfld():  ',status

c           Read global attribute "float"
c           -----------------------------	      
			status = he5_gdrdattr(gdid, "float", f)
            write(*,*) 'Status returned by he5_gdrdattr():  ',status
			write(*,*) 'global attribute value: ', f
		 endif
	  endif

c     Detach from the grid
c     --------------------	  
	  status = he5_gddetach(gdid)
      write(*,*) 'Status returned by he5_gddetach():  ',status

c     Close the file
c     --------------
	  status = he5_gdclose(gdfid)
      write(*,*) 'Status returned by he5_gdclose():  ',status
	  
	  stop
	  end

      program     he5_za_writedimscaleF_32

      implicit    none

      include     'hdfeos5.inc'

      integer     status
      integer     i, j
      integer     he5_zaopen
      integer     he5_zaattach
      integer     he5_zawrfld
      integer     he5_zawrattr
      integer     he5_zawrgattr
      integer     he5_ehwrglatt
      integer     he5_zawrlattr 
      integer     he5_zadetach
      integer     he5_zaclose
      integer     HE5_ZAsetdimscale
      integer     HE5_ZAwritedscaleattr

      integer     zafid,zaid1
      integer*4   datbuf_i1(1) 
      integer*4   datbuf_i(15)
      integer     count(2)
      integer*4   nbands
      integer     bands(3)
      integer*4   datbuf_i2(2)
      integer     xdim, ydim, ntime
      integer     data(15)
      integer     FAIL
      parameter   (FAIL=-1)



!  /*
!   * We first open the HDF-EOS zaath file, "za.he5".  Because this file
!   * already exist and we wish to write to it, we use the H5F_ACC_RDWR access
!   * code in the open statement.  The HE5_ZAopen routine returns the zaath file
!   * id, zafid, which is used to identify the file in subsequent routines.
!   */ 
      nbands = 15
      do j=1,nbands
         data(j)=(j+1)*2
      enddo

      zafid = HE5_ZAopen("za.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_zaopen(): ',zafid
!  /*
!   * If the zaath file cannot be found, HE5_ZAopen will return -1 for the file
!   * handle (zafid).  We there check that this is not the case before
!   * proceeding with the other routines.
!   * 
!   * The HE5_ZAattach routine returns the handle to the existing zaath "ZA1",
!   * ZAid.  If the zaath is not found, HE5_ZAattach returns -1 for the handle.
!   */ 

      if (zafid .ne. FAIL) then
 
         ZAid1 = HE5_ZAattach(zafid, "ZA1")
         write(*,*) 'Za ID returned by he5_zaattach(): ',zaid1

!      /* the field Spectra has Bands,Res2tr,Res2xtr dimensions. 
!	 xdim = 120;
!	 ydim = 200;
!	 Time dim is set to 10
!      */

         if (ZAid1 .eq. -1) then
            
            write(*,*) 'Error: Cannot attach to zaath ZA1. Stpped.'
            status = HE5_ZAclose(zafid)
            stop
            
         endif
                  
         status = HE5_ZAsetdimscale2(ZAid1, "Spectra", "Bands",
     1        "banddimscale", nbands, HE5T_NATIVE_INT, data)
         write(*,*) 'Status returned by HE5_ZAsetdimscale: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale for Bands',
     1                 ' dimemnsion in field Vegetation'
            status = HE5_ZAdetach(ZAid1)
            status = HE5_ZAclose(zafid)
            stop
         endif

         count(1)= 12
         status = HE5_ZAwritedscaleattr(ZAid1, "Bands", "label", 
     1                         HE5T_NATIVE_CHAR, count, "Bands Dim")
         write(*,*) 'Status returned by HE5_ZAwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1                ' dimemnsion in field Spectra'
            status = HE5_ZAdetach(ZAid1)
            status = HE5_ZAclose(zafid)
            stop
         endif
         
         count(1)= 6
         status = HE5_ZAwritedscaleattr(ZAid1, "Bands", "unit", 
     1                              HE5T_NATIVE_CHAR, count, "None")
         write(*,*) 'Status returned by HE5_ZAwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1                 ' dimemnsion in field Spectra'
            status = HE5_ZAdetach(ZAid1)
            status = HE5_ZAclose(zafid)
            stop
         endif
         
         count(1)= 4
         status = HE5_ZAwritedscaleattr(ZAid1, "Bands", "format", 
     1                                 HE5T_NATIVE_CHAR, count, "I2")
         write(*,*) 'Status returned by HE5_ZAwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1                 ' dimemnsion in field Spectra'
            status = HE5_ZAdetach(ZAid1)
            status =  HE5_ZAclose(zafid)
            stop
         endif

         datbuf_i1(1) = -999
         count(1)= 1
         status = HE5_ZAwritedscaleattr(ZAid1, "Bands", "MissingValue",
     1                             HE5T_NATIVE_INT, count, datbuf_i1)
         write(*,*) 'Status returned by HE5_ZAwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1                 ' dimemnsion in field Spectra'
            status = HE5_ZAdetach(ZAid1)
            status = HE5_ZAclose(zafid)
            stop
         endif
         
         datbuf_i(1) =  -999
         datbuf_i(2) =  0
         datbuf_i(3) =  999


         count(1)= 3
         status = HE5_ZAwritedscaleattr(ZAid1, "Bands", "IntValues", 
     1                               HE5T_NATIVE_INT, count, datbuf_i)
         write(*,*) 'Status returned by HE5_ZAwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1         ' dimemnsion in field Spectra'
            status = HE5_ZAdetach(ZAid1)
            status = HE5_ZAclose(zafid)
            stop
         endif
         
         status = HE5_ZAdetach(ZAid1)
         write(*,*) 'Status returned by he5_zadetach(): ',status

         status = HE5_ZAclose(zafid)
         write(*,*) 'Status returned by he5_zaclose(): ',status

      endif
      stop
      end

c----------------------------------------------------------------------------
c     Copyright (C) 2000   Emergent IT Inc. and Raytheon Systems Company    |
c----------------------------------------------------------------------------
c testgrid64.f                                                              |
c In this program we create, define and write a simple grid hdfeos file     |
c using the grid interface                                                  |
c----------------------------------------------------------------------------

      program       testgrid64

      implicit      none
 
      include       'hdfeos5.inc'

      integer   	status, i, ii
      integer		compparm(5)
      integer 	    gdfid, gdfid2, gdfid3, gdid_utm, gdid2, gdid3
      integer 	    zonecode, pixregcode, orgcode
      integer	    attr(4), iattr(4), gattr(4), lattr(4)
      integer 	    spherecode, zero
      integer		regionid, regionid2, regionid3, regionid4
      integer	    dtype, classid, order
      integer	    he5_gdopen, he5_gdcreate
      integer       he5_gdattach, he5_gddetach
      integer	    he5_gdclose, he5_gddefproj
      integer       he5_gddefdim, he5_gdinqdatatype
      integer	    he5_gddeftle, he5_gddeffld
      integer       he5_gdsetfill, he5_gdwrfld
      integer	    he5_gdwrattr, he5_gdwrgattr
      integer       he5_gdwrlattr, he5_gdorginfo
      integer	    he5_gddefcomp, he5_gdinqflds
      integer       he5_gdprojinfo
      integer	    he5_gdrdfld, he5_gdattrinfo
      integer       he5_gdgatinfo
      integer       he5_gdlatinfo, he5_gdrdattr
      integer       he5_gdrdgattr, he5_gdrdlattr
      integer	    he5_gdreginfo, he5_gddeftmeper
      integer       he5_gddefvrtreg
      integer	    he5_gddeforigin, he5_gddefpreg
      integer       he5_gdinqdims, he5_gdgetfill
      integer	    he5_gdgridinfo, he5_gdcompinfo
      integer       he5_gdfldinfo, he5_gddefboxreg
      integer	    he5_gdgetpix, he5_gddupreg
      integer       he5_gdpreginfo, he5_gdextreg
      integer		rnk(8), numtype(8)
      integer		zcode, scode, nflds

      integer*4	    ntype
      integer*4		nt, rk
      integer*4		periodid
      integer*4		lstatus, n, one      
      integer*4		index1
      integer*4		index2
      integer*4		dimsizes(2)
      integer*4		lat(40,50)
      integer*4		latcnt
      integer*4		lon(40,50)
      integer*4		loncnt
      integer*4	    he5_gdinqgrid, he5_gddiminfo
      integer*4     he5_gdnentries
      integer*4	    he5_gdinqattrs, he5_gdinqgattrs
      integer*4     he5_gdinqlattrs
      integer*4	    pcode

      integer*8	    xdim, ydim
      integer*8	    testdim1, testdim2, hghtdim, conduction
      integer*8	    timedim, convection, setcount(1)
      integer*8 	start(2)
      integer*8 	stride(2)
      integer*8 	edge(2)
      integer*8 	start1d, stride1d, edge1d
      integer*8		tiledims(2)
      integer*8	    count, nlonlat
      integer*8	    size
      integer*8		rowval(5), colval(5)
      integer*8	    xdimsize, ydimsize
      integer*8	    he5_gdgetpixval, he5_gdinterpolate
      integer*8	    strbufsize
      integer*8		dims(8)

      real		    fillvalue, ifillv

      real*4		ray3(250)
      real*4		utmray(60,80), georay(60,80)
      real*4		utmhght(80)
      real*4		hghtinit
      real*4		utmcnt, geocnt
      real*4		raycnt, ray3cnt
      real*4		tempray(60,80)
      real*4		datbuf(4800)
      real*4		fldval(5)
      
      real*8		starttime, stoptime
      real*8		range(2)
      real*8		projparm(16), pparm(16)
      real*8		uplft(2), lowrgt(2)
      real*8		iuplft(2), ilrgt(2)
      real*8		interval(5,2)
      real*8		lonval(5), latval(5)
      real*8		utmtmeray(4800)
      real*8		tmeinit
      real*8		upleftpt(2), lowrtpt(2),corlon(2),corlat(2)

      character*80	grdnames, dimname, fldlist, attrlist
      character*80	compcodestring, maxdimname
      

      index1 = 0
      index2 = 0
      dimsizes(1) = 40
      dimsizes(2) = 100
      compparm(1) = 6
      compparm(2) = 0
      compparm(3) = 0
      compparm(4) = 0
      compparm(5) = 0
      fillvalue = 1996.0
      raycnt = -799.0
      ray3cnt = -19.5
      attr(1) = 11
      attr(2) = 33
      attr(3) = 55
      attr(4) = 77
      utmcnt=-799.0
      geocnt=2001.0
      hghtinit = 323.0
      tmeinit = 35232487.2d0
      starttime = 35233000.8d0
      stoptime = 35435050.9d0
      range(1) = 352.8d0
      range(2) = 400.9d0
      lonval(1) = -122.0d0
      latval(1) = -68.0d0
      lonval(2) = -122.5d0
      latval(2) = -68.0d0
      lonval(3) = -123.0d0
      latval(3) = -68.0d0
      lonval(4) = -123.5d0
      latval(4) = -68.0d0
      lonval(5) = -124.0d0
      latval(5) = -68.0d0
      tiledims(1) = 16
      tiledims(2) = 15

      latcnt = 38.0
      loncnt = 78.0
      zero = 0
      one = 1
      
c
c This section of the program just fills some arrays with data that we will
c use later in the program
c
      do 70 index1=1,60
         do 80 index2=1,80
            utmray(index2,index1) = utmcnt
            georay(index2,index1) = geocnt
            utmcnt = utmcnt + .4
            geocnt = geocnt + .2
   80   continue
   70 continue
  
      
      do 30 index1=1,250
            ray3(index1) = ray3cnt
            ray3cnt = ray3cnt + .1
   30 continue
      
      do 32 index1=1,80
            utmhght(index1) = hghtinit
            hghtinit = hghtinit + 2.75
   32 continue

      do 34 index1=1,4800
            utmtmeray(index1) = tmeinit
            tmeinit = tmeinit + 70.7
   34 continue

      do 50 index1=1,50
         do 60 index2=1,40      
            lat(index2,index1) = latcnt
            lon(index2,index1) = loncnt
            loncnt = loncnt - 0.1
   60    continue
         latcnt = latcnt + 0.1
         loncnt = 78.0
   50 continue

  230 format('********Error unexpected**********')
  231 format('********Error Expected************')
  240 format('***********Passed Test*********')


      open(unit=10,file='testgrid.txt', status = "UNKNOWN")

      write(*,*)'Testing Grid FORTRAN 77 interface '
      write(*,*)'=================================='
      write(10,*)'Testing Grid FORTRAN 77 interface '
      write(10,*)'=================================='
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdopen
c
      write(10,*)'Testing he5_gdopen... '
      write(10,*)'======================'
      write(*,*)'Testing he5_gdopen... '
      write(*,*)'======================'
      gdfid2 = he5_gdopen("grid2.he5",HE5F_ACC_TRUNC)
      if (gdfid2 .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdfid2 = he5_gdopen("grid2.he5",HE5F_ACC_TRUNC)'
         write(10,*)'Value returned by gdopen ', gdfid2
         write(*,*)'gdfid2 = he5_gdopen("grid2.he5",HE5F_ACC_TRUNC)'
         write(*,*)'Value returned by gdopen ', gdfid2
      endif
      write(*,*)' '
      write(10,*)' '

      gdfid3 = he5_gdopen("grid3.he5",HE5F_ACC_TRUNC)
      if (gdfid3 .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdfid3 = he5_gdopen("grid3.he5",HE5F_ACC_TRUNC)'
         write(10,*)'Value returned by gdopen ', gdfid3
         write(*,*)'gdfid3 = he5_gdopen("grid3.he5",HE5F_ACC_TRUNC)'
         write(*,*)'Value returned by gdopen ', gdfid3
      endif
      write(*,*)' '
      write(10,*)' '

      gdfid = he5_gdopen('grid.he5',HE5F_ACC_TRUNC)
      if (gdfid .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'Opening file grid.he5'
         write(10,*)'Opening file grid.he5'
         write(10,*) 'gdfid = he5_gdopen("grid.he5",HE5F_ACC_TRUNC)'
         write(10,*) 'File id returned from gdopen ', gdfid
         write(*,*) 'gdfid = he5_gdopen("grid.he5",HE5F_ACC_TRUNC)'
         write(*,*) 'File id returned from gdopen ', gdfid
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- he5_gdcreate
c
      write(10,27)
      write(10,*)'Testing he5_gdcreate... '
      write(10,*)'========================'
      write(*,*)'Testing he5_gdcreate... '
      write(*,*)'========================'

      xdim      = 60
      ydim      = 80
      uplft(1)  = 353299.39125d0
      uplft(2)  = -7100284.64348d0
      lowrgt(1) = 603434.52148d0
      lowrgt(2) = -7991341.17870d0


      gdid2 = he5_gdcreate(gdfid2, 'UTMGrid2', 
     1xdim, ydim, uplft, lowrgt)
      if (gdid2 .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*) 'Create UTMGrid2'
         write(*,*)'gdid2 = he5_gdcreate(gdfid2, "UTMGrid2", 
     1xdim, ydim, uplft, lowrgt)'
         write(10,*) 'Value returned by gdcreate ', gdid2
         write(*,*) 'Create UTMGrid2'
         write(10,*)'gdid2 = he5_gdcreate(gdfid2, "UTMGrid2",
     1xdim, ydim, uplft, lowrgt)'
         write(*,*) 'Value returned by gdcreate ', gdid2
      endif

      gdid3 = he5_gdcreate(gdfid3, 'UTMGrid3', 
     1xdim, ydim, uplft, lowrgt)
      if (gdid3 .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*) 'Create UTMGrid3'
         write(*,*)'gdid3 = he5_gdcreate(gdfid3, "UTMGrid3", 
     1xdim, ydim, uplft, lowrgt)'
         write(10,*) 'Value returned by gdcreate ', gdid3
         write(*,*) 'Create UTMGrid3'
         write(10,*)'gdid3 = he5_gdcreate(gdfid3, "UTMGrid3",
     1xdim, ydim, uplft, lowrgt)'
         write(*,*) 'Value returned by gdcreate ', gdid3
      endif
      
      
    
      gdid_utm = he5_gdcreate(gdfid, 'UTMGrid', xdim, ydim, 
     1uplft, lowrgt)
      if (gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Creating UTMGrid'
         write(*,*)'Creating UTMGrid'
         write(*,*)'gdid_utm= he5_gdcreate(gdfid,"UTMGrid",xdim,
     1ydim,uplft,lowrgt)'
         write(10,*)'gdid_utm= he5_gdcreate(gdfid,"UTMGrid",xdim,
     1ydim,uplft,lowrgt)'
         write(10,*)'UTM grid id returned from gdcreate ',gdid_utm
         write(*,*)'UTM grid id returned from gdcreate ',gdid_utm
      endif 
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddefproj
c
      write(10,27)
      write(10,*)'Testing he5_gddefproj... '
      write(10,*)'========================'
      write(*,*)'Testing he5_gddefproj... '
      write(*,*)'========================'

      zonecode = 10
      spherecode = 0

      do 120 index1=1,16
         projparm(index1)=0
 120  continue
  
      status = he5_gddefproj(gdid_utm,HE5_GCTP_UTM,zonecode,
     1spherecode,projparm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Defining UTM projection'
         write(*,*)'Defining UTM projection'
         write(*,*)'status= he5_gddefproj(gdid_utm,HE5_GCTP_UTM,
     1zonecode,spherecode, projparm)'
         write(10,*)'status= he5_gddefproj(gdid_utm,HE5_GCTP_UTM,
     1zonecode,spherecode, projparm)'
         write(10,*)'Returned value from gddefproj ', status
         write(*,*)'Returned value from gddefproj ', status
      endif 
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefproj(gdid3,HE5_GCTP_UTM,zonecode,
     1spherecode,projparm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Defining UTM projection'
         write(*,*)'Defining UTM projection'
         write(*,*)'status= he5_gddefproj(gdid3,HE5_GCTP_UTM,
     1zonecode,spherecode, projparm)'
         write(10,*)'status= he5_gddefproj(gdid3,HE5_GCTP_UTM,
     1zonecode,spherecode, projparm)'
         write(10,*)'Returned value from gddefproj ', status
         write(*,*)'Returned value from gddefproj ', status
      endif 
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefproj(gdid2,HE5_GCTP_UTM,zonecode,
     1spherecode,projparm)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Defining UTM'
         write(10,*)'status = he5_gddefproj(gdid2,HE5_GCTP_UTM,
     1zonecode,spherecode,projparm)'
         write(10,*)'Value returned by gddefproj ', status
         write(*,*)'Defining UTM'
         write(*,*)'status = he5_gddefproj(gdid2,HE5_GCTP_UTM,
     1zonecode,spherecode,projparm)'
         write(*,*)'Value returned by gddefproj ', status
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- he5_gddefpreg
c
      write(10,27)
      write(10,*)'Testing he5_gddefpreg... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gddefpreg... '
      write(*,*)'=========================='
      status = he5_gddefpreg(gdid_utm, HE5_HDFE_CORNER)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gddefpreg(gdid_utm, 
     1HE5_HDFE_CORNER)'
         write(10,*)'status = he5_gddefpreg(gdid_utm, 
     1HE5_HDFE_CORNER)'
         write(10,*)'Returned from gddefpreg ', status
         write(*,*)'Returned from gddefpreg ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefpreg(gdid3, HE5_HDFE_CORNER)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gddefpreg(gdid3, 
     1HE5_HDFE_CORNER)'
         write(10,*)'status = he5_gddefpreg(gdid3, 
     1HE5_HDFE_CORNER)'
         write(10,*)'Returned from gddefpreg ', status
         write(*,*)'Returned from gddefpreg ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddeforigin
c
      write(10,27)
      write(10,*)'Testing he5_gddeforigin... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gddeforigin... '
      write(*,*)'=========================='
      status = he5_gddeforigin(gdid_utm,HE5_HDFE_GD_UL)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gddeforigin(gdid_utm,
     1HE5_HDFE_GD_UL)'
         write(*,*)'Value of status from gddeforigin ',status
         write(10,*)'status = he5_gddeforigin(gdid_utm,
     1HE5_HDFE_GD_UL)'
         write(10,*)'Value of status from gddeforigin ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddeforigin(gdid3,HE5_HDFE_GD_UL)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gddeforigin(gdid3,
     1HE5_HDFE_GD_UL)'
         write(*,*)'Value of status from gddeforigin ',status
         write(10,*)'status = he5_gddeforigin(gdid3,
     1HE5_HDFE_GD_UL)'
         write(10,*)'Value of status from gddeforigin ',status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddefdim
c
      write(10,27)
      write(10,*)'Testing he5_gddefdim... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gddefdim... '
      write(*,*)'=========================='
      testdim1 = 40
      status = he5_gddefdim(gdid2,'TestDim1',testdim1)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddefdim(gdid2,"TestDim1",40)'
         write(10,*)'Value returned by gddefdim ', status
         write(*,*)'status = he5_gddefdim(gdid2,"TestDim1",40)'
         write(*,*)'Value returned by gddefdim ', status
      endif
      write(10,*)' '
      write(*,*)' '

      testdim2 = 25
      status = he5_gddefdim(gdid2, 'TestDim2', testdim2)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddefdim(gdid2,"TestDim2",25)'
         write(10,*)'Value returned by gddefdim ', status
         write(*,*)'status = he5_gddefdim(gdid2,"TestDim2",25)'
         write(*,*)'Value returned by gddefdim ', status
      endif
      write(10,*)' '
      write(*,*)' '

      conduction = 250
      status = he5_gddefdim(gdid_utm, 'Conduction', conduction)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddefdim(gdid_utm,
     1"Conduction",250)'
         write(10,*)'Returned value from gddefdim ', status
         write(*,*)'status = he5_gddefdim(gdid_utm, 
     1"Conduction", 250)'
         write(*,*)'Returned value from gddefdim ', status
      endif
      write(10,*)' '
      write(*,*)' '

      timedim = 4800
      status = he5_gddefdim(gdid_utm,'Timedim',timedim)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddefdim(gdid_utm,
     1"Timedim",4800)'
         write(10,*)'Status returned by call to gddefdim ',status
         write(*,*)'status = he5_gddefdim(gdid_utm,
     1"Timedim",4800)'
         write(*,*)'Status returned by call to gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      hghtdim = 80
      status = he5_gddefdim(gdid_utm,'Hghtdim',hghtdim)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = he5_gddefdim(gdid_utm,"Hghtdim",80)'
        write(10,*)'Status returned by call to gddefdim ',status
        write(*,*)'status = he5_gddefdim(gdid_utm,"Hghtdim",80)'
        write(*,*)'Status returned by call to gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      convection = 60
      status = he5_gddefdim(gdid_utm,'Convection',convection)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define dimension Convection '
        write(10,*)'status = he5_gddefdim(gdid_utm,
     1"Convection",60)'
        write(10,*)'Status returned by call to gddefdim ',status
        write(*,*)'Define dimension Convection '
        write(*,*)'status = he5_gddefdim(gdid_utm,
     1"Convection",60)'
        write(*,*)'Status returned by call to gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      conduction = 250
      status = he5_gddefdim(gdid3, 'Conduction', conduction)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddefdim(gdid3,
     1"Conduction",250)'
         write(10,*)'Returned value from gddefdim ', status
         write(*,*)'status = he5_gddefdim(gdid3, 
     1"Conduction", 250)'
         write(*,*)'Returned value from gddefdim ', status
      endif
      write(10,*)' '
      write(*,*)' '

      timedim = 4800
      status = he5_gddefdim(gdid3,'Timedim',timedim)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddefdim(gdid3,
     1"Timedim",4800)'
         write(10,*)'Status returned by call to gddefdim ',status
         write(*,*)'status = he5_gddefdim(gdid3,
     1"Timedim",4800)'
         write(*,*)'Status returned by call to gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      hghtdim = 80
      status = he5_gddefdim(gdid3,'Hghtdim',hghtdim)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = he5_gddefdim(gdid3,"Hghtdim",80)'
        write(10,*)'Status returned by call to gddefdim ',status
        write(*,*)'status = he5_gddefdim(gdid3,"Hghtdim",80)'
        write(*,*)'Status returned by call to gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      convection = 60
      status = he5_gddefdim(gdid3,'Convection',convection)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define dimension Convection '
        write(10,*)'status = he5_gddefdim(gdid3,
     1"Convection",60)'
        write(10,*)'Status returned by call to gddefdim ',status
        write(*,*)'Define dimension Convection '
        write(*,*)'status = he5_gddefdim(gdid3,
     1"Convection",60)'
        write(*,*)'Status returned by call to gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddetach
c
      write(10,27)
      write(10,*)'Testing he5_gddetach... '
      write(10,*)'======================='
      write(*,*)'Testing he5_gddetach... '
      write(*,*)'======================='
      status = he5_gddetach(gdid2)
      if(status .lt. zero) then
         write(*,231)
         write(10,231)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid2)'
         write(10,*)'Value returned by gddetach ', status
         write(*,*)'status = he5_gddetach(gdid2)'
         write(*,*)'Value returned by gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid_utm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Returned value from gddetach ', status
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Returned value from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '
 
      status = he5_gddetach(gdid3)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid3)'
         write(10,*)'Returned value from gddetach ', status
         write(*,*)'status = he5_gddetach(gdid3)'
         write(*,*)'Returned value from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '
 
c Test Case -- he5_gdattach
c
      write(10,27)
      write(10,*)'Testing he5_gdattach... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdattach... '
      write(*,*)'=========================='
      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if(gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid_utm=he5_gdattach(gdfid,"UTMGrid")'
         write(10,*)'Handle returned from gdattach ',gdid_utm
         write(*,*)'gdid_utm=he5_gdattach(gdfid,"UTMGrid")'
         write(*,*)'Handle returned from gdattach ',gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

      gdid2 = he5_gdattach(gdfid2, 'UTMGrid2')
      if(gdid2 .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid2=he5_gdattach(gdfid2, "UTMGrid2")'
         write(10,*)'Value returned by gdattach ', gdid2
         write(*,*)'gdid2=he5_gdattach(gdfid2, "UTMGrid2")'
         write(*,*)'Value returned by gdattach ', gdid2
      endif
      write(10,*)' '
      write(*,*)' '

      gdid3 = he5_gdattach(gdfid3, 'UTMGrid3')
      if(gdid3 .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid3=he5_gdattach(gdfid3, "UTMGrid3")'
         write(10,*)'Value returned by gdattach ', gdid3
         write(*,*)'gdid3=he5_gdattach(gdfid3, "UTMGrid3")'
         write(*,*)'Value returned by gdattach ', gdid3
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddeffld
c
      write(10,27)
      write(10,*)'Testing he5_gddeffld... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gddeffld... '
      write(*,*)'=========================='

      status= he5_gddeffld(gdid2,"tempfield","TestDim2,TestDim1",
     1" ",HE5T_NATIVE_FLOAT, HE5_HDFE_NOMERGE)
      if(status .lt. zero) then
         write(*,231)
         write(10,231)
        
      else 
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "tempfield"'
        write(10,*)'status= he5_gddeffld(gdid2,"tempfield",
     1"TestDim2,TestDim1"," ",HE5T_NATIVE_FLOAT,HE5_HDFE_NOMERGE)'
        write(10,*)'Value returned by gddeffld ', status
        write(*,*)'Define: "tempfield"'
        write(*,*)'status= he5_gddeffld(gdid2,"tempfield",
     1"TestDim2,TestDim1","",HE5T_NATIVE_FLOAT,HE5_HDFE_NOMERGE)'
        write(*,*)'Value returned by gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid_utm,'Time','Timedim'," ",
     1HE5T_NATIVE_DOUBLE, HE5_HDFE_NOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
        write(*,*)' '
        write(*,240)
        write(10,*)' '
        write(10,240)
        write(10,*)' Define field Time'
        write(10,*)'status= he5_gddeffld(gdid_utm,"Time","Timedim",
     1"",HE5T_NATIVE_DOUBLE, HE5_HDFE_NOMERGE)'
        write(10,*)'Status returned by call to gddeffld ',status
        write(*,*)' Define field Time'
        write(*,*)'status= he5_gddeffld(gdid_utm,"Time","Timedim",
     1"",HE5T_NATIVE_DOUBLE, HE5_HDFE_NOMERGE)'
        write(*,*)'Status returned by call to gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid_utm,'Height','Hghtdim'," ", 
     1HE5T_NATIVE_FLOAT, HE5_HDFE_NOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
        write(*,*)' '
        write(*,240)
        write(10,*)' '
        write(10,240)
        write(10,*)' Define field Height'
        write(10,*)'status= he5_gddeffld(gdid_utm,"Height",
     1"Hghtdim","",HE5T_NATIVE_FLOAT, HE5_HDFE_NOMERGE)'
        write(10,*)'Status returned by call to gddeffld ',status
        write(*,*)' Define field Height'
        write(*,*)'status= he5_gddeffld(gdid_utm,"Height","Hghtdim",
     1"",HE5T_NATIVE_FLOAT, HE5_HDFE_NOMERGE)'
        write(*,*)'Status returned by call to gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid3,'Time','Timedim'," ",
     1HE5T_NATIVE_DOUBLE, HE5_HDFE_NOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
        write(*,*)' '
        write(*,240)
        write(10,*)' '
        write(10,240)
        write(10,*)' Define field Time'
        write(10,*)'status= he5_gddeffld(gdid3,"Time","Timedim",
     1"",HE5T_NATIVE_DOUBLE, HE5_HDFE_NOMERGE)'
        write(10,*)'Status returned by call to gddeffld ',status
        write(*,*)' Define field Time'
        write(*,*)'status= he5_gddeffld(gdid3,"Time","Timedim",
     1"",HE5T_NATIVE_DOUBLE, HE5_HDFE_NOMERGE)'
        write(*,*)'Status returned by call to gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid3,'Height','Hghtdim'," ", 
     1HE5T_NATIVE_FLOAT, HE5_HDFE_NOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
        write(*,*)' '
        write(*,240)
        write(10,*)' '
        write(10,240)
        write(10,*)' Define field Height'
        write(10,*)'status= he5_gddeffld(gdid3,"Height",
     1"Hghtdim","",HE5T_NATIVE_FLOAT, HE5_HDFE_NOMERGE)'
        write(10,*)'Status returned by call to gddeffld ',status
        write(*,*)' Define field Height'
        write(*,*)'status= he5_gddeffld(gdid3,"Height","Hghtdim",
     1"",HE5T_NATIVE_FLOAT, HE5_HDFE_NOMERGE)'
        write(*,*)'Status returned by call to gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- he5_gddeftle
c
      write(10,27)
      write(10,*)'Testing he5_gddeftle... '
      write(10,*)'======================='
      write(*,*)'Testing he5_gddeftle... '
      write(*,*)'======================='

      status = he5_gddeftle(gdid_utm,HE5_HDFE_TILE,2,tiledims)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define tiling dimensions '
        write(10,*)'status = he5_gddeftle(gdid_utm,
     1HE5_HDFE_TILE,2,tiledims)'
        write(10,*)'Status returned by call to gddeftle ',status
        write(*,*)'Status returned by call to gddeftle ',status
        write(*,*)'status = he5_gddeftle(gdid_utm,
     1HE5_HDFE_TILE,2,tiledims)'
        write(*,*)'Define tiling dimensions '
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid_utm,'SideB','YDim,Convection',
     1" ",HE5T_NATIVE_INT, HE5_HDFE_NOMERGE)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define field that will be tiled '
        write(10,*)'status= he5_gddeffld(gdid_utm,"SideB",
     1"YDim,Convection"," ",HE5T_NATIVE_INT,HE5_HDFE_NOMERGE)'
        write(10,*)'Status returned by call to gddeffld ',status
        write(*,*)'Define field that will be tiled '
        write(*,*)'status= he5_gddeffld(gdid_utm,"SideB",
     1"YDim,Convection","",HE5T_NATIVE_INT,HE5_HDFE_NOMERGE)'
        write(*,*)'Status returned by call to gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid_utm)
      if (status .lt. zero) then 
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Returned value from gddetach ', status
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Returned value from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if (gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gdattach(gdfid,"UTMGrid")'
         write(10,*)'Returned value from gdattach ', status
         write(*,*)'status = he5_gddetach(gdfid,"UTMGrid")'
         write(*,*)'Returned value from gdattach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid_utm,'Grounding','Conduction',
     1" ",HE5T_NATIVE_FLOAT, HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Define: "Grounding"'                  
         write(10,*)'status= he5_gddeffld(gdid_utm,"Grounding",
     1"Conduction","",HE5T_NATIVE_FLOAT,HE5_HDF_NOMERGE)'
         write(10,*)'Value returned by gddeffld ', status
         write(*,*)'Define: "Grounding"'                  
         write(*,*)'status= he5_gddeffld(gdid_utm,"Grounding",
     1"Conduction","",HE5T_NATIVE_FLOAT,HE5_HDF_NOMERGE)'
         write(*,*)'Value returned by gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddeftle(gdid3,HE5_HDFE_TILE,2,tiledims)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define tiling dimensions '
        write(10,*)'status = he5_gddeftle(gdid3,
     1HE5_HDFE_TILE,2,tiledims)'
        write(10,*)'Status returned by call to gddeftle ',status
        write(*,*)'Status returned by call to gddeftle ',status
        write(*,*)'status = he5_gddeftle(gdid3,
     1HE5_HDFE_TILE,2,tiledims)'
        write(*,*)'Define tiling dimensions '
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid3,'SideB','YDim,Convection',
     1" ",HE5T_NATIVE_INT, HE5_HDFE_NOMERGE)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define field that will be tiled '
        write(10,*)'status= he5_gddeffld(gdid3,"SideB",
     1"YDim,Convection"," ",HE5T_NATIVE_INT,HE5_HDFE_NOMERGE)'
        write(10,*)'Status returned by call to gddeffld ',status
        write(*,*)'Define field that will be tiled '
        write(*,*)'status= he5_gddeffld(gdid3,"SideB",
     1"YDim,Convection","",HE5T_NATIVE_INT,HE5_HDFE_NOMERGE)'
        write(*,*)'Status returned by call to gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid3)
      if (status .lt. zero) then 
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid3)'
         write(10,*)'Returned value from gddetach ', status
         write(*,*)'status = he5_gddetach(gdid3)'
         write(*,*)'Returned value from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid3 = he5_gdattach(gdfid3, 'UTMGrid3')
      if (gdid3 .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gdattach(gdfid3,"UTMGrid3")'
         write(10,*)'Returned value from gdattach ', status
         write(*,*)'status = he5_gddetach(gdfid3,"UTMGrid3")'
         write(*,*)'Returned value from gdattach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid3,'Grounding','Conduction',
     1" ",HE5T_NATIVE_FLOAT, HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Define: "Grounding"'                  
         write(10,*)'status= he5_gddeffld(gdid3,"Grounding",
     1"Conduction","",HE5T_NATIVE_FLOAT,HE5_HDF_NOMERGE)'
         write(10,*)'Value returned by gddeffld ', status
         write(*,*)'Define: "Grounding"'                  
         write(*,*)'status= he5_gddeffld(gdid3,"Grounding",
     1"Conduction","",HE5T_NATIVE_FLOAT,HE5_HDF_NOMERGE)'
         write(*,*)'Value returned by gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddefcomp
c
      write(10,27)
      write(10,*)'Testing he5_gddefcomp... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gddefcomp... '
      write(*,*)'=========================='

      tiledims(1) = 16
      tiledims(2) = 15
      status = he5_gddeftle(gdid_utm,HE5_HDFE_TILE,2,tiledims)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'Setup Tiling dimensions '
         write(*,*)'Required when using compression'
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefcomp(gdid_utm,HE5_HDFE_COMP_DEFLATE, compparm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Setup compression mode'
        write(10,*)'status = he5_gddefcomp(gdid_utm,
     1HE5_HDFE_COMP_DEFLATE, compparm)'
        write(10,*)'Status returned by call to gddefcomp ',status
        write(*,*)'Setup compression mode'
        write(*,*)'status = he5_gddefcomp(gdid_utm,
     1HE5_HDFE_COMP_DEFLATE, compparm)'
        write(*,*)'Status returned by call to gddefcomp ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid_utm,"Voltage","YDim,XDim"," ",
     1HE5T_NATIVE_FLOAT,0)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "Voltage"'
        write(10,*)'status = he5_gddeffld(gdid_utm,"Voltage",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
        write(10,*)'Value returned from gddeffld ', status
        write(*,*)'Define: "Voltage"'
        write(*,*)'status = he5_gddeffld(gdid_utm,"Voltage",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
        write(*,*)'Value returned from gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddeftle(gdid3,HE5_HDFE_TILE,2,tiledims)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'Setup Tiling dimensions '
         write(*,*)'Required when using compression'
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefcomp(gdid3,
     1HE5_HDFE_COMP_SHUF_SZIP_K13orEC, compparm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Setup compression mode'
        write(10,*)'status = he5_gddefcomp(gdid3,
     1HE5_HDFE_COMP_SHUF_SZIP_K13orEC,compparm)'
        write(10,*)'Status returned by call to gddefcomp ',status
        write(*,*)'Setup compression mode'
        write(*,*)'status = he5_gddefcomp(gdid3,
     1HE5_HDFE_COMP_SHUF_SZIP_K13orEC,compparm)'
        write(*,*)'Status returned by call to gddefcomp ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid3,"Voltage","YDim,XDim"," ",
     1HE5T_NATIVE_FLOAT,0)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "Voltage"'
        write(10,*)'status = he5_gddeffld(gdid3,"Voltage",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
        write(10,*)'Value returned from gddeffld ', status
        write(*,*)'Define: "Voltage"'
        write(*,*)'status = he5_gddeffld(gdid3,"Voltage",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
        write(*,*)'Value returned from gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdsetfill
c
      write(10,27)
      write(10,*)'Testing he5_gdsetfill... '
      write(10,*)'========================'
      write(*,*)'Testing he5_gdsetfill... '
      write(*,*)'========================='

      status = he5_gdsetfill(gdid_utm, "Drift", 
     1HE5T_NATIVE_FLOAT, fillvalue)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Testing he5_gdsetfill'
         write(10,*)'status = he5_gdsetfill(gdid_utm, "Drift", 
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(10,*)'Returned from gdsetfill ', status
         write(*,*)'Testing he5_gdsetfill'
         write(*,*)'status = he5_gdsetfill(gdid_utm, "Drift", 
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(*,*)'Returned from gdsetfill ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid_utm,"Drift","YDim,XDim"," ",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "Drift"'      
        write(10,*)'status= he5_gddeffld(gdid_utm,"Drift","YDim,XDim",
     1"",HE5T_NATIVE_FLOAT, HE5_HDFE_AUTOMERGE)'
        write(10,*)'Value returned from gddeffld ', status
        write(*,*)'Define: "Drift"'      
        write(*,*)'status= he5_gddeffld(gdid_utm,"Drift","YDim,XDim",
     1"",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
        write(*,*)'Value returned from gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid_utm,'Impedance','YDim,XDim'," ",
     1HE5T_NATIVE_FLOAT, HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Define: "Impedance"'            
         write(10,*)'status= he5_gddeffld(gdid_utm,"Impedance",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
         write(10,*)'Value returned from gddeffld ', status
         write(*,*)'Define: "Impedance"'            
         write(*,*)'status= he5_gddeffld(gdid_utm,"Impedance",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
         write(*,*)'Value returned from gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '


      status = he5_gddetach(gdid_utm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Returned value from gddetach ', status
         write(*,*)'Returned value from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if(gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(10,*)'Handle returned from gdattach ', gdid_utm
         write(*,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(*,*)'Handle returned from gdattach ',gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdsetfill(gdid3, "Drift", 
     1HE5T_NATIVE_FLOAT, fillvalue)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Testing he5_gdsetfill'
         write(10,*)'status = he5_gdsetfill(gdid3, "Drift", 
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(10,*)'Returned from gdsetfill ', status
         write(*,*)'Testing he5_gdsetfill'
         write(*,*)'status = he5_gdsetfill(gdid3, "Drift", 
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(*,*)'Returned from gdsetfill ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid3,"Drift","YDim,XDim"," ",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "Drift"'      
        write(10,*)'status= he5_gddeffld(gdid3,"Drift","YDim,XDim",
     1"",HE5T_NATIVE_FLOAT, HE5_HDFE_AUTOMERGE)'
        write(10,*)'Value returned from gddeffld ', status
        write(*,*)'Define: "Drift"'      
        write(*,*)'status= he5_gddeffld(gdid3,"Drift","YDim,XDim",
     1"",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
        write(*,*)'Value returned from gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid3,'Impedance','YDim,XDim'," ",
     1HE5T_NATIVE_FLOAT, HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Define: "Impedance"'            
         write(10,*)'status= he5_gddeffld(gdid3,"Impedance",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
         write(10,*)'Value returned from gddeffld ', status
         write(*,*)'Define: "Impedance"'            
         write(*,*)'status= he5_gddeffld(gdid3,"Impedance",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
         write(*,*)'Value returned from gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '


      status = he5_gddetach(gdid3)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid3)'
         write(*,*)'status = he5_gddetach(gdid3)'
         write(10,*)'Returned value from gddetach ', status
         write(*,*)'Returned value from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid3 = he5_gdattach(gdfid3, 'UTMGrid3')
      if(gdid3 .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid3 = he5_gdattach(gdfid3, "UTMGrid3")'
         write(10,*)'Handle returned from gdattach ', gdid3
         write(*,*)'gdid3 = he5_gdattach(gdfid3, "UTMGrid3")'
         write(*,*)'Handle returned from gdattach ',gdid3
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- he5_gdwrfld
c
      write(10,27)
      write(10,*)'Testing he5_gdwrfld... '
      write(10,*)'======================'
      write(*,*)'Testing he5_gdwrfld... '
      write(*,*)'======================'

      start(1) = 0
      start(2) = 0
      stride(1) = 1
      stride(2) = 1
      edge(1) = 80
      edge(2) = 60
      
      status = he5_gdwrfld(gdid_utm,"Voltage",start,stride,
     1edge,utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Voltage '
        write(10,*)'status= he5_gdwrfld(gdid_utm,"Voltage",start,
     1stride,edge,utmray)'
        write(10,*)'Status returned by gdwrfield ', status
        write(*,*)'Write to field Voltage '
        write(*,*)'status= he5_gdwrfld(gdid_utm,"Voltage",start,
     1stride,edge,utmray)'
        write(*,*)'Status returned by gdwrfield ', status
      endif
      write(10,*)' '
      write(*,*)' '


      start(1) = 10
      start(2) = 10
      edge(1) = 10
      edge(2) = 10
      status=he5_gdwrfld(gdid_utm,'Drift',start,stride,
     1edge,utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Drift '
        write(10,*)'status=he5_gdwrfld(gdid_utm,"Drift",start,
     1stride,edge,utmray)'
        write(10,*)'Status returned from gdwrfld ', status
        write(*,*)'Write to field Drift '
        write(*,*)'status = he5_gdwrfld(gdid_utm,"Drift",start,
     1stride,edge,utmray)'
        write(*,*)'Status returned from gdwrfld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      start(1) = 0
      start(2) = 0
      edge(1) = 80
      edge(2) = 60
      status = he5_gdwrfld(gdid_utm, 'Impedance', start,stride,
     1edge,utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Impedance '
        write(10,*)'status= he5_gdwrfld(gdid_utm,"Impedance",start,
     1stride,edge,utmray)'
        write(10,*)'Returned from gdwrfld ', status
        write(*,*)'Write to field Impedance '
        write(*,*)'status= he5_gdwrfld(gdid_utm,"Impedance",start,
     1stride,edge,utmray)'
        write(*,*)'Returned from gdwrfld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=4800
      status= he5_gdwrfld(gdid_utm,'Time',start1d,stride1d,
     1edge1d,utmtmeray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Time '
        write(10,*)'status= he5_gdwrfld(gdid_utm,"Time",start1d,
     1stride1d,edge1d,utmtmeray)'
        write(10,*)'Status returned by call to gdwrfld ',status
        write(*,*)'Write to field Time '
        write(*,*)'status= he5_gdwrfld(gdid_utm,"Time",start1d,stride1d,
     1edge1d,utmtmeray)'
        write(*,*)'Status returned by call to gdwrfld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=80
      status= he5_gdwrfld(gdid_utm,'Height',start1d,stride1d,
     1edge1d,utmhght)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Height '
        write(10,*)'status= he5_gdwrfld(gdid_utm,"Height",start1d,
     1stride1d,edge1d,utmhght)'
        write(10,*)'Status returned by call to gdwrfld ',status
        write(*,*)'Write to field Height '
        write(*,*)'status= he5_gdwrfld(gdid_utm,"Height",start1d,
     1stride1d,edge1d,utmhght)'
        write(*,*)'Status returned by call to gdwrfld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=250
      status= he5_gdwrfld(gdid_utm,'Grounding',start1d,
     1stride1d,edge1d,ray3)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Grounding '
        write(10,*)'status= he5_gdwrfld(gdid_utm,"Grounding",start1d,
     1stride1d,edge1d,ray3)'
        write(10,*)'Value returned by gdwrfld ', status
        write(*,*)'Write to field Grounding '
        write(*,*)'status= he5_gdwrfld(gdid_utm,"Grounding",start1d,
     1stride1d,edge1d,ray3)'
        write(*,*)'Value returned by gdwrfld ', status
      endif
        write(10,*)' '
        write(*,*)' '

      status = he5_gddetach(gdid_utm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Value of status returned by gddetach ',status
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Value of status returned by gddetach ',status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(10,*)'Grid id returned by gdattach ',gdid_utm
         write(*,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(*,*)'Grid id returned by gdattach ',gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

      start(1) = 0
      start(2) = 0
      stride(1) = 1
      stride(2) = 1
      edge(1) = 80
      edge(2) = 60
      
      status = he5_gdwrfld(gdid3,"Voltage",start,stride,
     1edge,utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Voltage '
        write(10,*)'status= he5_gdwrfld(gdid3,"Voltage",start,
     1stride,edge,utmray)'
        write(10,*)'Status returned by gdwrfield ', status
        write(*,*)'Write to field Voltage '
        write(*,*)'status= he5_gdwrfld(gdid3,"Voltage",start,
     1stride,edge,utmray)'
        write(*,*)'Status returned by gdwrfield ', status
      endif
      write(10,*)' '
      write(*,*)' '


      start(1) = 10
      start(2) = 10
      edge(1) = 10
      edge(2) = 10
      status=he5_gdwrfld(gdid3,'Drift',start,stride,
     1edge,utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Drift '
        write(10,*)'status=he5_gdwrfld(gdid3,"Drift",start,
     1stride,edge,utmray)'
        write(10,*)'Status returned from gdwrfld ', status
        write(*,*)'Write to field Drift '
        write(*,*)'status = he5_gdwrfld(gdid3,"Drift",start,
     1stride,edge,utmray)'
        write(*,*)'Status returned from gdwrfld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      start(1) = 0
      start(2) = 0
      edge(1) = 80
      edge(2) = 60
      status = he5_gdwrfld(gdid3, 'Impedance', start,stride,
     1edge,utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Impedance '
        write(10,*)'status= he5_gdwrfld(gdid3,"Impedance",start,
     1stride,edge,utmray)'
        write(10,*)'Returned from gdwrfld ', status
        write(*,*)'Write to field Impedance '
        write(*,*)'status= he5_gdwrfld(gdid3,"Impedance",start,
     1stride,edge,utmray)'
        write(*,*)'Returned from gdwrfld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=4800
      status= he5_gdwrfld(gdid3,'Time',start1d,stride1d,
     1edge1d,utmtmeray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Time '
        write(10,*)'status= he5_gdwrfld(gdid3,"Time",start1d,
     1stride1d,edge1d,utmtmeray)'
        write(10,*)'Status returned by call to gdwrfld ',status
        write(*,*)'Write to field Time '
        write(*,*)'status= he5_gdwrfld(gdid3,"Time",start1d,stride1d,
     1edge1d,utmtmeray)'
        write(*,*)'Status returned by call to gdwrfld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=80
      status= he5_gdwrfld(gdid3,'Height',start1d,stride1d,
     1edge1d,utmhght)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Height '
        write(10,*)'status= he5_gdwrfld(gdid3,"Height",start1d,
     1stride1d,edge1d,utmhght)'
        write(10,*)'Status returned by call to gdwrfld ',status
        write(*,*)'Write to field Height '
        write(*,*)'status= he5_gdwrfld(gdid3,"Height",start1d,
     1stride1d,edge1d,utmhght)'
        write(*,*)'Status returned by call to gdwrfld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=250
      status= he5_gdwrfld(gdid3,'Grounding',start1d,
     1stride1d,edge1d,ray3)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Grounding '
        write(10,*)'status= he5_gdwrfld(gdid3,"Grounding",start1d,
     1stride1d,edge1d,ray3)'
        write(10,*)'Value returned by gdwrfld ', status
        write(*,*)'Write to field Grounding '
        write(*,*)'status= he5_gdwrfld(gdid3,"Grounding",start1d,
     1stride1d,edge1d,ray3)'
        write(*,*)'Value returned by gdwrfld ', status
      endif
        write(10,*)' '
        write(*,*)' '

      status = he5_gddetach(gdid3)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid3)'
         write(10,*)'Value of status returned by gddetach ',status
         write(*,*)'status = he5_gddetach(gdid3)'
         write(*,*)'Value of status returned by gddetach ',status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid3 = he5_gdattach(gdfid3, 'UTMGrid3')
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid3 = he5_gdattach(gdfid3, "UTMGrid3")'
         write(10,*)'Grid id returned by gdattach ',gdid3
         write(*,*)'gdid3 = he5_gdattach(gdfid3, "UTMGrid3")'
         write(*,*)'Grid id returned by gdattach ',gdid3
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- he5_gdwrattr
c
      write(10,27)
      write(10,*)'Testing he5_gdwrattr... Global attribute '
      write(10,*)'==================================== '
      write(*,*)'Testing he5_gdwrattr... Global attribute '
      write(*,*)'==================================== '

      setcount(1) = 4
      status = he5_gdwrattr(gdid_utm, 'Resistance', HE5T_NATIVE_INT, 
     1setcount, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status= he5_gdwrattr(gdid_utm,"Resistance",
     1HE5T_NATIVE_INT, 4, attr)'
         write(10,*)'Returned from gdwrattr ', status
         write(*,*)'status= he5_gdwrattr(gdid_utm,"Resistance",
     1HE5T_NATIVE_FLOAT, 4, attr)'
         write(*,*)'Returned from gdwrattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

      setcount(1) = 4
      status = he5_gdwrattr(gdid3, 'Resistance', HE5T_NATIVE_INT, 
     1setcount, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status= he5_gdwrattr(gdid3,"Resistance",
     1HE5T_NATIVE_INT, 4, attr)'
         write(10,*)'Returned from gdwrattr ', status
         write(*,*)'status= he5_gdwrattr(gdid3,"Resistance",
     1HE5T_NATIVE_FLOAT, 4, attr)'
         write(*,*)'Returned from gdwrattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdwrgattr
c
      write(10,27)
      write(10,*)'Testing he5_gdwrgattr... Group attribute '
      write(10,*)'==================================== '
      write(*,*)'Testing he5_gdwrgattr... Group attribute '
      write(*,*)'==================================== '

      attr(1) = 22
      attr(2) = 44
      attr(3) = 66
      attr(4) = 88
      status = he5_gdwrgattr(gdid_utm, 'group', HE5T_NATIVE_INT, 
     1setcount, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status= he5_gdwrgattr(gdid_utm,"group",
     1HE5T_NATIVE_INT, 4, attr)'
         write(10,*)'Returned from gdwrgattr ', status
         write(*,*)'status= he5_gdwrgattr(gdid_utm,"group",
     1HE5T_NATIVE_INT, 4, attr)'
         write(*,*)'Returned from gdwrgattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdwrgattr(gdid3, 'group', HE5T_NATIVE_INT, 
     1setcount, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status= he5_gdwrgattr(gdid3,"group",
     1HE5T_NATIVE_INT, 4, attr)'
         write(10,*)'Returned from gdwrgattr ', status
         write(*,*)'status= he5_gdwrgattr(gdid3,"group",
     1HE5T_NATIVE_INT, 4, attr)'
         write(*,*)'Returned from gdwrgattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdwrlattr
c
      write(10,27)
      write(10,*)'Testing he5_gdwrlattr... Local attribute '
      write(10,*)'======================================== '
      write(*,*)'Testing he5_gdwrlattr... Local attribute '
      write(*,*)'======================================== '

      attr(1) = 12
      attr(2) = 34
      attr(3) = 56
      attr(4) = 78
      status = he5_gdwrlattr(gdid_utm,"Grounding", "local", 
     1HE5T_NATIVE_INT,setcount, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status= he5_gdwrlattr(gdid_utm,"Grounding",
     1"local",HE5T_NATIVE_INT, 4, attr)'
         write(10,*)'Returned from gdwrlattr ', status
         write(*,*)'status= he5_gdwrlattr(gdid_utm,"Grounding",
     1"local",HE5T_NATIVE_INT, 4, attr)'
         write(*,*)'Returned from gdwrlattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid_utm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Returned from gddetach ', status
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Returned from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdwrlattr(gdid3,"Grounding", "local", 
     1HE5T_NATIVE_INT,setcount, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status= he5_gdwrlattr(gdid3,"Grounding",
     1"local",HE5T_NATIVE_INT, 4, attr)'
         write(10,*)'Returned from gdwrlattr ', status
         write(*,*)'status= he5_gdwrlattr(gdid3,"Grounding",
     1"local",HE5T_NATIVE_INT, 4, attr)'
         write(*,*)'Returned from gdwrlattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid3)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid3)'
         write(10,*)'Returned from gddetach ', status
         write(*,*)'status = he5_gddetach(gdid3)'
         write(*,*)'Returned from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '


      status = he5_gddetach(gdid2)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid2)'
         write(10,*)'Value returned by gddetach ', status
         write(*,*)'status = he5_gddetach(gdid2)'
         write(*,*)'Value returned by gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdclose
c
      write(10,27)
      write(10,*)'Testing he5_gdclose... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdclose... '
      write(*,*)'=========================='

      status = he5_gdclose(gdfid2)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gdclose(gdfid2)'
         write(10,*)'Value returned by gdclose ', status
         write(*,*)'status = he5_gdclose(gdfid2)'
         write(*,*)'Value returned by gdclose ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdclose(gdfid3)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gdclose(gdfid3)'
         write(10,*)'Value returned by gdclose ', status
         write(*,*)'status = he5_gdclose(gdfid3)'
         write(*,*)'Value returned by gdclose ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdclose(gdfid)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gdclose(gdfid)'
         write(10,*)'Returned from gdclose ', status
         write(*,*)'status = he5_gdclose(gdfid)'
         write(*,*)'Returned from gdclose ', status
      endif
      write(10,*)' '
      write(*,*)' '

      
      gdfid = he5_gdopen('grid.he5',HE5F_ACC_RDWR)
      if (gdfid .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'gdfid = he5_gdopen("grid.he5",HE5F_ACC_RDWR)'
         write(10,*)'gdfid = he5_gdopen("grid.he5",HE5F_ACC_RDWR)'
         write(*,*)'Grid file id returned by gdopen ',gdfid
         write(10,*)'Grid file id returned by gdopen ',gdfid
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if (gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(10,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(*,*)'Grid id returned by gdattach ',gdid_utm
         write(10,*)'Grid id returned by gdattach ',gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

      gdfid3 = he5_gdopen('grid3.he5',HE5F_ACC_RDWR)
      if (gdfid3 .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'gdfid3 = he5_gdopen("grid3.he5",HE5F_ACC_RDWR)'
         write(10,*)'gdfid3 = he5_gdopen("grid3.he5",HE5F_ACC_RDWR)'
         write(*,*)'Grid file id returned by gdopen ',gdfid3
         write(10,*)'Grid file id returned by gdopen ',gdfid3
      endif
      write(10,*)' '
      write(*,*)' '


      gdid3 = he5_gdattach(gdfid3, 'UTMGrid3')
      if (gdid3 .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'gdid3 = he5_gdattach(gdfid3, "UTMGrid3")'
         write(10,*)'gdid3 = he5_gdattach(gdfid3, "UTMGrid3")'
         write(*,*)'Grid id returned by gdattach ',gdid3
         write(10,*)'Grid id returned by gdattach ',gdid3
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdinqgrid
c
      write(10,27)
      write(10,*)'Testing he5_gdinqgrid... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdinqgrid... '
      write(*,*)'=========================='

      lstatus = he5_gdinqgrid('grid.he5',grdnames,strbufsize)
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = he5_gdinqgrid("grid.he5",grdnames,
     1strbufsize)'
         write(*,*)'Names of grids ',grdnames
         write(*,*)'Number of grids ',lstatus
         write(*,*)'Size of names of grids ',strbufsize
         write(10,*)'lstatus = he5_gdinqgrid("grid.he5",grdnames,
     1strbufsize)'
         write(10,*)'Names of grids ',grdnames
         write(10,*)'Number of grids ',lstatus
         write(10,*)'Size of names of grids ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

      lstatus = he5_gdinqgrid('grid3.he5',grdnames,strbufsize)
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = he5_gdinqgrid("grid3.he5",grdnames,
     1strbufsize)'
         write(*,*)'Names of grids ',grdnames
         write(*,*)'Number of grids ',lstatus
         write(*,*)'Size of names of grids ',strbufsize
         write(10,*)'lstatus = he5_gdinqgrid("grid3.he5",grdnames,
     1strbufsize)'
         write(10,*)'Names of grids ',grdnames
         write(10,*)'Number of grids ',lstatus
         write(10,*)'Size of names of grids ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdorginfo
c
      write(10,27)
      write(10,*)'Testing he5_gdorginfo... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdorginfo... '
      write(*,*)'=========================='

      status = he5_gdorginfo(gdid_utm, orgcode)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = he5_gdorginfo(gdid_utm, orgcode)'
         write(10,*)'lstatus = he5_gdorginfo(gdid_utm, orgcode)'
         write(*,*)'Value returned by gdorginfo ',status
         write(10,*)'Value returned by gdorginfo ',status
         write(*,*)'Origin code value ',orgcode
         write(10,*)'Origin code value ',orgcode
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdorginfo(gdid3, orgcode)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = he5_gdorginfo(gdid3, orgcode)'
         write(10,*)'lstatus = he5_gdorginfo(gdid3, orgcode)'
         write(*,*)'Value returned by gdorginfo ',status
         write(10,*)'Value returned by gdorginfo ',status
         write(*,*)'Origin code value ',orgcode
         write(10,*)'Origin code value ',orgcode
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdpreginfo
c
      write(10,27)
      write(10,*)'Testing he5_gdpreginfo... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdpreginfo... '
      write(*,*)'=========================='

      status = he5_gdpreginfo(gdid_utm, pixregcode)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdpreginfo(gdid_utm, pixregcode)'
         write(10,*)'status = he5_gdpreginfo(gdid_utm, pixregcode)'
         write(*,*)'Value returned by gdpreginfo ',status
         write(10,*)'Value returned by gdpreginfo ',status
         write(*,*)'Pixel reg code ',pixregcode
         write(10,*)'Pixel reg code ',pixregcode
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdpreginfo(gdid3, pixregcode)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdpreginfo(gdid3, pixregcode)'
         write(10,*)'status = he5_gdpreginfo(gdid3, pixregcode)'
         write(*,*)'Value returned by gdpreginfo ',status
         write(10,*)'Value returned by gdpreginfo ',status
         write(*,*)'Pixel reg code ',pixregcode
         write(10,*)'Pixel reg code ',pixregcode
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdinqdims
c
      write(10,27)
      write(10,*)'Testing he5_gdinqdims... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdinqdims... '
      write(*,*)'=========================='

      status = he5_gdinqdims(gdid_utm, dimname, dims)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdinqdims(gdid_utm, dimname, dims)'
         write(*,*)'Number of dimensions ',status
         write(*,*)'Dimensions in grid UTM ',dimname
         write(*,*)'Size of dimensions '
         write(10,*)'status = he5_gdinqdims(gdid_utm, dimname, dims)'
         write(10,*)'Number of dimensions ',status
         write(10,*)'Dimensions in grid UTM ',dimname
         write(10,*)'Size of dimensions '
         do 130 i=1,status
            write(*,*)' ',dims(i)
            write(10,*)' ',dims(i)
 130     continue
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdinqdims(gdid3, dimname, dims)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdinqdims(gdid3, dimname, dims)'
         write(*,*)'Number of dimensions ',status
         write(*,*)'Dimensions in grid UTM ',dimname
         write(*,*)'Size of dimensions '
         write(10,*)'status = he5_gdinqdims(gdid3, dimname, dims)'
         write(10,*)'Number of dimensions ',status
         write(10,*)'Dimensions in grid UTM ',dimname
         write(10,*)'Size of dimensions '
         do 131 i=1,status
            write(*,*)' ',dims(i)
            write(10,*)' ',dims(i)
 131     continue
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddiminfo
c
      write(10,27)
      write(10,*)'Testing he5_gddiminfo... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gddiminfo... '
      write(*,*)'=========================='

      lstatus = he5_gddiminfo(gdid_utm, 'Conduction')
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus=he5_gddiminfo(gdid_utm,"Conduction")'
         write(*,*)'Size of dimension Conduction ',lstatus
         write(10,*)'lstatus=he5_gddiminfo(gdid_utm,"Conduction")'
         write(10,*)'Size of dimension Conduction ',lstatus
      endif
      write(10,*)' '
      write(*,*)' '

      lstatus = he5_gddiminfo(gdid3, 'Conduction')
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus=he5_gddiminfo(gdid3,"Conduction")'
         write(*,*)'Size of dimension Conduction ',lstatus
         write(10,*)'lstatus=he5_gddiminfo(gdid3,"Conduction")'
         write(10,*)'Size of dimension Conduction ',lstatus
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdgridinfo
c
      write(10,27)
      write(10,*)'Testing he5_gdgridinfo... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdgridinfo... '
      write(*,*)'=========================='

      status= he5_gdgridinfo(gdid_utm,xdimsize,ydimsize,
     1upleftpt,lowrtpt)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status= he5_gdgridinfo(gdid_utm,xdimsize,
     1ydimsize,upleftpt,lowrtpt)'
         write(*,*)'Status returned by gdgridinfo ',status
         write(*,11)'X dim size ',xdimsize, ' Y dim size ',ydimsize
         write(*,12)'Upper left pt ',upleftpt(1),' ',upleftpt(2)
         write(*,12)'Lower right pt ',lowrtpt(1),' ',lowrtpt(2)
         write(10,*)'status= he5_gdgridinfo(gdid_utm,xdimsize,
     1ydimsize,upleftpt,lowrtpt)'
         write(10,*)'Value returned by gdgridinfo ',status
         write(10,*)'X dim size ',xdimsize, ' Y dim size ',ydimsize
         write(10,*)'Upper left pt ',upleftpt(1),upleftpt(2)
         write(10,*)'Lower right pt ',lowrtpt(1),lowrtpt(2)
      endif
      write(10,*)' '
      write(*,*)' '
   11 format(a,i2,a,i2)
   12 format(a,f14.5,a,f14.5)

      status= he5_gdgridinfo(gdid3,xdimsize,ydimsize,
     1upleftpt,lowrtpt)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status= he5_gdgridinfo(gdid3,xdimsize,
     1ydimsize,upleftpt,lowrtpt)'
         write(*,*)'Status returned by gdgridinfo ',status
         write(*,11)'X dim size ',xdimsize, ' Y dim size ',ydimsize
         write(*,12)'Upper left pt ',upleftpt(1),' ',upleftpt(2)
         write(*,12)'Lower right pt ',lowrtpt(1),' ',lowrtpt(2)
         write(10,*)'status= he5_gdgridinfo(gdid3,xdimsize,
     1ydimsize,upleftpt,lowrtpt)'
         write(10,*)'Value returned by gdgridinfo ',status
         write(10,*)'X dim size ',xdimsize, ' Y dim size ',ydimsize
         write(10,*)'Upper left pt ',upleftpt(1),upleftpt(2)
         write(10,*)'Lower right pt ',lowrtpt(1),lowrtpt(2)
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdprojinfo
c
      write(10,27)
      write(10,*)'Testing he5_gdprojinfo... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdprojinfo... '
      write(*,*)'=========================='

      status = he5_gdprojinfo(gdid_utm,pcode,zcode,scode,pparm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdprojinfo(gdid_utm,pcode,
     1zcode,scode,pparm)'
         write(*,*)'Status returned by gdprojinfo ',status
         write(*,*)'Projection code ',pcode, ' Zone code ',zcode
         write(*,*)'Sphere code ',scode
         write(10,*)'status = he5_gdprojinfo(gdid_utm,pcode,
     1zcode,scode,pparm)'
         write(10,*)'Value returned by gdprojinfo ',status
         write(10,*)'Projection code ',pcode, ' Zone code ',zcode
         write(10,*)'Sphere code ',scode
         do 140 i=1,16
            write(*,55)' ',pparm(i)
            write(10,55)' ',pparm(i)
 140     continue
      endif
   55 format(a,f5.2)
      write(10,*)' '
      write(*,*)' '

      status = he5_gdprojinfo(gdid3,pcode,zcode,scode,pparm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdprojinfo(gdid3,pcode,
     1zcode,scode,pparm)'
         write(*,*)'Status returned by gdprojinfo ',status
         write(*,*)'Projection code ',pcode, ' Zone code ',zcode
         write(*,*)'Sphere code ',scode
         write(10,*)'status = he5_gdprojinfo(gdid3,pcode,
     1zcode,scode,pparm)'
         write(10,*)'Value returned by gdprojinfo ',status
         write(10,*)'Projection code ',pcode, ' Zone code ',zcode
         write(10,*)'Sphere code ',scode
         do 141 i=1,16
            write(*,55)' ',pparm(i)
            write(10,55)' ',pparm(i)
 141     continue
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdcompinfo
c
      write(10,27)
      write(10,*)'Testing he5_gdcompinfo... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdcompinfo... '
      write(*,*)'=========================='

      status = he5_gdcompinfo(gdid_utm,'Voltage',
     1compcodestring,compparm)
      if (status .lt. zero) then
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = he5_gdcompinfo(gdid_utm,"Voltage",
     1compcode,compparm)'
        write(10,*)'Compression info for field Voltage'
        write(10,*)'Comp code ',compcodestring
        write(10,*)'Compression parameters ',compparm
        write(*,*)'status = he5_gdcompinfo(gdid_utm,"Voltage",
     1compcode,compparm)'
        write(*,*)'Compression info for field Voltage'
        write(*,*)'Comp code ',compcodestring
        write(*,*)'Compression parameters ',compparm
      endif

      status = he5_gdcompinfo(gdid3,'Voltage',
     1compcodestring,compparm)
      if (status .lt. zero) then
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = he5_gdcompinfo(gdid3,"Voltage",
     1compcode,compparm)'
        write(10,*)'Compression info for field Voltage'
        write(10,*)'Comp code ',compcodestring
        write(10,*)'Compression parameters ',compparm
        write(*,*)'status = he5_gdcompinfo(gdid3,"Voltage",
     1compcode,compparm)'
        write(*,*)'Compression info for field Voltage'
        write(*,*)'Comp code ',compcodestring
        write(*,*)'Compression parameters ',compparm
      endif

c Test Case -- he5_gdinqflds
c
      write(10,27)
      write(10,*)'Testing he5_gdinqflds... '
      write(10,*)'========================'
      write(*,*)'Testing he5_gdinqflds... '
      write(*,*)'========================'

      nflds = he5_gdinqflds(gdid_utm,fldlist,rnk,numtype)
      if (nflds .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'nflds = he5_gdinqflds(gdid_utm,
     1fldlist,rnk,numtype)'
         write(*,*)'Number of fields ',nflds
         write(10,*)'nflds = he5_gdinqflds(gdid_utm,
     1fldlist,rnk,numtype)'
         write(10,*)'Number of fields ',nflds
         if (nflds .ne. 0) then
            write(*,*)'Fields ',fldlist
            write(10,*)'Fields ',fldlist
            do 150 i=1,nflds
               write(*,*)'Rank and type ',rnk(i), ' ',numtype(i)
               write(10,*)'Rank and type ',rnk(i), ' ',numtype(i)
  150       continue
         endif
      endif
      write(10,*)' '
      write(*,*)' '

      nflds = he5_gdinqflds(gdid3,fldlist,rnk,numtype)
      if (nflds .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'nflds = he5_gdinqflds(gdid3,
     1fldlist,rnk,numtype)'
         write(*,*)'Number of fields ',nflds
         write(10,*)'nflds = he5_gdinqflds(gdid3,
     1fldlist,rnk,numtype)'
         write(10,*)'Number of fields ',nflds
         if (nflds .ne. 0) then
            write(*,*)'Fields ',fldlist
            write(10,*)'Fields ',fldlist
            do 151 i=1,nflds
               write(*,*)'Rank and type ',rnk(i), ' ',numtype(i)
               write(10,*)'Rank and type ',rnk(i), ' ',numtype(i)
  151       continue
         endif
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdfldinfo
c
      write(10,27)
      write(10,*)'Testing he5_gdfldinfo... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdfldinfo... '
      write(*,*)'=========================='

      status = he5_gdfldinfo(gdid_utm, 'Drift', rnk, dims, 
     1numtype, dimname, maxdimname)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdfldinfo(gdid_utm, "Drift", 
     1rnk, dims, numtype, dimname, maxdimname)'
         write(*,*)'Value returned by gdfldinfo for field Drift ',
     1status
         write(*,*)'Drift rank ',rnk(1)
         write(*,*)'Dimensions  ',dims(1),' ',dims(2)
         write(*,*)'Number type of field ',numtype(1)
         write(*,*)'Dimension names ',dimname
         write(10,*)'status = he5_gdfldinfo(gdid_utm, "Drift",
     1rnk, dims, numtype, dimname, maxdimname)'
         write(10,*)'Value returned by gdfldinfo for field Drift ',
     1status
         write(10,*)'Drift rank ',rnk(1)
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdfldinfo(gdid3, 'Drift', rnk, dims, 
     1numtype, dimname, maxdimname)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdfldinfo(gdid3, "Drift", 
     1rnk, dims, numtype, dimname, maxdimname)'
         write(*,*)'Value returned by gdfldinfo for field Drift ',
     1status
         write(*,*)'Drift rank ',rnk(1)
         write(*,*)'Dimensions  ',dims(1),' ',dims(2)
         write(*,*)'Number type of field ',numtype(1)
         write(*,*)'Dimension names ',dimname
         write(10,*)'status = he5_gdfldinfo(gdid3, "Drift",
     1rnk, dims, numtype, dimname, maxdimname)'
         write(10,*)'Value returned by gdfldinfo for field Drift ',
     1status
         write(10,*)'Drift rank ',rnk(1)
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdrdfld
c
      write(10,27)
      write(10,*)'Testing he5_gdrdfld... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdrdfld... '
      write(*,*)'=========================='

      start(1) = 0
      start(2) = 0
      stride(1) = 1
      stride(2) = 1
      edge(1) = 80
      edge(2) = 60
      status = he5_gdrdfld(gdid_utm,'Drift',start,stride,edge,tempray)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdrdfld(gdid_utm,"Drift",
     1start,stride,edge,tempray)'
         write(*,*)'Value returned by gdrdfld ',status
         write(10,*)'status = he5_gdrdfld(gdid_utm,"Drift",
     1start,stride,edge,tempray)'
         write(10,*)'Value returned by gdrdfld ',status
         do 65 ii=1,6
           do 66 i=1,5
              write(10,*)'Field value at ',ii,' ',i,'  ',
     1tempray(ii,i)
              write(*,*)'Field value at ',ii,' ',i,'  ',
     1tempray(ii,i)
   66      continue
   65   continue
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdrdfld(gdid3,'Drift',start,stride,edge,tempray)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdrdfld(gdid3,"Drift",
     1start,stride,edge,tempray)'
         write(*,*)'Value returned by gdrdfld ',status
         write(10,*)'status = he5_gdrdfld(gdid3,"Drift",
     1start,stride,edge,tempray)'
         write(10,*)'Value returned by gdrdfld ',status
         do 75 ii=1,6
           do 76 i=1,5
              write(10,*)'Field value at ',ii,' ',i,'  ',
     1tempray(ii,i)
              write(*,*)'Field value at ',ii,' ',i,'  ',
     1tempray(ii,i)
   76      continue
   75   continue
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- he5_gdnentries
c
      write(10,27)
      write(10,*)'Testing he5_gdnentries... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdnentries... '
      write(*,*)'=========================='

      n=he5_gdnentries(gdid_utm,HE5_HDFE_NENTDIM,strbufsize)
      if (n .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'n = he5_gdnentries(gdid_utm, 
     1HE5_HDFE_NENTDIM, strbufsize)'
         write(*,*)'Number of dimensions ', n
         write(*,*)'Size of Dimension string ',strbufsize
         write(10,*)'n = he5_gdnentries(gdid_utm, 
     1HE5_HDFE_NENTDIM, strbufsize)'
         write(10,*)'Number of dimensions ', n
         write(10,*)'Size of Dimension string ',strbufsize
      endif

      n = he5_gdnentries(gdid_utm,HE5_HDFE_NENTDFLD,strbufsize)
      if (n .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'n = he5_gdnentries(gdid_utm,
     1HE5_HDFE_NENTDFLD,strbufsize)'
         write(*,*)'Number of data fields ',n
         write(*,*)'Size of Field string ',strbufsize
         write(10,*)'n = he5_gdnentries(gdid_utm,
     1HDFE_NENTDFLD,strbufsize)'
         write(10,*)'Number of data fields ',n
         write(10,*)'Size of Field string ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

      n=he5_gdnentries(gdid3,HE5_HDFE_NENTDIM,strbufsize)
      if (n .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'n = he5_gdnentries(gdid3, 
     1HE5_HDFE_NENTDIM, strbufsize)'
         write(*,*)'Number of dimensions ', n
         write(*,*)'Size of Dimension string ',strbufsize
         write(10,*)'n = he5_gdnentries(gdid3, 
     1HE5_HDFE_NENTDIM, strbufsize)'
         write(10,*)'Number of dimensions ', n
         write(10,*)'Size of Dimension string ',strbufsize
      endif

      n = he5_gdnentries(gdid3,HE5_HDFE_NENTDFLD,strbufsize)
      if (n .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'n = he5_gdnentries(gdid3,
     1HE5_HDFE_NENTDFLD,strbufsize)'
         write(*,*)'Number of data fields ',n
         write(*,*)'Size of Field string ',strbufsize
         write(10,*)'n = he5_gdnentries(gdid3,
     1HDFE_NENTDFLD,strbufsize)'
         write(10,*)'Number of data fields ',n
         write(10,*)'Size of Field string ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdattrinfo
c
      write(10,27)
      write(10,*)'Testing he5_gdattrinfo, Global attribute'
      write(10,*)'============================================'
      write(*,*)'Testing he5_gdattrinfo, Global attribute'
      write(*,*)'============================================'

      status = he5_gdattrinfo(gdid_utm,'Resistance',ntype,count)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdattrinfo(gdid_utm,"Resistance",
     1ntype,count)'
         write(*,*)'Value returned by gdattrinfo ',status
         write(*,*)'Number type of attribute ',ntype
         write(*,*)'Number of total bytes in attribute ',count
         write(10,*)'status = he5_gdattrinfo(gdid_utm,"Resistance",
     1ntype,count)'
         write(10,*)'Value returned by gdattrinfo ',status
         write(10,*)'Number type of attribute ',ntype
         write(10,*)'Number of total bytes in attribute ',count
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdattrinfo(gdid3,'Resistance',ntype,count)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdattrinfo(gdid3,"Resistance",
     1ntype,count)'
         write(*,*)'Value returned by gdattrinfo ',status
         write(*,*)'Number type of attribute ',ntype
         write(*,*)'Number of total bytes in attribute ',count
         write(10,*)'status = he5_gdattrinfo(gdid3,"Resistance",
     1ntype,count)'
         write(10,*)'Value returned by gdattrinfo ',status
         write(10,*)'Number type of attribute ',ntype
         write(10,*)'Number of total bytes in attribute ',count
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- he5_gdgatinfo
c
      write(10,27)
      write(10,*)'Testing he5_gdgatinfo, Group attribute'
      write(10,*)'============================================'
      write(*,*)'Testing he5_gdgatinfo, Group attribute'
      write(*,*)'============================================'

      status = he5_gdgatinfo(gdid_utm,'group',ntype,count)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdgatinfo(gdid_utm,"group",
     1ntype,count)'
         write(*,*)'Value returned by gdgatinfo ',status
         write(*,*)'Number type of attribute ',ntype
         write(*,*)'Number of total bytes in attribute ',count
         write(10,*)'status = he5_gdgatinfo(gdid_utm,"group",
     1ntype,count)'
         write(10,*)'Value returned by gdgatinfo ',status
         write(10,*)'Number type of attribute ',ntype
         write(10,*)'Number of total bytes in attribute ',count
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdgatinfo(gdid3,'group',ntype,count)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdgatinfo(gdid3,"group",
     1ntype,count)'
         write(*,*)'Value returned by gdgatinfo ',status
         write(*,*)'Number type of attribute ',ntype
         write(*,*)'Number of total bytes in attribute ',count
         write(10,*)'status = he5_gdgatinfo(gdid3,"group",
     1ntype,count)'
         write(10,*)'Value returned by gdgatinfo ',status
         write(10,*)'Number type of attribute ',ntype
         write(10,*)'Number of total bytes in attribute ',count
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdlatinfo
c
      write(10,27)
      write(10,*)'Testing he5_gdlatinfo, Local attribute'
      write(10,*)'======================================'
      write(*,*)'Testing he5_gdlatinfo, Local attribute'
      write(*,*)'======================================'

      status = he5_gdlatinfo(gdid_utm,"Grounding","local",
     1ntype,count)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdlatinfo(gdid_utm,"Grounding",
     1"local",ntype,count)'
         write(*,*)'Value returned by gdlatinfo ',status
         write(*,*)'Number type of attribute ',ntype
         write(*,*)'Number of total bytes in attribute ',count
         write(10,*)'status = he5_gdlatinfo(gdid_utm,"Grounding",
     1"local",ntype,count)'
         write(10,*)'Value returned by gdgatinfo ',status
         write(10,*)'Number type of attribute ',ntype
         write(10,*)'Number of total bytes in attribute ',count
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdlatinfo(gdid3,"Grounding","local",
     1ntype,count)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdlatinfo(gdid3,"Grounding",
     1"local",ntype,count)'
         write(*,*)'Value returned by gdlatinfo ',status
         write(*,*)'Number type of attribute ',ntype
         write(*,*)'Number of total bytes in attribute ',count
         write(10,*)'status = he5_gdlatinfo(gdid3,"Grounding",
     1"local",ntype,count)'
         write(10,*)'Value returned by gdgatinfo ',status
         write(10,*)'Number type of attribute ',ntype
         write(10,*)'Number of total bytes in attribute ',count
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdrdattr
c
      write(10,27)
      write(10,*)'Testing he5_gdrdattr, Global attribute'
      write(10,*)'======================================'
      write(*,*)'Testing he5_gdrdattr, Global attribute'
      write(*,*)'======================================'

      status = he5_gdrdattr(gdid_utm,'Resistance',iattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status = he5_gdrdattr(gdid_utm,"Resistance",
     1iattr)'
        write(*,*)'Value returned by gdrdattr ',status
        write(10,*)'status = he5_gdrdattr(gdid_utm,"Resistance",
     1iattr)'
        write(10,*)'Value returned by gdrdattr ',status
        do 67 i=1,count
           write(10,*)'Attribute value  ',iattr(i)
           write(*,*)'Attribute value   ',iattr(i)
   67   continue
        
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdrdattr(gdid3,'Resistance',iattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status = he5_gdrdattr(gdid3,"Resistance",
     1iattr)'
        write(*,*)'Value returned by gdrdattr ',status
        write(10,*)'status = he5_gdrdattr(gdid3,"Resistance",
     1iattr)'
        write(10,*)'Value returned by gdrdattr ',status
        do 77 i=1,count
           write(10,*)'Attribute value  ',iattr(i)
           write(*,*)'Attribute value   ',iattr(i)
   77   continue
        
      endif
      write(10,*)' '
      write(*,*)' '
  
c Test Case -- he5_gdrdgattr
c
      write(10,27)
      write(10,*)'Testing he5_gdrdgattr, Group attribute '
      write(10,*)'======================================'
      write(*,*)'Testing he5_gdrdgattr, Group attribute'
      write(*,*)'======================================'

      status = he5_gdrdgattr(gdid_utm,'group',gattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status = he5_gdrdgattr(gdid_utm,"group",
     1gattr)'
        write(*,*)'Value returned by gdrdgattr ',status
        write(10,*)'status = he5_gdrdgattr(gdid_utm,"group",
     1gattr)'
        write(10,*)'Value returned by gdrdgattr ',status
        do 68 i=1,count
           write(10,*)'Attribute value  ',gattr(i)
           write(*,*)'Attribute value   ',gattr(i)
   68   continue
        
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdrdgattr(gdid3,'group',gattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status = he5_gdrdgattr(gdid3,"group",
     1gattr)'
        write(*,*)'Value returned by gdrdgattr ',status
        write(10,*)'status = he5_gdrdgattr(gdid3,"group",
     1gattr)'
        write(10,*)'Value returned by gdrdgattr ',status
        do 78 i=1,count
           write(10,*)'Attribute value  ',gattr(i)
           write(*,*)'Attribute value   ',gattr(i)
   78   continue
        
      endif
      write(10,*)' '
      write(*,*)' '
  
c Test Case -- he5_gdinqdatatype
c
      write(10,27)
      write(10,*)'Testing he5_gdinqdatatype '
      write(10,*)'============================='
      write(*,*)'Testing he5_gdinqdatatype'
      write(*,*)'============================='

      status = he5_gdinqdatatype(gdid_utm,"Grounding","local",
     1HE5_HDFE_LOCATTRGROUP,dtype,classid,order,size)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
        write(*,*)' '
        write(*,240)
        write(10,*)' '
        write(10,240)
         write(*,*)'status = he5_gdinqdatatype(gdid_utm,"Grounding",
     1"local",HE5_HDFE_LOCATTRGROUP,dtype,classid,order,size)'
         write(*,*)'Data type of attribute ',dtype
         write(*,*)'Class id of attribute ',classid
         write(*,*)'Order of attribute ',order
         write(*,*)'Size of attribute ',size
         write(10,*)'status = he5_gdinqdatatype(gdid_utm,"Grounding",
     1"local", HE5_HDFE_LOCATTRGROUP,dtype,classid,order,size)'
         write(10,*)'Data type of attribute ',dtype
         write(10,*)'Class id of attribute ',classid
         write(10,*)'Order of attribute ',order
         write(10,*)'Size of attribute ',size
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdinqdatatype(gdid3,"Grounding","local",
     1HE5_HDFE_LOCATTRGROUP,dtype,classid,order,size)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
        write(*,*)' '
        write(*,240)
        write(10,*)' '
        write(10,240)
         write(*,*)'status = he5_gdinqdatatype(gdid3,"Grounding",
     1"local",HE5_HDFE_LOCATTRGROUP,dtype,classid,order,size)'
         write(*,*)'Data type of attribute ',dtype
         write(*,*)'Class id of attribute ',classid
         write(*,*)'Order of attribute ',order
         write(*,*)'Size of attribute ',size
         write(10,*)'status = he5_gdinqdatatype(gdid3,"Grounding",
     1"local", HE5_HDFE_LOCATTRGROUP,dtype,classid,order,size)'
         write(10,*)'Data type of attribute ',dtype
         write(10,*)'Class id of attribute ',classid
         write(10,*)'Order of attribute ',order
         write(10,*)'Size of attribute ',size
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdrdlattr
c
      write(10,27)
      write(10,*)'Testing he5_gdrdlattr, Local attribute '
      write(10,*)'======================================'
      write(*,*)'Testing he5_gdrdlattr, Local attribute'
      write(*,*)'======================================'

      status = he5_gdrdlattr(gdid_utm,'Grounding',
     1'local',lattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status = he5_gdrdlattr(gdid_utm,"Grounding",
     1"local",lattr)'
        write(*,*)'Value returned by gdrdlattr ',status
        write(10,*)'status = he5_gdrdlattr(gdid_utm,"Grounding",
     1"local",lattr)'
        write(10,*)'Value returned by gdrdlattr ',status
        do 69 i=1,count
           write(10,*)'Attribute value  ',lattr(i)
           write(*,*)'Attribute value   ',lattr(i)
   69   continue
        
      endif
      write(10,*)' '
      write(*,*)' '
  
      status = he5_gdrdlattr(gdid3,'Grounding',
     1'local',lattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status = he5_gdrdlattr(gdid3,"Grounding",
     1"local",lattr)'
        write(*,*)'Value returned by gdrdlattr ',status
        write(10,*)'status = he5_gdrdlattr(gdid3,"Grounding",
     1"local",lattr)'
        write(10,*)'Value returned by gdrdlattr ',status
        do 79 i=1,count
           write(10,*)'Attribute value  ',lattr(i)
           write(*,*)'Attribute value   ',lattr(i)
   79   continue
        
      endif
      write(10,*)' '
      write(*,*)' '
  
c Test Case -- he5_gdinqattrs
c
      write(10,27)
      write(10,*)'Testing he5_gdinqattrs, Global attribute'
      write(10,*)'========================================'
      write(*,*)'Testing he5_gdinqattrs, Global attribute'
      write(*,*)'========================================'

      lstatus = he5_gdinqattrs(gdid_utm, attrlist,strbufsize)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = he5_gdinqattrs(gdid_utm, 
     1attrlist,strbufsize)'
        write(*,*)'Value returned by gdinqattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(*,*)'Length of attrlist in bytes ',strbufsize
        write(10,*)'lstatus = he5_gdinqattrs(gdid_utm, 
     1attrlist,strbufsize)'
        write(10,*)'Value returned by gdinqattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
        write(10,*)'Length of attrlist in bytes ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

      lstatus = he5_gdinqattrs(gdid3, attrlist,strbufsize)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = he5_gdinqattrs(gdid3, 
     1attrlist,strbufsize)'
        write(*,*)'Value returned by gdinqattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(*,*)'Length of attrlist in bytes ',strbufsize
        write(10,*)'lstatus = he5_gdinqattrs(gdid3, 
     1attrlist,strbufsize)'
        write(10,*)'Value returned by gdinqattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
        write(10,*)'Length of attrlist in bytes ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdinqgattrs
c
      write(10,27)
      write(10,*)'Testing he5_gdinqgattrs, Group attribute'
      write(10,*)'============================================'
      write(*,*)'Testing he5_gdinqgattrs, Group attribute'
      write(*,*)'============================================'

      lstatus = he5_gdinqgattrs(gdid_utm,attrlist,strbufsize)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = he5_gdinqgattrs(gdid_utm, 
     1attrlist,strbufsize)'
        write(*,*)'Value returned by gdinqgattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(*,*)'Length of attrlist in bytes ',strbufsize
        write(10,*)'lstatus = he5_gdinqgattrs(gdid_utm,
     1attrlist,strbufsize)'
        write(10,*)'Value returned by gdinqgattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
        write(10,*)'Length of attrlist in bytes ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

      lstatus = he5_gdinqgattrs(gdid3,attrlist,strbufsize)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = he5_gdinqgattrs(gdid3, 
     1attrlist,strbufsize)'
        write(*,*)'Value returned by gdinqgattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(*,*)'Length of attrlist in bytes ',strbufsize
        write(10,*)'lstatus = he5_gdinqgattrs(gdid3,
     1attrlist,strbufsize)'
        write(10,*)'Value returned by gdinqgattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
        write(10,*)'Length of attrlist in bytes ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- he5_gdinqlattrs
c
      write(10,27)
      write(10,*)'Testing he5_gdinqlattrs, Local attribute'
      write(10,*)'========================================'
      write(*,*)'Testing he5_gdinqlattrs, Local attribute'
      write(*,*)'========================================'

      lstatus = he5_gdinqlattrs(gdid_utm,"Grounding",attrlist,
     1strbufsize)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = he5_gdinqlattrs(gdid_utm,"Grounding",
     1attrlist,strbufsize)'
        write(*,*)'Value returned by gdinqlattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(*,*)'Length of attrlist in bytes ',strbufsize
        write(10,*)'lstatus = he5_gdinqlattrs(gdid_utm,"Grounding",
     1attrlist, strbufsize)'
        write(10,*)'Value returned by gdinqlattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
        write(10,*)'Length of attrlist in bytes ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

      lstatus = he5_gdinqlattrs(gdid3,"Grounding",attrlist,
     1strbufsize)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = he5_gdinqlattrs(gdid3,"Grounding",
     1attrlist,strbufsize)'
        write(*,*)'Value returned by gdinqlattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(*,*)'Length of attrlist in bytes ',strbufsize
        write(10,*)'lstatus = he5_gdinqlattrs(gdid3,"Grounding",
     1attrlist, strbufsize)'
        write(10,*)'Value returned by gdinqlattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
        write(10,*)'Length of attrlist in bytes ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdgetfill
c
      write(10,27)
      write(10,*)'Testing he5_gdgetfill... '
      write(10,*)'======================='
      write(*,*)'Testing he5_gdgetfill... '
      write(*,*)'========================'

      status = he5_gdgetfill(gdid_utm,'Drift',ifillv)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdgetfill(gdid_utm,"Drift",
     1ifillv)'
         write(*,*)'Value returned by gdgetfill ',status
         write(*,*)'Fill value ',ifillv
         write(10,*)'status = he5_gdgetfill(gdid_utm,"Drift",
     1ifillv)'
         write(10,*)'Value returned by gdgetfill ',status
         write(10,*)'Fill value ',ifillv
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdgetfill(gdid3,'Drift',ifillv)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdgetfill(gdid3,"Drift",
     1ifillv)'
         write(*,*)'Value returned by gdgetfill ',status
         write(*,*)'Fill value ',ifillv
         write(10,*)'status = he5_gdgetfill(gdid3,"Drift",
     1ifillv)'
         write(10,*)'Value returned by gdgetfill ',status
         write(10,*)'Fill value ',ifillv
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddefboxreg
c
      write(10,27)
      write(10,*)'Testing he5_gddefboxreg... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gddefboxreg... '
      write(*,*)'=========================='

      corlon(1)=-126.0
      corlon(2)=-121.5
      corlat(1)=-70.0
      corlat(2)=-65.0

      regionid = he5_gddefboxreg(gdid_utm,corlon,corlat)
      if (regionid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'regionid = he5_gddefboxreg(gdid_utm,
     1corlon,corlat)'
         write(*,*)'Region id returned by gddefboxreg ',regionid
         write(10,*)'regionid = he5_gddefboxreg(gdid_utm,
     1corlon,corlat)'
         write(10,*)'Region id returned by gddefboxreg ',regionid
      endif
      write(10,*)' '
      write(*,*)' '

      regionid3 = he5_gddefboxreg(gdid3,corlon,corlat)
      if (regionid3 .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'regionid3 = he5_gddefboxreg(gdid3,
     1corlon,corlat)'
         write(*,*)'Region id returned by gddefboxreg ',regionid3
         write(10,*)'regionid3 = he5_gddefboxreg(gdid3,
     1corlon,corlat)'
         write(10,*)'Region id returned by gddefboxreg ',regionid3
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdreginfo
c
      write(10,27)
      write(10,*)'Testing he5_gdreginfo... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdreginfo... '
      write(*,*)'=========================='

      status = he5_gdreginfo(gdid_utm,regionid,'Impedance',nt,rk,
     1dims,size,iuplft,ilrgt)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdreginfo(gdid_utm,regionid,
     1"Impedance",nt, rk,dims,size,iuplft,ilrgt)'
         write(*,*)'Value returned by gdreginfo ',status
         write(*,*)'Number type of region ',nt
         write(*,*)'Rank of region ',rk
         write(*,*)'Size of region ',size
         write(*,11)'Dimensions of region ',dims(1),' ',dims(2)
         write(*,12)'Upper left point of region ',iuplft(1),' ',
     1iuplft(2)
         write(*,12)'Lower right point of region ',ilrgt(1),' ',
     1ilrgt(2)
         write(10,*)'status = he5_gdreginfo(gdid_utm,regionid,
     1"Impedance",nt,rk,dims,size,iuplft,ilrgt)'
         write(10,*)'Value returned by gdreginfo ',status
         write(10,*)'Number type of region ',nt
         write(10,*)'Rank of region ',rk
         write(10,*)'Size of region ',size
         write(10,11)'Dimensions of region ',dims(1),' ',dims(2)
         write(10,12)'Upper left point of region ',iuplft(1),' ',
     1iuplft(2)
         write(10,12)'Lower right point of region ',ilrgt(1),' ',
     1ilrgt(2)
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdreginfo(gdid3,regionid3,'Impedance',nt,rk,
     1dims,size,iuplft,ilrgt)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdreginfo(gdid3,regionid3,
     1"Impedance",nt, rk,dims,size,iuplft,ilrgt)'
         write(*,*)'Value returned by gdreginfo ',status
         write(*,*)'Number type of region ',nt
         write(*,*)'Rank of region ',rk
         write(*,*)'Size of region ',size
         write(*,11)'Dimensions of region ',dims(1),' ',dims(2)
         write(*,12)'Upper left point of region ',iuplft(1),' ',
     1iuplft(2)
         write(*,12)'Lower right point of region ',ilrgt(1),' ',
     1ilrgt(2)
         write(10,*)'status = he5_gdreginfo(gdid3,regionid3,
     1"Impedance",nt,rk,dims,size,iuplft,ilrgt)'
         write(10,*)'Value returned by gdreginfo ',status
         write(10,*)'Number type of region ',nt
         write(10,*)'Rank of region ',rk
         write(10,*)'Size of region ',size
         write(10,11)'Dimensions of region ',dims(1),' ',dims(2)
         write(10,12)'Upper left point of region ',iuplft(1),' ',
     1iuplft(2)
         write(10,12)'Lower right point of region ',ilrgt(1),' ',
     1ilrgt(2)
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdextreg
c
      write(10,27)
      write(10,*)'Testing he5_gdextreg... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdextreg... '
      write(*,*)'=========================='

      status = he5_gdextreg(gdid_utm,regionid,'Impedance',datbuf)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdextreg(gdid_utm,regionid,
     1"Impedance",datbuf)'
         write(*,*)'Value returned by gdextreg ',status
         write(10,*)'status = he5_gdextreg(gdid_utm,regionid,
     1"Impedance",datbuf)'
         write(10,*)'Value returned by gdextreg ',status
         do 175 i=100,150
            write(*,*)'Value of region ',datbuf(i)
            write(10,*)'Value of region ',datbuf(i)
  175    continue
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdextreg(gdid3,regionid3,'Impedance',datbuf)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdextreg(gdid3,regionid3,
     1"Impedance",datbuf)'
         write(*,*)'Value returned by gdextreg ',status
         write(10,*)'status = he5_gdextreg(gdid3,regionid3,
     1"Impedance",datbuf)'
         write(10,*)'Value returned by gdextreg ',status
         do 176 i=100,150
            write(*,*)'Value of region ',datbuf(i)
            write(10,*)'Value of region ',datbuf(i)
  176    continue
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddeftmeper
c
      write(10,27)
      write(10,*)'Testing he5_gddeftmeper... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gddeftmeper... '
      write(*,*)'=========================='

      periodid = he5_gddeftmeper(gdid_utm,HE5_HDFE_NOPREVSUB,
     1starttime,stoptime)
      if (periodid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'periodid = he5_gddeftmeper(gdid_utm,
     1HE5_HDFE_NOPREVSUB,starttime,stoptime)'
        write(10,*)'Define a time period '
        write(10,*)'Period id returned by gddeftmeper ',periodid
        write(*,*)'periodid = he5_gddeftmeper(gdid_utm,
     1HE5_HDFE_NOPREVSUB,starttime,stoptime)'
        write(*,*)'Define a time period '
        write(*,*)'Period id returned by gddeftmeper ',periodid
      endif
      write(10,*)' '
      write(*,*)' '

      periodid = he5_gddeftmeper(gdid3,HE5_HDFE_NOPREVSUB,
     1starttime,stoptime)
      if (periodid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'periodid = he5_gddeftmeper(gdid3,
     1HE5_HDFE_NOPREVSUB,starttime,stoptime)'
        write(10,*)'Define a time period '
        write(10,*)'Period id returned by gddeftmeper ',periodid
        write(*,*)'periodid = he5_gddeftmeper(gdid3,
     1HE5_HDFE_NOPREVSUB,starttime,stoptime)'
        write(*,*)'Define a time period '
        write(*,*)'Period id returned by gddeftmeper ',periodid
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddefvrtreg
c
      write(10,27)
      write(10,*)'Testing he5_gddefvrtreg... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gddefvrtreg... '
      write(*,*)'=========================='

      regionid = he5_gddefvrtreg(gdid_utm,HE5_HDFE_NOPREVSUB,
     1'Height',range)
      if (regionid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'regionid = he5_gddefvrtreg(gdid_utm,
     1HE5_HDFE_NOPREVSUB,"Height",range)'
        write(10,*)'Define a vertical region '
        write(10,*)'Region id returned by gddefvrtreg ',regionid
        write(*,*)'regionid = he5_gddefvrtreg(gdid_utm,
     1HE5_HDFE_NOPREVSUB,"Height",range)'
        write(*,*)'Define a vertical region '
        write(*,*)'Region id returned by gddefvrtreg ',regionid
      endif
      write(10,*)' '
      write(*,*)' '

      regionid3 = he5_gddefvrtreg(gdid3,HE5_HDFE_NOPREVSUB,
     1'Height',range)
      if (regionid3 .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'regionid3 = he5_gddefvrtreg(gdid3,
     1HE5_HDFE_NOPREVSUB,"Height",range)'
        write(10,*)'Define a vertical region '
        write(10,*)'Region id returned by gddefvrtreg ',regionid3
        write(*,*)'regionid3 = he5_gddefvrtreg(gdid3,
     1HE5_HDFE_NOPREVSUB,"Height",range)'
        write(*,*)'Define a vertical region '
        write(*,*)'Region id returned by gddefvrtreg ',regionid3
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddupreg
c
      write(10,27)
      write(10,*)'Testing he5_gddupreg... '
      write(10,*)'======================='
      write(*,*)'Testing he5_gddupreg... '
      write(*,*)'======================='

      regionid2 = he5_gddupreg(regionid)
      if (regionid2 .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'regionid2 = he5_gddupreg(regionid)'
        write(10,*)'Generate a new region id '
        write(10,*)'New region id ',regionid2
        write(*,*)'regionid2 = he5_gddupreg(regionid)'
        write(*,*)'Generate a new region id '
        write(*,*)'New region id ',regionid2
      endif
      write(10,*)' '
      write(*,*)' '

      regionid4 = he5_gddupreg(regionid3)
      if (regionid4 .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'regionid4 = he5_gddupreg(regionid3)'
        write(10,*)'Generate a new region id '
        write(10,*)'New region id ',regionid4
        write(*,*)'regionid4 = he5_gddupreg(regionid3)'
        write(*,*)'Generate a new region id '
        write(*,*)'New region id ',regionid4
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- he5_gdgetpix
c
      write(10,27)
      write(10,*)'Testing he5_gdgetpix... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdgetpix... '
      write(*,*)'=========================='

      nlonlat = 5
      status= he5_gdgetpix(gdid_utm,nlonlat,lonval,
     1latval,rowval,colval)             
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = he5_gdgetpix(gdid_utm,5,lonval,
     1latval,rowval,colval)'
        write(10,*)'Retrieve pixel row. column values '
        write(*,*)'status = he5_gdgetpix(gdid_utm,5,lonval,latval,
     1rowval,colval)'
        write(*,*)'Retrieve pixel row. column values '
        do 37 i=1,5
           write(10,5)'Pixel position lon lat ',lonval(i),' ',
     1latval(i),' ','Row Column ',rowval(i),' ',colval(i) 
           write(*,5)'Pixel position lon lat ',lonval(i),' ',
     1latval(i),' ','Row Column ',rowval(i),' ',colval(i) 
   37   continue
      endif
    5 format(a,f6.1,a,f6.1,a,a,i2,a,i2)
      write(10,*)' '
      write(*,*)' '

      status= he5_gdgetpix(gdid3,nlonlat,lonval,
     1latval,rowval,colval)             
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = he5_gdgetpix(gdid3,5,lonval,
     1latval,rowval,colval)'
        write(10,*)'Retrieve pixel row. column values '
        write(*,*)'status = he5_gdgetpix(gdid3,5,lonval,latval,
     1rowval,colval)'
        write(*,*)'Retrieve pixel row. column values '
        do 47 i=1,5
           write(10,5)'Pixel position lon lat ',lonval(i),' ',
     1latval(i),' ','Row Column ',rowval(i),' ',colval(i) 
           write(*,5)'Pixel position lon lat ',lonval(i),' ',
     1latval(i),' ','Row Column ',rowval(i),' ',colval(i) 
   47   continue
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdgetpixval
c
      write(10,27)
      write(10,*)'Testing he5_gdgetpixval... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdgetpixval... '
      write(*,*)'=========================='

      nlonlat = 5
      size= he5_gdgetpixval(gdid_utm,nlonlat,rowval,colval,
     1"Voltage",fldval)
      if (size .le. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'lstatus = he5_gdgetpixval(gdid_utm,5,rowval,
     1colval,"Voltage",fldval)'
        write(10,*)'Retrieve pixel values for specific locations '
        write(*,*)'lstatus = he5_gdgetpixval(gdid_utm,5,rowval,
     1colval,"Voltage",fldval)'
        write(*,*)'Retrieve pixel values for specific locations '
        do i=1,5
           write(10,17)'Row Col ',rowval(i),' ',colval(i),' ',
     1'Pixel Value ',fldval(i)
           write(*,17)'Row Col ',rowval(i),' ',colval(i),' ',
     1'Pixel Value ',fldval(i)
        enddo
      endif
   17 format(a8,i2,a1,i2,a1,a12,f9.3)
      write(10,*)' '
      write(*,*)' '

      size= he5_gdgetpixval(gdid3,nlonlat,rowval,colval,
     1"Voltage",fldval)
      if (size .le. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'lstatus = he5_gdgetpixval(gdid3,5,rowval,
     1colval,"Voltage",fldval)'
        write(10,*)'Retrieve pixel values for specific locations '
        write(*,*)'lstatus = he5_gdgetpixval(gdid3,5,rowval,
     1colval,"Voltage",fldval)'
        write(*,*)'Retrieve pixel values for specific locations '
        do i=1,5
           write(10,17)'Row Col ',rowval(i),' ',colval(i),' ',
     1'Pixel Value ',fldval(i)
           write(*,17)'Row Col ',rowval(i),' ',colval(i),' ',
     1'Pixel Value ',fldval(i)
        enddo
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdinterpolate
c
      write(10,27)
      write(10,*)'Testing he5_gdinterpolate... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdinterpolate... '
      write(*,*)'=========================='

      nlonlat = 5
      size= he5_gdinterpolate(gdid_utm,nlonlat,lonval,latval,
     1'Voltage',interval)
      if (size .le. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'lstatus= he5_gdinterpolate(gdid_utm,5,lonval,
     1latval,"Voltage",interval)'
        write(10,*)'Interpolate 5 values for field Voltage '
        write(*,*)'lstatus= he5_gdinterpolate(gdid_utm,5,lonval,
     1latval,"Voltage",interval)'
        write(*,*)'Interpolate 5 values for field Voltage '
        write(*,*)'Status returned by call to gdinterpolate ',lstatus
        do i=1,5
           write(*,4)'Interpolated value ',interval(i,1)
           write(10,4)'Interpolated value ',interval(i,1)
        enddo
      endif
    4 format(a,f9.3)
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid_utm)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Value returned by gddetach ',status
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Value returned by gddetach ',status
      endif

      size= he5_gdinterpolate(gdid3,nlonlat,lonval,latval,
     1'Voltage',interval)
      if (size .le. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'lstatus= he5_gdinterpolate(gdid3,5,lonval,
     1latval,"Voltage",interval)'
        write(10,*)'Interpolate 5 values for field Voltage '
        write(*,*)'lstatus= he5_gdinterpolate(gdid3,5,lonval,
     1latval,"Voltage",interval)'
        write(*,*)'Interpolate 5 values for field Voltage '
        write(*,*)'Status returned by call to gdinterpolate ',lstatus
        do i=1,5
           write(*,4)'Interpolated value ',interval(i,1)
           write(10,4)'Interpolated value ',interval(i,1)
        enddo
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid3)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gddetach(gdid3)'
         write(*,*)'Value returned by gddetach ',status
         write(10,*)'status = he5_gddetach(gdid3)'
         write(10,*)'Value returned by gddetach ',status
      endif

      status = he5_gdclose(gdfid)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdclose(gdfid)'
         write(*,*)'Returned from gdclose ', status
         write(10,*)'status = he5_gdclose(gdfid)'
         write(10,*)'Returned from gdclose ', status
      endif

      status = he5_gdclose(gdfid3)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdclose(gdfid3)'
         write(*,*)'Returned from gdclose ', status
         write(10,*)'status = he5_gdclose(gdfid3)'
         write(10,*)'Returned from gdclose ', status
      endif

      close(unit=10)
 27   format(' ')
      stop
      end

      program       he5_gd_infoF_32

      implicit      none

      include       'hdfeos5.inc'

	  integer       status
	  integer       i
      integer       he5_gdopen
      integer       he5_gdattach
      integer       he5_gdfldinfo
      integer       he5_gdprojinfo
      integer       he5_gdgridinfo
      integer       he5_gdinqflds
      integer       he5_gdtileinfo
      integer       he5_gddetach
      integer       he5_gdclose
      integer       gdfid
      integer       gdid1
      integer       gdid2
      integer       nflds  
      integer       rk(32)
      integer       nt(32)
      integer       spherecode
      integer       projcode
      integer       zonecode

      integer*4     he5_gddiminfo
      integer*4     he5_gdinqdims
      integer*4     he5_gdnentries
      integer*4     he5_gdinqgrid
      integer*4     ndim
      integer*4     dims(32)
      integer*4     xdimsize
      integer*4     ydimsize
      integer*4     dimsize 
	  integer*4     n, strbufsize 
    
      real*8        upleftpt(2)
      real*8        lowrightpt(2)
      real*8        projparm(13)
	  
      character*256 dimname
      character*256 mxdimname
      character*256 fieldlist
      character*256 gridlist

      integer       tilecode
      integer       tilerank
      integer*4     tiledims(32)

      integer       FAIL
      parameter     (FAIL=-1)


c     Open HDF-EOS "grid.he5" file
c     ----------------------------	  
      gdfid = he5_gdopen('grid.he5',HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_gdopen():  ',gdfid

      if (gdfid .ne. FAIL) then
		 
c     Attach to the UTM and POLAR grids
c     ---------------------------------
      gdid1 = he5_gdattach(gdfid, 'UTMGrid')
      write(*,*) 'Grid ID returned by he5_gdattach():  ',gdid1

      gdid2 = he5_gdattach(gdfid, 'PolarGrid')
      write(*,*) 'Grid ID returned by he5_gdattach():  ',gdid2

c     Inquire dimensions
c     ------------------		 
      ndim = he5_gdinqdims(gdid1, dimname, dims)
      write(*,*) 'Dimension list (UTMGrid): ', dimname
      do i=1,ndim
         write(*,*) 'dim size: ', dims(i)
      enddo
      
      ndim = he5_gdinqdims(gdid2, dimname, dims)
      write(*,*) 'Dimension list (PolarGrid): ', dimname
      do i=1,ndim
         write(*,*) 'dim size: ', dims(i)
      enddo
      
c     Get the sizes of certain dimensions
c     -----------------------------------         
      dimsize = he5_gddiminfo(gdid1, 'Time')
      write(*,*) 'Size of "Time" Array: ', dimsize
		 
      dimsize = he5_gddiminfo(gdid2, 'Bands')
      write(*,*) 'Size of "Bands" Array: ', dimsize
      
c     Get grid parameters
c     -------------------
      status = he5_gdgridinfo(gdid1,xdimsize,ydimsize,
     1     upleftpt,lowrightpt)
      write(*,*)'X dim size, Y dim size (UTMGrid): ',
     2     xdimsize,ydimsize
      
      write(*,*) 'Up left pt (UTMGrid): ',upleftpt(1),
     1     upleftpt(2)
      write(*,*) 'Low right pt (UTMGrid): ',lowrightpt(1),
     2     lowrightpt(2)
	   
      status = he5_gdgridinfo(gdid2,xdimsize,ydimsize,
     1     upleftpt,lowrightpt)
      write(*,*) 'X dim size, Y dim size (PolarGrid): ',
     2     xdimsize,ydimsize
      
      write(*,*) 'Up left pt (PolarGrid): ',upleftpt(1),
     1        upleftpt(2)
      write(*,*) 'Low right pt (PolarGrid): ',lowrightpt(1),
     2     lowrightpt(2)
      
c     Get projection parameters
c     -------------------------		 
      status = he5_gdprojinfo(gdid1,projcode,zonecode,
     1     spherecode,projparm)
      write(*,*) 'projcode,zonecode (UTMGrid): ',projcode,
     2     zonecode
      write(*,*) 'spherecode (UTMGrid): ', spherecode	
      
      status = he5_gdprojinfo(gdid2,projcode,zonecode,
     1     spherecode,projparm)
      write(*,*) 'projcode (PolarGrid): ', projcode
      write(*,*) 'spherecode (PolarGrid): ', spherecode
      do i=1,13
         write(*,*) 'Projection Parameter: ',i,projparm(i)
      enddo
      
c     Get information about fields
c     ----------------------------
      nflds = he5_gdinqflds(gdid1, fieldlist, rk, nt)
      if (nflds .ne. 0) then
         write(*,*) 'Data fields (UTMGrid): ', fieldlist
         do i=1,nflds
            write(*,*) 'rank type: ',rk(i),nt(i)
         enddo
      endif

      status = he5_gdtileinfo(gdid1,"Vegetation",tilecode,tilerank,
     1         tiledims)
              write(*,*) 'Vegetation Tile Code: ', tilecode
              write(*,*) 'Vegetation Tile Rank: ', tilerank
              do i=1,tilerank
                         write(*,*) 'Tile Dimension ',i,tiledims(i)
              enddo

	         
      nflds = he5_gdinqflds(gdid2, fieldlist, rk, nt)
      if (nflds .ne. 0) then
         write(*,*) 'Data fields (PolarGrid): ', fieldlist
         do i=1,nflds
            write(*,*) 'rank type: ',rk(i),nt(i)
         enddo
      endif	
      
      status = he5_gdfldinfo(gdid2,'Spectra',rk,dims,nt,
     1     dimname,mxdimname)
      write(*,*) 'Spectra rank dims: ',rk(1)
      write(*,*) 'Spectra dim names: ',dimname
      write(*,*) 'Spectra max. dim names: ',mxdimname
      do i=1,rk(1)
         write(*,*) 'Spectra dims: ',i,dims(i)
      enddo
      
c     Get number of grid dimensions and dim. list length
c     --------------------------------------------------
      n = he5_gdnentries(gdid1, HE5_HDFE_NENTDIM, strbufsize)
      write(*,*) 'Number of dimension entries (UTMGrid): ', n
      write(*,*) 'Length of Dimension List (UTMGrid): ',strbufsize
      
c     Get number of data fields and field list length
c     -----------------------------------------------
      n = he5_gdnentries(gdid1, HE5_HDFE_NENTDFLD, strbufsize)
      write(*,*) 'Number of data fields (UTMGrid): ', n
      write(*,*) 'Length of Field List (UTMGrid): ',strbufsize
      
      endif
	  
c     Detach from the grids
c     ---------------------
      status = he5_gddetach(gdid1)
      write(*,*) 'Status returned by he5_gddetach():  ',status

      status = he5_gddetach(gdid2)
      write(*,*) 'Status returned by he5_gddetach():  ',status
      
c     Close the file
c     --------------
      status = he5_gdclose(gdfid)
      write(*,*) 'Status returned by he5_gdclose():  ',status
	  
      stop
      end

c----------------------------------------------------------------------------
c       FILE:     testpoint32.f                                               
c       PURPOSE:  To test HDF-EOS5 Point interface              
c----------------------------------------------------------------------------

      program       he5_pttestpoint32
 
      implicit      none
 
      include       'hdfeos5.inc'

      integer       status 
      integer       ptfid 
      integer       ptid1, ptid2, ptid3
      integer       ptid
      integer       rank_1(3)
      integer       rank_2(5)
      integer       rank_3(4)
      integer       rank_4(4)
      integer       rank_5(6)
      integer       dtype_1(3)
      integer       dtype_2(5)
      integer       dtype_3(4)
      integer       dtype_4(4)
      integer       dtype_5(6)
      integer       array_1(3)
      integer       array_2(5)
      integer       array_3(4)
      integer       array_4(4)
      integer       array_5(6)
      integer       i, zero
      integer       rank
      integer       datatype
      integer       attr
      integer       nflds
      integer       level
      integer       arr_rank
      integer       dtype(3)
      integer       nrecs
      integer       nlevels
      integer       attr1(5)
      integer       attr2(5)
      integer       ntype
      integer       classid
      integer       order
      integer       fieldgroup

      integer       he5_ptopen
      integer       he5_ptcreate
      integer       he5_ptdetach
      integer       he5_ptclose
      integer       he5_ptattach
      integer       he5_ptdeflevel 
      integer       he5_ptdeflinkage 
      integer       he5_ptwritelevel 
      integer       he5_ptfort2c
      integer       he5_ptwrbckptr
      integer       he5_ptwrfwdptr
      integer       he5_ptwriteattr 
      integer       he5_ptreadlevel
      integer       he5_ptlevelinfo 
      integer       he5_ptnrecs
      integer       he5_ptnlevels
      integer       he5_ptnfields
      integer       he5_ptc2fort
      integer       he5_ptinqattrs
      integer       he5_ptreadattr
      integer       he5_ptupdatelevel 
      integer       he5_ptwritegrpattr
      integer       he5_ptwritelocattr
      integer       he5_ptinqgrpattrs
      integer       he5_ptinqlocattrs
      integer       he5_ptattrinfo
      integer       he5_ptgrpattrinfo
      integer       he5_ptlocattrinfo
      integer       he5_ptreadgrpattr
      integer       he5_ptreadlocattr
      integer       he5_ptinqdatatype

      integer*4     dims_1(3,1)
      integer*4     dims_2(5,1)
      integer*4     dims_3(4,1)
      integer*4     dims_4(4,1)
      integer*4     dims_5(6,1)
      integer*4     n
      integer*4     count(1)
      integer*4     dimens(2)
      integer*4     fortcount(8)
      integer*4     date_tt
      integer*4     date(3)
      integer*4     date4_tt
      integer*4     date4(3)
      integer*4     wgt_tt
      integer*4     wgt(3)
      integer*4     datasize
      integer*4     rank_tt(3)
      integer*4     offset_tt(3)
      integer*4     dtype_tt(3)
      integer*4     dim_sizes_tt(3)
      integer*4     nattr
      integer*4     strbufsize
      integer*4     recs(32)
      integer*4     nrec
      integer*4     sz
      integer*4     size

      real*4        flt      
      real*4        concentration_tt(4)
      real*4        conc(15,4)
      real*4        outconc(4,15)
      real*4        rain_tt
      real*4        rain(20)
      real*4        temp_tt
      real*4        temp(20)
      real*4        rain5_tt
      real*4        rain5(25)
      real*4        temp5_tt
      real*4        temp5(25)
      real*4        con(4,15)
      real*4        outcon(15,4)
      real*4        conc_tt(4)

      real*8        time_tt
      real*8        time(15)
      real*8        lon_tt
      real*8        lon(3)
      real*8        lat_tt
      real*8        lat(3)
      real*8        time3_tt
      real*8        time3(20)
      real*8        time5_tt
      real*8        time5(25)
      real*8        lon5_tt
      real*8        lon5(25)
      real*8        lat5_tt
      real*8        lat5(25)
 
      character*240 fieldlist1
      character*240 fieldlist2
      character*240 fieldlist3
      character*240 fieldlist4
      character*240 fieldlist5
      character*80  levelname
      character*20  parent
      character*20  child
      character*20  linkfield
      character*80  fieldname
      character*80  attrname
      character*8   spc_tt
      character*8   spc(15)
      character*8   desc_tt
      character*8   desc(3)
      character*8   id_tt
      character*8   id(3)
      character*8   id3_tt
      character*8   id3(20)
      character*8   desc4_tt
      character*8   desc4(3)
      character*8   id4_tt
      character*8   id4(3)
      character*8   id5_tt
      character*8   id5(25)
      character*80  fieldname3(3)
      character*240 fieldlist
      character*240 attrlist
      character*8   spec(15)
      character*1   null_char_0

      open(unit=1, file="testpoint.txt", status = "UNKNOWN")

      write(*,*)' '
      write(1,*)' '
      write(*,*)'Testing he5_ptath FORTRAN 77 interface'
      write(*,*)'======================================'
      write(1,*)'Testing he5_ptath FORTRAN 77 interface'
      write(1,*)'======================================'
      write(*,*)' '
      write(1,*)' '

      zero=0

c Test Case -- he5_ptopen
c
      write(*,*)'Testing he5_ptopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptopen '
      write(1,*)'====================='
      ptfid = he5_ptopen('point.he5',HE5F_ACC_TRUNC) 
      if (ptfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_TRUNC)'
         write(*,*)'	Value returned by he5_ptopen ', ptfid
         write(1,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_TRUNC)'
         write(1,*)'	Value returned by he5_ptopen ', ptfid
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptcreate
c
      write(*,*)'Testing he5_ptcreate '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptcreate '
      write(1,*)'====================='
      ptid1 = he5_ptcreate(ptfid, "Simple Point")
      if (ptid1 .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid1 = he5_ptcreate(ptfid, "Simple Point")'
         write(*,*)'	Value returned by he5_ptcreate ', ptid1
         write(1,*)'	ptid1 = he5_ptcreate(ptfid, "Simple Point")'
         write(1,*)'	Value returned by he5_ptcreate ', ptid1
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptcreate
c
      write(*,*)'Testing he5_ptcreate '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptcreate '
      write(1,*)'====================='
      ptid2 = he5_ptcreate(ptfid, "FixedBuoy Point")
      if (ptid2 .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid2 = he5_ptcreate(ptfid, "FixedBuoy Point")'
         write(*,*)'	Value returned by he5_ptcreate ', ptid2
         write(1,*)'	ptid2 = he5_ptcreate(ptfid, "FixedBuoy Point")'
         write(1,*)'	Value returned by he5_ptcreate ', ptid2
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptcreate
c
      write(*,*)'Testing he5_ptcreate '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptcreate '
      write(1,*)'====================='
      ptid3 = he5_ptcreate(ptfid, "FloatBuoy Point")
      if (ptid3 .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid3 = he5_ptcreate(ptfid, "FloatBuoy Point")'
         write(*,*)'	Value returned by he5_ptcreate ', ptid3
         write(1,*)'	ptid3 = he5_ptcreate(ptfid, "FloatBuoy Point")'
         write(1,*)'	Value returned by he5_ptcreate ', ptid3
      endif
      write(*,*)' '
      write(1,*)' '



c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid1)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid1)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid1)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid2)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid2)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid3)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid3)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid3)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptclose
c
      write(*,*)'Testing he5_ptclose '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptclose '
      write(1,*)'====================='
      status = he5_ptclose(ptfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptclose(ptfid)'
         write(*,*)'	Value returned by he5_ptclose ', status
         write(1,*)'	status = he5_ptclose(ptfid)'
         write(1,*)'	Value returned by he5_ptclose ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptopen
c
      write(*,*)'Testing he5_ptopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptopen '
      write(1,*)'====================='
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDWR) 
      if (ptfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDWR)'
         write(*,*)'	Value returned by he5_ptopen ', ptfid
         write(1,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDWR)'
         write(1,*)'	Value returned by he5_ptopen ', ptfid
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "Simple Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "Simple Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "Simple Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '


c     Populate input information structure 
c     ------------------------------------ 

      levelname = 'Sensor'

      rank_1(1)  = 1
      rank_1(2)  = 1
      rank_1(3)  = 1

      fieldlist1 = 'Time,Concentration,Species'

      dtype_1(1)     =  HE5T_NATIVE_DOUBLE
      dtype_1(2)     =  HE5T_NATIVE_FLOAT
      dtype_1(3)     =  HE5T_NATIVE_CHAR

      array_1(1)     =  0
      array_1(2)     =  1
      array_1(3)     =  1

      dims_1(1,1)      =  1
      dims_1(2,1)      =  4
      dims_1(3,1)      =  8

c Test Case -- he5_ptdeflevel
c
      write(1,27)
      write(*,*)'Testing he5_ptdeflevel '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdeflevel '
      write(1,*)'====================='
      status = he5_ptdeflevel(ptid, levelname, rank_1, fieldlist1,
     1dims_1, dtype_1, array_1)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdeflevel(ptid, levelname, rank_1'
         write(*,*)'             fieldlist1,dims_1, dtype_1, array_1)'
         write(*,*)'	Value returned by he5_ptdeflevel ', status
         write(1,*)'	status = he5_ptdeflevel(ptid, levelname, rank_1'
         write(1,*)'             fieldlist1,dims_1, dtype_1, array_1)'
         write(1,*)'	Value returned by he5_ptdeflevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '


c     Populate input information structure 
c     ------------------------------------ 

      levelname = 'Desc-Loc'

      rank_2(1)  = 1
      rank_2(2)  = 1
      rank_2(3)  = 1
      rank_2(4)  = 1
      rank_2(5)  = 1

      fieldlist2 = 'Label,Longitude,Latitude,DeployDate,ID'

      dtype_2(1)     =  HE5T_NATIVE_CHAR
      dtype_2(2)     =  HE5T_NATIVE_DOUBLE
      dtype_2(3)     =  HE5T_NATIVE_DOUBLE
      dtype_2(4)     =  HE5T_NATIVE_INT
      dtype_2(5)     =  HE5T_NATIVE_CHAR

      array_2(1)  = 1
      array_2(2)  = 0
      array_2(3)  = 0
      array_2(4)  = 0
      array_2(5)  = 1

      dims_2(1,1)      =  8
      dims_2(2,1)      =  1
      dims_2(3,1)      =  1
      dims_2(4,1)      =  1
      dims_2(5,1)      =  8


c Test Case -- he5_ptdeflevel
c
      write(1,27)
      write(*,*)'Testing he5_ptdeflevel '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdeflevel '
      write(1,*)'====================='
      status = he5_ptdeflevel(ptid, levelname, rank_2, fieldlist2,
     1dims_2, dtype_2, array_2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdeflevel(ptid, levelname, rank_2'
         write(*,*)'             fieldlist2,dims_2, dtype_2, array_2)'
         write(*,*)'	Value returned by he5_ptdeflevel ', status
         write(1,*)'	status = he5_ptdeflevel(ptid, levelname, rank_2'
         write(1,*)'             fieldlist2,dims_2, dtype_2, array_2)'
         write(1,*)'	Value returned by he5_ptdeflevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

c     Populate input information structure 
c     ------------------------------------ 

      levelname = 'Observations'

      rank_3(1)  = 1
      rank_3(2)  = 1
      rank_3(3)  = 1
      rank_3(4)  = 1

      fieldlist3 = 'Time,Rainfall,Temperature,ID'

      dtype_3(1)     =  HE5T_NATIVE_DOUBLE
      dtype_3(2)     =  HE5T_NATIVE_FLOAT
      dtype_3(3)     =  HE5T_NATIVE_FLOAT
      dtype_3(4)     =  HE5T_NATIVE_CHAR

      array_3(1)  = 0
      array_3(2)  = 0
      array_3(3)  = 0
      array_3(4)  = 1

      dims_3(1,1)      =  1
      dims_3(2,1)      =  1
      dims_3(3,1)      =  1
      dims_3(4,1)      =  8

c Test Case -- he5_ptdeflevel
c
      write(1,27)
      write(*,*)'Testing he5_ptdeflevel '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptdeflevel '
      write(1,*)'======================'
      status = he5_ptdeflevel(ptid, levelname, rank_3, fieldlist3,
     1dims_3, dtype_3, array_3)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdeflevel(ptid, levelname, rank_3'
         write(*,*)'             fieldlist3,dims_3, dtype_3, array_3)'
         write(*,*)'	Value returned by he5_ptdeflevel ', status
         write(1,*)'	status = he5_ptdeflevel(ptid, levelname, rank_3'
         write(1,*)'             fieldlist3,dims_3, dtype_3, array_3)'
         write(1,*)'	Value returned by he5_ptdeflevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

      parent    = 'Desc-Loc'
      child     = 'Observations'
      linkfield = 'ID'

c Test Case -- he5_ptdeflinkage
c
      write(*,*)'Testing he5_ptdeflinkage '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptdeflinkage '
      write(1,*)'========================'
      status = he5_ptdeflinkage(ptid, parent, child, linkfield)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdeflinkage(ptid, parent, child,'
         write(*,*)'	         linkfield)'
         write(*,*)'	Value returned by he5_ptdeflinkage ', status
         write(1,*)'	status = he5_ptdeflinkage(ptid, parent, child,'
         write(1,*)'	         linkfield)'
         write(1,*)'	Value returned by he5_ptdeflinkage ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "FloatBuoy Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "FloatBuoy Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "FloatBuoy Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '


      levelname = 'Description'

      rank_4(1)  = 1
      rank_4(2)  = 1
      rank_4(3)  = 1
      rank_4(4)  = 1

      fieldlist4 = 'Label,DeployDate,Weight,ID'

      dtype_4(1)     =  HE5T_NATIVE_CHAR
      dtype_4(2)     =  HE5T_NATIVE_INT
      dtype_4(3)     =  HE5T_NATIVE_INT
      dtype_4(4)     =  HE5T_NATIVE_CHAR

      array_4(1)  = 1
      array_4(2)  = 0
      array_4(3)  = 0
      array_4(4)  = 1

      dims_4(1,1)      =  8
      dims_4(2,1)      =  1
      dims_4(3,1)      =  1
      dims_4(4,1)      =  8

c Test Case -- he5_ptdeflevel
c
      write(1,27)
      write(*,*)'Testing he5_ptdeflevel '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdeflevel '
      write(1,*)'====================='
      status = he5_ptdeflevel(ptid, levelname, rank_4, fieldlist4,
     1dims_4, dtype_4, array_4)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdeflevel(ptid, levelname, rank_4'
         write(*,*)'             fieldlist4,dims_4, dtype_4, array_4)'
         write(*,*)'	Value returned by he5_ptdeflevel ', status
         write(1,*)'	status = he5_ptdeflevel(ptid, levelname, rank_4'
         write(1,*)'             fieldlist4,dims_4, dtype_4, array_4)'
         write(1,*)'	Value returned by he5_ptdeflevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

      levelname = 'Measurements'

      rank_5(1)  = 1
      rank_5(2)  = 1
      rank_5(3)  = 1
      rank_5(4)  = 1
      rank_5(5)  = 1
      rank_5(6)  = 1

      fieldlist5 = 'Time,Longitude,Latitude,Rainfall,Temperature,ID'

      dtype_5(1)     =  HE5T_NATIVE_DOUBLE
      dtype_5(2)     =  HE5T_NATIVE_DOUBLE
      dtype_5(3)     =  HE5T_NATIVE_DOUBLE
      dtype_5(4)     =  HE5T_NATIVE_FLOAT
      dtype_5(5)     =  HE5T_NATIVE_FLOAT
      dtype_5(6)     =  HE5T_NATIVE_CHAR

      array_5(1)  = 0
      array_5(2)  = 0
      array_5(3)  = 0
      array_5(4)  = 0
      array_5(5)  = 0
      array_5(6)  = 1

      dims_5(1,1)      =  1
      dims_5(2,1)      =  1
      dims_5(3,1)      =  1
      dims_5(4,1)      =  1
      dims_5(5,1)      =  1
      dims_5(6,1)      =  8


c Test Case -- he5_ptdeflevel
c
      write(1,27)
      write(*,*)'Testing he5_ptdeflevel '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdeflevel '
      write(1,*)'====================='
      status = he5_ptdeflevel(ptid, levelname, rank_5, fieldlist5,
     1dims_5, dtype_5, array_5)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdeflevel(ptid, levelname, rank_5'
         write(*,*)'             fieldlist5,dims_5, dtype_5, array_5)'
         write(*,*)'	Value returned by he5_ptdeflevel ', status
         write(1,*)'	status = he5_ptdeflevel(ptid, levelname, rank_5'
         write(1,*)'             fieldlist5,dims_5, dtype_5, array_5)'
         write(1,*)'	Value returned by he5_ptdeflevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

      parent    = 'Description'
      child     = 'Measurements'
      linkfield = 'ID'

c Test Case -- he5_ptdeflinkage
c
      write(*,*)'Testing he5_ptdeflinkage '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdeflinkage '
      write(1,*)'====================='
      status = he5_ptdeflinkage(ptid, parent, child, linkfield)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdeflinkage(ptid, parent, child,'
         write(*,*)'	         linkfield)'
         write(*,*)'	Value returned by he5_ptdeflinkage ', status
         write(1,*)'	status = he5_ptdeflinkage(ptid, parent, child,'
         write(1,*)'	         linkfield)'
         write(1,*)'	Value returned by he5_ptdeflinkage ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptclose
c
      write(*,*)'Testing he5_ptclose '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptclose '
      write(1,*)'====================='
      status = he5_ptclose(ptfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptclose(ptfid)'
         write(*,*)'	Value returned by he5_ptclose ', status
         write(1,*)'	status = he5_ptclose(ptfid)'
         write(1,*)'	Value returned by he5_ptclose ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptopen
c
      write(*,*)'Testing he5_ptopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptopen '
      write(1,*)'====================='
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDWR) 
      if (ptfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDWR)'
         write(*,*)'	Value returned by he5_ptopen ', ptfid
         write(1,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDWR)'
         write(1,*)'	Value returned by he5_ptopen ', ptfid
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "Simple Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "Simple Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "Simple Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

c     Read Simple Point 
c     ----------------- 
      open(unit=10, file='simple.txt', status='OLD')

      n = 0
      do 10 i=1,1000
         read(10, 110, end=100) time_tt, concentration_tt(1), 
     1                                  concentration_tt(2), 
     2                                  concentration_tt(3),
     3                                  concentration_tt(4), 
     4                                  spc_tt
         time(i)     = time_tt
         conc(i,1)   = concentration_tt(1)
         conc(i,2)   = concentration_tt(2)
         conc(i,3)   = concentration_tt(3)
         conc(i,4)   = concentration_tt(4)
         spc(i)      = spc_tt

         n = n + 1
   10 continue

  100 close(unit=10)
  110 format(F13.1,F6.2,F6.2,F6.2,F6.2,2X,A8)

      count(1) = n

      fieldname      = 'Time'
      datatype       = HE5T_NATIVE_DOUBLE


c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, time)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, time)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, time)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


   
c.....Convert array to 'C' order
      dimens(1) = 15
      dimens(2) = 4
      rank      = 2
      datatype  = HE5T_NATIVE_FLOAT

c Test Case -- he5_ptfort2c
c
      write(1,27)
      write(*,*)'Testing he5_ptfort2c '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptfort2c '
      write(1,*)'====================='
      status    = he5_ptfort2c(dimens, rank, datatype, conc, 
     1outconc)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptfort2c(dimens,rank,datatype,conc,'
         write(*,*)'	         outconc)'
         write(*,*)'	Value returned by he5_ptfort2c ', status
         write(1,*)'	status = he5_ptfort2c(dimens,rank,datatype,conc,'
         write(1,*)'	         outconc)'
         write(1,*)'	Value returned by he5_ptfort2c ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Concentration'

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, outconc)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, outconc)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, outconc)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Species'
      datatype       = HE5T_NATIVE_CHAR

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, spc)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

c     Read FixedBuoy Point 
c     -------------------- 
      open(unit=11, file='fixedBuoy0.txt', status='OLD')

      n = 0
      do 20 i=1,1000
         read(11, 210, end=200) desc_tt, lon_tt, lat_tt, date_tt, 
     1id_tt
         desc(i)     = desc_tt
         lon(i)      = lon_tt
         lat(i)      = lat_tt
         date(i)     = date_tt
         id(i)       = id_tt

         n = n + 1
   20 continue

  200 close(unit=11)
  210 format(A8,F13.7,F13.7,I7,1X,A8)

      count(1) = n

      fieldname      = 'Label'
      datatype       = HE5T_NATIVE_CHAR

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, desc)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, desc)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, desc)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Longitude'
      datatype       = HE5T_NATIVE_DOUBLE

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, lon)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, lon)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, lon)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Latitude'
      datatype       = HE5T_NATIVE_DOUBLE


c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, lat)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, lat)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, lat)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'DeployDate'
      datatype       = HE5T_NATIVE_INT

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype,  date)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype,  date)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype,  date)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'ID'
      datatype       = HE5T_NATIVE_CHAR

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, id)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, id)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, id)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


c     Read FixedBuoy Point - Level 1
c     ------------------------------ 
      open(unit=12, file='fixedBuoy1.txt', status='OLD')

      n = 0
      do 30 i=1,1000
         read(12, 310, end=300) time3_tt, rain_tt, temp_tt, id3_tt 
         time3(i)     = time3_tt
         rain(i)      = rain_tt
         temp(i)      = temp_tt
         id3(i)       = id3_tt

         n = n + 1
   30 continue

  300 close(unit=12)
  310 format(F13.2,F8.1,F8.2,3X,A8)

      count(1) = n

      fieldname      = 'Time'
      datatype       = HE5T_NATIVE_DOUBLE

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, time3)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, time3)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'	         fieldname,datatype, time3)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Rainfall'
      datatype       = HE5T_NATIVE_FLOAT

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, rain)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, rain)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'	         fieldname,datatype, rain)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Temperature'
      datatype       = HE5T_NATIVE_FLOAT

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, temp)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, temp)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'	         fieldname,datatype, temp)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

      fieldname      = 'ID'
      datatype       = HE5T_NATIVE_CHAR

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, id3)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, id3)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'	         fieldname,datatype, id3)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptwrbckptr
c
      write(1,27)
      write(*,*)'Testing he5_ptwrbckptr '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptwrbckptr '
      write(1,*)'====================='
      status = he5_ptwrbckptr(ptid,1)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptwrbckptr(ptid,1)'
         write(*,*)'	Value returned by he5_ptwrbckptr ', status
         write(1,*)'	status = he5_ptwrbckptr(ptid,1)'
         write(1,*)'	Value returned by he5_ptwrbckptr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptwrfwdptr
c
      write(1,27)
      write(*,*)'Testing he5_ptwrfwdptr '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptwrfwdptr '
      write(1,*)'====================='
      status = he5_ptwrfwdptr(ptid,1)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptwrfwdptr(ptid,1)'
         write(*,*)'	Value returned by he5_ptwrfwdptr ', status
         write(1,*)'	status = he5_ptwrfwdptr(ptid,1)'
         write(1,*)'	Value returned by he5_ptwrfwdptr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c     Write attributes to "Fixed Buoy Point"
c     --------------------------------------
      attrname       = 'GlobalAttribute_int'
      ntype          = HE5T_NATIVE_INT
      fortcount(1)   = 1
      attr           = 9999 

c Test Case -- he5_ptwriteattr
c
      write(1,27)
      write(*,*)'Testing he5_ptwriteattr '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptwriteattr '
      write(1,*)'====================='
      status   = he5_ptwriteattr(ptid,attrname,ntype,fortcount,
     1attr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptwriteattr(ptid,attrname,'
         write(*,*)'	           ntype,fortcount,attr)'
         write(*,*)'	Value returned by he5_ptwriteattr ', status
         write(1,*)'	status   = he5_ptwriteattr(ptid,attrname,'
         write(1,*)'	           ntype,fortcount,attr)'
         write(1,*)'	Value returned by he5_ptwriteattr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "FloatBuoy Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "FloatBuoy Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "FloatBuoy Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

c     Read FloatBuoy Point - Level 0
c     ------------------------------ 
      open(unit=14, file='floatBuoy0.txt', status='OLD')

      n = 0
      do 40 i=1,1000
         read(14, 410, end=400) desc4_tt, date4_tt, wgt_tt, id4_tt 
         desc4(i)     = desc4_tt
         date4(i)     = date4_tt
         wgt(i)       = wgt_tt
         id4(i)       = id4_tt

         n = n + 1
   40 continue

  400 close(unit=14)
  410 format(A8,I8,I7,2X,A8)

      count(1) = n

      fieldname      = 'Label'
      datatype       = HE5T_NATIVE_CHAR

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, desc4)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, desc4)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, desc4)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'DeployDate'
      datatype       = HE5T_NATIVE_INT

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, date4)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, date4)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, date4)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Weight'
      datatype       = HE5T_NATIVE_INT

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, wgt)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, wgt)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, wgt)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'ID'
      datatype       = HE5T_NATIVE_CHAR

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, id4)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, id4)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, id4)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


c     Read FixedBuoy Point - Level 1
c     ------------------------------ 
      open(unit=15, file='floatBuoy1.txt', status='OLD')

      n = 0
      do 50 i=1,1000
         read(15, 510, end=500) time5_tt, lon5_tt, lat5_tt,  
     1rain5_tt,temp5_tt,id5_tt
         time5(i)     = time5_tt
         lon5(i)      = lon5_tt
         lat5(i)      = lat5_tt
         rain5(i)     = rain5_tt
         temp5(i)     = temp5_tt
         id5(i)       = id5_tt

         n = n + 1
   50 continue

  500 close(unit=15)
  510 format(F13.1,F13.6,F13.6,F8.1,F8.2,3X,A8)

      count(1) = n

      fieldname      = 'Time'
      datatype       = HE5T_NATIVE_DOUBLE

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, time5)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, time5)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'	         fieldname,datatype, time5)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Longitude'
      datatype       = HE5T_NATIVE_DOUBLE

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, lon5)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, lon5)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'	         fieldname,datatype, lon5)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Latitude'
      datatype       = HE5T_NATIVE_DOUBLE

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, lat5)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, lat5)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'	         fieldname,datatype, lat5)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Rainfall'
      datatype       = HE5T_NATIVE_FLOAT

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, rain5)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, rain5)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'             fieldname,datatype, rain5)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Temperature'
      datatype       = HE5T_NATIVE_FLOAT

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, temp5)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, temp5)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'	         fieldname,datatype, temp5)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'ID'
      datatype       = HE5T_NATIVE_CHAR

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, id5)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, id5)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'	         fieldname,datatype, id5)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptwrbckptr
c
      write(*,*)'Testing he5_ptwrbckptr '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptwrbckptr '
      write(1,*)'======================'
      status = he5_ptwrbckptr(ptid,1)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptwrbckptr(ptid,1)'
         write(*,*)'	Value returned by he5_ptwrbckptr ', status
         write(1,*)'	status = he5_ptwrbckptr(ptid,1)'
         write(1,*)'	Value returned by he5_ptwrbckptr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptwrfwdptr
c
      write(*,*)'Testing he5_ptwrfwdptr '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptwrfwdptr '
      write(1,*)'======================'
      status = he5_ptwrfwdptr(ptid,1)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptwrfwdptr(ptid,1)'
         write(*,*)'	Value returned by he5_ptwrfwdptr ', status
         write(1,*)'	status = he5_ptwrfwdptr(ptid,1)'
         write(1,*)'	Value returned by he5_ptwrfwdptr ', status
      endif
      write(*,*)' '
      write(1,*)' '



c     Write attributes to "Float Buoy Point"
c     --------------------------------------
      attrname       = 'GlobalAttribute_float'
      ntype          = HE5T_NATIVE_FLOAT
      fortcount(1)   = 1
      flt            = -7.5

c Test Case -- he5_ptwriteattr
c
      write(*,*)'Testing he5_ptwriteattr '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptwriteattr '
      write(1,*)'======================'
      status   = he5_ptwriteattr(ptid,attrname,
     1ntype,fortcount,flt)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptwriteattr(ptid,attrname,'
         write(*,*)'	           ntype,fortcount,flt)'
         write(*,*)'	Value returned by he5_ptwriteattr ', status
         write(1,*)'	status   = he5_ptwriteattr(ptid,attrname,'
         write(1,*)'	           ntype,fortcount,flt)'
         write(1,*)'	Value returned by he5_ptwriteattr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptclose
c
      write(*,*)'Testing he5_ptclose '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptclose '
      write(1,*)'====================='
      status = he5_ptclose(ptfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptclose(ptfid)'
         write(*,*)'	Value returned by he5_ptclose ', status
         write(1,*)'	status = he5_ptclose(ptfid)'
         write(1,*)'	Value returned by he5_ptclose ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptopen
c
      write(*,*)'Testing he5_ptopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptopen '
      write(1,*)'====================='
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDONLY) 
      if (ptfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDONLY)'
         write(*,*)'	Value returned by he5_ptopen ', ptfid
         write(1,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDONLY)'
         write(1,*)'	Value returned by he5_ptopen ', ptfid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "Simple Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "Simple Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "Simple Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

c     Get level information 
c     --------------------- 
      level = 0

c Test Case -- he5_ptlevelinfo
c
      write(*,*)'Testing he5_ptlevelinfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptlevelinfo '
      write(1,*)'====================='
      status = he5_ptlevelinfo(ptid, level, levelname, rank_tt,
     1fieldlist, dim_sizes_tt, datasize, offset_tt, dtype_tt)
      if (ptfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status=he5_ptlevelinfo(ptid,level,levelname,'
         write(*,*)'           rank_tt,fieldlist,dim_sizes_tt,'
         write(*,*)'           datasize,offset_tt,dtype_tt)'
         write(*,*)'	Value returned by he5_ptlevelinfo ', status
         write(1,*)'    status=he5_ptlevelinfo(ptid,level,levelname,'
         write(1,*)'           rank_tt,fieldlist,dim_sizes_tt,'
         write(1,*)'           datasize,offset_tt,dtype_tt)'
         write(1,*)'	Value returned by he5_ptlevelinfo ', status
      endif
      write(*,*)' '
      write(1,*)' '

c     Get the number of records in level
c     ---------------------------------- 
      level = 0

c Test Case -- he5_ptnrecs
c
      write(*,*)'Testing he5_ptnrecs '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptnrecs '
      write(1,*)'====================='
      nrecs = he5_ptnrecs(ptid, level)
      if (nrecs .le. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nrecs = he5_ptnrecs(ptid, level)'
         write(*,*)'	Value returned by he5_ptnrecs ', nrecs
         write(1,*)'	nrecs = he5_ptnrecs(ptid, level)'
         write(1,*)'	Value returned by he5_ptnrecs ', nrecs
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptnlevels
c
      write(*,*)'Testing he5_ptnlevels '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptnlevels '
      write(1,*)'====================='
      nlevels = he5_ptnlevels(ptid)
      if (nlevels .le. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nlevels = he5_ptnlevels(ptid)'
         write(*,*)'	Value returned by he5_ptnlevels ', nlevels
         write(1,*)'	nlevels = he5_ptnlevels(ptid)'
         write(1,*)'	Value returned by he5_ptnlevels ', nlevels
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptnfields
c
      write(*,*)'Testing he5_ptnfields '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptnfields '
      write(1,*)'====================='
      nflds = he5_ptnfields(ptid, level, fieldlist, strbufsize)
      if (nflds .le. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nflds = he5_ptnfields(ptid, level,'
         write(*,*)'	        fieldlist, strbufsize)'
         write(*,*)'	Value returned by he5_ptnfields ', nflds
         write(1,*)'	nflds = he5_ptnfields(ptid, level,'
         write(1,*)'	        fieldlist, strbufsize)'
         write(1,*)'	Value returned by he5_ptnfields ', nflds
      endif
      write(*,*)' '
      write(1,*)' '

c     Populate input information structure 
c     ------------------------------------ 
      dtype(1)     =  HE5T_NATIVE_DOUBLE
      dtype(2)     =  HE5T_NATIVE_FLOAT
      dtype(3)     =  HE5T_NATIVE_CHAR

c     Read the level data and print out
c     --------------------------------- 
      fieldname3(1)  = 'Time'

c Test Case -- he5_ptreadlevel
c
      write(*,*)'Testing he5_ptreadlevel '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptreadlevel '
      write(1,*)'====================='
      status = he5_ptreadlevel(ptid, 0, fieldname3(1), 
     1dtype(1), time)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptreadlevel(ptid, 0, fieldname3(1),'
         write(*,*)'	         dtype(1), time)'
         write(*,*)'	Value returned by he5_ptreadlevel ', status
         write(1,*)'	status = he5_ptreadlevel(ptid, 0, fieldname3(1),'
         write(1,*)'	         dtype(1), time)'
         write(1,*)'	Value returned by he5_ptreadlevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname3(2)  = 'Concentration'

c Test Case -- he5_ptreadlevel
c
      write(*,*)'Testing he5_ptreadlevel '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptreadlevel '
      write(1,*)'====================='
      status = he5_ptreadlevel(ptid, 0, fieldname3(2), 
     1dtype(2), con)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptreadlevel(ptid, 0, fieldname3(2),'
         write(*,*)'	         dtype(2), con)'
         write(*,*)'	Value returned by he5_ptreadlevel ', status
         write(1,*)'	status = he5_ptreadlevel(ptid, 0, fieldname3(2),'
         write(1,*)'	         dtype(2), con)'
         write(1,*)'	Value returned by he5_ptreadlevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

c     Convert 'C' array to Fortran order
c     ---------------------------------- 
      dimens(1) = 15
      dimens(2) = 4
      arr_rank  = 2
      datatype  = HE5T_NATIVE_FLOAT

ccc      status  = he5_ptc2fort(dimens, arr_rank, datatype, con, 
ccc     1outcon)
ccc      write(*,*) 'Status returned by he5_ptc2fort():  ',status

c Test Case -- he5_ptc2fort
c
      write(1,27)
      write(*,*)'Testing he5_ptc2fort '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptc2fort '
      write(1,*)'====================='
      status  = he5_ptc2fort(dimens, arr_rank, datatype, con, 
     1outcon)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptc2fort(dimens,arr_rank,'
         write(*,*)'	         datatype,con,outcon)'
         write(*,*)'	Value returned by he5_ptc2fort ', status
         write(1,*)'    status = he5_ptc2fort(dimens,arr_rank,'
         write(1,*)'	         datatype,con,outcon)'
         write(1,*)'	Value returned by he5_ptc2fort ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname3(3)  = 'Species'

c Test Case -- he5_ptreadlevel
c
      write(*,*)'Testing he5_ptreadlevel '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptreadlevel '
      write(1,*)'====================='
      status = he5_ptreadlevel(ptid, 0, fieldname3(3), 
     1dtype(3), spec)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptreadlevel(ptid, 0, fieldname3(3),'
         write(*,*)'	         dtype(3), spec)'
         write(*,*)'	Value returned by he5_ptreadlevel ', status
         write(1,*)'	status = he5_ptreadlevel(ptid, 0, fieldname3(3),'
         write(1,*)'	         dtype(3), spec)'
         write(1,*)'	Value returned by he5_ptreadlevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

      attrname       = 'GlobalAttribute_int'

      nattr   = he5_ptinqattrs(ptid,attrlist,strbufsize)

c Test Case -- he5_ptinqattrs
c
      write(*,*)'Testing he5_ptinqattrs '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptinqattrs '
      write(1,*)'======================'
      nattr   = he5_ptinqattrs(ptid,attrlist,strbufsize)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nattr   = he5_ptinqattrs(ptid,attrlist,strbufsize)'
         write(*,*)'	Value returned by he5_ptinqattrs ', nattr
         write(1,*)'	nattr   = he5_ptinqattrs(ptid,attrlist,strbufsize)'
         write(1,*)'	Value returned by he5_ptinqattrs ', nattr
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptreadattr
c
      write(*,*)'Testing he5_ptreadattr '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptreadattr '
      write(1,*)'======================'
      status   = he5_ptreadattr(ptid,attrname,attr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptreadattr(ptid,attrname,attr)'
         write(*,*)'	Value returned by he5_ptreadattr ', nattr
         write(1,*)'	status   = he5_ptreadattr(ptid,attrname,attr)'
         write(1,*)'	Value returned by he5_ptreadattr ', nattr
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptclose
c
      write(*,*)'Testing he5_ptclose '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptclose '
      write(1,*)'====================='
      status = he5_ptclose(ptfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptclose(ptfid)'
         write(*,*)'	Value returned by he5_ptclose ', status
         write(1,*)'	status = he5_ptclose(ptfid)'
         write(1,*)'	Value returned by he5_ptclose ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptopen
c
      write(*,*)'Testing he5_ptopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptopen '
      write(1,*)'====================='
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDWR) 
      if (ptfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDWR)'
         write(*,*)'	Value returned by he5_ptopen ', ptfid
         write(1,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDWR)'
         write(1,*)'	Value returned by he5_ptopen ', ptfid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "Simple Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "Simple Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "Simple Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

      dtype(1)     =  HE5T_NATIVE_DOUBLE
      dtype(2)     =  HE5T_NATIVE_FLOAT
      dtype(3)     =  HE5T_NATIVE_CHAR

      nrec      = 1
      recs(1)   = 0

      level     = 0

      fieldname = 'Concentration'

      conc_tt(1)   = 1.11
      conc_tt(2)   = 2.22
      conc_tt(3)   = 3.33
      conc_tt(4)   = 4.44

c Test Case -- he5_ptupdatelevel
c
      write(*,*)'Testing he5_ptupdatelevel '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptupdatelevel '
      write(1,*)'========================='
      status = he5_ptupdatelevel(ptid, level, fieldname, nrec,
     1recs, dtype(2), conc_tt)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptupdatelevel(ptid, level,'
         write(*,*)'	         fieldname, nrec, recs,'
         write(*,*)'	         dtype(2), conc_tt)'
         write(*,*)'	Value returned by he5_ptupdatelevel ', status
         write(1,*)'	status = he5_ptupdatelevel(ptid, level,'
         write(1,*)'	         fieldname, nrec, recs,'
         write(1,*)'	         dtype(2), conc_tt)'
         write(1,*)'	Value returned by he5_ptupdatelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

      fieldname = 'Time'

      time_tt   = 13131313.0

c Test Case -- he5_ptupdatelevel
c
      write(*,*)'Testing he5_ptupdatelevel '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptupdatelevel '
      write(1,*)'========================='
      status = he5_ptupdatelevel(ptid, level, fieldname, nrec,
     1recs, dtype(1), time_tt)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptupdatelevel(ptid, level,'
         write(*,*)'	         fieldname, nrec, recs,'
         write(*,*)'	         dtype(1), time_tt)'
         write(*,*)'	Value returned by he5_ptupdatelevel ', status
         write(1,*)'	status = he5_ptupdatelevel(ptid, level,'
         write(1,*)'	         fieldname, nrec, recs,'
         write(1,*)'	         dtype(1), time_tt)'
         write(1,*)'	Value returned by he5_ptupdatelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

      fieldname = 'Species'

      spc_tt    = 'AM'

c Test Case -- he5_ptupdatelevel
c
      write(*,*)'Testing he5_ptupdatelevel '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptupdatelevel '
      write(1,*)'========================='
      status = he5_ptupdatelevel(ptid, level, fieldname, nrec,
     1recs, dtype(3), spc_tt)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptupdatelevel(ptid, level,'
         write(*,*)'	         fieldname, nrec, recs,'
         write(*,*)'	         dtype(3), spc_tt)'
         write(*,*)'	Value returned by he5_ptupdatelevel ', status
         write(1,*)'	status = he5_ptupdatelevel(ptid, level,'
         write(1,*)'	         fieldname, nrec, recs,'
         write(1,*)'	         dtype(3), spc_tt)'
         write(1,*)'	Value returned by he5_ptupdatelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptclose
c
      write(*,*)'Testing he5_ptclose '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptclose '
      write(1,*)'====================='
      status = he5_ptclose(ptfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptclose(ptfid)'
         write(*,*)'	Value returned by he5_ptclose ', status
         write(1,*)'	status = he5_ptclose(ptfid)'
         write(1,*)'	Value returned by he5_ptclose ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptopen
c
      write(*,*)'Testing he5_ptopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptopen '
      write(1,*)'====================='
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDWR) 
      if (ptfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDWR)'
         write(*,*)'	Value returned by he5_ptopen ', ptfid
         write(1,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDWR)'
         write(1,*)'	Value returned by he5_ptopen ', ptfid
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

c     Write attributes to "Fixed Buoy Point"
c     --------------------------------------
      attrname       = 'GlobalAttribute_int'
      ntype          = HE5T_NATIVE_INT
      fortcount(1)   = 1
      attr           = 9999
             

c Test Case -- he5_ptwriteattr
c
      write(*,*)'Testing he5_ptwriteattr '
      write(*,*)'======================='
      write(1,*)'Testing he5_ptwriteattr '
      write(1,*)'======================='
      status   = he5_ptwriteattr(ptid,attrname,ntype,fortcount,
     1attr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptwriteattr(ptid,attrname,'
         write(*,*)'	           ntype,fortcount,attr)'
         write(*,*)'	Value returned by he5_ptwriteattr ', status
         write(1,*)'	status   = he5_ptwriteattr(ptid,attrname,'
         write(1,*)'	           ntype,fortcount,attr)'
         write(1,*)'	Value returned by he5_ptwriteattr ', status
      endif
      write(*,*)' '
      write(1,*)' '

      attrname       = 'GroupAttribute'
      ntype          = HE5T_NATIVE_INT
      fortcount(1)   = 5
      attr1(1)       = 1
      attr1(2)       = 2
      attr1(3)       = 3
      attr1(4)       = 4
      attr1(5)       = 5

c Test Case -- he5_ptwritegrpattr
c
      write(*,*)'Testing he5_ptwritegrpattr '
      write(*,*)'=========================='
      write(1,*)'Testing he5_ptwritegrpattr '
      write(1,*)'=========================='
      status   = he5_ptwritegrpattr(ptid,attrname,ntype,fortcount,
     1attr1)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptwritegrpattr(ptid,attrname,'
         write(*,*)'	           ntype,fortcount,attr1)'
         write(*,*)'	Value returned by he5_ptclose ', status
         write(1,*)'	status   = he5_ptwritegrpattr(ptid,attrname,'
         write(1,*)'	           ntype,fortcount,attr1)'
         write(1,*)'	Value returned by he5_ptclose ', status
      endif
      write(*,*)' '
      write(1,*)' '

      levelname      = 'Observations'
      attrname       = 'LocalAttribute'
      ntype          = HE5T_NATIVE_INT
      fortcount(1)   = 5
      attr2(1)       = 10
      attr2(2)       = 20
      attr2(3)       = 30
      attr2(4)       = 40
      attr2(5)       = 50

c Test Case -- he5_ptwritelocattr
c
      write(*,*)'Testing he5_ptwritelocattr '
      write(*,*)'=========================='
      write(1,*)'Testing he5_ptwritelocattr '
      write(1,*)'=========================='
      status   = he5_ptwritelocattr(ptid,levelname,attrname,
     1ntype,fortcount,attr2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptwritelocattr(ptid,'
         write(*,*)'	           levelname,attrname,ntype,'
         write(*,*)'	           fortcount,attr2)'
         write(*,*)'	Value returned by he5_ptwritelocattr ', status
         write(1,*)'	status   = he5_ptwritelocattr(ptid,'
         write(1,*)'	           levelname,attrname,ntype,'
         write(1,*)'	           fortcount,attr2)'
         write(1,*)'	Value returned by he5_ptwritelocattr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

      attrname       = 'GlobalAttribute_float'
      ntype          = HE5T_NATIVE_FLOAT
      fortcount(1)   = 1
      flt            = -7.5

c Test Case -- he5_ptwriteattr
c
      write(*,*)'Testing he5_ptwriteattr '
      write(*,*)'======================='
      write(1,*)'Testing he5_ptwriteattr '
      write(1,*)'======================='
      status   = he5_ptwriteattr(ptid,attrname,
     1ntype,fortcount,flt)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptwriteattr(ptid,attrname,'
         write(*,*)'	           ntype,fortcount,flt)'
         write(*,*)'	Value returned by he5_ptwriteattr ', status
         write(1,*)'	status   = he5_ptwriteattr(ptid,attrname,'
         write(1,*)'	           ntype,fortcount,flt)'
         write(1,*)'	Value returned by he5_ptwriteattr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptclose
c
      write(*,*)'Testing he5_ptclose '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptclose '
      write(1,*)'====================='
      status = he5_ptclose(ptfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptclose(ptfid)'
         write(*,*)'	Value returned by he5_ptclose ', status
         write(1,*)'	status = he5_ptclose(ptfid)'
         write(1,*)'	Value returned by he5_ptclose ', status
      endif
      write(*,*)' '
      write(1,*)' '


      null_char_0  = '0'

c Test Case -- he5_ptopen
c
      write(*,*)'Testing he5_ptopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptopen '
      write(1,*)'====================='
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDONLY) 
      if (ptfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDONLY)'
         write(*,*)'	Value returned by he5_ptopen ', ptfid
         write(1,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDONLY)'
         write(1,*)'	Value returned by he5_ptopen ', ptfid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

c     Global Attributes
c     -----------------
      attrname       = 'GlobalAttribute_int'
             
      print *,'Global Attribute:   '

c Test Case -- he5_ptreadattr
c
      write(*,*)'Testing he5_ptreadattr '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptreadattr '
      write(1,*)'======================'
      status   = he5_ptreadattr(ptid,attrname,attr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptreadattr(ptid,attrname,attr)'
         write(*,*)'	Value returned by he5_ptreadattr ', status
         write(1,*)'	status   = he5_ptreadattr(ptid,attrname,attr)'
         write(1,*)'	Value returned by he5_ptreadattr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptinqattrs
c
      write(*,*)'Testing he5_ptinqattrs '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptinqattrs '
      write(1,*)'======================'
      nattr   = he5_ptinqattrs(ptid,null_char_0,strbufsize)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nattr   = he5_ptinqattrs(ptid,'
         write(*,*)'	          null_char_0,strbufsize)'
         write(*,*)'	Value returned by he5_ptinqattrs ', nattr
         write(1,*)'	nattr   = he5_ptinqattrs(ptid,'
         write(1,*)'	          null_char_0,strbufsize)'
         write(1,*)'	Value returned by he5_ptinqattrs ', nattr
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptinqattrs
c
      write(*,*)'Testing he5_ptinqattrs '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptinqattrs '
      write(1,*)'======================'
      nattr   = he5_ptinqattrs(ptid,attrlist,strbufsize)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nattr   = he5_ptinqattrs(ptid,attrlist,strbufsize)'
         write(*,*)'	Value returned by he5_ptinqattrs ', nattr
         write(1,*)'	nattr   = he5_ptinqattrs(ptid,attrlist,strbufsize)'
         write(1,*)'	Value returned by he5_ptinqattrs ', nattr
      endif
      write(*,*)' '
      write(1,*)' '

      attrname       = 'GlobalAttribute_int'

c Test Case -- he5_ptattrinfo
c
      write(*,*)'Testing he5_ptattrinfo '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptattrinfo '
      write(1,*)'======================'
      status   = he5_ptattrinfo(ptid,attrname,ntype,sz)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptattrinfo(ptid,attrname,ntype,sz)'
         write(*,*)'	Value returned by he5_ptattrinfo ', status
         write(1,*)'	status   = he5_ptattrinfo(ptid,attrname,ntype,sz)'
         write(1,*)'	Value returned by he5_ptattrinfo ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptattrinfo
c
      write(*,*)'Testing he5_ptattrinfo '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptattrinfo '
      write(1,*)'======================'
      status   = he5_ptattrinfo(ptid,attrname,ntype,sz)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptattrinfo(ptid,attrname,ntype,sz)'
         write(*,*)'	Value returned by he5_ptattrinfo ', status
         write(1,*)'	status   = he5_ptattrinfo(ptid,attrname,ntype,sz)'
         write(1,*)'	Value returned by he5_ptattrinfo ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptreadattr
c
      write(*,*)'Testing he5_ptreadattr '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptreadattr '
      write(1,*)'======================'
      status   = he5_ptreadattr(ptid,attrname,flt)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptreadattr(ptid,attrname,flt)'
         write(*,*)'	Value returned by he5_ptreadattr ', status
         write(1,*)'	status   = he5_ptreadattr(ptid,attrname,flt)'
         write(1,*)'	Value returned by he5_ptreadattr ', status
      endif
      write(*,*)' '
      write(1,*)' '

      attrname       = 'GroupAttribute'

c Test Case -- he5_ptreadgrpattr
c
      write(*,*)'Testing he5_ptreadgrpattr'
      write(*,*)'========================='
      write(1,*)'Testing he5_ptreadgrpattr'
      write(1,*)'========================='
      status = he5_ptreadgrpattr(ptid,attrname,attr1)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptreadgrpattr(ptid,attrname,attr1)'
         write(*,*)'	Value returned by he5_ptreadgrpattr ', status
         write(1,*)'	status = he5_ptreadgrpattr(ptid,attrname,attr1)'
         write(1,*)'	Value returned by he5_ptreadgrpattr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptinqgrpattrs
c
      write(*,*)'Testing he5_ptinqgrpattrs '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptinqgrpattrs '
      write(1,*)'========================='
      nattr = he5_ptinqgrpattrs(ptid,null_char_0,strbufsize)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nattr = he5_ptinqgrpattrs(ptid,'
         write(*,*)'	        null_char_0,strbufsize)'
         write(*,*)'	Value returned by he5_ptinqgrpattrs ', nattr
         write(1,*)'	nattr = he5_ptinqgrpattrs(ptid,'
         write(1,*)'	        null_char_0,strbufsize)'
         write(1,*)'	Value returned by he5_ptinqgrpattrs ', nattr
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptinqgrpattrs
c
      write(*,*)'Testing he5_ptinqgrpattrs '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptinqgrpattrs '
      write(1,*)'========================='
      nattr = he5_ptinqgrpattrs(ptid,attrlist,strbufsize)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nattr = he5_ptinqgrpattrs(ptid,'
         write(*,*)'	        attrlist,strbufsize)'
         write(*,*)'	Value returned by he5_ptinqgrpattrs ', status
         write(1,*)'	nattr = he5_ptinqgrpattrs(ptid,'
         write(1,*)'	        attrlist,strbufsize)'
         write(1,*)'	Value returned by he5_ptinqgrpattrs ', status
      endif
      write(*,*)' '
      write(1,*)' '

      attrname       = 'GroupAttribute'

c Test Case -- he5_ptgrpattrinfo
c
      write(*,*)'Testing he5_ptgrpattrinfo '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptgrpattrinfo '
      write(1,*)'========================='
      status   = he5_ptgrpattrinfo(ptid,attrname,ntype,sz)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptgrpattrinfo(ptid,'
         write(*,*)'	           attrname,ntype,sz)'
         write(*,*)'	Value returned by he5_ptgrpattrinfo ', status
         write(1,*)'	status   = he5_ptgrpattrinfo(ptid,'
         write(1,*)'	           attrname,ntype,sz)'
         write(1,*)'	Value returned by he5_ptgrpattrinfo ', status
      endif
      write(*,*)' '
      write(1,*)' '

      attrname       = 'LocalAttribute'
      levelname      = 'Observations'

c Test Case -- he5_ptreadlocattr
c
      write(*,*)'Testing he5_ptreadlocattr '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptreadlocattr '
      write(1,*)'========================='
      status = he5_ptreadlocattr(ptid,levelname,attrname,attr2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptreadlocattr(ptid,'
         write(*,*)'	         levelname,attrname,attr2)'
         write(*,*)'	Value returned by he5_ptreadlocattr ', status
         write(1,*)'	status = he5_ptreadlocattr(ptid,'
         write(1,*)'	         levelname,attrname,attr2)'
         write(1,*)'	Value returned by he5_ptreadlocattr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptinqlocattrs
c
      write(*,*)'Testing he5_ptinqlocattrs '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptinqlocattrs '
      write(1,*)'========================='
      nattr = he5_ptinqlocattrs(ptid,levelname,null_char_0,strbufsize)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nattr = he5_ptinqlocattrs(ptid,'
         write(*,*)'	        levelname,null_char_0,strbufsize)'
         write(*,*)'	Value returned by he5_ptinqlocattrs ', nattr
         write(1,*)'	nattr = he5_ptinqlocattrs(ptid,'
         write(1,*)'	        levelname,null_char_0,strbufsize)'
         write(1,*)'	Value returned by he5_ptinqlocattrs ', nattr
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptinqlocattrs
c
      write(*,*)'Testing he5_ptinqlocattrs '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptinqlocattrs '
      write(1,*)'====================='
      nattr = he5_ptinqlocattrs(ptid,levelname,attrlist,strbufsize)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nattr = he5_ptinqlocattrs(ptid,'
         write(*,*)'	        levelname,attrlist,strbufsize)'
         write(*,*)'	Value returned by he5_ptinqlocattrs ', nattr
         write(1,*)'	nattr = he5_ptinqlocattrs(ptid,'
         write(1,*)'	        levelname,attrlist,strbufsize)'
         write(1,*)'	Value returned by he5_ptinqlocattrs ', nattr
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptlocattrinfo
c
      write(*,*)'Testing he5_ptlocattrinfo '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptlocattrinfo '
      write(1,*)'========================='
      status = he5_ptlocattrinfo(ptid,levelname,attrname,ntype,sz)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptlocattrinfo(ptid,'
         write(*,*)'	         levelname,attrname,ntype,sz)'
         write(*,*)'	Value returned by he5_ptlocattrinfo ', status
         write(1,*)'	status = he5_ptlocattrinfo(ptid,'
         write(1,*)'	         levelname,attrname,ntype,sz)'
         write(1,*)'	Value returned by he5_ptlocattrinfo ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptclose
c
      write(*,*)'Testing he5_ptclose '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptclose '
      write(1,*)'====================='
      status = he5_ptclose(ptfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptclose(ptfid)'
         write(*,*)'	Value returned by he5_ptclose ', status
         write(1,*)'	status = he5_ptclose(ptfid)'
         write(1,*)'	Value returned by he5_ptclose ', status
      endif
      write(*,*)' '
      write(1,*)' '

      null_char_0  = '0'

c Test Case -- he5_ptopen
c
      write(*,*)'Testing he5_ptopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptopen '
      write(1,*)'====================='
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDONLY) 
      if (ptfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDONLY)'
         write(*,*)'	Value returned by he5_ptopen ', ptfid
         write(1,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDONLY)'
         write(1,*)'	Value returned by he5_ptopen ', ptfid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

      fieldgroup = HE5_HDFE_DATAGROUP
      fieldname  = 'Observations'

c Test Case -- he5_ptinqdatatype
c
      write(*,*)'Testing he5_ptinqdatatype '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptinqdatatype '
      write(1,*)'========================='
      status = he5_ptinqdatatype(ptid,fieldname,null_char_0,fieldgroup,
     1datatype,classid,order,size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptinqdatatype(ptid,fieldname,'
         write(*,*)'	         null_char_0,fieldgroup,datatype,classid,'
         write(*,*)'	         order,size)'
         write(*,*)'	Value returned by he5_ptinqdatatype ', status
         write(1,*)'	status = he5_ptinqdatatype(ptid,fieldname,'
         write(1,*)'	         null_char_0,fieldgroup,datatype,classid,'
         write(1,*)'	         order,size)'
         write(1,*)'	Value returned by he5_ptinqdatatype ', status
      endif
      write(*,*)' '
      write(1,*)' '

      fieldgroup   = HE5_HDFE_ATTRGROUP
      attrname     = 'GlobalAttribute_int'

c Test Case -- he5_ptinqdatatype
c
      write(*,*)'Testing he5_ptinqdatatype '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptinqdatatype '
      write(1,*)'========================='
      status = he5_ptinqdatatype(ptid,null_char_0,attrname,fieldgroup,
     1datatype,classid,order,size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptinqdatatype(ptid,null_char_0,'
         write(*,*)'	         attrname,fieldgroup,datatype,'
         write(*,*)'	         classid,order,size)'
         write(*,*)'	Value returned by he5_ptinqdatatype ', status
         write(1,*)'	status = he5_ptinqdatatype(ptid,null_char_0,'
         write(1,*)'	         attrname,fieldgroup,datatype,'
         write(1,*)'	         classid,order,size)'
         write(1,*)'	Value returned by he5_ptinqdatatype ', status
      endif
      write(*,*)' '
      write(1,*)' '

      fieldgroup   = HE5_HDFE_GRPATTRGROUP
      attrname     = 'GroupAttribute'

c Test Case -- he5_ptinqdatatype
c
      write(*,*)'Testing he5_ptinqdatatype '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptinqdatatype '
      write(1,*)'========================='
      status = he5_ptinqdatatype(ptid,null_char_0,attrname,fieldgroup,
     1datatype,classid,order,size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptinqdatatype(ptid,null_char_0,'
         write(*,*)'	         attrname,fieldgroup,datatype,'
         write(*,*)'	         classid,order,size)'
         write(*,*)'	Value returned by he5_ptinqdatatype ', status
         write(1,*)'	status = he5_ptinqdatatype(ptid,null_char_0,'
         write(1,*)'	         attrname,fieldgroup,datatype,'
         write(1,*)'	         classid,order,size)'
         write(1,*)'	Value returned by he5_ptinqdatatype ', status
      endif
      write(*,*)' '
      write(1,*)' '

      fieldname    = 'Observations'
      fieldgroup   = HE5_HDFE_LOCATTRGROUP
      attrname     = 'LocalAttribute'

c Test Case -- he5_ptinqdatatype
c
      write(*,*)'Testing he5_ptinqdatatype '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptinqdatatype '
      write(1,*)'========================='
      status = he5_ptinqdatatype(ptid,fieldname,attrname,fieldgroup,
     1datatype,classid,order,size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptinqdatatype(ptid,fieldname,'
         write(*,*)'	         attrname,fieldgroup,datatype,'
         write(*,*)'	         classid,order,size)'
         write(*,*)'	Value returned by he5_ptinqdatatype ', status
         write(1,*)'	status = he5_ptinqdatatype(ptid,fieldname,'
         write(1,*)'	         attrname,fieldgroup,datatype,'
         write(1,*)'	         classid,order,size)'
         write(1,*)'	Value returned by he5_ptinqdatatype ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptclose
c
      write(*,*)'Testing he5_ptclose '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptclose '
      write(1,*)'====================='
      status = he5_ptclose(ptfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptclose(ptfid)'
         write(*,*)'	Value returned by he5_ptclose ', status
         write(1,*)'	status = he5_ptclose(ptfid)'
         write(1,*)'	Value returned by he5_ptclose ', status
      endif
      write(*,*)' '
      write(1,*)' '

      close(unit=1)

   27 format(' ')
  230 format('********Error unexpected**********')
  240 format('***********Passed Test*********')

      stop
      end

!
!   In this program we (1) open the "za.he5" HDF-EOS file, (2)
!   attach to the "ZA1" za, and (3) define the external data 
!   field "ExtData".
!

      program     he5_za_defexternalfldF_64

      implicit    none
 
      include     'hdfeos5.inc'

      integer     status
      integer     he5_zaopen
      integer     he5_zaattach
      integer     he5_zadefine
      integer     he5_zadetach
      integer     he5_zaclose
      integer     he5_zasetxdat
      integer     zafid, zaid

      integer*8   offset(3), size(3)

      integer     FAIL
      parameter   (FAIL=-1)


!     Open the HDF-EOS file, "za.he5" using "READ/WRITE" access code
!     --------------------------------------------------------------
      zafid = he5_zaopen("za.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_zaopen():  ',zafid
      if (zafid .NE. FAIL) then

      zaid = he5_zaattach(zafid, "ZA1")
      write(*,*) 'ZA ID returned by he5_zaattach():  ',zaid
      if (zaid .NE. FAIL) then

      offset(1) = 0 
      size(1)   = 40

      offset(2) = 40
      size(2)   = 80

      offset(3) = 80
      size(3)   = 120

      status = he5_zasetxdat(zaid, "extf1.dat,extf2.dat,extf3.dat",
     1offset, size)
      write(*,*) 'Status returned by he5_zasetxdat():  ',status
      
      status = he5_zadefine(zaid, "ExtData", "ExtDim",
     1" ", HE5T_NATIVE_INT)
      write(*,*) 'Status returned by he5_zadefine():  ',status

      endif
      endif

!     Detach from the za
!     ------------------      
      status = he5_zadetach(zaid)
      write(*,*) 'Status returned by he5_zadetach():  ',status

!     Close the file
!     --------------      
      status = he5_zaclose(zafid)
      write(*,*) 'Status returned by he5_zaclose():  ',status

      stop
      end

c  In this program we (1) open the "swath.he5" file, (2) attach to
c  the "Swath1" swath, and (3) write data to the "Longitude", 
c  "Longitude" and "Spectra" fields

      program        he5_sw_writedataF_64

      implicit       none

      include        'hdfeos5.inc'

      integer        status
      integer        he5_swopen 
      integer        he5_swattach 
      integer        he5_swwrfld
      integer        he5_swwrattr
      integer        he5_swwrlattr
      integer        he5_swwrgattr
      integer        he5_ehwrglatt
      integer        he5_swdetach
      integer        he5_swclose
      integer        he5_prwrite
      integer        swfid, SWid 
      integer        buffer(250)
      integer        counter
      integer        i, j , k
      integer        itrack

      integer*4      attr(4)
      integer*8      track
      integer*8      start(3)
      integer*8      stride(3)
      integer*8      count(3)
      integer*8      len(4)
      integer*8      datasize
      character*10    attr4
      character*100   attr5

      character*4    charfield(10)

      real           lng(10)
      real           lat(10)
 
      real*8         plane(800)
      real*8         tme(73)

      integer        FAIL
      parameter      (FAIL=-1)
      
c     Set longitude values along the cross track
c     ------------------------------------------
      do i=1,10
		 lng(i) = i-1.0
      enddo

      data charfield/'aaaa','b  b','cc  ','dddd','ee e','ffff',
     1              'gggg','hh  ','i   ','jjjj'/
	 
c     Open HDF-EOS file, "swath.he5"
c     ------------------------------
      swfid = he5_swopen("swath.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_swopen():  ',swfid

      if (swfid .NE. FAIL) then
		 SWid = he5_swattach(swfid, "Swath1")
         write(*,*) 'Swath ID returned by he5_swattach():  ',swid

		 if (swid .NE. FAIL) then

c     Write data starting at the beginning of each cross track
c     --------------------------------------------------------
			start(1)  = 0
			stride(1) = 1
			stride(2) = 1
			count(1)  = 10
			count(2)  = 1

c     Loop through all the tracks, incrementing the track starting
c     position by one each time
c     ------------------------------------------------------------
			do track = 1,20
			   start(2) = track - 1
			   status = he5_swwrfld(swid,"Longitude",start,
     1              stride,count,lng)
			   do itrack = 1,10
				  lat(itrack) = track
			   enddo
			   status = he5_swwrfld(swid,"Latitude",start,
     1              stride,count,lat) 
			enddo

			do i = 1,73
			   tme(i) = 345740878.3 + 848936.2*(i-1)
			enddo
            
			start(1)  = 0
			stride(1) = 1
			count(1)  = 73
	     
			status = he5_swwrfld(swid, "Time", start, stride,
     1           count, tme)

			start(1) = 0
                        stride(1) = 1
                        count(1)  = 10
                        status = he5_swwrfld(swid, "test_string", start, 
     1           stride, count, charfield)

c     Write Spectra one plane at a time 
c     Value is 100 * track index + band index (0-based)
c     -------------------------------------------------
			start(1)  = 0
			start(2)  = 0
			count(1)  = 20
			count(2)  = 40
			count(3)  = 1
			stride(3) = 1
	    
			do i=1,15
			   start(3) = i - 1
			   do j=1,40
				  do k=1,20
					 plane((j-1)*20+k) = (j-1)*100 + i-1
				  enddo
			   enddo
			   status = he5_swwrfld(swid,"Spectra",start,
     1              stride,count,plane)
			enddo

c     Populate data buffer and write data to the Profile Field
c     --------------------------------------------------------
      datasize = 0
      counter  = 0
      do i=1,4

         len(i)    = i*25
         datasize  = datasize + len(i)
         do j=1,(25*i)
            counter = counter + 1
            buffer(counter) = (i)*1000 + j - 1
         enddo
      enddo

      start(1)  = 0
      count(1)  = 4
      stride(1) = 1

      status = he5_prwrite(swid,"Profile-2000",start,stride,count,
     1datasize,len,buffer)
      write(*,*) 'Status returned by he5_prwrite():  ',status
			
c     Write User defined Attribute
c     ----------------------------
			attr(1)  = 3
			attr(2)  = 5
			attr(3)  = 7
			attr(4)  = 11
            count(1) = 4
			status = he5_swwrattr(swid,"TestAttr",HE5T_NATIVE_INT,
     1           count,attr)

c     Write Global Attribute
c     ----------------------
			attr4 = "ABCDEFGH"
			count(1) = 8
			status = he5_swwrattr(swid,"GLOBAL_CHAR_ATTR",HE5T_NATIVE_CHAR,
	1	count,attr4)

			attr4 = "111"
			count(1) = 3		
			status = he5_swwrgattr(swid,"GLOBAL_CHAR_ATTR_1",HE5T_NATIVE_CHAR,
	1	count,attr4)

			attr4 = "222222"
			count(1) = 6
			status = he5_ehwrglatt(swfid,"GLOBAL_CHAR_ATTR_2",HE5T_NATIVE_CHAR,
	1	count,attr4)

c     Write Local Attribute
c     ---------------------
			attr5 = "abababababababababab"
			count(1) = 20
			status = he5_swwrlattr(swid,"Density","LocalAttribute_0",
	1	HE5T_NATIVE_CHAR,count,attr5)

	      
		 endif
	  endif
	  
c     Detach from the swath
c     ---------------------
      status = he5_swdetach(swid)
      write(*,*) 'Status returned by he5_swdetach():  ',status

c     Close the file
c     --------------
      status = he5_swclose(swfid)
      write(*,*) 'Status returned by he5_swclose():  ',status
	  
      stop
      end

c
c	In this program we (1) open the "swath.he5" HDF-EOS file, (2)
c	attach to the "Swath1" swath, and (3) define the external 
c   data field "ExtData".
c

      program     he5_sw_defexternalfldF_64

      implicit    none
 
      include     'hdfeos5.inc'

      integer     status
      integer     he5_swopen
      integer     he5_swattach
      integer     he5_swdefdfld
      integer     he5_swdetach
      integer     he5_swclose
      integer     he5_swsetxdat
      integer     swfid, swid

      integer*8   offset(3), size(3)

      integer     FAIL
      parameter   (FAIL=-1)


c     Open the HDF-EOS file, "swath.he5" using "READ/WRITE" access code
c     -----------------------------------------------------------------
      swfid = he5_swopen("swath.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_swopen():  ',swfid
      if (swfid .NE. FAIL) then

      swid = he5_swattach(swfid, "Swath1")
      write(*,*) 'Swath ID returned by he5_swattach():  ',swid
      if (swid .NE. FAIL) then

      offset(1) = 0 
      size(1)   = 40

      offset(2) = 40
      size(2)   = 80

      offset(3) = 80
      size(3)   = 120

      status = he5_swsetxdat(swid, "extf1.dat,extf2.dat,extf3.dat",
     1offset, size)
      write(*,*) 'Status returned by he5_swsetxdat():  ',status
      
      status = he5_swdefdfld(swid, "ExtData", "ExtDim",
     1" ", HE5T_NATIVE_INT, 0)
      write(*,*) 'Status returned by he5_swdefdfld():  ',status

      endif
      endif

c     Detach from the swath
c     ---------------------      
      status = he5_swdetach(swid)
      write(*,*) 'Status returned by he5_swdetach():  ',status

c     Close the file
c     --------------      
      status = he5_swclose(swfid)
      write(*,*) 'Status returned by he5_swclose():  ',status

      stop
      end

c----------------------------------------------------------------------------
c       FILE:     testpoint64.f                                               
c       PURPOSE:  To test HDF-EOS5 Point interface              
c       Author:   C. Praderas, Emergent IT Inc.         
c       Date:     June 2001                              
c----------------------------------------------------------------------------

      program       he5_pttestpoint64

      implicit      none

      include       'hdfeos5.inc'

      integer       status 
      integer       ptfid 
      integer       ptid1, ptid2, ptid3
      integer       ptid
      integer       rank_1(3)
      integer       rank_2(5)
      integer       rank_3(4)
      integer       rank_4(4)
      integer       rank_5(6)
      integer       dtype_1(3)
      integer       dtype_2(5)
      integer       dtype_3(4)
      integer       dtype_4(4)
      integer       dtype_5(6)
      integer       array_1(3)
      integer       array_2(5)
      integer       array_3(4)
      integer       array_4(4)
      integer       array_5(6)
      integer       i, zero
      integer       rank
      integer       datatype
      integer       attr
      integer       nflds
      integer       level
      integer       arr_rank
      integer       dtype(3)
      integer       nrecs
      integer       nlevels
      integer       attr1(5)
      integer       attr2(5)
      integer       ntype
      integer       classid
      integer       order
      integer       fieldgroup
      integer       rank_tt(3)
      integer       dtype_tt(3)
      integer       he5_ptopen
      integer       he5_ptcreate
      integer       he5_ptdetach
      integer       he5_ptclose
      integer       he5_ptattach
      integer       he5_ptdeflevel 
      integer       he5_ptdeflinkage 
      integer       he5_ptwritelevel 
      integer       he5_ptfort2c
      integer       he5_ptwrbckptr
      integer       he5_ptwrfwdptr
      integer       he5_ptwriteattr 
      integer       he5_ptreadlevel
      integer       he5_ptlevelinfo 
      integer       he5_ptnrecs
      integer       he5_ptnlevels
      integer       he5_ptnfields
      integer       he5_ptc2fort
      integer       he5_ptinqattrs
      integer       he5_ptreadattr
      integer       he5_ptupdatelevel 
      integer       he5_ptwritegrpattr
      integer       he5_ptwritelocattr
      integer       he5_ptinqgrpattrs
      integer       he5_ptinqlocattrs
      integer       he5_ptattrinfo
      integer       he5_ptgrpattrinfo
      integer       he5_ptlocattrinfo
      integer       he5_ptreadgrpattr
      integer       he5_ptreadlocattr
      integer       he5_ptinqdatatype

      integer*8     dims_1(3,1)
      integer*8     dims_2(5,1)
      integer*8     dims_3(4,1)
      integer*8     dims_4(4,1)
      integer*8     dims_5(6,1)
      integer*8     n
      integer*8     count(1)
      integer*8     dimens(2)
      integer*8     fortcount(8)
      integer*8     datasize
      integer*8     offset_tt(3)
      integer*8     dim_sizes_tt(3)
      integer*8     nattr
      integer*8     strbufsize
      integer*8     recs(32)
      integer*8     nrec
      integer*8     sz
      integer*8     size

      integer*4     date_tt
      integer*4     date(3)
      integer*4     date4_tt
      integer*4     date4(3)
      integer*4     wgt_tt
      integer*4     wgt(3)

      real*4        flt      
      real*4        concentration_tt(4)
      real*4        conc(15,4)
      real*4        outconc(4,15)
      real*4        rain_tt
      real*4        rain(20)
      real*4        temp_tt
      real*4        temp(20)
      real*4        rain5_tt
      real*4        rain5(25)
      real*4        temp5_tt
      real*4        temp5(25)
      real*4        con(4,15)
      real*4        outcon(15,4)
      real*4        conc_tt(4)

      real*8        time_tt
      real*8        time(15)
      real*8        lon_tt
      real*8        lon(3)
      real*8        lat_tt
      real*8        lat(3)
      real*8        time3_tt
      real*8        time3(20)
      real*8        time5_tt
      real*8        time5(25)
      real*8        lon5_tt
      real*8        lon5(25)
      real*8        lat5_tt
      real*8        lat5(25)
 
      character*240 fieldlist1
      character*240 fieldlist2
      character*240 fieldlist3
      character*240 fieldlist4
      character*240 fieldlist5
      character*80  levelname
      character*20  parent
      character*20  child
      character*20  linkfield
      character*80  fieldname
      character*80  attrname
      character*8   spc_tt
      character*8   spc(15)
      character*8   desc_tt
      character*8   desc(3)
      character*8   id_tt
      character*8   id(3)
      character*8   id3_tt
      character*8   id3(20)
      character*8   desc4_tt
      character*8   desc4(3)
      character*8   id4_tt
      character*8   id4(3)
      character*8   id5_tt
      character*8   id5(25)
      character*80  fieldname3(3)
      character*240 fieldlist
      character*240 attrlist
      character*8   spec(15)
      character*1   null_char_0

      open(unit=1, file="testpoint64_f.txtout", status = "UNKNOWN")

      write(*,*)' '
      write(1,*)' '
      write(*,*)'Testing he5_ptath FORTRAN 77 interface'
      write(*,*)'======================================'
      write(1,*)'Testing he5_ptath FORTRAN 77 interface'
      write(1,*)'======================================'
      write(*,*)' '
      write(1,*)' '

      zero=0

c Test Case -- he5_ptopen
c
      write(*,*)'Testing he5_ptopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptopen '
      write(1,*)'====================='
      ptfid = he5_ptopen('point.he5',HE5F_ACC_TRUNC) 
      if (ptfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_TRUNC)'
         write(*,*)'	Value returned by he5_ptopen ', ptfid
         write(1,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_TRUNC)'
         write(1,*)'	Value returned by he5_ptopen ', ptfid
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptcreate
c
      write(*,*)'Testing he5_ptcreate '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptcreate '
      write(1,*)'====================='
      ptid1 = he5_ptcreate(ptfid, "Simple Point")
      if (ptid1 .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid1 = he5_ptcreate(ptfid, "Simple Point")'
         write(*,*)'	Value returned by he5_ptcreate ', ptid1
         write(1,*)'	ptid1 = he5_ptcreate(ptfid, "Simple Point")'
         write(1,*)'	Value returned by he5_ptcreate ', ptid1
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptcreate
c
      write(*,*)'Testing he5_ptcreate '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptcreate '
      write(1,*)'====================='
      ptid2 = he5_ptcreate(ptfid, "FixedBuoy Point")
      if (ptid2 .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid2 = he5_ptcreate(ptfid, "FixedBuoy Point")'
         write(*,*)'	Value returned by he5_ptcreate ', ptid2
         write(1,*)'	ptid2 = he5_ptcreate(ptfid, "FixedBuoy Point")'
         write(1,*)'	Value returned by he5_ptcreate ', ptid2
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptcreate
c
      write(*,*)'Testing he5_ptcreate '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptcreate '
      write(1,*)'====================='
      ptid3 = he5_ptcreate(ptfid, "FloatBuoy Point")
      if (ptid3 .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid3 = he5_ptcreate(ptfid, "FloatBuoy Point")'
         write(*,*)'	Value returned by he5_ptcreate ', ptid3
         write(1,*)'	ptid3 = he5_ptcreate(ptfid, "FloatBuoy Point")'
         write(1,*)'	Value returned by he5_ptcreate ', ptid3
      endif
      write(*,*)' '
      write(1,*)' '



c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid1)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid1)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid1)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid2)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid2)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid3)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid3)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid3)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptclose
c
      write(*,*)'Testing he5_ptclose '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptclose '
      write(1,*)'====================='
      status = he5_ptclose(ptfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptclose(ptfid)'
         write(*,*)'	Value returned by he5_ptclose ', status
         write(1,*)'	status = he5_ptclose(ptfid)'
         write(1,*)'	Value returned by he5_ptclose ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptopen
c
      write(*,*)'Testing he5_ptopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptopen '
      write(1,*)'====================='
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDWR) 
      if (ptfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDWR)'
         write(*,*)'	Value returned by he5_ptopen ', ptfid
         write(1,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDWR)'
         write(1,*)'	Value returned by he5_ptopen ', ptfid
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "Simple Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "Simple Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "Simple Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '


c     Populate input information structure 
c     ------------------------------------ 

      levelname = 'Sensor'

      rank_1(1)  = 1
      rank_1(2)  = 1
      rank_1(3)  = 1

      fieldlist1 = 'Time,Concentration,Species'

      dtype_1(1)     =  HE5T_NATIVE_DOUBLE
      dtype_1(2)     =  HE5T_NATIVE_FLOAT
      dtype_1(3)     =  HE5T_NATIVE_CHAR

      array_1(1)     =  0
      array_1(2)     =  1
      array_1(3)     =  1

      dims_1(1,1)      =  1
      dims_1(2,1)      =  4
      dims_1(3,1)      =  8

c Test Case -- he5_ptdeflevel
c
      write(1,27)
      write(*,*)'Testing he5_ptdeflevel '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdeflevel '
      write(1,*)'====================='
      status = he5_ptdeflevel(ptid, levelname, rank_1, fieldlist1,
     1dims_1, dtype_1, array_1)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdeflevel(ptid, levelname, rank_1'
         write(*,*)'             fieldlist1,dims_1, dtype_1, array_1)'
         write(*,*)'	Value returned by he5_ptdeflevel ', status
         write(1,*)'	status = he5_ptdeflevel(ptid, levelname, rank_1'
         write(1,*)'             fieldlist1,dims_1, dtype_1, array_1)'
         write(1,*)'	Value returned by he5_ptdeflevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '


c     Populate input information structure 
c     ------------------------------------ 

      levelname = 'Desc-Loc'

      rank_2(1)  = 1
      rank_2(2)  = 1
      rank_2(3)  = 1
      rank_2(4)  = 1
      rank_2(5)  = 1

      fieldlist2 = 'Label,Longitude,Latitude,DeployDate,ID'

      dtype_2(1)     =  HE5T_NATIVE_CHAR
      dtype_2(2)     =  HE5T_NATIVE_DOUBLE
      dtype_2(3)     =  HE5T_NATIVE_DOUBLE
      dtype_2(4)     =  HE5T_NATIVE_INT
      dtype_2(5)     =  HE5T_NATIVE_CHAR

      array_2(1)  = 1
      array_2(2)  = 0
      array_2(3)  = 0
      array_2(4)  = 0
      array_2(5)  = 1

      dims_2(1,1)      =  8
      dims_2(2,1)      =  1
      dims_2(3,1)      =  1
      dims_2(4,1)      =  1
      dims_2(5,1)      =  8


c Test Case -- he5_ptdeflevel
c
      write(1,27)
      write(*,*)'Testing he5_ptdeflevel '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdeflevel '
      write(1,*)'====================='
      status = he5_ptdeflevel(ptid, levelname, rank_2, fieldlist2,
     1dims_2, dtype_2, array_2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdeflevel(ptid, levelname, rank_2'
         write(*,*)'             fieldlist2,dims_2, dtype_2, array_2)'
         write(*,*)'	Value returned by he5_ptdeflevel ', status
         write(1,*)'	status = he5_ptdeflevel(ptid, levelname, rank_2'
         write(1,*)'             fieldlist2,dims_2, dtype_2, array_2)'
         write(1,*)'	Value returned by he5_ptdeflevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

c     Populate input information structure 
c     ------------------------------------ 

      levelname = 'Observations'

      rank_3(1)  = 1
      rank_3(2)  = 1
      rank_3(3)  = 1
      rank_3(4)  = 1

      fieldlist3 = 'Time,Rainfall,Temperature,ID'

      dtype_3(1)     =  HE5T_NATIVE_DOUBLE
      dtype_3(2)     =  HE5T_NATIVE_FLOAT
      dtype_3(3)     =  HE5T_NATIVE_FLOAT
      dtype_3(4)     =  HE5T_NATIVE_CHAR

      array_3(1)  = 0
      array_3(2)  = 0
      array_3(3)  = 0
      array_3(4)  = 1

      dims_3(1,1)      =  1
      dims_3(2,1)      =  1
      dims_3(3,1)      =  1
      dims_3(4,1)      =  8

c Test Case -- he5_ptdeflevel
c
      write(1,27)
      write(*,*)'Testing he5_ptdeflevel '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptdeflevel '
      write(1,*)'======================'
      status = he5_ptdeflevel(ptid, levelname, rank_3, fieldlist3,
     1dims_3, dtype_3, array_3)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdeflevel(ptid, levelname, rank_3'
         write(*,*)'             fieldlist3,dims_3, dtype_3, array_3)'
         write(*,*)'	Value returned by he5_ptdeflevel ', status
         write(1,*)'	status = he5_ptdeflevel(ptid, levelname, rank_3'
         write(1,*)'             fieldlist3,dims_3, dtype_3, array_3)'
         write(1,*)'	Value returned by he5_ptdeflevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

      parent    = 'Desc-Loc'
      child     = 'Observations'
      linkfield = 'ID'

c Test Case -- he5_ptdeflinkage
c
      write(*,*)'Testing he5_ptdeflinkage '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptdeflinkage '
      write(1,*)'========================'
      status = he5_ptdeflinkage(ptid, parent, child, linkfield)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdeflinkage(ptid, parent, child,'
         write(*,*)'	         linkfield)'
         write(*,*)'	Value returned by he5_ptdeflinkage ', status
         write(1,*)'	status = he5_ptdeflinkage(ptid, parent, child,'
         write(1,*)'	         linkfield)'
         write(1,*)'	Value returned by he5_ptdeflinkage ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "FloatBuoy Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "FloatBuoy Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "FloatBuoy Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '


      levelname = 'Description'

      rank_4(1)  = 1
      rank_4(2)  = 1
      rank_4(3)  = 1
      rank_4(4)  = 1

      fieldlist4 = 'Label,DeployDate,Weight,ID'

      dtype_4(1)     =  HE5T_NATIVE_CHAR
      dtype_4(2)     =  HE5T_NATIVE_INT
      dtype_4(3)     =  HE5T_NATIVE_INT
      dtype_4(4)     =  HE5T_NATIVE_CHAR

      array_4(1)  = 1
      array_4(2)  = 0
      array_4(3)  = 0
      array_4(4)  = 1

      dims_4(1,1)      =  8
      dims_4(2,1)      =  1
      dims_4(3,1)      =  1
      dims_4(4,1)      =  8

c Test Case -- he5_ptdeflevel
c
      write(1,27)
      write(*,*)'Testing he5_ptdeflevel '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdeflevel '
      write(1,*)'====================='
      status = he5_ptdeflevel(ptid, levelname, rank_4, fieldlist4,
     1dims_4, dtype_4, array_4)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdeflevel(ptid, levelname, rank_4'
         write(*,*)'             fieldlist4,dims_4, dtype_4, array_4)'
         write(*,*)'	Value returned by he5_ptdeflevel ', status
         write(1,*)'	status = he5_ptdeflevel(ptid, levelname, rank_4'
         write(1,*)'             fieldlist4,dims_4, dtype_4, array_4)'
         write(1,*)'	Value returned by he5_ptdeflevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

      levelname = 'Measurements'

      rank_5(1)  = 1
      rank_5(2)  = 1
      rank_5(3)  = 1
      rank_5(4)  = 1
      rank_5(5)  = 1
      rank_5(6)  = 1

      fieldlist5 = 'Time,Longitude,Latitude,Rainfall,Temperature,ID'

      dtype_5(1)     =  HE5T_NATIVE_DOUBLE
      dtype_5(2)     =  HE5T_NATIVE_DOUBLE
      dtype_5(3)     =  HE5T_NATIVE_DOUBLE
      dtype_5(4)     =  HE5T_NATIVE_FLOAT
      dtype_5(5)     =  HE5T_NATIVE_FLOAT
      dtype_5(6)     =  HE5T_NATIVE_CHAR

      array_5(1)  = 0
      array_5(2)  = 0
      array_5(3)  = 0
      array_5(4)  = 0
      array_5(5)  = 0
      array_5(6)  = 1

      dims_5(1,1)      =  1
      dims_5(2,1)      =  1
      dims_5(3,1)      =  1
      dims_5(4,1)      =  1
      dims_5(5,1)      =  1
      dims_5(6,1)      =  8


c Test Case -- he5_ptdeflevel
c
      write(1,27)
      write(*,*)'Testing he5_ptdeflevel '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdeflevel '
      write(1,*)'====================='
      status = he5_ptdeflevel(ptid, levelname, rank_5, fieldlist5,
     1dims_5, dtype_5, array_5)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdeflevel(ptid, levelname, rank_5'
         write(*,*)'             fieldlist5,dims_5, dtype_5, array_5)'
         write(*,*)'	Value returned by he5_ptdeflevel ', status
         write(1,*)'	status = he5_ptdeflevel(ptid, levelname, rank_5'
         write(1,*)'             fieldlist5,dims_5, dtype_5, array_5)'
         write(1,*)'	Value returned by he5_ptdeflevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

      parent    = 'Description'
      child     = 'Measurements'
      linkfield = 'ID'

c Test Case -- he5_ptdeflinkage
c
      write(*,*)'Testing he5_ptdeflinkage '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdeflinkage '
      write(1,*)'====================='
      status = he5_ptdeflinkage(ptid, parent, child, linkfield)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdeflinkage(ptid, parent, child,'
         write(*,*)'	         linkfield)'
         write(*,*)'	Value returned by he5_ptdeflinkage ', status
         write(1,*)'	status = he5_ptdeflinkage(ptid, parent, child,'
         write(1,*)'	         linkfield)'
         write(1,*)'	Value returned by he5_ptdeflinkage ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptclose
c
      write(*,*)'Testing he5_ptclose '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptclose '
      write(1,*)'====================='
      status = he5_ptclose(ptfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptclose(ptfid)'
         write(*,*)'	Value returned by he5_ptclose ', status
         write(1,*)'	status = he5_ptclose(ptfid)'
         write(1,*)'	Value returned by he5_ptclose ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptopen
c
      write(*,*)'Testing he5_ptopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptopen '
      write(1,*)'====================='
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDWR) 
      if (ptfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDWR)'
         write(*,*)'	Value returned by he5_ptopen ', ptfid
         write(1,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDWR)'
         write(1,*)'	Value returned by he5_ptopen ', ptfid
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "Simple Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "Simple Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "Simple Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

c     Read Simple Point 
c     ----------------- 
      open(unit=10, file='simple.txt', status='OLD')

      n = 0
      do 10 i=1,1000
         read(10, 110, end=100) time_tt, concentration_tt(1), 
     1                                  concentration_tt(2), 
     2                                  concentration_tt(3),
     3                                  concentration_tt(4), 
     4                                  spc_tt
         time(i)     = time_tt
         conc(i,1)   = concentration_tt(1)
         conc(i,2)   = concentration_tt(2)
         conc(i,3)   = concentration_tt(3)
         conc(i,4)   = concentration_tt(4)
         spc(i)      = spc_tt

         n = n + 1
   10 continue

  100 close(unit=10)
  110 format(F13.1,F6.2,F6.2,F6.2,F6.2,2X,A8)

      count(1) = n

      fieldname      = 'Time'
      datatype       = HE5T_NATIVE_DOUBLE


c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, time)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, time)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, time)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


   
c.....Convert array to 'C' order
      dimens(1) = 15
      dimens(2) = 4
      rank      = 2
      datatype  = HE5T_NATIVE_FLOAT

c Test Case -- he5_ptfort2c
c
      write(1,27)
      write(*,*)'Testing he5_ptfort2c '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptfort2c '
      write(1,*)'====================='
      status    = he5_ptfort2c(dimens, rank, datatype, conc, 
     1outconc)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptfort2c(dimens,rank,datatype,conc,'
         write(*,*)'	         outconc)'
         write(*,*)'	Value returned by he5_ptfort2c ', status
         write(1,*)'	status = he5_ptfort2c(dimens,rank,datatype,conc,'
         write(1,*)'	         outconc)'
         write(1,*)'	Value returned by he5_ptfort2c ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Concentration'

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, outconc)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, outconc)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, outconc)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Species'
      datatype       = HE5T_NATIVE_CHAR

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, spc)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

c     Read FixedBuoy Point 
c     -------------------- 
      open(unit=11, file='fixedBuoy0.txt', status='OLD')

      n = 0
      do 20 i=1,1000
         read(11, 210, end=200) desc_tt, lon_tt, lat_tt, date_tt, 
     1id_tt
         desc(i)     = desc_tt
         lon(i)      = lon_tt
         lat(i)      = lat_tt
         date(i)     = date_tt
         id(i)       = id_tt

         n = n + 1
   20 continue

  200 close(unit=11)
  210 format(A8,F13.7,F13.7,I7,1X,A8)

      count(1) = n

      fieldname      = 'Label'
      datatype       = HE5T_NATIVE_CHAR

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, desc)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, desc)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, desc)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Longitude'
      datatype       = HE5T_NATIVE_DOUBLE

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, lon)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, lon)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, lon)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Latitude'
      datatype       = HE5T_NATIVE_DOUBLE


c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, lat)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, lat)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, lat)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'DeployDate'
      datatype       = HE5T_NATIVE_INT

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype,  date)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype,  date)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype,  date)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'ID'
      datatype       = HE5T_NATIVE_CHAR

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, id)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, id)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, id)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


c     Read FixedBuoy Point - Level 1
c     ------------------------------ 
      open(unit=12, file='fixedBuoy1.txt', status='OLD')

      n = 0
      do 30 i=1,1000
         read(12, 310, end=300) time3_tt, rain_tt, temp_tt, id3_tt 
         time3(i)     = time3_tt
         rain(i)      = rain_tt
         temp(i)      = temp_tt
         id3(i)       = id3_tt

         n = n + 1
   30 continue

  300 close(unit=12)
  310 format(F13.2,F8.1,F8.2,3X,A8)

      count(1) = n

      fieldname      = 'Time'
      datatype       = HE5T_NATIVE_DOUBLE

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, time3)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, time3)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'	         fieldname,datatype, time3)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Rainfall'
      datatype       = HE5T_NATIVE_FLOAT

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, rain)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, rain)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'	         fieldname,datatype, rain)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Temperature'
      datatype       = HE5T_NATIVE_FLOAT

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, temp)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, temp)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'	         fieldname,datatype, temp)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

      fieldname      = 'ID'
      datatype       = HE5T_NATIVE_CHAR

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, id3)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, id3)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'	         fieldname,datatype, id3)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptwrbckptr
c
      write(1,27)
      write(*,*)'Testing he5_ptwrbckptr '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptwrbckptr '
      write(1,*)'====================='
      status = he5_ptwrbckptr(ptid,1)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptwrbckptr(ptid,1)'
         write(*,*)'	Value returned by he5_ptwrbckptr ', status
         write(1,*)'	status = he5_ptwrbckptr(ptid,1)'
         write(1,*)'	Value returned by he5_ptwrbckptr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptwrfwdptr
c
      write(1,27)
      write(*,*)'Testing he5_ptwrfwdptr '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptwrfwdptr '
      write(1,*)'====================='
      status = he5_ptwrfwdptr(ptid,1)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptwrfwdptr(ptid,1)'
         write(*,*)'	Value returned by he5_ptwrfwdptr ', status
         write(1,*)'	status = he5_ptwrfwdptr(ptid,1)'
         write(1,*)'	Value returned by he5_ptwrfwdptr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c     Write attributes to "Fixed Buoy Point"
c     --------------------------------------
      attrname       = 'GlobalAttribute_int'
      ntype          = HE5T_NATIVE_INT
      fortcount(1)   = 1
      attr           = 9999 

c Test Case -- he5_ptwriteattr
c
      write(1,27)
      write(*,*)'Testing he5_ptwriteattr '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptwriteattr '
      write(1,*)'====================='
      status   = he5_ptwriteattr(ptid,attrname,ntype,fortcount,
     1attr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptwriteattr(ptid,attrname,'
         write(*,*)'	           ntype,fortcount,attr)'
         write(*,*)'	Value returned by he5_ptwriteattr ', status
         write(1,*)'	status   = he5_ptwriteattr(ptid,attrname,'
         write(1,*)'	           ntype,fortcount,attr)'
         write(1,*)'	Value returned by he5_ptwriteattr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "FloatBuoy Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "FloatBuoy Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "FloatBuoy Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

c     Read FloatBuoy Point - Level 0
c     ------------------------------ 
      open(unit=14, file='floatBuoy0.txt', status='OLD')

      n = 0
      do 40 i=1,1000
         read(14, 410, end=400) desc4_tt, date4_tt, wgt_tt, id4_tt 
         desc4(i)     = desc4_tt
         date4(i)     = date4_tt
         wgt(i)       = wgt_tt
         id4(i)       = id4_tt

         n = n + 1
   40 continue

  400 close(unit=14)
  410 format(A8,I8,I7,2X,A8)

      count(1) = n

      fieldname      = 'Label'
      datatype       = HE5T_NATIVE_CHAR

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, desc4)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, desc4)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, desc4)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'DeployDate'
      datatype       = HE5T_NATIVE_INT

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, date4)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, date4)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, date4)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Weight'
      datatype       = HE5T_NATIVE_INT

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, wgt)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, wgt)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, wgt)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'ID'
      datatype       = HE5T_NATIVE_CHAR

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, id4)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(*,*)'	         fieldname,datatype, id4)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,0,count,'
         write(1,*)'	         fieldname,datatype, id4)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


c     Read FixedBuoy Point - Level 1
c     ------------------------------ 
      open(unit=15, file='floatBuoy1.txt', status='OLD')

      n = 0
      do 50 i=1,1000
         read(15, 510, end=500) time5_tt, lon5_tt, lat5_tt,  
     1rain5_tt,temp5_tt,id5_tt
         time5(i)     = time5_tt
         lon5(i)      = lon5_tt
         lat5(i)      = lat5_tt
         rain5(i)     = rain5_tt
         temp5(i)     = temp5_tt
         id5(i)       = id5_tt

         n = n + 1
   50 continue

  500 close(unit=15)
  510 format(F13.1,F13.6,F13.6,F8.1,F8.2,3X,A8)

      count(1) = n

      fieldname      = 'Time'
      datatype       = HE5T_NATIVE_DOUBLE

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, time5)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, time5)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'	         fieldname,datatype, time5)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Longitude'
      datatype       = HE5T_NATIVE_DOUBLE

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, lon5)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, lon5)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'	         fieldname,datatype, lon5)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Latitude'
      datatype       = HE5T_NATIVE_DOUBLE

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, lat5)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, lat5)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'	         fieldname,datatype, lat5)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Rainfall'
      datatype       = HE5T_NATIVE_FLOAT

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, rain5)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, rain5)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'             fieldname,datatype, rain5)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'Temperature'
      datatype       = HE5T_NATIVE_FLOAT

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, temp5)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, temp5)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'	         fieldname,datatype, temp5)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname      = 'ID'
      datatype       = HE5T_NATIVE_CHAR

c Test Case -- he5_ptwritelevel
c
      write(1,27)
      write(*,*)'Testing he5_ptwritelevel '
      write(*,*)'========================'
      write(1,*)'Testing he5_ptwritelevel '
      write(1,*)'========================'
      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, id5)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(*,*)'	         fieldname,datatype, id5)'
         write(*,*)'	Value returned by he5_ptwritelevel ', status
         write(1,*)'    status = he5_ptwritelevel(ptid,1,count,'
         write(1,*)'	         fieldname,datatype, id5)'
         write(1,*)'	Value returned by he5_ptwritelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptwrbckptr
c
      write(*,*)'Testing he5_ptwrbckptr '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptwrbckptr '
      write(1,*)'======================'
      status = he5_ptwrbckptr(ptid,1)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptwrbckptr(ptid,1)'
         write(*,*)'	Value returned by he5_ptwrbckptr ', status
         write(1,*)'	status = he5_ptwrbckptr(ptid,1)'
         write(1,*)'	Value returned by he5_ptwrbckptr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptwrfwdptr
c
      write(*,*)'Testing he5_ptwrfwdptr '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptwrfwdptr '
      write(1,*)'======================'
      status = he5_ptwrfwdptr(ptid,1)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptwrfwdptr(ptid,1)'
         write(*,*)'	Value returned by he5_ptwrfwdptr ', status
         write(1,*)'	status = he5_ptwrfwdptr(ptid,1)'
         write(1,*)'	Value returned by he5_ptwrfwdptr ', status
      endif
      write(*,*)' '
      write(1,*)' '



c     Write attributes to "Float Buoy Point"
c     --------------------------------------
      attrname       = 'GlobalAttribute_float'
      ntype          = HE5T_NATIVE_FLOAT
      fortcount(1)   = 1
      flt            = -7.5

c Test Case -- he5_ptwriteattr
c
      write(*,*)'Testing he5_ptwriteattr '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptwriteattr '
      write(1,*)'======================'
      status   = he5_ptwriteattr(ptid,attrname,
     1ntype,fortcount,flt)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptwriteattr(ptid,attrname,'
         write(*,*)'	           ntype,fortcount,flt)'
         write(*,*)'	Value returned by he5_ptwriteattr ', status
         write(1,*)'	status   = he5_ptwriteattr(ptid,attrname,'
         write(1,*)'	           ntype,fortcount,flt)'
         write(1,*)'	Value returned by he5_ptwriteattr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptclose
c
      write(*,*)'Testing he5_ptclose '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptclose '
      write(1,*)'====================='
      status = he5_ptclose(ptfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptclose(ptfid)'
         write(*,*)'	Value returned by he5_ptclose ', status
         write(1,*)'	status = he5_ptclose(ptfid)'
         write(1,*)'	Value returned by he5_ptclose ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptopen
c
      write(*,*)'Testing he5_ptopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptopen '
      write(1,*)'====================='
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDONLY) 
      if (ptfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDONLY)'
         write(*,*)'	Value returned by he5_ptopen ', ptfid
         write(1,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDONLY)'
         write(1,*)'	Value returned by he5_ptopen ', ptfid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "Simple Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "Simple Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "Simple Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

c     Get level information 
c     --------------------- 
      level = 0

c Test Case -- he5_ptlevelinfo
c
      write(*,*)'Testing he5_ptlevelinfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptlevelinfo '
      write(1,*)'====================='
      status = he5_ptlevelinfo(ptid, level, levelname, rank_tt,
     1fieldlist, dim_sizes_tt, datasize, offset_tt, dtype_tt)
      if (ptfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status=he5_ptlevelinfo(ptid,level,levelname,'
         write(*,*)'           rank_tt,fieldlist,dim_sizes_tt,'
         write(*,*)'           datasize,offset_tt,dtype_tt)'
         write(*,*)'	Value returned by he5_ptlevelinfo ', status
         write(1,*)'    status=he5_ptlevelinfo(ptid,level,levelname,'
         write(1,*)'           rank_tt,fieldlist,dim_sizes_tt,'
         write(1,*)'           datasize,offset_tt,dtype_tt)'
         write(1,*)'	Value returned by he5_ptlevelinfo ', status
      endif
      write(*,*)' '
      write(1,*)' '

c     Get the number of records in level
c     ---------------------------------- 
      level = 0

c Test Case -- he5_ptnrecs
c
      write(*,*)'Testing he5_ptnrecs '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptnrecs '
      write(1,*)'====================='
      nrecs = he5_ptnrecs(ptid, level)
      if (nrecs .le. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nrecs = he5_ptnrecs(ptid, level)'
         write(*,*)'	Value returned by he5_ptnrecs ', nrecs
         write(1,*)'	nrecs = he5_ptnrecs(ptid, level)'
         write(1,*)'	Value returned by he5_ptnrecs ', nrecs
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptnlevels
c
      write(*,*)'Testing he5_ptnlevels '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptnlevels '
      write(1,*)'====================='
      nlevels = he5_ptnlevels(ptid)
      if (nlevels .le. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nlevels = he5_ptnlevels(ptid)'
         write(*,*)'	Value returned by he5_ptnlevels ', nlevels
         write(1,*)'	nlevels = he5_ptnlevels(ptid)'
         write(1,*)'	Value returned by he5_ptnlevels ', nlevels
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptnfields
c
      write(*,*)'Testing he5_ptnfields '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptnfields '
      write(1,*)'====================='
      nflds = he5_ptnfields(ptid, level, fieldlist, strbufsize)
      if (nflds .le. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nflds = he5_ptnfields(ptid, level,'
         write(*,*)'	        fieldlist, strbufsize)'
         write(*,*)'	Value returned by he5_ptnfields ', nflds
         write(1,*)'	nflds = he5_ptnfields(ptid, level,'
         write(1,*)'	        fieldlist, strbufsize)'
         write(1,*)'	Value returned by he5_ptnfields ', nflds
      endif
      write(*,*)' '
      write(1,*)' '

c     Populate input information structure 
c     ------------------------------------ 
      dtype(1)     =  HE5T_NATIVE_DOUBLE
      dtype(2)     =  HE5T_NATIVE_FLOAT
      dtype(3)     =  HE5T_NATIVE_CHAR

c     Read the level data and print out
c     --------------------------------- 
      fieldname3(1)  = 'Time'

c Test Case -- he5_ptreadlevel
c
      write(*,*)'Testing he5_ptreadlevel '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptreadlevel '
      write(1,*)'====================='
      status = he5_ptreadlevel(ptid, 0, fieldname3(1), 
     1dtype(1), time)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptreadlevel(ptid, 0, fieldname3(1),'
         write(*,*)'	         dtype(1), time)'
         write(*,*)'	Value returned by he5_ptreadlevel ', status
         write(1,*)'	status = he5_ptreadlevel(ptid, 0, fieldname3(1),'
         write(1,*)'	         dtype(1), time)'
         write(1,*)'	Value returned by he5_ptreadlevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname3(2)  = 'Concentration'

c Test Case -- he5_ptreadlevel
c
      write(*,*)'Testing he5_ptreadlevel '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptreadlevel '
      write(1,*)'====================='
      status = he5_ptreadlevel(ptid, 0, fieldname3(2), 
     1dtype(2), con)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptreadlevel(ptid, 0, fieldname3(2),'
         write(*,*)'	         dtype(2), con)'
         write(*,*)'	Value returned by he5_ptreadlevel ', status
         write(1,*)'	status = he5_ptreadlevel(ptid, 0, fieldname3(2),'
         write(1,*)'	         dtype(2), con)'
         write(1,*)'	Value returned by he5_ptreadlevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

c     Convert 'C' array to Fortran order
c     ---------------------------------- 
      dimens(1) = 15
      dimens(2) = 4
      arr_rank  = 2
      datatype  = HE5T_NATIVE_FLOAT

ccc      status  = he5_ptc2fort(dimens, arr_rank, datatype, con, 
ccc     1outcon)
ccc      write(*,*) 'Status returned by he5_ptc2fort():  ',status

c Test Case -- he5_ptc2fort
c
      write(1,27)
      write(*,*)'Testing he5_ptc2fort '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptc2fort '
      write(1,*)'====================='
      status  = he5_ptc2fort(dimens, arr_rank, datatype, con, 
     1outcon)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'    status = he5_ptc2fort(dimens,arr_rank,'
         write(*,*)'	         datatype,con,outcon)'
         write(*,*)'	Value returned by he5_ptc2fort ', status
         write(1,*)'    status = he5_ptc2fort(dimens,arr_rank,'
         write(1,*)'	         datatype,con,outcon)'
         write(1,*)'	Value returned by he5_ptc2fort ', status
      endif
      write(*,*)' '
      write(1,*)' '


      fieldname3(3)  = 'Species'

c Test Case -- he5_ptreadlevel
c
      write(*,*)'Testing he5_ptreadlevel '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptreadlevel '
      write(1,*)'====================='
      status = he5_ptreadlevel(ptid, 0, fieldname3(3), 
     1dtype(3), spec)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptreadlevel(ptid, 0, fieldname3(3),'
         write(*,*)'	         dtype(3), spec)'
         write(*,*)'	Value returned by he5_ptreadlevel ', status
         write(1,*)'	status = he5_ptreadlevel(ptid, 0, fieldname3(3),'
         write(1,*)'	         dtype(3), spec)'
         write(1,*)'	Value returned by he5_ptreadlevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

      attrname       = 'GlobalAttribute_int'

      nattr   = he5_ptinqattrs(ptid,attrlist,strbufsize)

c Test Case -- he5_ptinqattrs
c
      write(*,*)'Testing he5_ptinqattrs '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptinqattrs '
      write(1,*)'======================'
      nattr   = he5_ptinqattrs(ptid,attrlist,strbufsize)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nattr   = he5_ptinqattrs(ptid,attrlist,strbufsize)'
         write(*,*)'	Value returned by he5_ptinqattrs ', nattr
         write(1,*)'	nattr   = he5_ptinqattrs(ptid,attrlist,strbufsize)'
         write(1,*)'	Value returned by he5_ptinqattrs ', nattr
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptreadattr
c
      write(*,*)'Testing he5_ptreadattr '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptreadattr '
      write(1,*)'======================'
      status   = he5_ptreadattr(ptid,attrname,attr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptreadattr(ptid,attrname,attr)'
         write(*,*)'	Value returned by he5_ptreadattr ', nattr
         write(1,*)'	status   = he5_ptreadattr(ptid,attrname,attr)'
         write(1,*)'	Value returned by he5_ptreadattr ', nattr
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptclose
c
      write(*,*)'Testing he5_ptclose '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptclose '
      write(1,*)'====================='
      status = he5_ptclose(ptfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptclose(ptfid)'
         write(*,*)'	Value returned by he5_ptclose ', status
         write(1,*)'	status = he5_ptclose(ptfid)'
         write(1,*)'	Value returned by he5_ptclose ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptopen
c
      write(*,*)'Testing he5_ptopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptopen '
      write(1,*)'====================='
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDWR) 
      if (ptfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDWR)'
         write(*,*)'	Value returned by he5_ptopen ', ptfid
         write(1,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDWR)'
         write(1,*)'	Value returned by he5_ptopen ', ptfid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "Simple Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "Simple Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "Simple Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

      dtype(1)     =  HE5T_NATIVE_DOUBLE
      dtype(2)     =  HE5T_NATIVE_FLOAT
      dtype(3)     =  HE5T_NATIVE_CHAR

      nrec      = 1
      recs(1)   = 0

      level     = 0

      fieldname = 'Concentration'

      conc_tt(1)   = 1.11
      conc_tt(2)   = 2.22
      conc_tt(3)   = 3.33
      conc_tt(4)   = 4.44

c Test Case -- he5_ptupdatelevel
c
      write(*,*)'Testing he5_ptupdatelevel '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptupdatelevel '
      write(1,*)'========================='
      status = he5_ptupdatelevel(ptid, level, fieldname, nrec,
     1recs, dtype(2), conc_tt)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptupdatelevel(ptid, level,'
         write(*,*)'	         fieldname, nrec, recs,'
         write(*,*)'	         dtype(2), conc_tt)'
         write(*,*)'	Value returned by he5_ptupdatelevel ', status
         write(1,*)'	status = he5_ptupdatelevel(ptid, level,'
         write(1,*)'	         fieldname, nrec, recs,'
         write(1,*)'	         dtype(2), conc_tt)'
         write(1,*)'	Value returned by he5_ptupdatelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

      fieldname = 'Time'

      time_tt   = 13131313.0

c Test Case -- he5_ptupdatelevel
c
      write(*,*)'Testing he5_ptupdatelevel '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptupdatelevel '
      write(1,*)'========================='
      status = he5_ptupdatelevel(ptid, level, fieldname, nrec,
     1recs, dtype(1), time_tt)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptupdatelevel(ptid, level,'
         write(*,*)'	         fieldname, nrec, recs,'
         write(*,*)'	         dtype(1), time_tt)'
         write(*,*)'	Value returned by he5_ptupdatelevel ', status
         write(1,*)'	status = he5_ptupdatelevel(ptid, level,'
         write(1,*)'	         fieldname, nrec, recs,'
         write(1,*)'	         dtype(1), time_tt)'
         write(1,*)'	Value returned by he5_ptupdatelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '

      fieldname = 'Species'

      spc_tt    = 'AM'

c Test Case -- he5_ptupdatelevel
c
      write(*,*)'Testing he5_ptupdatelevel '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptupdatelevel '
      write(1,*)'========================='
      status = he5_ptupdatelevel(ptid, level, fieldname, nrec,
     1recs, dtype(3), spc_tt)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptupdatelevel(ptid, level,'
         write(*,*)'	         fieldname, nrec, recs,'
         write(*,*)'	         dtype(3), spc_tt)'
         write(*,*)'	Value returned by he5_ptupdatelevel ', status
         write(1,*)'	status = he5_ptupdatelevel(ptid, level,'
         write(1,*)'	         fieldname, nrec, recs,'
         write(1,*)'	         dtype(3), spc_tt)'
         write(1,*)'	Value returned by he5_ptupdatelevel ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptclose
c
      write(*,*)'Testing he5_ptclose '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptclose '
      write(1,*)'====================='
      status = he5_ptclose(ptfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptclose(ptfid)'
         write(*,*)'	Value returned by he5_ptclose ', status
         write(1,*)'	status = he5_ptclose(ptfid)'
         write(1,*)'	Value returned by he5_ptclose ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptopen
c
      write(*,*)'Testing he5_ptopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptopen '
      write(1,*)'====================='
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDWR) 
      if (ptfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDWR)'
         write(*,*)'	Value returned by he5_ptopen ', ptfid
         write(1,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDWR)'
         write(1,*)'	Value returned by he5_ptopen ', ptfid
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

c     Write attributes to "Fixed Buoy Point"
c     --------------------------------------
      attrname       = 'GlobalAttribute_int'
      ntype          = HE5T_NATIVE_INT
      fortcount(1)   = 1
      attr           = 9999
             

c Test Case -- he5_ptwriteattr
c
      write(*,*)'Testing he5_ptwriteattr '
      write(*,*)'======================='
      write(1,*)'Testing he5_ptwriteattr '
      write(1,*)'======================='
      status   = he5_ptwriteattr(ptid,attrname,ntype,fortcount,
     1attr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptwriteattr(ptid,attrname,'
         write(*,*)'	           ntype,fortcount,attr)'
         write(*,*)'	Value returned by he5_ptwriteattr ', status
         write(1,*)'	status   = he5_ptwriteattr(ptid,attrname,'
         write(1,*)'	           ntype,fortcount,attr)'
         write(1,*)'	Value returned by he5_ptwriteattr ', status
      endif
      write(*,*)' '
      write(1,*)' '

      attrname       = 'GroupAttribute'
      ntype          = HE5T_NATIVE_INT
      fortcount(1)   = 5
      attr1(1)       = 1
      attr1(2)       = 2
      attr1(3)       = 3
      attr1(4)       = 4
      attr1(5)       = 5

c Test Case -- he5_ptwritegrpattr
c
      write(*,*)'Testing he5_ptwritegrpattr '
      write(*,*)'=========================='
      write(1,*)'Testing he5_ptwritegrpattr '
      write(1,*)'=========================='
      status   = he5_ptwritegrpattr(ptid,attrname,ntype,fortcount,
     1attr1)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptwritegrpattr(ptid,attrname,'
         write(*,*)'	           ntype,fortcount,attr1)'
         write(*,*)'	Value returned by he5_ptclose ', status
         write(1,*)'	status   = he5_ptwritegrpattr(ptid,attrname,'
         write(1,*)'	           ntype,fortcount,attr1)'
         write(1,*)'	Value returned by he5_ptclose ', status
      endif
      write(*,*)' '
      write(1,*)' '

      levelname      = 'Observations'
      attrname       = 'LocalAttribute'
      ntype          = HE5T_NATIVE_INT
      fortcount(1)   = 5
      attr2(1)       = 10
      attr2(2)       = 20
      attr2(3)       = 30
      attr2(4)       = 40
      attr2(5)       = 50

c Test Case -- he5_ptwritelocattr
c
      write(*,*)'Testing he5_ptwritelocattr '
      write(*,*)'=========================='
      write(1,*)'Testing he5_ptwritelocattr '
      write(1,*)'=========================='
      status   = he5_ptwritelocattr(ptid,levelname,attrname,
     1ntype,fortcount,attr2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptwritelocattr(ptid,'
         write(*,*)'	           levelname,attrname,ntype,'
         write(*,*)'	           fortcount,attr2)'
         write(*,*)'	Value returned by he5_ptwritelocattr ', status
         write(1,*)'	status   = he5_ptwritelocattr(ptid,'
         write(1,*)'	           levelname,attrname,ntype,'
         write(1,*)'	           fortcount,attr2)'
         write(1,*)'	Value returned by he5_ptwritelocattr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

      attrname       = 'GlobalAttribute_float'
      ntype          = HE5T_NATIVE_FLOAT
      fortcount(1)   = 1
      flt            = -7.5

c Test Case -- he5_ptwriteattr
c
      write(*,*)'Testing he5_ptwriteattr '
      write(*,*)'======================='
      write(1,*)'Testing he5_ptwriteattr '
      write(1,*)'======================='
      status   = he5_ptwriteattr(ptid,attrname,
     1ntype,fortcount,flt)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptwriteattr(ptid,attrname,'
         write(*,*)'	           ntype,fortcount,flt)'
         write(*,*)'	Value returned by he5_ptwriteattr ', status
         write(1,*)'	status   = he5_ptwriteattr(ptid,attrname,'
         write(1,*)'	           ntype,fortcount,flt)'
         write(1,*)'	Value returned by he5_ptwriteattr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptclose
c
      write(*,*)'Testing he5_ptclose '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptclose '
      write(1,*)'====================='
      status = he5_ptclose(ptfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptclose(ptfid)'
         write(*,*)'	Value returned by he5_ptclose ', status
         write(1,*)'	status = he5_ptclose(ptfid)'
         write(1,*)'	Value returned by he5_ptclose ', status
      endif
      write(*,*)' '
      write(1,*)' '


      null_char_0  = '0'

c Test Case -- he5_ptopen
c
      write(*,*)'Testing he5_ptopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptopen '
      write(1,*)'====================='
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDONLY) 
      if (ptfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDONLY)'
         write(*,*)'	Value returned by he5_ptopen ', ptfid
         write(1,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDONLY)'
         write(1,*)'	Value returned by he5_ptopen ', ptfid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

c     Global Attributes
c     -----------------
      attrname       = 'GlobalAttribute_int'
             
      print *,'Global Attribute:   '

c Test Case -- he5_ptreadattr
c
      write(*,*)'Testing he5_ptreadattr '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptreadattr '
      write(1,*)'======================'
      status   = he5_ptreadattr(ptid,attrname,attr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptreadattr(ptid,attrname,attr)'
         write(*,*)'	Value returned by he5_ptreadattr ', status
         write(1,*)'	status   = he5_ptreadattr(ptid,attrname,attr)'
         write(1,*)'	Value returned by he5_ptreadattr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptinqattrs
c
      write(*,*)'Testing he5_ptinqattrs '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptinqattrs '
      write(1,*)'======================'
      nattr   = he5_ptinqattrs(ptid,null_char_0,strbufsize)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nattr   = he5_ptinqattrs(ptid,'
         write(*,*)'	          null_char_0,strbufsize)'
         write(*,*)'	Value returned by he5_ptinqattrs ', nattr
         write(1,*)'	nattr   = he5_ptinqattrs(ptid,'
         write(1,*)'	          null_char_0,strbufsize)'
         write(1,*)'	Value returned by he5_ptinqattrs ', nattr
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptinqattrs
c
      write(*,*)'Testing he5_ptinqattrs '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptinqattrs '
      write(1,*)'======================'
      nattr   = he5_ptinqattrs(ptid,attrlist,strbufsize)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nattr   = he5_ptinqattrs(ptid,attrlist,strbufsize)'
         write(*,*)'	Value returned by he5_ptinqattrs ', nattr
         write(1,*)'	nattr   = he5_ptinqattrs(ptid,attrlist,strbufsize)'
         write(1,*)'	Value returned by he5_ptinqattrs ', nattr
      endif
      write(*,*)' '
      write(1,*)' '

      attrname       = 'GlobalAttribute_int'

c Test Case -- he5_ptattrinfo
c
      write(*,*)'Testing he5_ptattrinfo '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptattrinfo '
      write(1,*)'======================'
      status   = he5_ptattrinfo(ptid,attrname,ntype,sz)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptattrinfo(ptid,attrname,ntype,sz)'
         write(*,*)'	Value returned by he5_ptattrinfo ', status
         write(1,*)'	status   = he5_ptattrinfo(ptid,attrname,ntype,sz)'
         write(1,*)'	Value returned by he5_ptattrinfo ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptattrinfo
c
      write(*,*)'Testing he5_ptattrinfo '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptattrinfo '
      write(1,*)'======================'
      status   = he5_ptattrinfo(ptid,attrname,ntype,sz)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptattrinfo(ptid,attrname,ntype,sz)'
         write(*,*)'	Value returned by he5_ptattrinfo ', status
         write(1,*)'	status   = he5_ptattrinfo(ptid,attrname,ntype,sz)'
         write(1,*)'	Value returned by he5_ptattrinfo ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptreadattr
c
      write(*,*)'Testing he5_ptreadattr '
      write(*,*)'======================'
      write(1,*)'Testing he5_ptreadattr '
      write(1,*)'======================'
      status   = he5_ptreadattr(ptid,attrname,flt)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptreadattr(ptid,attrname,flt)'
         write(*,*)'	Value returned by he5_ptreadattr ', status
         write(1,*)'	status   = he5_ptreadattr(ptid,attrname,flt)'
         write(1,*)'	Value returned by he5_ptreadattr ', status
      endif
      write(*,*)' '
      write(1,*)' '

      attrname       = 'GroupAttribute'

c Test Case -- he5_ptreadgrpattr
c
      write(*,*)'Testing he5_ptreadgrpattr'
      write(*,*)'========================='
      write(1,*)'Testing he5_ptreadgrpattr'
      write(1,*)'========================='
      status = he5_ptreadgrpattr(ptid,attrname,attr1)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptreadgrpattr(ptid,attrname,attr1)'
         write(*,*)'	Value returned by he5_ptreadgrpattr ', status
         write(1,*)'	status = he5_ptreadgrpattr(ptid,attrname,attr1)'
         write(1,*)'	Value returned by he5_ptreadgrpattr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptinqgrpattrs
c
      write(*,*)'Testing he5_ptinqgrpattrs '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptinqgrpattrs '
      write(1,*)'========================='
      nattr = he5_ptinqgrpattrs(ptid,null_char_0,strbufsize)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nattr = he5_ptinqgrpattrs(ptid,'
         write(*,*)'	        null_char_0,strbufsize)'
         write(*,*)'	Value returned by he5_ptinqgrpattrs ', nattr
         write(1,*)'	nattr = he5_ptinqgrpattrs(ptid,'
         write(1,*)'	        null_char_0,strbufsize)'
         write(1,*)'	Value returned by he5_ptinqgrpattrs ', nattr
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptinqgrpattrs
c
      write(*,*)'Testing he5_ptinqgrpattrs '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptinqgrpattrs '
      write(1,*)'========================='
      nattr = he5_ptinqgrpattrs(ptid,attrlist,strbufsize)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nattr = he5_ptinqgrpattrs(ptid,'
         write(*,*)'	        attrlist,strbufsize)'
         write(*,*)'	Value returned by he5_ptinqgrpattrs ', status
         write(1,*)'	nattr = he5_ptinqgrpattrs(ptid,'
         write(1,*)'	        attrlist,strbufsize)'
         write(1,*)'	Value returned by he5_ptinqgrpattrs ', status
      endif
      write(*,*)' '
      write(1,*)' '

      attrname       = 'GroupAttribute'

c Test Case -- he5_ptgrpattrinfo
c
      write(*,*)'Testing he5_ptgrpattrinfo '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptgrpattrinfo '
      write(1,*)'========================='
      status   = he5_ptgrpattrinfo(ptid,attrname,ntype,sz)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status   = he5_ptgrpattrinfo(ptid,'
         write(*,*)'	           attrname,ntype,sz)'
         write(*,*)'	Value returned by he5_ptgrpattrinfo ', status
         write(1,*)'	status   = he5_ptgrpattrinfo(ptid,'
         write(1,*)'	           attrname,ntype,sz)'
         write(1,*)'	Value returned by he5_ptgrpattrinfo ', status
      endif
      write(*,*)' '
      write(1,*)' '

      attrname       = 'LocalAttribute'
      levelname      = 'Observations'

c Test Case -- he5_ptreadlocattr
c
      write(*,*)'Testing he5_ptreadlocattr '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptreadlocattr '
      write(1,*)'========================='
      status = he5_ptreadlocattr(ptid,levelname,attrname,attr2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptreadlocattr(ptid,'
         write(*,*)'	         levelname,attrname,attr2)'
         write(*,*)'	Value returned by he5_ptreadlocattr ', status
         write(1,*)'	status = he5_ptreadlocattr(ptid,'
         write(1,*)'	         levelname,attrname,attr2)'
         write(1,*)'	Value returned by he5_ptreadlocattr ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptinqlocattrs
c
      write(*,*)'Testing he5_ptinqlocattrs '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptinqlocattrs '
      write(1,*)'========================='
      nattr = he5_ptinqlocattrs(ptid,levelname,null_char_0,strbufsize)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nattr = he5_ptinqlocattrs(ptid,'
         write(*,*)'	        levelname,null_char_0,strbufsize)'
         write(*,*)'	Value returned by he5_ptinqlocattrs ', nattr
         write(1,*)'	nattr = he5_ptinqlocattrs(ptid,'
         write(1,*)'	        levelname,null_char_0,strbufsize)'
         write(1,*)'	Value returned by he5_ptinqlocattrs ', nattr
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptinqlocattrs
c
      write(*,*)'Testing he5_ptinqlocattrs '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptinqlocattrs '
      write(1,*)'====================='
      nattr = he5_ptinqlocattrs(ptid,levelname,attrlist,strbufsize)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	nattr = he5_ptinqlocattrs(ptid,'
         write(*,*)'	        levelname,attrlist,strbufsize)'
         write(*,*)'	Value returned by he5_ptinqlocattrs ', nattr
         write(1,*)'	nattr = he5_ptinqlocattrs(ptid,'
         write(1,*)'	        levelname,attrlist,strbufsize)'
         write(1,*)'	Value returned by he5_ptinqlocattrs ', nattr
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptlocattrinfo
c
      write(*,*)'Testing he5_ptlocattrinfo '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptlocattrinfo '
      write(1,*)'========================='
      status = he5_ptlocattrinfo(ptid,levelname,attrname,ntype,sz)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptlocattrinfo(ptid,'
         write(*,*)'	         levelname,attrname,ntype,sz)'
         write(*,*)'	Value returned by he5_ptlocattrinfo ', status
         write(1,*)'	status = he5_ptlocattrinfo(ptid,'
         write(1,*)'	         levelname,attrname,ntype,sz)'
         write(1,*)'	Value returned by he5_ptlocattrinfo ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptclose
c
      write(*,*)'Testing he5_ptclose '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptclose '
      write(1,*)'====================='
      status = he5_ptclose(ptfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptclose(ptfid)'
         write(*,*)'	Value returned by he5_ptclose ', status
         write(1,*)'	status = he5_ptclose(ptfid)'
         write(1,*)'	Value returned by he5_ptclose ', status
      endif
      write(*,*)' '
      write(1,*)' '

      null_char_0  = '0'

c Test Case -- he5_ptopen
c
      write(*,*)'Testing he5_ptopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptopen '
      write(1,*)'====================='
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDONLY) 
      if (ptfid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDONLY)'
         write(*,*)'	Value returned by he5_ptopen ', ptfid
         write(1,*)'	ptfid= he5_ptopen("point.he5",HE5F_ACC_RDONLY)'
         write(1,*)'	Value returned by he5_ptopen ', ptfid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptattach
c
      write(1,27)
      write(*,*)'Testing he5_ptattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptattach '
      write(1,*)'====================='
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'	Value returned by he5_ptattach ', ptid
         write(1,*)'	ptid = he5_ptattach(ptfid, "FixedBuoy Point")'
         write(1,*)'	Value returned by he5_ptattach ', ptid
      endif
      write(*,*)' '
      write(1,*)' '

      fieldgroup = HE5_HDFE_DATAGROUP
      fieldname  = 'Observations'

c Test Case -- he5_ptinqdatatype
c
      write(*,*)'Testing he5_ptinqdatatype '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptinqdatatype '
      write(1,*)'========================='
      status = he5_ptinqdatatype(ptid,fieldname,null_char_0,fieldgroup,
     1datatype,classid,order,size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptinqdatatype(ptid,fieldname,'
         write(*,*)'	         null_char_0,fieldgroup,datatype,classid,'
         write(*,*)'	         order,size)'
         write(*,*)'	Value returned by he5_ptinqdatatype ', status
         write(1,*)'	status = he5_ptinqdatatype(ptid,fieldname,'
         write(1,*)'	         null_char_0,fieldgroup,datatype,classid,'
         write(1,*)'	         order,size)'
         write(1,*)'	Value returned by he5_ptinqdatatype ', status
      endif
      write(*,*)' '
      write(1,*)' '

      fieldgroup   = HE5_HDFE_ATTRGROUP
      attrname     = 'GlobalAttribute_int'

c Test Case -- he5_ptinqdatatype
c
      write(*,*)'Testing he5_ptinqdatatype '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptinqdatatype '
      write(1,*)'========================='
      status = he5_ptinqdatatype(ptid,null_char_0,attrname,fieldgroup,
     1datatype,classid,order,size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptinqdatatype(ptid,null_char_0,'
         write(*,*)'	         attrname,fieldgroup,datatype,'
         write(*,*)'	         classid,order,size)'
         write(*,*)'	Value returned by he5_ptinqdatatype ', status
         write(1,*)'	status = he5_ptinqdatatype(ptid,null_char_0,'
         write(1,*)'	         attrname,fieldgroup,datatype,'
         write(1,*)'	         classid,order,size)'
         write(1,*)'	Value returned by he5_ptinqdatatype ', status
      endif
      write(*,*)' '
      write(1,*)' '

      fieldgroup   = HE5_HDFE_GRPATTRGROUP
      attrname     = 'GroupAttribute'

c Test Case -- he5_ptinqdatatype
c
      write(*,*)'Testing he5_ptinqdatatype '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptinqdatatype '
      write(1,*)'========================='
      status = he5_ptinqdatatype(ptid,null_char_0,attrname,fieldgroup,
     1datatype,classid,order,size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptinqdatatype(ptid,null_char_0,'
         write(*,*)'	         attrname,fieldgroup,datatype,'
         write(*,*)'	         classid,order,size)'
         write(*,*)'	Value returned by he5_ptinqdatatype ', status
         write(1,*)'	status = he5_ptinqdatatype(ptid,null_char_0,'
         write(1,*)'	         attrname,fieldgroup,datatype,'
         write(1,*)'	         classid,order,size)'
         write(1,*)'	Value returned by he5_ptinqdatatype ', status
      endif
      write(*,*)' '
      write(1,*)' '

      fieldname    = 'Observations'
      fieldgroup   = HE5_HDFE_LOCATTRGROUP
      attrname     = 'LocalAttribute'

c Test Case -- he5_ptinqdatatype
c
      write(*,*)'Testing he5_ptinqdatatype '
      write(*,*)'========================='
      write(1,*)'Testing he5_ptinqdatatype '
      write(1,*)'========================='
      status = he5_ptinqdatatype(ptid,fieldname,attrname,fieldgroup,
     1datatype,classid,order,size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptinqdatatype(ptid,fieldname,'
         write(*,*)'	         attrname,fieldgroup,datatype,'
         write(*,*)'	         classid,order,size)'
         write(*,*)'	Value returned by he5_ptinqdatatype ', status
         write(1,*)'	status = he5_ptinqdatatype(ptid,fieldname,'
         write(1,*)'	         attrname,fieldgroup,datatype,'
         write(1,*)'	         classid,order,size)'
         write(1,*)'	Value returned by he5_ptinqdatatype ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptdetach
c
      write(1,27)
      write(*,*)'Testing he5_ptdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptdetach '
      write(1,*)'====================='
      status = he5_ptdetach(ptid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
               else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptdetach(ptid)'
         write(*,*)'	Value returned by he5_ptdetach ', status
         write(1,*)'	status = he5_ptdetach(ptid)'
         write(1,*)'	Value returned by he5_ptdetach ', status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_ptclose
c
      write(*,*)'Testing he5_ptclose '
      write(*,*)'====================='
      write(1,*)'Testing he5_ptclose '
      write(1,*)'====================='
      status = he5_ptclose(ptfid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status = he5_ptclose(ptfid)'
         write(*,*)'	Value returned by he5_ptclose ', status
         write(1,*)'	status = he5_ptclose(ptfid)'
         write(1,*)'	Value returned by he5_ptclose ', status
      endif
      write(*,*)' '
      write(1,*)' '

      close(unit=1)

   27 format(' ')
  230 format('********Error unexpected**********')
  240 format('***********Passed Test*********')

      stop
      end

!     In this program we (1) open the "za.he5" HDF-EOS file, 
!     (2) attach to the "ZA1" za, and (3) define the za fields
!     ========================================================

      program     he5_za_definefieldsF_32

      implicit    none

      include     'hdfeos5.inc'

      integer     status
      integer     he5_zaopen
      integer     he5_zaattach
      integer     he5_zadefine
      integer     he5_zadefchunk
      integer     he5_zadefcomp
      integer     he5_zadetach
      integer     he5_zaclose
      integer     zafid, zaid

      integer     chunkrank
      integer*4   chunkdims(3)
      integer     compparm(1)

      integer     FAIL
      parameter   (FAIL=-1)

!     Open the HDF-EOS file, "za.he5" using "READ/WRITE" access code
!     --------------------------------------------------------------
      zafid = he5_zaopen("za.he5",HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_zaopen():  ',zafid 
      if (zafid .NE. FAIL) then

         zaid = he5_zaattach(zafid, "ZA1")
         write(*,*) 'ZA ID  returned by he5_zaattach():  ',zaid 
         if (zaid .NE. FAIL) then
            
!     Define Data fields
!     ------------------
            
            status = he5_zadefine(zaid, "Density", 
     1           "MyTrack1"," ", HE5T_NATIVE_FLOAT)
            write(*,*) 'Status returned by he5_zadefine():  ',status 

            status = he5_zadefine(zaid, "Temperature",
     1           "MyTrack2,MyTrack1",
     2           " ", HE5T_NATIVE_FLOAT)	      
            write(*,*) 'Status returned by he5_zadefine():  ',status 
	      
            status = he5_zadefine(zaid, "Pressure", 
     1           "Res2xtr,Res2tr",
     2           " ", HE5T_NATIVE_FLOAT)
            write(*,*) 'Status returned by he5_zadefine():  ',status 
	      
                chunkrank = 3
                chunkdims(1) = 20
                chunkdims(2) = 40
                chunkdims(3) = 15
                compparm(1) = 6
 
            status = he5_zadefchunk(zaid,chunkrank,chunkdims)
            write(*,*) 'Status returned by he5_zadefchunk(): ',status
 
            status = he5_zadefcomp(zaid,HE5_HDFE_COMP_DEFLATE,compparm)
            write(*,*) 'Status returned by he5_zadefcomp():  ',status

            status = he5_zadefine(zaid, "Spectra", 
     1           "Res2xtr,Res2tr,Bands",
     2           " ", HE5T_NATIVE_DOUBLE)	      
            write(*,*) 'Status returned by he5_zadefine():  ',status 



         endif
      endif
      
!     Detach from the za
!     ------------------      
      status = he5_zadetach(zaid)
      write(*,*) 'Status returned by he5_zadetach():  ',status 
      
!     Close the file
!     --------------      
      status = he5_zaclose(zafid)
      write(*,*) 'Status returned by he5_zaclose():  ',status 

      stop
      end

c	  In this program we retrieve (1) information about the
c	  dimensions, (2) the dimension mappings 
c     (geolocation relations), 	and (3) the swath fields 

      program         he5_sw_infoF_32

      implicit        none

      include         'hdfeos5.inc'

	  integer         i
          integer         status
	  integer         swfid, swid
	  integer         he5_swopen
	  integer         he5_swattach
	  integer         he5_swfldinfo
          integer         he5_swattrinfo
	  integer         he5_swmapinfo
          integer         he5_swinqgfldalias
          integer         he5_swinqdfldalias
          integer         he5_swchunkinfo
	  integer         he5_swdetach	  
	  integer         he5_swclose
	  integer         rank(32)
	  integer         ntype(32)
	  integer         rk
	  integer         nt

	  integer*4       he5_swinqdims
	  integer*4       he5_swinqmaps
          integer*4       he5_swinqgflds
          integer*4       he5_swinqdflds
	  integer*4       he5_swdiminfo
	  integer*4       he5_swimapinfo
	  integer*4       he5_swinqimaps
          integer*4       n
	  integer*4       offset
	  integer*4       incr
	  integer*4       ndims
	  integer*4       nmaps
	  integer*4       nflds
	  integer*4       dims(32)
	  integer*4       off(32)
	  integer*4       inc(32)
	  integer*4       sizes(8)
	  integer*4       indx(32)
	  integer*4       dimsize
          integer*4       count

	  character*72    dimname
	  character*72    dimmap
          character*72    dimlist
          character*72    maxdimlst
          character*72    fieldlist

          integer*4       nfldalias
          integer*4       strbufsize
 
          character*72    fldaliases

          integer         chunkrank
          integer*4       chunkdims(32)


	  integer         FAIL
	  parameter       (FAIL=-1)

      
c     Open the "swath.he5" file for "read only" access
c     ------------------------------------------------
	  swfid = he5_swopen("swath.he5", HE5F_ACC_RDONLY)
      write(*,*) 'File ID returned by he5_swopen():  ',swfid

	  if (swfid .NE. FAIL) then
	   
c     Attach the swath
c     ----------------
		 swid = he5_swattach(swfid, "Swath1")
         write(*,*) 'Swath ID returned by he5_swattach():  ',swid

		 if (swid .NE. FAIL) then
		
c     Inquire Dimensions
c     ------------------			
			ndims = he5_swinqdims(swid, dimname, dims)
			write(*,*) 'Dimension list: ', dimname
			do i = 1,ndims
			   write(*,*) 'dim size: ', dims(i)
			enddo
			write(*,*)	      
						
c     Inquire Dimension Mappings
c     --------------------------
			nmaps = he5_swinqmaps(swid, dimmap, off, inc)
			write(*,*) 'Dimension map: ', dimmap
			do i = 1,nmaps
			   write(*,*) 'offset increment: ', off(i), inc(i)
			enddo
			write(*,*)

c     Inquire Indexed Dimension Mappings
c     ----------------------------------
			nmaps = he5_swinqimaps(swid, dimmap, sizes)
			write(*,*) 'Index Dimension map: ', dimmap
			do i=1,nmaps
			   write(*,*) 'sizes: ', sizes(i)
			enddo
			write(*,*)	      
			
c     Inquire Geolocation Fields
c     --------------------------
			nflds = he5_swinqgflds(swid, fieldlist, rank, ntype)
			write(*,*) 'Geolocation fieldlist: ', fieldlist
			do i=1,nflds
			   write(*,*) 'field rank & datatype: ',rank(i),ntype(i)
			enddo
			write(*,*) 

        nfldalias = he5_swinqgfldalias(swid,fldaliases,strbufsize)
        write(*,*) 'Fields & aliases list: ',fldaliases
        write(*,*) 'Length of list is ',strbufsize
	      
c     Inquire Data Fields	      
c     -------------------			
			nflds = he5_swinqdflds(swid, fieldlist, rank, ntype)
			write(*,*) 'Data Fieldlist: ', fieldlist
			do i=1,nflds
			   write(*,*) 'field rank & datatype: ',rank(i),ntype(i)
			enddo
			write(*,*) 

        nfldalias = he5_swinqdfldalias(swid,fldaliases,strbufsize)
        write(*,*) 'Fields & aliases list: ',fldaliases
        write(*,*) 'Length of list is ',strbufsize

			
c     Get info on "GeoTrack" dim
c     --------------------------			
	      dimsize = he5_swdiminfo(swid, "GeoTrack")
	      write(*,*) 'Size of GeoTrack: ', dimsize
	      write(*,*)
	      

c     Get info on "GeoTrack/Res2tr" mapping
c     -------------------------------------		  
	      status = he5_swmapinfo(swid,"GeoTrack","Res2tr",
     1         offset,incr)	      
	      write(*,*) 'Mapping Offset: ', offset
	      write(*,*) 'Mapping Increment: ', incr
	      write(*,*)


c     Get info on "IndxTrack/Res2tr" indexed mapping
c     ----------------------------------------------		  
	      n = he5_swimapinfo(swid, "IndxTrack", "Res2tr", indx)
	      do i=1,n
			 write(*,*) 'Index Mapping Entry ', i, indx(i)
	      enddo
	      write(*,*)
	      
c     Get info on "Longitude" Field
c     -----------------------------		  
	      status = he5_swfldinfo(swid,"Longitude",rk,dims,nt,
     1         dimlist,maxdimlst)
	      write(*,*) 'Longitude Rank: ', rk
	      write(*,*) 'Longitude NumberType: ', nt
	      write(*,*) 'Longitude Dimlist: ', dimlist
	      write(*,*) 'Longitude Max Dimlist: ', maxdimlst
	      do i=1,rk
			 write(*,*) 'Dimension ',i,dims(i)
	      enddo

        	status = he5_swattrinfo(swid,"GLOBAL_CHAR_ATTR",nt,count)
              write(*,*) 'GLOBAL_CHAR_ATTR NumberType: ', nt
              write(*,*) 'GLOBAL_CHAR_ATTR size: ', count

              status = he5_swchunkinfo(swid,"Spectra",chunkrank,
     1         chunkdims)
              write(*,*) 'Spectra Chunking Rank: ', chunkrank
              do i=1,chunkrank
                         write(*,*) 'Chunking Dimension ',i,chunkdims(i)
              enddo


	   endif
	  endif
	  
c     Detach from swath
c     -----------------
	  status = he5_swdetach(swid)
      write(*,*) 'Status returned by he5_swdetach():  ',status

c     Close the file
c     --------------
	  status = he5_swclose(swfid)
      write(*,*) 'Status returned by he5_swclose():  ',status

	  stop
	  end

      program     he5_gd_writedataF_32

      implicit    none

      include     'hdfeos5.inc'

      integer     status
      integer     i, j
      integer     he5_gdopen
      integer     he5_gdattach
      integer     he5_gdwrfld
      integer     he5_gdwrattr
      integer     he5_gdwrgattr
      integer     he5_ehwrglatt
      integer     he5_gdwrlattr 
      integer     he5_gddetach
      integer     he5_gdclose
      integer     gdfid,gdid

      integer*4   start(2), stride(2), count(2)

      real*4      f, veg(120,200), temp(100,100)
      character*10    attr4
      character*100   attr5

      integer     FAIL
      parameter   (FAIL=-1)

c     Create data buffers 
c     -------------------      
      do i=1,200
         do j=1,120
            veg(j,i) = 10 + i
         enddo
      enddo
	  
      do i=1,100
         do j=1,100
            temp(j,i) = 100*(i-1) + j
         enddo
      enddo

c     Open HDF-EOS file "grid.he5" 
c     ---------------------------      
      gdfid = he5_gdopen("grid.he5",HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_gdopen():  ',gdfid

      if (gdfid .ne. FAIL) then

c     Attach to the UTM grid
c     ----------------------         
         gdid = he5_gdattach(gdfid, "UTMGrid")
         write(*,*) 'Grid ID returned by he5_gdattach():  ',gdid
         
         if (gdid .ne. FAIL) then
            start(1)  = 0
            start(2)  = 0
            stride(1) = 1
            stride(2) = 1
            count(1)  = 120
            count(2)  = 200
            
c     Write data to the field "Vegetation"
c     ------------------------------------
            status = he5_gdwrfld(gdid,"Vegetation",
     1           start,stride,count,veg)
            write(*,*) 'Status returned by he5_gdwrfld():  ',status
      
            f        = 1
            count(1) = 1

c     Write global attribute "float"
c     ------------------------------
            status = he5_gdwrattr(gdid,"float",
     1           HE5T_NATIVE_FLOAT,count,f)
            write(*,*) 'Status returned by he5_gdwrattr():  ',status
            
            attr4 = "ABCDEFGH"
            count(1) = 8
            status = he5_gdwrattr(gdid,"GLOBAL_CHAR_ATTR",HE5T_NATIVE_CHAR,
     1           count,attr4)
            write(*,*) 'Status returned by he5_gdwrattr():  ',status

            attr4 = "111"
            count(1) = 3
            status = he5_gdwrgattr(gdid,"GLOBAL_CHAR_ATTR_1",
     1           HE5T_NATIVE_CHAR,count,attr4)
            write(*,*) 'Status returned by he5_gdwrgattr():  ',status
            
            attr4 = "222222"
            count(1) = 6
            status = he5_ehwrglatt(gdfid,"GLOBAL_CHAR_ATTR_2",
     1           HE5T_NATIVE_CHAR,count,attr4)
            write(*,*) 'Status returned by he5_ehwrglatt():  ',status
            
            attr5 = "abcdefgh111111111111"
            count(1) = 20
            status = he5_gdwrlattr(gdid,"Vegetation","LocalAttribute_0",
     1           HE5T_NATIVE_CHAR,count,attr5)
            write(*,*) 'Status returned by he5_gdwrlattr():  ',status
            
         endif
      endif

c     Detach from the grid
c     --------------------	  
      status = he5_gddetach(gdid)
      write(*,*) 'Status returned by he5_gddetach():  ',status


c     Attach to the POLAR grid 
c     ------------------------	  
      gdid = he5_gdattach(gdfid, "PolarGrid")
      write(*,*) 'Grid ID returned by he5_gdattach():  ',gdid
      
      if (gdid .ne. FAIL) then
         start(1)  = 0
         start(2)  = 0
         stride(1) = 1
         stride(2) = 1
         count(1)  = 100
         count(2)  = 100
         
c     Write data to the "Temperature" field
c     -------------------------------------         
         status = he5_gdwrfld(gdid,"Temperature",
     1        start,stride,count,temp)
         write(*,*) 'Status returned by he5_gdwrfld():  ',status
         
      endif
      
c     Detach from the grid
c     --------------------
      status = he5_gddetach(gdid)
      write(*,*) 'Status returned by he5_gddetach():  ',status
      
c     Close the file 
c     --------------	  
      status = he5_gdclose(gdfid)
      write(*,*) 'Status returned by he5_gdclose():  ',status
      
      stop
      end

c
c ----------------------------------------------------------------------------
c |    Copyright (C) 1999   Emergent IT Inc. and Raytheon Systems Company    |
c ----------------------------------------------------------------------------
c

      program            he5_sw_rdexternaldataF_32

      implicit           none

      include            'hdfeos5.inc'

      integer            i
      integer            status
      integer            he5_swopen
      integer            he5_swattach
      integer            he5_swrdfld
      integer            he5_swgetxdat
      integer            he5_ehrdwrfile
      integer            he5_swdetach
      integer            he5_swclose
      integer            swfid, swid
      integer            nfiles
      integer            datain1(100)
      integer            datain2(100)
      integer            datain3(100)
      integer            dataout(60)

      integer*4          start(2)
      integer*4          stride(2)
      integer*4          count(2)
      integer*4          offset(3)
      integer*4          size(3)
      integer*4          nmlgth
      integer*4          num_elements

      character          filelist*256

      integer            FAIL
      parameter          (FAIL=-1)

c.....Use this for writing (only) to an existing file
      integer            WRITE_EXISTING_ONLY
      parameter          (WRITE_EXISTING_ONLY=0)

c.....Use this for reading (only) from an existing file
      integer            READ_ONLY
      parameter          (READ_ONLY=1)

c.....Use this for creating and writing to a file
      integer            WRITE_NEW
      parameter          (WRITE_NEW=2)



c     Create the external data sets
c     -----------------------------
      do 10 i=1,100

         datain1(i) = 1000+i
         datain2(i) = 2000+i
         datain3(i) = 3000+i        
         
 10   continue

      num_elements = 100
      
      status = he5_ehrdwrfile("extf1.dat",WRITE_NEW,
     1HE5T_NATIVE_INT,num_elements,datain1)
      write(*,*) 'Status returned from he5_ehrdwrfile:   ',status

      status = he5_ehrdwrfile("extf2.dat",WRITE_NEW,
     1HE5T_NATIVE_INT,num_elements,datain2)
      write(*,*) 'Status returned from he5_ehrdwrfile:   ',status

      status = he5_ehrdwrfile("extf3.dat",WRITE_NEW,
     1HE5T_NATIVE_INT,num_elements,datain3)
      write(*,*) 'Status returned from he5_ehrdwrfile:   ',status

c     Open HDF-EOS swath file, "swath.he5"
c     -----------------------------------
	  swfid = he5_swopen("swath.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned from he5_swopen():  ',swfid

	  if (swfid .NE. FAIL) then
		 swid = he5_swattach(swfid, "Swath1")
         write(*,*) 'Swath ID returned from he5_swattach():  ',swid

		 if (swid .NE. FAIL) then
			
c     Read the external data field 
c     ----------------------------
      start(1)  = 0
      stride(1) = 1
      count(1)  = 60

      status = he5_swrdfld(swid,"ExtData",
     1     start,stride,count,dataout)
      write(*,*) 'Status returned from he5_swrdfld():  ',status


c     Display the data
c     ----------------
      do i=1,60
         write(*,*)'External data',dataout(i)
      enddo

      nmlgth = 48

c     Get the number of external files
c     --------------------------------     
      nfiles = he5_swgetxdat(swid,"ExtData",nmlgth,
     1     filelist,offset,size)

      write(*,*) 'Number of external files',nfiles
      write(*,*) 'External files:',filelist
      do i=1,nfiles
         write(*,*) 'offsets:',offset(i)
         write(*,*) 'sizes:',size(i)
      enddo

		 endif
	  endif
	
c     Detach from swath
c     -----------------
	  status = he5_swdetach(swid)
      write(*,*) 'Status returned from he5_swdetach():  ',status

c     Close the file
c     --------------
	  status = he5_swclose(swfid)
      write(*,*) 'Status returned from he5_swclose():  ',status
      
	  stop
	  end

c     In this program we (1) open an HDF-EOS file, (2) create the 
c     swath interface, and (3) define the swath field dimensions
c     ===========================================================

      program            he5_sw_setupF_64

      implicit           none

      include            'hdfeos5.inc'
      include            'hdfeos5_64.inc'

      integer            status
      integer            he5_swopen
      integer            he5_swcreate
      integer            he5_swdefdim
      integer            he5_swdefmap
      integer            he5_swdefimap
      integer            he5_swdetach
      integer            he5_swclose
      integer            swfid, swid

      integer*8          dtrack, extdata
      integer*8          offset, incr
      integer*8          indx(12)

      data indx  /0,1,3,6,7,8,11,12,14,24,32,39/

c     Open the HDF-EOS file, "swath.he5" using "TRUNC" file access code 
c     -----------------------------------------------------------------
      swfid = he5_swopen("swath.he5",HE5F_ACC_TRUNC)
      write(*,*) 'File ID returned by he5_swopen():  ',swfid

c     Create the swath, "Swath1", within the file 
c     -------------------------------------------
      swid = he5_swcreate(swfid, "Swath1")
      write(*,*) 'Swath ID returned by he5_swcreate():  ',swid
    
c     Define Geolocation and Data dimensions
c     --------------------------------------
c     ----------------------------------------------------------------------
c     Typically, many fields within a swath share the same dimension. The
c     swath interface therefore provides a way of defining dimensions that
c     will then be used to define swath fields.  A dimension is defined with
c     a name and a size and is connected to the particular swath through the
c     swath id.  In this example, we define the geo- location track and
c     cross track dimensions with size 20 and 10 respectively and two
c     dimensions corresponding to these but with twice the resolution.
c     Also, we define "Bands" and "unlimited" dimensions.
c     ----------------------------------------------------------------------
      dtrack = 73
      status = he5_swdefdim(swid, "GeoTrack", dtrack)
      write(*,*) 'Status returned by he5_swdefdim():  ',status

      dtrack = 10
      status = he5_swdefdim(swid, "GeoXtrack", dtrack)
      write(*,*) 'Status returned by he5_swdefdim():  ',status

      dtrack = 40
      status = he5_swdefdim(swid, "Res2tr", dtrack)
      write(*,*) 'Status returned by he5_swdefdim():  ',status

      dtrack = 20
      status = he5_swdefdim(swid, "Res2xtr", dtrack)
      write(*,*) 'Status returned by he5_swdefdim():  ',status

      dtrack = 15
      status = he5_swdefdim(swid, "Bands", dtrack)
      write(*,*) 'Status returned by he5_swdefdim():  ',status

      dtrack = 12
      status = he5_swdefdim(swid, "IndxTrack", dtrack)
      write(*,*) 'Status returned by he5_swdefdim():  ',status

      dtrack = 4
      status = he5_swdefdim(swid, "ProfDim", dtrack)
      write(*,*) 'Status returned by he5_swdefdim():  ',status
      
c     Define "External" dimension
c     ---------------------------
      extdata = 60
      status = he5_swdefdim(swid, "ExtDim", extdata)
      write(*,*) 'Status returned by he5_swdefdim():  ',status
     
c     Define Unlimited (appendable) dimension
c     ---------------------------------------
      status = he5_swdefdim(swid, "Unlim", HE5S_UNLIMITED_F_64)
      write(*,*) 'Status returned by he5_swdefdim():  ',status

c     ----------------------------------------------------------------------
c     Once the dimensions are defined, the relationship (mapping)between the
c     geolocation dimensions, such as track and cross track, and the data
c     dimensions, must be established.  This is done through the SWdefdimmap
c     routine.  It takes as input the swath id, the names of the dimensions
c     designating the geolocation and data dimensions, respectively, and the
c     offset and increment defining the relation.
c     
c     In the first example we relate the "GeoTrack" and "Res2tr" dimensions
c     with an offset of 0 and an increment of 2.  Thus the ith element of
c     "Geotrack" corresponds to the 2 * ith element of "Res2tr".
c   
c     In the second example, the ith element of "GeoXtrack" corresponds to 
c     the 2 * ith + 1 element of "Res2xtr".
c     -----------------------------------------------------------------------  
      
c     Define dimension mappings
c     -------------------------
      offset = 0
      incr   = 2
      status = he5_swdefmap(swid, "GeoTrack", "Res2tr",
     1offset, incr)
      write(*,*) 'Status returned by he5_swdefmap():  ',status

      offset = 1
      status = he5_swdefmap(swid, "GeoXtrack", "Res2xtr", 
     1offset, incr)
      write(*,*) 'Status returned by he5_swdefmap():  ',status


c     Define indexed dimension mapping
c     --------------------------------
      status = he5_swdefimap(swid, "IndxTrack", "Res2tr", 
     1indx)
      write(*,*) 'Status returned by he5_swdefimap():  ',status

c     Detach from the swath
c     ---------------------
      status = he5_swdetach(swid)
      write(*,*) 'Status returned by he5_swdetach():  ',status

c     Close the swath file
c     --------------------
      status = he5_swclose(swfid)
      write(*,*) 'Status returned by he5_swclose():  ',status

      stop
      end

      program     he5_sw_writedimscaleF_32

      implicit    none

      include     'hdfeos5.inc'

      integer     status
      integer     i, j
      integer     he5_swopen
      integer     he5_swattach
      integer     he5_swwrfld
      integer     he5_swwrattr
      integer     he5_swwrgattr
      integer     he5_ehwrglatt
      integer     he5_swwrlattr 
      integer     he5_swdetach
      integer     he5_swclose
      integer     HE5_SWsetdimscale
      integer     HE5_SWwritedscaleattr

      integer     swfid,swid1
      integer*4   datbuf_i1(1) 
      integer*4   datbuf_i(15)
      integer     count(2)
      integer*4   nbands
      integer     bands(3)
      integer*4   datbuf_i2(2)
      integer     xdim, ydim, ntime
      integer     data(15)
      integer     FAIL
      parameter   (FAIL=-1)



!  /*
!   * We first open the HDF-EOS swath file, "swath.he5".  Because this file
!   * already exist and we wish to write to it, we use the H5F_ACC_RDWR access
!   * code in the open statement.  The HE5_SWopen routine returns the swath file
!   * id, swfid, which is used to identify the file in subsequent routines.
!   */ 
      nbands = 15
      do j=1,nbands
         data(j)=(j+1)*2
      enddo

      swfid = HE5_SWopen("swath.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_swopen(): ',swfid
!  /*
!   * If the swath file cannot be found, HE5_SWopen will return -1 for the file
!   * handle (swfid).  We there check that this is not the case before
!   * proceeding with the other routines.
!   * 
!   * The HE5_SWattach routine returns the handle to the existing swath "Swath1",
!   * SWid.  If the swath is not found, HE5_SWattach returns -1 for the handle.
!   */ 

      if (swfid .ne. FAIL) then
 
         SWid1 = HE5_SWattach(swfid, "Swath1")
         write(*,*) 'Swath ID returned by he5_swattach(): ',swid1

!      /* the field Spectra has Bands,Res2tr,Res2xtr dimensions. 
!	 xdim = 120;
!	 ydim = 200;
!	 Time dim is set to 10
!      */

         if (SWid1 .eq. -1) then
            
            write(*,*) 'Error: Cannot attach to swath Swath1. Stpped.'
            status = HE5_SWclose(swfid)
            stop
            
         endif
                  
         status = HE5_SWsetdimscale(SWid1, "Spectra", "Bands", nbands,
     1                               HE5T_NATIVE_INT, data)
         write(*,*) 'Status returned by HE5_SWsetdimscale: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale for Bands',
     1                 ' dimemnsion in field Vegetation'
            status = HE5_SWdetach(SWid1)
            status = HE5_SWclose(swfid)
            stop
         endif

         count(1)= 12
         status = HE5_SWwritedscaleattr(SWid1, "Bands", "label", 
     1                         HE5T_NATIVE_CHAR, count, "Bands Dim")
         write(*,*) 'Status returned by HE5_SWwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1                ' dimemnsion in field Spectra'
            status = HE5_SWdetach(SWid1)
            status = HE5_SWclose(swfid)
            stop
         endif
         
         count(1)= 6
         status = HE5_SWwritedscaleattr(SWid1, "Bands", "unit", 
     1                              HE5T_NATIVE_CHAR, count, "None")
         write(*,*) 'Status returned by HE5_SWwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1                 ' dimemnsion in field Spectra'
            status = HE5_SWdetach(SWid1)
            status = HE5_SWclose(swfid)
            stop
         endif
         
         count(1)= 4
         status = HE5_SWwritedscaleattr(SWid1, "Bands", "format", 
     1                                 HE5T_NATIVE_CHAR, count, "I2")
         write(*,*) 'Status returned by HE5_SWwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1                 ' dimemnsion in field Spectra'
            status = HE5_SWdetach(SWid1)
            status =  HE5_SWclose(swfid)
            stop
         endif

         datbuf_i1(1) = -999
         count(1)= 1
         status = HE5_SWwritedscaleattr(SWid1, "Bands", "MissingValue",
     1                             HE5T_NATIVE_INT, count, datbuf_i1)
         write(*,*) 'Status returned by HE5_SWwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1                 ' dimemnsion in field Spectra'
            status = HE5_SWdetach(SWid1)
            status = HE5_SWclose(swfid)
            stop
         endif
         
         datbuf_i(1) =  -999
         datbuf_i(2) =  0
         datbuf_i(3) =  999


         count(1)= 3
         status = HE5_SWwritedscaleattr(SWid1, "Bands", "IntValues", 
     1                               HE5T_NATIVE_INT, count, datbuf_i)
         write(*,*) 'Status returned by HE5_SWwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1         ' dimemnsion in field Spectra'
            status = HE5_SWdetach(SWid1)
            status = HE5_SWclose(swfid)
            stop
         endif
         
         status = HE5_SWdetach(SWid1)
         write(*,*) 'Status returned by he5_swdetach(): ',status

         status = HE5_SWclose(swfid)
         write(*,*) 'Status returned by he5_swclose(): ',status

      endif
      stop
      end

c     In this program we (1) open the "swath.he5" file, (2) attach to
c     the "Swath1" swath, and (3) write data to the "Longitude", 
c     "Longitude" and "Spectra" fields

      program        he5_sw_writedataF_32
      
      implicit       none

      include        'hdfeos5.inc'

      integer        status
      integer        he5_swopen 
      integer        he5_swattach 
      integer        he5_swwrfld
      integer        he5_swwrattr
      integer        he5_swwrlattr
      integer        he5_swwrgattr
      integer        he5_ehwrglatt
      integer        he5_swsetalias
      integer        he5_swdetach
      integer        he5_swclose
      integer        he5_prwrite
      integer        swfid, swid 
      integer        buffer(250)
      integer        counter
      integer        i, j, k 
      integer        itrack

      integer*4      attr(4)
      integer*4      attr0(4)
      integer*4      track
      integer*4      start(3)
      integer*4      stride(3)
      integer*4      count(3)
      integer*4      len(4)
      integer*4      datasize
      real           attr1(4)
      character*10    attr4
      character*100   attr5

      real           lng(10)
      real           lat(10)
 
      real*8         plane(800)
      real*8         tme(20)

      integer        FAIL
      parameter      (FAIL=-1)	


c     Set longitude values along the cross track
c     ------------------------------------------
      do i=1,10
         lng(i) = i-1.0
      enddo
      
c     Open HDF-EOS file, "swath.he5"
c     ------------------------------
      swfid = he5_swopen("swath.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_swopen():  ',swfid
      
      if (swfid .NE. FAIL) then
         swid = he5_swattach(swfid, "Swath1")      
         write(*,*) 'Swath ID returned by he5_swattach():  ',swid
         
         if (swid .NE. FAIL) then
            
c     Write data starting at the beginning of each cross track
c     --------------------------------------------------------
            start(1)  = 0
            stride(1) = 1
            stride(2) = 1
            count(1)  = 10
            count(2)  = 1
            
c     Loop through all the tracks, incrementing the track starting
c     position by one each time
c     ------------------------------------------------------------
            do track = 1,20
               start(2) = track - 1
               status = he5_swwrfld(swid,"Longitude",start,
     1              stride,count,lng)
               
               do itrack = 1,10
                  lat(itrack) = track
               enddo
               status = he5_swwrfld(swid,"Latitude",start,
     1              stride,count,lat) 
            enddo
            
            do i = 1,20
               tme(i) = 34574087.3 + 84893.2*(i-1)
            enddo
            
            start(1)  = 0
            stride(1) = 1
            count(1)  = 20
            
            status = he5_swwrfld(swid, "Time", start, stride,
     1           count, tme)
            
            start(1)  = 0
            stride(1) = 1
            stride(2) = 1
            count(1)  = 10
            count(2)  = 1
            
            do track = 1,20
               start(2) = track - 1
               status = he5_swwrfld(swid,"Temperature",start,
     1              stride,count,lng)
            enddo
            
            status = he5_swsetalias(swid,"Temperature","L2gpValue")
            status = he5_swsetalias(swid,"Latitude","Lat,L")
            
c     Write Spectra one plane at a time 
c     Value is 100 * track index + band index (0-based)
c     -------------------------------------------------
            start(1)  = 0
            start(2)  = 0
            count(1)  = 20
            count(2)  = 40
            count(3)  = 1
            stride(3) = 1
	    
            do i=1,15
               start(3) = i - 1
               do j=1,40
                  do k=1,20
                     plane((j-1)*20+k) = (j-1)*100 + i-1
                  enddo
               enddo
               status = he5_swwrfld(swid,"Spectra",start,
     1              stride,count,plane)
            enddo
            
c     Populate data buffer and write data to the Profile Field
c     --------------------------------------------------------
            datasize = 0
            counter  = 0
            do i=1,4
               
               len(i)    = i*25
               datasize  = datasize + len(i)
               do j=1,(25*i)
                  counter = counter + 1
                  buffer(counter) = (i)*1000 + j - 1
               enddo
            enddo

            start(1)  = 0
            count(1)  = 4
            stride(1) = 1
            
            status = he5_prwrite(swid,"Profile-2000",start,stride,count,
     1           datasize,len,buffer)
            write(*,*) 'Status returned by he5_prwrite():  ',status
            
c     Write User defined Attribute
c     ----------------------------
            attr(1) = 3
            attr(2) = 5
            attr(3) = 7
            attr(4) = 11
            count(1) = 4
            status = he5_swwrattr(swid,"TestAttr",HE5T_NATIVE_INT,
     1           count,attr)
            write(*,*) 'Status returned by he5_swwrattr():  ',status
            
            
c     Write Global Attribute
c     ----------------------
            attr4 = "ABCDEFGH"
            count(1) = 8
            status = he5_swwrattr(swid,"GLOBAL_CHAR_ATTR",
     1           HE5T_NATIVE_CHAR,count,attr4)
            write(*,*) 'Status returned by he5_swwrattr():  ',status
            
            attr4 = "111"
            count(1) = 3
            status = he5_swwrgattr(swid,"GLOBAL_CHAR_ATTR_1",
     1           HE5T_NATIVE_CHAR,count,attr4)
            write(*,*) 'Status returned by he5_swwrgattr():  ',status
            
            attr4 = "222222"
            count(1) = 6
            status = he5_ehwrglatt(swfid,"GLOBAL_CHAR_ATTR_2",
     1           HE5T_NATIVE_CHAR,count,attr4)
            write(*,*) 'Status returned by he5_ehwrglatt():  ',status
            
c     Write Local Attribute
c     ---------------------
            attr0(1) = 100
            attr0(2) = 200
            attr0(3) = 300
            attr0(4) = 400
            count(1) = 4
            status = he5_swwrlattr(swid,"Density","LocalAttribute_1",
     1		 HE5T_NATIVE_INT,count,attr0)
            write(*,*) 'Status returned by he5_swwrlattr():  ',status
            
            attr5 = "abababababababababab"
            count(1) = 20
            status = he5_swwrlattr(swid,"Density","LocalAttribute_0",
     1           HE5T_NATIVE_CHAR,count,attr5)
            write(*,*) 'Status returned by he5_swwrlattr():  ',status
            
            attr1(1) = 1.111111
            attr1(2) = 2.222222
            attr1(3) = 3.333333
            attr1(4) = 4.444444
            count(1) = 4
            status = he5_swwrlattr(swid,"Longitude","LocalAttribute_2",
     1           HE5T_NATIVE_REAL,count,attr1)
            write(*,*) 'Status returned by he5_swwrlattr():  ',status
            
            
         endif
      endif
      
c     Detach from the swath
c     ---------------------
      status = he5_swdetach(swid)
      write(*,*) 'Status returned by he5_swdetach():  ',status
      
c     Close the file
c     --------------
      status = he5_swclose(swfid)
      write(*,*) 'Status returned by he5_swclose():  ',status
      
      stop
      end

      program   he5_gd_definefldsF_32

      implicit  none

      include   'hdfeos5.inc'

      integer   status
      integer   he5_gdopen
      integer   he5_gddeffld
      integer   he5_gdsetfill
      integer   he5_gddeftle
      integer   he5_gddefcomp
      integer   he5_gdattach
      integer   he5_gddetach
      integer   he5_gdclose
      integer   gdfid, gdid1, gdid2  

      integer   tilecode, tilerank
      integer*4 tiledims(2)
      integer   compparm(1)
      
      real*4    fillval1, fillval2
	
      fillval1 = -7.0
      fillval2 = -9999.0

c     Open HDF-EOS file "grid.he5" 
c     ----------------------------	  
	  gdfid = he5_gdopen("grid.he5",HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_gdopen():  ',gdfid

c     Attach to the UTM grid
c     ----------------------
	  gdid1 = he5_gdattach(gdfid, "UTMGrid")
      write(*,*) 'Grid ID returned by he5_gdattach():  ',gdid1

c     Define Fields
c     -------------

      status = he5_gdsetfill(gdid1,"Pollution",
     1     HE5T_NATIVE_FLOAT,fillval1)
      write(*,*) 'Status returned by he5_gdsetfill():  ',status

      status = he5_gddeffld(gdid1,"Pollution",
     1     "XDim,YDim,Time"," ", HE5T_NATIVE_FLOAT, 0)
      write(*,*) 'Status returned by he5_gddeffld():  ',status

                tilerank = 2
                tiledims(1) = 60
                tiledims(2) = 100
                compparm(1) = 6

      status = he5_gddeftle(gdid1,HE5_HDFE_TILE,tilerank,tiledims)
      write(*,*) 'Status returned by he5_gddeftle(): ',status

      status = he5_gddefcomp(gdid1,HE5_HDFE_COMP_DEFLATE,compparm)
      write(*,*) 'Status returned by he5_gddefcomp():  ',status

      status = he5_gddeffld(gdid1, "Vegetation", "XDim,YDim",
     1     " ", HE5T_NATIVE_FLOAT, 0)
      write(*,*) 'Status returned by he5_gddeffld():  ',status


c     Attach to the POLAR grid
c     ------------------------
	  gdid2 = he5_gdattach(gdfid, "PolarGrid")
      write(*,*) 'Grid ID returned by he5_gdattach():  ',gdid2

      
c     Define Fields
c     -------------	  
      status = he5_gddeffld(gdid2, "Temperature", "XDim,YDim",
     1     " ", HE5T_NATIVE_FLOAT, 0)
      write(*,*) 'Status returned by he5_gddeffld():  ',status

c     Set fill value for "Pressure" field
c     -----------------------------------
      status = he5_gdsetfill(gdid2,"Pressure",
     1     HE5T_NATIVE_FLOAT,fillval2)
      write(*,*) 'Status returned by he5_gdsetfill():  ',status

      status = he5_gddeffld(gdid2, "Pressure", "XDim,YDim",
     1     " ", HE5T_NATIVE_FLOAT, 0)
      write(*,*) 'Status returned by he5_gddeffld():  ',status

c     Define Fields
c     -------------	  
      status = he5_gddeffld(gdid2, "Soil Dryness", "XDim,YDim",
     1     " ", HE5T_NATIVE_FLOAT, 0)
      write(*,*) 'Status returned by he5_gddeffld():  ',status

      
      status = he5_gddeffld(gdid2, "Spectra", "XDim,YDim,Bands",
     1     " ", HE5T_NATIVE_DOUBLE, 0)
      write(*,*) 'Status returned by he5_gddeffld():  ',status


c     Detach from the grids
c     ---------------------
	  status = he5_gddetach(gdid1)
      write(*,*) 'Status returned by he5_gddetach():  ',status

	  status = he5_gddetach(gdid2)
      write(*,*) 'Status returned by he5_gddetach():  ',status

      
c     Close the file
c     --------------
	  status = he5_gdclose(gdfid)
      write(*,*) 'Status returned by he5_gdclose():  ',status

	  stop
	  end
      
      

      program       he5_pt_updatelevelsF_32

      integer       status
      integer       ptfid 
      integer       ptid
      integer       level
      integer       rank, datatype

      integer*4     recs(32)
      integer*4     nrec

      integer*4     dimens(2)
      integer*4     num_elements

      real*4        concentration_tt(4)
      real*4        conc(15,4)
      real*4        conc_tt(4)
      real*4        outconc(4,15)
      real*8        time(15)
      real*8        time_tt

      character*8   spc(15)
      character*8   spc_tt

      character*80  fieldname

      integer       datasize_time
      integer       datasize_conc
      integer       datasize_spc
      integer       dtype(3)

      integer       he5_ptopen
      integer       he5_ptattach
      integer       he5_ptupdatelevel 
      integer       he5_ptdetach 
      integer       he5_ptclose


c     Open the HDF-EOS point file, "point.he5"
c     ----------------------------------------
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_ptopen():  ',ptfid

c     Read Simple Point 
c     ----------------- 
      ptid = HE5_PTattach(ptfid, "Simple Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid


      open(unit=1, file='simple_a.txt', status='OLD')

      n = 0
      do 10 i=1,1000
         read(1, *, end=100) time_tt, concentration_tt(1), 
     1                                concentration_tt(2), 
     2                                concentration_tt(3),
     3                                concentration_tt(4), 
     4                                spc_tt
         time(i)     = time_tt
         conc(i,1)   = concentration_tt(1)
         conc(i,2)   = concentration_tt(2)
         conc(i,3)   = concentration_tt(3)
         conc(i,4)   = concentration_tt(4)
         spc(i)      = spc_tt

         n = n + 1
   10 continue

  100 close(unit=1)


      print *,'n = ',n
      do i = 1,n
        print *,time(i)
        print *,conc(i,1),conc(i,2),conc(i,3),conc(i,4)
        print *,spc(i)
      end do

c.....specify the storage size of each atomic field
      datasize_time  = 8
      datasize_conc  = 4*4
      datasize_spc   = 8*1

      dtype(1)     =  HE5T_NATIVE_DOUBLE
      dtype(2)     =  HE5T_NATIVE_FLOAT
      dtype(3)     =  HE5T_NATIVE_CHAR


cc... One way that works
      nrec      = 0
      recs(1)   = 0

cc... Another way that works 
cc      nrec      = n
cc      do i = 1,n
cc         recs(i)   = i-1
cc      end do

      level     = 0

      fieldname = 'Concentration'

cc      conc_tt(1)   = 1.11
cc      conc_tt(2)   = 2.22
cc      conc_tt(3)   = 3.33
cc      conc_tt(4)   = 4.44


c.....Convert array to 'C' order
      dimens(1) = 15
      dimens(2) = 4
      rank      = 2
      datatype  = HE5T_NATIVE_FLOAT

      num_elements   = he5_ptfort2c(dimens, rank, datatype, conc, 
     1outconc)
      write(*,*) 'num_elements returned by he5_ptfort2c():  ',num_elements

c      status = he5_ptupdatelevel(ptid, level, fieldname, nrec,
c     1recs, datasize_conc, dtype(2), conc)
      status = he5_ptupdatelevel(ptid, level, fieldname, nrec,
     1recs, datasize_conc, dtype(2), outconc)
      write(*,*) 'Status returned by he5_ptupdatelevel():  ',status

cc      print *,nrec
cc      print *,recs

      fieldname = 'Time'

cc      time_tt   = 13131313.0

      status = he5_ptupdatelevel(ptid, level, fieldname, nrec,
     1recs, datasize_time, dtype(1), time)
      write(*,*) 'Status returned by he5_ptupdatelevel():  ',status

cc      print *,nrec
cc      print *,recs

      fieldname = 'Species'

cc      spc_tt    = 'AM'

      status = he5_ptupdatelevel(ptid, level, fieldname, nrec,
     1recs, datasize_spc, dtype(3), spc)
      write(*,*) 'Status returned by he5_ptupdatelevel():  ',status

cc      print *,nrec
cc      print *,recs



c.....Close out the point interface
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status


      status = he5_ptclose(ptfid)
      write(*,*) 'Status returned by he5_ptclose():  ',status


      stop
      end

      program       he5_pt_readdataF_32

      implicit      none

      include      'hdfeos5.inc'

      integer       status
      integer       ptfid 
      integer       ptid
      integer       he5_ptopen
      integer       he5_ptattach
      integer       he5_ptreadlevel
      integer       he5_ptlevelinfo 
      integer       he5_ptnrecs
      integer       he5_ptnlevels
      integer       he5_ptnfields
      integer       he5_ptc2fort
      integer       he5_ptinqattrs
      integer       he5_ptreadattr
      integer       he5_ptdetach 
      integer       he5_ptclose
      integer       i
      integer       nflds
      integer       level
      integer       arr_rank
      integer       datatype
      integer       dtype(3)
      integer       attr
      integer       nrecs
      integer       nlevels

      integer*4     dimens(2)
      integer*4     datasize
      integer*4     rank_tt(3)
      integer*4     offset_tt(3)
      integer*4     dtype_tt(3)
      integer*4     dim_sizes_tt(3)
      integer*4     nattr
      integer*4     strbufsize

      character*80  levelname
      character*80  fieldname(3)
      character*80  attrname
      character*240 fieldlist
      character*240 attrlist
      character*8   spec(15)

      real*4        con(4,15)
      real*4        outcon(15,4)
      real*8        time(15)


c     Open the HDF-EOS point file, "point.he5"
c     ----------------------------------------
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDONLY)
      write(*,*) 'File ID returned by he5_ptopen():  ',ptfid

c     Read Simple Point 
c     ----------------- 
      ptid = he5_ptattach(ptfid, "Simple Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid

c     Get level information 
c     --------------------- 
      level = 0

      status = he5_ptlevelinfo(ptid, level, levelname, rank_tt,
     1fieldlist, dim_sizes_tt, datasize, offset_tt, dtype_tt)
      write(*,*) 'Status returned by he5_ptlevelinfo(): ',status

c     Get the number of records in level
c     ---------------------------------- 
      level = 0
      nrecs = he5_ptnrecs(ptid, level)
      print *,'Number of records in level: ', nrecs

      nlevels = he5_ptnlevels(ptid)
      print *,'Number of levels in Point data set: ', nlevels

      nflds = he5_ptnfields(ptid, level, fieldlist, strbufsize)
      print *,'Number of fields in level: ', nflds

c     Populate input information structure 
c     ------------------------------------ 
      dtype(1)     =  HE5T_NATIVE_DOUBLE
      dtype(2)     =  HE5T_NATIVE_FLOAT
      dtype(3)     =  HE5T_NATIVE_CHAR

c     Read the level data and print out
c     --------------------------------- 
      fieldname(1)  = 'Time'

      status = he5_ptreadlevel(ptid, 0, fieldname(1), 
     1dtype(1), time)
      write(*,*) 'Status returned by he5_ptreadlevel():  ',status

      write(*,*) 'time array:    '
      do i = 1,nrecs
        print *,time(i)
      end do

      fieldname(2)  = 'Concentration'

      status = he5_ptreadlevel(ptid, 0, fieldname(2),  
     1dtype(2), con)  
      write(*,*) 'Status returned by he5_ptreadlevel():  ',status

c     Convert 'C' array to Fortran order
c     ---------------------------------- 
      dimens(1) = 15
      dimens(2) = 4
      arr_rank  = 2
      datatype  = HE5T_NATIVE_FLOAT

      status  = he5_ptc2fort(dimens, arr_rank, datatype, con, 
     1outcon)
      write(*,*) 'Status returned by he5_ptc2fort():  ',status

      write(*,*) 'outcon array:    '
      do i = 1,nrecs
        print *,outcon(i,1),outcon(i,2),outcon(i,3),outcon(i,4) 
      end do

      fieldname(3)  = 'Species'

      status = he5_ptreadlevel(ptid, 0, fieldname(3), 
     1dtype(3), spec)  
      write(*,*) 'Status returned by he5_ptreadlevel():  ',status

      write(*,*) 'spec array:    '
      do i = 1,nrecs
        print *,spec(i)
      end do

c.....Close out the point interface
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status

c     Read FixedBuoy Point 
c     -------------------- 
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid

c     Global Attributes
c     -----------------
      attrname       = 'GlobalAttribute_int'

      print *,'   '
      print *,'Global Attribute:   '
      nattr   = he5_ptinqattrs(ptid,attrlist,strbufsize)
      print *,'Number of attributes:  ',nattr
      print *,'Attribute list:  ',attrlist
      print *,'Size (in bytes) of attribute list:  ',strbufsize

      status   = he5_ptreadattr(ptid,attrname,attr)
      write(*,*) 'Status returned by he5_ptreadattr():  ',status
      print *,'Attribute value:    ',attr

c.....Close out the point interface
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status

      status = he5_ptclose(ptfid)
      write(*,*) 'Status returned by he5_ptclose():  ',status


      stop
      end

!     In this program we (1) open the "za.he5" file, (2) attach to
!     the "ZA1" za, and (3) write data to the "Spectra" fields 

      program        he5_za_writedataF_32
      
      implicit       none

      include        'hdfeos5.inc'

      integer        status
      integer        he5_zaopen 
      integer        he5_zaattach 
      integer        he5_zawrite
      integer        he5_zawrattr
      integer        he5_zadetach
      integer        he5_zaclose
      integer        zafid, zaid 
      integer        i, j, k 

      integer*4      attr(4)
      integer*4      start(3)
      integer*4      stride(3)
      integer*4      count(3)

      real*8         plane(800)

      integer        FAIL
      parameter      (FAIL=-1)	


!     Open HDF-EOS file, "za.he5"
!     ---------------------------
      zafid = he5_zaopen("za.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_zaopen():  ',zafid

      if (zafid .NE. FAIL) then
		 zaid = he5_zaattach(zafid, "ZA1")      
         write(*,*) 'ZA ID returned by he5_zaattach():  ',zaid

		 if (zaid .NE. FAIL) then
            
!     Write Spectra one plane at a time 
!     Value is 100 * track index + band index (0-based)
!     -------------------------------------------------
			start(1)  = 0
			start(2)  = 0
			count(1)  = 20
			count(2)  = 40
			count(3)  = 1
			stride(1) = 1
			stride(2) = 1
			stride(3) = 1
	    
			do i=1,15
			   start(3) = i - 1
			   do j=1,40
				  do k=1,20
					 plane((j-1)*20+k) = (j-1)*100 + i-1
				  enddo
			   enddo
			   status = he5_zawrite(zaid,"Spectra",start,
     1              stride,count,plane)
			enddo
	write(*,*) 'Status returned by he5_zawrite(): ',status

		            
!     Write User defined Attribute
!     ----------------------------
			attr(1) = 3
			attr(2) = 5
			attr(3) = 7
			attr(4) = 11
            count(1) = 4
			status = he5_zawrattr(zaid,"TestAttr",HE5T_NATIVE_INT,
     1           count,attr)
            
		 endif
	  endif

!     Detach from the za
!     ------------------
      status = he5_zadetach(zaid)
      write(*,*) 'Status returned by he5_zadetach():  ',status
 
!     Close the file
!     --------------
      status = he5_zaclose(zafid)
      write(*,*) 'Status returned by he5_zaclose():  ',status

      stop
      end

c----------------------------------------------------------------------------
c     Copyright (C) 2000   Emergent IT Inc. and Raytheon Systems Company    |
c----------------------------------------------------------------------------
c testswath32.f                                                             |
c In this program we create, define and write a simple swath hdfeos file    |
c using the swath interface                                                 |
c----------------------------------------------------------------------------

      program   testswath32

      implicit  none
 
      include   'hdfeos5.inc'

      integer   index1, index2, status
      integer   rank, n, dtype, classid, order
      integer   rdattr(4), global_attr(4)
      integer   compparm(5), cnkrank
      integer   rdcompparm(5), compcode
      integer   he5_swopen, he5_swcreate
      integer   swfid, swid, swid2
      integer   he5_swdefdim, he5_swdetach
      integer   he5_swdefgfld, he5_swdefdfld
      integer   he5_swdefmap, he5_swclose, he5_swdefimap
      integer   he5_swsetfill, he5_swwrlattr, he5_swwrattr
      integer   he5_swwrfld, he5_swwrgattr, he5_swdefvrtreg
      integer   he5_swgmapinfo, he5_swrdfld, he5_swfldinfo 
      integer   he5_swmapinfo, he5_swattrinfo, he5_swrdattr
      integer   he5_swgattrinfo, he5_swrdgattr, he5_swrdlattr
      integer   he5_swreginfo, he5_swextreg, he5_swregidx
      integer   he5_swperinfo, he5_swextper
      integer   he5_swlattrinfo, he5_swgetfill, he5_swidtype
      integer   he5_swdefchunk, he5_swdefcomp, he5_swcompinfo
      integer   regionid, regionid2, regionid3, he5_swupimap
      integer   rnkd(4), ntyped(4), rnk(3), ntype(3), nt
      integer   he5_swattach
      integer   he5_swdefboxreg, he5_swdeftmeper, he5_swdupreg

      integer*4 he5_swinqswath, he5_swnentries, he5_swinqmaps
      integer*4 he5_swinqimaps, he5_swinqdims, he5_swdiminfo
      integer*4 he5_swimapinfo, he5_swinqattrs, he5_swinqgattrs
      integer*4 he5_swinqlattrs, he5_swinqgflds, he5_swinqdflds
      integer*4 size, strbufsize, ndims, chunkdims(1)
      integer*4 start(2), stride(2), dataedge(2), geoedge(2)
      integer*4 geostart(2),istart(2),iedge(2),dedge(2)
      integer*4 sd_start(2), sd_stride(2), sd_edge(2)
      integer*4 rd_start(2), rd_stride(2), rd_edge(2)
      integer*4 indexmap(30), dimsize
      integer*4 nattr, nswath, idxsz, nmaps
      integer*4 tstart(1),tstride(1),tedge(1)
      integer*4 strbufsz2, nflds, idxrange(2)
      integer*4 count(1), offset, inc, zero, status4
      integer*4 ndxmap(2), dims(5),latdims(2)
      integer*4 idxmap(50), upidxmap(50)
      integer*4 dim1, dim2, dim3, dim4

      real      grpattr(3), locattr(3), rdgnlattr(3)
      real      ray1(100,40), ray2(40,100)
      real      lat(40,50), lon(40,50), ray4(40,100)
      real      ray3(40,40), temp(40,100)
      real      idxlat(30,30), idxlon(30,30)
      real      latcnt, loncnt, raycnt, idxlatcnt, idxloncnt	
      real      fillvalue, rdfilval, tempbuf(4200)

      real*8    cornerlon(2),cornerlat(2)
      real*8    twodtime(40,50)
      real*8    onedtime(40)
      real*8    range(2)
      real*8    tmcnt, starttime, endtime

      character*(256)  geodim
      character*(256)  idxdimmap
      character*(256)  dimmap, dimname, fieldlist
      character*(256)  attrlist, swathlist
      character*(256)  dimens, maxdims

      dim1          = 30
      dim2          = 40
      dim3          = 50
      dim4          = 100
      count(1)      = 3
      compparm(1)   = 6
      compparm(2)   = 0
      compparm(3)   = 0
      compparm(4)   = 0
      compparm(5)   = 0

      cnkrank       = 1
      chunkdims(1)  = 10

      rdcompparm(1) = 1
      rdcompparm(2) = 1
      rdcompparm(3) = 1
      rdcompparm(4) = 1
      rdcompparm(5) = 1
      compcode      = -1
      raycnt        = -799.0
      tmcnt         = 46353400.0d0
      starttime     = 46353450.0d0
      endtime       = 46500000.0d0
      range(1)      = 46353450.0d0
      range(2)      = 46500000.0d0
      latcnt        = 39.8
      loncnt        = 78.0
      global_attr(1)= 11
      global_attr(2)= 33
      global_attr(3)= 66
      global_attr(4)= 99
      grpattr(1)    = 21.7
      grpattr(2)    = 24.3
      grpattr(3)    = 26.3
      locattr(3)    = 21.7
      locattr(2)    = 24.3
      locattr(1)    = 26.3
      start(1)      = 10
      start(2)      = 10
      tstart(1)     = 0
      tstride(1)    = 1
      tedge(1)      = 40
      geostart(1)   = 0
      geostart(2)   = 0 
      stride(1)     = 1
      stride(2)     = 1
      sd_start(1)   = 0
      sd_start(2)   = 0
      sd_stride(1)  = 1
      sd_stride(2)  = 1
      sd_edge(1)    = 100
      sd_edge(2)    = 40
      rd_start(1)   = 0
      rd_start(2)   = 0
      rd_stride(1)  = 1
      rd_stride(2)  = 1
      rd_edge(1)    = 40
      rd_edge(2)    = 100
      dataedge(1)   = 20
      dataedge(2)   = 50
      geoedge(1)    = 40
      geoedge(2)    = 50
      idxlatcnt     = 39.8
      idxloncnt     = 78.0
      istart(1)     = 0
      istart(2)     = 0
      iedge(1)      = 30
      iedge(2)      = 30
      dedge(1)      = 40
      dedge(2)      = 40
      rank          = 2
      fillvalue     = 16.0
      cornerlon(1)  = 75.0
      cornerlon(2)  = 78.0
      cornerlat(1)  = 38.0
      cornerlat(2)  = 39.8
      indexmap(1)   = 1
      indexmap(2)   = 2
      indexmap(3)   = 3
      indexmap(4)   = 4
      indexmap(5)   = 6
      indexmap(6)   = 7
      indexmap(7)   = 8
      indexmap(8)   = 9
      indexmap(9)   = 11
      indexmap(10)  = 12
      indexmap(11)  = 13
      indexmap(12)  = 14
      indexmap(13)  = 16
      indexmap(14)  = 17
      indexmap(15)  = 18
      indexmap(16)  = 19
      indexmap(17)  = 21
      indexmap(18)  = 22
      indexmap(19)  = 23
      indexmap(20)  = 24
      indexmap(21)  = 26
      indexmap(22)  = 27
      indexmap(23)  = 28
      indexmap(24)  = 29
      indexmap(25)  = 31
      indexmap(26)  = 32
      indexmap(27)  = 33
      indexmap(28)  = 34
      indexmap(29)  = 36
      indexmap(30)  = 37
      zero          = 0

c
c This section of the program just fills some arrays with data that will be
c used later in the program
c
      do 110 index1=1,100
         do 100 index2=1,40
            ray1(index1, index2)=raycnt
            ray2(index2, index1)=raycnt + 1.0
            ray4(index2,index1) = raycnt
            raycnt = raycnt +1.
  100    continue
  110 continue

      do 130 index1=1,40
         do 120 index2=1,50
            lat(index1, index2)=latcnt
            lon(index1, index2)=loncnt
            twodtime(index1,index2)=tmcnt
            loncnt=loncnt-.1
            tmcnt=tmcnt+5.0
  120    continue
         onedtime(index1)=tmcnt
         latcnt=latcnt-0.1
         loncnt = 78.0
  130 continue

      do 150 index1=1,30
         do 140 index2=1,30
            idxlat(index1, index2)=idxlatcnt
            idxlon(index1, index2)=idxloncnt
            idxloncnt=idxloncnt-.1
  140    continue
         idxlatcnt=idxlatcnt-.1
         idxloncnt=78.0
  150 continue


      do 170 index1=1,40
         do 160 index2=1,40
            ray3(index1, index2)=raycnt
            raycnt = raycnt+1.25
  160    continue
  170 continue

      do 987 index1=1,50
         idxmap(index1)=zero
         upidxmap(index1)=zero
  987 continue

  230 format('********Error unexpected**********')
  240 format('***********Passed Test*********')

      open(unit=1, file="testswath32_f.txtout", status = "UNKNOWN")

      write(*,*)'Testing he5_swath FORTRAN 77 interface'
      write(*,*)'======================================'
      write(1,*)'Testing he5_swath FORTRAN 77 interface'
      write(1,*)'======================================'
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swopen
c
      write(*,*)'Testing he5_swopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_swopen '
      write(1,*)'====================='
      swfid=he5_swopen('swath.he5',HE5F_ACC_TRUNC)
      if (swfid .lt. 0) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swfid= he5_swopen("swath.he5",HE5F_ACC_TRUNC)'
         write(*,*)'Value returned by he5_swopen ', swfid
         write(1,*)'swfid= he5_swopen("swath.he5",HE5F_ACC_TRUNC)'
         write(1,*)'Value returned by he5_swopen ', swfid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swcreate
c
      write(1,27)
      write(*,*)'Testing he5_swcreate '
      write(*,*)'====================='
      write(1,*)'Testing he5_swcreate '
      write(1,*)'====================='
      swid=he5_swcreate(swfid,'Simplef')
      if (swid .lt. 0) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swid=he5_swcreate(swfid, "Simplef")'
         write(*,*)'Value returned by he5_swcreate ', swid
         write(1,*)'swid= he5_swcreate(swfid, "Simplef")'
         write(1,*)'Value returned by he5_swcreate ', swid
      endif
      write(*,*)' '
      write(1,*)' '

      swid2=he5_swcreate(swfid,'Indexedf')
      if (swid2 .lt. 0) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	swid2= he5_swcreate(swfid, "Indexedf")'
         write(*,*)'	Value returned by he5_swcreate ', swid2
         write(1,*)'	swid2= he5_swcreate(swfid, "Indexedf")'
         write(1,*)'	Value returned by he5_swcreate ', swid2
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_swdefdim
c
      write(1,27)
      write(*,*)'Testing he5_swdefdim '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdefdim '
      write(1,*)'====================='
      status=he5_swdefdim(swid,'DataTrack',dim4)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_swdefdim(swid, "DataTrack", 100)'
         write(*,*)'	Value returned by he5_swdefdim ',status
         write(1,*)'	status= he5_swdefdim(swid, "DataTrack", 100)'
         write(1,*)'	Value returned by he5_swdefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdim(swid,'DataXtrack',dim2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_swdefdim(swid, "DataXtrack", 40)'
         write(*,*)'	Value returned by he5_swdefdim ',status
         write(1,*)'	status= he5_swdefdim(swid, "DataXtrack", 40)'
         write(1,*)'	Value returned by he5_swdefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdim(swid,'GeoTrack',dim3) 
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_swdefdim(swid, "GeoTrack", 50)'
         write(*,*)'	Value returned by he5_swdefdim ',status
         write(1,*)'	status= he5_swdefdim(swid, "GeoTrack", 50)'
         write(1,*)'	Value returned by he5_swdefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdim(swid,'GeoXtrack',dim2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_swdefdim(swid, "GeoXtrack", 40)'
         write(*,*)'	Value returned by he5_swdefdim ',status
         write(1,*)'	status= he5_swdefdim(swid, "GeoXtrack", 40)'
         write(1,*)'	Value returned by he5_swdefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdim(swid2,'DataTrack',dim2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_swdefdim(swid2, "DataTrack", 40)'
         write(*,*)'	Value returned by he5_swdefdim ', status
         write(1,*)'	status= he5_swdefdim(swid2, "DataTrack", 40)'
         write(1,*)'	Value returned by he5_swdefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdim(swid2,'DataXtrack',dim2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_swdefdim(swid2, "DataXtrack", 40)'
         write(*,*)'	Value returned by he5_swdefdim ', status
         write(1,*)'	status= he5_swdefdim(swid2, "DataXtrack", 40)'
         write(1,*)'	Value returned by he5_swdefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdim(swid2,'GeoTrack',dim1)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_swdefdim(swid2, "GeoTrack", 30)'
         write(*,*)'	Value returned by he5_swdefdim ', status
         write(1,*)'	status= he5_swdefdim(swid2, "GeoTrack", 30)'
         write(1,*)'	Value returned by he5_swdefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdim(swid2,'GeoXtrack',dim1)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_swdefdim(swid2, "GeoXtrack", 30)'
         write(*,*)'	Value returned by he5_swdefdim ', status
         write(1,*)'	status= he5_swdefdim(swid2, "GeoXtrack", 30)'
         write(1,*)'	Value returned by he5_swdefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdim(swid2,'Timedim',dim2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define dimension Timedim '
         write(*,*)'	Value returned by he5_swdefdim ', status
         write(1,*)'Define dimension Timedim '
         write(1,*)'	Value returned by he5_swdefdim ', status
      endif

      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swdefgfld
c
      write(1,27)
      write(*,*)'Testing he5_swdefgfld '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdefgfld '
      write(1,*)'====================='
      status=he5_swdefgfld(swid,'Latitude','GeoXtrack,GeoTrack',
     1' ',HE5T_NATIVE_FLOAT,0)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdefgfld(swid,"Latitude",
     1"GeoXtrack,GeoTrack"," ", HE5T_NATIVE_FLOAT, 0)'
         write(1,*)'status= he5_swdefgfld(swid,"Latitude",
     1"GeoXtrack,GeoTrack"," ", HE5T_NATIVE_FLOAT, 0)'
         write(1,*)'Value returned by he5_swdefgfld ',status
         write(*,*)'Value returned by he5_swdefgfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefgfld(swid,'Longitude','GeoXtrack,GeoTrack',
     1' ',HE5T_NATIVE_FLOAT, 0)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Value returned by he5_swdefgfld ',status
         write(1,*)'Value returned by he5_swdefgfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefgfld(swid2,'Latitude','GeoXtrack,GeoTrack',
     1' ',HE5T_NATIVE_FLOAT, 0)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Value returned by he5_swdefgfld ', status
         write(1,*)'Value returned by he5_swdefgfld ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefgfld(swid2,'Longitude','GeoXtrack,GeoTrack',
     1' ',HE5T_NATIVE_FLOAT, 0)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Value returned by he5_swdefgfld ', status
         write(1,*)'Value returned by he5_swdefgfld ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefgfld(swid2,'Time','Timedim',' ',
     1HE5T_NATIVE_DOUBLE, 0)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define field Time for swath Indexedf '
         write(*,*)'Status returned from call to he5_swdefgfld ',status
         write(1,*)'Define field Time for swath Indexedf '
         write(1,*)'Status returned from call to he5_swdefgfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefgfld(swid,'Time','GeoXtrack,GeoTrack',
     1' ', HE5T_NATIVE_DOUBLE, 0)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdefgfld(swid, "Time","GeoXtrack,GeoTrack",
     1"",HE5T_NATIVE_DOUBLE, 0)'
         write(*,*)'Value returned by he5_swdefgfld ',status
         write(1,*)'status= he5_swdefgfld(swid, "Time","GeoXtrack,GeoTrack",
     1"",HE5T_NATIVE_DOUBLE, 0)'
         write(1,*)'Value returned by he5_swdefgfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swdefdfld
c
      write(1,27)
      write(*,*)'Testing he5_swdefdfld '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdefdfld '
      write(1,*)'====================='

      status=he5_swdefdfld(swid,'SideA','DataXtrack,DataTrack',
     1' ', HE5T_NATIVE_FLOAT, 0)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
        
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define data field SideA '
         write(*,*)'Value returned by he5_swdefdfld ',status
         write(1,*)'Define data field SideA '
         write(1,*)'Value returned by he5_swdefdfld ',status
         write(*,*)' '
         write(1,*)' '
      endif

c Test Case  -- he5_swsetfill
c
      write(1,27)
      write(*,*)'Testing he5_swsetfill '
      write(*,*)'====================='
      write(1,*)'Testing he5_swsetfill '
      write(1,*)'====================='
      status= he5_swsetfill(swid,'Temperature',
     1HE5T_NATIVE_FLOAT, fillvalue)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swsetfill(swid,"Temperature",
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(*,*)'Value returned by he5_swsetfill ',status
         write(1,*)'status=he5_swsetfill(swid,"Temperature",
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(1,*)'Value returned by he5_swsetfill ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdfld(swid,'Temperature',
     1'DataXtrack,DataTrack',' ',HE5T_NATIVE_FLOAT, 0)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define data field Temperature '
         write(*,*)'Value returned by he5_swdefdfld ',status
         write(1,*)'Define data field Temperature '
         write(1,*)'Value returned by he5_swdefdfld ',status
         write(*,*)' '
         write(1,*)' '
      endif

      status= he5_swsetfill(swid,'Conduction',
     1HE5T_NATIVE_FLOAT,fillvalue)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swsetfill(swid,"Conduction",
     1HE5T_NATIVE_FLOAT,fillvalue)'
         write(*,*)'Value returned by he5_swsetfill ',status
         write(1,*)'status=he5_swsetfill(swid,"Conduction",
     1HE5T_NATIVE_FLOAT,fillvalue)'
         write(1,*)'Value returned by he5_swsetfill ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdfld(swid,'Conduction',
     1'DataXtrack,DataTrack',' ',HE5T_NATIVE_FLOAT,0)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdefdfld(swid,"Conduction",
     1"DataXtrack,DataTrack","",HE5T_NATIVE_FLOAT, 0)'
         write(*,*)'Value returned by he5_swdefdfld ',status
         write(1,*)'status= he5_swdefdfld(swid,"Conduction",
     1"DataXtrack,DataTrack","",HE5T_NATIVE_FLOAT, 0)'
         write(1,*)'Value returned by he5_swdefdfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefdfld(swid2,'Sensor1',
     1'DataXtrack,DataTrack',' ',HE5T_NATIVE_FLOAT, 0)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swdefdfld(swid2, "Sensor1",
     1"DataTrack,DataXtrack","",HE5T_NATIVE_FLOAT, 0)'
         write(*,*)'Value returned by he5_swdefdfld ',status
         write(1,*)'status= he5_swdefdfld(swid2, "Sensor1",
     1"DataTrack,DataXtrack","",HE5T_NATIVE_FLOAT, 0)'
         write(1,*)'Value returned by he5_swdefdfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swdefchunk
c
      write(1,27)
      write(*,*)'Testing he5_swdefchunk'
      write(*,*)'======================'
      write(1,*)'Testing he5_swdefchunk'
      write(1,*)'======================'
      status=he5_swdefchunk(swid,cnkrank,chunkdims)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdefchunk(swid, cnkrank, chunkdims)'
         write(*,*)'Value returned by he5_swdefchunk ',status
         write(1,*)'status= he5_swdefchunk(swid, cnkrank, chunkdims)'
         write(1,*)'Value returned by he5_swdefchunk ',status
      endif
      write(*,*)' '
      write(1,*)' '
    
c Test Case -- he5_swdefcomp
c
      write(1,27)
      write(*,*)'Testing he5_swdefcomp'
      write(*,*)'====================='
      write(1,*)'Testing he5_swdefcomp'
      write(1,*)'====================='
      status=he5_swdefcomp(swid,HE5_HDFE_COMP_DEFLATE,compparm)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdefcomp(swid,HE5_HDFE_COMP_DEFLATE,
     1compparm)'
         write(*,*)'Value returned by he5_swdefcomp ',status
         write(1,*)'status= he5_swdefcomp(swid,HE5_HDFE_COMP_DEFLATE,
     1compparm)'
         write(1,*)'Value returned by he5_swdefcomp ',status
      endif
      write(*,*)' '
      write(1,*)' '


      status=he5_swdefdfld(swid,'CompChunk','GeoTrack',
     1' ',HE5T_NATIVE_FLOAT, 0)
      if (status .lt. 0) then
         write(*,230)
         write(1,230) 
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define data field CompChunk '
         write(*,*)'Value returned by he5_swdefdfld ',status
         write(1,*)'Define data field CompChunk '
         write(1,*)'Value returned by he5_swdefdfld ',status
         write(*,*)' '
         write(1,*)' '
      endif

c Test Case -- he5_swdetach
c
      write(1,27)
      write(*,*)'Testing he5_swdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdetach '
      write(1,*)'====================='
      status=he5_swdetach(swid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdetach(swid)'
         write(*,*)'Value returned by he5_swdetach ',status
         write(1,*)'status= he5_swdetach(swid)'
         write(1,*)'Value returned by he5_swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdetach(swid2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdetach(swid2)'
         write(*,*)'Value returned by he5_swdetach ',status
         write(1,*)'status= he5_swdetach(swid2)'
         write(1,*)'Value returned by he5_swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      swid=he5_swattach(swfid,'Simplef')
      if (swid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swid= he5_swattach(swfid, "Simplef")'
         write(*,*)'Value returned by he5_swattach ',swid
         write(1,*)'swid= he5_swattach(swfid, "Simplef")'
         write(1,*)'Value returned by he5_swattach ',swid
      endif
      write(*,*)' '
      write(1,*)' '

      swid2=he5_swattach(swfid,'Indexedf')
      if (swid2 .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swid2= he5_swattach(swfid, "Indexedf")'
         write(*,*)'Value returned by he5_swattach ',swid2
         write(1,*)'swid2= he5_swattach(swfid, "Indexedf")'
         write(1,*)'Value returned by he5_swattach ',swid2
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swdefmap
c
      write(1,27)
      write(*,*)'Testing he5_swdefmap '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdefmap '
      write(1,*)'====================='

      offset = 0
      inc    = 2
      status=he5_swdefmap(swid,'GeoTrack','DataTrack',offset,inc)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdefmap(swid,"GeoTrack",
     1"DataTrack", offset, inc)'
         write(*,*)'Value returned by he5_swdefmap ',status
         write(1,*)'status= he5_swdefmap(swid,"GeoTrack",
     1"DataTrack", offset, inc)'
         write(1,*)'Value returned by he5_swdefmap ',status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swdefimap
c
      write(1,27)
      write(*,*)'Testing he5_swdefimap '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdefimap '
      write(1,*)'====================='
      status=he5_swdefimap(swid2,'GeoTrack','DataTrack',indexmap)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdefimap(swid2, "GeoTrack", 
     1"DataTrack",indexmap)'
         write(*,*)'Value returned by he5_swdefimap ',status
         write(1,*)'status= he5_swdefimap(swid2, "GeoTrack",
     1"DataTrack",indexmap)'
         write(1,*)'Value returned by he5_swdefimap ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swdefimap(swid2,'GeoXtrack','DataXtrack',
     1indexmap)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swdefimap(swid2, "GeoXtrack",
     1"DataXtrack",indexmap)'
         write(*,*)'Value returned by he5_swdefimap ',status
         write(1,*)'status=he5_swdefimap(swid2, "GeoXtrack",
     1"DataXtrack",indexmap)'
         write(1,*)'Value returned by he5_swdefimap ',status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_swdetach
c
      write(1,27)
      write(*,*)'Testing he5_swdetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdetach '
      write(1,*)'====================='
      status= he5_swdetach(swid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdetach(swid)'
         write(*,*)'Value returned by he5_swdetach ',status
         write(1,*)'status= he5_swdetach(swid)'
         write(1,*)'Value returned by he5_swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_swdetach(swid2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdetach(swid2)'
         write(*,*)'Value returned by he5_swdetach ',status
         write(1,*)'status= he5_swdetach(swid2)'
         write(1,*)'Value returned by he5_swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swclose(swfid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)       
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swclose(swfid)'
         write(*,*)'Value returned by he5_swclose ',status
         write(1,*)'status= he5_swclose(swfid)'
         write(1,*)'Value returned by he5_swclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      swfid=he5_swopen('swath.he5',HE5F_ACC_RDWR)
      if (swfid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swfid=he5_swopen("swath.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_swopen ',swfid
         write(1,*)'swfid=he5_swopen("swath.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_swopen ',swfid
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_swattach
c
      write(1,27)
      write(*,*)'Testing he5_swattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_swattach '
      write(1,*)'====================='

      swid=he5_swattach(swfid,'Simplef')
      if (swid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swid= he5_swattach(swfid, "Simplef")'
         write(*,*)'Value returned by he5_swattach ',swid
         write(1,*)'swid= he5_swattach(swfid, "Simplef")'
         write(1,*)'Value returned by he5_swattach ',swid
      endif
      write(*,*)' '
      write(1,*)' '

      swid2=he5_swattach(swfid,'Indexedf')
      if (swid2 .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swid2= he5_swattach(swfid, "Indexedf")'
         write(*,*)'Value returned by he5_swattach ',swid2
         write(1,*)'swid2= he5_swattach(swfid, "Indexedf")'
         write(1,*)'Value returned by he5_swattach ',swid2
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swwrfld
c
      write(1,27)
      write(*,*)'Testing he5_swwrfld '
      write(*,*)'==================='
      write(1,*)'Testing he5_swwrfld '
      write(1,*)'==================='

      status=he5_swwrfld(swid,'SideA',sd_start,stride, 
     1rd_edge, ray4)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Write data field SideA '
         write(*,*)'Value returned by he5_swwrfld ',status
         write(1,*)'Write data field SideA '
         write(1,*)'Value returned by he5_swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swwrfld(swid,'Temperature',start,stride, 
     1dataedge, ray4)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swwrfld(swid,"Temperature",start, 
     1stride,dataedge, ray1)'
         write(*,*)'Value returned by he5_swwrfld ',status
         write(1,*)'status=he5_swwrfld(swid,"Temperature",start, 
     1stride,dataedge, ray1)'
         write(1,*)'Value returned by he5_swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swwrfld(swid,'Conduction',start,stride, 
     1dataedge, ray2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swwrfld(swid,"Conduction",start, 
     1stride,dataedge, ray2)'
         write(*,*)'Value returned by he5_swwrfld ',status
         write(1,*)'status=he5_swwrfld(swid,"Conduction",start, 
     1stride,dataedge, ray2)'
         write(1,*)'Value returned by he5_swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swwrfld(swid,'Latitude',geostart,stride,
     1geoedge,lat)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swwrfld(swid, "Latitude", geostart, 
     1stride, geoedge, lat)'
         write(*,*)'Value returned by he5_swwrfld ',status
         write(1,*)'status= he5_swwrfld(swid, "Latitude", geostart, 
     1stride, geoedge, lat)'
         write(1,*)'Value returned by he5_swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swwrfld(swid,'Longitude',geostart,stride, 
     1geoedge,lon)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swwrfld(swid,"Longitude",geostart,
     1stride,geoedge, lon)'
         write(*,*)'Value returned by he5_swwrfld ',status
         write(1,*)'status= he5_swwrfld(swid,"Longitude",geostart,
     1stride,geoedge, lon)'
         write(1,*)'Value returned by he5_swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swwrfld(swid,'Time',geostart,stride,geoedge,
     1twodtime)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swwrfld(swid,"Time",geostart,stride, 
     1geoedge, twodtime)'
         write(*,*)'Value returned by he5_swwrfld for Time ',status
         write(1,*)'status= he5_swwrfld(swid, "Time", geostart, stride, 
     1geoedge, twodtime)'
         write(1,*)'Value returned by he5_swwrfld for Time ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swwrfld(swid2,'Latitude',istart,stride,
     1iedge,idxlat)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)       
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swwrfld(swid2,"Latitude", 
     1istart,stride,iedge,idxlat)'
         write(*,*)'Value returned by he5_swwrfld ',status
         write(1,*)'status= he5_swwrfld(swid2,"Latitude",
     1istart,stride,iedge,lat)'
         write(1,*)'Value returned by he5_swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swwrfld(swid2,'Longitude',istart,stride, 
     1iedge,idxlon)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swwrfld(swid2,"Longitude", 
     1istart,stride,iedge,idxlon)'
         write(*,*)'Value returned by he5_swwrfld ',status
         write(1,*)'status= he5_swwrfld(swid2,"Longitude",
     1istart,stride,iedge,idxlon)'
         write(1,*)'Value returned by he5_swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swwrfld(swid2,'Time',tstart,tstride,
     1tedge,onedtime)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Write field Time '
         write(*,*)'Status returned by he5_swwrfld ',status
         write(1,*)'Write field Time '
         write(1,*)'Status returned by he5_swwrfld ',status
         write(*,*)' '
         write(1,*)' '
      endif

      iedge(1)=40
      iedge(2)=40
      status=he5_swwrfld(swid2,'Sensor1',istart,stride, 
     1iedge,ray3)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swwrfld(swid2, "Sensor1", 
     1istart, stride, iedge, ray3)'
         write(*,*)'Value returned by he5_swwrfld ',status
         write(1,*)'status= he5_swwrfld(swid2, "Sensor1", 
     1istart, stride, iedge, ray3)'
         write(1,*)'Value returned by he5_swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swwrlattr
c
      write(1,27)
      write(*,*)'Testing he5_swwrlattr, Local Attribute '
      write(*,*)'================================== '
      write(1,*)'Testing he5_swwrlattr, Local Attribute '
      write(1,*)'================================== '
      status=he5_swwrlattr(swid2,'Sensor1','local',
     1HE5T_NATIVE_FLOAT,count,locattr)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swwrlattr(swid2,"Sensor1","local",
     1HE5T_NATIVE_FLOAT,count,locattr)'
         write(*,*)'Value returned by he5_swwrlattr ',status
         write(1,*)'status=he5_swwrlattr(swid2,"Sensor1", "local", 
     1HE5T_NATIVE_FLOAT,count,locattr)'
         write(1,*)'Value returned by he5_swwrlattr ',status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_swwrattr
c
      count(1) = 4

      write(1,27)
      write(*,*)'Testing he5_swwrattr, Global Attribute '
      write(*,*)'====================================== '
      write(1,*)'Testing he5_swwrattr, Global Attribute '
      write(1,*)'======================================= '
      status=he5_swwrattr(swid,'Drift',HE5T_NATIVE_INT,count, 
     1global_attr)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swwrattr(swid, "Drift", 
     1HE5T_NATIVE_INT, count, global_attr)'
         write(*,*)'Value returned by he5_swwrattr ',status
         write(1,*)'status=he5_swwrattr(swid, "Drift", 
     1HE5T_NATIVE_INT, count, global_attr)'
         write(1,*)'Value returned by he5_swwrattr ',status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swwrgattr
c
      count(1) = 3
     
      write(1,27)
      write(*,*)'Testing he5_swwrgattr, Group Attribute '
      write(*,*)'====================================== '
      write(1,*)'Testing he5_swwrgattr, Group Attribute '
      write(1,*)'====================================== '
      status=he5_swwrgattr(swid,'group',HE5T_NATIVE_FLOAT, 
     1count,grpattr)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swwrgattr(swid, "group", 
     1HE5T_NATIVE_FLOAT,count,grpgattr)'
         write(*,*)'Value returned by he5_swwrgattr ',status
         write(1,*)'status=he5_swwrgattr(swid, "group", 
     1HE5T_NATIVE_FLOAT,count,grpattr)'
         write(1,*)'Value returned by he5_swwrgattr ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_swdetach(swid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
      write(*,*)'status= he5_swdetach(swid)'
      write(*,*)'Value returned by he5_swdetach ',status
      write(1,*)'status= he5_swdetach(swid)'
      write(1,*)'Value returned by he5_swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_swdetach(swid2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdetach(swid2)'
         write(*,*)'Value returned by he5_swdetach ',status
         write(1,*)'status= he5_swdetach(swid2)'
         write(1,*)'Value returned by he5_swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_swclose
c
      write(1,27)
      write(*,*)'Testing he5_swclose '
      write(*,*)'==================='
      write(1,*)'Testing he5_swclose '
      write(1,*)'==================='
      status= he5_swclose(swfid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Value returned by he5_swclose ',status
         write(1,*)'status= he5_swclose(swfid)'
         write(1,*)'Value returned by he5_swclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      swfid= he5_swopen('swath.he5',HE5F_ACC_RDWR)
      if (swfid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swfid= he5_swopen("swath.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_swopen ', swfid
         write(1,*)'swfid= he5_swopen("swath.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_swopen ', swfid
      endif
      write(*,*)' '
      write(1,*)' '

      swid= he5_swattach(swfid,'Simplef')
      if (swid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swid= he5_swattach(swfid, "Simplef")'
         write(*,*)'Value returned by he5_swattach ',swid
         write(1,*)'swid= he5_swattach(swfid, "Simplef")'
         write(1,*)'Value returned by he5_swattach ',swid
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_swdetach(swid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdetach(swid)'
         write(*,*)'Value returned by he5_swdetach ',status
         write(1,*)'status= he5_swdetach(swid)'
         write(1,*)'Value returned by he5_swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_swclose(swfid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swclose(swfid)'
         write(*,*)'Value returned by he5_swclose ',status
         write(1,*)'status= he5_swclose(swfid)'
         write(1,*)'Value returned by he5_swclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      swfid= he5_swopen('swath.he5',HE5F_ACC_RDWR)
      if (swfid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swfid= he5_swopen("swath.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_swopen ',swfid
         write(1,*)'swfid= he5_swopen("swath.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_swopen ',swfid
      endif
      write(*,*)' '
      write(1,*)' '

      swid=he5_swattach(swfid,'Simplef')
      if (swid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swid= he5_swattach(swfid, "Simplef")'
         write(*,*)'Value returned by he5_swattach ',swid
         write(1,*)'swid= he5_swattach(swfid, "Simplef")'
         write(1,*)'Value returned by he5_swattach ',swid
      endif
      write(*,*)' '
      write(1,*)' '

      swid2=he5_swattach(swfid,'Indexedf')
      if (swid2 .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swid2= he5_swattach(swfid, "Indexedf")'
         write(*,*)'Value returned by he5_swattach ',swid2
         write(1,*)'swid2= he5_swattach(swfid, "Indexedf")'
         write(1,*)'Value returned by he5_swattach ',swid2
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swdefvrtreg
c
      write(1,27)
      write(*,*)'Testing he5_swdefvrtreg'
      write(*,*)'======================='
      write(1,*)'Testing he5_swdefvrtreg'
      write(1,*)'======================='

      regionid=he5_swdefvrtreg(swid2,HE5_HDFE_NOPREVSUB,'Time',range)
      if (regionid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define region id for field Time '
         write(*,*)'Region id returned by he5_swdefvrtreg ',
     1regionid
         write(1,*)'Define region id for field Time '
         write(1,*)'Region id returned by he5_swdefvrtreg ',
     1regionid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swnentries
c
      write(1,27)
      write(*,*)'Testing he5_swnentries '
      write(*,*)'====================='
      write(1,*)'Testing he5_swnentries '
      write(1,*)'====================='

      nmaps=he5_swnentries(swid,1,strbufsize)
      if (nmaps .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'nmaps= he5_swnentries(swid, 1, strbufsize)'
         write(*,*)'Number of dimension mappings ',nmaps
         write(*,*)'Size of strbufsize ',strbufsize
         write(1,*)'nmaps= he5_swnentries(swid, 1, strbufsize)'
         write(1,*)'Number of dimension mappings ',nmaps
         write(1,*)'Size of strbufsize ',strbufsize
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swinqmaps
c
      write(1,27)
      write(*,*)'Testing he5_swinqmaps '
      write(*,*)'====================='
      write(1,*)'Testing he5_swinqmaps '
      write(1,*)'====================='
      nmaps=he5_swinqmaps(swid, dimmap, offset, inc)
      if (nmaps .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'nmaps=he5_swinqmaps(swid,dimmap,offset,inc)'
         write(*,*)'Dimension mappings ',dimmap
         write(*,*)'offset ',offset
         write(*,*)'increment ',inc
         write(1,*)'nmaps=he5_swinqmaps(swid,dimmap,offset,inc)'
         write(1,*)'Dimension mappings ',dimmap
         write(1,*)'offset ',offset
         write(1,*)'increment ',inc
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swgmapinfo
c
      write(1,27)
      write(*,*)'Testing he5_swgmapinfo '
      write(*,*)'======================'
      write(1,*)'Testing he5_swgmapinfo '
      write(1,*)'======================'
      status = he5_swgmapinfo(swid2,'GeoTrack')
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status = he5_swgmapinfo(swid2, "GeoTrack")'
         write(1,*)'status = he5_swgmapinfo(swid2, "GeoTrack")'
         write(*,*)'Status returned by he5_swgmapinfo ',status
         write(1,*)'Status returned by he5_swgmapinfo ',status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swinqimaps
c
      write(1,27)
      write(*,*)'Testing he5_swinqimaps '
      write(*,*)'====================='
      write(1,*)'Testing he5_swinqimaps '
      write(1,*)'====================='
      nmaps=he5_swinqimaps(swid2, idxdimmap, ndxmap)
      if (nmaps .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'nmaps=he5_swinqimaps(swid2,idxdimmap,ndxmap)'
         write(*,*)'Number of indexed mappings ',nmaps
         write(*,*)'Indexed Dimension mappings ',idxdimmap
         write(*,*)'Index size ',ndxmap
         write(1,*)'nmaps=he5_swinqimaps(swid2,idxdimmap,ndxmap)'
         write(1,*)'Number of indexed mappings ',nmaps
         write(1,*)'Indexed Dimension mappings ',idxdimmap
         write(1,*)'Index size ',ndxmap
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swinqdims
c
      write(1,27)
      write(*,*)'Testing he5_swinqdims '
      write(*,*)'====================='
      write(1,*)'Testing he5_swinqdims '
      write(1,*)'====================='
      ndims=he5_swinqdims(swid,dimname,dims)
      if (ndims .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'ndims= he5_swinqdims(swid, dimname, dims)'
         write(*,*)'Number of dimesions ',ndims
         write(*,*)'Names of dimensions ',dimname
         write(*,*)'Size of dimensions ',dims
         write(1,*)'ndims= he5_swinqdims(swid, dimname, dims)'
         write(1,*)'Number of dimesions ',ndims
         write(1,*)'Names of dimensions ',dimname
         write(1,*)'Size of dimensions ',dims
      endif
      write(*,*)' '
      write(1,*)' '

      ndims= he5_swinqdims(swid2, dimname, dims)
      if (ndims .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'ndims=he5_swinqdims(swid2,dimname,dims)'
         write(*,*)'Number of dimesions ',ndims
         write(*,*)'Names of dimensions ',dimname
         write(*,*)'Size of dimensions ',dims
         write(1,*)'ndims=he5_swinqdims(swid2,dimname,dims)'
         write(1,*)'Number of dimesions ',ndims
         write(1,*)'Names of dimensions ',dimname
         write(1,*)'Size of dimensions ',dims
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swinqgflds
c
      write(1,27)
      write(*,*)'Testing he5_swinqgflds '
      write(*,*)'======================'
      write(1,*)'Testing he5_swinqgflds '
      write(1,*)'======================'

      nflds= he5_swinqgflds(swid,fieldlist,rnk,ntype)
      if (nflds .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'nflds=he5_swinqgflds(swid,fieldlist,rnk,ntype)'
         write(*,*)'Number of geolocation fields in swath ',nflds
         write(*,*)'Names of geolocation fields ',fieldlist
         write(*,*)'Rank of fields ',rnk
         write(*,*)'Number type of fields ',ntype
         write(1,*)'nflds=he5_swinqgflds(swid,fieldlist,rnk,ntype)'
         write(1,*)'Number of geolocation fields in swath ',nflds
         write(1,*)'Names of geolocation fields ',fieldlist
         write(1,*)'Rank of fields ',rnk
         write(1,*)'Number type of fields ',ntype
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swinqdflds
c
      write(1,27)
      write(*,*)'Testing he5_swinqdflds '
      write(*,*)'======================'
      write(1,*)'Testing he5_swinqdflds '
      write(1,*)'======================'
      nflds=he5_swinqdflds(swid,fieldlist,rnkd,ntyped)
      if (nflds .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'nflds=he5_swinqdflds(swid,fieldlist,rnkd,ntyped)'
         write(*,*)'Number of data fields in swath ',nflds
         write(*,*)'Names of data fields ',fieldlist
         write(*,*)'Rank of fields ',rnkd
         write(*,*)'Number type of fields ',ntyped
         write(1,*)'nflds=he5_swinqdflds(swid,fieldlist,rnkd,ntyped)'
         write(1,*)'Number of data fields in swath ',nflds
         write(1,*)'Names of data fields ',fieldlist
         write(1,*)'Rank of fields ',rnkd
         write(1,*)'Number type of fields ',ntyped
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swdiminfo
c
      write(1,27)
      write(*,*)'Testing he5_swdiminfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdiminfo '
      write(1,*)'====================='
      dimsize= he5_swdiminfo(swid,'DataTrack')
      if (dimsize .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'dimsize= he5_swdiminfo(swid, "DataTrack")'
         write(*,*)'Size of dimension DataTrack ',dimsize
         write(1,*)'dimsize= he5_swdiminfo(swid, "DataTrack")'
         write(1,*)'Size of dimension DataTrack ',dimsize
         write(*,*)' '
         write(1,*)' '
      endif

c Test Case -- he5_swrdfld
c
      write(1,27)
      write(*,*)'Testing he5_swrdfld '
      write(*,*)'==================='
      write(1,*)'Testing he5_swrdfld '
      write(1,*)'==================='

      rd_start(1)=0
      rd_start(2)=0
      rd_stride(1)=1
      rd_stride(2)=1
      rd_edge(1)=40
      rd_edge(2)=100
      status= he5_swrdfld(swid,'Conduction',rd_start,
     1rd_stride,rd_edge,temp)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Value returned by he5_swrdfld ',status
         write(*,*)'status= he5_swrdfld(swid, "Conduction", 
     1rd_start,rd_stride, rd_edge, temp)'
         write(1,*)'status= he5_swrdfld(swid, "Conduction", 
     1rd_start,rd_stride, rd_edge, temp)'
         write(1,*)'Value returned by he5_swrdfld ',status
         do 190 index1=10,15
            do 180 index2=10,15
               write(*,*)'value of conduction ',temp(index1,index2)
               write(1,*)'value of conduction ',temp(index1,index2)
  180       continue
  190    continue
      endif

      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swfldinfo
c
      write(1,27)
      write(*,*)'Testing he5_swfldinfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_swfldinfo '
      write(1,*)'====================='
      status=he5_swfldinfo(swid,'Latitude',rank,latdims,nt,
     1dimens,maxdims)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swfldinfo(swid, "Latitude", 
     1rank, latdims, nt, dimens, maxdims)'
         write(*,*)'Value returned by he5_swfldinfo ',status
         write(*,*)'Rank of field latitude ',rank
         write(*,*)'dimension list of field latitude ',dimens
         write(*,*)'Size of latitude dimensions ',latdims
         write(*,*)'number type of field latitude ',nt
         write(1,*)'status= he5_swfldinfo(swid, "Latitude", 
     1rank, latdims, nt, dimens, maxdims)'
         write(1,*)'Value returned by he5_swfldinfo ',status
         write(1,*)'Rank of field latitude ',rank
         write(1,*)'dimension list of field latitude ',dimens
         write(1,*)'Size of latitude dimensions ',latdims
         write(1,*)'number type of field latitude ',nt
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swmapinfo
c
      write(1,27)
      write(*,*)'Testing he5_swmapinfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_swmapinfo '
      write(1,*)'====================='
      status=he5_swmapinfo(swid,'GeoTrack','DataTrack',offset,inc)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swmapinfo(swid,"GeoTrack","DataTrack", 
     1offset,inc)'
         write(*,*)'Value returned by he5_swmapinfo ',status
         write(*,*)'Offset ',offset,' Increment ',inc
         write(1,*)'status=he5_swmapinfo(swid,"GeoTrack","DataTrack", 
     1offset,inc)'
         write(1,*)'Value returned by he5_swmapinfo ',status
         write(1,*)'Offset ',offset,' Increment ',inc
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swimapinfo
c
      write(1,27)
      write(*,*)'Testing he5_swimapinfo '
      write(*,*)'======================'
      write(1,*)'Testing he5_swimapinfo '
      write(1,*)'======================'
      status4=he5_swimapinfo(swid2,'GeoXtrack','DataXtrack',idxmap)
      if (status4 .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status4= he5_swimapinfo(swid2,"GeoXtrack",
     1"DataXtrack", idxmap)'
         write(*,*)'Value returned by he5_swimapinfo ',status4
         do 980 index1=1,30
            write(*,*)' Value of index array ',idxmap(index1)
            write(1,*)' Value of index array ',idxmap(index1)
  980    continue
         write(1,*)'status4= he5_swimapinfo(swid2, "GeoXtrack", 
     1"DataXtrack",idxmap)'
         write(1,*)'Value returned by he5_swimapinfo ',status4
         write(1,*)'Indexed map values ',idxmap
      endif
      write(*,*)' '
      write(1,*)' '
 
c Test Case -- he5_swinqattrs
c
      write(1,27)
      write(*,*)'Testing he5_swinqattrs Global attributes '
      write(*,*)'==================================== '
      write(1,*)'Testing he5_swinqattrs Global attributes '
      write(1,*)'==================================== '

      nattr = he5_swinqattrs(swid,attrlist,strbufsz2)
      if (nattr .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Number of global attributes in swath ',nattr
         write(*,*)'Attribute list of swath ',attrlist
         write(1,*)'Number of global attributes in swath ',nattr
         write(1,*)'Attribute list of swath ',attrlist
         write(*,*)' '
         write(1,*)' '
      endif

c Test Case -- he5_swattrinfo
c
      write(1,27)
      write(*,*)'Testing he5_swattrinfo Global attribute'
      write(*,*)'======================================='
      write(1,*)'Testing he5_swattrinfo Global attribute'
      write(1,*)'======================================='
      status= he5_swattrinfo(swid, attrlist, n, size)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swattrinfo(swid,attrlist,n,size)'
         write(*,*)'Value returned by he5_swattrinfo ',status
         write(*,*)'Number type of attributes ',n,' Size ',size
         write(1,*)'status=he5_swattrinfo(swid,attrlist,n,size)'
         write(1,*)'Value returned by he5_swattrinfo ',status
         write(1,*)'Number type of attributes ',n,' Size ',size
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swrdattr
c
      write(1,27)
      write(*,*)'Testing he5_swrdattr, Global attribute '
      write(*,*)'======================================'
      write(1,*)'Testing he5_swrdattr, Global attribute '
      write(1,*)'======================================'

      status= he5_swrdattr(swid, attrlist, rdattr)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swrdattr(swid,attrlist,rdattr)'
         write(*,*)'Value returned by he5_swrdattr ',status
         write(*,*)'attribute ',rdattr
         write(1,*)'status=he5_swrdattr(swid,attrlist,rdattr)'
         write(1,*)'Value returned by he5_swrdattr ',status
         write(1,*)'attribute ',rdattr
      endif
      write(*,*)' '
      write(1,*)' '

c     Test Case -- he5_swinqgattrs
c
      write(1,27)
      write(*,*)'Testing he5_swinqgattrs Group attributes '
      write(*,*)'==================================== '
      write(1,*)'Testing he5_swinqgattrs Group attributes '
      write(1,*)'==================================== '

      nattr = he5_swinqgattrs(swid,attrlist,strbufsz2)
      if (nattr .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Number of group attributes in swath ',nattr
         write(*,*)'Attribute list of swath ',attrlist
         write(1,*)'Number of group attributes in swath ',nattr
         write(1,*)'Attribute list of swath ',attrlist
         write(*,*)' '
         write(1,*)' '
      endif

c Test Case -- he5_swgattrinfo
c
      write(1,27)
      write(*,*)'Testing he5_swgattrinfo Group attribute'
      write(*,*)'======================================='
      write(1,*)'Testing he5_swgattrinfo Group attribute'
      write(1,*)'======================================='
      status= he5_swgattrinfo(swid, attrlist, n, size)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swgattrinfo(swid,attrlist,n,size)'
         write(*,*)'Value returned by he5_swgattrinfo ',status
         write(*,*)'Number type of attributes ',n,' Size ',size
         write(1,*)'status=he5_swgattrinfo(swid,attrlist,n,size)'
         write(1,*)'Value returned by he5_swgattrinfo ',status
         write(1,*)'Number type of attributes ',n,' Size ',size
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swrdgattr
c
      write(1,27)
      write(*,*)'Testing he5_swrdgattr, Group attribute '
      write(*,*)'======================================'
      write(1,*)'Testing he5_swrdgattr, Group attribute '
      write(1,*)'======================================'

       status= he5_swrdgattr(swid,'group',rdgnlattr)
       if (status .lt. 0) then
          write(*,230)
          write(1,230)
       else
          write(*,*)'  '
          write(*,240)
          write(1,*)'  '
          write(1,240)
          write(*,*)'status=he5_swrdgattr(swid,attrlist,rdgnlattr)'
          write(*,*)'Value returned by he5_swrdgattr ',status
          write(*,*)'attribute ',rdgnlattr
          write(1,*)'status=he5_swrdgattr(swid,attrlist,rdgnlattr)'
          write(1,*)'Value returned by he5_swrdgattr ',status
          write(1,*)'attribute ',rdgnlattr
       endif
       write(*,*)' '
       write(1,*)' '

c Test Case -- he5_swinqlattrs
c
      write(1,27)
      write(*,*)'Testing he5_swinqlattrs Local attributes '
      write(*,*)'==================================== '
      write(1,*)'Testing he5_swinqlattrs Local attributes '
      write(1,*)'==================================== '

      nattr=he5_swinqlattrs(swid2,'Sensor1',attrlist,strbufsz2)
      if (nattr .lt. 0) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swinqlattrs(... "Sensor1" ...)'
         write(*,*)'Number of local attributes in field',nattr
         write(*,*)'Attribute list of field ',attrlist
         write(1,*)'swinqlattrs(... "Sensor1" ...)'
         write(1,*)'Number of local attributes in field',nattr
         write(1,*)'Attribute list of field ',attrlist
         write(*,*)' '
         write(1,*)' '
      endif

c Test Case -- he5_swlattrinfo
c
      write(1,27)
      write(*,*)'Testing he5_swlattrinfo Local attribute'
      write(*,*)'======================================='
      write(1,*)'Testing he5_swlattrinfo Local attribute'
      write(1,*)'======================================='
      status=he5_swlattrinfo(swid2,'Sensor1','local',n,size)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swlattrinfo(... "Sensor1" ...)'
         write(*,*)'Value returned by he5_swlattrinfo ',status
         write(*,*)'Number type of attributes ',n,' Size ',size
         write(1,*)'swlattrinfo(... "Sensor1" ...)'
         write(1,*)'Value returned by he5_swlattrinfo ',status
         write(1,*)'Number type of attributes ',n,' Size ',size
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swidtype
c
      write(1,27)
      write(*,*)'Testing he5_swidtype, Inquire Datatype '
      write(*,*)'======================================='
      write(1,*)'Testing he5_swidtype, Inquire Datatype '
      write(1,*)'======================================='

      status= he5_swidtype(swid2,'Sensor1','local', 
     1HE5_HDFE_LOCATTRGROUP,dtype,classid, order, size)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swidtype(swid2,"Sensor1","local", 
     1HE5_HDFE_LOCATTRGROUP,dtype, classid, order, size)'
         write(*,*)'Value returned by he5_swidtype ',status
         write(*,*)'Datatype of local attribute ',dtype
         write(*,*)'Class id and order ',classid, order
         write(*,*)'Size of attribute ',size
         write(1,*)'status= he5_swidtype(swid2,"Sensor1","local", 
     1HE5_HDFE_LOCATTRGROUP,dtype, classid, order, size)'
         write(1,*)'Value returned by he5_swidtype ',status
         write(1,*)'Datatype of local attribute ',dtype
         write(1,*)'Class id and order ',classid, order
         write(1,*)'Size of attribute ',size
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_swrdlattr
c
      write(1,27)
      write(*,*)'Testing he5_swrdlattr, Local attribute '
      write(*,*)'======================================'
      write(1,*)'Testing he5_swrdlattr, Local attribute '
      write(1,*)'======================================'

      status=he5_swrdlattr(swid2,'Sensor1','local',rdgnlattr)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swrdlattr(swid2,"Sensor1","local", 
     1rdgnlattr)'
         write(*,*)'Value returned by he5_swrdlattr ',status
         write(*,*)'attribute ',rdgnlattr
         write(1,*)'status=he5_swrdlattr(swid2,"Sensor1","local", 
     1rdgnlattr)'
         write(1,*)'Value returned by he5_swrdlattr ',status
         write(1,*)'attribute ',rdgnlattr
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swgetfill
c
      write(1,27)
      write(*,*)'Testing he5_swgetfill '
      write(*,*)'====================='
      write(1,*)'Testing he5_swgetfill '
      write(1,*)'====================='
      status= he5_swgetfill(swid,'Conduction', rdfilval)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swgetfill(swid,"Conduction",rdfilval)'
         write(*,*)'Value returned by he5_swgetfill ',status
         write(*,*)'Value of fill ',rdfilval
         write(1,*)'status=he5_swgetfill(swid,"Conduction",rdfilval)'
         write(1,*)'Value returned by he5_swgetfill ',status
         write(1,*)'Value of fill ',rdfilval
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swdefboxreg
c
      write(1,27)
      write(*,*)'Testing he5_swdefboxreg '
      write(*,*)'======================='
      write(1,*)'Testing he5_swdefboxreg '
      write(1,*)'======================='

      regionid= he5_swdefboxreg(swid, cornerlon, cornerlat, 
     1HE5_HDFE_ENDPOINT)
      if (regionid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'regionid= he5_swdefboxreg(swid,cornerlon,
     1cornerlat, HE5_HDFE_ENDPOINT)'
         write(*,*)'Value returned by he5_swdefboxreg ',regionid
         write(1,*)'regionid= he5_swdefboxreg(swid, cornerlon, 
     1cornerlat, HE5_HDFE_ENDPOINT)'
         write(1,*)'Value returned by he5_swdefboxreg ',regionid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swregidx
c
      write(1,27)
      write(*,*)'Testing he5_swregidx '
      write(*,*)'===================='
      write(1,*)'Testing he5_swregidx '
      write(1,*)'===================='

      idxrange(1)=0
      idxrange(2)=0
      regionid3=he5_swregidx(swid,cornerlon,cornerlat, 
     1HE5_HDFE_ENDPOINT,geodim,idxrange)
      if (regionid3 .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'regionid3=he5_swregidx(swid,cornerlon, 
     1cornerlat,HE5_HDFE_ENDPOINT,geodim,idxrange)'
         write(*,*)'Region ID returned by he5_swregdex ',regionid3
         write(*,*)'Geodim of region ',geodim
         write(*,*)'indicies of region ',idxrange(1),idxrange(2)
         write(1,*)'regionid3=he5_swregidx(swid, cornerlon, 
     1cornerlat, HE5_HDFE_ENDPOINT, geodim, idxrange)'
         write(1,*)'Region ID returned by he5_swregdex ',regionid3
         write(1,*)'Geodim of region ',geodim
         write(1,*)'indicies of region ',idxrange(1),idxrange(2)
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_swdupreg
c
      write(1,27)
      write(*,*)'Testing he5_swdupreg '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdupreg '
      write(1,*)'====================='

      regionid2= he5_swdupreg(regionid)
      if (regionid2 .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Duplicate region id information '
         write(*,*)'Region ID returned by he5_swdupreg ',regionid2
         write(1,*)'Duplicate region id information '
         write(1,*)'Region ID returned by he5_swdupreg ',regionid2
         write(*,*)' '
         write(1,*)' '
      endif

c Test Case -- he5_swreginfo
c
      write(1,27)
      write(*,*)'Testing he5_swreginfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_swreginfo '
      write(1,*)'====================='
      status=he5_swreginfo(swid,regionid,'Temperature',nt,rank, 
     1dims,size)      
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swreginfo(swid,regionid,"Temperature", 
     1nt, rank, dims, size)'
         write(*,*)'Value returned by he5_swreginfo ',status
         write(*,*)'Number type of region ',nt,' Rank of region ',rank
         write(*,*)'Dimensions of region ',dims(1),' ',dims(2)
         write(*,*)'Value of size ',size
         write(1,*)'status=he5_swreginfo(swid,regionid,"Temperature", 
     1nt, rank, dims, size)'
         write(1,*)'Value returned by he5_swreginfo ',status
         write(1,*)'Number type of region ',nt,' Rank of region ',rank
         write(1,*)'Value of size ',size
         write(1,*)'Dimensions of region ',dims(1),' ',dims(2)
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swextreg
c
      write(1,27)
      write(*,*)'Testing he5_swextreg '
      write(*,*)'====================='
      write(1,*)'Testing he5_swextreg '
      write(1,*)'====================='
      status=he5_swextreg(swid,regionid,'Temperature', 
     1HE5_HDFE_INTERNAL, tempbuf) 
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status = he5_swextreg(swid, regionid, 
     1"Temperature", HE5_HDFE_INTERNAL, tempbuf)'
         write(*,*)'Value returned by he5_swextreg ', status
         write(1,*)'status = he5_swextreg(swid, regionid, 
     1"Temperature", HE5_HDFE_INTERNAL,tempbuf)'
         write(1,*)'Value returned by he5_swextreg ', status
         do 210 index1=100,115
            write(*,*)'region value at position ',tempbuf(index1)
            write(1,*)'region value at position ',tempbuf(index1)
  210    continue
      endif

      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swdeftmeper
c
      write(1,27)
      write(*,*)'Testing he5_swdeftmeper '
      write(*,*)'====================='
      write(1,*)'Testing he5_swdeftmeper '
      write(1,*)'====================='
      regionid = he5_swdeftmeper(swid, starttime, endtime, 
     1HE5_HDFE_ENDPOINT)
      if (regionid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'regionid= he5_swdeftmeper(swid, starttime, 
     1endtime, HE5_HDFE_ENDPOINT)'
         write(*,*)'Value returned by he5_swdeftmeper ',regionid
         write(1,*)'regionid= he5_swdeftmeper(swid, starttime, 
     1endtime, HE5_HDFE_ENDPOINT)'
         write(1,*)'Value returned by he5_swdeftmeper ',regionid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swperinfo
c
      write(1,27)
      write(*,*)'Testing he5_swperinfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_swperinfo '
      write(1,*)'====================='
      status = he5_swperinfo(swid,regionid,'Temperature',nt,rank,
     1dims,size)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status = he5_swperinfo(swid, regionid,
     1"Temperature",nt, rank, dims, size)'
         write(*,*)'Value returned by he5_swperinfo ',status
         write(*,*)'Rank of field ',rank,' Number type of region ',nt
         write(*,*)'Dimensions of region ',dims(1),' ',dims(2)
         write(*,*)'Value of size ',size
         write(1,*)'status = he5_swperinfo(swid, regionid,
     1"Temperature",nt, rank, dims, size)'
         write(1,*)'Value returned by he5_swperinfo ',status
         write(1,*)'Rank of field ',rank,' Number type of region ',nt
         write(1,*)'Dimensions of region ',dims(1),' ',dims(2)
         write(1,*)'Value of size ',size
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swextper
c
      write(1,27)
      write(*,*)'Testing he5_swextper '
      write(*,*)'===================='
      write(1,*)'Testing he5_swextper '
      write(1,*)'===================='
      status= he5_swextper(swid,regionid,'Temperature', 
     1HE5_HDFE_INTERNAL,tempbuf)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swextper(swid, regionid, 
     1"Temperature", HE5_HDFE_INTERNAL, tempbuf)'
         write(*,*)'Value returned by he5_swextper swath ',status
         write(1,*)'status= he5_swextper(swid, regionid, 
     1"Temperature", HE5_HDFE_INTERNAL, tempbuf) '
         write(1,*)'Value returned by he5_swextper swath ',status
         do 220 index1=1000,1015
            write(*,*)'region value at position ',tempbuf(index1)
            write(1,*)'region value at position ',tempbuf(index1)
  220    continue
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- he5_swupimap
c
      write(1,27)
      write(*,*)'Testing he5_swupimap '
      write(*,*)'====================='
      write(1,*)'Testing he5_swupimap '
      write(1,*)'====================='
      idxsz=he5_swupimap(swid2,regionid,idxmap,upidxmap,ndxmap)
      if (idxsz .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Size of index array in region ',idxsz
         write(1,*)'Size of index array in region ',idxsz
         write(*,*)'Indicies of updated index ',ndxmap(1),ndxmap(2)
         write(1,*)'Indicies of updated index ',ndxmap(1),ndxmap(2)
         do 380 index1=1,idxsz
            write(*,*)' Value of index array ',upidxmap(index1)
            write(1,*)' Value of index array ',upidxmap(index1)
  380    continue
      endif



c Test Case -- he5_swcompinfo
c
      write(1,27)
      write(*,*)'Testing he5_swcompinfo '
      write(*,*)'======================='
      write(1,*)'Testing he5_swcompinfo '
      write(1,*)'======================='
      status=he5_swcompinfo(swid,'CompChunk',compcode,rdcompparm)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_swcompinfo(swid,"CompChunk",compcode, 
     1rdcompparm)'
         write(*,*)'Status returned by he5_swcompinfo ',status
         write(*,*)'Compression code ',compcode
         write(*,*)'Compression parameter ',rdcompparm(1)
         write(1,*)'status=he5_swcompinfo(swid,"CompChunk",compcode, 
     1rdcompparm)'
         write(1,*)'Status returned by he5_swcompinfo ',status
         write(1,*)'Compression code ',compcode
         write(1,*)'Compression parameter ',rdcompparm(1)
      endif
      write(*,*)' '
      write(1,*)' '



      status= he5_swdetach(swid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdetach(swid)'
         write(*,*)'Value returned by he5_swdetach ',status
         write(1,*)'status= he5_swdetach(swid)'
         write(1,*)'Value returned by he5_swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_swdetach(swid2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swdetach(swid2)'
         write(*,*)'Value returned by he5_swdetach ',status
         write(1,*)'status= he5_swdetach(swid2)'
         write(1,*)'Value returned by he5_swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_swclose(swfid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swclose(swfid)'
         write(*,*)'Value returned by he5_swclose ',status
         write(1,*)'status= he5_swclose(swfid)'
         write(1,*)'Value returned by he5_swclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      swfid=he5_swopen('swath.he5',HE5F_ACC_RDWR)
      if (swfid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'swfid=he5_swopen("swath.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_swopen ',swfid
         write(1,*)'swfid=he5_swopen("swath.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_swopen ',swfid
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- he5_swinqswath
c
      write(1,27)
      write(*,*)'Testing he5_swinqswath '
      write(*,*)'======================'
      write(1,*)'Testing he5_swinqswath '
      write(1,*)'======================'

      nswath=he5_swinqswath('swath.he5',swathlist,strbufsz2)
      if (nswath .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Retrieve information on swaths in 
     1file swath.he5'
         write(*,*)'Number of swaths in file ', nswath
         write(*,*)'List of swaths ',swathlist
         write(1,*)'Retrieve information on swaths in 
     1file swath.he5'
         write(1,*)'Number of swaths in file ', nswath
         write(1,*)'List of swaths ',swathlist
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_swclose(swfid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)       
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_swclose(swfid)'
         write(*,*)'Value returned by he5_swclose ',status
         write(1,*)'status= he5_swclose(swfid)'
         write(1,*)'Value returned by he5_swclose ',status
      endif
      write(*,*)' '
      write(1,*)' '

      close(unit=1)
   27 format(' ')
      stop
      end

!
! ----------------------------------------------------------------------------
! |    Copyright (C) 2002   Emergent IT Inc. and Raytheon Systems Company    |
! ----------------------------------------------------------------------------
!
      program            he5_za_wrexternaldataF_64

      implicit           none
 
      include            'hdfeos5.inc'

      integer            i
      integer            status
      integer            he5_zaopen
      integer            he5_zaattach
      integer            he5_zawrite
      integer            he5_ehrdwrfile
      integer            he5_zadetach
      integer            he5_zaclose
      integer            zafid, zaid

      integer            data_out_1(100)
      integer            data_out_2(100)
      integer            data_out_3(100)
      integer            data(60)

      integer*8          start(2)
      integer*8          stride(2)
      integer*8          count(2)
      integer*8          num_elements

      integer            FAIL
      parameter          (FAIL=-1)

!.....Use this for writing (only) to an existing file
      integer            WRITE_EXISTING_ONLY
      parameter          (WRITE_EXISTING_ONLY=0)

!.....Use this for reading (only) from an existing file
      integer            READ_ONLY
      parameter          (READ_ONLY=1)

!.....Use this for creating and writing to a file
      integer            WRITE_NEW
      parameter          (WRITE_NEW=2)


!     Create the new data buffer
!     --------------------------
      do 10 i=1,60
         data(i) = 9999
 10   continue
      
!     Open HDF-EOS za file, "za.he5"
!     ------------------------------
	  zafid = he5_zaopen("za.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned from he5_zaopen():  ',zafid

	  if (zafid .NE. FAIL) then
		 zaid = he5_zaattach(zafid, "ZA1")
         write(*,*) 'ZA ID returned from he5_zaattach():  ',zaid

		 if (zaid .NE. FAIL) then
			
!     Write new data to the external files 
!     ------------------------------------
      start(1)  = 0
      stride(1) = 1
      count(1)  = 60

      status = he5_zawrite(zaid,"ExtData",
     1     start,stride,count,data)
      write(*,*) 'Status returned  from he5_zawrite():  ',status

      num_elements = 100

      status = he5_ehrdwrfile("extf1.dat",READ_ONLY,
     1HE5T_NATIVE_INT,num_elements,data_out_1)
      write(*,*) 'Status returned from he5_ehrdwrfile:   ',status

      status = he5_ehrdwrfile("extf2.dat",READ_ONLY,
     1HE5T_NATIVE_INT,num_elements,data_out_2)
      write(*,*) 'Status returned from he5_ehrdwrfile:   ',status

      status = he5_ehrdwrfile("extf3.dat",READ_ONLY,
     1HE5T_NATIVE_INT,num_elements,data_out_3)
      write(*,*) 'Status returned from he5_ehrdwrfile:   ',status


      write(*,*)'External file extf1.dat:'
      write(*,*) data_out_1
      write(*,*) '  '

      write(*,*)'External file extf2.dat:'
      write(*,*) data_out_2
      write(*,*) '  '

      write(*,*)'External file extf3.dat:'
      write(*,*) data_out_3
      write(*,*) '  '

		 endif
	  endif
	
!     Detach from swath
!     -----------------
	  status = he5_zadetach(zaid)
      write(*,*) 'Status returned from he5_zadetach():  ',status

!     Close the file
!     --------------
	  status = he5_zaclose(zafid)
      write(*,*) 'Status returned from he5_zaclose():  ',status     

	  stop
	  end

c----------------------------------------------------------------------------
c     Copyright (C) 2000   Emergent IT Inc. and Raytheon Systems Company    |
c----------------------------------------------------------------------------
c testgrid32.f                                                                |
c In this program we create, define and write a simple grid hdfeos file     |
c using the grid interface                                                  |
c----------------------------------------------------------------------------


      program       testgrid32

      implicit      none
 
      include       'hdfeos5.inc'
 
      integer       zero
      integer       rnk(8), numtype(8)
      integer       zcode, scode, nflds
      integer       regionid, regionid2, regionid3, regionid4
      integer       dtype, classid, order
      integer       status, i, ii
      integer       compparm(5)
      integer 	    gdfid, gdfid2, gdfid3, gdid_utm, gdid2, gdid3
      integer 	    zonecode, pixregcode, orgcode
      integer	    attr(4), iattr(4), gattr(4), lattr(4)
      integer 	    spherecode
      integer	    he5_gdopen, he5_gdcreate
      integer	    he5_gdclose, he5_gddefproj
      integer	    he5_gddeftle, he5_gddeffld
      integer	    he5_gdwrattr, he5_gdwrgattr
      integer	    he5_gddefcomp, he5_gdinqflds
      integer	    he5_gdrdfld, he5_gdattrinfo
      integer	    he5_gdlatinfo, he5_gdrdattr
      integer	    he5_gdreginfo, he5_gddeftmeper
      integer	    he5_gddeforigin, he5_gddefpreg
      integer	    he5_gdgridinfo, he5_gdcompinfo
      integer	    he5_gdgetpix, he5_gddupreg
      integer	    he5_gdattach, he5_gddetach
      integer	    he5_gddefdim, he5_gdinqdatatype
      integer	    he5_gdsetfill, he5_gdwrfld
      integer	    he5_gdwrlattr, he5_gdorginfo
      integer	    he5_gdprojinfo, he5_gdgatinfo
      integer	    he5_gdrdgattr, he5_gdrdlattr
      integer	    he5_gddefvrtreg
      integer	    he5_gdinqdims, he5_gdgetfill
      integer	    he5_gdfldinfo, he5_gddefboxreg
      integer	    he5_gdpreginfo, he5_gdextreg
      integer 	    nt(4), rk(4)

      integer*4 	xdim, ydim
      integer*4	    he5_gdinqgrid, he5_gddiminfo
      integer*4	    he5_gdinqattrs, he5_gdinqgattrs
      integer*4	    he5_gdgetpixval, he5_gdinterpolate
      integer*4	    he5_gdnentries, he5_gdinqlattrs
      integer*4     index1
      integer*4  	index2
      integer*4	    dimsizes(2)
      integer*4 	tiledims(2), tilecords(2)
      integer*4 	ntype, count
      integer*4 	rowval(5), colval(5)
      integer*4 	lat(40,50)
      integer*4 	latcnt
      integer*4 	lon(40,50)
      integer*4 	loncnt
      integer*4 	lstatus, n, one
      integer*4 	size
      integer*4     start(2)
      integer*4     stride(2)
      integer*4     edge(2)
      integer*4     start1d, stride1d, edge1d
      integer*4 	periodid
      integer*4     strbufsize, pcode
      integer*4     xdimsize, ydimsize
      integer*4	    dims(32)
      
      real		    fillvalue, ifillv

      real*4		fldval(5)
      real*4		ray3(250)
      real*4		utmray(60,80), georay(60,80)
      real*4		utmhght(80)
      real*4		hghtinit
      real*4		utmcnt, geocnt
      real*4		raycnt, ray3cnt
      real*4		tempray(60,80)
      real*4		datbuf(4800)

      real*8		starttime, stoptime
      real*8		range(2)
      real*8		projparm(16), pparm(16)
      real*8		uplft(2), lowrgt(2)
      real*8		iuplft(2), ilrgt(2)
      real*8		interval(5,2)
      real*8		lonval(5), latval(5)
      real*8		upleftpt(2), lowrtpt(2),corlon(2),corlat(2)
      real*8		utmtmeray(4800)
      real*8		tmeinit

      character*80	grdnames, dimname, fldlist, attrlist
      character*80	maxdimname
      integer*4	    	compcodestring
      
      nt(1)= 0      
      nt(2)= 0      
      nt(3)= 0      
      nt(4)= 0
      rk(1)= 0
      rk(2)= 0
      rk(3)= 0
      rk(4)= 0

      index1      = 0
      index2      = 0
      dimsizes(1) = 40
      dimsizes(2) = 100
      compparm(1) = 6 
      compparm(2) = 0
      compparm(3) = 0
      compparm(4) = 0
      compparm(5) = 0
      fillvalue   = 1996.0
      raycnt      = -799.0
      ray3cnt     = -19.5
      attr(1)     = 11
      attr(2)     = 33
      attr(3)     = 55
      attr(4)     = 77
      utmcnt      = -799.0
      geocnt      = 2001.0
      hghtinit    = 323.0
      tmeinit     = 35232487.2d0
      starttime   = 35233000.8d0
      stoptime    = 35435050.9d0
      range(1)    = 352.8d0
      range(2)    = 400.9d0
      lonval(1)   = -122.0d0
      latval(1)   = -68.0d0
      lonval(2)   = -122.5d0
      latval(2)   = -68.0d0
      lonval(3)   = -123.0d0
      latval(3)   = -68.0d0
      lonval(4)   = -123.5d0
      latval(4)   = -68.0d0
      lonval(5)   = -124.0d0
      latval(5)   = -68.0d0
      tiledims(1) = 16
      tiledims(2) = 15
      tilecords(1)= 0
      tilecords(2)= 0
      latcnt      = 38.0
      loncnt      = 78.0
      one         = 1
      zero        = 0
c
c This section of the program just fills some arrays with data that we will
c use later in the program
c
      do 70 index1=1,60
         do 80 index2=1,80
            utmray(index2,index1) = utmcnt
            georay(index2,index1) = geocnt
            utmcnt = utmcnt + .4
            geocnt = geocnt + .2
   80   continue
   70 continue
  
      
      do 30 index1=1,250
            ray3(index1) = ray3cnt
            ray3cnt = ray3cnt + .1
   30 continue
      
      do 32 index1=1,80
            utmhght(index1) = hghtinit
            hghtinit = hghtinit + 2.75
   32 continue

      do 34 index1=1,4800
            utmtmeray(index1) = tmeinit
            tmeinit = tmeinit + 70.7
   34 continue

      do 50 index1=1,50
         do 60 index2=1,40      
            lat(index2,index1) = latcnt
            lon(index2,index1) = loncnt
            loncnt = loncnt - 0.1
   60    continue
         latcnt = latcnt + 0.1
         loncnt = 78.0
   50 continue

  230 format('********Error unexpected**********')
  231 format('********Error Expected************')
  240 format('***********Passed Test*********')


      open(unit=10,file='testgridsz32_f.txtout',status="UNKNOWN")

      write(*,*)'Testing Grid FORTRAN 77 interface '
      write(*,*)'=================================='
      write(10,*)'Testing Grid FORTRAN 77 interface '
      write(10,*)'=================================='
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdopen
c
      write(10,*)'Testing gdopen... '
      write(10,*)'=================='
      write(*,*)'Testing gdopen... '
      write(*,*)'=================='
      gdfid2 = he5_gdopen("grid2sz32.he5",HE5F_ACC_TRUNC)
      if (gdfid2 .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdfid2 = he5_gdopen(grid2sz32.he5",HE5F_ACC_TRUNC)'
         write(10,*)'Value returned by he5_gdopen ', gdfid2
         write(*,*)'gdfid2 = he5_gdopen(grid2sz32.he5",HE5F_ACC_TRUNC)'
         write(*,*)'Value returned by he5_gdopen ', gdfid2
      endif
      write(*,*)' '
      write(10,*)' '
       gdfid3 = he5_gdopen("grid3sz32.he5",HE5F_ACC_TRUNC)
      if (gdfid3 .lt. zero) then
         write(*,231)
         write(10,231)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
      write(10,*)'gdfid3 = he5_gdopen("grid3sz32.he5",HE5F_ACC_TRUNC)'
      write(10,*)'Value returned by he5_gdopen ', gdfid3
      write(*,*)'gdfid3 = he5_gdopen("grid3sz32.he5",HE5F_ACC_TRUNC)'
      write(*,*)'Value returned by he5_gdopen ', gdfid3
      endif
      write(*,*)' '
      write(10,*)' '

      gdfid = he5_gdopen('gridsz32.he5',HE5F_ACC_TRUNC)
      if (gdfid .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'Opening file gridsz32.he5'
         write(10,*)'Opening file gridsz32.he5'
         write(10,*) 'gdfid = he5_gdopen("gridsz32.he5",HE5F_ACC_TRUNC)'
         write(10,*) 'File id returned from he5_gdopen ', gdfid
         write(*,*) 'gdfid = he5_gdopen("gridsz32.he5",HE5F_ACC_TRUNC)'
         write(*,*) 'File id returned from he5_gdopen ', gdfid
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- gdcreate
c
      write(10,27)
      write(10,*)'Testing gdcreate... '
      write(10,*)'=================='
      write(*,*)'Testing gdcreate... '
      write(*,*)'=================='

      xdim = 60
      ydim = 80
      uplft(1)  = 353299.39125d0
      uplft(2)  = -7100284.64348d0
      lowrgt(1) = 603434.52148d0
      lowrgt(2) = -7991341.17870d0


      gdid2 = he5_gdcreate(gdfid2, 'UTMGrid2', xdim, 
     1ydim, uplft, lowrgt)
      if (gdid2 .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*) 'Create UTMGrid2'
         write(*,*)'gdid2 = he5_gdcreate(gdfid2, "UTMGrid2", 
     1xdim, ydim, uplft, lowrgt)'
         write(10,*) 'Value returned by he5_gdcreate ', gdid2
         write(*,*) 'Create UTMGrid2'
         write(10,*)'gdid2 = he5_gdcreate(gdfid2, "UTMGrid2", 
     1xdim, ydim, uplft, lowrgt)'
         write(*,*) 'Value returned by he5_gdcreate ', gdid2
      endif
      
      gdid3 = he5_gdcreate(gdfid3, 'UTMGrid3', xdim, 
     1ydim, uplft, lowrgt)
      if (gdid3 .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*) 'Create UTMGrid3'
         write(*,*)'gdid3 = he5_gdcreate(gdfid3, "UTMGrid3", 
     1xdim, ydim, uplft, lowrgt)'
         write(10,*) 'Value returned by he5_gdcreate ', gdid3
         write(*,*) 'Create UTMGrid3'
         write(10,*)'gdid3 = he5_gdcreate(gdfid3, "UTMGrid3", 
     1xdim, ydim, uplft, lowrgt)'
         write(*,*) 'Value returned by he5_gdcreate ', gdid3
      endif
    
      gdid_utm = he5_gdcreate(gdfid, 'UTMGrid', xdim, 
     1ydim, uplft, lowrgt)
      if (gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Creating UTMGrid'
         write(*,*)'Creating UTMGrid'
         write(*,*)'gdid_utm=he5_gdcreate(gdfid,"UTMGrid",
     1xdim,ydim,uplft,lowrgt)'
         write(10,*)'gdid_utm=he5_gdcreate(gdfid,"UTMGrid",
     1xdim,ydim,uplft,lowrgt)'
         write(10,*)'UTM grid id returned from he5_gdcreate ', 
     1gdid_utm
         write(*,*)'UTM grid id returned from he5_gdcreate ', 
     1gdid_utm
      endif 
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefproj
c
      write(10,27)
      write(10,*)'Testing gddefproj... '
      write(10,*)'=================='
      write(*,*)'Testing gddefproj... '
      write(*,*)'=================='

      zonecode = 10
      spherecode = 0

      do 120 index1=1,16
         projparm(index1)=0
 120  continue
  
      status = he5_gddefproj(gdid_utm,HE5_GCTP_UTM,zonecode,
     1spherecode,projparm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Defining UTM projection'
         write(*,*)'Defining UTM projection'
         write(*,*)'status=he5_gddefproj(gdid_utm,HE5_GCTP_UTM,
     1zonecode,spherecode, projparm)'
         write(10,*)'status=he5_gddefproj(gdid_utm,HE5_GCTP_UTM,
     1zonecode,spherecode, projparm)'
         write(10,*)'Returned value from he5_gddefproj ', status
         write(*,*)'Returned value from he5_gddefproj ', status
      endif 
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefproj(gdid3,HE5_GCTP_UTM,zonecode,
     1spherecode,projparm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Defining UTM projection'
         write(*,*)'Defining UTM projection'
         write(*,*)'status=he5_gddefproj(gdid3,HE5_GCTP_UTM,
     1zonecode,spherecode, projparm)'
         write(10,*)'status=he5_gddefproj(gdid3,HE5_GCTP_UTM,
     1zonecode,spherecode, projparm)'
         write(10,*)'Returned value from he5_gddefproj ', status
         write(*,*)'Returned value from he5_gddefproj ', status
      endif 
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefproj(gdid2,HE5_GCTP_UTM,zonecode,
     1spherecode,projparm)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Defining UTM'
         write(10,*)'status = he5_gddefproj(gdid2,HE5_GCTP_UTM,
     1zonecode,spherecode,projparm)'
         write(10,*)'Value returned by he5_gddefproj ', status
         write(*,*)'Defining UTM'
         write(*,*)'status = he5_gddefproj(gdid2,HE5_GCTP_UTM,
     1zonecode,spherecode,projparm)'
         write(*,*)'Value returned by he5_gddefproj ', status
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- gddefpreg
c
      write(10,27)
      write(10,*)'Testing gddefpreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddefpreg... '
      write(*,*)'=================='
      status = he5_gddefpreg(gdid_utm, HE5_HDFE_CORNER)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gddefpreg(gdid_utm, 
     1HE5_HDFE_CORNER)'
         write(10,*)'status = he5_gddefpreg(gdid_utm, 
     1HE5_HDFE_CORNER)'
         write(10,*)'Returned from he5_gddefpreg ', status
         write(*,*)'Returned from he5_gddefpreg ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefpreg(gdid3, HE5_HDFE_CORNER)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gddefpreg(gdid3, 
     1HE5_HDFE_CORNER)'
         write(10,*)'status = he5_gddefpreg(gdid3, 
     1HE5_HDFE_CORNER)'
         write(10,*)'Returned from he5_gddefpreg ', status
         write(*,*)'Returned from he5_gddefpreg ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeforigin
c
      write(10,27)
      write(10,*)'Testing gddeforigin... '
      write(10,*)'=================='
      write(*,*)'Testing gddeforigin... '
      write(*,*)'=================='
      status = he5_gddeforigin(gdid_utm, HE5_HDFE_GD_UL)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gddeforigin(gdid_utm, 
     1HE5_HDFE_GD_UL)'
         write(*,*)'Value of status from he5_gddeforigin ',
     1status
         write(10,*)'status = he5_gddeforigin(gdid_utm, 
     1HE5_HDFE_GD_UL)'
         write(10,*)'Value of status from he5_gddeforigin ',
     1status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddeforigin(gdid3, HE5_HDFE_GD_UL)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gddeforigin(gdid3, 
     1HE5_HDFE_GD_UL)'
         write(*,*)'Value of status from he5_gddeforigin ',
     1status
         write(10,*)'status = he5_gddeforigin(gdid3, 
     1HE5_HDFE_GD_UL)'
         write(10,*)'Value of status from he5_gddeforigin ',
     1status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefdim
c
      write(10,27)
      write(10,*)'Testing gddefdim... '
      write(10,*)'=================='
      write(*,*)'Testing gddefdim... '
      write(*,*)'=================='
      status = he5_gddefdim(gdid2, 'TestDim1', 40)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddefdim(gdid2, "TestDim1", 40)'
         write(10,*)'Value returned by he5_gddefdim ', status
         write(*,*)'status = he5_gddefdim(gdid2, "TestDim1", 40)'
         write(*,*)'Value returned by he5_gddefdim ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefdim(gdid2, 'TestDim2', 25)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddefdim(gdid2, "TestDim2", 25)'
         write(10,*)'Value returned by he5_gddefdim ', status
         write(*,*)'status = he5_gddefdim(gdid2, "TestDim2", 25)'
         write(*,*)'Value returned by he5_gddefdim ', status
      endif
      write(10,*)' '
      write(*,*)' '


      status = he5_gddefdim(gdid_utm, 'Conduction', 250)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status=he5_gddefdim(gdid_utm,"Conduction",250)'
         write(10,*)'Returned value from he5_gddefdim ',status
         write(*,*)'status=he5_gddefdim(gdid_utm,"Conduction",250)'
         write(*,*)'Returned value from he5_gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefdim(gdid_utm,'Timedim',4800)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddefdim(gdid_utm,"Timedim",4800)'
         write(10,*)'Status returned by call to he5_gddefdim ',status
         write(*,*)'status = he5_gddefdim(gdid_utm,"Timedim",4800)'
         write(*,*)'Status returned by call to he5_gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefdim(gdid_utm,'Hghtdim',80)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = he5_gddefdim(gdid_utm,"Hghtdim",80)'
        write(10,*)'Status returned by call to he5_gddefdim ',status
        write(*,*)'status = he5_gddefdim(gdid_utm,"Hghtdim",80)'
        write(*,*)'Status returned by call to he5_gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefdim(gdid_utm,'Convection',60)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define dimension Convection '
        write(10,*)'status = he5_gddefdim(gdid_utm,"Convection",60)'
        write(10,*)'Status returned by call to he5_gddefdim ',status
        write(*,*)'Define dimension Convection '
        write(*,*)'status = he5_gddefdim(gdid_utm,"Convection",60)'
        write(*,*)'Status returned by call to he5_gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefdim(gdid3, 'Conduction', 250)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status=he5_gddefdim(gdid3,"Conduction",250)'
         write(10,*)'Returned value from he5_gddefdim ',status
         write(*,*)'status=he5_gddefdim(gdid3,"Conduction",250)'
         write(*,*)'Returned value from he5_gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefdim(gdid3,'Timedim',4800)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddefdim(gdid3,"Timedim",4800)'
         write(10,*)'Status returned by call to he5_gddefdim ',status
         write(*,*)'status = he5_gddefdim(gdid3,"Timedim",4800)'
         write(*,*)'Status returned by call to he5_gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefdim(gdid3,'Hghtdim',80)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = he5_gddefdim(gdid3,"Hghtdim",80)'
        write(10,*)'Status returned by call to he5_gddefdim ',status
        write(*,*)'status = he5_gddefdim(gdid3,"Hghtdim",80)'
        write(*,*)'Status returned by call to he5_gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefdim(gdid3,'Convection',60)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define dimension Convection '
        write(10,*)'status = he5_gddefdim(gdid3,"Convection",60)'
        write(10,*)'Status returned by call to he5_gddefdim ',status
        write(*,*)'Define dimension Convection '
        write(*,*)'status = he5_gddefdim(gdid3,"Convection",60)'
        write(*,*)'Status returned by call to he5_gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddetach
c
      write(10,27)
      write(10,*)'Testing gddetach... '
      write(10,*)'=================='
      write(*,*)'Testing gddetach... '
      write(*,*)'=================='
      status = he5_gddetach(gdid2)
      if(status .lt. zero) then
         write(*,231)
         write(10,231)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid2)'
         write(10,*)'Value returned by he5_gddetach ', status
         write(*,*)'status = he5_gddetach(gdid2)'
         write(*,*)'Value returned by he5_gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid_utm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Returned value from he5_gddetach ', status
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Returned value from he5_gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid3)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid3)'
         write(10,*)'Returned value from he5_gddetach ', status
         write(*,*)'status = he5_gddetach(gdid3)'
         write(*,*)'Returned value from he5_gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '
 
c Test Case -- gdattach
c
      write(10,27)
      write(10,*)'Testing gdattach... '
      write(10,*)'=================='
      write(*,*)'Testing gdattach... '
      write(*,*)'=================='
      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if(gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(10,*)'Handle returned from he5_gdattach ', gdid_utm
         write(*,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(*,*)'Handle returned from he5_gdattach ', gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

      gdid3 = he5_gdattach(gdfid3, 'UTMGrid3')
      if(gdid3 .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid3 = he5_gdattach(gdfid3, "UTMGrid3")'
         write(10,*)'Handle returned from he5_gdattach ', gdid3
         write(*,*)'gdid3 = he5_gdattach(gdfid3, "UTMGrid3")'
         write(*,*)'Handle returned from he5_gdattach ', gdid3
      endif
      write(10,*)' '
      write(*,*)' '

      gdid2 = he5_gdattach(gdfid2, 'UTMGrid2')
      if(gdid2 .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid2 = he5_gdattach(gdfid2, "UTMGrid2")'
         write(10,*)'Value returned by he5_gdattach ', gdid2
         write(*,*)'gdid2 = he5_gdattach(gdfid2, "UTMGrid2")'
         write(*,*)'Value returned by he5_gdattach ', gdid2
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeffld
c
      write(10,27)
      write(10,*)'Testing gddeffld... '
      write(10,*)'=================='
      write(*,*)'Testing gddeffld... '
      write(*,*)'=================='
      status=he5_gddeffld(gdid2,"tempfield","TestDim2,TestDim1","",
     1HE5T_NATIVE_FLOAT, HE5_HDFE_NOMERGE)
      if(status .lt. zero) then
         write(*,231)
         write(10,231)
        
      else 
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "tempfield"'
        write(10,*)'status=he5_gddeffld(gdid2,"tempfield",
     1"TestDim2,TestDim1","",HE5T_NATIVE_FLOAT,HE5_HDFE_NOMERGE)'
        write(10,*)'Value returned by he5_gddeffld ', status
        write(*,*)'Define: "tempfield"'
        write(*,*)'status=he5_gddeffld(gdid2,"tempfield",
     1"TestDim2,TestDim1","",HE5T_NATIVE_FLOAT,HE5_HDFE_NOMERGE)'
        write(*,*)'Value returned by he5_gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status=he5_gddeffld(gdid_utm,'Time','Timedim',"",
     1HE5T_NATIVE_DOUBLE, HE5_HDFE_NOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
        write(*,*)' '
        write(*,240)
        write(10,*)' '
        write(10,240)
        write(10,*)' Define field Time'
        write(10,*)'status=he5_gddeffld(gdid_utm,"Time","Timedim","",
     1HE5T_NATIVE_DOUBLE,HE5_HDFE_NOMERGE)'
        write(10,*)'Status returned by call to he5_gddeffld ',status
        write(*,*)' Define field Time'
        write(*,*)'status=he5_gddeffld(gdid_utm,"Time","Timedim","",
     1HE5T_NATIVE_DOUBLE,HE5_HDFE_NOMERGE)'
        write(*,*)'Status returned by call to he5_gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status=he5_gddeffld(gdid_utm,'Height','Hghtdim',"",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_NOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
        write(*,*)' '
        write(*,240)
        write(10,*)' '
        write(10,240)
        write(10,*)' Define field Height'
        write(10,*)'status=he5_gddeffld(gdid_utm,"Height","Hghtdim","",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_NOMERGE)'
        write(10,*)'Status returned by call to he5_gddeffld ',status
        write(*,*)' Define field Height'
        write(*,*)'status=he5_gddeffld(gdid_utm,"Height","Hghtdim","",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_NOMERGE)'
        write(*,*)'Status returned by call to he5_gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status=he5_gddeffld(gdid3,'Time','Timedim',"",
     1HE5T_NATIVE_DOUBLE, HE5_HDFE_NOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
        write(*,*)' '
        write(*,240)
        write(10,*)' '
        write(10,240)
        write(10,*)' Define field Time'
        write(10,*)'status=he5_gddeffld(gdid3,"Time","Timedim","",
     1HE5T_NATIVE_DOUBLE,HE5_HDFE_NOMERGE)'
        write(10,*)'Status returned by call to he5_gddeffld ',status
        write(*,*)' Define field Time'
        write(*,*)'status=he5_gddeffld(gdid3,"Time","Timedim","",
     1HE5T_NATIVE_DOUBLE,HE5_HDFE_NOMERGE)'
        write(*,*)'Status returned by call to he5_gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status=he5_gddeffld(gdid3,'Height','Hghtdim',"",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_NOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
        write(*,*)' '
        write(*,240)
        write(10,*)' '
        write(10,240)
        write(10,*)' Define field Height'
        write(10,*)'status=he5_gddeffld(gdid3,"Height","Hghtdim","",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_NOMERGE)'
        write(10,*)'Status returned by call to he5_gddeffld ',status
        write(*,*)' Define field Height'
        write(*,*)'status=he5_gddeffld(gdid3,"Height","Hghtdim","",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_NOMERGE)'
        write(*,*)'Status returned by call to he5_gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeftle
c
      write(10,27)
      write(10,*)'Testing gddeftle... '
      write(10,*)'=================='
      write(*,*)'Testing gddeftle... '
      write(*,*)'=================='

      status = he5_gddeftle(gdid_utm,HE5_HDFE_TILE,2,tiledims)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define tiling dimensions '
        write(10,*)'status = he5_gddeftle(gdid_utm,
     1HE5_HDFE_TILE,2,tiledims)'
        write(10,*)'Status returned by call to he5_gddeftle ',status
        write(*,*)'Status returned by call to he5_gddeftle ',status
        write(*,*)'status = he5_gddeftle(gdid_utm,
     1HE5_HDFE_TILE,2,tiledims)'
        write(*,*)'Define tiling dimensions '
      endif
      write(10,*)' '
      write(*,*)' '

      status=he5_gddeffld(gdid_utm,'SideB','YDim,Convection',"",
     1HE5T_NATIVE_INT,HE5_HDFE_NOMERGE)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define field that will be tiled '
        write(10,*)'status=he5_gddeffld(gdid_utm,"SideB",
     1"YDim,Convection","",HE5T_NATIVE_INT,HE5_HDFE_NOMERGE)'
        write(10,*)'Status returned by call to he5_gddeffld ',status
        write(*,*)'Define field that will be tiled '
        write(*,*)'status=he5_gddeffld(gdid_utm,"SideB",
     1"YDim,Convection","",HE5T_NATIVE_INT,HE5_HDFE_NOMERGE)'
        write(*,*)'Status returned by call to he5_gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid_utm)
      if (status .lt. zero) then 
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Returned value from he5_gddetach ', status
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Returned value from he5_gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if (gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gdattach(gdfid,"UTMGrid")'
         write(10,*)'Returned value from he5_gdattach ', status
         write(*,*)'status = he5_gddetach(gdfid,"UTMGrid")'
         write(*,*)'Returned value from he5_gdattach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status=he5_gddeffld(gdid_utm,'Grounding','Conduction',"",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Define: "Grounding"'                  
         write(10,*)'status=he5_gddeffld(gdid_utm,"Grounding",
     1"Conduction","",HE5T_NATIVE_FLOAT,HDF_NOMERGE)'
         write(10,*)'Value returned by he5_gddeffld ', status
         write(*,*)'Define: "Grounding"'                  
         write(*,*)'status=he5_gddeffld(gdid_utm,"Grounding",
     1"Conduction","",HE5T_NATIVE_FLOAT,HDF_NOMERGE)'
         write(*,*)'Value returned by he5_gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddeftle(gdid3,HE5_HDFE_TILE,2,tiledims)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define tiling dimensions '
        write(10,*)'status = he5_gddeftle(gdid3,
     1HE5_HDFE_TILE,2,tiledims)'
        write(10,*)'Status returned by call to he5_gddeftle ',status
        write(*,*)'Status returned by call to he5_gddeftle ',status
        write(*,*)'status = he5_gddeftle(gdid3,
     1HE5_HDFE_TILE,2,tiledims)'
        write(*,*)'Define tiling dimensions '
      endif
      write(10,*)' '
      write(*,*)' '

      status=he5_gddeffld(gdid3,'SideB','YDim,Convection',"",
     1HE5T_NATIVE_INT,HE5_HDFE_NOMERGE)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define field that will be tiled '
        write(10,*)'status=he5_gddeffld(gdid3,"SideB",
     1"YDim,Convection","",HE5T_NATIVE_INT,HE5_HDFE_NOMERGE)'
        write(10,*)'Status returned by call to he5_gddeffld ',status
        write(*,*)'Define field that will be tiled '
        write(*,*)'status=he5_gddeffld(gdid3,"SideB",
     1"YDim,Convection","",HE5T_NATIVE_INT,HE5_HDFE_NOMERGE)'
        write(*,*)'Status returned by call to he5_gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid3)
      if (status .lt. zero) then 
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid3)'
         write(10,*)'Returned value from he5_gddetach ', status
         write(*,*)'status = he5_gddetach(gdid3)'
         write(*,*)'Returned value from he5_gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid3 = he5_gdattach(gdfid3, 'UTMGrid3')
      if (gdid3 .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gdattach(gdfid3,"UTMGrid3")'
         write(10,*)'Returned value from he5_gdattach ', status
         write(*,*)'status = he5_gddetach(gdfid3,"UTMGrid3")'
         write(*,*)'Returned value from he5_gdattach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status=he5_gddeffld(gdid3,'Grounding','Conduction',"",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Define: "Grounding"'                  
         write(10,*)'status=he5_gddeffld(gdid3,"Grounding",
     1"Conduction","",HE5T_NATIVE_FLOAT,HDF_NOMERGE)'
         write(10,*)'Value returned by he5_gddeffld ', status
         write(*,*)'Define: "Grounding"'                  
         write(*,*)'status=he5_gddeffld(gdid3,"Grounding",
     1"Conduction","",HE5T_NATIVE_FLOAT,HDF_NOMERGE)'
         write(*,*)'Value returned by he5_gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefcomp
c
      write(10,27)
      write(10,*)'Testing gddefcomp... '
      write(10,*)'=================='
      write(*,*)'Testing gddefcomp... '
      write(*,*)'=================='

      tiledims(1) = 16
      tiledims(2) = 15
      status = he5_gddeftle(gdid_utm,HE5_HDFE_TILE,2,tiledims)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'Setup Tiling dimensions '
         write(*,*)'Required when using compression'
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefcomp(gdid_utm,
     1HE5_HDFE_COMP_DEFLATE, compparm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Setup compression mode'
        write(10,*)'status = he5_gddefcomp(gdid_utm,
     1HE5_HDFE_COMP_DEFLATE,compparm)'
        write(10,*)'Status returned by call to he5_gddefcomp ',status
        write(*,*)'Setup compression mode'
        write(*,*)'status = he5_gddefcomp(gdid_utm,
     1HE5_HDFE_COMP_DEFLATE, compparm)'
        write(*,*)'Status returned by call to he5_gddefcomp ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddeffld(gdid_utm,"Voltage","YDim,XDim"," ",
     1HE5T_NATIVE_FLOAT, HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "Voltage"'
        write(10,*)'status = he5_gddeffld(gdid_utm,"Voltage",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT, HE5_HDFE_AUTOMERGE)'
        write(10,*)'Value returned from he5_gddeffld ', status
        write(*,*)'Define: "Voltage"'
        write(*,*)'status = he5_gddeffld(gdid_utm,"Voltage",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT, HE5_HDFE_AUTOMERGE)'
        write(*,*)'Value returned from he5_gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddeftle(gdid3,HE5_HDFE_TILE,2,tiledims)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'Setup Tiling dimensions '
         write(*,*)'Required when using compression'
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefcomp(gdid3,
     1HE5_HDFE_COMP_SHUF_SZIP_K13orEC, compparm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Setup compression mode'
        write(10,*)'status = he5_gddefcomp(gdid3,
     1HE5_HDFE_COMP_SHUF_SZIP_K13orEC,compparm)'
        write(10,*)'Status returned by call to he5_gddefcomp ',status
        write(*,*)'Setup compression mode'
        write(*,*)'status = he5_gddefcomp(gdid3,
     1HE5_HDFE_COMP_SHUF_SZIP_K13orEC,compparm)'
        write(*,*)'Status returned by call to he5_gddefcomp ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddeffld(gdid3,"Voltage","YDim,XDim"," ",
     1HE5T_NATIVE_FLOAT, HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "Voltage"'
        write(10,*)'status = he5_gddeffld(gdid3,"Voltage",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT, HE5_HDFE_AUTOMERGE)'
        write(10,*)'Value returned from he5_gddeffld ', status
        write(*,*)'Define: "Voltage"'
        write(*,*)'status = he5_gddeffld(gdid3,"Voltage",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT, HE5_HDFE_AUTOMERGE)'
        write(*,*)'Value returned from he5_gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdsetfill
c
      write(10,27)
      write(10,*)'Testing gdsetfill... '
      write(10,*)'=================='
      write(*,*)'Testing gdsetfill... '
      write(*,*)'=================='

      status = he5_gdsetfill(gdid_utm, "Drift", 
     1HE5T_NATIVE_FLOAT, fillvalue)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Testing gdsetfill'
         write(10,*)'status = he5_gdsetfill(gdid_utm, "Drift", 
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(10,*)'Returned from he5_gdsetfill ', status
         write(*,*)'Testing gdsetfill'
         write(*,*)'status = he5_gdsetfill(gdid_utm, "Drift", 
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(*,*)'Returned from he5_gdsetfill ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status=he5_gddeffld(gdid_utm,"Drift","YDim,XDim"," ",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "Drift"'      
        write(10,*)'status=he5_gddeffld(gdid_utm,"Drift",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
        write(10,*)'Value returned from he5_gddeffld ', status
        write(*,*)'Define: "Drift"'      
        write(*,*)'status=he5_gddeffld(gdid_utm,"Drift",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
        write(*,*)'Value returned from he5_gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status=he5_gddeffld(gdid_utm,"Impedance","YDim,XDim"," ",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Define: "Impedance"'            
         write(10,*)'status=he5_gddeffld(gdid_utm,"Impedance",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
         write(10,*)'Value returned from he5_gddeffld ', status
         write(*,*)'Define: "Impedance"'            
         write(*,*)'status=he5_gddeffld(gdid_utm,"Impedance",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
         write(*,*)'Value returned from he5_gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '


      status = he5_gddetach(gdid_utm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Returned value from he5_gddetach ', status
         write(*,*)'Returned value from he5_gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if(gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(10,*)'Handle returned from he5_gdattach ', gdid_utm
         write(*,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(*,*)'Handle returned from he5_gdattach ', gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdsetfill(gdid3, "Drift", 
     1HE5T_NATIVE_FLOAT, fillvalue)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Testing gdsetfill'
         write(10,*)'status = he5_gdsetfill(gdid3, "Drift", 
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(10,*)'Returned from he5_gdsetfill ', status
         write(*,*)'Testing gdsetfill'
         write(*,*)'status = he5_gdsetfill(gdid3, "Drift", 
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(*,*)'Returned from he5_gdsetfill ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status=he5_gddeffld(gdid3,"Drift","YDim,XDim"," ",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "Drift"'      
        write(10,*)'status=he5_gddeffld(gdid3,"Drift",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
        write(10,*)'Value returned from he5_gddeffld ', status
        write(*,*)'Define: "Drift"'      
        write(*,*)'status=he5_gddeffld(gdid3,"Drift",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
        write(*,*)'Value returned from he5_gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status=he5_gddeffld(gdid3,"Impedance","YDim,XDim"," ",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Define: "Impedance"'            
         write(10,*)'status=he5_gddeffld(gdid3,"Impedance",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
         write(10,*)'Value returned from he5_gddeffld ', status
         write(*,*)'Define: "Impedance"'            
         write(*,*)'status=he5_gddeffld(gdid3,"Impedance",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
         write(*,*)'Value returned from he5_gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '


      status = he5_gddetach(gdid3)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid3)'
         write(*,*)'status = he5_gddetach(gdid3)'
         write(10,*)'Returned value from he5_gddetach ', status
         write(*,*)'Returned value from he5_gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid3 = he5_gdattach(gdfid3, 'UTMGrid3')
      if(gdid3 .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid3 = he5_gdattach(gdfid, "UTMGrid3")'
         write(10,*)'Handle returned from he5_gdattach ', gdid3
         write(*,*)'gdid3 = he5_gdattach(gdfid, "UTMGrid3")'
         write(*,*)'Handle returned from he5_gdattach ', gdid3
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdwrfld
c
      write(10,27)
      write(10,*)'Testing gdwrfld... '
      write(10,*)'=================='
      write(*,*)'Testing gdwrfld... '
      write(*,*)'=================='

      start(1) = 0
      start(2) = 0
      stride(1) = 1
      stride(2) = 1
      edge(1) = 80
      edge(2) = 60
      
      status = he5_gdwrfld(gdid_utm, "Voltage", start, stride, 
     1edge, utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Voltage '
        write(10,*)'status=he5_gdwrfld(gdid_utm,"Voltage",start,
     1stride,edge,utmray)'
        write(10,*)'Status returned by he5_gdwrfield ', status
        write(*,*)'Write to field Voltage '
        write(*,*)'status=he5_gdwrfld(gdid_utm,"Voltage",start,
     1stride,edge,utmray)'
        write(*,*)'Status returned by he5_gdwrfield ', status
      endif
      write(10,*)' '
      write(*,*)' '


      start(1) = 10
      start(2) = 10
      edge(1) = 10
      edge(2) = 10
      status = he5_gdwrfld(gdid_utm, 'Drift', start,stride,
     1edge,utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Drift '
        write(10,*)'status = he5_gdwrfld(gdid_utm,"Drift",start,
     1stride,edge,utmray)'
        write(10,*)'Status returned from he5_gdwrfld ', status
        write(*,*)'Write to field Drift '
        write(*,*)'status = he5_gdwrfld(gdid_utm,"Drift",start,
     1stride,edge,utmray)'
        write(*,*)'Status returned from he5_gdwrfld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      start(1) = 0
      start(2) = 0
      edge(1) = 80
      edge(2) = 60
      status = he5_gdwrfld(gdid_utm, 'Impedance', start,stride,
     1edge,utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Impedance '
        write(10,*)'status=he5_gdwrfld(gdid_utm,"Impedance",start,
     1stride,edge,utmray)'
        write(10,*)'Returned from he5_gdwrfld ', status
        write(*,*)'Write to field Impedance '
        write(*,*)'status=he5_gdwrfld(gdid_utm,"Impedance",start,
     1stride,edge,utmray)'
        write(*,*)'Returned from he5_gdwrfld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=4800
      status=he5_gdwrfld(gdid_utm,'Time',start1d,stride1d,
     1edge1d,utmtmeray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Time '
        write(10,*)'status=he5_gdwrfld(gdid_utm,"Time",start1d,
     1stride1d,edge1d,utmtmeray)'
        write(10,*)'Status returned by call to he5_gdwrfld ',status
        write(*,*)'Write to field Time '
        write(*,*)'status=he5_gdwrfld(gdid_utm,"Time",start1d,
     1stride1d,edge1d,utmtmeray)'
        write(*,*)'Status returned by call to he5_gdwrfld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=80
      status=he5_gdwrfld(gdid_utm,'Height',start1d,stride1d,
     1edge1d,utmhght)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Height '
        write(10,*)'status=he5_gdwrfld(gdid_utm,"Height",start1d,
     1stride1d,edge1d,utmhght)'
        write(10,*)'Status returned by call to he5_gdwrfld ',status
        write(*,*)'Write to field Height '
        write(*,*)'status=he5_gdwrfld(gdid_utm,"Height",start1d,
     1stride1d,edge1d,utmhght)'
        write(*,*)'Status returned by call to he5_gdwrfld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=250
      status=he5_gdwrfld(gdid_utm,'Grounding',start1d,stride1d,
     1edge1d,ray3)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Grounding '
        write(10,*)'status=he5_gdwrfld(gdid_utm,"Grounding",start1d,
     1stride1d,edge1d,ray3)'
        write(10,*)'Value returned by he5_gdwrfld ', status
        write(*,*)'Write to field Grounding '
        write(*,*)'status=he5_gdwrfld(gdid_utm,"Grounding",start1d,
     1stride1d,edge1d,ray3)'
        write(*,*)'Value returned by he5_gdwrfld ', status
      endif
        write(10,*)' '
        write(*,*)' '

      status = he5_gddetach(gdid_utm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Value of status returned by he5_gddetach ',
     1status
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Value of status returned by he5_gddetach ',
     1status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(10,*)'Grid id returned by he5_gdattach ',gdid_utm
         write(*,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(*,*)'Grid id returned by he5_gdattach ',gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

      start(1) = 0
      start(2) = 0
      stride(1) = 1
      stride(2) = 1
      edge(1) = 80
      edge(2) = 60
      
      status = he5_gdwrfld(gdid3, "Voltage", start, stride, 
     1edge, utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Voltage '
        write(10,*)'status=he5_gdwrfld(gdid3,"Voltage",start,
     1stride,edge,utmray)'
        write(10,*)'Status returned by he5_gdwrfield ', status
        write(*,*)'Write to field Voltage '
        write(*,*)'status=he5_gdwrfld(gdid3,"Voltage",start,
     1stride,edge,utmray)'
        write(*,*)'Status returned by he5_gdwrfield ', status
      endif
      write(10,*)' '
      write(*,*)' '


      start(1) = 10
      start(2) = 10
      edge(1) = 10
      edge(2) = 10
      status = he5_gdwrfld(gdid3, 'Drift', start,stride,
     1edge,utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Drift '
        write(10,*)'status = he5_gdwrfld(gdid3,"Drift",start,
     1stride,edge,utmray)'
        write(10,*)'Status returned from he5_gdwrfld ', status
        write(*,*)'Write to field Drift '
        write(*,*)'status = he5_gdwrfld(gdid3,"Drift",start,
     1stride,edge,utmray)'
        write(*,*)'Status returned from he5_gdwrfld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      start(1) = 0
      start(2) = 0
      edge(1) = 80
      edge(2) = 60
      status = he5_gdwrfld(gdid3, 'Impedance', start,stride,
     1edge,utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Impedance '
        write(10,*)'status=he5_gdwrfld(gdid3,"Impedance",start,
     1stride,edge,utmray)'
        write(10,*)'Returned from he5_gdwrfld ', status
        write(*,*)'Write to field Impedance '
        write(*,*)'status=he5_gdwrfld(gdid3,"Impedance",start,
     1stride,edge,utmray)'
        write(*,*)'Returned from he5_gdwrfld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=4800
      status=he5_gdwrfld(gdid3,'Time',start1d,stride1d,
     1edge1d,utmtmeray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Time '
        write(10,*)'status=he5_gdwrfld(gdid3,"Time",start1d,
     1stride1d,edge1d,utmtmeray)'
        write(10,*)'Status returned by call to he5_gdwrfld ',status
        write(*,*)'Write to field Time '
        write(*,*)'status=he5_gdwrfld(gdid3,"Time",start1d,
     1stride1d,edge1d,utmtmeray)'
        write(*,*)'Status returned by call to he5_gdwrfld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=80
      status=he5_gdwrfld(gdid3,'Height',start1d,stride1d,
     1edge1d,utmhght)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Height '
        write(10,*)'status=he5_gdwrfld(gdid3,"Height",start1d,
     1stride1d,edge1d,utmhght)'
        write(10,*)'Status returned by call to he5_gdwrfld ',status
        write(*,*)'Write to field Height '
        write(*,*)'status=he5_gdwrfld(gdid3,"Height",start1d,
     1stride1d,edge1d,utmhght)'
        write(*,*)'Status returned by call to he5_gdwrfld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=250
      status=he5_gdwrfld(gdid3,'Grounding',start1d,stride1d,
     1edge1d,ray3)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Grounding '
        write(10,*)'status=he5_gdwrfld(gdid3,"Grounding",start1d,
     1stride1d,edge1d,ray3)'
        write(10,*)'Value returned by he5_gdwrfld ', status
        write(*,*)'Write to field Grounding '
        write(*,*)'status=he5_gdwrfld(gdid3,"Grounding",start1d,
     1stride1d,edge1d,ray3)'
        write(*,*)'Value returned by he5_gdwrfld ', status
      endif
        write(10,*)' '
        write(*,*)' '

      status = he5_gddetach(gdid3)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid3)'
         write(10,*)'Value of status returned by he5_gddetach ',
     1status
         write(*,*)'status = he5_gddetach(gdid3)'
         write(*,*)'Value of status returned by he5_gddetach ',
     1status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid3 = he5_gdattach(gdfid3, 'UTMGrid3')
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid3 = he5_gdattach(gdfid, "UTMGrid3")'
         write(10,*)'Grid id returned by he5_gdattach ',gdid3
         write(*,*)'gdid3 = he5_gdattach(gdfid, "UTMGrid3")'
         write(*,*)'Grid id returned by he5_gdattach ',gdid3
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdwrattr
c
      write(10,27)
      write(10,*)'Testing gdwrattr... Global attribute '
      write(10,*)'==================================== '
      write(*,*)'Testing gdwrattr... Global attribute '
      write(*,*)'==================================== '

      status = he5_gdwrattr(gdid_utm, 'Resistance', 
     1HE5T_NATIVE_INT, 4, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status=he5_gdwrattr(gdid_utm,"Resistance",
     1HE5T_NATIVE_INT, 4, attr)'
         write(10,*)'Returned from he5_gdwrattr ', status
         write(*,*)'status=he5_gdwrattr(gdid_utm,"Resistance",
     1HE5T_NATIVE_FLOAT, 4, attr)'
         write(*,*)'Returned from he5_gdwrattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdwrattr(gdid3, 'Resistance', 
     1HE5T_NATIVE_INT, 4, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status=he5_gdwrattr(gdid3,"Resistance",
     1HE5T_NATIVE_INT, 4, attr)'
         write(10,*)'Returned from he5_gdwrattr ', status
         write(*,*)'status=he5_gdwrattr(gdid3,"Resistance",
     1HE5T_NATIVE_FLOAT, 4, attr)'
         write(*,*)'Returned from he5_gdwrattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdwrgattr
c
      write(10,27)
      write(10,*)'Testing gdwrgattr... Group attribute '
      write(10,*)'==================================== '
      write(*,*)'Testing gdwrgattr... Group attribute '
      write(*,*)'==================================== '

      attr(1) = 22
      attr(2) = 44
      attr(3) = 66
      attr(4) = 88
      status = he5_gdwrgattr(gdid_utm, 'group', 
     1HE5T_NATIVE_INT, 4, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status=he5_gdwrgattr(gdid_utm,"group",
     1HE5T_NATIVE_INT, 4, attr)'
         write(10,*)'Returned from he5_gdwrgattr ', status
         write(*,*)'status=he5_gdwrgattr(gdid_utm,"group",
     1HE5T_NATIVE_INT, 4, attr)'
         write(*,*)'Returned from he5_gdwrgattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

      attr(1) = 22
      attr(2) = 44
      attr(3) = 66
      attr(4) = 88
      status = he5_gdwrgattr(gdid3, 'group', 
     1HE5T_NATIVE_INT, 4, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status=he5_gdwrgattr(gdid3,"group",
     1HE5T_NATIVE_INT, 4, attr)'
         write(10,*)'Returned from he5_gdwrgattr ', status
         write(*,*)'status=he5_gdwrgattr(gdid3,"group",
     1HE5T_NATIVE_INT, 4, attr)'
         write(*,*)'Returned from he5_gdwrgattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdwrlattr
c
      write(10,27)
      write(10,*)'Testing gdwrlattr... Local attribute '
      write(10,*)'==================================== '
      write(*,*)'Testing gdwrlattr... Local attribute '
      write(*,*)'==================================== '

      attr(1) = 12
      attr(2) = 34
      attr(3) = 56
      attr(4) = 78
      status = he5_gdwrlattr(gdid_utm,"Grounding", "local", 
     1HE5T_NATIVE_INT, 4, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status=he5_gdwrlattr(gdid_utm,"Grounding",
     1"local",HE5T_NATIVE_INT, 4, attr)'
         write(10,*)'Returned from he5_gdwrlattr ', status
         write(*,*)'status=he5_gdwrlattr(gdid_utm,"Grounding",
     1"local",HE5T_NATIVE_INT, 4, attr)'
         write(*,*)'Returned from he5_gdwrlattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid_utm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Returned from he5_gddetach ', status
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Returned from he5_gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdwrlattr(gdid3,"Grounding", "local", 
     1HE5T_NATIVE_INT, 4, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status=he5_gdwrlattr(gdid3,"Grounding",
     1"local",HE5T_NATIVE_INT, 4, attr)'
         write(10,*)'Returned from he5_gdwrlattr ', status
         write(*,*)'status=he5_gdwrlattr(gdid3,"Grounding",
     1"local",HE5T_NATIVE_INT, 4, attr)'
         write(*,*)'Returned from he5_gdwrlattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid3)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid3)'
         write(10,*)'Returned from he5_gddetach ', status
         write(*,*)'status = he5_gddetach(gdid3)'
         write(*,*)'Returned from he5_gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid2)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid2)'
         write(10,*)'Value returned by he5_gddetach ', status
         write(*,*)'status = he5_gddetach(gdid2)'
         write(*,*)'Value returned by he5_gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdclose
c
      write(10,27)
      write(10,*)'Testing gdclose... '
      write(10,*)'=================='
      write(*,*)'Testing gdclose... '
      write(*,*)'=================='

      status = he5_gdclose(gdfid2)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gdclose(gdfid2)'
         write(10,*)'Value returned by he5_gdclose ', status
         write(*,*)'status = he5_gdclose(gdfid2)'
         write(*,*)'Value returned by he5_gdclose ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdclose(gdfid3)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gdclose(gdfid3)'
         write(10,*)'Value returned by he5_gdclose ', status
         write(*,*)'status = he5_gdclose(gdfid3)'
         write(*,*)'Value returned by he5_gdclose ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdclose(gdfid)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gdclose(gdfid)'
         write(10,*)'Returned from he5_gdclose ', status
         write(*,*)'status = he5_gdclose(gdfid)'
         write(*,*)'Returned from he5_gdclose ', status
      endif
      write(10,*)' '
      write(*,*)' '

      
      gdfid = he5_gdopen('gridsz32.he5',HE5F_ACC_RDWR)
      if (gdfid .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'gdfid = he5_gdopen("gridsz32.he5",HE5F_ACC_RDWR)'
         write(10,*)'gdfid = he5_gdopen("gridsz32.he5",HE5F_ACC_RDWR)'
         write(*,*)'Grid file id returned by he5_gdopen ',gdfid
         write(10,*)'Grid file id returned by he5_gdopen ',gdfid
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if (gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(10,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(*,*)'Grid id returned by he5_gdattach ',gdid_utm
         write(10,*)'Grid id returned by he5_gdattach ',gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

      gdfid3 = he5_gdopen('grid3sz32.he5',HE5F_ACC_RDWR)
      if (gdfid3 .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'gdfid3 = he5_gdopen("grid3sz32.he5",HE5F_ACC_RDWR)'
         write(10,*)'gdfid3 = he5_gdopen("grid3sz32.he5",HE5F_ACC_RDWR)'
         write(*,*)'Grid file id returned by he5_gdopen ',gdfid
         write(10,*)'Grid file id returned by he5_gdopen ',gdfid
      endif
      write(10,*)' '
      write(*,*)' '

      gdid3 = he5_gdattach(gdfid3, 'UTMGrid3')
      if (gdid3 .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'gdid3 = he5_gdattach(gdfid3, "UTMGrid3")'
         write(10,*)'gdid3 = he5_gdattach(gdfid, "UTMGrid3")'
         write(*,*)'Grid id returned by he5_gdattach ',gdid3
         write(10,*)'Grid id returned by he5_gdattach ',gdid3
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdinqgrid
c
      write(10,27)
      write(10,*)'Testing gdinqgrid... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqgrid... '
      write(*,*)'=================='

      lstatus = he5_gdinqgrid('gridsz32.he5',grdnames,strbufsize)
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus=he5_gdinqgrid("gridsz32.he5",
     1grdnames,strbufsize)'
         write(*,*)'Names of grids ',grdnames
         write(*,*)'Number of grids ',lstatus
         write(*,*)'Size of names of grids ',strbufsize
         write(10,*)'lstatus=he5_gdinqgrid("gridsz32.he5",
     1grdnames,strbufsize)'
         write(10,*)'Names of grids ',grdnames
         write(10,*)'Number of grids ',lstatus
         write(10,*)'Size of names of grids ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

      lstatus = he5_gdinqgrid('grid3sz32.he5',grdnames,strbufsize)
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus=he5_gdinqgrid("grid3sz32.he5",
     1grdnames,strbufsize)'
         write(*,*)'Names of grids ',grdnames
         write(*,*)'Number of grids ',lstatus
         write(*,*)'Size of names of grids ',strbufsize
         write(10,*)'lstatus=he5_gdinqgrid("grid3sz32.he5",
     1grdnames,strbufsize)'
         write(10,*)'Names of grids ',grdnames
         write(10,*)'Number of grids ',lstatus
         write(10,*)'Size of names of grids ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdorginfo
c
      write(10,27)
      write(10,*)'Testing gdorginfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdorginfo... '
      write(*,*)'=================='

      status = he5_gdorginfo(gdid_utm, orgcode)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = he5_gdorginfo(gdid_utm, orgcode)'
         write(10,*)'lstatus = he5_gdorginfo(gdid_utm, orgcode)'
         write(*,*)'Value returned by he5_gdorginfo ',status
         write(10,*)'Value returned by he5_gdorginfo ',status
         write(*,*)'Origin code value ',orgcode
         write(10,*)'Origin code value ',orgcode
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdorginfo(gdid3, orgcode)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = he5_gdorginfo(gdid3, orgcode)'
         write(10,*)'lstatus = he5_gdorginfo(gdid3, orgcode)'
         write(*,*)'Value returned by he5_gdorginfo ',status
         write(10,*)'Value returned by he5_gdorginfo ',status
         write(*,*)'Origin code value ',orgcode
         write(10,*)'Origin code value ',orgcode
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdpreginfo
c
      write(10,27)
      write(10,*)'Testing gdpreginfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdpreginfo... '
      write(*,*)'=================='

      status = he5_gdpreginfo(gdid_utm, pixregcode)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdpreginfo(gdid_utm, pixregcode)'
         write(10,*)'status = he5_gdpreginfo(gdid_utm, pixregcode)'
         write(*,*)'Value returned by he5_gdpreginfo ',status
         write(10,*)'Value returned by he5_gdpreginfo ',status
         write(*,*)'Pixel reg code ',pixregcode
         write(10,*)'Pixel reg code ',pixregcode
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdpreginfo(gdid3, pixregcode)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdpreginfo(gdid3, pixregcode)'
         write(10,*)'status = he5_gdpreginfo(gdid3, pixregcode)'
         write(*,*)'Value returned by he5_gdpreginfo ',status
         write(10,*)'Value returned by he5_gdpreginfo ',status
         write(*,*)'Pixel reg code ',pixregcode
         write(10,*)'Pixel reg code ',pixregcode
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdinqdims
c
      write(10,27)
      write(10,*)'Testing gdinqdims... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqdims... '
      write(*,*)'=================='

      status = he5_gdinqdims(gdid_utm, dimname, dims)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdinqdims(gdid_utm, dimname, dims)'
         write(*,*)'Number of dimensions ',status
         write(*,*)'Dimensions in grid UTM ',dimname
         write(*,*)'Size of dimensions '
         write(10,*)'status = he5_gdinqdims(gdid_utm, dimname, dims)'
         write(10,*)'Number of dimensions ',status
         write(10,*)'Dimensions in grid UTM ',dimname
         write(10,*)'Size of dimensions '
         do 130 i=1,status
            write(*,*)' ',dims(i)
            write(10,*)' ',dims(i)
 130     continue
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdinqdims(gdid3, dimname, dims)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdinqdims(gdid3, dimname, dims)'
         write(*,*)'Number of dimensions ',status
         write(*,*)'Dimensions in grid UTM ',dimname
         write(*,*)'Size of dimensions '
         write(10,*)'status = he5_gdinqdims(gdid3, dimname, dims)'
         write(10,*)'Number of dimensions ',status
         write(10,*)'Dimensions in grid UTM ',dimname
         write(10,*)'Size of dimensions '
         do 131 i=1,status
            write(*,*)' ',dims(i)
            write(10,*)' ',dims(i)
 131     continue
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddiminfo
c
      write(10,27)
      write(10,*)'Testing gddiminfo... '
      write(10,*)'=================='
      write(*,*)'Testing gddiminfo... '
      write(*,*)'=================='

      lstatus = he5_gddiminfo(gdid_utm, 'Conduction')
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = he5_gddiminfo(gdid_utm, "Conduction")'
         write(*,*)'Size of dimension Conduction ',lstatus
         write(10,*)'lstatus = he5_gddiminfo(gdid_utm, "Conduction")'
         write(10,*)'Size of dimension Conduction ',lstatus
      endif
      write(10,*)' '
      write(*,*)' '

      lstatus = he5_gddiminfo(gdid3, 'Conduction')
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = he5_gddiminfo(gdid3, "Conduction")'
         write(*,*)'Size of dimension Conduction ',lstatus
         write(10,*)'lstatus = he5_gddiminfo(gdid3, "Conduction")'
         write(10,*)'Size of dimension Conduction ',lstatus
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgridinfo
c
      write(10,27)
      write(10,*)'Testing gdgridinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdgridinfo... '
      write(*,*)'=================='

      status=he5_gdgridinfo(gdid_utm,xdimsize,ydimsize,
     1upleftpt,lowrtpt)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status=he5_gdgridinfo(gdid_utm,xdimsize,
     1ydimsize,upleftpt,lowrtpt)'
         write(*,*)'Status returned by he5_gdgridinfo ',status
         write(*,11)'X dim size ',xdimsize, ' Y dim size ',ydimsize
         write(*,12)'Upper left pt ',upleftpt(1),' ',upleftpt(2)
         write(*,12)'Lower right pt ',lowrtpt(1),' ',lowrtpt(2)
         write(10,*)'status=he5_gdgridinfo(gdid_utm,xdimsize,
     1ydimsize,upleftpt,lowrtpt)'
         write(10,*)'Value returned by he5_gdgridinfo ',status
         write(10,*)'X dim size ',xdimsize, ' Y dim size ',ydimsize
         write(10,*)'Upper left pt ',upleftpt(1),upleftpt(2)
         write(10,*)'Lower right pt ',lowrtpt(1),lowrtpt(2)
      endif
      write(10,*)' '
      write(*,*)' '
   11 format(a,i2,a,i2)
   12 format(a,f14.5,a,f14.5)

      status=he5_gdgridinfo(gdid3,xdimsize,ydimsize,
     1upleftpt,lowrtpt)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status=he5_gdgridinfo(gdid3,xdimsize,
     1ydimsize,upleftpt,lowrtpt)'
         write(*,*)'Status returned by he5_gdgridinfo ',status
         write(*,11)'X dim size ',xdimsize, ' Y dim size ',ydimsize
         write(*,12)'Upper left pt ',upleftpt(1),' ',upleftpt(2)
         write(*,12)'Lower right pt ',lowrtpt(1),' ',lowrtpt(2)
         write(10,*)'status=he5_gdgridinfo(gdid3,xdimsize,
     1ydimsize,upleftpt,lowrtpt)'
         write(10,*)'Value returned by he5_gdgridinfo ',status
         write(10,*)'X dim size ',xdimsize, ' Y dim size ',ydimsize
         write(10,*)'Upper left pt ',upleftpt(1),upleftpt(2)
         write(10,*)'Lower right pt ',lowrtpt(1),lowrtpt(2)
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdprojinfo
c
      write(10,27)
      write(10,*)'Testing gdprojinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdprojinfo... '
      write(*,*)'=================='

      status = he5_gdprojinfo(gdid_utm,pcode,zcode,scode,pparm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status=he5_gdprojinfo(gdid_utm,pcode,zcode,
     1scode,pparm)'
         write(*,*)'Status returned by he5_gdprojinfo ',status
         write(*,*)'Projection code ',pcode, ' Zone code ',zcode
         write(*,*)'Sphere code ',scode
         write(10,*)'status=he5_gdprojinfo(gdid_utm,pcode,zcode,
     1scode,pparm)'
         write(10,*)'Value returned by he5_gdprojinfo ',status
         write(10,*)'Projection code ',pcode, ' Zone code ',zcode
         write(10,*)'Sphere code ',scode
         do 140 i=1,16
            write(*,55)' ',pparm(i)
            write(10,55)' ',pparm(i)
 140     continue
      endif
   55 format(a,f5.2)
      write(10,*)' '
      write(*,*)' '

      status = he5_gdprojinfo(gdid3,pcode,zcode,scode,pparm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status=he5_gdprojinfo(gdid3,pcode,zcode,
     1scode,pparm)'
         write(*,*)'Status returned by he5_gdprojinfo ',status
         write(*,*)'Projection code ',pcode, ' Zone code ',zcode
         write(*,*)'Sphere code ',scode
         write(10,*)'status=he5_gdprojinfo(gdid3,pcode,zcode,
     1scode,pparm)'
         write(10,*)'Value returned by he5_gdprojinfo ',status
         write(10,*)'Projection code ',pcode, ' Zone code ',zcode
         write(10,*)'Sphere code ',scode
         do 141 i=1,16
            write(*,55)' ',pparm(i)
            write(10,55)' ',pparm(i)
 141     continue
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdcompinfo
c
      write(10,27)
      write(10,*)'Testing gdcompinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdcompinfo... '
      write(*,*)'=================='

      status = he5_gdcompinfo(gdid_utm,'Voltage',
     1compcodestring,compparm)
      if (status .lt. zero) then
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status=he5_gdcompinfo(gdid_utm,"Voltage",
     1compcode,compparm)'
        write(10,*)'Compression info for field Voltage'
        write(10,*)'Comp code ',compcodestring
        write(10,*)'Compression parameters ',compparm
        write(*,*)'status=he5_gdcompinfo(gdid_utm,"Voltage",
     1compcode,compparm)'
        write(*,*)'Compression info for field Voltage'
        write(*,*)'Comp code ',compcodestring
        write(*,*)'Compression parameters ',compparm
      endif

      status = he5_gdcompinfo(gdid3,'Voltage',
     1compcodestring,compparm)
      if (status .lt. zero) then
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status=he5_gdcompinfo(gdid3,"Voltage",
     1compcode,compparm)'
        write(10,*)'Compression info for field Voltage'
        write(10,*)'Comp code ',compcodestring
        write(10,*)'Compression parameters ',compparm
        write(*,*)'status=he5_gdcompinfo(gdid3,"Voltage",
     1compcode,compparm)'
        write(*,*)'Compression info for field Voltage'
        write(*,*)'Comp code ',compcodestring
        write(*,*)'Compression parameters ',compparm
      endif

c Test Case -- gdinqflds
c
      write(10,27)
      write(10,*)'Testing gdinqflds... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqflds... '
      write(*,*)'=================='

      nflds = he5_gdinqflds(gdid_utm,fldlist,rnk,numtype)
      if (nflds .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'nflds = he5_gdinqflds(gdid_utm,fldlist,
     1rnk,numtype)'
         write(*,*)'Number of fields ',nflds
         write(10,*)'nflds = he5_gdinqflds(gdid_utm,fldlist,
     1rnk,numtype)'
         write(10,*)'Number of fields ',nflds
         if (nflds .ne. 0) then
            write(*,*)'Fields ',fldlist
            write(10,*)'Fields ',fldlist
            do 150 i=1,nflds
               write(*,*)'Rank and type ',rnk(i), ' ', numtype(i)
               write(10,*)'Rank and type ',rnk(i), ' ', numtype(i)
  150       continue
         endif
      endif
      write(10,*)' '
      write(*,*)' '

      nflds = he5_gdinqflds(gdid3,fldlist,rnk,numtype)
      if (nflds .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'nflds = he5_gdinqflds(gdid3,fldlist,
     1rnk,numtype)'
         write(*,*)'Number of fields ',nflds
         write(10,*)'nflds = he5_gdinqflds(gdid3,fldlist,
     1rnk,numtype)'
         write(10,*)'Number of fields ',nflds
         if (nflds .ne. 0) then
            write(*,*)'Fields ',fldlist
            write(10,*)'Fields ',fldlist
            do 151 i=1,nflds
               write(*,*)'Rank and type ',rnk(i), ' ', numtype(i)
               write(10,*)'Rank and type ',rnk(i), ' ', numtype(i)
  151       continue
         endif
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdfldinfo
c
      write(10,27)
      write(10,*)'Testing gdfldinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdfldinfo... '
      write(*,*)'=================='

      status=he5_gdfldinfo(gdid_utm,'Drift',rnk,dims,numtype,
     1dimname,maxdimname)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status=he5_gdfldinfo(gdid_utm,"Drift",rnk,dims, 
     1numtype, dimname, maxdimname)'
         write(*,*)'Value returned by he5_gdfldinfo for field 
     1Drift ',status
         write(*,*)'Drift rank ',rnk(1)
         write(*,*)'Dimensions  ',dims(1),' ',dims(2)
         write(*,*)'Number type of field ',numtype(1)
         write(*,*)'Dimension names ',dimname
         write(10,*)'status=he5_gdfldinfo(gdid_utm,"Drift",rnk,dims, 
     1numtype, dimname, maxdimname)'

         write(10,*)'Value returned by he5_gdfldinfo for field 
     1Drift ',status
         write(10,*)'Drift rank ',rnk(1)
      endif
      write(10,*)' '
      write(*,*)' '

      status=he5_gdfldinfo(gdid3,'Drift',rnk,dims,numtype,
     1dimname,maxdimname)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status=he5_gdfldinfo(gdid3,"Drift",rnk,dims, 
     1numtype, dimname, maxdimname)'
         write(*,*)'Value returned by he5_gdfldinfo for field 
     1Drift ',status
         write(*,*)'Drift rank ',rnk(1)
         write(*,*)'Dimensions  ',dims(1),' ',dims(2)
         write(*,*)'Number type of field ',numtype(1)
         write(*,*)'Dimension names ',dimname
         write(10,*)'status=he5_gdfldinfo(gdid3,"Drift",rnk,dims, 
     1numtype, dimname, maxdimname)'

         write(10,*)'Value returned by he5_gdfldinfo for field 
     1Drift ',status
         write(10,*)'Drift rank ',rnk(1)
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdrdfld
c
      write(10,27)
      write(10,*)'Testing gdrdfld... '
      write(10,*)'=================='
      write(*,*)'Testing gdrdfld... '
      write(*,*)'=================='

      start(1) = 0
      start(2) = 0
      stride(1) = 1
      stride(2) = 1
      edge(1) = 80
      edge(2) = 60
      status = he5_gdrdfld(gdid_utm,'Drift',start,stride,edge,
     1tempray)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdrdfld(gdid_utm,"Drift",start,
     1stride,edge,tempray)'
         write(*,*)'Value returned by he5_gdrdfld ',status
         write(10,*)'status = he5_gdrdfld(gdid_utm,"Drift",start,
     1stride,edge,tempray)'
         write(10,*)'Value returned by he5_gdrdfld ',status
         do 65 ii=1,6
           do 66 i=1,5
              write(10,*)'Field value at ',ii,' ',i,'  ',tempray(ii,i)
              write(*,*)'Field value at ',ii,' ',i,'  ',tempray(ii,i)
   66      continue
   65   continue
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdrdfld(gdid3,'Drift',start,stride,edge,
     1tempray)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdrdfld(gdid3,"Drift",start,
     1stride,edge,tempray)'
         write(*,*)'Value returned by he5_gdrdfld ',status
         write(10,*)'status = he5_gdrdfld(gdid3,"Drift",start,
     1stride,edge,tempray)'
         write(10,*)'Value returned by he5_gdrdfld ',status
         do 75 ii=1,6
           do 76 i=1,5
              write(10,*)'Field value at ',ii,' ',i,'  ',tempray(ii,i)
              write(*,*)'Field value at ',ii,' ',i,'  ',tempray(ii,i)
   76      continue
   75   continue
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- gdnentries
c
      write(10,27)
      write(10,*)'Testing gdnentries... '
      write(10,*)'=================='
      write(*,*)'Testing gdnentries... '
      write(*,*)'=================='

      n = he5_gdnentries(gdid_utm, HE5_HDFE_NENTDIM, strbufsize)
      if (n .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'n = he5_gdnentries(gdid_utm,
     1HE5_HDFE_NENTDIM, strbufsize)'
         write(*,*)'Number of dimensions ', n
         write(*,*)'Size of Dimension string ',strbufsize
         write(10,*)'n = he5_gdnentries(gdid_utm, 
     1HE5_HDFE_NENTDIM, strbufsize)'
         write(10,*)'Number of dimensions ', n
         write(10,*)'Size of Dimension string ',strbufsize
      endif

      n = he5_gdnentries(gdid_utm,HE5_HDFE_NENTDFLD,strbufsize)
      if (n .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'n = he5_gdnentries(gdid_utm,HE5_HDFE_NENTDFLD,
     1strbufsize)'
         write(*,*)'Number of data fields ',n
         write(*,*)'Size of Field string ',strbufsize
         write(10,*)'n = he5_gdnentries(gdid_utm,HE5_HDFE_NENTDFLD,
     1strbufsize)'
         write(10,*)'Number of data fields ',n
         write(10,*)'Size of Field string ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

      n = he5_gdnentries(gdid3, HE5_HDFE_NENTDIM, strbufsize)
      if (n .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'n = he5_gdnentries(gdid3,
     1HE5_HDFE_NENTDIM, strbufsize)'
         write(*,*)'Number of dimensions ', n
         write(*,*)'Size of Dimension string ',strbufsize
         write(10,*)'n = he5_gdnentries(gdid3, 
     1HE5_HDFE_NENTDIM, strbufsize)'
         write(10,*)'Number of dimensions ', n
         write(10,*)'Size of Dimension string ',strbufsize
      endif

      n = he5_gdnentries(gdid3,HE5_HDFE_NENTDFLD,strbufsize)
      if (n .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'n = he5_gdnentries(gdid3,HE5_HDFE_NENTDFLD,
     1strbufsize)'
         write(*,*)'Number of data fields ',n
         write(*,*)'Size of Field string ',strbufsize
         write(10,*)'n = he5_gdnentries(gdid3,HE5_HDFE_NENTDFLD,
     1strbufsize)'
         write(10,*)'Number of data fields ',n
         write(10,*)'Size of Field string ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdattrinfo
c
      write(10,27)
      write(10,*)'Testing gdattrinfo, Global attribute'
      write(10,*)'===================================='
      write(*,*)'Testing gdattrinfo, Global attribute'
      write(*,*)'===================================='

      status = he5_gdattrinfo(gdid_utm,'Resistance',ntype,count)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status=he5_gdattrinfo(gdid_utm,"Resistance",
     1ntype,count)'
         write(*,*)'Value returned by he5_gdattrinfo ',status
         write(*,*)'Number type of attribute ',ntype
         write(*,*)'Number of total bytes in attribute ',count
         write(10,*)'status=he5_gdattrinfo(gdid_utm,"Resistance",
     1ntype,count)'
         write(10,*)'Value returned by he5_gdattrinfo ',status
         write(10,*)'Number type of attribute ',ntype
         write(10,*)'Number of total bytes in attribute ',count
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdattrinfo(gdid3,'Resistance',ntype,count)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status=he5_gdattrinfo(gdid3,"Resistance",
     1ntype,count)'
         write(*,*)'Value returned by he5_gdattrinfo ',status
         write(*,*)'Number type of attribute ',ntype
         write(*,*)'Number of total bytes in attribute ',count
         write(10,*)'status=he5_gdattrinfo(gdid3,"Resistance",
     1ntype,count)'
         write(10,*)'Value returned by he5_gdattrinfo ',status
         write(10,*)'Number type of attribute ',ntype
         write(10,*)'Number of total bytes in attribute ',count
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgatinfo
c
      write(10,27)
      write(10,*)'Testing gdgatinfo, Group attribute'
      write(10,*)'===================================='
      write(*,*)'Testing gdgatinfo, Group attribute'
      write(*,*)'===================================='

      status = he5_gdgatinfo(gdid_utm,'group',ntype,count)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdgatinfo(gdid_utm,"group",
     1ntype,count)'
         write(*,*)'Value returned by he5_gdgatinfo ',status
         write(*,*)'Number type of attribute ',ntype
         write(*,*)'Number of total bytes in attribute ',count
         write(10,*)'status = he5_gdgatinfo(gdid_utm,"group",
     1ntype,count)'
         write(10,*)'Value returned by he5_gdgatinfo ',status
         write(10,*)'Number type of attribute ',ntype
         write(10,*)'Number of total bytes in attribute ',count
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdgatinfo(gdid3,'group',ntype,count)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdgatinfo(gdid3,"group",
     1ntype,count)'
         write(*,*)'Value returned by he5_gdgatinfo ',status
         write(*,*)'Number type of attribute ',ntype
         write(*,*)'Number of total bytes in attribute ',count
         write(10,*)'status = he5_gdgatinfo(gdid3,"group",
     1ntype,count)'
         write(10,*)'Value returned by he5_gdgatinfo ',status
         write(10,*)'Number type of attribute ',ntype
         write(10,*)'Number of total bytes in attribute ',count
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdlatinfo
c
      write(10,27)
      write(10,*)'Testing gdlatinfo, Local attribute'
      write(10,*)'===================================='
      write(*,*)'Testing gdlatinfo, Local attribute'
      write(*,*)'===================================='

      status = he5_gdlatinfo(gdid_utm,"Grounding","local",ntype,count)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdlatinfo(gdid_utm,"Grounding",
     1"local",ntype,count)'
         write(*,*)'Value returned by he5_gdlatinfo ',status
         write(*,*)'Number type of attribute ',ntype
         write(*,*)'Number of total bytes in attribute ',count
         write(10,*)'status = he5_gdlatinfo(gdid_utm,"Grounding",
     1"local",ntype,count)'
         write(10,*)'Value returned by he5_gdgatinfo ',status
         write(10,*)'Number type of attribute ',ntype
         write(10,*)'Number of total bytes in attribute ',count
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdlatinfo(gdid3,"Grounding","local",ntype,count)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdlatinfo(gdid3,"Grounding",
     1"local",ntype,count)'
         write(*,*)'Value returned by he5_gdlatinfo ',status
         write(*,*)'Number type of attribute ',ntype
         write(*,*)'Number of total bytes in attribute ',count
         write(10,*)'status = he5_gdlatinfo(gdid3,"Grounding",
     1"local",ntype,count)'
         write(10,*)'Value returned by he5_gdgatinfo ',status
         write(10,*)'Number type of attribute ',ntype
         write(10,*)'Number of total bytes in attribute ',count
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdrdattr
c
      write(10,27)
      write(10,*)'Testing gdrdattr, Global attribute'
      write(10,*)'=================================='
      write(*,*)'Testing gdrdattr, Global attribute'
      write(*,*)'=================================='

      status = he5_gdrdattr(gdid_utm,'Resistance',iattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status = he5_gdrdattr(gdid_utm,"Resistance",iattr)'
        write(*,*)'Value returned by he5_gdrdattr ',status
        write(10,*)'status = he5_gdrdattr(gdid_utm,"Resistance",iattr)'
        write(10,*)'Value returned by he5_gdrdattr ',status
        do 67 i=1,count
           write(10,*)'Attribute value  ',iattr(i)
           write(*,*)'Attribute value   ',iattr(i)
   67   continue
        
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdrdattr(gdid3,'Resistance',iattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status = he5_gdrdattr(gdid3,"Resistance",iattr)'
        write(*,*)'Value returned by he5_gdrdattr ',status
        write(10,*)'status = he5_gdrdattr(gdid3,"Resistance",iattr)'
        write(10,*)'Value returned by he5_gdrdattr ',status
        do 77 i=1,count
           write(10,*)'Attribute value  ',iattr(i)
           write(*,*)'Attribute value   ',iattr(i)
   77   continue
        
      endif
      write(10,*)' '
      write(*,*)' '
  
c Test Case -- gdrdgattr
c
      write(10,27)
      write(10,*)'Testing gdrdgattr, Group attribute '
      write(10,*)'=================================='
      write(*,*)'Testing gdrdgattr, Group attribute'
      write(*,*)'================================='

      status = he5_gdrdgattr(gdid_utm,'group',gattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status = he5_gdrdgattr(gdid_utm,"group",gattr)'
        write(*,*)'Value returned by he5_gdrdgattr ',status
        write(10,*)'status = he5_gdrdgattr(gdid_utm,"group",gattr)'
        write(10,*)'Value returned by he5_gdrdgattr ',status
        do 68 i=1,count
           write(10,*)'Attribute value  ',gattr(i)
           write(*,*)'Attribute value   ',gattr(i)
   68   continue
        
      endif
      write(10,*)' '
      write(*,*)' '
  
      status = he5_gdrdgattr(gdid3,'group',gattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status = he5_gdrdgattr(gdid3,"group",gattr)'
        write(*,*)'Value returned by he5_gdrdgattr ',status
        write(10,*)'status = he5_gdrdgattr(gdid3,"group",gattr)'
        write(10,*)'Value returned by he5_gdrdgattr ',status
        do 78 i=1,count
           write(10,*)'Attribute value  ',gattr(i)
           write(*,*)'Attribute value   ',gattr(i)
   78   continue
        
      endif
      write(10,*)' '
      write(*,*)' '
  
c Test Case -- gdinqdatatype
c
      write(10,27)
      write(10,*)'Testing gdinqdatatype '
      write(10,*)'====================='
      write(*,*)'Testing gdinqdatatype'
      write(*,*)'====================='

      status = he5_gdinqdatatype(gdid_utm,"Grounding","local",
     1HE5_HDFE_LOCATTRGROUP,dtype,classid,order,size)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
        write(*,*)' '
        write(*,240)
        write(10,*)' '
        write(10,240)
         write(*,*)'status = he5_gdinqdatatype(gdid_utm,"Grounding",
     1"local",HE5_HDFE_LOCATTRGROUP,dtype,classid,order,size)'
         write(*,*)'Data type of attribute ',dtype
         write(*,*)'Class id of attribute ',classid
         write(*,*)'Order of attribute ',order
         write(*,*)'Size of attribute ',size
         write(10,*)'status =he5_gdinqdatatype(gdid_utm,"Grounding",
     1"local",HE5_HDFE_LOCATTRGROUP,dtype,classid,order,size)'
         write(10,*)'Data type of attribute ',dtype
         write(10,*)'Class id of attribute ',classid
         write(10,*)'Order of attribute ',order
         write(10,*)'Size of attribute ',size
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdinqdatatype(gdid3,"Grounding","local",
     1HE5_HDFE_LOCATTRGROUP,dtype,classid,order,size)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
        write(*,*)' '
        write(*,240)
        write(10,*)' '
        write(10,240)
         write(*,*)'status = he5_gdinqdatatype(gdid3,"Grounding",
     1"local",HE5_HDFE_LOCATTRGROUP,dtype,classid,order,size)'
         write(*,*)'Data type of attribute ',dtype
         write(*,*)'Class id of attribute ',classid
         write(*,*)'Order of attribute ',order
         write(*,*)'Size of attribute ',size
         write(10,*)'status =he5_gdinqdatatype(gdid3,"Grounding",
     1"local",HE5_HDFE_LOCATTRGROUP,dtype,classid,order,size)'
         write(10,*)'Data type of attribute ',dtype
         write(10,*)'Class id of attribute ',classid
         write(10,*)'Order of attribute ',order
         write(10,*)'Size of attribute ',size
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdrdlattr
c
      write(10,27)
      write(10,*)'Testing gdrdlattr, Local attribute '
      write(10,*)'=================================='
      write(*,*)'Testing gdrdlattr, Local attribute'
      write(*,*)'================================='

      status = he5_gdrdlattr(gdid_utm,"Grounding","local",lattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status=he5_gdrdlattr(gdid_utm,"Grounding",
     1"local",lattr)'
        write(*,*)'Value returned by he5_gdrdlattr ',status
        write(10,*)'status=he5_gdrdlattr(gdid_utm,"Grounding",
     1"local",lattr)'
        write(10,*)'Value returned by he5_gdrdlattr ',status
        do 69 i=1,count
           write(10,*)'Attribute value  ',lattr(i)
           write(*,*)'Attribute value   ',lattr(i)
   69   continue
        
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdrdlattr(gdid3,"Grounding","local",lattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status=he5_gdrdlattr(gdid3,"Grounding",
     1"local",lattr)'
        write(*,*)'Value returned by he5_gdrdlattr ',status
        write(10,*)'status=he5_gdrdlattr(gdid3,"Grounding",
     1"local",lattr)'
        write(10,*)'Value returned by he5_gdrdlattr ',status
        do 79 i=1,count
           write(10,*)'Attribute value  ',lattr(i)
           write(*,*)'Attribute value   ',lattr(i)
   79   continue
        
      endif
      write(10,*)' '
      write(*,*)' '
  
c Test Case -- gdinqattrs
c
      write(10,27)
      write(10,*)'Testing gdinqattrs, Global attribute'
      write(10,*)'===================================='
      write(*,*)'Testing gdinqattrs, Global attribute'
      write(*,*)'===================================='

      lstatus = he5_gdinqattrs(gdid_utm, attrlist,strbufsize)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = he5_gdinqattrs(gdid_utm, 
     1attrlist,strbufsize)'
        write(*,*)'Value returned by he5_gdinqattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(*,*)'Length of attrlist in bytes ',strbufsize
        write(10,*)'lstatus = he5_gdinqattrs(gdid_utm, 
     1attrlist,strbufsize)'
        write(10,*)'Value returned by he5_gdinqattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
        write(10,*)'Length of attrlist in bytes ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

      lstatus = he5_gdinqattrs(gdid3, attrlist,strbufsize)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = he5_gdinqattrs(gdid3, 
     1attrlist,strbufsize)'
        write(*,*)'Value returned by he5_gdinqattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(*,*)'Length of attrlist in bytes ',strbufsize
        write(10,*)'lstatus = he5_gdinqattrs(gdid3, 
     1attrlist,strbufsize)'
        write(10,*)'Value returned by he5_gdinqattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
        write(10,*)'Length of attrlist in bytes ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdinqgattrs
c
      write(10,27)
      write(10,*)'Testing gdinqgattrs, Group attribute'
      write(10,*)'===================================='
      write(*,*)'Testing gdinqgattrs, Group attribute'
      write(*,*)'===================================='

      lstatus = he5_gdinqgattrs(gdid_utm, attrlist,strbufsize)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = he5_gdinqgattrs(gdid_utm, 
     1attrlist,strbufsize)'
        write(*,*)'Value returned by he5_gdinqgattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(*,*)'Length of attrlist in bytes ',strbufsize
        write(10,*)'lstatus = he5_gdinqgattrs(gdid_utm,
     1attrlist,strbufsize)'
        write(10,*)'Value returned by he5_gdinqgattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
        write(10,*)'Length of attrlist in bytes ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

      lstatus = he5_gdinqgattrs(gdid3, attrlist,strbufsize)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = he5_gdinqgattrs(gdid3, 
     1attrlist,strbufsize)'
        write(*,*)'Value returned by he5_gdinqgattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(*,*)'Length of attrlist in bytes ',strbufsize
        write(10,*)'lstatus = he5_gdinqgattrs(gdid3,
     1attrlist,strbufsize)'
        write(10,*)'Value returned by he5_gdinqgattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
        write(10,*)'Length of attrlist in bytes ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdinqlattrs
c
      write(10,27)
      write(10,*)'Testing gdinqlattrs, Local attribute'
      write(10,*)'===================================='
      write(*,*)'Testing gdinqlattrs, Local attribute'
      write(*,*)'===================================='

      lstatus = he5_gdinqlattrs(gdid_utm,"Grounding",
     1attrlist,strbufsize)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = he5_gdinqlattrs(gdid_utm,"Grounding",
     1attrlist,strbufsize)'
        write(*,*)'Value returned by he5_gdinqlattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(*,*)'Length of attrlist in bytes ',strbufsize
        write(10,*)'lstatus = he5_gdinqlattrs(gdid_utm,"Grounding",
     1attrlist,strbufsize)'
        write(10,*)'Value returned by he5_gdinqlattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
        write(10,*)'Length of attrlist in bytes ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

      lstatus = he5_gdinqlattrs(gdid3,"Grounding",
     1attrlist,strbufsize)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = he5_gdinqlattrs(gdid3,"Grounding",
     1attrlist,strbufsize)'
        write(*,*)'Value returned by he5_gdinqlattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(*,*)'Length of attrlist in bytes ',strbufsize
        write(10,*)'lstatus = he5_gdinqlattrs(gdid3,"Grounding",
     1attrlist,strbufsize)'
        write(10,*)'Value returned by he5_gdinqlattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
        write(10,*)'Length of attrlist in bytes ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgetfill
c
      write(10,27)
      write(10,*)'Testing gdgetfill... '
      write(10,*)'=================='
      write(*,*)'Testing gdgetfill... '
      write(*,*)'=================='

      status = he5_gdgetfill(gdid_utm,'Drift',ifillv)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdgetfill(gdid_utm,"Drift",ifillv)'
         write(*,*)'Value returned by he5_gdgetfill ',status
         write(*,*)'Fill value ',ifillv
         write(10,*)'status = he5_gdgetfill(gdid_utm,"Drift",ifillv)'
         write(10,*)'Value returned by he5_gdgetfill ',status
         write(10,*)'Fill value ',ifillv
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdgetfill(gdid3,'Drift',ifillv)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdgetfill(gdid3,"Drift",ifillv)'
         write(*,*)'Value returned by he5_gdgetfill ',status
         write(*,*)'Fill value ',ifillv
         write(10,*)'status = he5_gdgetfill(gdid3,"Drift",ifillv)'
         write(10,*)'Value returned by he5_gdgetfill ',status
         write(10,*)'Fill value ',ifillv
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefboxreg
c
      write(10,27)
      write(10,*)'Testing gddefboxreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddefboxreg... '
      write(*,*)'=================='

      corlon(1)=-126.0
      corlon(2)=-121.5
      corlat(1)=-70.0
      corlat(2)=-65.0

      regionid = he5_gddefboxreg(gdid_utm,corlon,corlat)
      if (regionid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'regionid = he5_gddefboxreg(gdid_utm,corlon,corlat)'
         write(*,*)'Region id returned by he5_gddefboxreg ',regionid
         write(10,*)'regionid = he5_gddefboxreg(gdid_utm,corlon,corlat)'
         write(10,*)'Region id returned by he5_gddefboxreg ',regionid
      endif
      write(10,*)' '
      write(*,*)' '

      regionid3 = he5_gddefboxreg(gdid3,corlon,corlat)
      if (regionid3 .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'regionid3 = he5_gddefboxreg(gdid3,corlon,corlat)'
         write(*,*)'Region id returned by he5_gddefboxreg ',regionid3
         write(10,*)'regionid3 = he5_gddefboxreg(gdid3,corlon,corlat)'
         write(10,*)'Region id returned by he5_gddefboxreg ',regionid3
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- gdreginfo
c
      write(10,27)
      write(10,*)'Testing gdreginfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdreginfo... '
      write(*,*)'=================='
      status = he5_gdreginfo(gdid_utm,regionid,"Impedance",nt,rk,
     1dims,size,iuplft,ilrgt)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdreginfo(gdid_utm,regionid,
     1"Impedance",nt,rk,dims,size,iuplft,ilrgt)'
         write(*,*)'Value returned by he5_gdreginfo ',status
         write(*,*)'Number type of region ',nt
         write(*,*)'Rank of region ',rk
         write(*,*)'Size of region ',size
         write(*,11)'Dimensions of region',dims(1),' ',dims(2)
         write(*,12)'Upper left point of region ',
     1iuplft(1),' ',iuplft(2)
         write(*,12)'Lower right point of region ',ilrgt(1),' ',ilrgt(2)
         write(10,*)'status = he5_gdreginfo(gdid_utm,regionid,
     1"Impedance",nt,rk,dims,size,iuplft,ilrgt)'
         write(10,*)'Value returned by he5_gdreginfo ',status
         write(10,*)'Number type of region ',nt
         write(10,*)'Rank of region ',rk
         write(10,*)'Size of region ',size
         write(10,11)'Dimensions of region',dims(1),' ',dims(2)
         write(10,12)'Upper left point of region ',
     1iuplft(1),' ',iuplft(2)
         write(10,12)'Lower right point of region ',
     1ilrgt(1),' ',ilrgt(2)
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdreginfo(gdid3,regionid3,"Impedance",nt,rk,
     1dims,size,iuplft,ilrgt)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdreginfo(gdid3,regionid3,"Impedance",
     1nt,rk,dims,size,iuplft,ilrgt)'
         write(*,*)'Value returned by he5_gdreginfo ',status
         write(*,*)'Number type of region ',nt
         write(*,*)'Rank of region ',rk
         write(*,*)'Size of region ',size
         write(*,11)'Dimensions of region',dims(1),' ',dims(2)
         write(*,12)'Upper left point of region ',
     1iuplft(1),' ',iuplft(2)
         write(*,12)'Lower right point of region ',ilrgt(1),' ',ilrgt(2)
         write(10,*)'status = he5_gdreginfo(gdid3,regionid3,
     1"Impedance",nt,rk,dims,size,iuplft,ilrgt)'
         write(10,*)'Value returned by he5_gdreginfo ',status
         write(10,*)'Number type of region ',nt
         write(10,*)'Rank of region ',rk
         write(10,*)'Size of region ',size
         write(10,11)'Dimensions of region',dims(1),' ',dims(2)
         write(10,12)'Upper left point of region ',
     1iuplft(1),' ',iuplft(2)
         write(10,12)'Lower right point of region ',
     1ilrgt(1),' ',ilrgt(2)
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdextreg
c
      write(10,27)
      write(10,*)'Testing gdextreg... '
      write(10,*)'=================='
      write(*,*)'Testing gdextreg... '
      write(*,*)'=================='

      status = he5_gdextreg(gdid_utm,regionid,'Impedance',datbuf)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)

         write(*,*)'status=he5_gdextreg(gdid_utm,regionid,
     1"Impedance",datbuf)'
         write(*,*)'Value returned by he5_gdextreg ',status
         write(10,*)'status=he5_gdextreg(gdid_utm,
     1regionid,"Impedance",datbuf)'
         write(10,*)'Value returned by he5_gdextreg ',status
         do 175 i=100,150
            write(*,*)'Value of region ',datbuf(i)
            write(10,*)'Value of region ',datbuf(i)
  175    continue
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdextreg(gdid3,regionid3,'Impedance',datbuf)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)

         write(*,*)'status=he5_gdextreg(gdid3,regionid3,
     1"Impedance",datbuf)'
         write(*,*)'Value returned by he5_gdextreg ',status
         write(10,*)'status=he5_gdextreg(gdid3,
     1regionid,"Impedance",datbuf)'
         write(10,*)'Value returned by he5_gdextreg ',status
         do 185 i=100,150
            write(*,*)'Value of region ',datbuf(i)
            write(10,*)'Value of region ',datbuf(i)
  185    continue
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeftmeper
c
      write(10,27)
      write(10,*)'Testing gddeftmeper... '
      write(10,*)'=================='
      write(*,*)'Testing gddeftmeper... '
      write(*,*)'=================='

      periodid = he5_gddeftmeper(gdid_utm,
     1HE5_HDFE_NOPREVSUB,starttime,stoptime)
      if (periodid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'periodid = he5_gddeftmeper(gdid_utm,
     1HE5_HDFE_NOPREVSUB,starttime,stoptime)'
        write(10,*)'Define a time period '
        write(10,*)'Period id returned by he5_gddeftmeper ',periodid
        write(*,*)'periodid = he5_gddeftmeper(gdid_utm,
     1HE5_HDFE_NOPREVSUB,starttime,stoptime)'
        write(*,*)'Define a time period '
        write(*,*)'Period id returned by he5_gddeftmeper ',periodid
      endif
      write(10,*)' '
      write(*,*)' '

      periodid = he5_gddeftmeper(gdid3,
     1HE5_HDFE_NOPREVSUB,starttime,stoptime)
      if (periodid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'periodid = he5_gddeftmeper(gdid3,HE5_HDFE_NOPREVSUB,
     1starttime,stoptime)'
        write(10,*)'Define a time period '
        write(10,*)'Period id returned by he5_gddeftmeper ',periodid
        write(*,*)'periodid = he5_gddeftmeper(gdid3,HE5_HDFE_NOPREVSUB,
     1starttime,stoptime)'
        write(*,*)'Define a time period '
        write(*,*)'Period id returned by he5_gddeftmeper ',periodid
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefvrtreg
c
      write(10,27)
      write(10,*)'Testing gddefvrtreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddefvrtreg... '
      write(*,*)'=================='

      regionid = he5_gddefvrtreg(gdid_utm,
     1HE5_HDFE_NOPREVSUB,'Height',range)
      if (regionid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)

        write(10,*)'regionid = he5_gddefvrtreg(gdid_utm,
     1HE5_HDFE_NOPREVSUB,"Height",range)'
        write(10,*)'Define a vertical region '
        write(10,*)'Region id returned by he5_gddefvrtreg ',regionid
        write(*,*)'regionid = he5_gddefvrtreg(gdid_utm,
     1HE5_HDFE_NOPREVSUB,"Height",range)'
        write(*,*)'Define a vertical region '
        write(*,*)'Region id returned by he5_gddefvrtreg ',regionid
      endif
      write(10,*)' '
      write(*,*)' '

      regionid3 = he5_gddefvrtreg(gdid3,
     1HE5_HDFE_NOPREVSUB,'Height',range)
      if (regionid3 .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)

        write(10,*)'regionid3 = he5_gddefvrtreg(gdid3,
     1HE5_HDFE_NOPREVSUB,"Height",range)'
        write(10,*)'Define a vertical region '
        write(10,*)'Region id returned by he5_gddefvrtreg ',regionid3
        write(*,*)'regionid3 = he5_gddefvrtreg(gdid3,
     1HE5_HDFE_NOPREVSUB,"Height",range)'
        write(*,*)'Define a vertical region '
        write(*,*)'Region id returned by he5_gddefvrtreg ',regionid3
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddupreg
c
      write(10,27)
      write(10,*)'Testing gddupreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddupreg... '
      write(*,*)'=================='

      regionid2 = he5_gddupreg(regionid)
      if (regionid2 .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'regionid2 = he5_gddupreg(regionid)'
        write(10,*)'Generate a new region id '
        write(10,*)'New region id ',regionid2
        write(*,*)'regionid2 = he5_gddupreg(regionid)'
        write(*,*)'Generate a new region id '
        write(*,*)'New region id ',regionid2
      endif
      write(10,*)' '
      write(*,*)' '

      regionid4 = he5_gddupreg(regionid3)
      if (regionid4 .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'regionid4 = he5_gddupreg(regionid3)'
        write(10,*)'Generate a new region id '
        write(10,*)'New region id ',regionid4
        write(*,*)'regionid4 = he5_gddupreg(regionid3)'
        write(*,*)'Generate a new region id '
        write(*,*)'New region id ',regionid4
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgetpix
c
      write(10,27)
      write(10,*)'Testing gdgetpix... '
      write(10,*)'=================='
      write(*,*)'Testing gdgetpix... '
      write(*,*)'=================='

      status = he5_gdgetpix(gdid_utm,5,lonval,latval,rowval,colval)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)

        write(10,*)'status=he5_gdgetpix(gdid_utm,5,lonval,
     1latval,rowval,colval)'
        write(10,*)'Retrieve pixel row. column values '
        write(*,*)'status = he5_gdgetpix(gdid_utm,5,lonval,latval,
     1rowval,colval)'
        write(*,*)'Retrieve pixel row. column values '
        do 37 i=1,5
           write(10,5)'Pixel position lon lat ',lonval(i),' ',
     1latval(i),' ','Row Column ',rowval(i),' ',colval(i) 
           write(*,5)'Pixel position lon lat ',lonval(i),' ',
     1latval(i),' ','Row Column ',rowval(i),' ',colval(i) 
   37   continue
      endif
    5 format(a,f6.1,a,f6.1,a,a,i2,a,i2)
      write(10,*)' '
      write(*,*)' '

      status = he5_gdgetpix(gdid3,5,lonval,latval,rowval,colval)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)

        write(10,*)'status=he5_gdgetpix(gdid3,5,lonval,
     1latval,rowval,colval)'
        write(10,*)'Retrieve pixel row. column values '
        write(*,*)'status = he5_gdgetpix(gdid3,5,lonval,latval,
     1rowval,colval)'
        write(*,*)'Retrieve pixel row. column values '
        do 47 i=1,5
           write(10,5)'Pixel position lon lat ',lonval(i),' ',
     1latval(i),' ','Row Column ',rowval(i),' ',colval(i) 
           write(*,5)'Pixel position lon lat ',lonval(i),' ',
     1latval(i),' ','Row Column ',rowval(i),' ',colval(i) 
   47   continue
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgetpixval
c
      write(10,27)
      write(10,*)'Testing gdgetpixval... '
      write(10,*)'=================='
      write(*,*)'Testing gdgetpixval... '
      write(*,*)'=================='

      lstatus = he5_gdgetpixval(gdid_utm,5,rowval,
     1colval,"Voltage",fldval)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'lstatus = he5_gdgetpixval(gdid_utm,5,rowval,colval,
     1"Voltage",fldval)'
        write(10,*)'Retrieve pixel values for specific locations '
        write(*,*)'lstatus = he5_gdgetpixval(gdid_utm,5,rowval,colval,
     1"Voltage",fldval)'
        write(*,*)'Retrieve pixel values for specific locations '
        do 42 i=1,5
           write(10,17)'Row Col ',rowval(i),' ',colval(i),' ',
     1'Pixel Value ',fldval(i)
           write(*,17)'Row Col ',rowval(i),' ',colval(i),' ',
     1'Pixel Value ',fldval(i)
   42   continue
      endif
   17 format(a8,i2,a1,i2,a1,a12,f9.3)
      write(10,*)' '
      write(*,*)' '

      lstatus = he5_gdgetpixval(gdid3,5,rowval,
     1colval,"Voltage",fldval)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'lstatus = he5_gdgetpixval(gdid3,5,rowval,colval,
     1"Voltage",fldval)'
        write(10,*)'Retrieve pixel values for specific locations '
        write(*,*)'lstatus = he5_gdgetpixval(gdid3,5,rowval,colval,
     1"Voltage",fldval)'
        write(*,*)'Retrieve pixel values for specific locations '
        do 52 i=1,5
           write(10,17)'Row Col ',rowval(i),' ',colval(i),' ',
     1'Pixel Value ',fldval(i)
           write(*,17)'Row Col ',rowval(i),' ',colval(i),' ',
     1'Pixel Value ',fldval(i)
   52   continue
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdinterpolate
c
      write(10,27)
      write(10,*)'Testing gdinterpolate... '
      write(10,*)'=================='
      write(*,*)'Testing gdinterpolate... '
      write(*,*)'=================='

      lstatus=he5_gdinterpolate(gdid_utm,5,lonval,latval,
     1'Voltage',interval)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'lstatus=he5_gdinterpolate(gdid_utm,5,lonval,latval,
     1"Voltage",interval)'
        write(10,*)'Interpolate 5 values for field Voltage '
        write(*,*)'lstatus=he5_gdinterpolate(gdid_utm,5,lonval,latval,
     1"Voltage",interval)'
        write(*,*)'Interpolate 5 values for field Voltage '
        write(*,*)'Status returned by call to he5_gdinterpolate ',
     1lstatus
        do 38 index1=1,5
           write(*,4)'Interpolated value ',interval(index1,1)
           write(10,4)'Interpolated value ',interval(index1,1)
   38   continue
      endif
    4 format(a,f9.3)
      write(10,*)' '
      write(*,*)' '


      status = he5_gddetach(gdid_utm)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Value returned by he5_gddetach ',status
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Value returned by he5_gddetach ',status
      endif

      lstatus=he5_gdinterpolate(gdid3,5,lonval,latval,
     1'Voltage',interval)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'lstatus=he5_gdinterpolate(gdid3,5,lonval,latval,
     1"Voltage",interval)'
        write(10,*)'Interpolate 5 values for field Voltage '
        write(*,*)'lstatus=he5_gdinterpolate(gdid3,5,lonval,latval,
     1"Voltage",interval)'
        write(*,*)'Interpolate 5 values for field Voltage '
        write(*,*)'Status returned by call to he5_gdinterpolate ',
     1lstatus
        do 48 index1=1,5
           write(*,4)'Interpolated value ',interval(index1,1)
           write(10,4)'Interpolated value ',interval(index1,1)
   48   continue
      endif
      write(10,*)' '
      write(*,*)' '


      status = he5_gddetach(gdid3)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gddetach(gdid3)'
         write(*,*)'Value returned by he5_gddetach ',status
         write(10,*)'status = he5_gddetach(gdid3)'
         write(10,*)'Value returned by he5_gddetach ',status
      endif

      status = he5_gdclose(gdfid)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdclose(gdfid)'
         write(*,*)'Returned from he5_gdclose ', status
         write(10,*)'status = he5_gdclose(gdfid)'
         write(10,*)'Returned from he5_gdclose ', status
      endif

      status = he5_gdclose(gdfid3)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdclose(gdfid3)'
         write(*,*)'Returned from he5_gdclose ', status
         write(10,*)'status = he5_gdclose(gdfid3)'
         write(10,*)'Returned from he5_gdclose ', status
      endif

      close(unit=10)
  27  format('')
      stop
      end

c  In this example we will (1) open the "grid.he5" HDF-EOS file, (2) attach to
c  the "PolarGrid" grid, and (3) subset data from the "Temperature" field.
 
      program      he5_gd_subsetF_64

      implicit     none

      include      'hdfeos5.inc'

      integer      status
      integer      gdfid
      integer      gdid
      integer      rgid
      integer      he5_gdopen
      integer      he5_gdattach
      integer      he5_gdreginfo
      integer      he5_gddefboxreg
      integer      he5_gdextreg
      integer      he5_gddetach
      integer      he5_gdclose
      integer      rk,nt

      integer*8    dims(8)
      integer*8    size

      real*8       cornerlon(2)
      real*8       cornerlat(2)
      real*8       upleft(2)
      real*8       lowright(2)

      real*4       datbuf(100*100)
	
      integer      FAIL
      parameter    (FAIL=-1)

c     Open the HDF-EOS grid file, "grid.he5"
c     --------------------------------------- 
      gdfid = he5_gdopen("grid.he5",HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_gdopen():  ',gdfid

      if (gdfid .NE. FAIL) then

c        Attach to the POLAR grid
c        ------------------------
         gdid = he5_gdattach(gdfid,"PolarGrid")
         write(*,*) 'Grid ID returned by he5_gdattach():  ',gdid

         if (gdid .NE. FAIL) then
            cornerlon(1) = 0.
            cornerlat(1) = 90.
            cornerlon(2) = 90.
            cornerlat(2) = 0.

c           Define box region
c           -----------------
            rgid   = he5_gddefboxreg(gdid,
     1           cornerlon,cornerlat)
            write(*,*) 'Region ID returned by he5_gddefboxreg():  ',
     1           rgid

c           Get region information
c           ----------------------            
            status = he5_gdreginfo(gdid,rgid,"Temperature",
     1           nt,rk, dims, size, upleft, lowright)
            write(*,*) dims(1), dims(2), rk, nt

c           Extract region
c           --------------
            status = he5_gdextreg(gdid,rgid,"Temperature",
     1           datbuf)
            write(*,*) 'Status returned by he5_gdextreg():  ',status
         endif
         
c        Detach from the grid
c        --------------------
         status = he5_gddetach(gdid)
         write(*,*) 'Status returned by he5_gddetach():  ',status

c        Close the file
c        --------------
         status = he5_gdclose(gdfid)
         write(*,*) 'Status returned by he5_gdclose():  ',status        

      endif
      stop
      end
	

      program       he5_gd_infoF_64

      implicit      none

      include       'hdfeos5.inc'

	  integer       status
	  integer       i,n
      integer       he5_gdopen
      integer       he5_gdattach
      integer       he5_gdfldinfo
      integer       he5_gdprojinfo
      integer       he5_gdgridinfo
      integer       he5_gdinqflds
      integer       he5_gdtileinfo
      integer       he5_gddetach
      integer       he5_gdclose
      integer       gdfid
      integer       gdid1
      integer       gdid2
      integer       nflds  
      integer       rk(32)
      integer       nt(32)
      integer       spherecode
      integer       projcode
      integer       zonecode

      integer*8     he5_gddiminfo
      integer*8     he5_gdinqdims
      integer*8     he5_gdnentries
      integer*8     ndim
      integer*8     dims(32)
      integer*8     xdimsize
      integer*8     ydimsize
      integer*8     dimsize 

	  integer*8     strbufsize 
    
      real*8        upleftpt(2)
      real*8        lowrightpt(2)
      real*8        projparm(13)
	  
      character*72  dimname
      character*72  mxdimname
      character*72  fieldlist
	  
      integer       tilecode
      integer       tilerank
      integer*8     tiledims(32)

      integer       FAIL
      parameter     (FAIL=-1)

c     Open HDF-EOS "grid.he5" file
c     -----------------------------	  
      gdfid = he5_gdopen('grid.he5',HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_gdopen():  ',gdfid

      if (gdfid .ne. FAIL) then
		 
c     Attach to the UTM and POLAR grids
c     ---------------------------------
      gdid1 = he5_gdattach(gdfid, 'UTMGrid')
      write(*,*) 'Grid ID returned by he5_gdattach():  ',gdid1

      gdid2 = he5_gdattach(gdfid, 'PolarGrid')
      write(*,*) 'Grid ID returned by he5_gdattach():  ',gdid2

c     Inquire dimensions
c     ------------------		 
      ndim = he5_gdinqdims(gdid1, dimname, dims)
      write(*,*) 'Dimension list (UTMGrid): ',dimname
      do i=1,ndim
         write(*,*) 'dim size: ', dims(i)
      enddo
		 
      ndim = he5_gdinqdims(gdid2, dimname, dims)
      write(*,*) 'Dimension list (PolarGrid): ',dimname
      do i=1,ndim
         write(*,*) 'dim size: ', dims(i)
      enddo

c     Get the sizes of certain dimensions
c        -----------------------------------         
      dimsize = he5_gddiminfo(gdid1, 'Time')
      write(*,*) 'Size of "Time" Array: ', dimsize
		 
      dimsize = he5_gddiminfo(gdid2, 'Bands')
      write(*,*) 'Size of "Bands" Array: ', dimsize
	
c     Get grid parameters
c     -------------------
      status = he5_gdgridinfo(gdid1,xdimsize,ydimsize,
     1upleftpt,lowrightpt)
      write(*,*)'X dim size, Y dim size (UTMGrid): ',
     1xdimsize,ydimsize
	   
      write(*,*) 'Up left pt (UTMGrid): ',
     1upleftpt(1),upleftpt(2)
      write(*,*) 'Low right pt (UTMGrid): ',
     1lowrightpt(1),lowrightpt(2)
	   
      status = he5_gdgridinfo(gdid2,xdimsize,ydimsize,
     1upleftpt,lowrightpt)
      write(*,*) 'X dim size, Y dim size (PolarGrid): ',
     1xdimsize,ydimsize
		 
      write(*,*) 'Up left pt (PolarGrid): ',
     1upleftpt(1),upleftpt(2)
      write(*,*) 'Low right pt (PolarGrid): ',
     1lowrightpt(1),lowrightpt(2)

c     Get projection parameters
c     -------------------------		 
      status = he5_gdprojinfo(gdid1,projcode,zonecode,
     1     spherecode,projparm)
      write(*,*) 'projcode,zonecode (UTMGrid): ',
     1     projcode,zonecode
      write(*,*) 'spherecode (UTMGrid): ', spherecode	
	   
      status = he5_gdprojinfo(gdid2,projcode,zonecode,
     1     spherecode,projparm)
      write(*,*) 'projcode (PolarGrid): ', projcode
      write(*,*) 'spherecode (PolarGrid): ', spherecode
      do i=1,13
         write(*,*) 'Projection Parameter: ',i,projparm(i)
      enddo
         
c     Get information about fields
c     ----------------------------
      nflds = he5_gdinqflds(gdid1, fieldlist, rk, nt)
      if (nflds .ne. 0) then
         write(*,*) 'Data fields (UTMGrid): ', fieldlist
         do i=1,nflds
            write(*,*) 'rank type: ',rk(i),nt(i)
         enddo
      endif
	         
      status = he5_gdtileinfo(gdid1,"Vegetation",tilecode,tilerank,
     1         tiledims)
              write(*,*) 'Vegetation Tile Code: ', tilecode
              write(*,*) 'Vegetation Tile Rank: ', tilerank
              do i=1,tilerank
                         write(*,*) 'Tile Dimension ',i,tiledims(i)
              enddo

      nflds = he5_gdinqflds(gdid2, fieldlist, rk, nt)
      if (nflds .ne. 0) then
         write(*,*) 'Data fields (PolarGrid): ',fieldlist
         do i=1,nflds
            write(*,*) 'rank type: ',rk(i),nt(i)
         enddo
      endif	
      
      status = he5_gdfldinfo(gdid2,'Spectra',rk,dims,nt,
     1     dimname,mxdimname)
      write(*,*) 'Spectra rank dims: ',rk(1)
      write(*,*) 'Spectra dim names: ',dimname
      write(*,*) 'Spectra max. dim names: ',mxdimname
      do i=1,rk(1)
         write(*,*) 'Spectra dims: ',i,dims(i)
      enddo
         
c     Get number of grid dimensions and dim. list length
c     --------------------------------------------------
      n = he5_gdnentries(gdid1, HE5_HDFE_NENTDIM, strbufsize)
      write(*,*) 'Number of dimension entries (UTMGrid): ', n
      write(*,*) 'Length of Dimension List (UTMGrid): ', 
     1     strbufsize
	   
c     Get number of data fields and field list length
c     -----------------------------------------------
      n = he5_gdnentries(gdid1, HE5_HDFE_NENTDFLD, 
     1     strbufsize)
      write(*,*) 'Number of data fields (UTMGrid): ', n
      write(*,*) 'Length of Field List (UTMGrid): ', 
     1     strbufsize
        
      endif
	  
c     Detach from the grids
c     ---------------------
      status = he5_gddetach(gdid1)
      write(*,*) 'Status returned by he5_gddetach():  ',status

      status = he5_gddetach(gdid2)
      write(*,*) 'Status returned by he5_gddetach():  ',status     

c     Close the file
c     --------------
      status = he5_gdclose(gdfid)
      write(*,*) 'Status returned by he5_gdclose():  ',status  

      stop
      end

      program     he5_gd_writedataF_64
 
      implicit    none

      include     'hdfeos5.inc'

	  integer     i, j, status
      integer     he5_gdopen
      integer     he5_gdattach
      integer     he5_gdwrfld
	  integer     he5_gdwrattr
      integer     he5_gdwrgattr
      integer     he5_ehwrglatt
      integer     he5_gdwrlattr
      integer     he5_gddetach
      integer     he5_gdclose
	  integer     gdfid, gdid

	  integer*8   start(2),stride(2),count(2)

	  real*4      f,veg(120,200),temp(100,100)
      character*10    attr4
      character*100   attr5

      integer     FAIL
      parameter   (FAIL=-1)


c     Create data buffers 
c     -------------------      
	  do i=1,200
		 do j=1,120
			veg(j,i) = 10 + i
		 enddo
	  enddo
	  
	  do i=1,100
		 do j=1,100
			temp(j,i) = 100*(i-1) + j
		 enddo
	  enddo

c     Open HDF-EOS file "grid.he5" 
c     ---------------------------      
	  gdfid = he5_gdopen("grid.he5",HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_gdopen():  ',gdfid

	  if (gdfid .ne. FAIL) then

c        Attach to the UTM grid
c        ----------------------         
		 gdid = he5_gdattach(gdfid, "UTMGrid")
         write(*,*) 'Grid ID returned by he5_gdattach():  ',gdid

		 if (gdid .ne. FAIL) then
			start(1)  = 0
			start(2)  = 0
			stride(1) = 1
			stride(2) = 1
			count(1)  = 120
			count(2)  = 200

c           Write data to the field "Vegetation"
c           ------------------------------------
			status = he5_gdwrfld(gdid,"Vegetation",
     1           start,stride,count,veg)
            write(*,*) 'Status returned by he5_gdwrfld():  ',status
      
			f        = 1
			count(1) = 1

c           Write global attribute "float"
c           ------------------------------
			status = he5_gdwrattr(gdid,"float",
     1      HE5T_NATIVE_FLOAT,count,f)
            write(*,*) 'Status returned by he5_gdwrattr():  ',status

		attr4 = "ABCDEFGH"
		count(1) = 8
		status = he5_gdwrattr(gdid,"GLOBAL_CHAR_ATTR",HE5T_NATIVE_CHAR,
	1	count,attr4)
	write(*,*) 'Status returned by he5_gdwrattr():  ',status

		attr4 = "111"
		count(1) = 3
		status = he5_gdwrgattr(gdid,"GLOBAL_CHAR_ATTR_1",HE5T_NATIVE_CHAR,
	1	count,attr4)
	write(*,*) 'Status returned by he5_gdwrgattr():  ',status

		attr4 = "222222"
		count(1) = 6
		status = he5_ehwrglatt(gdfid,"GLOBAL_CHAR_ATTR_2",HE5T_NATIVE_CHAR,
	1	count,attr4)
	write(*,*) 'Status returned by he5_ehwrglatt():  ',status

		attr5 = "abcdefgh111111111111"
		count(1) = 20
		status = he5_gdwrlattr(gdid,"Vegetation","LocalAttribute_0",
	1	HE5T_NATIVE_CHAR,count,attr5)
	write(*,*) 'Status returned by he5_gdwrlattr():  ',status

		 endif
	  endif

c     Detach from the grid
c     --------------------	  
	  status = he5_gddetach(gdid)
      write(*,*) 'Status returned by he5_gddetach():  ',status

c     Attach to the POLAR grid 
c     ------------------------	  
	  gdid = he5_gdattach(gdfid, "PolarGrid")
      write(*,*) 'Grid ID returned by he5_gdattach():  ',gdid

	  if (gdid .ne. FAIL) then
		 start(1)  = 0
		 start(2)  = 0
		 stride(1) = 1
		 stride(2) = 1
		 count(1)  = 100
		 count(2)  = 100

c        Write data to the "Temperature" field
c        -------------------------------------         
		 status = he5_gdwrfld(gdid,"Temperature",
     1        start,stride,count,temp)
         write(*,*) 'Status returned by he5_gdwrfld():  ',status

	  endif

c     Detach from the grid
c     --------------------
	  status = he5_gddetach(gdid)
      write(*,*) 'Status returned by he5_gddetach():  ',status

c     Close the file 
c     --------------	  
	  status = he5_gdclose(gdfid)
      write(*,*) 'Status returned by he5_gdclose():  ',status

	  stop
	  end

      program       he5_pt_writedataF_32

      implicit      none

      include       'hdfeos5.inc'

      integer       status
      integer       ptfid 
      integer       ptid
      integer       he5_ptopen
      integer       he5_ptattach
      integer       he5_ptwritelevel 
      integer       he5_ptfort2c
      integer       he5_ptwrbckptr
      integer       he5_ptwrfwdptr
      integer       he5_ptwriteattr 
      integer       he5_ptdetach 
      integer       he5_ptclose
      integer       i
      integer       rank, datatype
      integer       attr

      integer*4     n
      integer*4     count(1)
      integer*4     dimens(2)
      integer*4     fortcount(8),ntype

      real*4        flt      

      character*80  fieldname,attrname

c.....used by Simple Point
      real*8        time_tt
      real*8        time(15)
      real*4        concentration_tt(4)
      real*4        conc(15,4)
      real*4        outconc(4,15)
      character*8   spc_tt
      character*8   spc(15)

c.....used by FixedBuoy Point - Level 0
      character*8   desc_tt
      character*8   desc(3)
      real*8        lon_tt
      real*8        lon(3)
      real*8        lat_tt
      real*8        lat(3)
      integer*4     date_tt
      integer*4     date(3)
      character*8   id_tt
      character*8   id(3)

c.....used by FixedBuoy Point - Level 1
      real*8        time3_tt
      real*8        time3(20)
      real*4        rain_tt
      real*4        rain(20)
      real*4        temp_tt
      real*4        temp(20)
      character*8   id3_tt
      character*8   id3(20)

c.....used by FloatBuoy Point - Level 0
      character*8   desc4_tt
      character*8   desc4(3)
      integer*4     date4_tt
      integer*4     date4(3)
      integer*4     wgt_tt
      integer*4     wgt(3)
      character*8   id4_tt
      character*8   id4(3)

c.....used by FloatBuoy Point - Level 1
      real*8        time5_tt
      real*8        time5(25)
      real*8        lon5_tt
      real*8        lon5(25)
      real*8        lat5_tt
      real*8        lat5(25)
      real*4        rain5_tt
      real*4        rain5(25)
      real*4        temp5_tt
      real*4        temp5(25)
      character*8   id5_tt
      character*8   id5(25)


c     Open the HDF point file, "point.he5"
c     -----------------------------------
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_ptopen():  ',ptfid

c     Do Simple Point 
c     --------------- 
      ptid = HE5_PTattach(ptfid, "Simple Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid


c     Read Simple Point 
c     ----------------- 
      open(unit=1, file='simple.txt', status='OLD')

      n = 0
      do 10 i=1,1000
         read(1, 110, end=100) time_tt, concentration_tt(1), 
     1                                  concentration_tt(2), 
     2                                  concentration_tt(3),
     3                                  concentration_tt(4), 
     4                                  spc_tt
         time(i)     = time_tt
         conc(i,1)   = concentration_tt(1)
         conc(i,2)   = concentration_tt(2)
         conc(i,3)   = concentration_tt(3)
         conc(i,4)   = concentration_tt(4)
         spc(i)      = spc_tt

         n = n + 1
   10 continue

  100 close(unit=1)
  110 format(F13.1,F6.2,F6.2,F6.2,F6.2,2X,A8)

      count(1) = n

      fieldname      = 'Time'
      datatype       = HE5T_NATIVE_DOUBLE

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, time)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status
   
c.....Convert array to 'C' order
      dimens(1) = 15
      dimens(2) = 4
      rank      = 2
      datatype  = HE5T_NATIVE_FLOAT

      status    = he5_ptfort2c(dimens, rank, datatype, conc, 
     1outconc)
      write(*,*) 'Status returned by he5_ptfort2c():  ',status

      fieldname      = 'Concentration'

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, outconc)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status


      fieldname      = 'Species'
      datatype       = HE5T_NATIVE_CHAR

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, spc)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

c.....Close out the point interface
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status

c     Do FixedBuoy Point 
c     ------------------ 
      ptid = HE5_PTattach(ptfid, "FixedBuoy Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid

c     Read FixedBuoy Point 
c     -------------------- 
      open(unit=1, file='fixedBuoy0.txt', status='OLD')

      n = 0
      do 20 i=1,1000
         read(1, 210, end=200) desc_tt, lon_tt, lat_tt, date_tt, 
     1id_tt
         desc(i)     = desc_tt
         lon(i)      = lon_tt
         lat(i)      = lat_tt
         date(i)     = date_tt
         id(i)       = id_tt

         n = n + 1
   20 continue

  200 close(unit=1)
  210 format(A8,F13.7,F13.7,I7,1X,A8)

      count(1) = n

      fieldname      = 'Label'
      datatype       = HE5T_NATIVE_CHAR

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, desc)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'Longitude'
      datatype       = HE5T_NATIVE_DOUBLE

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, lon)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'Latitude'
      datatype       = HE5T_NATIVE_DOUBLE

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, lat)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'DeployDate'
      datatype       = HE5T_NATIVE_INT

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, date)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'ID'
      datatype       = HE5T_NATIVE_CHAR

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, id)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

c     Read FixedBuoy Point - Level 1
c     ------------------------------ 
      open(unit=1, file='fixedBuoy1.txt', status='OLD')

      n = 0
      do 30 i=1,1000
         read(1, 310, end=300) time3_tt, rain_tt, temp_tt, id3_tt 
         time3(i)     = time3_tt
         rain(i)      = rain_tt
         temp(i)      = temp_tt
         id3(i)       = id3_tt

         n = n + 1
   30 continue

  300 close(unit=1)
  310 format(F13.2,F8.1,F8.2,3X,A8)

      count(1) = n

      fieldname      = 'Time'
      datatype       = HE5T_NATIVE_DOUBLE

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, time3)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'Rainfall'
      datatype       = HE5T_NATIVE_FLOAT

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, rain)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'Temperature'
      datatype       = HE5T_NATIVE_FLOAT

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, temp)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'ID'
      datatype       = HE5T_NATIVE_CHAR

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, id3)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

c.....Write forward and backward pointers
      status = he5_ptwrbckptr(ptid,1)
      write(*,*) 'Status returned by he5_ptwrbckptr():  ',status

      status = he5_ptwrfwdptr(ptid,1)
      write(*,*) 'Status returned by he5_ptwrfwdptr():  ',status

c     Write attributes to "Fixed Buoy Point"
c     --------------------------------------
      attrname       = 'GlobalAttribute_int'
      ntype          = HE5T_NATIVE_INT
      fortcount(1)   = 1
      attr           = 9999 

      status   = he5_ptwriteattr(ptid,attrname,ntype,fortcount,
     1attr)
      write(*,*) 'Status returned by he5_ptwriteattr():  ',status

c.....Close out the point interface
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status


c     Do FloatBuoy Point 
c     ------------------ 
      ptid = HE5_PTattach(ptfid, "FloatBuoy Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid

c     Read FloatBuoy Point - Level 0
c     ------------------------------ 
      open(unit=1, file='floatBuoy0.txt', status='OLD')

      n = 0
      do 40 i=1,1000
         read(1, 410, end=400) desc4_tt, date4_tt, wgt_tt, id4_tt 
         desc4(i)     = desc4_tt
         date4(i)     = date4_tt
         wgt(i)       = wgt_tt
         id4(i)       = id4_tt

         n = n + 1
   40 continue

  400 close(unit=1)
  410 format(A8,I8,I7,2X,A8)

      count(1) = n

      fieldname      = 'Label'
      datatype       = HE5T_NATIVE_CHAR

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, desc4)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'DeployDate'
      datatype       = HE5T_NATIVE_INT

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, date4)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'Weight'
      datatype       = HE5T_NATIVE_INT

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, wgt)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'ID'
      datatype       = HE5T_NATIVE_CHAR

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1datatype, id4)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

c     Read FixedBuoy Point - Level 1
c     ------------------------------ 
      open(unit=1, file='floatBuoy1.txt', status='OLD')

      n = 0
      do 50 i=1,1000
         read(1, 510, end=500) time5_tt, lon5_tt, lat5_tt,  
     1rain5_tt,temp5_tt,id5_tt
         time5(i)     = time5_tt
         lon5(i)      = lon5_tt
         lat5(i)      = lat5_tt
         rain5(i)     = rain5_tt
         temp5(i)     = temp5_tt
         id5(i)       = id5_tt

         n = n + 1
   50 continue

  500 close(unit=1)
  510 format(F13.1,F13.6,F13.6,F8.1,F8.2,3X,A8)

      count(1) = n

      fieldname      = 'Time'
      datatype       = HE5T_NATIVE_DOUBLE

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, time5)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'Longitude'
      datatype       = HE5T_NATIVE_DOUBLE

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, lon5)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'Latitude'
      datatype       = HE5T_NATIVE_DOUBLE

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, lat5)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'Rainfall'
      datatype       = HE5T_NATIVE_FLOAT

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, rain5)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'Temperature'
      datatype       = HE5T_NATIVE_FLOAT

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, temp5)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'ID'
      datatype       = HE5T_NATIVE_CHAR

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1datatype, id5)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

c.....Write forward and backward pointers
      status = he5_ptwrbckptr(ptid,1)
      write(*,*) 'Status returned by he5_ptwrbckptr():  ',status

      status = he5_ptwrfwdptr(ptid,1)
      write(*,*) 'Status returned by he5_ptwrfwdptr():  ',status

c     Write attributes to "Float Buoy Point"
c     --------------------------------------
      attrname       = 'GlobalAttribute_float'
      ntype          = HE5T_NATIVE_FLOAT
      fortcount(1)   = 1
      flt            = -7.5

      status   = he5_ptwriteattr(ptid,attrname,
     1ntype,fortcount,flt)
      write(*,*) 'Status returned by he5_ptwriteattr():  ',status

c.....Close out the point interface
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status

      status = he5_ptclose(ptfid)
      write(*,*) 'Status returned by he5_ptclose():  ',status


      stop
      end

c     In this program we (1) open the "swath.he5" HDF-EOS file
c     (2) attach to the "Swath1" swath, and (3) subset data from 
c     the "Spectra" field
c     ==========================================================

      program     he5_sw_subsetF_64

      implicit    none

      include     'hdfeos5.inc'

	  integer     status
	  integer     i
	  integer     he5_swopen
      integer     he5_swattach
	  integer     he5_swextper
	  integer     he5_swperinfo
      integer     he5_swreginfo
	  integer     he5_swdefboxreg
      integer     he5_swdeftmeper
      integer     he5_swextreg
      integer     he5_swdetach
      integer     he5_swclose
	  integer     swfid
      integer     swid
	  integer     rank
	  integer     ntype
	  integer     regionid
	  integer     periodid

	  integer*8   dims(8)
	  integer*8   size

	  real*8      cornerlon(2)
	  real*8      cornerlat(2)
	  real*8      datbuf(40,20,15)
	  real*8      tmebuf(20)
	  real*8      t1
	  real*8      t2

	  integer     FAIL
      parameter   (FAIL=-1)

c     Open HDF-EOS swath file, "swath.he5"
c     ------------------------------------
	  swfid = he5_swopen("swath.he5",HE5F_ACC_RDONLY)
      write(*,*) 'File ID returned by he5_swopen():  ',swfid

      if (swfid .NE. FAIL) then
		 swid = he5_swattach(swfid, "Swath1")
         write(*,*) 'Swath ID returned by he5_swattach():  ',swid

		 if (swid .NE. FAIL) then
			cornerlon(1) = 3.
			cornerlat(1) = 5.
			cornerlon(2) = 7.
			cornerlat(2) = 12.
            
c     Define box region 
c     -----------------
			regionid = he5_swdefboxreg(swid,cornerlon,
     1           cornerlat,HE5_HDFE_MIDPOINT)
            write(*,*) 'Region ID returned by he5_swdefboxreg():  ',
     1           regionid

			write(*,*) regionid,swid
            
			status = he5_swreginfo(swid,regionid,"Spectra",ntype,
     1           rank,dims,size)
            write(*,*) 'Status returned by he5_swreginfo():  ',
     1           status
			write(*,*) dims(1), dims(2), dims(3), rank, ntype, size
	      
c     Extract region data
c     -------------------
			status = he5_swextreg(swid,regionid,"Spectra",
     1           HE5_HDFE_INTERNAL,datbuf)
            write(*,*) 'Status returned by he5_swextreg():  ',
     1           status
            
c     Time Subsetting
c     ---------------
			t1  = 352324870.2d0
			t2  = 366098980.1d0
			periodid = he5_swdeftmeper(swid,t1,t2,HE5_HDFE_MIDPOINT)
            write(*,*) 'Period ID returned by he5_swdeftmeper():  ',
     1           periodid

			write(*,*) 'Time Subset: ', periodid,swid
            
			status = he5_swperinfo(swid,periodid,"Time",ntype,rank,
     1           dims,size)
	        write(*,*) 'Status returned by he5_swperinfo():  ',
     1           status 
            write(*,*) 'Time Subset: ', rank, dims(1), size
            
c     Extract Time data
c     -----------------
			status = he5_swextper(swid,periodid,"Time",
     1           HE5_HDFE_INTERNAL,tmebuf)
             write(*,*) 'Status returned by he5_swextper():  ',
     1           status            

			do 10 i=1,size/8
			   write(*,*) i, tmebuf(i)
 10         continue
            
		 endif

c     Detach from swath
c     -----------------		 
		 status = he5_swdetach(swid)
         write(*,*) 'Status returned by he5_swdetach():  ',status         

c     Close the file
c     --------------
		 status = he5_swclose(swfid)
         write(*,*) 'Status returned by he5_swclose():  ',status             

      endif
      
      stop
      end
	

C **********************************************************************SPLD   1
C ** PROGRAM SPLOAD - LOADS NAD 1927 AND NAD 1983 DIRECT ACCESS FILES **SPLD   2
C ** U. S. GEOLOGICAL SURVEY - CHIPPEAUX AND LINCK           09/19/89 **SPLD   3
C **********************************************************************SPLD   4
      PROGRAM SPLOAD                                                    SPLD   5
C                                                                       SPLD   6
C     PROGRAM TO COPY NAD 1927 AND NAD 1983 SEQUENTIAL FILES TO DIRECT  SPLD   7
C     ACCESS FILES FOR USE BY GCTP                                      SPLD   8
C                                                                       SPLD   9
      REAL*8 PARM(9)                                                    SPLD  10
      INTEGER*4 I, ID, IZONE, LENGTH                                    SPLD  11
      CHARACTER*32 ZNAME, GETF27, GETF83, PUTF27, PUTF83                SPLD  12
      CHARACTER*3 STAT27, STAT83                                        SPLD  13
C                                                                       SPLD  14
C     IPR    = LOGICAL UNIT NUMBER OF PRINTER                           SPLD  15
C     GETF27 = NAME OF NAD 1927 INPUT FILE                              SPLD  16
C     PUTF27 = NAME OF NAD 1927 OUTPUT FILE                             SPLD  17
C     GETF83 = NAME OF NAD 1983 INPUT FILE                              SPLD  18
C     PUTF83 = NAME OF NAD 1983 OUTPUT FILE                             SPLD  19
C     STAT27 = STATUS OF NAD 1927 OUTPUT FILE                           SPLD  20
C     STAT83 = STATUS OF NAD 1983 OUTPUT FILE                           SPLD  21
C     LENGTH = LENGTH IN BYTES OR WORDS OF OUTPUT RECORDS               SPLD  22
C                                                                       SPLD  23
      PARAMETER (IPR = 6)                                               SPLD  24
      PARAMETER (GETF27 = 'nad1927', GETF83 = 'nad1983')                SPLD  25
      PARAMETER (PUTF27 = 'nad27sp', PUTF83 = 'nad83sp')                SPLD  26
      PARAMETER (STAT27 = 'NEW', STAT83 = 'NEW')                        SPLD  27
      PARAMETER (LENGTH = 108)                                          SPLD  28
C                                                                       SPLD  29
      OPEN(UNIT=2,FILE=GETF27,STATUS='OLD',                             SPLD  30
     .     ACCESS='SEQUENTIAL')                                         SPLD  31
      OPEN(UNIT=3,FILE=PUTF27,STATUS=STAT27,RECL=LENGTH,                SPLD  32
     .     ACCESS='DIRECT')                                             SPLD  33
C                                                                       SPLD  34
      OPEN(UNIT=12,FILE=GETF83,STATUS='OLD',                            SPLD  35
     .     ACCESS='SEQUENTIAL')                                         SPLD  36
      OPEN(UNIT=13,FILE=PUTF83,STATUS=STAT83,RECL=LENGTH,               SPLD  37
     .     ACCESS='DIRECT')                                             SPLD  38
C                                                                       SPLD  39
    1 FORMAT(A32,7X,I1,31X,I4)                                          SPLD  40
    2 FORMAT(3D25.16)                                                   SPLD  41
    3 FORMAT(1X,I3,5X,A32,5X,I4,5X,I1)                                  SPLD  42
C                                                                       SPLD  43
      I = 0                                                             SPLD  44
   10 READ(2,1,END=20) ZNAME, ID, IZONE                                 SPLD  45
      I = I + 1                                                         SPLD  46
      READ(2,2) PARM(1), PARM(2), PARM(3)                               SPLD  47
      READ(2,2) PARM(4), PARM(5), PARM(6)                               SPLD  48
      READ(2,2) PARM(7), PARM(8), PARM(9)                               SPLD  49
      WRITE(3,REC=I) ZNAME, ID, PARM                                    SPLD  50
      WRITE(IPR,3) I, ZNAME, IZONE, ID                                  SPLD  51
      GO TO 10                                                          SPLD  52
C                                                                       SPLD  53
   20 I = 0                                                             SPLD  54
   30 READ(12,1,END=40) ZNAME, ID, IZONE                                SPLD  55
      I = I + 1                                                         SPLD  56
      READ(12,2) PARM(1), PARM(2), PARM(3)                              SPLD  57
      READ(12,2) PARM(4), PARM(5), PARM(6)                              SPLD  58
      READ(12,2) PARM(7), PARM(8), PARM(9)                              SPLD  59
      WRITE(13,REC=I)  ZNAME, ID, PARM                                  SPLD  60
      WRITE(IPR,3) I, ZNAME, IZONE, ID                                  SPLD  61
      GO TO 30                                                          SPLD  62
C                                                                       SPLD  63
   40 CLOSE(2)                                                          SPLD  64
      CLOSE(3)                                                          SPLD  65
      CLOSE(12)                                                         SPLD  66
      CLOSE(13)                                                         SPLD  67
C                                                                       SPLD  68
      STOP                                                              SPLD  69
      END                                                               SPLD  70

      program       he5_pt_definelevelsF_64

      implicit      none

      include       'hdfeos5.inc'

      integer       status
      integer       ptfid 
      integer       ptid
      integer       he5_ptopen
      integer       he5_ptattach
      integer       he5_ptdeflevel 
      integer       he5_ptdeflinkage 
      integer       he5_ptdetach 
      integer       he5_ptclose
      integer       rank_1(3)
      integer       rank_2(5)
      integer       rank_3(4)
      integer       rank_4(4)
      integer       rank_5(6)
      integer       dtype_1(3)
      integer       dtype_2(5)
      integer       dtype_3(4)
      integer       dtype_4(4)
      integer       dtype_5(6)
      integer       array_1(3)
      integer       array_2(5)
      integer       array_3(4)
      integer       array_4(4)
      integer       array_5(6)

      integer*8     dims_1(3,1)
      integer*8     dims_2(5,1)
      integer*8     dims_3(4,1)
      integer*8     dims_4(4,1)
      integer*8     dims_5(6,1)

      character*240 fieldlist1
      character*240 fieldlist2
      character*240 fieldlist3
      character*240 fieldlist4
      character*240 fieldlist5
      character*80  levelname
      character*20  parent
      character*20  child
      character*20  linkfield

c     Open the HDF-EOS point file, "point.he5"
c     ----------------------------------------
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_ptopen():  ',ptfid

c     Read Simple Point 
c     ----------------- 
      ptid = HE5_PTattach(ptfid, "Simple Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid

c     Populate input information structure 
c     ------------------------------------ 
      levelname = 'Sensor'

      rank_1(1)  = 1
      rank_1(2)  = 1
      rank_1(3)  = 1

      fieldlist1 = 'Time,Concentration,Species'

      dtype_1(1)     =  HE5T_NATIVE_DOUBLE
      dtype_1(2)     =  HE5T_NATIVE_FLOAT
      dtype_1(3)     =  HE5T_NATIVE_CHAR

      array_1(1)     =  0
      array_1(2)     =  1
      array_1(3)     =  1

      dims_1(1,1)      =  1
      dims_1(2,1)      =  4
      dims_1(3,1)      =  8

      status = he5_ptdeflevel(ptid, levelname, rank_1, fieldlist1,
     1dims_1, dtype_1, array_1)
      write(*,*) 'Status returned by he5_ptdeflevel():  ',status

c.....Close out the point interface
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status

c     Read Fixed Buoy Point 
c     --------------------- 
      ptid = HE5_PTattach(ptfid, "FixedBuoy Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid


c     Populate input information structure 
c     ------------------------------------ 

      levelname = 'Desc-Loc'

      rank_2(1)  = 1
      rank_2(2)  = 1
      rank_2(3)  = 1
      rank_2(4)  = 1
      rank_2(5)  = 1

      fieldlist2 = 'Label,Longitude,Latitude,DeployDate,ID'

      dtype_2(1)     =  HE5T_NATIVE_CHAR
      dtype_2(2)     =  HE5T_NATIVE_DOUBLE
      dtype_2(3)     =  HE5T_NATIVE_DOUBLE
      dtype_2(4)     =  HE5T_NATIVE_INT
      dtype_2(5)     =  HE5T_NATIVE_CHAR

      array_2(1)  = 1
      array_2(2)  = 0
      array_2(3)  = 0
      array_2(4)  = 0
      array_2(5)  = 1

      dims_2(1,1)      =  8
      dims_2(2,1)      =  1
      dims_2(3,1)      =  1
      dims_2(4,1)      =  1
      dims_2(5,1)      =  8

      status = he5_ptdeflevel(ptid, levelname, rank_2, fieldlist2,
     1dims_2, dtype_2, array_2)
      write(*,*) 'Status returned by he5_ptdeflevel():  ',status


c     Populate input information structure 
c     ------------------------------------ 

      levelname = 'Observations'

      rank_3(1)  = 1
      rank_3(2)  = 1
      rank_3(3)  = 1
      rank_3(4)  = 1

      fieldlist3 = 'Time,Rainfall,Temperature,ID'

      dtype_3(1)     =  HE5T_NATIVE_DOUBLE
      dtype_3(2)     =  HE5T_NATIVE_FLOAT
      dtype_3(3)     =  HE5T_NATIVE_FLOAT
      dtype_3(4)     =  HE5T_NATIVE_CHAR

      array_3(1)  = 0
      array_3(2)  = 0
      array_3(3)  = 0
      array_3(4)  = 1

      dims_3(1,1)      =  1
      dims_3(2,1)      =  1
      dims_3(3,1)      =  1
      dims_3(4,1)      =  8

      status = he5_ptdeflevel(ptid, levelname, rank_3, fieldlist3,
     1dims_3, dtype_3, array_3)
      write(*,*) 'Status ID returned by he5_ptdeflevel():  ',status

      parent    = 'Desc-Loc'
      child     = 'Observations'
      linkfield = 'ID'

      status = he5_ptdeflinkage(ptid, parent, child, linkfield)
      write(*,*) 'Status ID returned by he5_ptdeflinkage():  ',status

c.....Close out the point interface
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status


c     Read Floating Buoy Point 
c     --------------------- 
      ptid = HE5_PTattach(ptfid, "FloatBuoy Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid


c     Populate input information structure 
c     ------------------------------------ 

      levelname = 'Description'

      rank_4(1)  = 1
      rank_4(2)  = 1
      rank_4(3)  = 1
      rank_4(4)  = 1

      fieldlist4 = 'Label,DeployDate,Weight,ID'

      dtype_4(1)     =  HE5T_NATIVE_CHAR
      dtype_4(2)     =  HE5T_NATIVE_INT
      dtype_4(3)     =  HE5T_NATIVE_INT
      dtype_4(4)     =  HE5T_NATIVE_CHAR

      array_4(1)  = 1
      array_4(2)  = 0
      array_4(3)  = 0
      array_4(4)  = 1

      dims_4(1,1)      =  8
      dims_4(2,1)      =  1
      dims_4(3,1)      =  1
      dims_4(4,1)      =  8

      status = he5_ptdeflevel(ptid, levelname, rank_4, fieldlist4,
     1dims_4, dtype_4, array_4)
      write(*,*) 'Status returned by he5_ptdeflevel():  ',status

c     Populate input information structure 
c     ------------------------------------ 

      levelname = 'Measurements'

      rank_5(1)  = 1
      rank_5(2)  = 1
      rank_5(3)  = 1
      rank_5(4)  = 1
      rank_5(5)  = 1
      rank_5(6)  = 1

      fieldlist5 = 'Time,Longitude,Latitude,Rainfall,Temperature,ID'

      dtype_5(1)     =  HE5T_NATIVE_DOUBLE
      dtype_5(2)     =  HE5T_NATIVE_DOUBLE
      dtype_5(3)     =  HE5T_NATIVE_DOUBLE
      dtype_5(4)     =  HE5T_NATIVE_FLOAT
      dtype_5(5)     =  HE5T_NATIVE_FLOAT
      dtype_5(6)     =  HE5T_NATIVE_CHAR

      array_5(1)  = 0
      array_5(2)  = 0
      array_5(3)  = 0
      array_5(4)  = 0
      array_5(5)  = 0
      array_5(6)  = 1

      dims_5(1,1)      =  1
      dims_5(2,1)      =  1
      dims_5(3,1)      =  1
      dims_5(4,1)      =  1
      dims_5(5,1)      =  1
      dims_5(6,1)      =  8

      status = he5_ptdeflevel(ptid, levelname, rank_5, fieldlist5,
     1dims_5, dtype_5, array_5)
      write(*,*) 'Status returned by he5_ptdeflevel():  ',status

      parent    = 'Description'
      child     = 'Measurements'
      linkfield = 'ID'

      status = he5_ptdeflinkage(ptid, parent, child, linkfield)
      write(*,*) 'Status ID returned by he5_ptdeflinkage():  ',status

c.....Close out the point interface
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status

      status = he5_ptclose(ptfid)
      write(*,*) 'Status returned by he5_ptclose():  ',status

      stop
      end

!     In this program we (1) open an HDF-EOS file, (2) create the 
!     za interface, and (3) define the za field dimensions
!     ===========================================================
      
      program    he5_za_setupF_32

      implicit   none

      include    'hdfeos5.inc'

      integer    status
      integer    he5_zaopen
      integer    he5_zacreate
      integer    he5_zadefdim
      integer    he5_zadetach
      integer    he5_zaclose
      integer    zafid, zaid

      integer*4  dtrack, extdata


!     Open the HDF-EOS file, "za.he5" using "TRUNC" file access code 
!     --------------------------------------------------------------
      zafid = he5_zaopen('za.he5',HE5F_ACC_TRUNC)
      write(*,*) 'File ID returned by he5_zaopen():  ',zafid

!     Create the za, "ZA1", within the file 
!     -------------------------------------
      zaid = he5_zacreate(zafid, "ZA1")
      write(*,*) 'ZA ID returned by he5_zacreate():  ',zaid
    
!     Define Data dimensions
!     ----------------------
      dtrack = 20
      status = he5_zadefdim(zaid, "MyTrack1", dtrack)
      write(*,*) 'Status returned by he5_zadefdim():  ',status

      dtrack = 10
      status = he5_zadefdim(zaid, "MyTrack2", dtrack)
      write(*,*) 'Status returned by he5_zadefdim():  ',status

      dtrack = 40
      status = he5_zadefdim(zaid, "Res2tr", dtrack)
      write(*,*) 'Status returned by he5_zadefdim():  ',status

      dtrack = 20
      status = he5_zadefdim(zaid, "Res2xtr", dtrack)
      write(*,*) 'Status returned by he5_zadefdim():  ',status

      dtrack = 15
      status = he5_zadefdim(zaid, "Bands", dtrack)
      write(*,*) 'Status returned by he5_zadefdim():  ',status

      dtrack = 12
      status = he5_zadefdim(zaid, "IndxTrack", dtrack)
      write(*,*) 'Status returned by he5_zadefdim():  ',status

!     Define "External" dimension
!     ---------------------------
      extdata = 60
      status = he5_zadefdim(zaid, "ExtDim", extdata)
      write(*,*) 'Status returned by he5_zadefdim():  ',status

!     Define Unlimited (appendable) dimension
!     ---------------------------------------
      status = he5_zadefdim(zaid, "Unlim", HE5S_UNLIMITED_F)
      write(*,*) 'Status returned by he5_zadefdim():  ',status

!     Detach from the za
!     ------------------
      status = he5_zadetach(zaid)
      write(*,*) 'Status returned by he5_zadetach():  ',status

!     Close the za file
!     -----------------
      status = he5_zaclose(zafid)
      write(*,*) 'Status returned by he5_zaclose():  ',status

      stop
      end

!	In this program we retrieve (1) information about the
!	dimensions, (2) the za fields 

          program         he5_za_infoF_64

          implicit        none

          include         'hdfeos5.inc'

	  integer         i
          integer         status
	  integer         zafid, zaid
	  integer         he5_zaopen
	  integer         he5_zaattach
	  integer         he5_zainfo
          integer         he5_zachunkinfo
	  integer         he5_zadetach	  
	  integer         he5_zaclose
	  integer         rank(32)
	  integer         ntype(32)
	  integer         rk
          integer         nt

	  integer*8       he5_zainqdims
          integer*8       he5_zainquire
	  integer*8       he5_zadiminfo
	  integer*8       ndims
	  integer*8       nflds
	  integer*8       dims(32)
	  integer*8       dimsize

	  character*72    dimname
          character*72    dimlist
          character*72    maxdimlst
          character*72    fieldlist

          integer         chunkrank
          integer*8       chunkdims(32)
	  
	  integer         FAIL
	  parameter       (FAIL=-1)

!     Open the "za.he5" file for "read only" access
!     ---------------------------------------------
	  zafid = he5_zaopen("za.he5",HE5F_ACC_RDONLY)
      write(*,*) 'File ID returned by he5_zaopen():  ',zafid

	  if (zafid .NE. FAIL) then
	   
!     Attach the za
!     -------------
		 zaid = he5_zaattach(zafid, "ZA1")
         write(*,*) 'ZA ID returned by he5_zaattach():  ',zaid

		 if (zaid .NE. FAIL) then
		
!     Inquire Dimensions
!     ------------------			
			ndims = he5_zainqdims(zaid, dimname, dims)
			write(*,*) 'Dimension list: ', dimname
			do i = 1,ndims
			   write(*,*) 'dim size: ', dims(i)
			enddo
			write(*,*)	      
            
!     Inquire Data Fields	      
!     -------------------			
			nflds = he5_zainquire(zaid, fieldlist, rank, ntype)
			write(*,*) 'Data Fieldlist: ', fieldlist
			do i=1,nflds
			   write(*,*) 'field rank & datatype: ',rank(i),ntype(i)
			enddo
			write(*,*) 
			
!	  Get info on "MyTrack1" dim
!         --------------------------			
	      dimsize = he5_zadiminfo(zaid, "MyTrack1")
	      write(*,*) 'Size of MyTrack1: ', dimsize
	      write(*,*)
	      

!	  Get info on "Spectra" Field
!         ---------------------------		  
	      status = he5_zainfo(zaid,"Spectra",rk,dims,nt,
     1         dimlist,maxdimlst)
	      write(*,*) 'Spectra Rank: ', rk
	      write(*,*) 'Spectra NumberType: ', nt
	      write(*,*) 'Spectra Dimlist: ', dimlist
	      write(*,*) 'Spectra Max Dimlist: ', maxdimlst
	      do i=1,rk
			 write(*,*) 'Dimension ',i,dims(i)
	      enddo

              status = he5_zachunkinfo(zaid,"Spectra",chunkrank,
     1         chunkdims)
              write(*,*) 'Spectra Chunking Rank: ', chunkrank
              do i=1,chunkrank
                         write(*,*) 'Chunking Dimension ',i,chunkdims(i)
              enddo
		  
	   endif
	  endif
	  
!     Detach from the za
!     ------------------
	  status = he5_zadetach(zaid)
      write(*,*) 'Status returned by he5_zadetach():  ',status

!     Close the file
!     --------------
	  status = he5_zaclose(zafid)
      write(*,*) 'Status returned by he5_zaclose():  ',status

	  stop
	  end

c     In this program we (1) open the "swath.he5" file, (2) attach to
c     the "Swath1" swath, and (3) read data from the "Longitude" field
c     ================================================================

      program            he5_sw_readdataF_64

      implicit           none

      include            'hdfeos5.inc'

      integer            status
      integer            he5_swopen
      integer            he5_swattach
      integer            he5_swrdfld
      integer            he5_swrdattr
      integer            he5_prread
      integer            he5_swdetach
      integer            he5_swclose
      integer            swfid, swid
      integer            buffer_out(250)
      integer            i,j,j1
      integer            element1(25)
      integer            element2(50)
      integer            element3(75)
      integer            element4(100)

      real*4             lng(10,20)

      integer*4          attr(4)

      integer*8          start(2)
      integer*8          stride(2)
      integer*8          count(2)
      integer*8          len(4)
      character*4        charfield(10)

      integer            FAIL
      parameter          (FAIL=-1)

    
c     Open HDF-EOS swath file, "swath.he5"
c     ------------------------------------
	  swfid = he5_swopen("swath.he5",HE5F_ACC_RDONLY)
      write(*,*) 'File ID returned by he5_swopen():  ',swfid

	  if (swfid .NE. FAIL) then
		 swid = he5_swattach(swfid, "Swath1")
         write(*,*) 'Swath ID returned by he5_swattach():  ',swid

		 if (swid .NE. FAIL) then
			
	      
c     Read the entire Longitude field
c     -------------------------------
			start(1)  = 0
			start(2)  = 0
			stride(1) = 1
			stride(2) = 1
			count(1)  = 10
			count(2)  = 20
            
			status = he5_swrdfld(swid,"Longitude",
     1           start,stride,count,lng)

			do i=1,20
			   do j=1,10
				  write(*,*)'i j Longitude ',i,j,lng(j,i)
			   enddo
			enddo

                        start(1)  = 0
                        stride(1) = 1
                        count(1)  = 10
                        status = he5_swrdfld(swid,"test_string",
     1           start,stride,count,charfield)

                        do i=1,10
                                  write(*,*)'i = ',i,charfield(i)
                        enddo

c     Read data from the Profile
c     --------------------------
			start(1)  = 0
			stride(1) = 1
			count(1)  = 4
 
      status = he5_prread(swid,"Profile-2000",start,stride,count,
     1len,buffer_out)
      write(*,*) '   '
      write(*,*) 'Status returned from he5_prread:  ',status

c     Display the Profile data
c     ------------------------
      do i=1,4
         write(*,*) 'len(',i,'):  ',len(i)
      enddo

      write(*,*) '   '
      write(*,*) 'buffer_out:  '
      write(*,*)  buffer_out
      write(*,*) '   '

      j = 0
      do i=1,25
        element1(i) = buffer_out(i)      
        j = j + 1
      enddo  
      write(*,*) '1st element: '
      write(*,*) element1
      write(*,*) '   '

      j1 = j
      do i=1,50
        element2(i) = buffer_out(j1 + i)      
        j = j + 1
      enddo  
      write(*,*) '2nd element: '
      write(*,*) element2
      write(*,*) '   '

      j1 = j
      do i=1,75
        element3(i) = buffer_out(j1 + i)      
        j = j + 1
      enddo  
      write(*,*) '3rd element: '
      write(*,*) element3
      write(*,*) '   '

      j1 = j
      do i=1,100
        element4(i) = buffer_out(j1 + i)      
        j = j + 1
      enddo  
      write(*,*) '4th element: '
      write(*,*) element4
      write(*,*) '   '
            
c     Read Attribute
c     --------------	      
			status = he5_swrdattr(swid, "TestAttr", attr)
			do i=1,4
			   write(*,*) 'Attribute Element', i, ':', attr(i)
			enddo	      
			
		 endif
	  endif
      
c     Detach from swath
c     -----------------
	  status = he5_swdetach(swid)
      write(*,*) 'Status returned from he5_swdetach:  ',status
      
c     Close the file
c     --------------
	  status = he5_swclose(swfid)
      write(*,*) 'Status returned from he5_swclose:  ',status
      
	  stop
	  end

c
c ----------------------------------------------------------------------------
c |    Copyright (C) 1999   Emergent IT Inc. and Raytheon Systems Company    |
c ----------------------------------------------------------------------------
c

      program            he5_sw_wrexternaldataF_32

      implicit           none
 
      include            'hdfeos5.inc'

      integer            i
      integer            status
      integer            he5_swopen
      integer            he5_swattach
      integer            he5_swwrfld
      integer            he5_ehrdwrfile
      integer            he5_swdetach
      integer            he5_swclose
      integer            swfid, swid

      integer            data_out_1(100)
      integer            data_out_2(100)
      integer            data_out_3(100)
      integer            data(60)

      integer*4          start(2)
      integer*4          stride(2)
      integer*4          count(2)
      integer*4          num_elements

      integer            FAIL
      parameter          (FAIL=-1)

c.....Use this for writing (only) to an existing file
      integer            WRITE_EXISTING_ONLY
      parameter          (WRITE_EXISTING_ONLY=0)

c.....Use this for reading (only) from an existing file
      integer            READ_ONLY
      parameter          (READ_ONLY=1)

c.....Use this for creating and writing to a file
      integer            WRITE_NEW
      parameter          (WRITE_NEW=2)


c     Create the new data buffer
c     --------------------------
      do 10 i=1,60
         data(i) = 9999
 10   continue
      
c     Open HDF-EOS swath file, "swath.he5"
c     ------------------------------------
	  swfid = he5_swopen("swath.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned from he5_swopen():  ',swfid

	  if (swfid .NE. FAIL) then
		 swid = he5_swattach(swfid, "Swath1")
         write(*,*) 'Swath ID returned from he5_swattach():  ',swid

		 if (swid .NE. FAIL) then
			
c     Write new data to the external files 
c     ------------------------------------
      start(1)  = 0
      stride(1) = 1
      count(1)  = 60

      status = he5_swwrfld(swid,"ExtData",
     1     start,stride,count,data)
      write(*,*) 'Status returned from he5_swrdfld():  ',status

      num_elements = 100

      status = he5_ehrdwrfile("extf1.dat",READ_ONLY,
     1HE5T_NATIVE_INT,num_elements,data_out_1)
      write(*,*) 'Status returned from he5_ehrdwrfile:   ',status

      status = he5_ehrdwrfile("extf2.dat",READ_ONLY,
     1HE5T_NATIVE_INT,num_elements,data_out_2)
      write(*,*) 'Status returned from he5_ehrdwrfile:   ',status

      status = he5_ehrdwrfile("extf3.dat",READ_ONLY,
     1HE5T_NATIVE_INT,num_elements,data_out_3)
      write(*,*) 'Status returned from he5_ehrdwrfile:   ',status

      write(*,*)'External file extf1.dat:'
      write(*,*) data_out_1
      write(*,*) '  '

      write(*,*)'External file extf2.dat:'
      write(*,*) data_out_2
      write(*,*) '  '

      write(*,*)'External file extf3.dat:'
      write(*,*) data_out_3
      write(*,*) '  '

		 endif
	  endif
	
c     Detach from swath
c     -----------------
	  status = he5_swdetach(swid)
      write(*,*) 'Status returned from he5_swdetach():  ',status

c     Close the file
c     --------------
	  status = he5_swclose(swfid)
      write(*,*) 'Status returned from he5_swclose():  ',status
      
	  stop
	  end

!
! ----------------------------------------------------------------------------
! |    Copyright (C) 2002   Emergent IT Inc. and Raytheon Systems Company    |
! ----------------------------------------------------------------------------
!

      program            he5_za_rdexternaldataF_64

      implicit           none
 
      include            'hdfeos5.inc'

      integer            i
      integer            status
      integer            he5_zaopen
      integer            he5_zaattach
      integer            he5_zaread
      integer            he5_zagetxdat
      integer            he5_ehrdwrfile
      integer            he5_zadetach
      integer            he5_zaclose
      integer            zafid, zaid
      integer            nfiles
      integer            datain1(100)
      integer            datain2(100)
      integer            datain3(100)
      integer            dataout(60)

      integer*8          start(2)
      integer*8          stride(2)
      integer*8          count(2)
      integer*8          offset(3)
      integer*8          size(3)
      integer*8          nmlgth
      integer*8          num_elements

      character          filelist*256

      integer            FAIL
      parameter          (FAIL=-1)

!.....Use this for writing (only) to an existing file
      integer            WRITE_EXISTING_ONLY
      parameter          (WRITE_EXISTING_ONLY=0)

!.....Use this for reading (only) from an existing file
      integer            READ_ONLY
      parameter          (READ_ONLY=1)

!.....Use this for creating and writing to a file
      integer            WRITE_NEW
      parameter          (WRITE_NEW=2)

!     Create the external data sets
!     -----------------------------
      do 10 i=1,100

         datain1(i) = 1000+i
         datain2(i) = 2000+i
         datain3(i) = 3000+i        
         
 10   continue

      num_elements = 100
      
      status = he5_ehrdwrfile("extf1.dat",WRITE_NEW,
     1HE5T_NATIVE_INT,num_elements,datain1)
      write(*,*) 'Status returned from he5_ehrdwrfile:   ',status

      status = he5_ehrdwrfile("extf2.dat",WRITE_NEW,
     1HE5T_NATIVE_INT,num_elements,datain2)
      write(*,*) 'Status returned from he5_ehrdwrfile:   ',status

      status = he5_ehrdwrfile("extf3.dat",WRITE_NEW,
     1HE5T_NATIVE_INT,num_elements,datain3)
      write(*,*) 'Status returned from he5_ehrdwrfile:   ',status

!     Open HDF-EOS za file, "za.he5"
!     ------------------------------
	  zafid = he5_zaopen("za.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned from he5_zaopen():  ',zafid

	  if (zafid .NE. FAIL) then
		 zaid = he5_zaattach(zafid, "ZA1")
         write(*,*) 'ZA ID returned from he5_zaattach():  ',zaid

		 if (zaid .NE. FAIL) then
			
!     Read the external data field 
!     ----------------------------
      start(1)  = 0
      stride(1) = 1
      count(1)  = 60

      status = he5_zaread(zaid,"ExtData",
     1     start,stride,count,dataout)
      write(*,*) 'Status returned from he5_zaread():  ',status

!     Display the data
!     ----------------
      do i=1,60
         write(*,*)'External data',dataout(i)
      enddo

      nmlgth = 48

!     Get the number of external files
!     --------------------------------     
      nfiles = he5_zagetxdat(zaid,"ExtData",nmlgth,
     1     filelist,offset,size)

      write(*,*) 'Number of external files',nfiles
      write(*,*) 'External files:',filelist
      do i=1,nfiles
         write(*,*) 'offsets:',offset(i)
         write(*,*) 'sizes:',size(i)
      enddo

		 endif
	  endif
	
!     Detach from za 
!     --------------
	  status = he5_zadetach(zaid)
      write(*,*) 'Status returned from he5_zadetach():  ',status

!     Close the file
!     --------------
	  status = he5_zaclose(zafid)
      write(*,*) 'Status returned from he5_zaclose():  ',status
            
	  stop
	  end

      program     he5_sw_readdimscaleF_32

      implicit    none

      include     'hdfeos5.inc'

      integer     status
      integer     i, j, jj
      integer     he5_swopen
      integer     he5_swattach
      integer     he5_swwrfld
      integer     he5_swwrattr
      integer     he5_swwrgattr
      integer     he5_ehwrglatt
      integer     he5_swwrlattr 
      integer     he5_swdetach
      integer     he5_swclose
      integer     HE5_SWdscaleattrinfo, HE5_SWreaddscaleattr
      integer     HE5_SWgetdimscale, HE5_SWinqdscaleattrs
      integer     ntype
      integer     swfid,swid1
      real*4      datbuf_f(1) 
      integer*4   datbuf_i(3)
      integer*4   nbands
      integer     bands(3)
      integer*4   datbuf_i2(2) 
      integer     count(2)
      integer         attr_int(25)
      real*4          attr_flt(25)
      real*8          attr_dbl(25)
      character       attr_char(25)
      integer         dimsize
      integer         bufsize, nattr 
      integer         data(30)
      integer         FAIL
      parameter       (FAIL=-1)
      character*100   attrlist
      character*100   strbufsize
      character*15    attrname(10)
      integer         numtype

!  /*
!   * Open the HDF swath file, "swath.he5".
!   */

      swfid = HE5_SWopen("swath.he5", HE5F_ACC_RDWR)
 
!  /*
!   * If the swath file cannot be found, HE5_SWopen will return -1 for the file
!   * handle (swfid).  We there check that this is not the case before
!   * proceeding with the other routines.
!   * 
!   * The HE5_SWattach routine returns the handle to the existing swath "Swath1",
!   * SWid.  If the swath is not found, HE5_SWattach returns -1 for the handle.
!   */ 

      if (swfid .ne. FAIL) then
     
         SWid1 = HE5_SWattach(swfid, "Swath1")

!      /* the field Pollution has Time,YDim,XDim dimensions. 
!	 xdim = 120
!	 ydim = 200
!	 Time dim is set to 10
!      */

         if (SWid1 .eq. FAIL) then
            
            write(*,*) 'Error: Cannot attach to swath  Swath1'
            status = HE5_SWclose(swfid)
            stop
         endif

         bufsize = HE5_SWgetdimscale(SWid1, "Spectra", "Bands", 
     1        dimsize, numtype, data)
         if (bufsize .eq. -1) then
	
            write(*,*) 'Error:Cannot get Dimension Scale size of Bands',
     1           ' dimemnsion in field Spectra'
            status = HE5_SWdetach(SWid1)
            status = HE5_SWclose(swfid)
            stop
            
         else
            
            write(*,*) 'bufsize = ',bufsize
            write(*,*) 'dimsize = ',dimsize
            write(*,*) 'numtype = ',numtype
            
            write(*,*) 'Values are:'
            do i = 1,dimsize
               write(*,*) 'DimscaleValue[',i,'] = ',data(i)
            enddo
         endif
         
         nattr = HE5_SWinqdscaleattrs(SWid1, "Bands", attrlist, 
     1        strbufsize)
         if ( nattr .lt. 0 ) then
            
            write(*,*) 'Error: Cannot get Dimension Scale attribute',
     1           ' list for Bands'
            status = HE5_SWdetach(SWid1)
            status = HE5_SWclose(swfid)
            stop
         endif
         write(*,*) ' '
         write(*,*) 'Dimension scale for Bands Attribute:'

         attrname(1) = 'label'
         attrname(2) = 'unit'
         attrname(3) = 'format'
         attrname(4) = 'MissingValue'
         attrname(5) = 'IntValues'
         do j = 1,5
            attr_char = ''
            count(1)= 0
            count(2)= 0

            status = HE5_SWdscaleattrinfo(SWid1,"Bands", attrname(j), 
     1        ntype, count)
                              
            if( ntype .eq. 0) then
               status = HE5_SWreaddscaleattr(SWid1,"Bands", attrname(j), 
     1              attr_int)
            endif

            if( ntype .eq. 10) then
               status = HE5_SWreaddscaleattr(SWid1,"Bands", attrname(j), 
     1              attr_flt)
            endif
            
            if( ntype .eq. 11) then
               status = HE5_SWreaddscaleattr(SWid1,"Bands", attrname(j), 
     1              attr_dbl)
            endif
            
            if( ntype .eq. 57) then
               status = HE5_SWreaddscaleattr(SWid1,"Bands", attrname(j), 
     1              attr_char)
            endif

            write(*,*) ' '
            write(*,*) 'Status returned by HE5_SWreaddscaleattr() :', 
     1           status
            write(*,*) 'Attribute Name: ',attrname(j)
            write(*,*) 'Number of attribute elements: ', count(1),
     1     '   ',count(2)
            write(*,*) 'Data type of attribute: ', ntype
            
            if( ntype .eq. 0) then
               do jj = 1,count(1)
                  write(*,*) 'Attrvalue[',jj,']: ', attr_int(jj)
               enddo
            endif
            
            if( ntype .eq. 10) then
               do jj = 1,count(1)
                  write(*,*) 'Attrvalue[',jj,']: ',attr_flt(jj)
               enddo
            endif

            if( ntype .eq. 11) then
               do jj = 1,count(1)
                  write(*,*) 'Attrvalue[',jj,']: ',attr_dbl(jj)
               enddo
            endif

            if( ntype .eq. 57) then
               write(*,*) 'Attrvalue: ', attr_char
            endif
         enddo
      endif

      status = HE5_SWdetach(SWid1)
      
      status = HE5_SWclose(swfid)
      
      stop
      end

      program       he5_pt_updatelevelsF_64

      implicit      none
 
      include       'hdfeos5.inc'
 
      integer       status
      integer       ptfid 
      integer       ptid
      integer       level
      integer       he5_ptopen
      integer       he5_ptattach
      integer       he5_ptupdatelevel 
      integer       he5_ptdetach 
      integer       he5_ptclose
      integer       dtype(3)

      integer*8     recs(32)
      integer*8     nrec

      real*4        conc_tt(4)

      real*8        time_tt

      character*8   spc_tt
      character*80  fieldname

c     Open the HDF-EOS point file, "point.he5"
c     ----------------------------------------
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_ptopen():  ',ptfid

c     Read Simple Point 
c     ----------------- 
      ptid = HE5_PTattach(ptfid, "Simple Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid

      dtype(1)     =  HE5T_NATIVE_DOUBLE
      dtype(2)     =  HE5T_NATIVE_FLOAT
      dtype(3)     =  HE5T_NATIVE_CHAR

      nrec         = 1
      recs(1)      = 0

      level        = 0

      fieldname    = 'Concentration'

      conc_tt(1)   = 1.11
      conc_tt(2)   = 2.22
      conc_tt(3)   = 3.33
      conc_tt(4)   = 4.44

      status = he5_ptupdatelevel(ptid, level, fieldname, nrec,
     1recs, dtype(2), conc_tt)
      write(*,*) 'Status returned by he5_ptupdatelevel():  ',status

      fieldname = 'Time'

      time_tt   = 13131313.0

      status = he5_ptupdatelevel(ptid, level, fieldname, nrec,
     1recs, dtype(1), time_tt)
      write(*,*) 'Status returned by he5_ptupdatelevel():  ',status

      fieldname = 'Species'

      spc_tt    = 'AM'

      status = he5_ptupdatelevel(ptid, level, fieldname, nrec,
     1recs, dtype(3), spc_tt)
      write(*,*) 'Status returned by he5_ptupdatelevel():  ',status


c.....Close out the point interface
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status


      status = he5_ptclose(ptfid)
      write(*,*) 'Status returned by he5_ptclose():  ',status


      stop
      end

      program       he5_pt_writeattrsF_32

      implicit      none

      include       'hdfeos5.inc'

      integer       status
      integer       ptfid 
      integer       ptid
      integer       he5_ptopen
      integer       he5_ptattach
      integer       he5_ptwriteattr
      integer       he5_ptwritegrpattr
      integer       he5_ptwritelocattr
      integer       he5_ptdetach 
      integer       he5_ptclose
      integer       attr,attr1(5)
      integer       attr2(5)
      integer       ntype

      integer*4     fortcount(8)

      real*4        flt      

      character*80  attrname,levelname


c     Open the HDF point file, "point.he5"
c     -----------------------------------
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_ptopen():  ',ptfid

c     Read Simple Point 
c     ----------------- 
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid

c     Write attributes to "Fixed Buoy Point"
c     --------------------------------------
      attrname       = 'GlobalAttribute_int'
      ntype          = HE5T_NATIVE_INT
      fortcount(1)   = 1
      attr           = 9999
             
      status   = he5_ptwriteattr(ptid,attrname,ntype,fortcount,
     1attr)
      write(*,*) 'Status returned by he5_ptwriteattr():  ',status

      attrname       = 'GroupAttribute'
      ntype          = HE5T_NATIVE_INT
      fortcount(1)   = 5
      attr1(1)       = 1
      attr1(2)       = 2
      attr1(3)       = 3
      attr1(4)       = 4
      attr1(5)       = 5

      status   = he5_ptwritegrpattr(ptid,attrname,ntype,fortcount,
     1attr1)
      write(*,*) 'Status returned by he5_ptwritegrpattr():  ',status

      levelname      = 'Observations'
      attrname       = 'LocalAttribute'
      ntype          = HE5T_NATIVE_INT
      fortcount(1)   = 5
      attr2(1)       = 10
      attr2(2)       = 20
      attr2(3)       = 30
      attr2(4)       = 40
      attr2(5)       = 50

      status   = he5_ptwritelocattr(ptid,levelname,attrname,
     1ntype,fortcount,attr2)
      write(*,*) 'Status returned by he5_ptwritelocattr():  ',status

c.....Close out the point interface
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status


c     Write attributes to "Fixed Buoy Point"
c     --------------------------------------
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid

      attrname       = 'GlobalAttribute_float'
      ntype          = HE5T_NATIVE_FLOAT
      fortcount(1)   = 1
      flt            = -7.5

      status   = he5_ptwriteattr(ptid,attrname,
     1ntype,fortcount,flt)
      write(*,*) 'Status returned by he5_ptwriteattr():  ',status


c.....Close out the point interface
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status

      status = he5_ptclose(ptfid)
      write(*,*) 'Status returned by he5_ptclose():  ',status

      stop
      end

c     In this program we (1) open the "swath.he5" file, (2) attach to
c     the "Swath1" swath, and (3) read data from the "Longitude" field
c     ================================================================

      program            he5_sw_readdataF_32

      implicit           none

      include            'hdfeos5.inc'

      integer            status
      integer            he5_swopen
      integer            he5_swattach
      integer            he5_swrdfld
      integer            he5_swrdattr
      integer            he5_prread
      integer            he5_swdetach
      integer            he5_swclose
      integer            swfid, swid
      integer            buffer_out(250)
      integer            i,j,j1
      integer            element1(25)
      integer            element2(50)
      integer            element3(75)
      integer            element4(100)

      real*4             lng(10,20)
      real*4             temp(10,20)

      integer*4          attr(4)

      integer*4          start(2)
      integer*4          stride(2)
      integer*4          count(2)
      integer*4          len(4)
      
      integer            FAIL
      parameter          (FAIL=-1)
      
c     Open HDF-EOS swath file, "swath.he5"
c     -----------------------------------
	  swfid = he5_swopen("swath.he5",HE5F_ACC_RDONLY)
      write(*,*) 'File ID returned by he5_swopen():  ',swfid

	  if (swfid .NE. FAIL) then
		 swid = he5_swattach(swfid, "Swath1")
         write(*,*) 'Swath ID returned by he5_swattach():  ',swid

		 if (swid .NE. FAIL) then
			
	      
c     Read the entire Longitude field
c     -------------------------------
			start(1)  = 0
			start(2)  = 0
			stride(1) = 1
			stride(2) = 1
			count(1)  = 10
			count(2)  = 20
            
			status = he5_swrdfld(swid,"Longitude",
     1           start,stride,count,lng)
            
			do i=1,20
			   do j=1,10
				  write(*,*)'i j Longitude ',i,j,lng(j,i)
			   enddo
			enddo

                        start(1)  = 0
                        start(2)  = 0
                        stride(1) = 1
                        stride(2) = 1
                        count(1)  = 10
                        count(2)  = 20
 
                        status = he5_swrdfld(swid,"L2gpValue",
     1           start,stride,count,temp)
 
                        do i=1,20
                           do j=1,10
                               write(*,*)'i j L2gpValue ',i,j,temp(j,i)
                           enddo
                        enddo


c     Read data from the Profile
c     --------------------------
			start(1)  = 0
			stride(1) = 1
			count(1)  = 4
 
      status = he5_prread(swid,"Profile-2000",start,stride,count,
     1len,buffer_out)
      write(*,*) '   '
      write(*,*) 'Status returned from he5_prread:  ',status

c     Display the Profile data
c     ------------------------
      do i=1,4
         write(*,*) 'len(',i,'):  ',len(i)
      enddo

      write(*,*) '   '
      write(*,*) 'buffer_out:  '
      write(*,*)  buffer_out
      write(*,*) '   '

      j = 0
      do i=1,25
        element1(i) = buffer_out(i)      
        j = j + 1
      enddo  
      write(*,*) '1st element: '
      write(*,*) element1
      write(*,*) '   '

      j1 = j
      do i=1,50
        element2(i) = buffer_out(j1 + i)      
        j = j + 1
      enddo  
      write(*,*) '2nd element: '
      write(*,*) element2
      write(*,*) '   '

      j1 = j
      do i=1,75
        element3(i) = buffer_out(j1 + i)      
        j = j + 1
      enddo  
      write(*,*) '3rd element: '
      write(*,*) element3
      write(*,*) '   '

      j1 = j
      do i=1,100
        element4(i) = buffer_out(j1 + i)      
        j = j + 1
      enddo  
      write(*,*) '4th element: '
      write(*,*) element4
      write(*,*) '   '
         
c     Read Attribute
c     --------------	      
			status = he5_swrdattr(swid, "TestAttr", attr)
			do i=1,4
			   write(*,*) 'Attribute Element', i, ':', attr(i)
			enddo	      
			
		 endif
	  endif
      
c     Detach from swath
c     -----------------
	  status = he5_swdetach(swid)
      write(*,*) 'Status returned from he5_swdetach:  ',status

c     Close the file
c     --------------
	  status = he5_swclose(swfid)
      write(*,*) 'Status returned from he5_swclose:  ',status

	  stop
	  end

!----------------------------------------------------------------------------
!     Copyright (C) 2002   Emergent IT Inc. and Raytheon Systems Company    |
!----------------------------------------------------------------------------
! testza32.f                                                                |
! In this program we create, define and write a simple za hdfeos file       |
! using the za interface                                                    |
!----------------------------------------------------------------------------

      program   testza32

      implicit  none
 
      include   'hdfeos5.inc'

      integer   index1, index2, status
      integer   rank, n, dtype, classid, order
      integer   rdattr(4), global_attr(4)
      integer   compparm(5), cnkrank
      integer   rdcompparm(5), compcode
      integer   he5_zaopen, he5_zacreate
      integer   zafid, zaid, zaid2
      integer   he5_zadefdim, he5_zadetach
      integer   he5_zadefine
      integer   he5_zaclose
      integer   he5_zasetfill, he5_zawrlattr, he5_zawrattr
      integer   he5_zawrite, he5_zawrgattr
      integer   he5_zaread, he5_zainfo 
      integer   he5_zaattrinfo, he5_zardattr
      integer   he5_zagattrinfo, he5_zardgattr, he5_zardlattr
      integer   he5_zalattrinfo, he5_zagetfill, he5_zaidtype
      integer   he5_zadefchunk, he5_zadefcomp, he5_zacompinfo
      integer   rnkd(4), ntyped(4), nt
      integer   he5_zaattach

      integer*4 he5_zainqza, he5_zanentries
      integer*4 he5_zainqdims, he5_zadiminfo
      integer*4 he5_zainqattrs, he5_zainqgattrs
      integer*4 he5_zainqlattrs, he5_zainquire
      integer*4 size, strbufsize, ndims, chunkdims(1)
      integer*4 start(2), stride(2), dataedge(2)
      integer*4 istart(2),iedge(2),dedge(2)
      integer*4 sd_start(2), sd_stride(2), sd_edge(2)
      integer*4 rd_start(2), rd_stride(2), rd_edge(2)
      integer*4 dimsize
      integer*4 nattr, nza, nmaps
      integer*4 strbufsz2, nflds
      integer*4 count(1)
      integer*4 dims(2),dims2(3),sddims(2)
      integer*4 dim1, dim2, dim3, dim4

      real      grpattr(3), locattr(3), rdgnlattr(3)
      real      ray1(100,40), ray2(40,100)
      real      ray4(40,100)
      real      ray3(40,40), temp(40,100)
      real      raycnt	
      real      fillvalue, rdfilval


      character*(256)  dimname, fieldlist
      character*(256)  attrlist, zalist
      character*(256)  dimens, maxdims

      dim1          = 30
      dim2          = 40
      dim3          = 50
      dim4          = 100
      count(1)      = 3
      compparm(1)   = 6
      compparm(2)   = 0
      compparm(3)   = 0
      compparm(4)   = 0
      compparm(5)   = 0

      cnkrank       = 1
      chunkdims(1)  = 10

      rdcompparm(1) = 1
      rdcompparm(2) = 1
      rdcompparm(3) = 1
      rdcompparm(4) = 1
      rdcompparm(5) = 1
      compcode      = -1
      raycnt        = -799.0
      global_attr(1)= 11
      global_attr(2)= 33
      global_attr(3)= 66
      global_attr(4)= 99
      grpattr(1)    = 21.7
      grpattr(2)    = 24.3
      grpattr(3)    = 26.3
      locattr(3)    = 21.7
      locattr(2)    = 24.3
      locattr(1)    = 26.3
      start(1)      = 10
      start(2)      = 10
      stride(1)     = 1
      stride(2)     = 1
      sd_start(1)   = 0
      sd_start(2)   = 0
      sd_stride(1)  = 1
      sd_stride(2)  = 1
      sd_edge(1)    = 100
      sd_edge(2)    = 40
      rd_start(1)   = 0
      rd_start(2)   = 0
      rd_stride(1)  = 1
      rd_stride(2)  = 1
      rd_edge(1)    = 40
      rd_edge(2)    = 100
      dataedge(1)   = 20
      dataedge(2)   = 50
      istart(1)     = 0
      istart(2)     = 0
      iedge(1)      = 30
      iedge(2)      = 30
      dedge(1)      = 40
      dedge(2)      = 40
      rank          = 2
      fillvalue     = 16.0

!
! This section of the program just fills some arrays with data that will be
! used later in the program
!
      do 110 index1=1,100
         do 100 index2=1,40
            ray1(index1, index2)=raycnt
            ray2(index2, index1)=raycnt + 1.0
            ray4(index2,index1) = raycnt
            raycnt = raycnt +1.
  100    continue
  110 continue

      do 170 index1=1,40
         do 160 index2=1,40
            ray3(index1, index2)=raycnt
            raycnt = raycnt+1.25
  160    continue
  170 continue


  230 format('********Error unexpected**********')
  240 format('***********Passed Test*********')

      open(unit=1, file="testza.txt", status = "UNKNOWN")

      write(*,*)'Testing he5_za FORTRAN 77 interface'
      write(*,*)'======================================'
      write(1,*)'Testing he5_za FORTRAN 77 interface'
      write(1,*)'======================================'
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zaopen
!
      write(*,*)'Testing he5_zaopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_zaopen '
      write(1,*)'====================='
      zafid=he5_zaopen('za.he5',HE5F_ACC_TRUNC)
      if (zafid .lt. 0) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_TRUNC)'
         write(*,*)'Value returned by he5_zaopen ', zafid
         write(1,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_TRUNC)'
         write(1,*)'Value returned by he5_zaopen ', zafid
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zacreate
!
      write(1,27)
      write(*,*)'Testing he5_zacreate '
      write(*,*)'====================='
      write(1,*)'Testing he5_zacreate '
      write(1,*)'====================='
      zaid=he5_zacreate(zafid,'Simplef')
      if (zaid .lt. 0) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid=he5_zacreate(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zacreate ', zaid
         write(1,*)'zaid= he5_zacreate(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zacreate ', zaid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid2=he5_zacreate(zafid,'Indexedf')
      if (zaid2 .lt. 0) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	zaid2= he5_zacreate(zafid, "Indexedf")'
         write(*,*)'	Value returned by he5_zacreate ', zaid2
         write(1,*)'	zaid2= he5_zacreate(zafid, "Indexedf")'
         write(1,*)'	Value returned by he5_zacreate ', zaid2
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zadefdim
!
      write(1,27)
      write(*,*)'Testing he5_zadefdim '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadefdim '
      write(1,*)'====================='
      status=he5_zadefdim(zaid,'DataTrack',dim4)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_zadefdim(zaid, "DataTrack", 100)'
         write(*,*)'	Value returned by he5_zadefdim ',status
         write(1,*)'	status= he5_zadefdim(zaid, "DataTrack", 100)'
         write(1,*)'	Value returned by he5_zadefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefdim(zaid,'DataXtrack',dim2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_zadefdim(zaid, "DataXtrack", 40)'
         write(*,*)'	Value returned by he5_zadefdim ',status
         write(1,*)'	status= he5_zadefdim(zaid, "DataXtrack", 40)'
         write(1,*)'	Value returned by he5_zadefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '


      status=he5_zadefdim(zaid2,'DataTrack',dim2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_zadefdim(zaid2, "DataTrack", 40)'
         write(*,*)'	Value returned by he5_zadefdim ', status
         write(1,*)'	status= he5_zadefdim(zaid2, "DataTrack", 40)'
         write(1,*)'	Value returned by he5_zadefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefdim(zaid2,'DataXtrack',dim2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_zadefdim(zaid2, "DataXtrack", 40)'
         write(*,*)'	Value returned by he5_zadefdim ', status
         write(1,*)'	status= he5_zadefdim(zaid2, "DataXtrack", 40)'
         write(1,*)'	Value returned by he5_zadefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '


      status=he5_zadefdim(zaid2,'Timedim',dim2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define dimension Timedim '
         write(*,*)'	Value returned by he5_zadefdim ', status
         write(1,*)'Define dimension Timedim '
         write(1,*)'	Value returned by he5_zadefdim ', status
      endif

      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zadefine
!
      write(1,27)
      write(*,*)'Testing he5_zadefine '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadefine '
      write(1,*)'====================='

      status=he5_zadefine(zaid,'SideA','DataXtrack,DataTrack',
     1' ', HE5T_NATIVE_FLOAT)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
        
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define data field SideA '
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'Define data field SideA '
         write(1,*)'Value returned by he5_zadefine ',status
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case  -- he5_zasetfill
!
      write(1,27)
      write(*,*)'Testing he5_zasetfill '
      write(*,*)'====================='
      write(1,*)'Testing he5_zasetfill '
      write(1,*)'====================='
      status= he5_zasetfill(zaid,'Temperature',
     1HE5T_NATIVE_FLOAT, fillvalue)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zasetfill(zaid,"Temperature",
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(*,*)'Value returned by he5_zasetfill ',status
         write(1,*)'status=he5_zasetfill(zaid,"Temperature",
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(1,*)'Value returned by he5_zasetfill ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefine(zaid,'Temperature',
     1'DataXtrack,DataTrack',' ',HE5T_NATIVE_FLOAT)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define data field Temperature '
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'Define data field Temperature '
         write(1,*)'Value returned by he5_zadefine ',status
         write(*,*)' '
         write(1,*)' '
      endif

      status= he5_zasetfill(zaid,'Conduction',
     1HE5T_NATIVE_FLOAT,fillvalue)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zasetfill(zaid,"Conduction",
     1HE5T_NATIVE_FLOAT,fillvalue)'
         write(*,*)'Value returned by he5_zasetfill ',status
         write(1,*)'status=he5_zasetfill(zaid,"Conduction",
     1HE5T_NATIVE_FLOAT,fillvalue)'
         write(1,*)'Value returned by he5_zasetfill ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefine(zaid,'Conduction',
     1'DataXtrack,DataTrack',' ',HE5T_NATIVE_FLOAT)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadefine(zaid,"Conduction",
     1"DataXtrack,DataTrack","",HE5T_NATIVE_FLOAT)'
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'status= he5_zadefine(zaid,"Conduction",
     1"DataXtrack,DataTrack","",HE5T_NATIVE_FLOAT)'
         write(1,*)'Value returned by he5_zadefine ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefine(zaid2,'Sensor1',
     1'DataXtrack,DataTrack',' ',HE5T_NATIVE_FLOAT)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zadefine(zaid2, "Sensor1",
     1"DataTrack,DataXtrack","",HE5T_NATIVE_FLOAT)'
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'status= he5_zadefine(zaid2, "Sensor1",
     1"DataTrack,DataXtrack","",HE5T_NATIVE_FLOAT)'
         write(1,*)'Value returned by he5_zadefine ',status
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zadefchunk
!
      write(1,27)
      write(*,*)'Testing he5_zadefchunk'
      write(*,*)'======================'
      write(1,*)'Testing he5_zadefchunk'
      write(1,*)'======================'
      status=he5_zadefchunk(zaid,cnkrank,chunkdims)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadefchunk(zaid, cnkrank, chunkdims)'
         write(*,*)'Value returned by he5_zadefchunk ',status
         write(1,*)'status= he5_zadefchunk(zaid, cnkrank, chunkdims)'
         write(1,*)'Value returned by he5_zadefchunk ',status
      endif
      write(*,*)' '
      write(1,*)' '
    
! Test Case -- he5_zadefcomp
!
      write(1,27)
      write(*,*)'Testing he5_zadefcomp'
      write(*,*)'====================='
      write(1,*)'Testing he5_zadefcomp'
      write(1,*)'====================='
      status=he5_zadefcomp(zaid,HE5_HDFE_COMP_DEFLATE,compparm)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadefcomp(zaid,HE5_HDFE_COMP_DEFLATE,
     1compparm)'
         write(*,*)'Value returned by he5_zadefcomp ',status
         write(1,*)'status= he5_zadefcomp(zaid,HE5_HDFE_COMP_DEFLATE,
     1compparm)'
         write(1,*)'Value returned by he5_zadefcomp ',status
      endif
      write(*,*)' '
      write(1,*)' '


      status=he5_zadefine(zaid,'CompChunk','DataTrack',
     1' ',HE5T_NATIVE_FLOAT)
      if (status .lt. 0) then
         write(*,230)
         write(1,230) 
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define data field CompChunk '
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'Define data field CompChunk '
         write(1,*)'Value returned by he5_zadefine ',status
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zadetach
!
      write(1,27)
      write(*,*)'Testing he5_zadetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadetach '
      write(1,*)'====================='
      status=he5_zadetach(zaid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadetach(zaid2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid2)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid2)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      zaid=he5_zaattach(zafid,'Simplef')
      if (zaid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zaattach ',zaid
         write(1,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zaattach ',zaid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid2=he5_zaattach(zafid,'Indexedf')
      if (zaid2 .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(*,*)'Value returned by he5_zaattach ',zaid2
         write(1,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(1,*)'Value returned by he5_zaattach ',zaid2
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zadetach
!
      write(1,27)
      write(*,*)'Testing he5_zadetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadetach '
      write(1,*)'====================='
      status= he5_zadetach(zaid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid2)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid2)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zaclose(zafid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)       
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaclose(zafid)'
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      zafid=he5_zaopen('za.he5',HE5F_ACC_RDWR)
      if (zafid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zafid=he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_zaopen ',zafid
         write(1,*)'zafid=he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_zaopen ',zafid
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zaattach
!
      write(1,27)
      write(*,*)'Testing he5_zaattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_zaattach '
      write(1,*)'====================='

      zaid=he5_zaattach(zafid,'Simplef')
      if (zaid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zaattach ',zaid
         write(1,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zaattach ',zaid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid2=he5_zaattach(zafid,'Indexedf')
      if (zaid2 .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(*,*)'Value returned by he5_zaattach ',zaid2
         write(1,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(1,*)'Value returned by he5_zaattach ',zaid2
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zawrite
!
      write(1,27)
      write(*,*)'Testing he5_zawrite '
      write(*,*)'==================='
      write(1,*)'Testing he5_zawrite '
      write(1,*)'==================='

      status=he5_zawrite(zaid,'SideA',sd_start,stride, 
     1rd_edge, ray4)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Write data field SideA '
         write(*,*)'Value returned by he5_zawrite ',status
         write(1,*)'Write data field SideA '
         write(1,*)'Value returned by he5_zawrite ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zawrite(zaid,'Temperature',start,stride, 
     1dataedge, ray4)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrite(zaid,"Temperature",start, 
     1stride,dataedge, ray1)'
         write(*,*)'Value returned by he5_zawrite ',status
         write(1,*)'status=he5_zawrite(zaid,"Temperature",start, 
     1stride,dataedge, ray1)'
         write(1,*)'Value returned by he5_zawrite ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zawrite(zaid,'Conduction',start,stride, 
     1dataedge, ray2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrite(zaid,"Conduction",start, 
     1stride,dataedge, ray2)'
         write(*,*)'Value returned by he5_zawrite ',status
         write(1,*)'status=he5_zawrite(zaid,"Conduction",start, 
     1stride,dataedge, ray2)'
         write(1,*)'Value returned by he5_zawrite ',status
      endif
      write(*,*)' '
      write(1,*)' '


      iedge(1)=40
      iedge(2)=40
      status=he5_zawrite(zaid2,'Sensor1',istart,stride, 
     1iedge,ray3)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zawrite(zaid2, "Sensor1", 
     1istart, stride, iedge, ray3)'
         write(*,*)'Value returned by he5_zawrite ',status
         write(1,*)'status= he5_zawrite(zaid2, "Sensor1", 
     1istart, stride, iedge, ray3)'
         write(1,*)'Value returned by he5_zawrite ',status
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zawrlattr
!
      write(1,27)
      write(*,*)'Testing he5_zawrlattr, Local Attribute '
      write(*,*)'================================== '
      write(1,*)'Testing he5_zawrlattr, Local Attribute '
      write(1,*)'================================== '
      status=he5_zawrlattr(zaid2,'Sensor1','local',
     1HE5T_NATIVE_FLOAT,count,locattr)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrlattr(zaid2,"Sensor1","local",
     1HE5T_NATIVE_FLOAT,count,locattr)'
         write(*,*)'Value returned by he5_zawrlattr ',status
         write(1,*)'status=he5_zawrlattr(zaid2,"Sensor1", "local", 
     1HE5T_NATIVE_FLOAT,count,locattr)'
         write(1,*)'Value returned by he5_zawrlattr ',status
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zawrattr
!
      count(1) = 4

      write(1,27)
      write(*,*)'Testing he5_zawrattr, Global Attribute '
      write(*,*)'====================================== '
      write(1,*)'Testing he5_zawrattr, Global Attribute '
      write(1,*)'======================================= '
      status=he5_zawrattr(zaid,'Drift',HE5T_NATIVE_INT,count, 
     1global_attr)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrattr(zaid, "Drift", 
     1HE5T_NATIVE_INT, count, global_attr)'
         write(*,*)'Value returned by he5_zawrattr ',status
         write(1,*)'status=he5_zawrattr(zaid, "Drift", 
     1HE5T_NATIVE_INT, count, global_attr)'
         write(1,*)'Value returned by he5_zawrattr ',status
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zawrgattr
!
      count(1) = 3
     
      write(1,27)
      write(*,*)'Testing he5_zawrgattr, Group Attribute '
      write(*,*)'====================================== '
      write(1,*)'Testing he5_zawrgattr, Group Attribute '
      write(1,*)'====================================== '
      status=he5_zawrgattr(zaid,'group',HE5T_NATIVE_FLOAT, 
     1count,grpattr)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrgattr(zaid, "group", 
     1HE5T_NATIVE_FLOAT,count,grpgattr)'
         write(*,*)'Value returned by he5_zawrgattr ',status
         write(1,*)'status=he5_zawrgattr(zaid, "group", 
     1HE5T_NATIVE_FLOAT,count,grpattr)'
         write(1,*)'Value returned by he5_zawrgattr ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
      write(*,*)'status= he5_zadetach(zaid)'
      write(*,*)'Value returned by he5_zadetach ',status
      write(1,*)'status= he5_zadetach(zaid)'
      write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid2)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid2)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zaclose
!
      write(1,27)
      write(*,*)'Testing he5_zaclose '
      write(*,*)'==================='
      write(1,*)'Testing he5_zaclose '
      write(1,*)'==================='
      status= he5_zaclose(zafid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      zafid= he5_zaopen('za.he5',HE5F_ACC_RDWR)
      if (zafid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_zaopen ', zafid
         write(1,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_zaopen ', zafid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid= he5_zaattach(zafid,'Simplef')
      if (zaid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zaattach ',zaid
         write(1,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zaattach ',zaid
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zaclose(zafid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaclose(zafid)'
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      zafid= he5_zaopen('za.he5',HE5F_ACC_RDWR)
      if (zafid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_zaopen ',zafid
         write(1,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_zaopen ',zafid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid=he5_zaattach(zafid,'Simplef')
      if (zaid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zaattach ',zaid
         write(1,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zaattach ',zaid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid2=he5_zaattach(zafid,'Indexedf')
      if (zaid2 .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(*,*)'Value returned by he5_zaattach ',zaid2
         write(1,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(1,*)'Value returned by he5_zaattach ',zaid2
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zanentries
!
      write(1,27)
      write(*,*)'Testing he5_zanentries '
      write(*,*)'====================='
      write(1,*)'Testing he5_zanentries '
      write(1,*)'====================='

      nmaps=he5_zanentries(zaid,1,strbufsize)
      if (nmaps .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'nmaps= he5_zanentries(zaid, 1, strbufsize)'
         write(*,*)'Number of dimension mappings ',nmaps
         write(*,*)'Size of strbufsize ',strbufsize
         write(1,*)'nmaps= he5_zanentries(zaid, 1, strbufsize)'
         write(1,*)'Number of dimension mappings ',nmaps
         write(1,*)'Size of strbufsize ',strbufsize
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zainqdims
!
      write(1,27)
      write(*,*)'Testing he5_zainqdims '
      write(*,*)'====================='
      write(1,*)'Testing he5_zainqdims '
      write(1,*)'====================='
      ndims=he5_zainqdims(zaid,dimname,dims)
      if (ndims .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'ndims= he5_zainqdims(zaid, dimname, dims)'
         write(*,*)'Number of dimesions ',ndims
         write(*,*)'Names of dimensions ',dimname
         write(*,*)'Size of dimensions ',dims
         write(1,*)'ndims= he5_zainqdims(zaid, dimname, dims)'
         write(1,*)'Number of dimesions ',ndims
         write(1,*)'Names of dimensions ',dimname
         write(1,*)'Size of dimensions ',dims
      endif
      write(*,*)' '
      write(1,*)' '

      ndims= he5_zainqdims(zaid2, dimname, dims2)
      if (ndims .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'ndims=he5_zainqdims(zaid2,dimname,dims2)'
         write(*,*)'Number of dimesions ',ndims
         write(*,*)'Names of dimensions ',dimname
         write(*,*)'Size of dimensions ',dims2
         write(1,*)'ndims=he5_zainqdims(zaid2,dimname,dims2)'
         write(1,*)'Number of dimesions ',ndims
         write(1,*)'Names of dimensions ',dimname
         write(1,*)'Size of dimensions ',dims2
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zainquire
!
      write(1,27)
      write(*,*)'Testing he5_zainquire '
      write(*,*)'======================'
      write(1,*)'Testing he5_zainquire '
      write(1,*)'======================'
      nflds=he5_zainquire(zaid,fieldlist,rnkd,ntyped)
      if (nflds .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'nflds=he5_zainquire(zaid,fieldlist,rnkd,ntyped)'
         write(*,*)'Number of data fields in za ',nflds
         write(*,*)'Names of data fields ',fieldlist
         write(*,*)'Rank of fields ',rnkd
         write(*,*)'Number type of fields ',ntyped
         write(1,*)'nflds=he5_zainquire(zaid,fieldlist,rnkd,ntyped)'
         write(1,*)'Number of data fields in za ',nflds
         write(1,*)'Names of data fields ',fieldlist
         write(1,*)'Rank of fields ',rnkd
         write(1,*)'Number type of fields ',ntyped
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zadiminfo
!
      write(1,27)
      write(*,*)'Testing he5_zadiminfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadiminfo '
      write(1,*)'====================='
      dimsize= he5_zadiminfo(zaid,'DataTrack')
      if (dimsize .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'dimsize= he5_zadiminfo(zaid, "DataTrack")'
         write(*,*)'Size of dimension DataTrack ',dimsize
         write(1,*)'dimsize= he5_zadiminfo(zaid, "DataTrack")'
         write(1,*)'Size of dimension DataTrack ',dimsize
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zaread
!
      write(1,27)
      write(*,*)'Testing he5_zaread '
      write(*,*)'==================='
      write(1,*)'Testing he5_zaread '
      write(1,*)'==================='

      rd_start(1)=0
      rd_start(2)=0
      rd_stride(1)=1
      rd_stride(2)=1
      rd_edge(1)=40
      rd_edge(2)=100
      status= he5_zaread(zaid,'Conduction',rd_start,
     1rd_stride,rd_edge,temp)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Value returned by he5_zaread ',status
         write(*,*)'status= he5_zaread(zaid, "Conduction", 
     1rd_start,rd_stride, rd_edge, temp)'
         write(1,*)'status= he5_zaread(zaid, "Conduction", 
     1rd_start,rd_stride, rd_edge, temp)'
         write(1,*)'Value returned by he5_zaread ',status
         do 190 index1=10,15
            do 180 index2=10,15
               write(*,*)'value of conduction ',temp(index1,index2)
               write(1,*)'value of conduction ',temp(index1,index2)
  180       continue
  190    continue
      endif

      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zainfo
!
      write(1,27)
      write(*,*)'Testing he5_zainfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_zainfo '
      write(1,*)'====================='
      status=he5_zainfo(zaid,'SideA',rank,sddims,nt,
     1dimens,maxdims)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zainfo(zaid, "SideA", 
     1rank, sddims, nt, dimens, maxdims)'
         write(*,*)'Value returned by he5_zainfo ',status
         write(*,*)'Rank of field sideA ',rank
         write(*,*)'dimension list of field sideA ',dimens
         write(*,*)'Size of sideA dimensions ',sddims
         write(*,*)'number type of field sideA ',nt
         write(1,*)'status= he5_zainfo(zaid, "SideA", 
     1rank, sddims, nt, dimens, maxdims)'
         write(1,*)'Value returned by he5_zainfo ',status
         write(1,*)'Rank of field sideA ',rank
         write(1,*)'dimension list of field sideA ',dimens
         write(1,*)'Size of sideA dimensions ',sddims
         write(1,*)'number type of field sideA ',nt
      endif
      write(*,*)' '
      write(1,*)' '

 
! Test Case -- he5_zainqattrs
!
      write(1,27)
      write(*,*)'Testing he5_zainqattrs Global attributes '
      write(*,*)'==================================== '
      write(1,*)'Testing he5_zainqattrs Global attributes '
      write(1,*)'==================================== '

      nattr = he5_zainqattrs(zaid,attrlist,strbufsz2)
      if (nattr .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Number of global attributes in za ',nattr
         write(*,*)'Attribute list of za ',attrlist
         write(1,*)'Number of global attributes in za ',nattr
         write(1,*)'Attribute list of za ',attrlist
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zaattrinfo
!
      write(1,27)
      write(*,*)'Testing he5_zaattrinfo Global attribute'
      write(*,*)'======================================='
      write(1,*)'Testing he5_zaattrinfo Global attribute'
      write(1,*)'======================================='
      status= he5_zaattrinfo(zaid, attrlist, n, size)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zaattrinfo(zaid,attrlist,n,size)'
         write(*,*)'Value returned by he5_zaattrinfo ',status
         write(*,*)'Number type of attributes ',n,' Size ',size
         write(1,*)'status=he5_zaattrinfo(zaid,attrlist,n,size)'
         write(1,*)'Value returned by he5_zaattrinfo ',status
         write(1,*)'Number type of attributes ',n,' Size ',size
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zardattr
!
      write(1,27)
      write(*,*)'Testing he5_zardattr, Global attribute '
      write(*,*)'======================================'
      write(1,*)'Testing he5_zardattr, Global attribute '
      write(1,*)'======================================'

      status= he5_zardattr(zaid, attrlist, rdattr)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zardattr(zaid,attrlist,rdattr)'
         write(*,*)'Value returned by he5_zardattr ',status
         write(*,*)'attribute ',rdattr
         write(1,*)'status=he5_zardattr(zaid,attrlist,rdattr)'
         write(1,*)'Value returned by he5_zardattr ',status
         write(1,*)'attribute ',rdattr
      endif
      write(*,*)' '
      write(1,*)' '

!     Test Case -- he5_zainqgattrs
!
      write(1,27)
      write(*,*)'Testing he5_zainqgattrs Group attributes '
      write(*,*)'==================================== '
      write(1,*)'Testing he5_zainqgattrs Group attributes '
      write(1,*)'==================================== '

      nattr = he5_zainqgattrs(zaid,attrlist,strbufsz2)
      if (nattr .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Number of group attributes in za ',nattr
         write(*,*)'Attribute list of za ',attrlist
         write(1,*)'Number of group attributes in za ',nattr
         write(1,*)'Attribute list of za ',attrlist
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zagattrinfo
!
      write(1,27)
      write(*,*)'Testing he5_zagattrinfo Group attribute'
      write(*,*)'======================================='
      write(1,*)'Testing he5_zagattrinfo Group attribute'
      write(1,*)'======================================='
      status= he5_zagattrinfo(zaid, attrlist, n, size)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zagattrinfo(zaid,attrlist,n,size)'
         write(*,*)'Value returned by he5_zagattrinfo ',status
         write(*,*)'Number type of attributes ',n,' Size ',size
         write(1,*)'status=he5_zagattrinfo(zaid,attrlist,n,size)'
         write(1,*)'Value returned by he5_zagattrinfo ',status
         write(1,*)'Number type of attributes ',n,' Size ',size
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zardgattr
!
      write(1,27)
      write(*,*)'Testing he5_zardgattr, Group attribute '
      write(*,*)'======================================'
      write(1,*)'Testing he5_zardgattr, Group attribute '
      write(1,*)'======================================'

       status= he5_zardgattr(zaid,'group',rdgnlattr)
       if (status .lt. 0) then
          write(*,230)
          write(1,230)
       else
          write(*,*)'  '
          write(*,240)
          write(1,*)'  '
          write(1,240)
          write(*,*)'status=he5_zardgattr(zaid,attrlist,rdgnlattr)'
          write(*,*)'Value returned by he5_zardgattr ',status
          write(*,*)'attribute ',rdgnlattr
          write(1,*)'status=he5_zardgattr(zaid,attrlist,rdgnlattr)'
          write(1,*)'Value returned by he5_zardgattr ',status
          write(1,*)'attribute ',rdgnlattr
       endif
       write(*,*)' '
       write(1,*)' '

! Test Case -- he5_zainqlattrs
!
      write(1,27)
      write(*,*)'Testing he5_zainqlattrs Local attributes '
      write(*,*)'==================================== '
      write(1,*)'Testing he5_zainqlattrs Local attributes '
      write(1,*)'==================================== '

      nattr=he5_zainqlattrs(zaid2,'Sensor1',attrlist,strbufsz2)
      if (nattr .lt. 0) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zainqlattrs(... "Sensor1" ...)'
         write(*,*)'Number of local attributes in field ',nattr
         write(*,*)'Attribute list of field ',attrlist
         write(1,*)'zainqlattrs(... "Sensor1" ...)'
         write(1,*)'Number of local attributes in field ',nattr
         write(1,*)'Attribute list of field ',attrlist
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zalattrinfo
!
      write(1,27)
      write(*,*)'Testing he5_zalattrinfo Local attribute'
      write(*,*)'======================================='
      write(1,*)'Testing he5_zalattrinfo Local attribute'
      write(1,*)'======================================='
      status=he5_zalattrinfo(zaid2,'Sensor1','local',n,size)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zalattrinfo(... "Sensor1" ...)'
         write(*,*)'Value returned by he5_zalattrinfo ',status
         write(*,*)'Number type of attributes ',n,' Size ',size
         write(1,*)'zalattrinfo(... "Sensor1" ...)'
         write(1,*)'Value returned by he5_zalattrinfo ',status
         write(1,*)'Number type of attributes ',n,' Size ',size
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zaidtype
!
      write(1,27)
      write(*,*)'Testing he5_zaidtype, Inquire Datatype '
      write(*,*)'======================================='
      write(1,*)'Testing he5_zaidtype, Inquire Datatype '
      write(1,*)'======================================='

      status= he5_zaidtype(zaid2,'Sensor1','local', 
     1HE5_HDFE_LOCATTRGROUP,dtype,classid, order, size)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaidtype(zaid2,"Sensor1","local", 
     1HE5_HDFE_LOCATTRGROUP,dtype, classid, order, size)'
         write(*,*)'Value returned by he5_zaidtype ',status
         write(*,*)'Datatype of local attribute ',dtype
         write(*,*)'Class id and order ',classid, order
         write(*,*)'Size of attribute ',size
         write(1,*)'status= he5_zaidtype(zaid2,"Sensor1","local", 
     1HE5_HDFE_LOCATTRGROUP,dtype, classid, order, size)'
         write(1,*)'Value returned by he5_zaidtype ',status
         write(1,*)'Datatype of local attribute ',dtype
         write(1,*)'Class id and order ',classid, order
         write(1,*)'Size of attribute ',size
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zardlattr
!
      write(1,27)
      write(*,*)'Testing he5_zardlattr, Local attribute '
      write(*,*)'======================================'
      write(1,*)'Testing he5_zardlattr, Local attribute '
      write(1,*)'======================================'

      status=he5_zardlattr(zaid2,'Sensor1','local',rdgnlattr)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zardlattr(zaid2,"Sensor1","local", 
     1rdgnlattr)'
         write(*,*)'Value returned by he5_zardlattr ',status
         write(*,*)'attribute ',rdgnlattr
         write(1,*)'status=he5_zardlattr(zaid2,"Sensor1","local", 
     1rdgnlattr)'
         write(1,*)'Value returned by he5_zardlattr ',status
         write(1,*)'attribute ',rdgnlattr
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zagetfill
!
      write(1,27)
      write(*,*)'Testing he5_zagetfill '
      write(*,*)'====================='
      write(1,*)'Testing he5_zagetfill '
      write(1,*)'====================='
      status= he5_zagetfill(zaid,'Conduction', rdfilval)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zagetfill(zaid,"Conduction",rdfilval)'
         write(*,*)'Value returned by he5_zagetfill ',status
         write(*,*)'Value of fill ',rdfilval
         write(1,*)'status=he5_zagetfill(zaid,"Conduction",rdfilval)'
         write(1,*)'Value returned by he5_zagetfill ',status
         write(1,*)'Value of fill ',rdfilval
      endif
      write(*,*)' '
      write(1,*)' '



! Test Case -- he5_zacompinfo
!
      write(1,27)
      write(*,*)'Testing he5_zacompinfo '
      write(*,*)'======================='
      write(1,*)'Testing he5_zacompinfo '
      write(1,*)'======================='
      status=he5_zacompinfo(zaid,'CompChunk',compcode,rdcompparm)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zacompinfo(zaid,"CompChunk",compcode, 
     1rdcompparm)'
         write(*,*)'Status returned by he5_zacompinfo ',status
         write(*,*)'Compression code ',compcode
         write(*,*)'Compression parameter ',rdcompparm(1)
         write(1,*)'status=he5_zacompinfo(zaid,"CompChunk",compcode, 
     1rdcompparm)'
         write(1,*)'Status returned by he5_zacompinfo ',status
         write(1,*)'Compression code ',compcode
         write(1,*)'Compression parameter ',rdcompparm(1)
      endif
      write(*,*)' '
      write(1,*)' '



      status= he5_zadetach(zaid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid2)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid2)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zaclose(zafid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaclose(zafid)'
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      zafid=he5_zaopen('za.he5',HE5F_ACC_RDWR)
      if (zafid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zafid=he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_zaopen ',zafid
         write(1,*)'zafid=he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_zaopen ',zafid
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zainqza
!
      write(1,27)
      write(*,*)'Testing he5_zainqza '
      write(*,*)'======================'
      write(1,*)'Testing he5_zainqza '
      write(1,*)'======================'

      nza=he5_zainqza('za.he5',zalist,strbufsz2)
      if (nza .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Retrieve information on zas in 
     1file za.he5'
         write(*,*)'Number of zas in file ', nza
         write(*,*)'List of zas ',zalist
         write(1,*)'Retrieve information on zas in 
     1file za.he5'
         write(1,*)'Number of zas in file ', nza
         write(1,*)'List of zas ',zalist
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zaclose(zafid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)       
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaclose(zafid)'
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '

      close(unit=1)
   27 format(' ')
      stop
      end

c     In this code we open an HDF-EOS file and create UTM, Polar 
c     Stereographic, and Geographic grids within the file
c     =========================================================

      program     he5_gd_setupF_64
 
      implicit    none

      include     'hdfeos5.inc'

      integer     status, gdfid, i 
      integer     he5_gdcreate, he5_gdopen 
      integer     he5_gddefdim, he5_gddefproj
      integer     he5_gddeforigin
      integer     he5_gddetach, he5_gdclose
      integer     gdid, gdid2, gdid3
      integer     zonecode, spherecode

      integer*8   xdim, ydim, dim

      real*8      uplft(2), lowrgt(2)
      real*8      projparm(16), he5_ehconvang

c     Open the HDF-EOS grid file, "grid.he5"
c     -------------------------------------
      gdfid = he5_gdopen('grid.he5',HE5F_ACC_TRUNC)
      write(*,*) 'File ID returned by he5_gdopen():  ',gdfid
    
c     Create UTM Grid     
c     ---------------

c --------------------------------------------------- c
c  Region is bounded by 54 E and 60 E longitudes and  c
c  20 N and 30 N latitudes. UTM Zone: 40.             c
c  Use default spheriod (Clarke 1866: spherecode = 0) c
c                                                     c
c  Grid into 120 bins along x-axis and 200 bins       c
c  along y-axis  (approx 3' by 3' bins).              c
c --------------------------------------------------- c

      zonecode   = 40
      spherecode = 0

c    Upper Left and Lower Right points in meters
c    -------------------------------------------
      uplft(1)  =   210584.50041
      uplft(2)  =  3322395.95445
      lowrgt(1) =  813931.10959
      lowrgt(2) = 2214162.53278

      xdim = 120
      ydim = 200

c     Define GCTP Projection Parameters
c     ---------------------------------
      do i=1,16
         projparm(i) = 0.d0
      enddo
    
      gdid   = he5_gdcreate(gdfid, "UTMGrid", 
     1     xdim, ydim, uplft, lowrgt)
      write(*,*) 'Grid ID returned by he5_gdcreate():  ',gdid

      status = he5_gddefproj(gdid,HE5_GCTP_UTM,
     1     zonecode,spherecode,projparm)
      write(*,*) 'Status returned by he5_gddefproj():  ',status
         
c     Define "Time" Dimension
c     -----------------------
      dim    = 10
      status = he5_gddefdim(gdid, "Time", dim)
      write(*,*) 'Status returned by he5_gddefdim():  ',status
     
c     Create polar stereographic grid 
c     -------------------------------
    
c --------------------------------------------------- c
c   Northern Hemisphere (True Scale at 90 N, 0        c
c   Longitude below pole).                            c
c   Use International 1967 spheriod (spherecode = 3)  c
c   Grid into 100 bins along x-axis and y-axis.       c
c --------------------------------------------------- c
      
      xdim = 100
      ydim = 100
      
      spherecode = 3
      
c     Set Longitude below pole & true scale in DDDMMMSSS.SSS format)
c     --------------------------------------------------------------
      projparm(5) = 0.0
      projparm(6) = 90000000.00

c     Use default boundaries for Polar Stereographic (hemisphere)
c     -----------------------------------------------------------
      uplft(1)    =  0
      uplft(2)    =  0
      lowrgt(1)   =  0
      lowrgt(2)   =  0

      zonecode   = 0
      
      gdid2  = he5_gdcreate(gdfid,"PolarGrid",
     1     xdim,ydim,uplft,lowrgt)
      write(*,*) 'Grid ID returned by he5_gdcreate():  ',gdid2

      status = he5_gddefproj(gdid2,HE5_GCTP_PS,
     1     zonecode,spherecode,projparm)
      write(*,*) 'Status returned by he5_gddefproj():  ',status

      status = he5_gddeforigin(gdid2, HE5_HDFE_GD_LR)
      write(*,*) 'Status returned by he5_gddeforigin():  ',status
            
c     Define "Bands" Dimension
c     ------------------------
      dim    = 3
      status = he5_gddefdim(gdid2, "Bands", dim)
      write(*,*) 'Status returned by he5_gddefdim():  ',status
            
c     Create geographic (linear scale) grid
c     -------------------------------------

c --------------------------------------------------- c 
c   0-15 degrees longitude, 20-30 degrees latitude    c
c --------------------------------------------------- c

      xdim = 60
      ydim = 40

      uplft(1)  = he5_ehconvAng(0.d0, HE5_HDFE_DEG_DMS)
      uplft(2)  = he5_ehconvAng(30.d0,HE5_HDFE_DEG_DMS)
      lowrgt(1) = he5_ehconvAng(15.d0,HE5_HDFE_DEG_DMS)
      lowrgt(2) = he5_ehconvAng(20.d0,HE5_HDFE_DEG_DMS)

      do i=1,16
         projparm(i) = 0.d0
      enddo
      
      zonecode   = 0
      spherecode = 0

      gdid3 =he5_gdcreate(gdfid,"GEOGrid",
     1     xdim,ydim,uplft,lowrgt)
      write(*,*) 'Grid ID returned by he5_gdcreate():  ',gdid3

      status=he5_gddefproj(gdid3,HE5_GCTP_GEO,
     1     zonecode,spherecode,projparm)
      write(*,*) 'Status returned by he5_gddefproj():  ',status

c     Detach from the created grids
c     -----------------------------
      status = he5_gddetach(gdid)
      write(*,*) 'Status returned by he5_gddetach():  ',status

      status = he5_gddetach(gdid2)
      write(*,*) 'Status returned by he5_gddetach():  ',status

      status = he5_gddetach(gdid3)
      write(*,*) 'Status returned by he5_gddetach():  ',status
          
c     Finally, close the grid file
c     ----------------------------
      status = he5_gdclose(gdfid)
      write(*,*) 'Status returned by he5_gdclose():  ',status

      stop
      end

      program     he5_sw_writedimscaleF_32
! This code creates fields and with just one call to HE5_SWdefdimscale creates dimmension scales
! for all fields that share the same dimension (both geofoelds and datafields). You need to call
! he5_sw_setupF_32 and he5_sw_definefieldsF_32 before calling the 
! he5_sw_definefields_and_all_dimscalesF_32
      implicit    none

      include     'hdfeos5.inc'

      integer     status
      integer     i, j
      integer     he5_swopen
      integer     he5_swattach
      integer     he5_swwrfld
      integer     he5_swwrattr
      integer     he5_swwrgattr
      integer     he5_ehwrglatt
      integer     he5_swwrlattr 
      integer     he5_swdetach
      integer     he5_swclose
      integer     HE5_SWsetdimscale
      integer     HE5_SWwritedscaleattr

      integer     swfid,swid1
      integer*4   datbuf_i1(1) 
      integer*4   datbuf_i(15)
      integer*4    count(2)
      integer*4   nbands
      integer     bands(3)
      integer*4   datbuf_i2(2)
      integer     xdim, ydim, ntime
      integer     data(15)
      integer     data2(20)
      integer     FAIL
      parameter   (FAIL=-1)
      integer     nscanline



!  /*
!   * We first open the HDF-EOS swath file, "swath.he5".  Because this file
!   * already exist and we wish to write to it, we use the H5F_ACC_RDWR access
!   * code in the open statement.  The HE5_SWopen routine returns the swath file
!   * id, swfid, which is used to identify the file in subsequent routines.
!   */ 
      nbands = 15
      do j=1,nbands
         data(j)=(j+1)*2
      enddo

      nscanline = 20
      do j=1,nscanline
         data2(j)=(j+1)*2
      enddo

      swfid = HE5_SWopen("swath.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_swopen(): ',swfid
!  /*
!   * If the swath file cannot be found, HE5_SWopen will return -1 for the file
!   * handle (swfid).  We there check that this is not the case before
!   * proceeding with the other routines.
!   * 
!   * The HE5_SWattach routine returns the handle to the existing swath "Swath1",
!   * SWid.  If the swath is not found, HE5_SWattach returns -1 for the handle.
!   */ 

      if (swfid .ne. FAIL) then
 
         SWid1 = HE5_SWattach(swfid, "Swath1")
         write(*,*) 'Swath ID returned by he5_swattach(): ',swid1

!      /* the field Spectra has Bands,Res2tr,Res2xtr dimensions. 
!	 xdim = 120;
!	 ydim = 200;
!	 Time dim is set to 10
!      */

         if (SWid1 .eq. -1) then
            
            write(*,*) 'Error: Cannot attach to swath Swath1. Stpped.'
            status = HE5_SWclose(swfid)
            stop
            
         endif
 
         status = HE5_SWsetdimscale2(SWid1, "Latitude", "GeoTrack",
     1        "geograck", nscanline, HE5T_NATIVE_INT, data2)
         write(*,*) 'Status returned by HE5_SWsetdimscale: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale for GeoTrack',
     1                 ' dimemnsion in field Latitude'
            status = HE5_SWdetach(SWid1)
            status = HE5_SWclose(swfid)
            stop
         endif

         count(1)= 12
         status = HE5_SWwritedscaleattr(SWid1, "GeoTrack", "label", 
     1                         HE5T_NATIVE_CHAR, count, "GeoTrack Dim")
         write(*,*) 'Status returned by HE5_SWwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for',
     1                ' GeoTrack dimemnsion in field '
            status = HE5_SWdetach(SWid1)
            status = HE5_SWclose(swfid)
            stop
         endif


         status = HE5_SWsetdimscale(SWid1, "Density", "GeoTrack",
     1                             nscanline, HE5T_NATIVE_INT, data2)
         write(*,*) 'Status returned by HE5_SWsetdimscale: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale for GeoTrack',
     1                 ' dimemnsion in field Density'
            status = HE5_SWdetach(SWid1)
            status = HE5_SWclose(swfid)
            stop
         endif

 
         status = HE5_SWsetdimscale2(SWid1, "Temperature", "GeoTrack",
     1        "geotrack_2",nscanline, HE5T_NATIVE_INT, data2)
         write(*,*) 'Status returned by HE5_SWsetdimscale: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale for GeoTrack',
     1                 ' dimemnsion in field Temperature'
            status = HE5_SWdetach(SWid1)
            status = HE5_SWclose(swfid)
            stop
         endif

                  
         status = HE5_SWsetdimscale(SWid1, "Spectra", "Bands", nbands,
     1                               HE5T_NATIVE_INT, data)
         write(*,*) 'Status returned by HE5_SWsetdimscale: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale for Bands',
     1                 ' dimemnsion in field Vegetation'
            status = HE5_SWdetach(SWid1)
            status = HE5_SWclose(swfid)
            stop
         endif

         count(1)= 9
         status = HE5_SWwritedscaleattr(SWid1, "Bands", "label", 
     1                         HE5T_NATIVE_CHAR, count, "Bands Dim")
         write(*,*) 'Status returned by HE5_SWwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1                ' dimemnsion in field Spectra'
            status = HE5_SWdetach(SWid1)
            status = HE5_SWclose(swfid)
            stop
         endif
         
         count(1)= 4
         status = HE5_SWwritedscaleattr(SWid1, "Bands", "unit", 
     1                              HE5T_NATIVE_CHAR, count, "None")
         write(*,*) 'Status returned by HE5_SWwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1                 ' dimemnsion in field Spectra'
            status = HE5_SWdetach(SWid1)
            status = HE5_SWclose(swfid)
            stop
         endif
         
         count(1)= 2
         status = HE5_SWwritedscaleattr(SWid1, "Bands", "format", 
     1                                 HE5T_NATIVE_CHAR, count, "I2")
         write(*,*) 'Status returned by HE5_SWwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1                 ' dimemnsion in field Spectra'
            status = HE5_SWdetach(SWid1)
            status =  HE5_SWclose(swfid)
            stop
         endif

         datbuf_i1(1) = -999
         count(1)= 1
         status = HE5_SWwritedscaleattr(SWid1, "Bands", "MissingValue",
     1                             HE5T_NATIVE_INT, count, datbuf_i1)
         write(*,*) 'Status returned by HE5_SWwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1                 ' dimemnsion in field Spectra'
            status = HE5_SWdetach(SWid1)
            status = HE5_SWclose(swfid)
            stop
         endif
         
         datbuf_i(1) =  -999
         datbuf_i(2) =  0
         datbuf_i(3) =  999


         count(1)= 3
         status = HE5_SWwritedscaleattr(SWid1, "Bands", "IntValues", 
     1                               HE5T_NATIVE_INT, count, datbuf_i)
         write(*,*) 'Status returned by HE5_SWwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale str for Bands',
     1         ' dimemnsion in field Spectra'
            status = HE5_SWdetach(SWid1)
            status = HE5_SWclose(swfid)
            stop
         endif
         
         status = HE5_SWdetach(SWid1)
         write(*,*) 'Status returned by he5_swdetach(): ',status

         status = HE5_SWclose(swfid)
         write(*,*) 'Status returned by he5_swclose(): ',status

      endif
      stop
      end

      program       he5_pt_datainfoF_64

      implicit      none

      include       'hdfeos5.inc'

      integer       status
      integer       ptfid 
      integer       ptid       
      integer       he5_ptopen
      integer       he5_ptattach
      integer       he5_ptinqdatatype
      integer       he5_ptdetach 
      integer       he5_ptclose
      integer       dtype
      integer       classid
      integer       order
      integer       fieldgroup

      integer*8     size

      character*1   null_char_0
      character*80  fieldname
      character*80  attrname

      null_char_0  = '0'

c     Open the HDF-EOS point file, "point.he5"
c     ----------------------------------------
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDONLY)
      write(*,*) 'File ID returned by he5_ptopen():  ',ptfid

c     Read Simple Point 
c     ----------------- 
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid

      fieldgroup = HE5_HDFE_DATAGROUP
      fieldname  = 'Observations'

      status = he5_ptinqdatatype(ptid,fieldname,null_char_0,fieldgroup,
     1dtype,classid,order,size)
      print *,'Status returned from he5_ptinqdatatype():  ',status
      print *,'dtype:        ',dtype
      print *,'class ID:     ',classid
      print *,'order:        ',order
      print *,'size:         ',size


      fieldgroup   = HE5_HDFE_ATTRGROUP
      attrname     = 'GlobalAttribute_int'

      status = he5_ptinqdatatype(ptid,null_char_0,attrname,fieldgroup,
     1dtype,classid,order,size)
      print *,'Status returned from he5_ptinqdatatype():  ',status
      print *,'dtype:        ',dtype
      print *,'class ID:     ',classid
      print *,'order:        ',order
      print *,'size:         ',size


      fieldgroup   = HE5_HDFE_GRPATTRGROUP
      attrname     = 'GroupAttribute'

      status = he5_ptinqdatatype(ptid,null_char_0,attrname,fieldgroup,
     1dtype,classid,order,size)
      print *,'Status returned from he5_ptinqdatatype():  ',status
      print *,'dtype:        ',dtype
      print *,'class ID:     ',classid
      print *,'order:        ',order
      print *,'size:         ',size


      fieldname    = 'Observations'
      fieldgroup   = HE5_HDFE_LOCATTRGROUP
      attrname     = 'LocalAttribute'

      status = he5_ptinqdatatype(ptid,fieldname,attrname,fieldgroup,
     1dtype,classid,order,size)
      print *,'Status returned from he5_ptinqdatatype():  ',status
      print *,'dtype:        ',dtype
      print *,'class ID:     ',classid
      print *,'order:        ',order
      print *,'size:         ',size


c.....Close out the point interface
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status

      status = he5_ptclose(ptfid)
      write(*,*) 'Status returned by he5_ptclose():  ',status

      stop
      end

!	In this program we (1) open the "za.he5" HDF-EOS file, 
!	(2) attach to the "ZA1" za, and (3) define the za fields
!       ========================================================

      program     he5_za_definefieldsF_64

      implicit    none

      include     'hdfeos5.inc'

      integer     status
      integer     he5_zaopen
      integer     he5_zaattach
      integer     he5_zadefine
      integer     he5_zadefchunk
      integer     he5_zadefcomp
      integer     he5_zadetach
      integer     he5_zaclose
      integer     zafid, zaid

      integer     chunkrank
      integer*8   chunkdims(3)
      integer     compparm(1)

      integer     FAIL
      parameter   (FAIL=-1)

!     Open the HDF-EOS file, "za.he5" using "READ/WRITE" access code
!     --------------------------------------------------------------
      zafid = he5_zaopen("za.he5",HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_zaopen():  ',zafid 
      if (zafid .NE. FAIL) then
         
         zaid = he5_zaattach(zafid, "ZA1")
         write(*,*) 'ZA ID  returned by he5_zaattach():  ',zaid 
         if (zaid .NE. FAIL) then
            
!     Define Data fields
!     ------------------

            status = he5_zadefine(zaid,"Density","MyTrack1",
     1           " ",HE5T_NATIVE_FLOAT)
            write(*,*) 'Status returned by he5_zadefine():  ',status 

            status = he5_zadefine(zaid,"Temperature", 
     1           "MyTrack2,MyTrack1"," ",HE5T_NATIVE_FLOAT)
            write(*,*) 'Status returned by he5_zadefine():  ',status 	      
	      
            status = he5_zadefine(zaid,"Pressure","Res2xtr,Res2tr",
     1           " ", HE5T_NATIVE_FLOAT)
            write(*,*) 'Status returned by he5_zadefine():  ',status 
	      
                chunkrank = 3
                chunkdims(1) = 20
                chunkdims(2) = 40
                chunkdims(3) = 15
                compparm(1) = 6
 
            status = he5_zadefchunk(zaid,chunkrank,chunkdims)
            write(*,*) 'Status returned by he5_zadefchunk(): ',status
 
            status = he5_zadefcomp(zaid,HE5_HDFE_COMP_DEFLATE,compparm)
            write(*,*) 'Status returned by he5_zadefcomp():  ',status

            status = he5_zadefine(zaid, "Spectra", 
     1           "Res2xtr,Res2tr,Bands"," ",
     2           HE5T_NATIVE_DOUBLE)	      
            write(*,*) 'Status returned by he5_zadefine():  ',status 
            

         endif
      endif
      
!     Detach from the za
!     ------------------      
      status = he5_zadetach(zaid)
      write(*,*) 'Status returned by he5_zadetach():  ',status 
      
!     Close the file
!     --------------      
      status = he5_zaclose(zafid)
      write(*,*) 'Status returned by he5_zaclose():  ',status 
      
      stop
      end

c----------------------------------------------------------------------------
c     Copyright (C) 2000   Emergent IT Inc. and Raytheon Systems Company    |
c----------------------------------------------------------------------------
c testgrid32.f                                                                |
c In this program we create, define and write a simple grid hdfeos file     |
c using the grid interface                                                  |
c----------------------------------------------------------------------------


      program       testgrid32

      implicit      none
 
      include       'hdfeos5.inc'
 
      integer       zero
      integer       rnk(8), numtype(8)
      integer       zcode, scode, nflds
      integer       regionid, regionid2
      integer       dtype, classid, order
      integer       status, i, ii
      integer       compparm(5)
      integer 	    gdfid, gdfid2, gdid_utm, gdid2
      integer 	    zonecode, pixregcode, orgcode
      integer	    attr(4), iattr(4), gattr(4), lattr(4)
      integer 	    spherecode
      integer	    he5_gdopen, he5_gdcreate
      integer	    he5_gdclose, he5_gddefproj
      integer	    he5_gddeftle, he5_gddeffld
      integer	    he5_gdwrattr, he5_gdwrgattr
      integer	    he5_gddefcomp, he5_gdinqflds
      integer	    he5_gdrdfld, he5_gdattrinfo
      integer	    he5_gdlatinfo, he5_gdrdattr
      integer	    he5_gdreginfo, he5_gddeftmeper
      integer	    he5_gddeforigin, he5_gddefpreg
      integer	    he5_gdgridinfo, he5_gdcompinfo
      integer	    he5_gdgetpix, he5_gddupreg
      integer	    he5_gdattach, he5_gddetach
      integer	    he5_gddefdim, he5_gdinqdatatype
      integer	    he5_gdsetfill, he5_gdwrfld
      integer	    he5_gdwrlattr, he5_gdorginfo
      integer	    he5_gdprojinfo, he5_gdgatinfo
      integer	    he5_gdrdgattr, he5_gdrdlattr
      integer	    he5_gddefvrtreg
      integer	    he5_gdinqdims, he5_gdgetfill
      integer	    he5_gdfldinfo, he5_gddefboxreg
      integer	    he5_gdpreginfo, he5_gdextreg
      integer 	    nt(4), rk(4)

      integer*4 	xdim, ydim
      integer*4	    he5_gdinqgrid, he5_gddiminfo
      integer*4	    he5_gdinqattrs, he5_gdinqgattrs
      integer*4	    he5_gdgetpixval, he5_gdinterpolate
      integer*4	    he5_gdnentries, he5_gdinqlattrs
      integer*4     index1
      integer*4  	index2
      integer*4	    dimsizes(2)
      integer*4 	tiledims(2), tilecords(2)
      integer*4 	ntype, count
      integer*4 	rowval(5), colval(5)
      integer*4 	lat(40,50)
      integer*4 	latcnt
      integer*4 	lon(40,50)
      integer*4 	loncnt
      integer*4 	lstatus, n, one
      integer*4 	size
      integer*4     start(2)
      integer*4     stride(2)
      integer*4     edge(2)
      integer*4     start1d, stride1d, edge1d
      integer*4 	periodid
      integer*4     strbufsize, pcode
      integer*4     xdimsize, ydimsize
      integer*4	    dims(32)
      
      real		    fillvalue, ifillv

      real*4		fldval(5)
      real*4		ray3(250)
      real*4		utmray(60,80), georay(60,80)
      real*4		utmhght(80)
      real*4		hghtinit
      real*4		utmcnt, geocnt
      real*4		raycnt, ray3cnt
      real*4		tempray(60,80)
      real*4		datbuf(4800)

      real*8		starttime, stoptime
      real*8		range(2)
      real*8		projparm(16), pparm(16)
      real*8		uplft(2), lowrgt(2)
      real*8		iuplft(2), ilrgt(2)
      real*8		interval(5,2)
      real*8		lonval(5), latval(5)
      real*8		upleftpt(2), lowrtpt(2),corlon(2),corlat(2)
      real*8		utmtmeray(4800)
      real*8		tmeinit

      character*80	grdnames, dimname, fldlist, attrlist
      character*80	maxdimname
      integer*4	    	compcodestring
      
      nt(1)= 0      
      nt(2)= 0      
      nt(3)= 0      
      nt(4)= 0
      rk(1)= 0
      rk(2)= 0
      rk(3)= 0
      rk(4)= 0

      index1      = 0
      index2      = 0
      dimsizes(1) = 40
      dimsizes(2) = 100
      compparm(1) = 6 
      compparm(2) = 0
      compparm(3) = 0
      compparm(4) = 0
      compparm(5) = 0
      fillvalue   = 1996.0
      raycnt      = -799.0
      ray3cnt     = -19.5
      attr(1)     = 11
      attr(2)     = 33
      attr(3)     = 55
      attr(4)     = 77
      utmcnt      = -799.0
      geocnt      = 2001.0
      hghtinit    = 323.0
      tmeinit     = 35232487.2d0
      starttime   = 35233000.8d0
      stoptime    = 35435050.9d0
      range(1)    = 352.8d0
      range(2)    = 400.9d0
      lonval(1)   = -122.0d0
      latval(1)   = -68.0d0
      lonval(2)   = -122.5d0
      latval(2)   = -68.0d0
      lonval(3)   = -123.0d0
      latval(3)   = -68.0d0
      lonval(4)   = -123.5d0
      latval(4)   = -68.0d0
      lonval(5)   = -124.0d0
      latval(5)   = -68.0d0
      tiledims(1) = 16
      tiledims(2) = 15
      tilecords(1)= 0
      tilecords(2)= 0
      latcnt      = 38.0
      loncnt      = 78.0
      one         = 1
      zero        = 0
c
c This section of the program just fills some arrays with data that we will
c use later in the program
c
      do 70 index1=1,60
         do 80 index2=1,80
            utmray(index2,index1) = utmcnt
            georay(index2,index1) = geocnt
            utmcnt = utmcnt + .4
            geocnt = geocnt + .2
   80   continue
   70 continue
  
      
      do 30 index1=1,250
            ray3(index1) = ray3cnt
            ray3cnt = ray3cnt + .1
   30 continue
      
      do 32 index1=1,80
            utmhght(index1) = hghtinit
            hghtinit = hghtinit + 2.75
   32 continue

      do 34 index1=1,4800
            utmtmeray(index1) = tmeinit
            tmeinit = tmeinit + 70.7
   34 continue

      do 50 index1=1,50
         do 60 index2=1,40      
            lat(index2,index1) = latcnt
            lon(index2,index1) = loncnt
            loncnt = loncnt - 0.1
   60    continue
         latcnt = latcnt + 0.1
         loncnt = 78.0
   50 continue

  230 format('********Error unexpected**********')
  231 format('********Error Expected************')
  240 format('***********Passed Test*********')


      open(unit=10,file='testgrid32_f.txtout',status="UNKNOWN")

      write(*,*)'Testing Grid FORTRAN 77 interface '
      write(*,*)'=================================='
      write(10,*)'Testing Grid FORTRAN 77 interface '
      write(10,*)'=================================='
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdopen
c
      write(10,*)'Testing gdopen... '
      write(10,*)'=================='
      write(*,*)'Testing gdopen... '
      write(*,*)'=================='
      gdfid2 = he5_gdopen("grid2f32.he5",HE5F_ACC_TRUNC)
      if (gdfid2 .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdfid2 = he5_gdopen("grid2f32.he5",HE5F_ACC_TRUNC)'
         write(10,*)'Value returned by he5_gdopen ', gdfid2
         write(*,*)'gdfid2 = he5_gdopen("grid2f32.he5",HE5F_ACC_TRUNC)'
         write(*,*)'Value returned by he5_gdopen ', gdfid2
      endif
      write(*,*)' '
      write(10,*)' '

      gdfid = he5_gdopen('gridf32.he5',HE5F_ACC_TRUNC)
      if (gdfid .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'Opening file gridf32.he5'
         write(10,*)'Opening file gridf32.he5'
         write(10,*) 'gdfid = he5_gdopen("gridf32.he5",HE5F_ACC_TRUNC)'
         write(10,*) 'File id returned from he5_gdopen ', gdfid
         write(*,*) 'gdfid = he5_gdopen("gridf32.he5",HE5F_ACC_TRUNC)'
         write(*,*) 'File id returned from he5_gdopen ', gdfid
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- gdcreate
c
      write(10,27)
      write(10,*)'Testing gdcreate... '
      write(10,*) '=================='
      write(*,*)'Testing gdcreate... '
      write(*,*)'=================='
      xdim = 60
      ydim = 80
      uplft(1)  = 353299.39125d0
      uplft(2)  = -7100284.64348d0
      lowrgt(1) = 603434.52148d0
      lowrgt(2) = -7991341.17870d0


      gdid2 = he5_gdcreate(gdfid2, 'UTMGrid2', xdim, 
     1ydim, uplft, lowrgt)
      if (gdid2 .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*) 'Create UTMGrid2'
         write(*,*)'gdid2 = he5_gdcreate(gdfid2, "UTMGrid2", 
     1xdim, ydim, uplft, lowrgt)'
         write(10,*) 'Value returned by he5_gdcreate ', gdid2
         write(*,*) 'Create UTMGrid2'
         write(10,*)'gdid2 = he5_gdcreate(gdfid2, "UTMGrid2", 
     1xdim, ydim, uplft, lowrgt)'
         write(*,*) 'Value returned by he5_gdcreate ', gdid2
      endif
      
    
      gdid_utm = he5_gdcreate(gdfid, 'UTMGrid', xdim, 
     1ydim, uplft, lowrgt)
      if (gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Creating UTMGrid'
         write(*,*)'Creating UTMGrid'
         write(*,*)'gdid_utm=he5_gdcreate(gdfid,"UTMGrid",
     1xdim,ydim,uplft,lowrgt)'
         write(10,*)'gdid_utm=he5_gdcreate(gdfid,"UTMGrid",
     1xdim,ydim,uplft,lowrgt)'
         write(10,*)'UTM grid id returned from he5_gdcreate ', 
     1gdid_utm
         write(*,*)'UTM grid id returned from he5_gdcreate ', 
     1gdid_utm
      endif 
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefproj
c
      write(10,27)
      write(10,*)'Testing gddefproj... '
      write(10,*)'=================='
      write(*,*)'Testing gddefproj... '
      write(*,*)'=================='

      zonecode = 10
      spherecode = 0

      do 120 index1=1,16
         projparm(index1)=0
 120  continue
  
      status = he5_gddefproj(gdid_utm,HE5_GCTP_UTM,zonecode,
     1spherecode,projparm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Defining UTM projection'
         write(*,*)'Defining UTM projection'
         write(*,*)'status=he5_gddefproj(gdid_utm,HE5_GCTP_UTM,
     1zonecode,spherecode, projparm)'
         write(10,*)'status=he5_gddefproj(gdid_utm,HE5_GCTP_UTM,
     1zonecode,spherecode, projparm)'
         write(10,*)'Returned value from he5_gddefproj ', status
         write(*,*)'Returned value from he5_gddefproj ', status
      endif 
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefproj(gdid2,HE5_GCTP_UTM,zonecode,
     1spherecode,projparm)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Defining UTM'
         write(10,*)'status = he5_gddefproj(gdid2,HE5_GCTP_UTM,
     1zonecode,spherecode,projparm)'
         write(10,*)'Value returned by he5_gddefproj ', status
         write(*,*)'Defining UTM'
         write(*,*)'status = he5_gddefproj(gdid2,HE5_GCTP_UTM,
     1zonecode,spherecode,projparm)'
         write(*,*)'Value returned by he5_gddefproj ', status
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- gddefpreg
c
      write(10,27)
      write(10,*)'Testing gddefpreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddefpreg... '
      write(*,*)'=================='
      status = he5_gddefpreg(gdid_utm, HE5_HDFE_CORNER)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gddefpreg(gdid_utm, 
     1HE5_HDFE_CORNER)'
         write(10,*)'status = he5_gddefpreg(gdid_utm, 
     1HE5_HDFE_CORNER)'
         write(10,*)'Returned from he5_gddefpreg ', status
         write(*,*)'Returned from he5_gddefpreg ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeforigin
c
      write(10,27)
      write(10,*)'Testing gddeforigin... '
      write(10,*)'=================='
      write(*,*)'Testing gddeforigin... '
      write(*,*)'=================='
      status = he5_gddeforigin(gdid_utm, HE5_HDFE_GD_UL)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gddeforigin(gdid_utm, 
     1HE5_HDFE_GD_UL)'
         write(*,*)'Value of status from he5_gddeforigin ',
     1status
         write(10,*)'status = he5_gddeforigin(gdid_utm, 
     1HE5_HDFE_GD_UL)'
         write(10,*)'Value of status from he5_gddeforigin ',
     1status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefdim
c
      write(10,27)
      write(10,*)'Testing gddefdim... '
      write(10,*)'=================='
      write(*,*)'Testing gddefdim... '
      write(*,*)'=================='
      status = he5_gddefdim(gdid2, 'TestDim1', 40)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddefdim(gdid2, "TestDim1", 40)'
         write(10,*)'Value returned by he5_gddefdim ', status
         write(*,*)'status = he5_gddefdim(gdid2, "TestDim1", 40)'
         write(*,*)'Value returned by he5_gddefdim ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefdim(gdid2, 'TestDim2', 25)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddefdim(gdid2, "TestDim2", 25)'
         write(10,*)'Value returned by he5_gddefdim ', status
         write(*,*)'status = he5_gddefdim(gdid2, "TestDim2", 25)'
         write(*,*)'Value returned by he5_gddefdim ', status
      endif
      write(10,*)' '
      write(*,*)' '


      status = he5_gddefdim(gdid_utm, 'Conduction', 250)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status=he5_gddefdim(gdid_utm,"Conduction",250)'
         write(10,*)'Returned value from he5_gddefdim ',status
         write(*,*)'status=he5_gddefdim(gdid_utm,"Conduction",250)'
         write(*,*)'Returned value from he5_gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefdim(gdid_utm,'Timedim',4800)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddefdim(gdid_utm,"Timedim",4800)'
         write(10,*)'Status returned by call to he5_gddefdim ',status
         write(*,*)'status = he5_gddefdim(gdid_utm,"Timedim",4800)'
         write(*,*)'Status returned by call to he5_gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefdim(gdid_utm,'Hghtdim',80)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = he5_gddefdim(gdid_utm,"Hghtdim",80)'
        write(10,*)'Status returned by call to he5_gddefdim ',status
        write(*,*)'status = he5_gddefdim(gdid_utm,"Hghtdim",80)'
        write(*,*)'Status returned by call to he5_gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefdim(gdid_utm,'Convection',60)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define dimension Convection '
        write(10,*)'status = he5_gddefdim(gdid_utm,"Convection",60)'
        write(10,*)'Status returned by call to he5_gddefdim ',status
        write(*,*)'Define dimension Convection '
        write(*,*)'status = he5_gddefdim(gdid_utm,"Convection",60)'
        write(*,*)'Status returned by call to he5_gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddetach
c
      write(10,27)
      write(10,*)'Testing gddetach... '
      write(10,*)'=================='
      write(*,*)'Testing gddetach... '
      write(*,*)'=================='
      status = he5_gddetach(gdid2)
      if(status .lt. zero) then
         write(*,231)
         write(10,231)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid2)'
         write(10,*)'Value returned by he5_gddetach ', status
         write(*,*)'status = he5_gddetach(gdid2)'
         write(*,*)'Value returned by he5_gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid_utm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Returned value from he5_gddetach ', status
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Returned value from he5_gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '
 
c Test Case -- gdattach
c
      write(10,27)
      write(10,*)'Testing gdattach... '
      write(10,*)'=================='
      write(*,*)'Testing gdattach... '
      write(*,*)'=================='
      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if(gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(10,*)'Handle returned from he5_gdattach ', gdid_utm
         write(*,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(*,*)'Handle returned from he5_gdattach ', gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

      gdid2 = he5_gdattach(gdfid2, 'UTMGrid2')
      if(gdid2 .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid2 = he5_gdattach(gdfid2, "UTMGrid2")'
         write(10,*)'Value returned by he5_gdattach ', gdid2
         write(*,*)'gdid2 = he5_gdattach(gdfid2, "UTMGrid2")'
         write(*,*)'Value returned by he5_gdattach ', gdid2
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeffld
c
      write(10,27)
      write(10,*)'Testing gddeffld... '
      write(10,*)'=================='
      write(*,*)'Testing gddeffld... '
      write(*,*)'=================='
      status=he5_gddeffld(gdid2,"tempfield","TestDim2,TestDim1","",
     1HE5T_NATIVE_FLOAT, HE5_HDFE_NOMERGE)
      if(status .lt. zero) then
         write(*,231)
         write(10,231)
        
      else 
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "tempfield"'
        write(10,*)'status=he5_gddeffld(gdid2,"tempfield",
     1"TestDim2,TestDim1","",HE5T_NATIVE_FLOAT,HE5_HDFE_NOMERGE)'
        write(10,*)'Value returned by he5_gddeffld ', status
        write(*,*)'Define: "tempfield"'
        write(*,*)'status=he5_gddeffld(gdid2,"tempfield",
     1"TestDim2,TestDim1","",HE5T_NATIVE_FLOAT,HE5_HDFE_NOMERGE)'
        write(*,*)'Value returned by he5_gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status=he5_gddeffld(gdid_utm,'Time','Timedim',"",
     1HE5T_NATIVE_DOUBLE, HE5_HDFE_NOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
        write(*,*)' '
        write(*,240)
        write(10,*)' '
        write(10,240)
        write(10,*)' Define field Time'
        write(10,*)'status=he5_gddeffld(gdid_utm,"Time","Timedim","",
     1HE5T_NATIVE_DOUBLE,HE5_HDFE_NOMERGE)'
        write(10,*)'Status returned by call to he5_gddeffld ',status
        write(*,*)' Define field Time'
        write(*,*)'status=he5_gddeffld(gdid_utm,"Time","Timedim","",
     1HE5T_NATIVE_DOUBLE,HE5_HDFE_NOMERGE)'
        write(*,*)'Status returned by call to he5_gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status=he5_gddeffld(gdid_utm,'Height','Hghtdim',"",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_NOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
        write(*,*)' '
        write(*,240)
        write(10,*)' '
        write(10,240)
        write(10,*)' Define field Height'
        write(10,*)'status=he5_gddeffld(gdid_utm,"Height","Hghtdim","",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_NOMERGE)'
        write(10,*)'Status returned by call to he5_gddeffld ',status
        write(*,*)' Define field Height'
        write(*,*)'status=he5_gddeffld(gdid_utm,"Height","Hghtdim","",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_NOMERGE)'
        write(*,*)'Status returned by call to he5_gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeftle
c
      write(10,27)
      write(10,*)'Testing gddeftle... '
      write(10,*)'=================='
      write(*,*)'Testing gddeftle... '
      write(*,*)'=================='

      status = he5_gddeftle(gdid_utm,HE5_HDFE_TILE,2,tiledims)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define tiling dimensions '
        write(10,*)'status = he5_gddeftle(gdid_utm,
     1HE5_HDFE_TILE,2,tiledims)'
        write(10,*)'Status returned by call to he5_gddeftle ',status
        write(*,*)'Status returned by call to he5_gddeftle ',status
        write(*,*)'status = he5_gddeftle(gdid_utm,
     1HE5_HDFE_TILE,2,tiledims)'
        write(*,*)'Define tiling dimensions '
      endif
      write(10,*)' '
      write(*,*)' '

      status=he5_gddeffld(gdid_utm,'SideB','YDim,Convection',"",
     1HE5T_NATIVE_INT,HE5_HDFE_NOMERGE)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define field that will be tiled '
        write(10,*)'status=he5_gddeffld(gdid_utm,"SideB",
     1"YDim,Convection","",HE5T_NATIVE_INT,HE5_HDFE_NOMERGE)'
        write(10,*)'Status returned by call to he5_gddeffld ',status
        write(*,*)'Define field that will be tiled '
        write(*,*)'status=he5_gddeffld(gdid_utm,"SideB",
     1"YDim,Convection","",HE5T_NATIVE_INT,HE5_HDFE_NOMERGE)'
        write(*,*)'Status returned by call to he5_gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid_utm)
      if (status .lt. zero) then 
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Returned value from he5_gddetach ', status
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Returned value from he5_gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if (gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gdattach(gdfid,"UTMGrid")'
         write(10,*)'Returned value from he5_gdattach ', status
         write(*,*)'status = he5_gddetach(gdfid,"UTMGrid")'
         write(*,*)'Returned value from he5_gdattach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status=he5_gddeffld(gdid_utm,'Grounding','Conduction',"",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Define: "Grounding"'                  
         write(10,*)'status=he5_gddeffld(gdid_utm,"Grounding",
     1"Conduction","",HE5T_NATIVE_FLOAT,HDF_NOMERGE)'
         write(10,*)'Value returned by he5_gddeffld ', status
         write(*,*)'Define: "Grounding"'                  
         write(*,*)'status=he5_gddeffld(gdid_utm,"Grounding",
     1"Conduction","",HE5T_NATIVE_FLOAT,HDF_NOMERGE)'
         write(*,*)'Value returned by he5_gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefcomp
c
      write(10,27)
      write(10,*)'Testing gddefcomp... '
      write(10,*)'=================='
      write(*,*)'Testing gddefcomp... '
      write(*,*)'=================='

      tiledims(1) = 16
      tiledims(2) = 15
      status = he5_gddeftle(gdid_utm,HE5_HDFE_TILE,2,tiledims)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'Setup Tiling dimensions '
         write(*,*)'Required when using compression'
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefcomp(gdid_utm,
     1HE5_HDFE_COMP_DEFLATE, compparm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Setup compression mode'
        write(10,*)'status = he5_gddefcomp(gdid_utm,
     1HE5_HDFE_COMP_DEFLATE,compparm)'
        write(10,*)'Status returned by call to he5_gddefcomp ',status
        write(*,*)'Setup compression mode'
        write(*,*)'status = he5_gddefcomp(gdid_utm,
     1HE5_HDFE_COMP_DEFLATE, compparm)'
        write(*,*)'Status returned by call to he5_gddefcomp ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddeffld(gdid_utm,"Voltage","YDim,XDim"," ",
     1HE5T_NATIVE_FLOAT, HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "Voltage"'
        write(10,*)'status = he5_gddeffld(gdid_utm,"Voltage",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT, HE5_HDFE_AUTOMERGE)'
        write(10,*)'Value returned from he5_gddeffld ', status
        write(*,*)'Define: "Voltage"'
        write(*,*)'status = he5_gddeffld(gdid_utm,"Voltage",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT, HE5_HDFE_AUTOMERGE)'
        write(*,*)'Value returned from he5_gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdsetfill
c
      write(10,27)
      write(10,*)'Testing gdsetfill... '
      write(10,*)'=================='
      write(*,*)'Testing gdsetfill... '
      write(*,*)'=================='

      status = he5_gdsetfill(gdid_utm, "Drift", 
     1HE5T_NATIVE_FLOAT, fillvalue)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Testing gdsetfill'
         write(10,*)'status = he5_gdsetfill(gdid_utm, "Drift", 
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(10,*)'Returned from he5_gdsetfill ', status
         write(*,*)'Testing gdsetfill'
         write(*,*)'status = he5_gdsetfill(gdid_utm, "Drift", 
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(*,*)'Returned from he5_gdsetfill ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status=he5_gddeffld(gdid_utm,"Drift","YDim,XDim"," ",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "Drift"'      
        write(10,*)'status=he5_gddeffld(gdid_utm,"Drift",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
        write(10,*)'Value returned from he5_gddeffld ', status
        write(*,*)'Define: "Drift"'      
        write(*,*)'status=he5_gddeffld(gdid_utm,"Drift",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
        write(*,*)'Value returned from he5_gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status=he5_gddeffld(gdid_utm,"Impedance","YDim,XDim"," ",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Define: "Impedance"'            
         write(10,*)'status=he5_gddeffld(gdid_utm,"Impedance",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
         write(10,*)'Value returned from he5_gddeffld ', status
         write(*,*)'Define: "Impedance"'            
         write(*,*)'status=he5_gddeffld(gdid_utm,"Impedance",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
         write(*,*)'Value returned from he5_gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '


      status = he5_gddetach(gdid_utm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Returned value from he5_gddetach ', status
         write(*,*)'Returned value from he5_gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if(gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(10,*)'Handle returned from he5_gdattach ', gdid_utm
         write(*,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(*,*)'Handle returned from he5_gdattach ', gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdwrfld
c
      write(10,27)
      write(10,*)'Testing gdwrfld... '
      write(10,*)'=================='
      write(*,*)'Testing gdwrfld... '
      write(*,*)'=================='

      start(1) = 0
      start(2) = 0
      stride(1) = 1
      stride(2) = 1
      edge(1) = 80
      edge(2) = 60
      
      status = he5_gdwrfld(gdid_utm, "Voltage", start, stride, 
     1edge, utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Voltage '
        write(10,*)'status=he5_gdwrfld(gdid_utm,"Voltage",start,
     1stride,edge,utmray)'
        write(10,*)'Status returned by he5_gdwrfield ', status
        write(*,*)'Write to field Voltage '
        write(*,*)'status=he5_gdwrfld(gdid_utm,"Voltage",start,
     1stride,edge,utmray)'
        write(*,*)'Status returned by he5_gdwrfield ', status
      endif
      write(10,*)' '
      write(*,*)' '


      start(1) = 10
      start(2) = 10
      edge(1) = 10
      edge(2) = 10
      status = he5_gdwrfld(gdid_utm, 'Drift', start,stride,
     1edge,utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Drift '
        write(10,*)'status = he5_gdwrfld(gdid_utm,"Drift",start,
     1stride,edge,utmray)'
        write(10,*)'Status returned from he5_gdwrfld ', status
        write(*,*)'Write to field Drift '
        write(*,*)'status = he5_gdwrfld(gdid_utm,"Drift",start,
     1stride,edge,utmray)'
        write(*,*)'Status returned from he5_gdwrfld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      start(1) = 0
      start(2) = 0
      edge(1) = 80
      edge(2) = 60
      status = he5_gdwrfld(gdid_utm, 'Impedance', start,stride,
     1edge,utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Impedance '
        write(10,*)'status=he5_gdwrfld(gdid_utm,"Impedance",start,
     1stride,edge,utmray)'
        write(10,*)'Returned from he5_gdwrfld ', status
        write(*,*)'Write to field Impedance '
        write(*,*)'status=he5_gdwrfld(gdid_utm,"Impedance",start,
     1stride,edge,utmray)'
        write(*,*)'Returned from he5_gdwrfld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=4800
      status=he5_gdwrfld(gdid_utm,'Time',start1d,stride1d,
     1edge1d,utmtmeray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Time '
        write(10,*)'status=he5_gdwrfld(gdid_utm,"Time",start1d,
     1stride1d,edge1d,utmtmeray)'
        write(10,*)'Status returned by call to he5_gdwrfld ',status
        write(*,*)'Write to field Time '
        write(*,*)'status=he5_gdwrfld(gdid_utm,"Time",start1d,
     1stride1d,edge1d,utmtmeray)'
        write(*,*)'Status returned by call to he5_gdwrfld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=80
      status=he5_gdwrfld(gdid_utm,'Height',start1d,stride1d,
     1edge1d,utmhght)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Height '
        write(10,*)'status=he5_gdwrfld(gdid_utm,"Height",start1d,
     1stride1d,edge1d,utmhght)'
        write(10,*)'Status returned by call to he5_gdwrfld ',status
        write(*,*)'Write to field Height '
        write(*,*)'status=he5_gdwrfld(gdid_utm,"Height",start1d,
     1stride1d,edge1d,utmhght)'
        write(*,*)'Status returned by call to he5_gdwrfld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=250
      status=he5_gdwrfld(gdid_utm,'Grounding',start1d,stride1d,
     1edge1d,ray3)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Grounding '
        write(10,*)'status=he5_gdwrfld(gdid_utm,"Grounding",start1d,
     1stride1d,edge1d,ray3)'
        write(10,*)'Value returned by he5_gdwrfld ', status
        write(*,*)'Write to field Grounding '
        write(*,*)'status=he5_gdwrfld(gdid_utm,"Grounding",start1d,
     1stride1d,edge1d,ray3)'
        write(*,*)'Value returned by he5_gdwrfld ', status
      endif
        write(10,*)' '
        write(*,*)' '

      status = he5_gddetach(gdid_utm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Value of status returned by he5_gddetach ',
     1status
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Value of status returned by he5_gddetach ',
     1status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(10,*)'Grid id returned by he5_gdattach ',gdid_utm
         write(*,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(*,*)'Grid id returned by he5_gdattach ',gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdwrattr
c
      write(10,27)
      write(10,*)'Testing gdwrattr... Global attribute '
      write(10,*)'==================================== '
      write(*,*)'Testing gdwrattr... Global attribute '
      write(*,*)'==================================== '

      status = he5_gdwrattr(gdid_utm, 'Resistance', 
     1HE5T_NATIVE_INT, 4, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status=he5_gdwrattr(gdid_utm,"Resistance",
     1HE5T_NATIVE_INT, 4, attr)'
         write(10,*)'Returned from he5_gdwrattr ', status
         write(*,*)'status=he5_gdwrattr(gdid_utm,"Resistance",
     1HE5T_NATIVE_FLOAT, 4, attr)'
         write(*,*)'Returned from he5_gdwrattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdwrgattr
c
      write(10,27)
      write(10,*)'Testing gdwrgattr... Group attribute '
      write(10,*)'==================================== '
      write(*,*)'Testing gdwrgattr... Group attribute '
      write(*,*)'==================================== '

      attr(1) = 22
      attr(2) = 44
      attr(3) = 66
      attr(4) = 88
      status = he5_gdwrgattr(gdid_utm, 'group', 
     1HE5T_NATIVE_INT, 4, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status=he5_gdwrgattr(gdid_utm,"group",
     1HE5T_NATIVE_INT, 4, attr)'
         write(10,*)'Returned from he5_gdwrgattr ', status
         write(*,*)'status=he5_gdwrgattr(gdid_utm,"group",
     1HE5T_NATIVE_INT, 4, attr)'
         write(*,*)'Returned from he5_gdwrgattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdwrlattr
c
      write(10,27)
      write(10,*)'Testing gdwrlattr... Local attribute '
      write(10,*)'==================================== '
      write(*,*)'Testing gdwrlattr... Local attribute '
      write(*,*)'==================================== '

      attr(1) = 12
      attr(2) = 34
      attr(3) = 56
      attr(4) = 78
      status = he5_gdwrlattr(gdid_utm,"Grounding", "local", 
     1HE5T_NATIVE_INT, 4, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status=he5_gdwrlattr(gdid_utm,"Grounding",
     1"local",HE5T_NATIVE_INT, 4, attr)'
         write(10,*)'Returned from he5_gdwrlattr ', status
         write(*,*)'status=he5_gdwrlattr(gdid_utm,"Grounding",
     1"local",HE5T_NATIVE_INT, 4, attr)'
         write(*,*)'Returned from he5_gdwrlattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid_utm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Returned from he5_gddetach ', status
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Returned from he5_gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid2)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid2)'
         write(10,*)'Value returned by he5_gddetach ', status
         write(*,*)'status = he5_gddetach(gdid2)'
         write(*,*)'Value returned by he5_gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdclose
c
      write(10,27)
      write(10,*)'Testing gdclose... '
      write(10,*)'=================='
      write(*,*)'Testing gdclose... '
      write(*,*)'=================='

      status = he5_gdclose(gdfid2)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gdclose(gdfid2)'
         write(10,*)'Value returned by he5_gdclose ', status
         write(*,*)'status = he5_gdclose(gdfid2)'
         write(*,*)'Value returned by he5_gdclose ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdclose(gdfid)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gdclose(gdfid)'
         write(10,*)'Returned from he5_gdclose ', status
         write(*,*)'status = he5_gdclose(gdfid)'
         write(*,*)'Returned from he5_gdclose ', status
      endif
      write(10,*)' '
      write(*,*)' '

      
      gdfid = he5_gdopen('gridf32.he5',HE5F_ACC_RDWR)
      if (gdfid .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'gdfid = he5_gdopen("gridf32.he5",HE5F_ACC_RDWR)'
         write(10,*)'gdfid = he5_gdopen("gridf32.he5",HE5F_ACC_RDWR)'
         write(*,*)'Grid file id returned by he5_gdopen ',gdfid
         write(10,*)'Grid file id returned by he5_gdopen ',gdfid
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if (gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(10,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(*,*)'Grid id returned by he5_gdattach ',gdid_utm
         write(10,*)'Grid id returned by he5_gdattach ',gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdinqgrid
c
      write(10,27)
      write(10,*)'Testing gdinqgrid... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqgrid... '
      write(*,*)'=================='

      lstatus = he5_gdinqgrid('gridf32.he5',grdnames,strbufsize)
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus=he5_gdinqgrid("gridf32.he5",
     1grdnames,strbufsize)'
         write(*,*)'Names of grids ',grdnames
         write(*,*)'Number of grids ',lstatus
         write(*,*)'Size of names of grids ',strbufsize
         write(10,*)'lstatus=he5_gdinqgrid("gridf32.he5",
     1grdnames,strbufsize)'
         write(10,*)'Names of grids ',grdnames
         write(10,*)'Number of grids ',lstatus
         write(10,*)'Size of names of grids ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdorginfo
c
      write(10,27)
      write(10,*)'Testing gdorginfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdorginfo... '
      write(*,*)'=================='

      status = he5_gdorginfo(gdid_utm, orgcode)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = he5_gdorginfo(gdid_utm, orgcode)'
         write(10,*)'lstatus = he5_gdorginfo(gdid_utm, orgcode)'
         write(*,*)'Value returned by he5_gdorginfo ',status
         write(10,*)'Value returned by he5_gdorginfo ',status
         write(*,*)'Origin code value ',orgcode
         write(10,*)'Origin code value ',orgcode
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdpreginfo
c
      write(10,27)
      write(10,*)'Testing gdpreginfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdpreginfo... '
      write(*,*)'=================='

      status = he5_gdpreginfo(gdid_utm, pixregcode)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdpreginfo(gdid_utm, pixregcode)'
         write(10,*)'status = he5_gdpreginfo(gdid_utm, pixregcode)'
         write(*,*)'Value returned by he5_gdpreginfo ',status
         write(10,*)'Value returned by he5_gdpreginfo ',status
         write(*,*)'Pixel reg code ',pixregcode
         write(10,*)'Pixel reg code ',pixregcode
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdinqdims
c
      write(10,27)
      write(10,*)'Testing gdinqdims... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqdims... '
      write(*,*)'=================='

      status = he5_gdinqdims(gdid_utm, dimname, dims)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdinqdims(gdid_utm, dimname, dims)'
         write(*,*)'Number of dimensions ',status
         write(*,*)'Dimensions in grid UTM ',dimname
         write(*,*)'Size of dimensions '
         write(10,*)'status = he5_gdinqdims(gdid_utm, dimname, dims)'
         write(10,*)'Number of dimensions ',status
         write(10,*)'Dimensions in grid UTM ',dimname
         write(10,*)'Size of dimensions '
         do 130 i=1,status
            write(*,*)' ',dims(i)
            write(10,*)' ',dims(i)
 130     continue
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddiminfo
c
      write(10,27)
      write(10,*)'Testing gddiminfo... '
      write(10,*)'=================='
      write(*,*)'Testing gddiminfo... '
      write(*,*)'=================='

      lstatus = he5_gddiminfo(gdid_utm, 'Conduction')
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = he5_gddiminfo(gdid_utm, "Conduction")'
         write(*,*)'Size of dimension Conduction ',lstatus
         write(10,*)'lstatus = he5_gddiminfo(gdid_utm, "Conduction")'
         write(10,*)'Size of dimension Conduction ',lstatus
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgridinfo
c
      write(10,27)
      write(10,*)'Testing gdgridinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdgridinfo... '
      write(*,*)'=================='

      status=he5_gdgridinfo(gdid_utm,xdimsize,ydimsize,
     1upleftpt,lowrtpt)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status=he5_gdgridinfo(gdid_utm,xdimsize,
     1ydimsize,upleftpt,lowrtpt)'
         write(*,*)'Status returned by he5_gdgridinfo ',status
         write(*,11)'X dim size ',xdimsize, ' Y dim size ',ydimsize
         write(*,12)'Upper left pt ',upleftpt(1),' ',upleftpt(2)
         write(*,12)'Lower right pt ',lowrtpt(1),' ',lowrtpt(2)
         write(10,*)'status=he5_gdgridinfo(gdid_utm,xdimsize,
     1ydimsize,upleftpt,lowrtpt)'
         write(10,*)'Value returned by he5_gdgridinfo ',status
         write(10,*)'X dim size ',xdimsize, ' Y dim size ',ydimsize
         write(10,*)'Upper left pt ',upleftpt(1),upleftpt(2)
         write(10,*)'Lower right pt ',lowrtpt(1),lowrtpt(2)
      endif
      write(10,*)' '
      write(*,*)' '
   11 format(a,i2,a,i2)
   12 format(a,f14.5,a,f14.5)

c Test Case -- gdprojinfo
c
      write(10,27)
      write(10,*)'Testing gdprojinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdprojinfo... '
      write(*,*)'=================='

      status = he5_gdprojinfo(gdid_utm,pcode,zcode,scode,pparm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status=he5_gdprojinfo(gdid_utm,pcode,zcode,
     1scode,pparm)'
         write(*,*)'Status returned by he5_gdprojinfo ',status
         write(*,*)'Projection code ',pcode, ' Zone code ',zcode
         write(*,*)'Sphere code ',scode
         write(10,*)'status=he5_gdprojinfo(gdid_utm,pcode,zcode,
     1scode,pparm)'
         write(10,*)'Value returned by he5_gdprojinfo ',status
         write(10,*)'Projection code ',pcode, ' Zone code ',zcode
         write(10,*)'Sphere code ',scode
         do 140 i=1,16
            write(*,55)' ',pparm(i)
            write(10,55)' ',pparm(i)
 140     continue
      endif
   55 format(a,f5.2)
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdcompinfo
c
      write(10,27)
      write(10,*)'Testing gdcompinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdcompinfo... '
      write(*,*)'=================='

      status = he5_gdcompinfo(gdid_utm,'Voltage',
     1compcodestring,compparm)
      if (status .lt. zero) then
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status=he5_gdcompinfo(gdid_utm,"Voltage",
     1compcode,compparm)'
        write(10,*)'Compression info for field Voltage'
        write(10,*)'Comp code ',compcodestring
        write(10,*)'Compression parameters ',compparm
        write(*,*)'status=he5_gdcompinfo(gdid_utm,"Voltage",
     1compcode,compparm)'
        write(*,*)'Compression info for field Voltage'
        write(*,*)'Comp code ',compcodestring
        write(*,*)'Compression parameters ',compparm
      endif

c Test Case -- gdinqflds
c
      write(10,27)
      write(10,*)'Testing gdinqflds... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqflds... '
      write(*,*)'=================='

      nflds = he5_gdinqflds(gdid_utm,fldlist,rnk,numtype)
      if (nflds .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'nflds = he5_gdinqflds(gdid_utm,fldlist,
     1rnk,numtype)'
         write(*,*)'Number of fields ',nflds
         write(10,*)'nflds = he5_gdinqflds(gdid_utm,fldlist,
     1rnk,numtype)'
         write(10,*)'Number of fields ',nflds
         if (nflds .ne. 0) then
            write(*,*)'Fields ',fldlist
            write(10,*)'Fields ',fldlist
            do 150 i=1,nflds
               write(*,*)'Rank and type ',rnk(i), ' ', numtype(i)
               write(10,*)'Rank and type ',rnk(i), ' ', numtype(i)
  150       continue
         endif
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdfldinfo
c
      write(10,27)
      write(10,*)'Testing gdfldinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdfldinfo... '
      write(*,*)'=================='

      status=he5_gdfldinfo(gdid_utm,'Drift',rnk,dims,numtype,
     1dimname,maxdimname)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status=he5_gdfldinfo(gdid_utm,"Drift",rnk,dims, 
     1numtype, dimname, maxdimname)'
         write(*,*)'Value returned by he5_gdfldinfo for field 
     1Drift ',status
         write(*,*)'Drift rank ',rnk(1)
         write(*,*)'Dimensions  ',dims(1),' ',dims(2)
         write(*,*)'Number type of field ',numtype(1)
         write(*,*)'Dimension names ',dimname
         write(10,*)'status=he5_gdfldinfo(gdid_utm,"Drift",rnk,dims, 
     1numtype, dimname, maxdimname)'

         write(10,*)'Value returned by he5_gdfldinfo for field 
     1Drift ',status
         write(10,*)'Drift rank ',rnk(1)
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdrdfld
c
      write(10,27)
      write(10,*)'Testing gdrdfld... '
      write(10,*)'=================='
      write(*,*)'Testing gdrdfld... '
      write(*,*)'=================='

      start(1) = 0
      start(2) = 0
      stride(1) = 1
      stride(2) = 1
      edge(1) = 80
      edge(2) = 60
      status = he5_gdrdfld(gdid_utm,'Drift',start,stride,edge,
     1tempray)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdrdfld(gdid_utm,"Drift",start,
     1stride,edge,tempray)'
         write(*,*)'Value returned by he5_gdrdfld ',status
         write(10,*)'status = he5_gdrdfld(gdid_utm,"Drift",start,
     1stride,edge,tempray)'
         write(10,*)'Value returned by he5_gdrdfld ',status
         do 65 ii=1,6
           do 66 i=1,5
              write(10,*)'Field value at ',ii,' ',i,'  ',tempray(ii,i)
              write(*,*)'Field value at ',ii,' ',i,'  ',tempray(ii,i)
   66      continue
   65   continue
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdnentries
c
      write(10,27)
      write(10,*)'Testing gdnentries... '
      write(10,*)'=================='
      write(*,*)'Testing gdnentries... '
      write(*,*)'=================='

      n = he5_gdnentries(gdid_utm, HE5_HDFE_NENTDIM, strbufsize)
      if (n .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'n = he5_gdnentries(gdid_utm,
     1HE5_HDFE_NENTDIM, strbufsize)'
         write(*,*)'Number of dimensions ', n
         write(*,*)'Size of Dimension string ',strbufsize
         write(10,*)'n = he5_gdnentries(gdid_utm, 
     1HE5_HDFE_NENTDIM, strbufsize)'
         write(10,*)'Number of dimensions ', n
         write(10,*)'Size of Dimension string ',strbufsize
      endif

      n = he5_gdnentries(gdid_utm,HE5_HDFE_NENTDFLD,strbufsize)
      if (n .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'n = he5_gdnentries(gdid_utm,HE5_HDFE_NENTDFLD,
     1strbufsize)'
         write(*,*)'Number of data fields ',n
         write(*,*)'Size of Field string ',strbufsize
         write(10,*)'n = he5_gdnentries(gdid_utm,HE5_HDFE_NENTDFLD,
     1strbufsize)'
         write(10,*)'Number of data fields ',n
         write(10,*)'Size of Field string ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdattrinfo
c
      write(10,27)
      write(10,*)'Testing gdattrinfo, Global attribute'
      write(10,*)'===================================='
      write(*,*)'Testing gdattrinfo, Global attribute'
      write(*,*)'===================================='

      status = he5_gdattrinfo(gdid_utm,'Resistance',ntype,count)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status=he5_gdattrinfo(gdid_utm,"Resistance",
     1ntype,count)'
         write(*,*)'Value returned by he5_gdattrinfo ',status
         write(*,*)'Number type of attribute ',ntype
         write(*,*)'Number of total bytes in attribute ',count
         write(10,*)'status=he5_gdattrinfo(gdid_utm,"Resistance",
     1ntype,count)'
         write(10,*)'Value returned by he5_gdattrinfo ',status
         write(10,*)'Number type of attribute ',ntype
         write(10,*)'Number of total bytes in attribute ',count
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgatinfo
c
      write(10,27)
      write(10,*)'Testing gdgatinfo, Group attribute'
      write(10,*)'===================================='
      write(*,*)'Testing gdgatinfo, Group attribute'
      write(*,*)'===================================='

      status = he5_gdgatinfo(gdid_utm,'group',ntype,count)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdgatinfo(gdid_utm,"group",
     1ntype,count)'
         write(*,*)'Value returned by he5_gdgatinfo ',status
         write(*,*)'Number type of attribute ',ntype
         write(*,*)'Number of total bytes in attribute ',count
         write(10,*)'status = he5_gdgatinfo(gdid_utm,"group",
     1ntype,count)'
         write(10,*)'Value returned by he5_gdgatinfo ',status
         write(10,*)'Number type of attribute ',ntype
         write(10,*)'Number of total bytes in attribute ',count
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdlatinfo
c
      write(10,27)
      write(10,*)'Testing gdlatinfo, Local attribute'
      write(10,*)'===================================='
      write(*,*)'Testing gdlatinfo, Local attribute'
      write(*,*)'===================================='

      status = he5_gdlatinfo(gdid_utm,"Grounding","local",ntype,count)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdlatinfo(gdid_utm,"Grounding",
     1"local",ntype,count)'
         write(*,*)'Value returned by he5_gdlatinfo ',status
         write(*,*)'Number type of attribute ',ntype
         write(*,*)'Number of total bytes in attribute ',count
         write(10,*)'status = he5_gdlatinfo(gdid_utm,"Grounding",
     1"local",ntype,count)'
         write(10,*)'Value returned by he5_gdgatinfo ',status
         write(10,*)'Number type of attribute ',ntype
         write(10,*)'Number of total bytes in attribute ',count
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdrdattr
c
      write(10,27)
      write(10,*)'Testing gdrdattr, Global attribute'
      write(10,*)'=================================='
      write(*,*)'Testing gdrdattr, Global attribute'
      write(*,*)'=================================='

      status = he5_gdrdattr(gdid_utm,'Resistance',iattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status = he5_gdrdattr(gdid_utm,"Resistance",iattr)'
        write(*,*)'Value returned by he5_gdrdattr ',status
        write(10,*)'status = he5_gdrdattr(gdid_utm,"Resistance",iattr)'
        write(10,*)'Value returned by he5_gdrdattr ',status
        do 67 i=1,count
           write(10,*)'Attribute value  ',iattr(i)
           write(*,*)'Attribute value   ',iattr(i)
   67   continue
        
      endif
      write(10,*)' '
      write(*,*)' '
  
c Test Case -- gdrdgattr
c
      write(10,27)
      write(10,*)'Testing gdrdgattr, Group attribute '
      write(10,*)'=================================='
      write(*,*)'Testing gdrdgattr, Group attribute'
      write(*,*)'================================='

      status = he5_gdrdgattr(gdid_utm,'group',gattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status = he5_gdrdgattr(gdid_utm,"group",gattr)'
        write(*,*)'Value returned by he5_gdrdgattr ',status
        write(10,*)'status = he5_gdrdgattr(gdid_utm,"group",gattr)'
        write(10,*)'Value returned by he5_gdrdgattr ',status
        do 68 i=1,count
           write(10,*)'Attribute value  ',gattr(i)
           write(*,*)'Attribute value   ',gattr(i)
   68   continue
        
      endif
      write(10,*)' '
      write(*,*)' '
  
c Test Case -- gdinqdatatype
c
      write(10,27)
      write(10,*)'Testing gdinqdatatype '
      write(10,*)'====================='
      write(*,*)'Testing gdinqdatatype'
      write(*,*)'====================='

      status = he5_gdinqdatatype(gdid_utm,"Grounding","local",
     1HE5_HDFE_LOCATTRGROUP,dtype,classid,order,size)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
        write(*,*)' '
        write(*,240)
        write(10,*)' '
        write(10,240)
         write(*,*)'status = he5_gdinqdatatype(gdid_utm,"Grounding",
     1"local",HE5_HDFE_LOCATTRGROUP,dtype,classid,order,size)'
         write(*,*)'Data type of attribute ',dtype
         write(*,*)'Class id of attribute ',classid
         write(*,*)'Order of attribute ',order
         write(*,*)'Size of attribute ',size
         write(10,*)'status =he5_gdinqdatatype(gdid_utm,"Grounding",
     1"local",HE5_HDFE_LOCATTRGROUP,dtype,classid,order,size)'
         write(10,*)'Data type of attribute ',dtype
         write(10,*)'Class id of attribute ',classid
         write(10,*)'Order of attribute ',order
         write(10,*)'Size of attribute ',size
      endif
      write(10,*)' '
      write(*,*)' '
c Test Case -- gdrdlattr
c
      write(10,27)
      write(10,*)'Testing gdrdlattr, Local attribute '
      write(10,*)'=================================='
      write(*,*)'Testing gdrdlattr, Local attribute'
      write(*,*)'================================='

      status = he5_gdrdlattr(gdid_utm,"Grounding","local",lattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status=he5_gdrdlattr(gdid_utm,"Grounding",
     1"local",lattr)'
        write(*,*)'Value returned by he5_gdrdlattr ',status
        write(10,*)'status=he5_gdrdlattr(gdid_utm,"Grounding",
     1"local",lattr)'
        write(10,*)'Value returned by he5_gdrdlattr ',status
        do 69 i=1,count
           write(10,*)'Attribute value  ',lattr(i)
           write(*,*)'Attribute value   ',lattr(i)
   69   continue
        
      endif
      write(10,*)' '
      write(*,*)' '
  
c Test Case -- gdinqattrs
c
      write(10,27)
      write(10,*)'Testing gdinqattrs, Global attribute'
      write(10,*)'===================================='
      write(*,*)'Testing gdinqattrs, Global attribute'
      write(*,*)'===================================='

      lstatus = he5_gdinqattrs(gdid_utm, attrlist,strbufsize)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = he5_gdinqattrs(gdid_utm, 
     1attrlist,strbufsize)'
        write(*,*)'Value returned by he5_gdinqattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(*,*)'Length of attrlist in bytes ',strbufsize
        write(10,*)'lstatus = he5_gdinqattrs(gdid_utm, 
     1attrlist,strbufsize)'
        write(10,*)'Value returned by he5_gdinqattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
        write(10,*)'Length of attrlist in bytes ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdinqgattrs
c
      write(10,27)
      write(10,*)'Testing gdinqgattrs, Group attribute'
      write(10,*)'===================================='
      write(*,*)'Testing gdinqgattrs, Group attribute'
      write(*,*)'===================================='

      lstatus = he5_gdinqgattrs(gdid_utm, attrlist,strbufsize)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = he5_gdinqgattrs(gdid_utm, 
     1attrlist,strbufsize)'
        write(*,*)'Value returned by he5_gdinqgattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(*,*)'Length of attrlist in bytes ',strbufsize
        write(10,*)'lstatus = he5_gdinqgattrs(gdid_utm,
     1attrlist,strbufsize)'
        write(10,*)'Value returned by he5_gdinqgattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
        write(10,*)'Length of attrlist in bytes ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdinqlattrs
c
      write(10,27)
      write(10,*)'Testing gdinqlattrs, Local attribute'
      write(10,*)'===================================='
      write(*,*)'Testing gdinqlattrs, Local attribute'
      write(*,*)'===================================='

      lstatus = he5_gdinqlattrs(gdid_utm,"Grounding",
     1attrlist,strbufsize)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = he5_gdinqlattrs(gdid_utm,"Grounding",
     1attrlist,strbufsize)'
        write(*,*)'Value returned by he5_gdinqlattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(*,*)'Length of attrlist in bytes ',strbufsize
        write(10,*)'lstatus = he5_gdinqlattrs(gdid_utm,"Grounding",
     1attrlist,strbufsize)'
        write(10,*)'Value returned by he5_gdinqlattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
        write(10,*)'Length of attrlist in bytes ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgetfill
c
      write(10,27)
      write(10,*)'Testing gdgetfill... '
      write(10,*)'=================='
      write(*,*)'Testing gdgetfill... '
      write(*,*)'=================='

      status = he5_gdgetfill(gdid_utm,'Drift',ifillv)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdgetfill(gdid_utm,"Drift",ifillv)'
         write(*,*)'Value returned by he5_gdgetfill ',status
         write(*,*)'Fill value ',ifillv
         write(10,*)'status = he5_gdgetfill(gdid_utm,"Drift",ifillv)'
         write(10,*)'Value returned by he5_gdgetfill ',status
         write(10,*)'Fill value ',ifillv
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefboxreg
c
      write(10,27)
      write(10,*)'Testing gddefboxreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddefboxreg... '
      write(*,*)'=================='

      corlon(1)=-126.0
      corlon(2)=-121.5
      corlat(1)=-70.0
      corlat(2)=-65.0

      regionid = he5_gddefboxreg(gdid_utm,corlon,corlat)
      if (regionid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'regionid = he5_gddefboxreg(gdid_utm,corlon,corlat)'
         write(*,*)'Region id returned by he5_gddefboxreg ',regionid
         write(10,*)'regionid = he5_gddefboxreg(gdid_utm,corlon,corlat)'
         write(10,*)'Region id returned by he5_gddefboxreg ',regionid
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdreginfo
c
      write(10,27)
      write(10,*)'Testing gdreginfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdreginfo... '
      write(*,*)'=================='
      status = he5_gdreginfo(gdid_utm,regionid,"Impedance",nt,rk,
     1dims,size,iuplft,ilrgt)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdreginfo(gdid_utm,regionid,
     1"Impedance",nt,rk,dims,size,iuplft,ilrgt)'
         write(*,*)'Value returned by he5_gdreginfo ',status
         write(*,*)'Number type of region ',nt
         write(*,*)'Rank of region ',rk
         write(*,*)'Size of region ',size
         write(*,11)'Dimensions of region',dims(1),' ',dims(2)
         write(*,12)'Upper left point of region ',
     1iuplft(1),' ',iuplft(2)
         write(*,12)'Lower right point of region ',ilrgt(1),' ',ilrgt(2)
         write(10,*)'status = he5_gdreginfo(gdid_utm,regionid,
     1"Impedance",nt,rk,dims,size,iuplft,ilrgt)'
         write(10,*)'Value returned by he5_gdreginfo ',status
         write(10,*)'Number type of region ',nt
         write(10,*)'Rank of region ',rk
         write(10,*)'Size of region ',size
         write(10,11)'Dimensions of region',dims(1),' ',dims(2)
         write(10,12)'Upper left point of region ',
     1iuplft(1),' ',iuplft(2)
         write(10,12)'Lower right point of region ',
     1ilrgt(1),' ',ilrgt(2)
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdextreg
c
      write(10,27)
      write(10,*)'Testing gdextreg... '
      write(10,*)'=================='
      write(*,*)'Testing gdextreg... '
      write(*,*)'=================='

      status = he5_gdextreg(gdid_utm,regionid,'Impedance',datbuf)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)

         write(*,*)'status=he5_gdextreg(gdid_utm,regionid,
     1"Impedance",datbuf)'
         write(*,*)'Value returned by he5_gdextreg ',status
         write(10,*)'status=he5_gdextreg(gdid_utm,
     1regionid,"Impedance",datbuf)'
         write(10,*)'Value returned by he5_gdextreg ',status
         do 175 i=100,150
            write(*,*)'Value of region ',datbuf(i)
            write(10,*)'Value of region ',datbuf(i)
  175    continue
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeftmeper
c
      write(10,27)
      write(10,*)'Testing gddeftmeper... '
      write(10,*)'=================='
      write(*,*)'Testing gddeftmeper... '
      write(*,*)'=================='

      periodid = he5_gddeftmeper(gdid_utm,
     1HE5_HDFE_NOPREVSUB,starttime,stoptime)
      if (periodid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'periodid = he5_gddeftmeper(gdid_utm,
     1HE5_HDFE_NOPREVSUB,starttime,stoptime)'
        write(10,*)'Define a time period '
        write(10,*)'Period id returned by he5_gddeftmeper ',periodid
        write(*,*)'periodid = he5_gddeftmeper(gdid_utm,
     1HE5_HDFE_NOPREVSUB,starttime,stoptime)'
        write(*,*)'Define a time period '
        write(*,*)'Period id returned by he5_gddeftmeper ',periodid
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefvrtreg
c
      write(10,27)
      write(10,*)'Testing gddefvrtreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddefvrtreg... '
      write(*,*)'=================='

      regionid = he5_gddefvrtreg(gdid_utm,
     1HE5_HDFE_NOPREVSUB,'Height',range)
      if (regionid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)

        write(10,*)'regionid = he5_gddefvrtreg(gdid_utm,
     1HE5_HDFE_NOPREVSUB,"Height",range)'
        write(10,*)'Define a vertical region '
        write(10,*)'Region id returned by he5_gddefvrtreg ',regionid
        write(*,*)'regionid = he5_gddefvrtreg(gdid_utm,
     1HE5_HDFE_NOPREVSUB,"Height",range)'
        write(*,*)'Define a vertical region '
        write(*,*)'Region id returned by he5_gddefvrtreg ',regionid
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddupreg
c
      write(10,27)
      write(10,*)'Testing gddupreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddupreg... '
      write(*,*)'=================='

      regionid2 = he5_gddupreg(regionid)
      if (regionid2 .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'regionid2 = he5_gddupreg(regionid)'
        write(10,*)'Generate a new region id '
        write(10,*)'New region id ',regionid2
        write(*,*)'regionid2 = he5_gddupreg(regionid)'
        write(*,*)'Generate a new region id '
        write(*,*)'New region id ',regionid2
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgetpix
c
      write(10,27)
      write(10,*)'Testing gdgetpix... '
      write(10,*)'=================='
      write(*,*)'Testing gdgetpix... '
      write(*,*)'=================='

      status = he5_gdgetpix(gdid_utm,5,lonval,latval,rowval,colval)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)

        write(10,*)'status=he5_gdgetpix(gdid_utm,5,lonval,
     1latval,rowval,colval)'
        write(10,*)'Retrieve pixel row. column values '
        write(*,*)'status = he5_gdgetpix(gdid_utm,5,lonval,latval,
     1rowval,colval)'
        write(*,*)'Retrieve pixel row. column values '
        do 37 i=1,5
           write(10,5)'Pixel position lon lat ',lonval(i),' ',
     1latval(i),' ','Row Column ',rowval(i),' ',colval(i) 
           write(*,5)'Pixel position lon lat ',lonval(i),' ',
     1latval(i),' ','Row Column ',rowval(i),' ',colval(i) 
   37   continue
      endif
    5 format(a,f6.1,a,f6.1,a,a,i2,a,i2)
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgetpixval
c
      write(10,27)
      write(10,*)'Testing gdgetpixval... '
      write(10,*)'=================='
      write(*,*)'Testing gdgetpixval... '
      write(*,*)'=================='

      lstatus = he5_gdgetpixval(gdid_utm,5,rowval,
     1colval,"Voltage",fldval)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'lstatus = he5_gdgetpixval(gdid_utm,5,rowval,colval,
     1"Voltage",fldval)'
        write(10,*)'Retrieve pixel values for specific locations '
        write(*,*)'lstatus = he5_gdgetpixval(gdid_utm,5,rowval,colval,
     1"Voltage",fldval)'
        write(*,*)'Retrieve pixel values for specific locations '
        do 42 i=1,5
           write(10,17)'Row Col ',rowval(i),' ',colval(i),' ',
     1'Pixel Value ',fldval(i)
           write(*,17)'Row Col ',rowval(i),' ',colval(i),' ',
     1'Pixel Value ',fldval(i)
   42   continue
      endif
   17 format(a8,i2,a1,i2,a1,a12,f9.3)
      write(10,*)' '
      write(*,*)' '


c Test Case -- gdinterpolate
c
      write(10,27)
      write(10,*)'Testing gdinterpolate... '
      write(10,*)'=================='
      write(*,*)'Testing gdinterpolate... '
      write(*,*)'=================='

      lstatus=he5_gdinterpolate(gdid_utm,5,lonval,latval,
     1'Voltage',interval)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'lstatus=he5_gdinterpolate(gdid_utm,5,lonval,latval,
     1"Voltage",interval)'
        write(10,*)'Interpolate 5 values for field Voltage '
        write(*,*)'lstatus=he5_gdinterpolate(gdid_utm,5,lonval,latval,
     1"Voltage",interval)'
        write(*,*)'Interpolate 5 values for field Voltage '
        write(*,*)'Status returned by call to he5_gdinterpolate ',
     1lstatus
        do 38 index1=1,5
           write(*,4)'Interpolated value ',interval(index1,1)
           write(10,4)'Interpolated value ',interval(index1,1)
   38   continue
      endif
    4 format(a,f9.3)
      write(10,*)' '
      write(*,*)' '


      status = he5_gddetach(gdid_utm)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Value returned by he5_gddetach ',status
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Value returned by he5_gddetach ',status
      endif

      status = he5_gdclose(gdfid)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdclose(gdfid)'
         write(*,*)'Returned from he5_gdclose ', status
         write(10,*)'status = he5_gdclose(gdfid)'
         write(10,*)'Returned from he5_gdclose ', status
      endif

      close(unit=10)
  27  format('')
      stop
      end

c	  In this program we (1) open the "swath.he5" HDF-EOS file, (2)
c	  attach to the "Swath1" swath, and (3) define the swath fields
c     =============================================================

      program     he5_sw_definefieldsF_32

      implicit    none

      include     'hdfeos5.inc'

      integer     status
      integer     he5_swopen
      integer     he5_swattach
      integer     he5_swsetfill
      integer     he5_swdefgfld
      integer     he5_swdefdfld
      integer     he5_prdefine
      integer     he5_swdefchunk
      integer     he5_swdefcomp
      integer     he5_swdetach
      integer     he5_swclose
      integer     swfid, swid

      integer     chunkrank
      integer*4   chunkdims(3) 
      integer     compparm(1)

      integer     FAIL
      parameter   (FAIL=-1)

c     Open the HDF-EOS file, "swath.he5" using "READ/WRITE" access code
c     -----------------------------------------------------------------
      swfid = he5_swopen("swath.he5",HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_swopen():  ',swfid 
      if (swfid .NE. FAIL) then

         swid = he5_swattach(swfid, "Swath1")
         write(*,*) 'Swath ID  returned by he5_swattach():  ',swid 
         if (swid .NE. FAIL) then
            
c     Define Geolocation and Data fields
c     ----------------------------------
c     ---------------------------------------------------------------
c     We define six fields.  The first three, "Time", "Longitude"
c	  and "Latitude" are geolocation fields and thus we use the
c	  geolocation dimensions "GeoTrack" and "GeoXtrack" in the field
c	  definitions.  We also must specify the data type using the
c	  standard HDF data type codes.  In this example the geolocation
c	  are 4-byte (32 bit) floating point numbers.
c     
c	  The next three fields are data fields.  Note that either
c	  geolocation or data dimensions can be used. 
c     ---------------------------------------------------------------
            
            status = he5_swdefgfld(swid, "Time", "GeoTrack", 
     1           " ",HE5T_NATIVE_DOUBLE, 0)
            write(*,*) 'Status returned by he5_swdefgfld():  ',status 

            status = he5_swdefgfld(swid, "Longitude", 
     1           "GeoXtrack,GeoTrack",
     2           " ", HE5T_NATIVE_FLOAT, 0)
            write(*,*) 'Status returned by he5_swdefgfld():  ',status 

            status = he5_swdefgfld(swid, "Latitude",
     1           "GeoXtrack,GeoTrack",
     2           " ", HE5T_NATIVE_FLOAT, 0)
            write(*,*) 'Status returned by he5_swdefgfld():  ',status 

            status = he5_swdefdfld(swid, "Density",
     1           "GeoTrack"," ", HE5T_NATIVE_FLOAT, 0)
            write(*,*) 'Status returned by he5_swdefdfld():  ',status

            status = he5_swdefdfld(swid, "Temperature",
     1           "GeoXtrack,GeoTrack",
     2           " ", HE5T_NATIVE_FLOAT, 0)	      
            write(*,*) 'Status returned by he5_swdefdfld():  ',status 
	      
            status = he5_swdefdfld(swid, "Pressure", 
     1           "Res2xtr,Res2tr",
     2           " ", HE5T_NATIVE_FLOAT, 0)
            write(*,*) 'Status returned by he5_swdefdfld():  ',status 
	      
		chunkrank = 3
                chunkdims(1) = 20
                chunkdims(2) = 40
                chunkdims(3) = 15
                compparm(1) = 6

            status = he5_swdefchunk(swid,chunkrank,chunkdims)
            write(*,*) 'Status returned by he5_swdefchunk(): ',status

            status = he5_swdefcomp(swid,
     1               HE5_HDFE_COMP_DEFLATE,compparm)
            write(*,*) 'Status returned by he5_swdefcomp():  ',
     1                  status

            status = he5_swdefdfld(swid, "Spectra", 
     1           "Res2xtr,Res2tr,Bands",
     2           " ", HE5T_NATIVE_DOUBLE, 0)	      
            write(*,*) 'Status returned by he5_swdefdfld():  ',status 


c     Define Profile Field
c     -----------------------  
            status = he5_prdefine(swid, "Profile-2000", 
     1           "ProfDim", " ", HE5T_NATIVE_INT)
            write(*,*) 'Status returned by he5_prdefine():  ',status


c     Define Appendable Field
c     -----------------------  
c     status = he5_swdefdfld(swid, "Count", "GeoTrack",
c     1"Unlim", HE5T_NATIVE_INT, 0)	      
            
         endif
      endif
      
c     Detach from the swath
c     ---------------------      
      status = he5_swdetach(swid)
      write(*,*) 'Status returned by he5_swdetach():  ',status 
      
c     Close the file
c     --------------      
      status = he5_swclose(swfid)
      write(*,*) 'Status returned by he5_swclose():  ',status 

      stop
      end

!----------------------------------------------------------------------------
!     Copyright (C) 2002   Emergent IT Inc. and Raytheon Systems Company    |
!----------------------------------------------------------------------------
! testza64.f                                                                |
! In this program we create, define and write a simple za hdfeos file       |
! using the za interface                                                    |
!----------------------------------------------------------------------------

      program   testza64
 
      implicit  none
 
      include   'hdfeos5.inc'
 
      integer   status
      integer   index1
      integer   index2
      integer   zafid
      integer   zaid
      integer   zaid2
      integer   rank
      integer   n, nt
      integer   dtype
      integer   classid
      integer   order
      integer   rdattr(4)
      integer   global_attr(4)
      integer   compparm(5)
      integer   cnkrank
      integer   rdcompparm(5)
      integer   compcode
      integer   ntyped(4)
      integer   rnkd(4)

      integer   he5_zaopen
      integer   he5_zacreate
      integer   he5_zaattach
      integer   he5_zadefdim
      integer   he5_zadefine
      integer   he5_zadefchunk
      integer   he5_zadefcomp
      integer   he5_zasetfill
      integer   he5_zawrattr
      integer   he5_zawrlattr
      integer   he5_zawrite
      integer   he5_zaread
      integer   he5_zawrgattr
      integer   he5_zardattr
      integer   he5_zardgattr
      integer   he5_zardlattr
      integer   he5_zainfo 
      integer   he5_zacompinfo
      integer   he5_zaattrinfo
      integer   he5_zagattrinfo
      integer   he5_zalattrinfo
      integer   he5_zagetfill
      integer   he5_zaidtype
      integer   he5_zadetach
      integer   he5_zaclose 

      integer*8 he5_zainqza
      integer*8 he5_zanentries
      integer*8 he5_zainqdims
      integer*8 he5_zadiminfo
      integer*8 he5_zainqattrs
      integer*8 he5_zainqgattrs
      integer*8 he5_zainqlattrs
      integer*8 he5_zainquire
      integer*8 size
      integer*8 strbufsize
      integer*8 ndims
      integer*8 chunkdims(1)
      integer*8 start(2)
      integer*8 stride(2)
      integer*8 dataedge(2)
      integer*8 istart(2)
      integer*8 iedge(2)
      integer*8 dedge(2)
      integer*8 sd_start(2)
      integer*8 sd_stride(2)
      integer*8 sd_edge(2)
      integer*8 rd_start(2)
      integer*8 rd_stride(2)
      integer*8 rd_edge(2)
      integer*8 dimsize
      integer*8 nattr
      integer*8 nza
      integer*8 nmaps
      integer*8 strbufsz2
      integer*8 nflds
      integer*8 count(1)
      integer*8 zero
      integer*8 dims(2)
      integer*8 dims2(3)
      integer*8 sddims(2)
      integer*8 dim1
      integer*8 dim2
      integer*8 dim3
      integer*8 dim4

      real      grpattr(3)
      real      locattr(3)
      real      rdgnlattr(3)
      real      ray1(100,40)
      real      ray2(40,100)
      real      ray4(40,100)
      real      ray3(40,40)
      real      temp(40,100)
      real      raycnt
      real      fillvalue
      real      rdfilval
      real      tempbuf(4200)


      character*(256)  dimname
      character*(256)  fieldlist
      character*(256)  attrlist
      character*(256)  zalist
      character*(256)  dimens
      character*(256)  maxdims

      dim1          = 30
      dim2          = 40
      dim3          = 50
      dim4          = 100
      count(1)      = 3
      compparm(1)   = 6
      compparm(2)   = 0
      compparm(3)   = 0
      compparm(4)   = 0
      compparm(5)   = 0
      cnkrank       = 1
      chunkdims(1)  = 10
      rdcompparm(1) = 1
      rdcompparm(2) = 1
      rdcompparm(3) = 1
      rdcompparm(4) = 1
      rdcompparm(5) = 1
      compcode      = -1
      raycnt        = -799.0
      global_attr(1)= 11
      global_attr(2)= 33
      global_attr(3)= 66
      global_attr(4)= 99
      grpattr(1)    = 21.7
      grpattr(2)    = 24.3
      grpattr(3)    = 26.3
      locattr(3)    = 21.7
      locattr(2)    = 24.3
      locattr(1)    = 26.3
      start(1)      = 10
      start(2)      = 10
      stride(1)     = 1
      stride(2)     = 1
      sd_start(1)   = 0
      sd_start(2)   = 0
      sd_stride(1)  = 1
      sd_stride(2)  = 1
      sd_edge(1)    = 100
      sd_edge(2)    = 40
      rd_start(1)   = 0
      rd_start(2)   = 0
      rd_stride(1)  = 1
      rd_stride(2)  = 1
      rd_edge(1)    = 40
      rd_edge(2)    = 100
      dataedge(1)   = 20
      dataedge(2)   = 50
      istart(1)     = 0
      istart(2)     = 0
      iedge(1)      = 30
      iedge(2)      = 30
      dedge(1)      = 40
      dedge(2)      = 40
      rank          = 2
      fillvalue     = 16.0
      zero          = 0

!
! This section of the program just fills some arrays with data that will be
! used later in the program
!
      do 110 index1=1,100
         do 100 index2=1,40
            ray1(index1, index2)=raycnt
            ray2(index2, index1)=raycnt + 1.0
            ray4(index2,index1) = raycnt
            raycnt = raycnt +1.
  100    continue
  110 continue

      do 170 index1=1,40
         do 160 index2=1,40
            ray3(index1, index2)=raycnt
            raycnt = raycnt+1.25
  160    continue
  170 continue


  230 format('********Error unexpected**********')
  240 format('***********Passed Test*********')

      open(unit=1, file="testza.txt", status = "UNKNOWN")

      write(*,*)'Testing he5_za FORTRAN 77 interface'
      write(*,*)'======================================'
      write(1,*)'Testing he5_za FORTRAN 77 interface'
      write(1,*)'======================================'
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zaopen
!
      write(*,*)'Testing he5_zaopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_zaopen '
      write(1,*)'====================='
      zafid=he5_zaopen('za.he5',HE5F_ACC_TRUNC)
      if (zafid .lt. zero) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	zafid= he5_zaopen("za.he5",HE5F_ACC_TRUNC)'
         write(*,*)'	Value returned by he5_zaopen ', zafid
         write(1,*)'	zafid= he5_zaopen("za.he5",HE5F_ACC_TRUNC)'
         write(1,*)'	Value returned by he5_zaopen ', zafid
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zacreate
!
      write(1,27)
      write(*,*)'Testing he5_zacreate '
      write(*,*)'====================='
      write(1,*)'Testing he5_zacreate '
      write(1,*)'====================='
      zaid=he5_zacreate(zafid,'Simplef')
      if (zaid .lt. zero) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid=he5_zacreate(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zacreate ', zaid
         write(1,*)'zaid= he5_zacreate(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zacreate ', zaid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid2=he5_zacreate(zafid,'Indexedf')
      if (zaid2 .lt. zero) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid2= he5_zacreate(zafid, "Indexedf")'
         write(*,*)'Value returned by he5_zacreate ', zaid2
         write(1,*)'zaid2= he5_zacreate(zafid, "Indexedf")'
         write(1,*)'Value returned by he5_zacreate ', zaid2
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zadefdim
!
      write(1,27)
      write(*,*)'Testing he5_zadefdim '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadefdim '
      write(1,*)'====================='
      status=he5_zadefdim(zaid,'DataTrack',dim4)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_zadefdim(zaid, "DataTrack", 100)'
         write(*,*)'	Value returned by he5_zadefdim ',status
         write(1,*)'	status= he5_zadefdim(zaid, "DataTrack", 100)'
         write(1,*)'	Value returned by he5_zadefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefdim(zaid,'DataXtrack',dim2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_zadefdim(zaid, "DataXtrack", 40)'
         write(*,*)'	Value returned by he5_zadefdim ',status
         write(1,*)'	status= he5_zadefdim(zaid, "DataXtrack", 40)'
         write(1,*)'	Value returned by he5_zadefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefdim(zaid2,'DataTrack',dim2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_zadefdim(zaid2, "DataTrack", 40)'
         write(*,*)'	Value returned by he5_zadefdim ', status
         write(1,*)'	status= he5_zadefdim(zaid2, "DataTrack", 40)'
         write(1,*)'	Value returned by he5_zadefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefdim(zaid2,'DataXtrack',dim2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_zadefdim(zaid2, "DataXtrack", 40)'
         write(*,*)'	Value returned by he5_zadefdim ', status
         write(1,*)'	status= he5_zadefdim(zaid2, "DataXtrack", 40)'
         write(1,*)'	Value returned by he5_zadefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefdim(zaid2,'Timedim',dim2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define dimension Timedim '
         write(*,*)'	Value returned by he5_zadefdim ', status
         write(1,*)'Define dimension Timedim '
         write(1,*)'	Value returned by he5_zadefdim ', status
      endif

      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zadefine
!
      write(1,27)
      write(*,*)'Testing he5_zadefine '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadefine '
      write(1,*)'====================='

      status=he5_zadefine(zaid,'SideA','DataXtrack,DataTrack',
     1' ', HE5T_NATIVE_FLOAT)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
        
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define data field SideA '
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'Define data field SideA '
         write(1,*)'Value returned by he5_zadefine ',status
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case  -- he5_zasetfill
!
      write(1,27)
      write(*,*)'Testing he5_zasetfill '
      write(*,*)'====================='
      write(1,*)'Testing he5_zasetfill '
      write(1,*)'====================='
      status= he5_zasetfill(zaid,'Temperature',
     1HE5T_NATIVE_FLOAT, fillvalue)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zasetfill(zaid,"Temperature",
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(*,*)'Value returned by he5_zasetfill ',status
         write(1,*)'status=he5_zasetfill(zaid,"Temperature",
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(1,*)'Value returned by he5_zasetfill ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefine(zaid,'Temperature',
     1'DataXtrack,DataTrack',' ',HE5T_NATIVE_FLOAT)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define data field Temperature '
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'Define data field Temperature '
         write(1,*)'Value returned by he5_zadefine ',status
         write(*,*)' '
         write(1,*)' '
      endif

      status= he5_zasetfill(zaid,'Conduction',
     1HE5T_NATIVE_FLOAT,fillvalue)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zasetfill(zaid,"Conduction",
     1HE5T_NATIVE_FLOAT,fillvalue)'
         write(*,*)'Value returned by he5_zasetfill ',status
         write(1,*)'status=he5_zasetfill(zaid,"Conduction",
     1HE5T_NATIVE_FLOAT,fillvalue)'
         write(1,*)'Value returned by he5_zasetfill ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefine(zaid,'Conduction',
     1'DataXtrack,DataTrack',' ',HE5T_NATIVE_FLOAT)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadefine(zaid,"Conduction",
     1"DataXtrack,DataTrack","",HE5T_NATIVE_FLOAT)'
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'status= he5_zadefine(zaid,"Conduction",
     1"DataXtrack,DataTrack","",HE5T_NATIVE_FLOAT)'
         write(1,*)'Value returned by he5_zadefine ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefine(zaid2,'Sensor1',
     1'DataXtrack,DataTrack',' ',HE5T_NATIVE_FLOAT)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zadefine(zaid2, "Sensor1",
     1"DataTrack,DataXtrack","",HE5T_NATIVE_FLOAT)'
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'status= he5_zadefine(zaid2, "Sensor1",
     1"DataTrack,DataXtrack","",HE5T_NATIVE_FLOAT)'
         write(1,*)'Value returned by he5_zadefine ',status
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zadefchunk
!
      write(1,27)
      write(*,*)'Testing he5_zadefchunk'
      write(*,*)'======================'
      write(1,*)'Testing he5_zadefchunk'
      write(1,*)'======================'
      status=he5_zadefchunk(zaid,cnkrank,chunkdims)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadefchunk(zaid, cnkrank, chunkdims)'
         write(*,*)'Value returned by he5_zadefchunk ',status
         write(1,*)'status= he5_zadefchunk(zaid, cnkrank, chunkdims)'
         write(1,*)'Value returned by he5_zadefchunk ',status
      endif
      write(*,*)' '
      write(1,*)' '
    
! Test Case -- he5_zadefcomp
!
      write(1,27)
      write(*,*)'Testing he5_zadefcomp'
      write(*,*)'====================='
      write(1,*)'Testing he5_zadefcomp'
      write(1,*)'====================='
      status=he5_zadefcomp(zaid,HE5_HDFE_COMP_DEFLATE,compparm)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadefcomp(zaid,HE5_HDFE_COMP_DEFLATE,
     1compparm)'
         write(*,*)'Value returned by he5_zadefcomp ',status
         write(1,*)'status= he5_zadefcomp(zaid,HE5_HDFE_COMP_DEFLATE,
     1compparm)'
         write(1,*)'Value returned by he5_zadefcomp ',status
      endif
      write(*,*)' '
      write(1,*)' '


      status=he5_zadefine(zaid,'CompChunk','DataTrack',
     1' ',HE5T_NATIVE_FLOAT)
      if (status .lt. zero) then
         write(*,230)
         write(1,230) 
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define data field CompChunk '
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'Define data field CompChunk '
         write(1,*)'Value returned by he5_zadefine ',status
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zadetach
!
      write(1,27)
      write(*,*)'Testing he5_zadetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadetach '
      write(1,*)'====================='
      status=he5_zadetach(zaid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadetach(zaid2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid2)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid2)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      zaid=he5_zaattach(zafid,'Simplef')
      if (zaid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zaattach ',zaid
         write(1,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zaattach ',zaid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid2=he5_zaattach(zafid,'Indexedf')
      if (zaid2 .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(*,*)'Value returned by he5_zaattach ',zaid2
         write(1,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(1,*)'Value returned by he5_zaattach ',zaid2
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zadetach
!
      write(1,27)
      write(*,*)'Testing he5_zadetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadetach '
      write(1,*)'====================='
      status= he5_zadetach(zaid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid2)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid2)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zaclose(zafid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)       
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaclose(zafid)'
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      zafid=he5_zaopen('za.he5',HE5F_ACC_RDWR)
      if (zafid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zafid=he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_zaopen ',zafid
         write(1,*)'zafid=he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_zaopen ',zafid
      endif
      write(*,*)' '
      write(1,*)' '
 
! Test Case -- he5_zaattach
!
      write(1,27)
      write(*,*)'Testing he5_zaattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_zaattach '
      write(1,*)'====================='

      zaid=he5_zaattach(zafid,'Simplef')
      if (zaid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zaattach ',zaid
         write(1,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zaattach ',zaid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid2=he5_zaattach(zafid,'Indexedf')
      if (zaid2 .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(*,*)'Value returned by he5_zaattach ',zaid2
         write(1,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(1,*)'Value returned by he5_zaattach ',zaid2
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zawrite
!
      write(1,27)
      write(*,*)'Testing he5_zawrite '
      write(*,*)'==================='
      write(1,*)'Testing he5_zawrite '
      write(1,*)'==================='

      status=he5_zawrite(zaid,'SideA',sd_start,stride, 
     1rd_edge, ray4)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Write data field SideA '
         write(*,*)'Value returned by he5_zawrite ',status
         write(1,*)'Write data field SideA '
         write(1,*)'Value returned by he5_zawrite ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zawrite(zaid,'Temperature',start,stride, 
     1dataedge, ray4)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrite(zaid,"Temperature",start, 
     1stride,dataedge, ray1)'
         write(*,*)'Value returned by he5_zawrite ',status
         write(1,*)'status=he5_zawrite(zaid,"Temperature",start, 
     1stride,dataedge, ray1)'
         write(1,*)'Value returned by he5_zawrite ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zawrite(zaid,'Conduction',start,stride, 
     1dataedge, ray2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrite(zaid,"Conduction",start, 
     1stride,dataedge, ray2)'
         write(*,*)'Value returned by he5_zawrite ',status
         write(1,*)'status=he5_zawrite(zaid,"Conduction",start, 
     1stride,dataedge, ray2)'
         write(1,*)'Value returned by he5_zawrite ',status
      endif
      write(*,*)' '
      write(1,*)' '


      iedge(1)=40
      iedge(2)=40
      status=he5_zawrite(zaid2,'Sensor1',istart,stride, 
     1iedge,ray3)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zawrite(zaid2, "Sensor1", 
     1istart, stride, iedge, ray3)'
         write(*,*)'Value returned by he5_zawrite ',status
         write(1,*)'status= he5_zawrite(zaid2, "Sensor1", 
     1istart, stride, iedge, ray3)'
         write(1,*)'Value returned by he5_zawrite ',status
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zawrlattr
!
      write(1,27)
      write(*,*)'Testing he5_zawrlattr, Local Attribute '
      write(*,*)'================================== '
      write(1,*)'Testing he5_zawrlattr, Local Attribute '
      write(1,*)'================================== '
      status=he5_zawrlattr(zaid2,'Sensor1','local',
     1HE5T_NATIVE_FLOAT,count,locattr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrlattr(zaid2,"Sensor1","local",
     1HE5T_NATIVE_FLOAT,count,locattr)'
         write(*,*)'Value returned by he5_zawrlattr ',status
         write(1,*)'status=he5_zawrlattr(zaid2,"Sensor1", "local", 
     1HE5T_NATIVE_FLOAT,count,locattr)'
         write(1,*)'Value returned by he5_zawrlattr ',status
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zawrattr
!
      count(1) = 4

      write(1,27)
      write(*,*)'Testing he5_zawrattr, Global Attribute '
      write(*,*)'====================================== '
      write(1,*)'Testing he5_zawrattr, Global Attribute '
      write(1,*)'======================================= '
      status=he5_zawrattr(zaid,'Drift',HE5T_NATIVE_INT,count, 
     1global_attr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrattr(zaid, "Drift", 
     1HE5T_NATIVE_INT, count, global_attr)'
         write(*,*)'Value returned by he5_zawrattr ',status
         write(1,*)'status=he5_zawrattr(zaid, "Drift", 
     1HE5T_NATIVE_INT, count, global_attr)'
         write(1,*)'Value returned by he5_zawrattr ',status
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zawrgattr
!
      count(1) = 3
     
      write(1,27)
      write(*,*)'Testing he5_zawrgattr, Group Attribute '
      write(*,*)'====================================== '
      write(1,*)'Testing he5_zawrgattr, Group Attribute '
      write(1,*)'====================================== '
      status=he5_zawrgattr(zaid,'group',HE5T_NATIVE_FLOAT, 
     1count,grpattr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrgattr(zaid, "group", 
     1HE5T_NATIVE_FLOAT,count,grpgattr)'
         write(*,*)'Value returned by he5_zawrgattr ',status
         write(1,*)'status=he5_zawrgattr(zaid, "group", 
     1HE5T_NATIVE_FLOAT,count,grpattr)'
         write(1,*)'Value returned by he5_zawrgattr ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
      write(*,*)'status= he5_zadetach(zaid)'
      write(*,*)'Value returned by he5_zadetach ',status
      write(1,*)'status= he5_zadetach(zaid)'
      write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid2)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid2)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zaclose
!
      write(1,27)
      write(*,*)'Testing he5_zaclose '
      write(*,*)'==================='
      write(1,*)'Testing he5_zaclose '
      write(1,*)'==================='
      status= he5_zaclose(zafid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      zafid= he5_zaopen('za.he5',HE5F_ACC_RDWR)
      if (zafid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_zaopen ', zafid
         write(1,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_zaopen ', zafid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid= he5_zaattach(zafid,'Simplef')
      if (zaid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zaattach ',zaid
         write(1,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zaattach ',zaid
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zaclose(zafid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaclose(zafid)'
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      zafid= he5_zaopen('za.he5',HE5F_ACC_RDWR)
      if (zafid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_zaopen ',zafid
         write(1,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_zaopen ',zafid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid=he5_zaattach(zafid,'Simplef')
      if (zaid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zaattach ',zaid
         write(1,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zaattach ',zaid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid2=he5_zaattach(zafid,'Indexedf')
      if (zaid2 .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(*,*)'Value returned by he5_zaattach ',zaid2
         write(1,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(1,*)'Value returned by he5_zaattach ',zaid2
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zanentries
!
      write(1,27)
      write(*,*)'Testing he5_zanentries '
      write(*,*)'====================='
      write(1,*)'Testing he5_zanentries '
      write(1,*)'====================='

      nmaps=he5_zanentries(zaid,1,strbufsize)
      if (nmaps .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'nmaps= he5_zanentries(zaid, 1, strbufsize)'
         write(*,*)'Number of dimension mappings ',nmaps
         write(*,*)'Size of strbufsize ',strbufsize
         write(1,*)'nmaps= he5_zanentries(zaid, 1, strbufsize)'
         write(1,*)'Number of dimension mappings ',nmaps
         write(1,*)'Size of strbufsize ',strbufsize
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zainqdims
!
      write(1,27)
      write(*,*)'Testing he5_zainqdims '
      write(*,*)'====================='
      write(1,*)'Testing he5_zainqdims '
      write(1,*)'====================='
      ndims=he5_zainqdims(zaid,dimname,dims)
      if (ndims .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'ndims= he5_zainqdims(zaid, dimname, dims)'
         write(*,*)'Number of dimesions ',ndims
         write(*,*)'Names of dimensions ',dimname
         write(*,*)'Size of dimensions ',dims
         write(1,*)'ndims= he5_zainqdims(zaid, dimname, dims)'
         write(1,*)'Number of dimesions ',ndims
         write(1,*)'Names of dimensions ',dimname
         write(1,*)'Size of dimensions ',dims
      endif
      write(*,*)' '
      write(1,*)' '

      ndims= he5_zainqdims(zaid2, dimname, dims2)
      if (ndims .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'ndims=he5_zainqdims(zaid2,dimname,dims2)'
         write(*,*)'Number of dimesions ',ndims
         write(*,*)'Names of dimensions ',dimname
         write(*,*)'Size of dimensions ',dims2
         write(1,*)'ndims=he5_zainqdims(zaid2,dimname,dims2)'
         write(1,*)'Number of dimesions ',ndims
         write(1,*)'Names of dimensions ',dimname
         write(1,*)'Size of dimensions ',dims2
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zainquire
!
      write(1,27)
      write(*,*)'Testing he5_zainquire '
      write(*,*)'======================'
      write(1,*)'Testing he5_zainquire '
      write(1,*)'======================'
      nflds=he5_zainquire(zaid,fieldlist,rnkd,ntyped)
      if (nflds .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'nflds=he5_zainquire(zaid,fieldlist,rnkd,ntyped)'
         write(*,*)'Number of data fields in za ',nflds
         write(*,*)'Names of data fields ',fieldlist
         write(*,*)'Rank of fields ',rnkd
         write(*,*)'Number type of fields ',ntyped
         write(1,*)'nflds=he5_zainquire(zaid,fieldlist,rnkd,ntyped)'
         write(1,*)'Number of data fields in za ',nflds
         write(1,*)'Names of data fields ',fieldlist
         write(1,*)'Rank of fields ',rnkd
         write(1,*)'Number type of fields ',ntyped
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zadiminfo
!
      write(1,27)
      write(*,*)'Testing he5_zadiminfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadiminfo '
      write(1,*)'====================='
      dimsize= he5_zadiminfo(zaid,'DataTrack')
      if (dimsize .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'dimsize= he5_zadiminfo(zaid, "DataTrack")'
         write(*,*)'Size of dimension DataTrack ',dimsize
         write(1,*)'dimsize= he5_zadiminfo(zaid, "DataTrack")'
         write(1,*)'Size of dimension DataTrack ',dimsize
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zaread
!
      write(1,27)
      write(*,*)'Testing he5_zaread '
      write(*,*)'==================='
      write(1,*)'Testing he5_zaread '
      write(1,*)'==================='

      rd_start(1)=0
      rd_start(2)=0
      rd_stride(1)=1
      rd_stride(2)=1
      rd_edge(1)=40
      rd_edge(2)=100
      status= he5_zaread(zaid,'Conduction',rd_start,
     1rd_stride,rd_edge,temp)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Value returned by he5_zaread ',status
         write(*,*)'status= he5_zaread(zaid, "Conduction", 
     1rd_start,rd_stride, rd_edge, temp)'
         write(1,*)'status= he5_zaread(zaid, "Conduction", 
     1rd_start,rd_stride, rd_edge, temp)'
         write(1,*)'Value returned by he5_zaread ',status
         do 190 index1=10,15
            do 180 index2=10,15
               write(*,*)'value of conduction ',temp(index1,index2)
               write(1,*)'value of conduction ',temp(index1,index2)
  180       continue
  190    continue
      endif

      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zainfo
!
      write(1,27)
      write(*,*)'Testing he5_zainfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_zainfo '
      write(1,*)'====================='
      status=he5_zainfo(zaid,'SideA',rank,sddims,nt,
     1dimens,maxdims)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zainfo(zaid, "SideA", 
     1rank, sddims, nt, dimens, maxdims)'
         write(*,*)'Value returned by he5_zainfo ',status
         write(*,*)'Rank of field sideA ',rank
         write(*,*)'dimension list of field sideA ',dimens
         write(*,*)'Size of sideA dimensions ',sddims
         write(*,*)'number type of field sideA ',nt
         write(1,*)'status= he5_zainfo(zaid, "SideA", 
     1rank, sddims, nt, dimens, maxdims)'
         write(1,*)'Value returned by he5_zainfo ',status
         write(1,*)'Rank of field sideA ',rank
         write(1,*)'dimension list of field sideA ',dimens
         write(1,*)'Size of sideA dimensions ',sddims
         write(1,*)'number type of field sideA ',nt
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zainqattrs
!
      write(1,27)
      write(*,*)'Testing he5_zainqattrs Global attributes '
      write(*,*)'==================================== '
      write(1,*)'Testing he5_zainqattrs Global attributes '
      write(1,*)'==================================== '

      nattr = he5_zainqattrs(zaid,attrlist,strbufsz2)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Number of global attributes in za ',nattr
         write(*,*)'Attribute list of za ',attrlist
         write(1,*)'Number of global attributes in za ',nattr
         write(1,*)'Attribute list of za ',attrlist
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zaattrinfo
!
      write(1,27)
      write(*,*)'Testing he5_zaattrinfo Global attribute'
      write(*,*)'======================================='
      write(1,*)'Testing he5_zaattrinfo Global attribute'
      write(1,*)'======================================='
      status= he5_zaattrinfo(zaid, attrlist, n, size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zaattrinfo(zaid,attrlist,n,size)'
         write(*,*)'Value returned by he5_zaattrinfo ',status
         write(*,*)'Number type of attributes ',n,' Size ',size
         write(1,*)'status=he5_zaattrinfo(zaid,attrlist,n,size)'
         write(1,*)'Value returned by he5_zaattrinfo ',status
         write(1,*)'Number type of attributes ',n,' Size ',size
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zardattr
!
      write(1,27)
      write(*,*)'Testing he5_zardattr, Global attribute '
      write(*,*)'======================================'
      write(1,*)'Testing he5_zardattr, Global attribute '
      write(1,*)'======================================'

      status= he5_zardattr(zaid, attrlist, rdattr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zardattr(zaid,attrlist,rdattr)'
         write(*,*)'Value returned by he5_zardattr ',status
         write(*,*)'attribute ',rdattr
         write(1,*)'status=he5_zardattr(zaid,attrlist,rdattr)'
         write(1,*)'Value returned by he5_zardattr ',status
         write(1,*)'attribute ',rdattr
      endif
      write(*,*)' '
      write(1,*)' '

!     Test Case -- he5_zainqgattrs
!
      write(1,27)
      write(*,*)'Testing he5_zainqgattrs Group attributes '
      write(*,*)'==================================== '
      write(1,*)'Testing he5_zainqgattrs Group attributes '
      write(1,*)'==================================== '

      nattr = he5_zainqgattrs(zaid,attrlist,strbufsz2)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Number of group attributes in za ',nattr
         write(*,*)'Attribute list of za ',attrlist
         write(1,*)'Number of group attributes in za ',nattr
         write(1,*)'Attribute list of za ',attrlist
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zagattrinfo
!
      write(1,27)
      write(*,*)'Testing he5_zagattrinfo Group attribute'
      write(*,*)'======================================='
      write(1,*)'Testing he5_zagattrinfo Group attribute'
      write(1,*)'======================================='
      status= he5_zagattrinfo(zaid, attrlist, n, size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zagattrinfo(zaid,attrlist,n,size)'
         write(*,*)'Value returned by he5_zagattrinfo ',status
         write(*,*)'Number type of attributes ',n,' Size ',size
         write(1,*)'status=he5_zagattrinfo(zaid,attrlist,n,size)'
         write(1,*)'Value returned by he5_zagattrinfo ',status
         write(1,*)'Number type of attributes ',n,' Size ',size
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zardgattr
!
      write(1,27)
      write(*,*)'Testing he5_zardgattr, Group attribute '
      write(*,*)'======================================'
      write(1,*)'Testing he5_zardgattr, Group attribute '
      write(1,*)'======================================'

       status= he5_zardgattr(zaid,'group',rdgnlattr)
       if (status .lt. zero) then
          write(*,230)
          write(1,230)
       else
          write(*,*)'  '
          write(*,240)
          write(1,*)'  '
          write(1,240)
          write(*,*)'status=he5_zardgattr(zaid,attrlist,rdgnlattr)'
          write(*,*)'Value returned by he5_zardgattr ',status
          write(*,*)'attribute ',rdgnlattr
          write(1,*)'status=he5_zardgattr(zaid,attrlist,rdgnlattr)'
          write(1,*)'Value returned by he5_zardgattr ',status
          write(1,*)'attribute ',rdgnlattr
       endif
       write(*,*)' '
       write(1,*)' '

! Test Case -- he5_zainqlattrs
!
      write(1,27)
      write(*,*)'Testing he5_zainqlattrs Local attributes '
      write(*,*)'==================================== '
      write(1,*)'Testing he5_zainqlattrs Local attributes '
      write(1,*)'==================================== '

      nattr=he5_zainqlattrs(zaid2,'Sensor1',attrlist,strbufsz2)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zainqlattrs(... "Sensor1" ...)'
         write(*,*)'Number of local attributes in field ',nattr
         write(*,*)'Attribute list of field ',attrlist
         write(1,*)'zainqlattrs(... "Sensor1" ...)'
         write(1,*)'Number of local attributes in field ',nattr
         write(1,*)'Attribute list of field ',attrlist
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zalattrinfo
!
      write(1,27)
      write(*,*)'Testing he5_zalattrinfo Local attribute'
      write(*,*)'======================================='
      write(1,*)'Testing he5_zalattrinfo Local attribute'
      write(1,*)'======================================='
      status=he5_zalattrinfo(zaid2,'Sensor1','local',n,size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zalattrinfo(... "Sensor1" ...)'
         write(*,*)'Value returned by he5_zalattrinfo ',status
         write(*,*)'Number type of attributes ',n,' Size ',size
         write(1,*)'zalattrinfo(... "Sensor1" ...)'
         write(1,*)'Value returned by he5_zalattrinfo ',status
         write(1,*)'Number type of attributes ',n,' Size ',size
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zaidtype
!
      write(1,27)
      write(*,*)'Testing he5_zaidtype, Inquire Datatype '
      write(*,*)'======================================='
      write(1,*)'Testing he5_zaidtype, Inquire Datatype '
      write(1,*)'======================================='

      status= he5_zaidtype(zaid2,'Sensor1','local', 
     1HE5_HDFE_LOCATTRGROUP,dtype,classid, order, size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaidtype(zaid2,"Sensor1","local", 
     1HE5_HDFE_LOCATTRGROUP,dtype, classid, order, size)'
         write(*,*)'Value returned by he5_zaidtype ',status
         write(*,*)'Datatype of local attribute ',dtype
         write(*,*)'Class id and order ',classid, order
         write(*,*)'Size of attribute ',size
         write(1,*)'status= he5_zaidtype(zaid2,"Sensor1","local", 
     1HE5_HDFE_LOCATTRGROUP,dtype, classid, order, size)'
         write(1,*)'Value returned by he5_zaidtype ',status
         write(1,*)'Datatype of local attribute ',dtype
         write(1,*)'Class id and order ',classid, order
         write(1,*)'Size of attribute ',size
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zardlattr
!
      write(1,27)
      write(*,*)'Testing he5_zardlattr, Local attribute '
      write(*,*)'======================================'
      write(1,*)'Testing he5_zardlattr, Local attribute '
      write(1,*)'======================================'

      status=he5_zardlattr(zaid2,'Sensor1','local',rdgnlattr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zardlattr(zaid2,"Sensor1","local", 
     1rdgnlattr)'
         write(*,*)'Value returned by he5_zardlattr ',status
         write(*,*)'attribute ',rdgnlattr
         write(1,*)'status=he5_zardlattr(zaid2,"Sensor1","local", 
     1rdgnlattr)'
         write(1,*)'Value returned by he5_zardlattr ',status
         write(1,*)'attribute ',rdgnlattr
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zagetfill
!
      write(1,27)
      write(*,*)'Testing he5_zagetfill '
      write(*,*)'====================='
      write(1,*)'Testing he5_zagetfill '
      write(1,*)'====================='
      status= he5_zagetfill(zaid,'Conduction', rdfilval)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zagetfill(zaid,"Conduction",rdfilval)'
         write(*,*)'Value returned by he5_zagetfill ',status
         write(*,*)'Value of fill ',rdfilval
         write(1,*)'status=he5_zagetfill(zaid,"Conduction",rdfilval)'
         write(1,*)'Value returned by he5_zagetfill ',status
         write(1,*)'Value of fill ',rdfilval
      endif
      write(*,*)' '
      write(1,*)' '



! Test Case -- he5_zacompinfo
!
      write(1,27)
      write(*,*)'Testing he5_zacompinfo '
      write(*,*)'======================='
      write(1,*)'Testing he5_zacompinfo '
      write(1,*)'======================='
      status=he5_zacompinfo(zaid,'CompChunk',compcode,rdcompparm)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zacompinfo(zaid,"CompChunk",compcode, 
     1rdcompparm)'
         write(*,*)'Status returned by he5_zacompinfo ',status
         write(*,*)'Compression code ',compcode
         write(*,*)'Compression parameter ',rdcompparm(1)
         write(1,*)'status=he5_zacompinfo(zaid,"CompChunk",compcode, 
     1rdcompparm)'
         write(1,*)'Status returned by he5_zacompinfo ',status
         write(1,*)'Compression code ',compcode
         write(1,*)'Compression parameter ',rdcompparm(1)
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid2)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid2)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zaclose(zafid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaclose(zafid)'
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      zafid= he5_zaopen('za.he5',HE5F_ACC_RDWR)
      if (zafid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_zaopen ',zafid
         write(1,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_zaopen ',zafid
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zainqza
!
      write(1,27)
      write(*,*)'Testing he5_zainqza '
      write(*,*)'======================'
      write(1,*)'Testing he5_zainqza '
      write(1,*)'======================'

      nza=he5_zainqza('za.he5',zalist,strbufsz2)
      if (nza .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Retrieve information on zas in 
     1file za.he5'
         write(*,*)'Number of zas in file ', nza
         write(*,*)'List of zas ',zalist
         write(1,*)'Retrieve information on zas in 
     1file za.he5'
         write(1,*)'Number of zas in file ', nza
         write(1,*)'List of zas ',zalist
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zaclose(zafid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaclose(zafid)'
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '

      close(unit=1)
   27 format(' ')
      stop
      end

c
c ----------------------------------------------------------------------------
c |    Copyright (C) 1999   Emergent IT Inc. and Raytheon Systems Company    |
c ----------------------------------------------------------------------------
c

      program            he5_sw_rdexternaldataF_64

      implicit           none
 
      include            'hdfeos5.inc'

      integer            i
      integer            status
      integer            he5_swopen
      integer            he5_swattach
      integer            he5_swrdfld
      integer            he5_swgetxdat
      integer            he5_ehrdwrfile
      integer            he5_swdetach
      integer            he5_swclose
      integer            swfid, swid
      integer            nfiles
      integer            datain1(100)
      integer            datain2(100)
      integer            datain3(100)
      integer            dataout(60)

      integer*8          start(2)
      integer*8          stride(2)
      integer*8          count(2)
      integer*8          offset(3)
      integer*8          size(3)
      integer*8          nmlgth
      integer*8          num_elements

      character          filelist*256

      integer            FAIL
      parameter          (FAIL=-1)

c.....Use this for writing (only) to an existing file
      integer            WRITE_EXISTING_ONLY
      parameter          (WRITE_EXISTING_ONLY=0)

c.....Use this for reading (only) from an existing file
      integer            READ_ONLY
      parameter          (READ_ONLY=1)

c.....Use this for creating and writing to a file
      integer            WRITE_NEW
      parameter          (WRITE_NEW=2)

c     Create the external data sets
c     -----------------------------
      do 10 i=1,100

         datain1(i) = 1000+i
         datain2(i) = 2000+i
         datain3(i) = 3000+i        
         
 10   continue

      num_elements = 100
      
      status = he5_ehrdwrfile("extf1.dat",WRITE_NEW,
     1HE5T_NATIVE_INT,num_elements,datain1)
      write(*,*) 'Status returned from he5_ehrdwrfile:   ',status

      status = he5_ehrdwrfile("extf2.dat",WRITE_NEW,
     1HE5T_NATIVE_INT,num_elements,datain2)
      write(*,*) 'Status returned from he5_ehrdwrfile:   ',status

      status = he5_ehrdwrfile("extf3.dat",WRITE_NEW,
     1HE5T_NATIVE_INT,num_elements,datain3)
      write(*,*) 'Status returned from he5_ehrdwrfile:   ',status

c     Open HDF-EOS swath file, "swath.he5"
c     ------------------------------------
	  swfid = he5_swopen("swath.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned from he5_swopen():  ',swfid

	  if (swfid .NE. FAIL) then
		 swid = he5_swattach(swfid, "Swath1")
         write(*,*) 'Swath ID returned from he5_swattach():  ',swid

		 if (swid .NE. FAIL) then
			
c     Read the external data field 
c     ----------------------------
      start(1)  = 0
      stride(1) = 1
      count(1)  = 60

      status = he5_swrdfld(swid,"ExtData",
     1     start,stride,count,dataout)
      write(*,*) 'Status returned from he5_swrdfld():  ',status

c     Display the data
c     ----------------
      do i=1,60
         write(*,*)'External data',dataout(i)
      enddo

      nmlgth = 48

c     Get the number of external files
c     --------------------------------     
      nfiles = he5_swgetxdat(swid,"ExtData",nmlgth,
     1     filelist,offset,size)

      write(*,*) 'Number of external files',nfiles
      write(*,*) 'External files:',filelist
      do i=1,nfiles
         write(*,*) 'offsets:',offset(i)
         write(*,*) 'sizes:',size(i)
      enddo

		 endif
	  endif
	
c     Detach from swath
c     -----------------
	  status = he5_swdetach(swid)
      write(*,*) 'Status returned from he5_swdetach():  ',status

c     Close the file
c     --------------
	  status = he5_swclose(swfid)
      write(*,*) 'Status returned from he5_swclose():  ',status
            
	  stop
	  end

      program     he5_gd_writedimscaleF_32

      implicit    none

      include     'hdfeos5.inc'

      integer     status
      integer     i, j
      integer     he5_gdopen
      integer     he5_gdattach
      integer     he5_gdwrfld
      integer     he5_gdwrattr
      integer     he5_gdwrgattr
      integer     he5_ehwrglatt
      integer     he5_gdwrlattr 
      integer     he5_gddetach
      integer     he5_gdclose
      integer     HE5_GDsetdimscale
      integer     HE5_GDwritedscaleattr
      integer     he5_gddeffld

      integer     gdfid,gdid1,gdid2,gdid3
      real*4      datbuf_f(1) 
      integer*4   datbuf_i(3)
      real*4      veg1(120),veg2(200), temp1(100),temp2(100)
      real*4      geospecf(4)
      integer*4   nbands
      integer     bands(3)
      integer*4   datbuf_i2(2)
      integer     count(2)
      integer     xdim, ydim, ntime
      integer     data(10)
      integer     FAIL
      parameter   (FAIL=-1)

!  /*
!   * We first open the HDF-EOS grid file, "Grid.h5".  Because this file
!   * already exist and we wish to write to it, we use the H5F_ACC_RDWR access
!   * code in the open statement.  The HE5_GDopen routine returns the grid file
!   * id, gdfid, which is used to identify the file in subsequent routines.
!   */ 
      do j=1,10
         data(j)=(j+1)*2
      enddo

      gdfid = HE5_GDopen("grid.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_gdopen(): ',gdfid
!  /*
!   * If the grid file cannot be found, HE5_GDopen will return -1 for the file
!   * handle (gdfid).  We there check that this is not the case before
!   * proceeding with the other routines.
!   * 
!   * The HE5_GDattach routine returns the handle to the existing grid "Grid1",
!   * GDid.  If the grid is not found, HE5_GDattach returns -1 for the handle.
!   */ 

      if (gdfid .ne. FAIL) then
 
         GDid1 = HE5_GDattach(gdfid, "UTMGrid")
         write(*,*) 'Grid ID returned by he5_gdattach(): ',gdid1

!   /* the field Pollution has Time,YDim,XDim dimensions. 
!    * xdim = 120
!    * ydim = 200
!    * Time dim is set to 10
!    */

         if (GDid1 .eq. -1) then
            
            write(*,*) 'Error: Cannot attach to grid UTMGrid. Stpped.'
            status = HE5_GDclose(gdfid)
            stop
            
         endif
         
         xdim = 120
         ydim = 200 
         ntime = 10
         
         status = HE5_GDsetdimscale(GDid1, "Pollution", "XDim", 
     1       xdim, HE5T_NATIVE_DOUBLE, veg1)
         write(*,*) 'Status returned by HE5_GDsetdimscale: ',status
         
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale for XDim',
     1                ' dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         status = HE5_GDsetdimscale(GDid1, "Pollution", "Time", ntime,
     1                               HE5T_NATIVE_INT, data)
         write(*,*) 'Status returned by HE5_GDsetdimscale: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale for Time',
     1           ' dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         status = HE5_GDsetdimscale(GDid1, "Vegetation", "XDim", xdim,
     1                               HE5T_NATIVE_DOUBLE, veg1)
         write(*,*) 'Status returned by HE5_GDsetdimscale: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale for XDim',
     1                 ' dimemnsion in field Vegetation'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif

         status = HE5_GDsetdimscale(GDid1, "Vegetation", "YDim", ydim,
     1                               HE5T_NATIVE_DOUBLE, veg2)
         write(*,*) 'Status returned by HE5_GDsetdimscale: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale for XDim',
     1                 ' dimemnsion in field Vegetation'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif

         count(1)= 12
         status = HE5_GDwritedscaleattr(GDid1, "XDim", "label", 
     1                         HE5T_NATIVE_CHAR, count, "X Dimension")
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale strs for XDim',
     1                ' dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         count(1)= 6
         status = HE5_GDwritedscaleattr(GDid1, "XDim", "unit", 
     1                              HE5T_NATIVE_CHAR, count, "meters")
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale strs for XDim',
     1                 ' dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         count(1)= 4
         status = HE5_GDwritedscaleattr(GDid1, "XDim", "format", 
     1                                 HE5T_NATIVE_CHAR, count, "F7.2")
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale strs for XDim',
     1                 ' dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status =  HE5_GDclose(gdfid)
            stop
         endif
         
         datbuf_f(1) =  -999.0
         count(1)= 1
         status = HE5_GDwritedscaleattr(GDid1, "XDim", "MissingValue",
     1                               HE5T_NATIVE_FLOAT, count, datbuf_f)
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale strs for XDim',
     1                 ' dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         datbuf_i(1) =  -999
         datbuf_i(2) =  0
         datbuf_i(3) =  999


         count(1)= 3
         status = HE5_GDwritedscaleattr(GDid1, "XDim", "IntValues", 
     1                               HE5T_NATIVE_INT, count, datbuf_i)
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale strs for XDim',
     1         ' dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         count(1)= 8
         status = HE5_GDwritedscaleattr(GDid1, "Time", "label", 
     1                             HE5T_NATIVE_CHAR, count, "Time Dim")
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale strs for',
     1                ' Time dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         count(1)= 1
         status = HE5_GDwritedscaleattr(GDid1, "Time", "unit", 
     1                                 HE5T_NATIVE_CHAR, count, "s")
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale strs for',
     1                ' Time dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         count(1)= 4
         status = HE5_GDwritedscaleattr(GDid1, "Time", "format", 
     1                                HE5T_NATIVE_CHAR, count, "F2.3")
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale strs for',
     1                ' Time dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         datbuf_i2(1) =  -999
         datbuf_i2(2) =  999
         count(1) = 2
         status = HE5_GDwritedscaleattr(GDid1, "Time", "MissingValue", 
     1                                HE5T_NATIVE_INT, count, datbuf_i2)
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale strs for',
     1                ' Time dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         status = HE5_GDdetach(GDid1)
         write(*,*) 'Status returned by he5_gddetach(): ',status

! -----------------------------------------------------------------

!         /* the field Spectra has Bands,YDim,XDim dimensions. 
!	 xdim = 100
!	 ydim = 100
!	 Bands dim is set to 3
!         */
!         
         GDid2 = HE5_GDattach(gdfid, "PolarGrid")
         write(*,*) 'Grid ID returned by he5_gdattach(): ',gdid2
         if (GDid2 .eq. -1) then
            
            write(*,*) 'Error: Cannot attach to grid PolarGrid'
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         ydim = 100
         nbands = 3
         
         status = HE5_GDsetdimscale(GDid2, "Spectra", "YDim", ydim, 
     1                              HE5T_NATIVE_DOUBLE, temp1)
         write(*,*) 'Status returned by HE5_GDsetdimscale: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale for YDim',
     1                 ' dimemnsion in field Spectra'
            status = HE5_GDdetach(GDid2)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         bands(1) = 5
         bands(2) = 8
         bands(3) = 9

         status = HE5_GDsetdimscale(GDid2, "Spectra", "Bands", 
     1                               nbands, HE5T_NATIVE_INT, bands)
         write(*,*) 'Status returned by HE5_GDsetdimscale: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale for',
     1                ' Bands dimemnsion in field Spectra'
            status = HE5_GDdetach(GDid2)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         count(1)= 5
         status = HE5_GDwritedscaleattr(GDid2, "YDim", "Label", 
     1                              HE5T_NATIVE_CHAR, count, "Y Dim")
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale strs for',
     1                ' XDim dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid2)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         count(1) = 4
         status = HE5_GDwritedscaleattr(GDid2, "Bands", "Units", 
     1                                HE5T_NATIVE_CHAR, count, "None")
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale strs for',
     1                ' Time dimemnsion in field Pollution '
            status = HE5_GDdetach(GDid2)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         status = HE5_GDdetach(GDid2)
! -----------------------------------------------------------------         
         xdim = 60
         ydim = 40

         GDid3 = HE5_GDattach(gdfid, "GEOGrid")
         write(*,*) 'Grid ID returned by he5_gdattach(): ',GDid3
         if (GDid3 .eq. -1) then
            
	    write(*,*) 'Error: Cannot attach to grid GEOGrid'
            status = HE5_GDclose(gdfid)
	    stop
         endif


!     Define Fields
!     -------------	  
         status = he5_gddeffld(gdid3, "GeoSpectra", "XDim,YDim",
     1     " ", HE5T_NATIVE_FLOAT, 0)
         write(*,*) 'Status returned by he5_gddeffld(): ',status

         status = HE5_GDsetdimscale(GDid3, "GeoSpectra", "YDim", 
     1                         ydim, HE5T_NATIVE_DOUBLE, GeoSpecf)
         write(*,*) 'Status returned by HE5_GDsetdimscale: ',status
         if (status .eq. -1) then
            
	    write(*,*) 'Error: Cannot set Dimension Scale for',
     1                ' YDim dimemnsion in field GeoSpectra'
            status = HE5_GDdetach(GDid3)
            status = HE5_GDclose(gdfid)
	    stop
         endif
         
         count(1) = 15
         status = HE5_GDwritedscaleattr(GDid3, "YDim", "Units", 
     1                    HE5T_NATIVE_CHAR, count, "Decimal Degrees")
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
	    write(*,*) 'Error: Cannot set Dimension Scale strs for',
     1                ' YDim dimemnsion in field GeoSpectra'
            status = HE5_GDdetach(GDid3)
            status = HE5_GDclose(gdfid)
	    stop
         endif
         
         
         status = HE5_GDdetach(GDid3)
         write(*,*) 'Status returned by he5_gddetach(): ',status
         status = HE5_GDclose(gdfid)
         write(*,*) 'Status returned by he5_gdclose(): ',status

      endif
      stop
      end

      program   he5_gd_definefieldsF_64
  
      implicit  none

      include   'hdfeos5.inc'
     
	  integer   status, he5_gddeffld, he5_gdsetfill
	  integer   he5_gdattach, he5_gddetach, he5_gdclose
          integer   he5_gddeftle, he5_gddefcomp
	  integer   gdfid, gdid1, gdid2, he5_gdopen 
    
          integer   tilecode, tilerank
          integer*8 tiledims(2)
          integer   compparm(1)

	  real*4    fillval1, fillval2
	
	  fillval1 = -7.0
	  fillval2 = -9999.0

c     Open HDF-EOS file "grid.he5" 
c     ----------------------------	  
	  gdfid = he5_gdopen("grid.he5",HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_gdopen():  ',gdfid

c     Attach to the UTM grid
c     ----------------------
	  gdid1 = he5_gdattach(gdfid, "UTMGrid")
      write(*,*) 'Grid ID returned by he5_gdattach():  ',gdid1 

c     Define Fields
c     -------------	  
      status = he5_gdsetfill(gdid1,"Pollution",
     1HE5T_NATIVE_FLOAT,fillval1)
      write(*,*) 'Status returned by he5_gdsetfill():  ',status

      status = he5_gddeffld(gdid1, "Pollution", 
     1"XDim,YDim,Time"," ", HE5T_NATIVE_FLOAT, 0)
      write(*,*) 'Status returned by he5_gddeffld():  ',status
      
                tilerank = 2
                tiledims(1) = 60
                tiledims(2) = 100
                compparm(1) = 6
 
      status = he5_gddeftle(gdid1,HE5_HDFE_TILE,tilerank,tiledims)
      write(*,*) 'Status returned by he5_gddeftle(): ',status
 
      status = he5_gddefcomp(gdid1,HE5_HDFE_COMP_DEFLATE,compparm)
      write(*,*) 'Status returned by he5_gddefcomp():  ',status

      status = he5_gddeffld(gdid1, "Vegetation",
     1"XDim,YDim"," ", HE5T_NATIVE_FLOAT, 0)
      write(*,*) 'Status returned by he5_gddeffld():  ',status

c     Attach to the POLAR grid
c     ------------------------
	  gdid2 = he5_gdattach(gdfid, "PolarGrid")
      write(*,*) 'Grid ID returned by he5_gdattach():  ',gdid2

c     Define Fields
c     -------------	  
      status = he5_gddeffld(gdid2, "Temperature",
     1"XDim,YDim"," ", HE5T_NATIVE_FLOAT, 0)
      write(*,*) 'Status returned by he5_gddeffld():  ',status

c     Set fill value for "Pressure" field
c     -----------------------------------
      status = he5_gdsetfill(gdid2,"Pressure",
     1HE5T_NATIVE_FLOAT,fillval2)
      write(*,*) 'Status returned by he5_gdsetfill():  ',status

      status = he5_gddeffld(gdid2, "Pressure", 
     1"XDim,YDim"," ", HE5T_NATIVE_FLOAT, 0)
      write(*,*) 'Status returned by he5_gddeffld():  ',status

c     Define Fields
c     -------------	  
      status = he5_gddeffld(gdid2, "Soil Dryness", 
     1"XDim,YDim"," ", HE5T_NATIVE_FLOAT, 0)
      write(*,*) 'Status returned by he5_gddeffld():  ',status
      
      status = he5_gddeffld(gdid2, "Spectra", 
     1"XDim,YDim,Bands"," ", HE5T_NATIVE_DOUBLE, 0)
      write(*,*) 'Status returned by he5_gddeffld():  ',status
      
c     Detach from the grids
c     ---------------------
	  status = he5_gddetach(gdid1)
      write(*,*) 'Status returned by he5_gddetach():  ',status

	  status = he5_gddetach(gdid2)
      write(*,*) 'Status returned by he5_gddetach():  ',status     

c     Close the file
c     --------------
	  status = he5_gdclose(gdfid)
      write(*,*) 'Status returned by he5_gdclose():  ',status
	  
	  stop
	  end

c----------------------------------------------------------------------------
c     Copyright (C) 2000   Emergent IT Inc. and Raytheon Systems Company    |
c----------------------------------------------------------------------------
c testgrid64.f                                                              |
c In this program we create, define and write a simple grid hdfeos file     |
c using the grid interface                                                  |
c----------------------------------------------------------------------------

      program       testgrid64

      implicit      none
 
      include       'hdfeos5.inc'

      integer   	status, i, ii
      integer		compparm(5)
      integer 	    gdfid, gdfid2, gdid_utm, gdid2
      integer 	    zonecode, pixregcode, orgcode
      integer	    attr(4), iattr(4), gattr(4), lattr(4)
      integer 	    spherecode, zero
      integer		regionid, regionid2
      integer	    dtype, classid, order
      integer	    he5_gdopen, he5_gdcreate
      integer       he5_gdattach, he5_gddetach
      integer	    he5_gdclose, he5_gddefproj
      integer       he5_gddefdim, he5_gdinqdatatype
      integer	    he5_gddeftle, he5_gddeffld
      integer       he5_gdsetfill, he5_gdwrfld
      integer	    he5_gdwrattr, he5_gdwrgattr
      integer       he5_gdwrlattr, he5_gdorginfo
      integer	    he5_gddefcomp, he5_gdinqflds
      integer       he5_gdprojinfo
      integer	    he5_gdrdfld, he5_gdattrinfo
      integer       he5_gdgatinfo
      integer       he5_gdlatinfo, he5_gdrdattr
      integer       he5_gdrdgattr, he5_gdrdlattr
      integer	    he5_gdreginfo, he5_gddeftmeper
      integer       he5_gddefvrtreg
      integer	    he5_gddeforigin, he5_gddefpreg
      integer       he5_gdinqdims, he5_gdgetfill
      integer	    he5_gdgridinfo, he5_gdcompinfo
      integer       he5_gdfldinfo, he5_gddefboxreg
      integer	    he5_gdgetpix, he5_gddupreg
      integer       he5_gdpreginfo, he5_gdextreg
      integer		rnk(8), numtype(8)
      integer		zcode, scode, nflds

      integer*4	    ntype
      integer*4		nt, rk
      integer*4		periodid
      integer*4		lstatus, n, one      
      integer*4		index1
      integer*4		index2
      integer*4		dimsizes(2)
      integer*4		lat(40,50)
      integer*4		latcnt
      integer*4		lon(40,50)
      integer*4		loncnt
      integer*4	    he5_gdinqgrid, he5_gddiminfo
      integer*4     he5_gdnentries
      integer*4	    he5_gdinqattrs, he5_gdinqgattrs
      integer*4     he5_gdinqlattrs
      integer*4	    pcode

      integer*8	    xdim, ydim
      integer*8	    testdim1, testdim2, hghtdim, conduction
      integer*8	    timedim, convection, setcount(1)
      integer*8 	start(2)
      integer*8 	stride(2)
      integer*8 	edge(2)
      integer*8 	start1d, stride1d, edge1d
      integer*8		tiledims(2)
      integer*8	    count, nlonlat
      integer*8	    size
      integer*8		rowval(5), colval(5)
      integer*8	    xdimsize, ydimsize
      integer*8	    he5_gdgetpixval, he5_gdinterpolate
      integer*8	    strbufsize
      integer*8		dims(8)

      real		    fillvalue, ifillv

      real*4		ray3(250)
      real*4		utmray(60,80), georay(60,80)
      real*4		utmhght(80)
      real*4		hghtinit
      real*4		utmcnt, geocnt
      real*4		raycnt, ray3cnt
      real*4		tempray(60,80)
      real*4		datbuf(4800)
      real*4		fldval(5)
      
      real*8		starttime, stoptime
      real*8		range(2)
      real*8		projparm(16), pparm(16)
      real*8		uplft(2), lowrgt(2)
      real*8		iuplft(2), ilrgt(2)
      real*8		interval(5,2)
      real*8		lonval(5), latval(5)
      real*8		utmtmeray(4800)
      real*8		tmeinit
      real*8		upleftpt(2), lowrtpt(2),corlon(2),corlat(2)

      character*80	grdnames, dimname, fldlist, attrlist
      character*80	maxdimname
      integer*4	    	compcodestring
      
      nt(1)= 0      
      nt(2)= 0      
      nt(3)= 0      
      nt(4)= 0
      rk(1)= 0
      rk(2)= 0
      rk(3)= 0
      rk(4)= 0

      index1 = 0
      index2 = 0
      dimsizes(1) = 40
      dimsizes(2) = 100
      compparm(1) = 0
      compparm(2) = 0
      compparm(3) = 0
      compparm(4) = 0
      compparm(5) = 0
      fillvalue = 1996.0
      raycnt = -799.0
      ray3cnt = -19.5
      attr(1) = 11
      attr(2) = 33
      attr(3) = 55
      attr(4) = 77
      utmcnt=-799.0
      geocnt=2001.0
      hghtinit = 323.0
      tmeinit = 35232487.2d0
      starttime = 35233000.8d0
      stoptime = 35435050.9d0
      range(1) = 352.8d0
      range(2) = 400.9d0
      lonval(1) = -122.0d0
      latval(1) = -68.0d0
      lonval(2) = -122.5d0
      latval(2) = -68.0d0
      lonval(3) = -123.0d0
      latval(3) = -68.0d0
      lonval(4) = -123.5d0
      latval(4) = -68.0d0
      lonval(5) = -124.0d0
      latval(5) = -68.0d0
      tiledims(1) = 16
      tiledims(2) = 15

      latcnt = 38.0
      loncnt = 78.0
      zero = 0
      one = 1
      
c
c This section of the program just fills some arrays with data that we will
c use later in the program
c
      do 70 index1=1,60
         do 80 index2=1,80
            utmray(index2,index1) = utmcnt
            georay(index2,index1) = geocnt
            utmcnt = utmcnt + .4
            geocnt = geocnt + .2
   80   continue
   70 continue
  
      
      do 30 index1=1,250
            ray3(index1) = ray3cnt
            ray3cnt = ray3cnt + .1
   30 continue
      
      do 32 index1=1,80
            utmhght(index1) = hghtinit
            hghtinit = hghtinit + 2.75
   32 continue

      do 34 index1=1,4800
            utmtmeray(index1) = tmeinit
            tmeinit = tmeinit + 70.7
   34 continue

      do 50 index1=1,50
         do 60 index2=1,40      
            lat(index2,index1) = latcnt
            lon(index2,index1) = loncnt
            loncnt = loncnt - 0.1
   60    continue
         latcnt = latcnt + 0.1
         loncnt = 78.0
   50 continue

  230 format('********Error unexpected**********')
  231 format('********Error Expected************')
  240 format('***********Passed Test*********')


      open(unit=10,file='testgrid_f.txtout', status = "UNKNOWN")

      write(*,*)'Testing Grid FORTRAN 77 interface '
      write(*,*)'=================================='
      write(10,*)'Testing Grid FORTRAN 77 interface '
      write(10,*)'=================================='
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdopen
c
      write(10,*)'Testing he5_gdopen... '
      write(10,*)'======================'
      write(*,*)'Testing he5_gdopen... '
      write(*,*)'======================'
      gdfid2 = he5_gdopen("grid2fortran64",HE5F_ACC_TRUNC)
      if (gdfid2 .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdfid2 = he5_gdopen("grid2fortran64",HE5F_ACC_TRUNC)'
         write(10,*)'Value returned by gdopen ', gdfid2
         write(*,*)'gdfid2 = he5_gdopen("grid2fortran64",HE5F_ACC_TRUNC)'
         write(*,*)'Value returned by gdopen ', gdfid2
      endif
      write(*,*)' '
      write(10,*)' '

      gdfid = he5_gdopen('gridfortran64',HE5F_ACC_TRUNC)
      if (gdfid .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'Opening file gridfortran64'
         write(10,*)'Opening file gridfortran64'
         write(10,*) 'gdfid = he5_gdopen("gridfortran64",HE5F_ACC_TRUNC)'
         write(10,*) 'File id returned from gdopen ', gdfid
         write(*,*) 'gdfid = he5_gdopen("gridfortran64",HE5F_ACC_TRUNC)'
         write(*,*) 'File id returned from gdopen ', gdfid
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- he5_gdcreate
c
      write(10,27)
      write(10,*)'Testing he5_gdcreate... '
      write(10,*)'========================'
      write(*,*)'Testing he5_gdcreate... '
      write(*,*)'========================'

      xdim      = 60
      ydim      = 80
      uplft(1)  = 353299.39125d0
      uplft(2)  = -7100284.64348d0
      lowrgt(1) = 603434.52148d0
      lowrgt(2) = -7991341.17870d0


      gdid2 = he5_gdcreate(gdfid2, 'UTMGrid2', 
     1xdim, ydim, uplft, lowrgt)
      if (gdid2 .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*) 'Create UTMGrid2'
         write(*,*)'gdid2 = he5_gdcreate(gdfid2, "UTMGrid2", 
     1xdim, ydim, uplft, lowrgt)'
         write(10,*) 'Value returned by gdcreate ', gdid2
         write(*,*) 'Create UTMGrid2'
         write(10,*)'gdid2 = he5_gdcreate(gdfid2, "UTMGrid2",
     1xdim, ydim, uplft, lowrgt)'
         write(*,*) 'Value returned by gdcreate ', gdid2
      endif
      
    
      gdid_utm = he5_gdcreate(gdfid, 'UTMGrid', xdim, ydim, 
     1uplft, lowrgt)
      if (gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Creating UTMGrid'
         write(*,*)'Creating UTMGrid'
         write(*,*)'gdid_utm= he5_gdcreate(gdfid,"UTMGrid",xdim,
     1ydim,uplft,lowrgt)'
         write(10,*)'gdid_utm= he5_gdcreate(gdfid,"UTMGrid",xdim,
     1ydim,uplft,lowrgt)'
         write(10,*)'UTM grid id returned from gdcreate ',gdid_utm
         write(*,*)'UTM grid id returned from gdcreate ',gdid_utm
      endif 
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddefproj
c
      write(10,27)
      write(10,*)'Testing he5_gddefproj... '
      write(10,*)'========================'
      write(*,*)'Testing he5_gddefproj... '
      write(*,*)'========================'

      zonecode = 10
      spherecode = 0

      do 120 index1=1,16
         projparm(index1)=0
 120  continue
  
      status = he5_gddefproj(gdid_utm,HE5_GCTP_UTM,zonecode,
     1spherecode,projparm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Defining UTM projection'
         write(*,*)'Defining UTM projection'
         write(*,*)'status= he5_gddefproj(gdid_utm,HE5_GCTP_UTM,
     1zonecode,spherecode, projparm)'
         write(10,*)'status= he5_gddefproj(gdid_utm,HE5_GCTP_UTM,
     1zonecode,spherecode, projparm)'
         write(10,*)'Returned value from gddefproj ', status
         write(*,*)'Returned value from gddefproj ', status
      endif 
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefproj(gdid2,HE5_GCTP_UTM,zonecode,
     1spherecode,projparm)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Defining UTM'
         write(10,*)'status = he5_gddefproj(gdid2,HE5_GCTP_UTM,
     1zonecode,spherecode,projparm)'
         write(10,*)'Value returned by gddefproj ', status
         write(*,*)'Defining UTM'
         write(*,*)'status = he5_gddefproj(gdid2,HE5_GCTP_UTM,
     1zonecode,spherecode,projparm)'
         write(*,*)'Value returned by gddefproj ', status
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- he5_gddefpreg
c
      write(10,27)
      write(10,*)'Testing he5_gddefpreg... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gddefpreg... '
      write(*,*)'=========================='
      status = he5_gddefpreg(gdid_utm, HE5_HDFE_CORNER)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gddefpreg(gdid_utm, 
     1HE5_HDFE_CORNER)'
         write(10,*)'status = he5_gddefpreg(gdid_utm, 
     1HE5_HDFE_CORNER)'
         write(10,*)'Returned from gddefpreg ', status
         write(*,*)'Returned from gddefpreg ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddeforigin
c
      write(10,27)
      write(10,*)'Testing he5_gddeforigin... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gddeforigin... '
      write(*,*)'=========================='
      status = he5_gddeforigin(gdid_utm,HE5_HDFE_GD_UL)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gddeforigin(gdid_utm,
     1HE5_HDFE_GD_UL)'
         write(*,*)'Value of status from gddeforigin ',status
         write(10,*)'status = he5_gddeforigin(gdid_utm,
     1HE5_HDFE_GD_UL)'
         write(10,*)'Value of status from gddeforigin ',status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddefdim
c
      write(10,27)
      write(10,*)'Testing he5_gddefdim... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gddefdim... '
      write(*,*)'=========================='
      testdim1 = 40
      status = he5_gddefdim(gdid2,'TestDim1',testdim1)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddefdim(gdid2,"TestDim1",40)'
         write(10,*)'Value returned by gddefdim ', status
         write(*,*)'status = he5_gddefdim(gdid2,"TestDim1",40)'
         write(*,*)'Value returned by gddefdim ', status
      endif
      write(10,*)' '
      write(*,*)' '

      testdim2 = 25
      status = he5_gddefdim(gdid2, 'TestDim2', testdim2)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddefdim(gdid2,"TestDim2",25)'
         write(10,*)'Value returned by gddefdim ', status
         write(*,*)'status = he5_gddefdim(gdid2,"TestDim2",25)'
         write(*,*)'Value returned by gddefdim ', status
      endif
      write(10,*)' '
      write(*,*)' '

      conduction = 250
      status = he5_gddefdim(gdid_utm, 'Conduction', conduction)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddefdim(gdid_utm,
     1"Conduction",250)'
         write(10,*)'Returned value from gddefdim ', status
         write(*,*)'status = he5_gddefdim(gdid_utm, 
     1"Conduction", 250)'
         write(*,*)'Returned value from gddefdim ', status
      endif
      write(10,*)' '
      write(*,*)' '

      timedim = 4800
      status = he5_gddefdim(gdid_utm,'Timedim',timedim)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddefdim(gdid_utm,
     1"Timedim",4800)'
         write(10,*)'Status returned by call to gddefdim ',status
         write(*,*)'status = he5_gddefdim(gdid_utm,
     1"Timedim",4800)'
         write(*,*)'Status returned by call to gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      hghtdim = 80
      status = he5_gddefdim(gdid_utm,'Hghtdim',hghtdim)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = he5_gddefdim(gdid_utm,"Hghtdim",80)'
        write(10,*)'Status returned by call to gddefdim ',status
        write(*,*)'status = he5_gddefdim(gdid_utm,"Hghtdim",80)'
        write(*,*)'Status returned by call to gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      convection = 60
      status = he5_gddefdim(gdid_utm,'Convection',convection)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define dimension Convection '
        write(10,*)'status = he5_gddefdim(gdid_utm,
     1"Convection",60)'
        write(10,*)'Status returned by call to gddefdim ',status
        write(*,*)'Define dimension Convection '
        write(*,*)'status = he5_gddefdim(gdid_utm,
     1"Convection",60)'
        write(*,*)'Status returned by call to gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddetach
c
      write(10,27)
      write(10,*)'Testing he5_gddetach... '
      write(10,*)'======================='
      write(*,*)'Testing he5_gddetach... '
      write(*,*)'======================='
      status = he5_gddetach(gdid2)
      if(status .lt. zero) then
         write(*,231)
         write(10,231)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid2)'
         write(10,*)'Value returned by gddetach ', status
         write(*,*)'status = he5_gddetach(gdid2)'
         write(*,*)'Value returned by gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid_utm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Returned value from gddetach ', status
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Returned value from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '
 
c Test Case -- he5_gdattach
c
      write(10,27)
      write(10,*)'Testing he5_gdattach... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdattach... '
      write(*,*)'=========================='
      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if(gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid_utm=he5_gdattach(gdfid,"UTMGrid")'
         write(10,*)'Handle returned from gdattach ',gdid_utm
         write(*,*)'gdid_utm=he5_gdattach(gdfid,"UTMGrid")'
         write(*,*)'Handle returned from gdattach ',gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

      gdid2 = he5_gdattach(gdfid2, 'UTMGrid2')
      if(gdid2 .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid2=he5_gdattach(gdfid2, "UTMGrid2")'
         write(10,*)'Value returned by gdattach ', gdid2
         write(*,*)'gdid2=he5_gdattach(gdfid2, "UTMGrid2")'
         write(*,*)'Value returned by gdattach ', gdid2
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddeffld
c
      write(10,27)
      write(10,*)'Testing he5_gddeffld... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gddeffld... '
      write(*,*)'=========================='

      status= he5_gddeffld(gdid2,"tempfield","TestDim2,TestDim1",
     1" ",HE5T_NATIVE_FLOAT, HE5_HDFE_NOMERGE)
      if(status .lt. zero) then
         write(*,231)
         write(10,231)
        
      else 
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "tempfield"'
        write(10,*)'status= he5_gddeffld(gdid2,"tempfield",
     1"TestDim2,TestDim1"," ",HE5T_NATIVE_FLOAT,HE5_HDFE_NOMERGE)'
        write(10,*)'Value returned by gddeffld ', status
        write(*,*)'Define: "tempfield"'
        write(*,*)'status= he5_gddeffld(gdid2,"tempfield",
     1"TestDim2,TestDim1","",HE5T_NATIVE_FLOAT,HE5_HDFE_NOMERGE)'
        write(*,*)'Value returned by gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid_utm,'Time','Timedim'," ",
     1HE5T_NATIVE_DOUBLE, HE5_HDFE_NOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
        write(*,*)' '
        write(*,240)
        write(10,*)' '
        write(10,240)
        write(10,*)' Define field Time'
        write(10,*)'status= he5_gddeffld(gdid_utm,"Time","Timedim",
     1"",HE5T_NATIVE_DOUBLE, HE5_HDFE_NOMERGE)'
        write(10,*)'Status returned by call to gddeffld ',status
        write(*,*)' Define field Time'
        write(*,*)'status= he5_gddeffld(gdid_utm,"Time","Timedim",
     1"",HE5T_NATIVE_DOUBLE, HE5_HDFE_NOMERGE)'
        write(*,*)'Status returned by call to gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid_utm,'Height','Hghtdim'," ", 
     1HE5T_NATIVE_FLOAT, HE5_HDFE_NOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
        write(*,*)' '
        write(*,240)
        write(10,*)' '
        write(10,240)
        write(10,*)' Define field Height'
        write(10,*)'status= he5_gddeffld(gdid_utm,"Height",
     1"Hghtdim","",HE5T_NATIVE_FLOAT, HE5_HDFE_NOMERGE)'
        write(10,*)'Status returned by call to gddeffld ',status
        write(*,*)' Define field Height'
        write(*,*)'status= he5_gddeffld(gdid_utm,"Height","Hghtdim",
     1"",HE5T_NATIVE_FLOAT, HE5_HDFE_NOMERGE)'
        write(*,*)'Status returned by call to gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddeftle
c
      write(10,27)
      write(10,*)'Testing he5_gddeftle... '
      write(10,*)'======================='
      write(*,*)'Testing he5_gddeftle... '
      write(*,*)'======================='

      status = he5_gddeftle(gdid_utm,HE5_HDFE_TILE,2,tiledims)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define tiling dimensions '
        write(10,*)'status = he5_gddeftle(gdid_utm,
     1HE5_HDFE_TILE,2,tiledims)'
        write(10,*)'Status returned by call to gddeftle ',status
        write(*,*)'Status returned by call to gddeftle ',status
        write(*,*)'status = he5_gddeftle(gdid_utm,
     1HE5_HDFE_TILE,2,tiledims)'
        write(*,*)'Define tiling dimensions '
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid_utm,'SideB','YDim,Convection',
     1" ",HE5T_NATIVE_INT, HE5_HDFE_NOMERGE)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define field that will be tiled '
        write(10,*)'status= he5_gddeffld(gdid_utm,"SideB",
     1"YDim,Convection"," ",HE5T_NATIVE_INT,HE5_HDFE_NOMERGE)'
        write(10,*)'Status returned by call to gddeffld ',status
        write(*,*)'Define field that will be tiled '
        write(*,*)'status= he5_gddeffld(gdid_utm,"SideB",
     1"YDim,Convection","",HE5T_NATIVE_INT,HE5_HDFE_NOMERGE)'
        write(*,*)'Status returned by call to gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid_utm)
      if (status .lt. zero) then 
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Returned value from gddetach ', status
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Returned value from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if (gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gdattach(gdfid,"UTMGrid")'
         write(10,*)'Returned value from gdattach ', status
         write(*,*)'status = he5_gddetach(gdfid,"UTMGrid")'
         write(*,*)'Returned value from gdattach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid_utm,'Grounding','Conduction',
     1" ",HE5T_NATIVE_FLOAT, HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Define: "Grounding"'                  
         write(10,*)'status= he5_gddeffld(gdid_utm,"Grounding",
     1"Conduction","",HE5T_NATIVE_FLOAT,HE5_HDF_NOMERGE)'
         write(10,*)'Value returned by gddeffld ', status
         write(*,*)'Define: "Grounding"'                  
         write(*,*)'status= he5_gddeffld(gdid_utm,"Grounding",
     1"Conduction","",HE5T_NATIVE_FLOAT,HE5_HDF_NOMERGE)'
         write(*,*)'Value returned by gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddefcomp
c
      write(10,27)
      write(10,*)'Testing he5_gddefcomp... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gddefcomp... '
      write(*,*)'=========================='

      tiledims(1) = 16
      tiledims(2) = 15
      status = he5_gddeftle(gdid_utm,HE5_HDFE_TILE,2,tiledims)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'Setup Tiling dimensions '
         write(*,*)'Required when using compression'
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddefcomp(gdid_utm,HE5_HDFE_COMP_DEFLATE, compparm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Setup compression mode'
        write(10,*)'status = he5_gddefcomp(gdid_utm,
     1HE5_HDFE_COMP_DEFLATE, compparm)'
        write(10,*)'Status returned by call to gddefcomp ',status
        write(*,*)'Setup compression mode'
        write(*,*)'status = he5_gddefcomp(gdid_utm,
     1HE5_HDFE_COMP_DEFLATE, compparm)'
        write(*,*)'Status returned by call to gddefcomp ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid_utm,"Voltage","YDim,XDim"," ",
     1HE5T_NATIVE_FLOAT,0)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "Voltage"'
        write(10,*)'status = he5_gddeffld(gdid_utm,"Voltage",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
        write(10,*)'Value returned from gddeffld ', status
        write(*,*)'Define: "Voltage"'
        write(*,*)'status = he5_gddeffld(gdid_utm,"Voltage",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
        write(*,*)'Value returned from gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdsetfill
c
      write(10,27)
      write(10,*)'Testing he5_gdsetfill... '
      write(10,*)'========================'
      write(*,*)'Testing he5_gdsetfill... '
      write(*,*)'========================='

      status = he5_gdsetfill(gdid_utm, "Drift", 
     1HE5T_NATIVE_FLOAT, fillvalue)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Testing he5_gdsetfill'
         write(10,*)'status = he5_gdsetfill(gdid_utm, "Drift", 
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(10,*)'Returned from gdsetfill ', status
         write(*,*)'Testing he5_gdsetfill'
         write(*,*)'status = he5_gdsetfill(gdid_utm, "Drift", 
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(*,*)'Returned from gdsetfill ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid_utm,"Drift","YDim,XDim"," ",
     1HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "Drift"'      
        write(10,*)'status= he5_gddeffld(gdid_utm,"Drift","YDim,XDim",
     1"",HE5T_NATIVE_FLOAT, HE5_HDFE_AUTOMERGE)'
        write(10,*)'Value returned from gddeffld ', status
        write(*,*)'Define: "Drift"'      
        write(*,*)'status= he5_gddeffld(gdid_utm,"Drift","YDim,XDim",
     1"",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
        write(*,*)'Value returned from gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status= he5_gddeffld(gdid_utm,'Impedance','YDim,XDim'," ",
     1HE5T_NATIVE_FLOAT, HE5_HDFE_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Define: "Impedance"'            
         write(10,*)'status= he5_gddeffld(gdid_utm,"Impedance",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
         write(10,*)'Value returned from gddeffld ', status
         write(*,*)'Define: "Impedance"'            
         write(*,*)'status= he5_gddeffld(gdid_utm,"Impedance",
     1"YDim,XDim","",HE5T_NATIVE_FLOAT,HE5_HDFE_AUTOMERGE)'
         write(*,*)'Value returned from gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '


      status = he5_gddetach(gdid_utm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Returned value from gddetach ', status
         write(*,*)'Returned value from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if(gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(10,*)'Handle returned from gdattach ', gdid_utm
         write(*,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(*,*)'Handle returned from gdattach ',gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdwrfld
c
      write(10,27)
      write(10,*)'Testing he5_gdwrfld... '
      write(10,*)'======================'
      write(*,*)'Testing he5_gdwrfld... '
      write(*,*)'======================'

      start(1) = 0
      start(2) = 0
      stride(1) = 1
      stride(2) = 1
      edge(1) = 80
      edge(2) = 60
      
      status = he5_gdwrfld(gdid_utm,"Voltage",start,stride,
     1edge,utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Voltage '
        write(10,*)'status= he5_gdwrfld(gdid_utm,"Voltage",start,
     1stride,edge,utmray)'
        write(10,*)'Status returned by gdwrfield ', status
        write(*,*)'Write to field Voltage '
        write(*,*)'status= he5_gdwrfld(gdid_utm,"Voltage",start,
     1stride,edge,utmray)'
        write(*,*)'Status returned by gdwrfield ', status
      endif
      write(10,*)' '
      write(*,*)' '


      start(1) = 10
      start(2) = 10
      edge(1) = 10
      edge(2) = 10
      status=he5_gdwrfld(gdid_utm,'Drift',start,stride,
     1edge,utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Drift '
        write(10,*)'status=he5_gdwrfld(gdid_utm,"Drift",start,
     1stride,edge,utmray)'
        write(10,*)'Status returned from gdwrfld ', status
        write(*,*)'Write to field Drift '
        write(*,*)'status = he5_gdwrfld(gdid_utm,"Drift",start,
     1stride,edge,utmray)'
        write(*,*)'Status returned from gdwrfld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      start(1) = 0
      start(2) = 0
      edge(1) = 80
      edge(2) = 60
      status = he5_gdwrfld(gdid_utm, 'Impedance', start,stride,
     1edge,utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Impedance '
        write(10,*)'status= he5_gdwrfld(gdid_utm,"Impedance",start,
     1stride,edge,utmray)'
        write(10,*)'Returned from gdwrfld ', status
        write(*,*)'Write to field Impedance '
        write(*,*)'status= he5_gdwrfld(gdid_utm,"Impedance",start,
     1stride,edge,utmray)'
        write(*,*)'Returned from gdwrfld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=4800
      status= he5_gdwrfld(gdid_utm,'Time',start1d,stride1d,
     1edge1d,utmtmeray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Time '
        write(10,*)'status= he5_gdwrfld(gdid_utm,"Time",start1d,
     1stride1d,edge1d,utmtmeray)'
        write(10,*)'Status returned by call to gdwrfld ',status
        write(*,*)'Write to field Time '
        write(*,*)'status= he5_gdwrfld(gdid_utm,"Time",start1d,stride1d,
     1edge1d,utmtmeray)'
        write(*,*)'Status returned by call to gdwrfld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=80
      status= he5_gdwrfld(gdid_utm,'Height',start1d,stride1d,
     1edge1d,utmhght)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Height '
        write(10,*)'status= he5_gdwrfld(gdid_utm,"Height",start1d,
     1stride1d,edge1d,utmhght)'
        write(10,*)'Status returned by call to gdwrfld ',status
        write(*,*)'Write to field Height '
        write(*,*)'status= he5_gdwrfld(gdid_utm,"Height",start1d,
     1stride1d,edge1d,utmhght)'
        write(*,*)'Status returned by call to gdwrfld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=250
      status= he5_gdwrfld(gdid_utm,'Grounding',start1d,
     1stride1d,edge1d,ray3)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Grounding '
        write(10,*)'status= he5_gdwrfld(gdid_utm,"Grounding",start1d,
     1stride1d,edge1d,ray3)'
        write(10,*)'Value returned by gdwrfld ', status
        write(*,*)'Write to field Grounding '
        write(*,*)'status= he5_gdwrfld(gdid_utm,"Grounding",start1d,
     1stride1d,edge1d,ray3)'
        write(*,*)'Value returned by gdwrfld ', status
      endif
        write(10,*)' '
        write(*,*)' '

      status = he5_gddetach(gdid_utm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Value of status returned by gddetach ',status
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Value of status returned by gddetach ',status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(10,*)'Grid id returned by gdattach ',gdid_utm
         write(*,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(*,*)'Grid id returned by gdattach ',gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdwrattr
c
      write(10,27)
      write(10,*)'Testing he5_gdwrattr... Global attribute '
      write(10,*)'==================================== '
      write(*,*)'Testing he5_gdwrattr... Global attribute '
      write(*,*)'==================================== '

      setcount(1) = 4
      status = he5_gdwrattr(gdid_utm, 'Resistance', HE5T_NATIVE_INT, 
     1setcount, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status= he5_gdwrattr(gdid_utm,"Resistance",
     1HE5T_NATIVE_INT, 4, attr)'
         write(10,*)'Returned from gdwrattr ', status
         write(*,*)'status= he5_gdwrattr(gdid_utm,"Resistance",
     1HE5T_NATIVE_FLOAT, 4, attr)'
         write(*,*)'Returned from gdwrattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdwrgattr
c
      write(10,27)
      write(10,*)'Testing he5_gdwrgattr... Group attribute '
      write(10,*)'==================================== '
      write(*,*)'Testing he5_gdwrgattr... Group attribute '
      write(*,*)'==================================== '

      attr(1) = 22
      attr(2) = 44
      attr(3) = 66
      attr(4) = 88
      status = he5_gdwrgattr(gdid_utm, 'group', HE5T_NATIVE_INT, 
     1setcount, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status= he5_gdwrgattr(gdid_utm,"group",
     1HE5T_NATIVE_INT, 4, attr)'
         write(10,*)'Returned from gdwrgattr ', status
         write(*,*)'status= he5_gdwrgattr(gdid_utm,"group",
     1HE5T_NATIVE_INT, 4, attr)'
         write(*,*)'Returned from gdwrgattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdwrlattr
c
      write(10,27)
      write(10,*)'Testing he5_gdwrlattr... Local attribute '
      write(10,*)'======================================== '
      write(*,*)'Testing he5_gdwrlattr... Local attribute '
      write(*,*)'======================================== '

      attr(1) = 12
      attr(2) = 34
      attr(3) = 56
      attr(4) = 78
      status = he5_gdwrlattr(gdid_utm,"Grounding", "local", 
     1HE5T_NATIVE_INT,setcount, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status= he5_gdwrlattr(gdid_utm,"Grounding",
     1"local",HE5T_NATIVE_INT, 4, attr)'
         write(10,*)'Returned from gdwrlattr ', status
         write(*,*)'status= he5_gdwrlattr(gdid_utm,"Grounding",
     1"local",HE5T_NATIVE_INT, 4, attr)'
         write(*,*)'Returned from gdwrlattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid_utm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Returned from gddetach ', status
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Returned from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid2)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gddetach(gdid2)'
         write(10,*)'Value returned by gddetach ', status
         write(*,*)'status = he5_gddetach(gdid2)'
         write(*,*)'Value returned by gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdclose
c
      write(10,27)
      write(10,*)'Testing he5_gdclose... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdclose... '
      write(*,*)'=========================='

      status = he5_gdclose(gdfid2)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gdclose(gdfid2)'
         write(10,*)'Value returned by gdclose ', status
         write(*,*)'status = he5_gdclose(gdfid2)'
         write(*,*)'Value returned by gdclose ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = he5_gdclose(gdfid)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = he5_gdclose(gdfid)'
         write(10,*)'Returned from gdclose ', status
         write(*,*)'status = he5_gdclose(gdfid)'
         write(*,*)'Returned from gdclose ', status
      endif
      write(10,*)' '
      write(*,*)' '

      
      gdfid = he5_gdopen('gridfortran64',HE5F_ACC_RDWR)
      if (gdfid .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'gdfid = he5_gdopen("gridfortran64",HE5F_ACC_RDWR)'
         write(10,*)'gdfid = he5_gdopen("gridfortran64",HE5F_ACC_RDWR)'
         write(*,*)'Grid file id returned by gdopen ',gdfid
         write(10,*)'Grid file id returned by gdopen ',gdfid
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = he5_gdattach(gdfid, 'UTMGrid')
      if (gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(10,*)'gdid_utm = he5_gdattach(gdfid, "UTMGrid")'
         write(*,*)'Grid id returned by gdattach ',gdid_utm
         write(10,*)'Grid id returned by gdattach ',gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdinqgrid
c
      write(10,27)
      write(10,*)'Testing he5_gdinqgrid... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdinqgrid... '
      write(*,*)'=========================='

      lstatus = he5_gdinqgrid('gridfortran64',grdnames,strbufsize)
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = he5_gdinqgrid("gridfortran64",grdnames,
     1strbufsize)'
         write(*,*)'Names of grids ',grdnames
         write(*,*)'Number of grids ',lstatus
         write(*,*)'Size of names of grids ',strbufsize
         write(10,*)'lstatus = he5_gdinqgrid("gridfortran64",grdnames,
     1strbufsize)'
         write(10,*)'Names of grids ',grdnames
         write(10,*)'Number of grids ',lstatus
         write(10,*)'Size of names of grids ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdorginfo
c
      write(10,27)
      write(10,*)'Testing he5_gdorginfo... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdorginfo... '
      write(*,*)'=========================='

      status = he5_gdorginfo(gdid_utm, orgcode)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = he5_gdorginfo(gdid_utm, orgcode)'
         write(10,*)'lstatus = he5_gdorginfo(gdid_utm, orgcode)'
         write(*,*)'Value returned by gdorginfo ',status
         write(10,*)'Value returned by gdorginfo ',status
         write(*,*)'Origin code value ',orgcode
         write(10,*)'Origin code value ',orgcode
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdpreginfo
c
      write(10,27)
      write(10,*)'Testing he5_gdpreginfo... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdpreginfo... '
      write(*,*)'=========================='

      status = he5_gdpreginfo(gdid_utm, pixregcode)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdpreginfo(gdid_utm, pixregcode)'
         write(10,*)'status = he5_gdpreginfo(gdid_utm, pixregcode)'
         write(*,*)'Value returned by gdpreginfo ',status
         write(10,*)'Value returned by gdpreginfo ',status
         write(*,*)'Pixel reg code ',pixregcode
         write(10,*)'Pixel reg code ',pixregcode
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdinqdims
c
      write(10,27)
      write(10,*)'Testing he5_gdinqdims... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdinqdims... '
      write(*,*)'=========================='

      status = he5_gdinqdims(gdid_utm, dimname, dims)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdinqdims(gdid_utm, dimname, dims)'
         write(*,*)'Number of dimensions ',status
         write(*,*)'Dimensions in grid UTM ',dimname
         write(*,*)'Size of dimensions '
         write(10,*)'status = he5_gdinqdims(gdid_utm, dimname, dims)'
         write(10,*)'Number of dimensions ',status
         write(10,*)'Dimensions in grid UTM ',dimname
         write(10,*)'Size of dimensions '
         do 130 i=1,status
            write(*,*)' ',dims(i)
            write(10,*)' ',dims(i)
 130     continue
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddiminfo
c
      write(10,27)
      write(10,*)'Testing he5_gddiminfo... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gddiminfo... '
      write(*,*)'=========================='

      lstatus = he5_gddiminfo(gdid_utm, 'Conduction')
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus=he5_gddiminfo(gdid_utm,"Conduction")'
         write(*,*)'Size of dimension Conduction ',lstatus
         write(10,*)'lstatus=he5_gddiminfo(gdid_utm,"Conduction")'
         write(10,*)'Size of dimension Conduction ',lstatus
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdgridinfo
c
      write(10,27)
      write(10,*)'Testing he5_gdgridinfo... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdgridinfo... '
      write(*,*)'=========================='

      status= he5_gdgridinfo(gdid_utm,xdimsize,ydimsize,
     1upleftpt,lowrtpt)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status= he5_gdgridinfo(gdid_utm,xdimsize,
     1ydimsize,upleftpt,lowrtpt)'
         write(*,*)'Status returned by gdgridinfo ',status
         write(*,11)'X dim size ',xdimsize, ' Y dim size ',ydimsize
         write(*,12)'Upper left pt ',upleftpt(1),' ',upleftpt(2)
         write(*,12)'Lower right pt ',lowrtpt(1),' ',lowrtpt(2)
         write(10,*)'status= he5_gdgridinfo(gdid_utm,xdimsize,
     1ydimsize,upleftpt,lowrtpt)'
         write(10,*)'Value returned by gdgridinfo ',status
         write(10,*)'X dim size ',xdimsize, ' Y dim size ',ydimsize
         write(10,*)'Upper left pt ',upleftpt(1),upleftpt(2)
         write(10,*)'Lower right pt ',lowrtpt(1),lowrtpt(2)
      endif
      write(10,*)' '
      write(*,*)' '
   11 format(a,i2,a,i2)
   12 format(a,f14.5,a,f14.5)

c Test Case -- he5_gdprojinfo
c
      write(10,27)
      write(10,*)'Testing he5_gdprojinfo... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdprojinfo... '
      write(*,*)'=========================='

      status = he5_gdprojinfo(gdid_utm,pcode,zcode,scode,pparm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdprojinfo(gdid_utm,pcode,
     1zcode,scode,pparm)'
         write(*,*)'Status returned by gdprojinfo ',status
         write(*,*)'Projection code ',pcode, ' Zone code ',zcode
         write(*,*)'Sphere code ',scode
         write(10,*)'status = he5_gdprojinfo(gdid_utm,pcode,
     1zcode,scode,pparm)'
         write(10,*)'Value returned by gdprojinfo ',status
         write(10,*)'Projection code ',pcode, ' Zone code ',zcode
         write(10,*)'Sphere code ',scode
         do 140 i=1,16
            write(*,55)' ',pparm(i)
            write(10,55)' ',pparm(i)
 140     continue
      endif
   55 format(a,f5.2)
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdcompinfo
c
      write(10,27)
      write(10,*)'Testing he5_gdcompinfo... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdcompinfo... '
      write(*,*)'=========================='

      status = he5_gdcompinfo(gdid_utm,'Voltage',
     1compcodestring,compparm)
      if (status .lt. zero) then
         
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = he5_gdcompinfo(gdid_utm,"Voltage",
     1compcode,compparm)'
        write(10,*)'Compression info for field Voltage'
        write(10,*)'Comp code ',compcodestring
        write(10,*)'Compression parameters ',compparm
        write(*,*)'status = he5_gdcompinfo(gdid_utm,"Voltage",
     1compcode,compparm)'
        write(*,*)'Compression info for field Voltage'
        write(*,*)'Comp code ',compcodestring
        write(*,*)'Compression parameters ',compparm
      endif

c Test Case -- he5_gdinqflds
c
      write(10,27)
      write(10,*)'Testing he5_gdinqflds... '
      write(10,*)'========================'
      write(*,*)'Testing he5_gdinqflds... '
      write(*,*)'========================'

      nflds = he5_gdinqflds(gdid_utm,fldlist,rnk,numtype)
      if (nflds .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'nflds = he5_gdinqflds(gdid_utm,
     1fldlist,rnk,numtype)'
         write(*,*)'Number of fields ',nflds
         write(10,*)'nflds = he5_gdinqflds(gdid_utm,
     1fldlist,rnk,numtype)'
         write(10,*)'Number of fields ',nflds
         if (nflds .ne. 0) then
            write(*,*)'Fields ',fldlist
            write(10,*)'Fields ',fldlist
            do 150 i=1,nflds
               write(*,*)'Rank and type ',rnk(i), ' ',numtype(i)
               write(10,*)'Rank and type ',rnk(i), ' ',numtype(i)
  150       continue
         endif
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdfldinfo
c
      write(10,27)
      write(10,*)'Testing he5_gdfldinfo... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdfldinfo... '
      write(*,*)'=========================='

      status = he5_gdfldinfo(gdid_utm, 'Drift', rnk, dims, 
     1numtype, dimname, maxdimname)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdfldinfo(gdid_utm, "Drift", 
     1rnk, dims, numtype, dimname, maxdimname)'
         write(*,*)'Value returned by gdfldinfo for field Drift ',
     1status
         write(*,*)'Drift rank ',rnk(1)
         write(*,*)'Dimensions  ',dims(1),' ',dims(2)
         write(*,*)'Number type of field ',numtype(1)
         write(*,*)'Dimension names ',dimname
         write(10,*)'status = he5_gdfldinfo(gdid_utm, "Drift",
     1rnk, dims, numtype, dimname, maxdimname)'
         write(10,*)'Value returned by gdfldinfo for field Drift ',
     1status
         write(10,*)'Drift rank ',rnk(1)
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdrdfld
c
      write(10,27)
      write(10,*)'Testing he5_gdrdfld... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdrdfld... '
      write(*,*)'=========================='

      start(1) = 0
      start(2) = 0
      stride(1) = 1
      stride(2) = 1
      edge(1) = 80
      edge(2) = 60
      status = he5_gdrdfld(gdid_utm,'Drift',start,stride,edge,tempray)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdrdfld(gdid_utm,"Drift",
     1start,stride,edge,tempray)'
         write(*,*)'Value returned by gdrdfld ',status
         write(10,*)'status = he5_gdrdfld(gdid_utm,"Drift",
     1start,stride,edge,tempray)'
         write(10,*)'Value returned by gdrdfld ',status
         do 65 ii=1,6
           do 66 i=1,5
              write(10,*)'Field value at ',ii,' ',i,'  ',
     1tempray(ii,i)
              write(*,*)'Field value at ',ii,' ',i,'  ',
     1tempray(ii,i)
   66      continue
   65   continue
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdnentries
c
      write(10,27)
      write(10,*)'Testing he5_gdnentries... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdnentries... '
      write(*,*)'=========================='

      n=he5_gdnentries(gdid_utm,HE5_HDFE_NENTDIM,strbufsize)
      if (n .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'n = he5_gdnentries(gdid_utm, 
     1HE5_HDFE_NENTDIM, strbufsize)'
         write(*,*)'Number of dimensions ', n
         write(*,*)'Size of Dimension string ',strbufsize
         write(10,*)'n = he5_gdnentries(gdid_utm, 
     1HE5_HDFE_NENTDIM, strbufsize)'
         write(10,*)'Number of dimensions ', n
         write(10,*)'Size of Dimension string ',strbufsize
      endif

      n = he5_gdnentries(gdid_utm,HE5_HDFE_NENTDFLD,strbufsize)
      if (n .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'n = he5_gdnentries(gdid_utm,
     1HE5_HDFE_NENTDFLD,strbufsize)'
         write(*,*)'Number of data fields ',n
         write(*,*)'Size of Field string ',strbufsize
         write(10,*)'n = he5_gdnentries(gdid_utm,
     1HDFE_NENTDFLD,strbufsize)'
         write(10,*)'Number of data fields ',n
         write(10,*)'Size of Field string ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdattrinfo
c
      write(10,27)
      write(10,*)'Testing he5_gdattrinfo, Global attribute'
      write(10,*)'============================================'
      write(*,*)'Testing he5_gdattrinfo, Global attribute'
      write(*,*)'============================================'

      status = he5_gdattrinfo(gdid_utm,'Resistance',ntype,count)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdattrinfo(gdid_utm,"Resistance",
     1ntype,count)'
         write(*,*)'Value returned by gdattrinfo ',status
         write(*,*)'Number type of attribute ',ntype
         write(*,*)'Number of total bytes in attribute ',count
         write(10,*)'status = he5_gdattrinfo(gdid_utm,"Resistance",
     1ntype,count)'
         write(10,*)'Value returned by gdattrinfo ',status
         write(10,*)'Number type of attribute ',ntype
         write(10,*)'Number of total bytes in attribute ',count
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdgatinfo
c
      write(10,27)
      write(10,*)'Testing he5_gdgatinfo, Group attribute'
      write(10,*)'============================================'
      write(*,*)'Testing he5_gdgatinfo, Group attribute'
      write(*,*)'============================================'

      status = he5_gdgatinfo(gdid_utm,'group',ntype,count)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdgatinfo(gdid_utm,"group",
     1ntype,count)'
         write(*,*)'Value returned by gdgatinfo ',status
         write(*,*)'Number type of attribute ',ntype
         write(*,*)'Number of total bytes in attribute ',count
         write(10,*)'status = he5_gdgatinfo(gdid_utm,"group",
     1ntype,count)'
         write(10,*)'Value returned by gdgatinfo ',status
         write(10,*)'Number type of attribute ',ntype
         write(10,*)'Number of total bytes in attribute ',count
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdlatinfo
c
      write(10,27)
      write(10,*)'Testing he5_gdlatinfo, Local attribute'
      write(10,*)'======================================'
      write(*,*)'Testing he5_gdlatinfo, Local attribute'
      write(*,*)'======================================'

      status = he5_gdlatinfo(gdid_utm,"Grounding","local",
     1ntype,count)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdlatinfo(gdid_utm,"Grounding",
     1"local",ntype,count)'
         write(*,*)'Value returned by gdlatinfo ',status
         write(*,*)'Number type of attribute ',ntype
         write(*,*)'Number of total bytes in attribute ',count
         write(10,*)'status = he5_gdlatinfo(gdid_utm,"Grounding",
     1"local",ntype,count)'
         write(10,*)'Value returned by gdgatinfo ',status
         write(10,*)'Number type of attribute ',ntype
         write(10,*)'Number of total bytes in attribute ',count
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdrdattr
c
      write(10,27)
      write(10,*)'Testing he5_gdrdattr, Global attribute'
      write(10,*)'======================================'
      write(*,*)'Testing he5_gdrdattr, Global attribute'
      write(*,*)'======================================'

      status = he5_gdrdattr(gdid_utm,'Resistance',iattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status = he5_gdrdattr(gdid_utm,"Resistance",
     1iattr)'
        write(*,*)'Value returned by gdrdattr ',status
        write(10,*)'status = he5_gdrdattr(gdid_utm,"Resistance",
     1iattr)'
        write(10,*)'Value returned by gdrdattr ',status
        do 67 i=1,count
           write(10,*)'Attribute value  ',iattr(i)
           write(*,*)'Attribute value   ',iattr(i)
   67   continue
        
      endif
      write(10,*)' '
      write(*,*)' '
  
c Test Case -- he5_gdrdgattr
c
      write(10,27)
      write(10,*)'Testing he5_gdrdgattr, Group attribute '
      write(10,*)'======================================'
      write(*,*)'Testing he5_gdrdgattr, Group attribute'
      write(*,*)'======================================'

      status = he5_gdrdgattr(gdid_utm,'group',gattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status = he5_gdrdgattr(gdid_utm,"group",
     1gattr)'
        write(*,*)'Value returned by gdrdgattr ',status
        write(10,*)'status = he5_gdrdgattr(gdid_utm,"group",
     1gattr)'
        write(10,*)'Value returned by gdrdgattr ',status
        do 68 i=1,count
           write(10,*)'Attribute value  ',gattr(i)
           write(*,*)'Attribute value   ',gattr(i)
   68   continue
        
      endif
      write(10,*)' '
      write(*,*)' '
  
c Test Case -- he5_gdinqdatatype
c
      write(10,27)
      write(10,*)'Testing he5_gdinqdatatype '
      write(10,*)'============================='
      write(*,*)'Testing he5_gdinqdatatype'
      write(*,*)'============================='

      status = he5_gdinqdatatype(gdid_utm,"Grounding","local",
     1HE5_HDFE_LOCATTRGROUP,dtype,classid,order,size)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
        write(*,*)' '
        write(*,240)
        write(10,*)' '
        write(10,240)
         write(*,*)'status = he5_gdinqdatatype(gdid_utm,"Grounding",
     1"local",HE5_HDFE_LOCATTRGROUP,dtype,classid,order,size)'
         write(*,*)'Data type of attribute ',dtype
         write(*,*)'Class id of attribute ',classid
         write(*,*)'Order of attribute ',order
         write(*,*)'Size of attribute ',size
         write(10,*)'status = he5_gdinqdatatype(gdid_utm,"Grounding",
     1"local", HE5_HDFE_LOCATTRGROUP,dtype,classid,order,size)'
         write(10,*)'Data type of attribute ',dtype
         write(10,*)'Class id of attribute ',classid
         write(10,*)'Order of attribute ',order
         write(10,*)'Size of attribute ',size
      endif
      write(10,*)' '
      write(*,*)' '
c Test Case -- he5_gdrdlattr
c
      write(10,27)
      write(10,*)'Testing he5_gdrdlattr, Local attribute '
      write(10,*)'======================================'
      write(*,*)'Testing he5_gdrdlattr, Local attribute'
      write(*,*)'======================================'

      status = he5_gdrdlattr(gdid_utm,'Grounding',
     1'local',lattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status = he5_gdrdlattr(gdid_utm,"Grounding",
     1"local",lattr)'
        write(*,*)'Value returned by gdrdlattr ',status
        write(10,*)'status = he5_gdrdlattr(gdid_utm,"Grounding",
     1"local",lattr)'
        write(10,*)'Value returned by gdrdlattr ',status
        do 69 i=1,count
           write(10,*)'Attribute value  ',lattr(i)
           write(*,*)'Attribute value   ',lattr(i)
   69   continue
        
      endif
      write(10,*)' '
      write(*,*)' '
  
c Test Case -- he5_gdinqattrs
c
      write(10,27)
      write(10,*)'Testing he5_gdinqattrs, Global attribute'
      write(10,*)'========================================'
      write(*,*)'Testing he5_gdinqattrs, Global attribute'
      write(*,*)'========================================'

      lstatus = he5_gdinqattrs(gdid_utm, attrlist,strbufsize)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = he5_gdinqattrs(gdid_utm, 
     1attrlist,strbufsize)'
        write(*,*)'Value returned by gdinqattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(*,*)'Length of attrlist in bytes ',strbufsize
        write(10,*)'lstatus = he5_gdinqattrs(gdid_utm, 
     1attrlist,strbufsize)'
        write(10,*)'Value returned by gdinqattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
        write(10,*)'Length of attrlist in bytes ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdinqgattrs
c
      write(10,27)
      write(10,*)'Testing he5_gdinqgattrs, Group attribute'
      write(10,*)'============================================'
      write(*,*)'Testing he5_gdinqgattrs, Group attribute'
      write(*,*)'============================================'

      lstatus = he5_gdinqgattrs(gdid_utm,attrlist,strbufsize)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = he5_gdinqgattrs(gdid_utm, 
     1attrlist,strbufsize)'
        write(*,*)'Value returned by gdinqgattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(*,*)'Length of attrlist in bytes ',strbufsize
        write(10,*)'lstatus = he5_gdinqgattrs(gdid_utm,
     1attrlist,strbufsize)'
        write(10,*)'Value returned by gdinqgattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
        write(10,*)'Length of attrlist in bytes ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdinqlattrs
c
      write(10,27)
      write(10,*)'Testing he5_gdinqlattrs, Local attribute'
      write(10,*)'========================================'
      write(*,*)'Testing he5_gdinqlattrs, Local attribute'
      write(*,*)'========================================'

      lstatus = he5_gdinqlattrs(gdid_utm,"Grounding",attrlist,
     1strbufsize)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = he5_gdinqlattrs(gdid_utm,"Grounding",
     1attrlist,strbufsize)'
        write(*,*)'Value returned by gdinqlattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(*,*)'Length of attrlist in bytes ',strbufsize
        write(10,*)'lstatus = he5_gdinqlattrs(gdid_utm,"Grounding",
     1attrlist, strbufsize)'
        write(10,*)'Value returned by gdinqlattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
        write(10,*)'Length of attrlist in bytes ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdgetfill
c
      write(10,27)
      write(10,*)'Testing he5_gdgetfill... '
      write(10,*)'======================='
      write(*,*)'Testing he5_gdgetfill... '
      write(*,*)'========================'

      status = he5_gdgetfill(gdid_utm,'Drift',ifillv)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdgetfill(gdid_utm,"Drift",
     1ifillv)'
         write(*,*)'Value returned by gdgetfill ',status
         write(*,*)'Fill value ',ifillv
         write(10,*)'status = he5_gdgetfill(gdid_utm,"Drift",
     1ifillv)'
         write(10,*)'Value returned by gdgetfill ',status
         write(10,*)'Fill value ',ifillv
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddefboxreg
c
      write(10,27)
      write(10,*)'Testing he5_gddefboxreg... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gddefboxreg... '
      write(*,*)'=========================='

      corlon(1)=-126.0
      corlon(2)=-121.5
      corlat(1)=-70.0
      corlat(2)=-65.0

      regionid = he5_gddefboxreg(gdid_utm,corlon,corlat)
      if (regionid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'regionid = he5_gddefboxreg(gdid_utm,
     1corlon,corlat)'
         write(*,*)'Region id returned by gddefboxreg ',regionid
         write(10,*)'regionid = he5_gddefboxreg(gdid_utm,
     1corlon,corlat)'
         write(10,*)'Region id returned by gddefboxreg ',regionid
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdreginfo
c
      write(10,27)
      write(10,*)'Testing he5_gdreginfo... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdreginfo... '
      write(*,*)'=========================='

      status = he5_gdreginfo(gdid_utm,regionid,'Impedance',nt,rk,
     1dims,size,iuplft,ilrgt)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdreginfo(gdid_utm,regionid,
     1"Impedance",nt, rk,dims,size,iuplft,ilrgt)'
         write(*,*)'Value returned by gdreginfo ',status
         write(*,*)'Number type of region ',nt
         write(*,*)'Rank of region ',rk
         write(*,*)'Size of region ',size
         write(*,11)'Dimensions of region ',dims(1),' ',dims(2)
         write(*,12)'Upper left point of region ',iuplft(1),' ',
     1iuplft(2)
         write(*,12)'Lower right point of region ',ilrgt(1),' ',
     1ilrgt(2)
         write(10,*)'status = he5_gdreginfo(gdid_utm,regionid,
     1"Impedance",nt,rk,dims,size,iuplft,ilrgt)'
         write(10,*)'Value returned by gdreginfo ',status
         write(10,*)'Number type of region ',nt
         write(10,*)'Rank of region ',rk
         write(10,*)'Size of region ',size
         write(10,11)'Dimensions of region ',dims(1),' ',dims(2)
         write(10,12)'Upper left point of region ',iuplft(1),' ',
     1iuplft(2)
         write(10,12)'Lower right point of region ',ilrgt(1),' ',
     1ilrgt(2)
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdextreg
c
      write(10,27)
      write(10,*)'Testing he5_gdextreg... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdextreg... '
      write(*,*)'=========================='

      status = he5_gdextreg(gdid_utm,regionid,'Impedance',datbuf)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdextreg(gdid_utm,regionid,
     1"Impedance",datbuf)'
         write(*,*)'Value returned by gdextreg ',status
         write(10,*)'status = he5_gdextreg(gdid_utm,regionid,
     1"Impedance",datbuf)'
         write(10,*)'Value returned by gdextreg ',status
         do 175 i=100,150
            write(*,*)'Value of region ',datbuf(i)
            write(10,*)'Value of region ',datbuf(i)
  175    continue
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddeftmeper
c
      write(10,27)
      write(10,*)'Testing he5_gddeftmeper... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gddeftmeper... '
      write(*,*)'=========================='

      periodid = he5_gddeftmeper(gdid_utm,HE5_HDFE_NOPREVSUB,
     1starttime,stoptime)
      if (periodid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'periodid = he5_gddeftmeper(gdid_utm,
     1HE5_HDFE_NOPREVSUB,starttime,stoptime)'
        write(10,*)'Define a time period '
        write(10,*)'Period id returned by gddeftmeper ',periodid
        write(*,*)'periodid = he5_gddeftmeper(gdid_utm,
     1HE5_HDFE_NOPREVSUB,starttime,stoptime)'
        write(*,*)'Define a time period '
        write(*,*)'Period id returned by gddeftmeper ',periodid
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddefvrtreg
c
      write(10,27)
      write(10,*)'Testing he5_gddefvrtreg... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gddefvrtreg... '
      write(*,*)'=========================='

      regionid = he5_gddefvrtreg(gdid_utm,HE5_HDFE_NOPREVSUB,
     1'Height',range)
      if (regionid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'regionid = he5_gddefvrtreg(gdid_utm,
     1HE5_HDFE_NOPREVSUB,"Height",range)'
        write(10,*)'Define a vertical region '
        write(10,*)'Region id returned by gddefvrtreg ',regionid
        write(*,*)'regionid = he5_gddefvrtreg(gdid_utm,
     1HE5_HDFE_NOPREVSUB,"Height",range)'
        write(*,*)'Define a vertical region '
        write(*,*)'Region id returned by gddefvrtreg ',regionid
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gddupreg
c
      write(10,27)
      write(10,*)'Testing he5_gddupreg... '
      write(10,*)'======================='
      write(*,*)'Testing he5_gddupreg... '
      write(*,*)'======================='

      regionid2 = he5_gddupreg(regionid)
      if (regionid2 .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'regionid2 = he5_gddupreg(regionid)'
        write(10,*)'Generate a new region id '
        write(10,*)'New region id ',regionid2
        write(*,*)'regionid2 = he5_gddupreg(regionid)'
        write(*,*)'Generate a new region id '
        write(*,*)'New region id ',regionid2
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdgetpix
c
      write(10,27)
      write(10,*)'Testing he5_gdgetpix... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdgetpix... '
      write(*,*)'=========================='

      nlonlat = 5
      status= he5_gdgetpix(gdid_utm,nlonlat,lonval,
     1latval,rowval,colval)             
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = he5_gdgetpix(gdid_utm,5,lonval,
     1latval,rowval,colval)'
        write(10,*)'Retrieve pixel row. column values '
        write(*,*)'status = he5_gdgetpix(gdid_utm,5,lonval,latval,
     1rowval,colval)'
        write(*,*)'Retrieve pixel row. column values '
        do 37 i=1,5
           write(10,5)'Pixel position lon lat ',lonval(i),' ',
     1latval(i),' ','Row Column ',rowval(i),' ',colval(i) 
           write(*,5)'Pixel position lon lat ',lonval(i),' ',
     1latval(i),' ','Row Column ',rowval(i),' ',colval(i) 
   37   continue
      endif
    5 format(a,f6.1,a,f6.1,a,a,i2,a,i2)
      write(10,*)' '
      write(*,*)' '

c Test Case -- he5_gdgetpixval
c
      write(10,27)
      write(10,*)'Testing he5_gdgetpixval... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdgetpixval... '
      write(*,*)'=========================='

      nlonlat = 5
      size= he5_gdgetpixval(gdid_utm,nlonlat,rowval,colval,
     1"Voltage",fldval)
      if (size .le. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'lstatus = he5_gdgetpixval(gdid_utm,5,rowval,
     1colval,"Voltage",fldval)'
        write(10,*)'Retrieve pixel values for specific locations '
        write(*,*)'lstatus = he5_gdgetpixval(gdid_utm,5,rowval,
     1colval,"Voltage",fldval)'
        write(*,*)'Retrieve pixel values for specific locations '
        do i=1,5
           write(10,17)'Row Col ',rowval(i),' ',colval(i),' ',
     1'Pixel Value ',fldval(i)
           write(*,17)'Row Col ',rowval(i),' ',colval(i),' ',
     1'Pixel Value ',fldval(i)
        enddo
      endif
   17 format(a8,i2,a1,i2,a1,a12,f9.3)
      write(10,*)' '
      write(*,*)' '


c Test Case -- he5_gdinterpolate
c
      write(10,27)
      write(10,*)'Testing he5_gdinterpolate... '
      write(10,*)'=========================='
      write(*,*)'Testing he5_gdinterpolate... '
      write(*,*)'=========================='

      nlonlat = 5
      size= he5_gdinterpolate(gdid_utm,nlonlat,lonval,latval,
     1'Voltage',interval)
      if (size .le. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'lstatus= he5_gdinterpolate(gdid_utm,5,lonval,
     1latval,"Voltage",interval)'
        write(10,*)'Interpolate 5 values for field Voltage '
        write(*,*)'lstatus= he5_gdinterpolate(gdid_utm,5,lonval,
     1latval,"Voltage",interval)'
        write(*,*)'Interpolate 5 values for field Voltage '
        write(*,*)'Status returned by call to gdinterpolate ',lstatus
        do i=1,5
           write(*,4)'Interpolated value ',interval(i,1)
           write(10,4)'Interpolated value ',interval(i,1)
        enddo
      endif
    4 format(a,f9.3)
      write(10,*)' '
      write(*,*)' '

      status = he5_gddetach(gdid_utm)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gddetach(gdid_utm)'
         write(*,*)'Value returned by gddetach ',status
         write(10,*)'status = he5_gddetach(gdid_utm)'
         write(10,*)'Value returned by gddetach ',status
      endif

      status = he5_gdclose(gdfid)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = he5_gdclose(gdfid)'
         write(*,*)'Returned from gdclose ', status
         write(10,*)'status = he5_gdclose(gdfid)'
         write(10,*)'Returned from gdclose ', status
      endif

      close(unit=10)
 27   format(' ')
      stop
      end

!     In this program we (1) open the "za.he5" file, (2) attach to
!     the "ZA1" za, and (3) read data from the "Spectra" field
!     ============================================================

      program            he5_za_readdataF_64

      implicit           none

      include            'hdfeos5.inc'

      integer            status
      integer            he5_zaopen
      integer            he5_zaattach
      integer            he5_zaread
      integer            he5_zardattr
      integer            he5_zadetach
      integer            he5_zaclose
      integer            zafid, zaid
      integer            i,j,k

      integer*4          attr(4)

      integer*8          start(3)
      integer*8          stride(3)
      integer*8          count(3)

      real*8             plane(800)

      integer            FAIL
      parameter          (FAIL=-1)

    
!     Open HDF-EOS za file, "za.he5"
!     ------------------------------
	  zafid = he5_zaopen("za.he5",HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_zaopen():  ',zafid

	  if (zafid .NE. FAIL) then
		 zaid = he5_zaattach(zafid, "ZA1")
         write(*,*) 'ZA ID returned by he5_zaattach():  ',zaid

		 if (zaid .NE. FAIL) then
			
	      
!     Read the entire Spectra field
!     -----------------------------
                        start(1)  = 0
                        start(2)  = 0
                        count(1)  = 20
                        count(2)  = 40
                        count(3)  = 1
                        stride(1) = 1
                        stride(2) = 1
                        stride(3) = 1
 
                        do i=1,15
                           start(3) = i - 1
                           do j=1,40
                                  do k=1,20
					plane((j-1)*20+k) = (j-1)*100 + i-1
                                  enddo
                           enddo
                           status = he5_zaread(zaid,"Spectra",start,
     1              stride,count,plane)
                        enddo
 

            
!     Read Attribute
!     --------------	      
			status = he5_zardattr(zaid, "TestAttr", attr)
			do i=1,4
			   write(*,*) 'Attribute Element', i, ':', attr(i)
			enddo	      
			
		 endif
	  endif
      
!     Detach from the za
!     ------------------
	  status = he5_zadetach(zaid)
      write(*,*) 'Status returned from he5_zadetach:  ',status
      
!     Close the file
!     --------------
	  status = he5_zaclose(zafid)
      write(*,*) 'Status returned from he5_zaclose:  ',status
      
	  stop
	  end

!
! ----------------------------------------------------------------------------
! |    Copyright (C) 2002   Emergent IT Inc. and Raytheon Systems Company    |
! ----------------------------------------------------------------------------
!

      program            he5_za_wrexternaldataF_32

      implicit           none
 
      include            'hdfeos5.inc'

      integer            i
      integer            status
      integer            he5_zaopen
      integer            he5_zaattach
      integer            he5_zawrite
      integer            he5_ehrdwrfile
      integer            he5_zadetach
      integer            he5_zaclose
      integer            zafid, zaid

      integer            data_out_1(100)
      integer            data_out_2(100)
      integer            data_out_3(100)
      integer            data(60)

      integer*4          start(2)
      integer*4          stride(2)
      integer*4          count(2)
      integer*4          num_elements

      integer            FAIL
      parameter          (FAIL=-1)

!.....Use this for writing (only) to an existing file
      integer            WRITE_EXISTING_ONLY
      parameter          (WRITE_EXISTING_ONLY=0)

!.....Use this for reading (only) from an existing file
      integer            READ_ONLY
      parameter          (READ_ONLY=1)

!.....Use this for creating and writing to a file
      integer            WRITE_NEW
      parameter          (WRITE_NEW=2)


!     Create the new data buffer
!     --------------------------
      do 10 i=1,60
         data(i) = 9999
 10   continue
      
!     Open HDF-EOS za file, "za.he5"
!     ------------------------------
	  zafid = he5_zaopen("za.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned from he5_zaopen():  ',zafid

	  if (zafid .NE. FAIL) then
		 zaid = he5_zaattach(zafid, "ZA1")
         write(*,*) 'ZA ID returned from he5_zaattach():  ',zaid

		 if (zaid .NE. FAIL) then
			
!     Write new data to the external files 
!     ------------------------------------
      start(1)  = 0
      stride(1) = 1
      count(1)  = 60

      status = he5_zawrite(zaid,"ExtData",
     1     start,stride,count,data)
      write(*,*) 'Status returned from he5_zawrite():  ',status

      num_elements = 100

      status = he5_ehrdwrfile("extf1.dat",READ_ONLY,
     1HE5T_NATIVE_INT,num_elements,data_out_1)
      write(*,*) 'Status returned from he5_ehrdwrfile:   ',status

      status = he5_ehrdwrfile("extf2.dat",READ_ONLY,
     1HE5T_NATIVE_INT,num_elements,data_out_2)
      write(*,*) 'Status returned from he5_ehrdwrfile:   ',status

      status = he5_ehrdwrfile("extf3.dat",READ_ONLY,
     1HE5T_NATIVE_INT,num_elements,data_out_3)
      write(*,*) 'Status returned from he5_ehrdwrfile:   ',status

      write(*,*)'External file extf1.dat:'
      write(*,*) data_out_1
      write(*,*) '  '

      write(*,*)'External file extf2.dat:'
      write(*,*) data_out_2
      write(*,*) '  '

      write(*,*)'External file extf3.dat:'
      write(*,*) data_out_3
      write(*,*) '  '

		 endif
	  endif
	
!     Detach from za
!     --------------
	  status = he5_zadetach(zaid)
      write(*,*) 'Status returned from he5_zadetach():  ',status

!     Close the file
!     --------------
	  status = he5_zaclose(zafid)
      write(*,*) 'Status returned from he5_zaclose():  ',status
      
	  stop
	  end

      program       he5_pt_writedataF_64

      implicit      none
 
      include       'hdfeos5.inc'
 
      integer       status
      integer       ptfid 
      integer       ptid
      integer       he5_ptopen
      integer       he5_ptattach
      integer       he5_ptwritelevel 
      integer       he5_ptfort2c
      integer       he5_ptwrbckptr
      integer       he5_ptwrfwdptr
      integer       he5_ptwriteattr 
      integer       he5_ptdetach 
      integer       he5_ptclose
      integer       i
      integer       rank
      integer       dtype
      integer       attr
      integer       ntype

      integer*8     n
      integer*8     count(1)
      integer*8     dimens(2)
      integer*8     fortcount(8)

      real*4        flt      

      character*80  fieldname
      character*80  attrname

c.....used by Simple Point
      real*8        time_tt
      real*8        time(15)
      real*4        concentration_tt(4)
      real*4        conc(15,4)
      real*4        outconc(4,15)
      character*8   spc_tt
      character*8   spc(15)

c.....used by FixedBuoy Point - Level 0
      character*8   desc_tt
      character*8   desc(3)
      real*8        lon_tt
      real*8        lon(3)
      real*8        lat_tt
      real*8        lat(3)
      integer*4     date_tt
      integer*4     date(3)
      character*8   id_tt
      character*8   id(3)

c.....used by FixedBuoy Point - Level 1
      real*8        time3_tt
      real*8        time3(20)
      real*4        rain_tt
      real*4        rain(20)
      real*4        temp_tt
      real*4        temp(20)
      character*8   id3_tt
      character*8   id3(20)

c.....used by FloatBuoy Point - Level 0
      character*8   desc4_tt
      character*8   desc4(3)
      integer*4     date4_tt
      integer*4     date4(3)
      integer*4     wgt_tt
      integer*4     wgt(3)
      character*8   id4_tt
      character*8   id4(3)

c.....used by FloatBuoy Point - Level 1
      real*8        time5_tt
      real*8        time5(25)
      real*8        lon5_tt
      real*8        lon5(25)
      real*8        lat5_tt
      real*8        lat5(25)
      real*4        rain5_tt
      real*4        rain5(25)
      real*4        temp5_tt
      real*4        temp5(25)
      character*8   id5_tt
      character*8   id5(25)


c     Open the HDF-EOS point file, "point.he5"
c     ----------------------------------------
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_ptopen():  ',ptfid

c     Do Simple Point 
c     --------------- 
      ptid = HE5_PTattach(ptfid, "Simple Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid

c     Read Simple Point 
c     ----------------- 
      open(unit=1, file='simple.txt', status='OLD')

      n = 0
      do 10 i=1,1000
         read(1, 110, end=100) time_tt, concentration_tt(1), 
     1                                  concentration_tt(2), 
     2                                  concentration_tt(3),
     3                                  concentration_tt(4), 
     4                                  spc_tt
         time(i)     = time_tt
         conc(i,1)   = concentration_tt(1)
         conc(i,2)   = concentration_tt(2)
         conc(i,3)   = concentration_tt(3)
         conc(i,4)   = concentration_tt(4)
         spc(i)      = spc_tt

         n = n + 1
   10 continue

  100 close(unit=1)
  110 format(F13.1,F6.2,F6.2,F6.2,F6.2,2X,A8)

      count(1) = n

      fieldname      = 'Time'
      dtype       = HE5T_NATIVE_DOUBLE

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1dtype, time)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status
   
c.....Convert array to 'C' order
      dimens(1) = 15
      dimens(2) = 4
      rank      = 2
      dtype  = HE5T_NATIVE_FLOAT

      status    = he5_ptfort2c(dimens, rank, dtype, conc, 
     1outconc)
      write(*,*) 'Status returned by he5_ptfort2c():  ',status


      fieldname      = 'Concentration'

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1dtype, outconc)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status


      fieldname      = 'Species'
      dtype       = HE5T_NATIVE_CHAR

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1dtype, spc)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

c.....Close out the point interface
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status

c     Do FixedBuoy Point 
c     ------------------ 
      ptid = HE5_PTattach(ptfid, "FixedBuoy Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid

c     Read FixedBuoy Point 
c     -------------------- 
      open(unit=1, file='fixedBuoy0.txt', status='OLD')

      n = 0
      do 20 i=1,1000
         read(1, 210, end=200) desc_tt, lon_tt, lat_tt, date_tt, 
     1id_tt
         desc(i)     = desc_tt
         lon(i)      = lon_tt
         lat(i)      = lat_tt
         date(i)     = date_tt
         id(i)       = id_tt

         n = n + 1
   20 continue

  200 close(unit=1)
  210 format(A8,F13.7,F13.7,I7,1X,A8)

      count(1) = n

      fieldname      = 'Label'
      dtype       = HE5T_NATIVE_CHAR

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1dtype, desc)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'Longitude'
      dtype       = HE5T_NATIVE_DOUBLE

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1dtype, lon)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'Latitude'
      dtype       = HE5T_NATIVE_DOUBLE

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1dtype, lat)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'DeployDate'
      dtype       = HE5T_NATIVE_INT

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1dtype, date)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'ID'
      dtype       = HE5T_NATIVE_CHAR

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1dtype, id)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status


c     Read FixedBuoy Point - Level 1
c     ------------------------------ 
      open(unit=1, file='fixedBuoy1.txt', status='OLD')

      n = 0
      do 30 i=1,1000
         read(1, 310, end=300) time3_tt, rain_tt, temp_tt, id3_tt 
         time3(i)     = time3_tt
         rain(i)      = rain_tt
         temp(i)      = temp_tt
         id3(i)       = id3_tt

         n = n + 1
   30 continue

  300 close(unit=1)
  310 format(F13.2,F8.1,F8.2,3X,A8)

      count(1) = n

      fieldname      = 'Time'
      dtype       = HE5T_NATIVE_DOUBLE

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1dtype, time3)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'Rainfall'
      dtype       = HE5T_NATIVE_FLOAT

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1dtype, rain)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'Temperature'
      dtype       = HE5T_NATIVE_FLOAT

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1dtype, temp)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status


      fieldname      = 'ID'
      dtype       = HE5T_NATIVE_CHAR

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1dtype, id3)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

c.....Write forward and backward pointers
      status = he5_ptwrbckptr(ptid,1)
      write(*,*) 'Status returned by he5_ptwrbckptr():  ',status

      status = he5_ptwrfwdptr(ptid,1)
      write(*,*) 'Status returned by he5_ptwrfwdptr():  ',status

c     Write attributes to "Fixed Buoy Point"
c     --------------------------------------
      attrname       = 'GlobalAttribute_int'
      ntype          = HE5T_NATIVE_INT
      fortcount(1)   = 1
      attr           = 9999 

      status   = he5_ptwriteattr(ptid,attrname,ntype,fortcount,
     1attr)
      write(*,*) 'Status returned by he5_ptwriteattr():  ',status

c.....Close out the point interface
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status


c     Do FloatBuoy Point 
c     ------------------ 
      ptid = HE5_PTattach(ptfid, "FloatBuoy Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid

c     Read FloatBuoy Point - Level 0
c     ------------------------------ 
      open(unit=1, file='floatBuoy0.txt', status='OLD')

      n = 0
      do 40 i=1,1000
         read(1, 410, end=400) desc4_tt, date4_tt, wgt_tt, id4_tt 
         desc4(i)     = desc4_tt
         date4(i)     = date4_tt
         wgt(i)       = wgt_tt
         id4(i)       = id4_tt

         n = n + 1
   40 continue

  400 close(unit=1)
  410 format(A8,I8,I7,2X,A8)

      count(1) = n

      fieldname      = 'Label'
      dtype       = HE5T_NATIVE_CHAR

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1dtype, desc4)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'DeployDate'
      dtype       = HE5T_NATIVE_INT

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1dtype, date4)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'Weight'
      dtype       = HE5T_NATIVE_INT

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1dtype, wgt)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'ID'
      dtype       = HE5T_NATIVE_CHAR

      status = he5_ptwritelevel(ptid, 0, count, fieldname, 
     1dtype, id4)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

c     Read FixedBuoy Point - Level 1
c     ------------------------------ 
      open(unit=1, file='floatBuoy1.txt', status='OLD')

      n = 0
      do 50 i=1,1000
         read(1, 510, end=500) time5_tt, lon5_tt, lat5_tt,  
     1rain5_tt,temp5_tt,id5_tt
         time5(i)     = time5_tt
         lon5(i)      = lon5_tt
         lat5(i)      = lat5_tt
         rain5(i)     = rain5_tt
         temp5(i)     = temp5_tt
         id5(i)       = id5_tt

         n = n + 1
   50 continue

  500 close(unit=1)
  510 format(F13.1,F13.6,F13.6,F8.1,F8.2,3X,A8)

      count(1) = n

      fieldname      = 'Time'
      dtype       = HE5T_NATIVE_DOUBLE

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1dtype, time5)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'Longitude'
      dtype       = HE5T_NATIVE_DOUBLE

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1dtype, lon5)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'Latitude'
      dtype       = HE5T_NATIVE_DOUBLE

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1dtype, lat5)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'Rainfall'
      dtype       = HE5T_NATIVE_FLOAT

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1dtype, rain5)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'Temperature'
      dtype       = HE5T_NATIVE_FLOAT

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1dtype, temp5)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

      fieldname      = 'ID'
      dtype       = HE5T_NATIVE_CHAR

      status = he5_ptwritelevel(ptid, 1, count, fieldname, 
     1dtype, id5)
      write(*,*) 'Status returned by he5_ptwritelevel():  ',status

c.....Write forward and backward pointers
      status = he5_ptwrbckptr(ptid,1)
      write(*,*) 'Status returned by he5_ptwrbckptr():  ',status

      status = he5_ptwrfwdptr(ptid,1)
      write(*,*) 'Status returned by he5_ptwrfwdptr():  ',status

c     Write attributes to "Float Buoy Point"
c     --------------------------------------
      attrname       = 'GlobalAttribute_float'
      ntype          = HE5T_NATIVE_FLOAT
      fortcount(1)   = 1
      flt            = -7.5

      status   = he5_ptwriteattr(ptid,attrname,
     1ntype,fortcount,flt)
      write(*,*) 'Status returned by he5_ptwriteattr():  ',status

c.....Close out the point interface
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status

      status = he5_ptclose(ptfid)
      write(*,*) 'Status returned by he5_ptclose():  ',status


      stop
      end

c
c	  In this program we (1) open the "swath.he5" HDF-EOS file, 
c     (2) attach to the "Swath1" swath, and (3) define the 
c     external data field "ExtData".
c
      program     he5_sw_defexternalfldF_32

      implicit    none
 
      include     'hdfeos5.inc'

      integer     status
      integer     he5_swopen
      integer     he5_swattach
      integer     he5_swdefdfld
      integer     he5_swdetach
      integer     he5_swclose
      integer     he5_swsetxdat
      integer     swfid, swid

      integer*4   offset(3), size(3)

      integer     FAIL
      parameter   (FAIL=-1)


c     Open the HDF-EOS file, "swath.he5" using "READ/WRITE" access code
c     ----------------------------------------------------------------
      swfid = he5_swopen("swath.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_swopen():  ',swfid
      if (swfid .NE. FAIL) then

      swid = he5_swattach(swfid, "Swath1")
      write(*,*) 'Swath ID returned by he5_swattach():  ',swid
      if (swid .NE. FAIL) then

      offset(1) = 0 
      size(1)   = 40

      offset(2) = 40
      size(2)   = 80

      offset(3) = 80
      size(3)   = 120

      status = he5_swsetxdat(swid, "extf1.dat,extf2.dat,extf3.dat",
     1offset, size)
      write(*,*) 'Status returned by he5_swsetxdat():  ',status
      
      status = he5_swdefdfld(swid, "ExtData", "ExtDim",
     1" ", HE5T_NATIVE_INT, 0)
      write(*,*) 'Status returned by he5_swdefdfld():  ',status

      endif
      endif

c     Detach from the swath
c     ---------------------      
      status = he5_swdetach(swid)
      write(*,*) 'Status returned by he5_swdetach():  ',status

c     Close the file
c     --------------      
      status = he5_swclose(swfid)
      write(*,*) 'Status returned by he5_swclose():  ',status

      stop
      end

c	  In this program we (1) open the "swath.he5" HDF-EOS file, (2)
c	  attach to the "Swath1" swath, and (3) define the swath fields
c     =============================================================

      program     he5_sw_definefieldsF_32

      implicit    none

      include     'hdfeos5.inc'

      integer     status
      integer     he5_swopen
      integer     he5_swattach
      integer     he5_swsetfill
      integer     he5_swdefgfld
      integer     he5_swdefdfld
      integer     he5_prdefine
      integer     he5_swdefchunk
      integer     he5_swdefcomp
      integer     he5_swdetach
      integer     he5_swclose
      integer     he5_szip_can_encode
      integer     swfid, swid

      integer     chunkrank
      integer     canenc
      integer*4   chunkdims(3) 
      integer     compparm(1)

      integer     FAIL
      parameter   (FAIL=-1)

c     Open the HDF-EOS file, "swath.he5" using "READ/WRITE" access code
c     -----------------------------------------------------------------
      swfid = he5_swopen("swath.he5",HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_swopen():  ',swfid 
      if (swfid .NE. FAIL) then

         swid = he5_swattach(swfid, "Swath1")
         write(*,*) 'Swath ID  returned by he5_swattach():  ',swid 
         if (swid .NE. FAIL) then
            
c     Define Geolocation and Data fields
c     ----------------------------------
c     ---------------------------------------------------------------
c     We define six fields.  The first three, "Time", "Longitude"
c	  and "Latitude" are geolocation fields and thus we use the
c	  geolocation dimensions "GeoTrack" and "GeoXtrack" in the field
c	  definitions.  We also must specify the data type using the
c	  standard HDF data type codes.  In this example the geolocation
c	  are 4-byte (32 bit) floating point numbers.
c     
c	  The next three fields are data fields.  Note that either
c	  geolocation or data dimensions can be used. 
c     ---------------------------------------------------------------
            
            status = he5_swdefgfld(swid, "Time", "GeoTrack", 
     1           " ",HE5T_NATIVE_DOUBLE, 0)
            write(*,*) 'Status returned by he5_swdefgfld():  ',status 

            status = he5_swdefgfld(swid, "Longitude", 
     1           "GeoXtrack,GeoTrack",
     2           " ", HE5T_NATIVE_FLOAT, 0)
            write(*,*) 'Status returned by he5_swdefgfld():  ',status 

            status = he5_swdefgfld(swid, "Latitude",
     1           "GeoXtrack,GeoTrack",
     2           " ", HE5T_NATIVE_FLOAT, 0)
            write(*,*) 'Status returned by he5_swdefgfld():  ',status 

            status = he5_swdefdfld(swid, "Density",
     1           "GeoTrack"," ", HE5T_NATIVE_FLOAT, 0)
            write(*,*) 'Status returned by he5_swdefdfld():  ',status

            status = he5_swdefdfld(swid, "Temperature",
     1           "GeoXtrack,GeoTrack",
     2           " ", HE5T_NATIVE_FLOAT, 0)	      
            write(*,*) 'Status returned by he5_swdefdfld():  ',status 
	      
            status = he5_swdefdfld(swid, "Pressure", 
     1           "Res2xtr,Res2tr",
     2           " ", HE5T_NATIVE_FLOAT, 0)
            write(*,*) 'Status returned by he5_swdefdfld():  ',status 
	      
		chunkrank = 3
                chunkdims(1) = 20
                chunkdims(2) = 40
                chunkdims(3) = 15
                compparm(1) = 6

            status = he5_swdefchunk(swid,chunkrank,chunkdims)
            write(*,*) 'Status returned by he5_swdefchunk(): ',status

            canenc = he5_szip_can_encode()
            if (canenc .ne. 0) then
                status = he5_swdefcomp(swid,
     1                   HE5_HDFE_COMP_SHUF_SZIP_K13orEC,compparm)
                write(*,*) 'Status returned by he5_swdefcomp():  ',
     1                      status
            else
                write(*,*) 'SZIP encoder is not available.'
                write(*,*) 'The data compression test is skipped.'
            endif

            status = he5_swdefdfld(swid, "Spectra", 
     1           "Res2xtr,Res2tr,Bands",
     2           " ", HE5T_NATIVE_DOUBLE, 0)	      
            write(*,*) 'Status returned by he5_swdefdfld():  ',status 


c     Define Profile Field
c     -----------------------  
            status = he5_prdefine(swid, "Profile-2000", 
     1           "ProfDim", " ", HE5T_NATIVE_INT)
            write(*,*) 'Status returned by he5_prdefine():  ',status


c     Define Appendable Field
c     -----------------------  
c     status = he5_swdefdfld(swid, "Count", "GeoTrack",
c     1"Unlim", HE5T_NATIVE_INT, 0)	      
            
         endif
      endif
      
c     Detach from the swath
c     ---------------------      
      status = he5_swdetach(swid)
      write(*,*) 'Status returned by he5_swdetach():  ',status 
      
c     Close the file
c     --------------      
      status = he5_swclose(swfid)
      write(*,*) 'Status returned by he5_swclose():  ',status 

      stop
      end

      program       he5_pt_updatelevelsF_32

      implicit      none

      include       'hdfeos5.inc'

      integer       status
      integer       ptfid 
      integer       ptid
      integer       level
      integer       he5_ptopen
      integer       he5_ptattach
      integer       he5_ptupdatelevel 
      integer       he5_ptdetach 
      integer       he5_ptclose
      integer       dtype(3)

      integer*4     recs(32)
      integer*4     nrec

      real*4        conc_tt(4)

      real*8        time_tt

      character*8   spc_tt
      character*80  fieldname


c     Open the HDF point file, "point.he5"
c     ------------------------------------
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_ptopen():  ',ptfid

c     Read Simple Point 
c     ----------------- 
      ptid = HE5_PTattach(ptfid, "Simple Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid

      dtype(1)     =  HE5T_NATIVE_DOUBLE
      dtype(2)     =  HE5T_NATIVE_FLOAT
      dtype(3)     =  HE5T_NATIVE_CHAR

      nrec      = 1
      recs(1)   = 0

      level     = 0

      fieldname = 'Concentration'

      conc_tt(1)   = 1.11
      conc_tt(2)   = 2.22
      conc_tt(3)   = 3.33
      conc_tt(4)   = 4.44

      status = he5_ptupdatelevel(ptid, level, fieldname, nrec,
     1recs, dtype(2), conc_tt)
      write(*,*) 'Status returned by he5_ptupdatelevel():  ',status

      fieldname = 'Time'

      time_tt   = 13131313.0

      status = he5_ptupdatelevel(ptid, level, fieldname, nrec,
     1recs, dtype(1), time_tt)
      write(*,*) 'Status returned by he5_ptupdatelevel():  ',status

      fieldname = 'Species'

      spc_tt    = 'AM'

      status = he5_ptupdatelevel(ptid, level, fieldname, nrec,
     1recs, dtype(3), spc_tt)
      write(*,*) 'Status returned by he5_ptupdatelevel():  ',status


c.....Close out the point interface
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status


      status = he5_ptclose(ptfid)
      write(*,*) 'Status returned by he5_ptclose():  ',status


      stop
      end

!----------------------------------------------------------------------------
!     Copyright (C) 2002   Emergent IT Inc. and Raytheon Systems Company    |
!----------------------------------------------------------------------------
! testza32.f                                                                |
! In this program we create, define and write a simple za hdfeos file       |
! using the za interface                                                    |
!----------------------------------------------------------------------------

      program   testza32

      implicit  none
 
      include   'hdfeos5.inc'

      integer   index1, index2, status
      integer   rank, n, dtype, classid, order
      integer   rdattr(4), global_attr(4)
      integer   compparm(5), cnkrank
      integer   rdcompparm(5), compcode
      integer   he5_zaopen, he5_zacreate
      integer   zafid, zaid, zaid2
      integer   he5_zadefdim, he5_zadetach
      integer   he5_zadefine
      integer   he5_zaclose
      integer   he5_zasetfill, he5_zawrlattr, he5_zawrattr
      integer   he5_zawrite, he5_zawrgattr
      integer   he5_zaread, he5_zainfo 
      integer   he5_zaattrinfo, he5_zardattr
      integer   he5_zagattrinfo, he5_zardgattr, he5_zardlattr
      integer   he5_zalattrinfo, he5_zagetfill, he5_zaidtype
      integer   he5_zadefchunk, he5_zadefcomp, he5_zacompinfo
      integer   rnkd(4), ntyped(4), nt
      integer   he5_zaattach

      integer*4 he5_zainqza, he5_zanentries
      integer*4 he5_zainqdims, he5_zadiminfo
      integer*4 he5_zainqattrs, he5_zainqgattrs
      integer*4 he5_zainqlattrs, he5_zainquire
      integer*4 size, strbufsize, ndims, chunkdims(1)
      integer*4 start(2), stride(2), dataedge(2)
      integer*4 istart(2),iedge(2),dedge(2)
      integer*4 sd_start(2), sd_stride(2), sd_edge(2)
      integer*4 rd_start(2), rd_stride(2), rd_edge(2)
      integer*4 dimsize
      integer*4 nattr, nza, nmaps
      integer*4 strbufsz2, nflds
      integer*4 count(1)
      integer*4 dims(2),dims2(3),sddims(2)
      integer*4 dim1, dim2, dim3, dim4

      real      grpattr(3), locattr(3), rdgnlattr(3)
      real      ray1(100,40), ray2(40,100)
      real      ray4(40,100)
      real      ray3(40,40), temp(40,100)
      real      raycnt	
      real      fillvalue, rdfilval


      character*(256)  dimname, fieldlist
      character*(256)  attrlist, zalist
      character*(256)  dimens, maxdims

      dim1          = 30
      dim2          = 40
      dim3          = 50
      dim4          = 100
      count(1)      = 3
      compparm(1)   = 6
      compparm(2)   = 0
      compparm(3)   = 0
      compparm(4)   = 0
      compparm(5)   = 0

      cnkrank       = 1
      chunkdims(1)  = 10

      rdcompparm(1) = 1
      rdcompparm(2) = 1
      rdcompparm(3) = 1
      rdcompparm(4) = 1
      rdcompparm(5) = 1
      compcode      = -1
      raycnt        = -799.0
      global_attr(1)= 11
      global_attr(2)= 33
      global_attr(3)= 66
      global_attr(4)= 99
      grpattr(1)    = 21.7
      grpattr(2)    = 24.3
      grpattr(3)    = 26.3
      locattr(3)    = 21.7
      locattr(2)    = 24.3
      locattr(1)    = 26.3
      start(1)      = 10
      start(2)      = 10
      stride(1)     = 1
      stride(2)     = 1
      sd_start(1)   = 0
      sd_start(2)   = 0
      sd_stride(1)  = 1
      sd_stride(2)  = 1
      sd_edge(1)    = 100
      sd_edge(2)    = 40
      rd_start(1)   = 0
      rd_start(2)   = 0
      rd_stride(1)  = 1
      rd_stride(2)  = 1
      rd_edge(1)    = 40
      rd_edge(2)    = 100
      dataedge(1)   = 20
      dataedge(2)   = 50
      istart(1)     = 0
      istart(2)     = 0
      iedge(1)      = 30
      iedge(2)      = 30
      dedge(1)      = 40
      dedge(2)      = 40
      rank          = 2
      fillvalue     = 16.0

!
! This section of the program just fills some arrays with data that will be
! used later in the program
!
      do 110 index1=1,100
         do 100 index2=1,40
            ray1(index1, index2)=raycnt
            ray2(index2, index1)=raycnt + 1.0
            ray4(index2,index1) = raycnt
            raycnt = raycnt +1.
  100    continue
  110 continue

      do 170 index1=1,40
         do 160 index2=1,40
            ray3(index1, index2)=raycnt
            raycnt = raycnt+1.25
  160    continue
  170 continue


  230 format('********Error unexpected**********')
  240 format('***********Passed Test*********')

      open(unit=1, file="testza32_f.txtout", status = "UNKNOWN")

      write(*,*)'Testing he5_za FORTRAN 77 interface'
      write(*,*)'======================================'
      write(1,*)'Testing he5_za FORTRAN 77 interface'
      write(1,*)'======================================'
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zaopen
!
      write(*,*)'Testing he5_zaopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_zaopen '
      write(1,*)'====================='
      zafid=he5_zaopen('za.he5',HE5F_ACC_TRUNC)
      if (zafid .lt. 0) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_TRUNC)'
         write(*,*)'Value returned by he5_zaopen ', zafid
         write(1,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_TRUNC)'
         write(1,*)'Value returned by he5_zaopen ', zafid
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zacreate
!
      write(1,27)
      write(*,*)'Testing he5_zacreate '
      write(*,*)'====================='
      write(1,*)'Testing he5_zacreate '
      write(1,*)'====================='
      zaid=he5_zacreate(zafid,'Simplef')
      if (zaid .lt. 0) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid=he5_zacreate(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zacreate ', zaid
         write(1,*)'zaid= he5_zacreate(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zacreate ', zaid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid2=he5_zacreate(zafid,'Indexedf')
      if (zaid2 .lt. 0) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	zaid2= he5_zacreate(zafid, "Indexedf")'
         write(*,*)'	Value returned by he5_zacreate ', zaid2
         write(1,*)'	zaid2= he5_zacreate(zafid, "Indexedf")'
         write(1,*)'	Value returned by he5_zacreate ', zaid2
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zadefdim
!
      write(1,27)
      write(*,*)'Testing he5_zadefdim '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadefdim '
      write(1,*)'====================='
      status=he5_zadefdim(zaid,'DataTrack',dim4)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_zadefdim(zaid, "DataTrack", 100)'
         write(*,*)'	Value returned by he5_zadefdim ',status
         write(1,*)'	status= he5_zadefdim(zaid, "DataTrack", 100)'
         write(1,*)'	Value returned by he5_zadefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefdim(zaid,'DataXtrack',dim2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_zadefdim(zaid, "DataXtrack", 40)'
         write(*,*)'	Value returned by he5_zadefdim ',status
         write(1,*)'	status= he5_zadefdim(zaid, "DataXtrack", 40)'
         write(1,*)'	Value returned by he5_zadefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '


      status=he5_zadefdim(zaid2,'DataTrack',dim2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_zadefdim(zaid2, "DataTrack", 40)'
         write(*,*)'	Value returned by he5_zadefdim ', status
         write(1,*)'	status= he5_zadefdim(zaid2, "DataTrack", 40)'
         write(1,*)'	Value returned by he5_zadefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefdim(zaid2,'DataXtrack',dim2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_zadefdim(zaid2, "DataXtrack", 40)'
         write(*,*)'	Value returned by he5_zadefdim ', status
         write(1,*)'	status= he5_zadefdim(zaid2, "DataXtrack", 40)'
         write(1,*)'	Value returned by he5_zadefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '


      status=he5_zadefdim(zaid2,'Timedim',dim2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define dimension Timedim '
         write(*,*)'	Value returned by he5_zadefdim ', status
         write(1,*)'Define dimension Timedim '
         write(1,*)'	Value returned by he5_zadefdim ', status
      endif

      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zadefine
!
      write(1,27)
      write(*,*)'Testing he5_zadefine '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadefine '
      write(1,*)'====================='

      status=he5_zadefine(zaid,'SideA','DataXtrack,DataTrack',
     1' ', HE5T_NATIVE_FLOAT)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
        
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define data field SideA '
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'Define data field SideA '
         write(1,*)'Value returned by he5_zadefine ',status
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case  -- he5_zasetfill
!
      write(1,27)
      write(*,*)'Testing he5_zasetfill '
      write(*,*)'====================='
      write(1,*)'Testing he5_zasetfill '
      write(1,*)'====================='
      status= he5_zasetfill(zaid,'Temperature',
     1HE5T_NATIVE_FLOAT, fillvalue)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zasetfill(zaid,"Temperature",
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(*,*)'Value returned by he5_zasetfill ',status
         write(1,*)'status=he5_zasetfill(zaid,"Temperature",
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(1,*)'Value returned by he5_zasetfill ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefine(zaid,'Temperature',
     1'DataXtrack,DataTrack',' ',HE5T_NATIVE_FLOAT)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define data field Temperature '
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'Define data field Temperature '
         write(1,*)'Value returned by he5_zadefine ',status
         write(*,*)' '
         write(1,*)' '
      endif

      status= he5_zasetfill(zaid,'Conduction',
     1HE5T_NATIVE_FLOAT,fillvalue)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zasetfill(zaid,"Conduction",
     1HE5T_NATIVE_FLOAT,fillvalue)'
         write(*,*)'Value returned by he5_zasetfill ',status
         write(1,*)'status=he5_zasetfill(zaid,"Conduction",
     1HE5T_NATIVE_FLOAT,fillvalue)'
         write(1,*)'Value returned by he5_zasetfill ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefine(zaid,'Conduction',
     1'DataXtrack,DataTrack',' ',HE5T_NATIVE_FLOAT)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadefine(zaid,"Conduction",
     1"DataXtrack,DataTrack","",HE5T_NATIVE_FLOAT)'
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'status= he5_zadefine(zaid,"Conduction",
     1"DataXtrack,DataTrack","",HE5T_NATIVE_FLOAT)'
         write(1,*)'Value returned by he5_zadefine ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefine(zaid2,'Sensor1',
     1'DataXtrack,DataTrack',' ',HE5T_NATIVE_FLOAT)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zadefine(zaid2, "Sensor1",
     1"DataTrack,DataXtrack","",HE5T_NATIVE_FLOAT)'
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'status= he5_zadefine(zaid2, "Sensor1",
     1"DataTrack,DataXtrack","",HE5T_NATIVE_FLOAT)'
         write(1,*)'Value returned by he5_zadefine ',status
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zadefchunk
!
      write(1,27)
      write(*,*)'Testing he5_zadefchunk'
      write(*,*)'======================'
      write(1,*)'Testing he5_zadefchunk'
      write(1,*)'======================'
      status=he5_zadefchunk(zaid,cnkrank,chunkdims)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadefchunk(zaid, cnkrank, chunkdims)'
         write(*,*)'Value returned by he5_zadefchunk ',status
         write(1,*)'status= he5_zadefchunk(zaid, cnkrank, chunkdims)'
         write(1,*)'Value returned by he5_zadefchunk ',status
      endif
      write(*,*)' '
      write(1,*)' '
    
! Test Case -- he5_zadefcomp
!
      write(1,27)
      write(*,*)'Testing he5_zadefcomp'
      write(*,*)'====================='
      write(1,*)'Testing he5_zadefcomp'
      write(1,*)'====================='
      status=he5_zadefcomp(zaid,HE5_HDFE_COMP_DEFLATE,compparm)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadefcomp(zaid,HE5_HDFE_COMP_DEFLATE,
     1compparm)'
         write(*,*)'Value returned by he5_zadefcomp ',status
         write(1,*)'status= he5_zadefcomp(zaid,HE5_HDFE_COMP_DEFLATE,
     1compparm)'
         write(1,*)'Value returned by he5_zadefcomp ',status
      endif
      write(*,*)' '
      write(1,*)' '


      status=he5_zadefine(zaid,'CompChunk','DataTrack',
     1' ',HE5T_NATIVE_FLOAT)
      if (status .lt. 0) then
         write(*,230)
         write(1,230) 
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define data field CompChunk '
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'Define data field CompChunk '
         write(1,*)'Value returned by he5_zadefine ',status
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zadetach
!
      write(1,27)
      write(*,*)'Testing he5_zadetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadetach '
      write(1,*)'====================='
      status=he5_zadetach(zaid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadetach(zaid2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid2)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid2)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      zaid=he5_zaattach(zafid,'Simplef')
      if (zaid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zaattach ',zaid
         write(1,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zaattach ',zaid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid2=he5_zaattach(zafid,'Indexedf')
      if (zaid2 .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(*,*)'Value returned by he5_zaattach ',zaid2
         write(1,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(1,*)'Value returned by he5_zaattach ',zaid2
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zadetach
!
      write(1,27)
      write(*,*)'Testing he5_zadetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadetach '
      write(1,*)'====================='
      status= he5_zadetach(zaid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid2)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid2)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zaclose(zafid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)       
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaclose(zafid)'
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      zafid=he5_zaopen('za.he5',HE5F_ACC_RDWR)
      if (zafid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zafid=he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_zaopen ',zafid
         write(1,*)'zafid=he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_zaopen ',zafid
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zaattach
!
      write(1,27)
      write(*,*)'Testing he5_zaattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_zaattach '
      write(1,*)'====================='

      zaid=he5_zaattach(zafid,'Simplef')
      if (zaid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zaattach ',zaid
         write(1,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zaattach ',zaid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid2=he5_zaattach(zafid,'Indexedf')
      if (zaid2 .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(*,*)'Value returned by he5_zaattach ',zaid2
         write(1,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(1,*)'Value returned by he5_zaattach ',zaid2
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zawrite
!
      write(1,27)
      write(*,*)'Testing he5_zawrite '
      write(*,*)'==================='
      write(1,*)'Testing he5_zawrite '
      write(1,*)'==================='

      status=he5_zawrite(zaid,'SideA',sd_start,stride, 
     1rd_edge, ray4)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Write data field SideA '
         write(*,*)'Value returned by he5_zawrite ',status
         write(1,*)'Write data field SideA '
         write(1,*)'Value returned by he5_zawrite ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zawrite(zaid,'Temperature',start,stride, 
     1dataedge, ray4)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrite(zaid,"Temperature",start, 
     1stride,dataedge, ray1)'
         write(*,*)'Value returned by he5_zawrite ',status
         write(1,*)'status=he5_zawrite(zaid,"Temperature",start, 
     1stride,dataedge, ray1)'
         write(1,*)'Value returned by he5_zawrite ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zawrite(zaid,'Conduction',start,stride, 
     1dataedge, ray2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrite(zaid,"Conduction",start, 
     1stride,dataedge, ray2)'
         write(*,*)'Value returned by he5_zawrite ',status
         write(1,*)'status=he5_zawrite(zaid,"Conduction",start, 
     1stride,dataedge, ray2)'
         write(1,*)'Value returned by he5_zawrite ',status
      endif
      write(*,*)' '
      write(1,*)' '


      iedge(1)=40
      iedge(2)=40
      status=he5_zawrite(zaid2,'Sensor1',istart,stride, 
     1iedge,ray3)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zawrite(zaid2, "Sensor1", 
     1istart, stride, iedge, ray3)'
         write(*,*)'Value returned by he5_zawrite ',status
         write(1,*)'status= he5_zawrite(zaid2, "Sensor1", 
     1istart, stride, iedge, ray3)'
         write(1,*)'Value returned by he5_zawrite ',status
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zawrlattr
!
      write(1,27)
      write(*,*)'Testing he5_zawrlattr, Local Attribute '
      write(*,*)'================================== '
      write(1,*)'Testing he5_zawrlattr, Local Attribute '
      write(1,*)'================================== '
      status=he5_zawrlattr(zaid2,'Sensor1','local',
     1HE5T_NATIVE_FLOAT,count,locattr)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrlattr(zaid2,"Sensor1","local",
     1HE5T_NATIVE_FLOAT,count,locattr)'
         write(*,*)'Value returned by he5_zawrlattr ',status
         write(1,*)'status=he5_zawrlattr(zaid2,"Sensor1", "local", 
     1HE5T_NATIVE_FLOAT,count,locattr)'
         write(1,*)'Value returned by he5_zawrlattr ',status
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zawrattr
!
      count(1) = 4

      write(1,27)
      write(*,*)'Testing he5_zawrattr, Global Attribute '
      write(*,*)'====================================== '
      write(1,*)'Testing he5_zawrattr, Global Attribute '
      write(1,*)'======================================= '
      status=he5_zawrattr(zaid,'Drift',HE5T_NATIVE_INT,count, 
     1global_attr)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrattr(zaid, "Drift", 
     1HE5T_NATIVE_INT, count, global_attr)'
         write(*,*)'Value returned by he5_zawrattr ',status
         write(1,*)'status=he5_zawrattr(zaid, "Drift", 
     1HE5T_NATIVE_INT, count, global_attr)'
         write(1,*)'Value returned by he5_zawrattr ',status
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zawrgattr
!
      count(1) = 3
     
      write(1,27)
      write(*,*)'Testing he5_zawrgattr, Group Attribute '
      write(*,*)'====================================== '
      write(1,*)'Testing he5_zawrgattr, Group Attribute '
      write(1,*)'====================================== '
      status=he5_zawrgattr(zaid,'group',HE5T_NATIVE_FLOAT, 
     1count,grpattr)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrgattr(zaid, "group", 
     1HE5T_NATIVE_FLOAT,count,grpgattr)'
         write(*,*)'Value returned by he5_zawrgattr ',status
         write(1,*)'status=he5_zawrgattr(zaid, "group", 
     1HE5T_NATIVE_FLOAT,count,grpattr)'
         write(1,*)'Value returned by he5_zawrgattr ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
      write(*,*)'status= he5_zadetach(zaid)'
      write(*,*)'Value returned by he5_zadetach ',status
      write(1,*)'status= he5_zadetach(zaid)'
      write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid2)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid2)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zaclose
!
      write(1,27)
      write(*,*)'Testing he5_zaclose '
      write(*,*)'==================='
      write(1,*)'Testing he5_zaclose '
      write(1,*)'==================='
      status= he5_zaclose(zafid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      zafid= he5_zaopen('za.he5',HE5F_ACC_RDWR)
      if (zafid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_zaopen ', zafid
         write(1,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_zaopen ', zafid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid= he5_zaattach(zafid,'Simplef')
      if (zaid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zaattach ',zaid
         write(1,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zaattach ',zaid
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zaclose(zafid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaclose(zafid)'
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      zafid= he5_zaopen('za.he5',HE5F_ACC_RDWR)
      if (zafid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_zaopen ',zafid
         write(1,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_zaopen ',zafid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid=he5_zaattach(zafid,'Simplef')
      if (zaid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zaattach ',zaid
         write(1,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zaattach ',zaid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid2=he5_zaattach(zafid,'Indexedf')
      if (zaid2 .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(*,*)'Value returned by he5_zaattach ',zaid2
         write(1,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(1,*)'Value returned by he5_zaattach ',zaid2
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zanentries
!
      write(1,27)
      write(*,*)'Testing he5_zanentries '
      write(*,*)'====================='
      write(1,*)'Testing he5_zanentries '
      write(1,*)'====================='

      nmaps=he5_zanentries(zaid,1,strbufsize)
      if (nmaps .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'nmaps= he5_zanentries(zaid, 1, strbufsize)'
         write(*,*)'Number of dimension mappings ',nmaps
         write(*,*)'Size of strbufsize ',strbufsize
         write(1,*)'nmaps= he5_zanentries(zaid, 1, strbufsize)'
         write(1,*)'Number of dimension mappings ',nmaps
         write(1,*)'Size of strbufsize ',strbufsize
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zainqdims
!
      write(1,27)
      write(*,*)'Testing he5_zainqdims '
      write(*,*)'====================='
      write(1,*)'Testing he5_zainqdims '
      write(1,*)'====================='
      ndims=he5_zainqdims(zaid,dimname,dims)
      if (ndims .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'ndims= he5_zainqdims(zaid, dimname, dims)'
         write(*,*)'Number of dimesions ',ndims
         write(*,*)'Names of dimensions ',dimname
         write(*,*)'Size of dimensions ',dims
         write(1,*)'ndims= he5_zainqdims(zaid, dimname, dims)'
         write(1,*)'Number of dimesions ',ndims
         write(1,*)'Names of dimensions ',dimname
         write(1,*)'Size of dimensions ',dims
      endif
      write(*,*)' '
      write(1,*)' '

      ndims= he5_zainqdims(zaid2, dimname, dims2)
      if (ndims .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'ndims=he5_zainqdims(zaid2,dimname,dims2)'
         write(*,*)'Number of dimesions ',ndims
         write(*,*)'Names of dimensions ',dimname
         write(*,*)'Size of dimensions ',dims2
         write(1,*)'ndims=he5_zainqdims(zaid2,dimname,dims2)'
         write(1,*)'Number of dimesions ',ndims
         write(1,*)'Names of dimensions ',dimname
         write(1,*)'Size of dimensions ',dims2
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zainquire
!
      write(1,27)
      write(*,*)'Testing he5_zainquire '
      write(*,*)'======================'
      write(1,*)'Testing he5_zainquire '
      write(1,*)'======================'
      nflds=he5_zainquire(zaid,fieldlist,rnkd,ntyped)
      if (nflds .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'nflds=he5_zainquire(zaid,fieldlist,rnkd,ntyped)'
         write(*,*)'Number of data fields in za ',nflds
         write(*,*)'Names of data fields ',fieldlist
         write(*,*)'Rank of fields ',rnkd
         write(*,*)'Number type of fields ',ntyped
         write(1,*)'nflds=he5_zainquire(zaid,fieldlist,rnkd,ntyped)'
         write(1,*)'Number of data fields in za ',nflds
         write(1,*)'Names of data fields ',fieldlist
         write(1,*)'Rank of fields ',rnkd
         write(1,*)'Number type of fields ',ntyped
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zadiminfo
!
      write(1,27)
      write(*,*)'Testing he5_zadiminfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadiminfo '
      write(1,*)'====================='
      dimsize= he5_zadiminfo(zaid,'DataTrack')
      if (dimsize .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'dimsize= he5_zadiminfo(zaid, "DataTrack")'
         write(*,*)'Size of dimension DataTrack ',dimsize
         write(1,*)'dimsize= he5_zadiminfo(zaid, "DataTrack")'
         write(1,*)'Size of dimension DataTrack ',dimsize
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zaread
!
      write(1,27)
      write(*,*)'Testing he5_zaread '
      write(*,*)'==================='
      write(1,*)'Testing he5_zaread '
      write(1,*)'==================='

      rd_start(1)=0
      rd_start(2)=0
      rd_stride(1)=1
      rd_stride(2)=1
      rd_edge(1)=40
      rd_edge(2)=100
      status= he5_zaread(zaid,'Conduction',rd_start,
     1rd_stride,rd_edge,temp)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Value returned by he5_zaread ',status
         write(*,*)'status= he5_zaread(zaid, "Conduction", 
     1rd_start,rd_stride, rd_edge, temp)'
         write(1,*)'status= he5_zaread(zaid, "Conduction", 
     1rd_start,rd_stride, rd_edge, temp)'
         write(1,*)'Value returned by he5_zaread ',status
         do 190 index1=10,15
            do 180 index2=10,15
               write(*,*)'value of conduction ',temp(index1,index2)
               write(1,*)'value of conduction ',temp(index1,index2)
  180       continue
  190    continue
      endif

      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zainfo
!
      write(1,27)
      write(*,*)'Testing he5_zainfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_zainfo '
      write(1,*)'====================='
      status=he5_zainfo(zaid,'SideA',rank,sddims,nt,
     1dimens,maxdims)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zainfo(zaid, "SideA", 
     1rank, sddims, nt, dimens, maxdims)'
         write(*,*)'Value returned by he5_zainfo ',status
         write(*,*)'Rank of field sideA ',rank
         write(*,*)'dimension list of field sideA ',dimens
         write(*,*)'Size of sideA dimensions ',sddims
         write(*,*)'number type of field sideA ',nt
         write(1,*)'status= he5_zainfo(zaid, "SideA", 
     1rank, sddims, nt, dimens, maxdims)'
         write(1,*)'Value returned by he5_zainfo ',status
         write(1,*)'Rank of field sideA ',rank
         write(1,*)'dimension list of field sideA ',dimens
         write(1,*)'Size of sideA dimensions ',sddims
         write(1,*)'number type of field sideA ',nt
      endif
      write(*,*)' '
      write(1,*)' '

 
! Test Case -- he5_zainqattrs
!
      write(1,27)
      write(*,*)'Testing he5_zainqattrs Global attributes '
      write(*,*)'==================================== '
      write(1,*)'Testing he5_zainqattrs Global attributes '
      write(1,*)'==================================== '

      nattr = he5_zainqattrs(zaid,attrlist,strbufsz2)
      if (nattr .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Number of global attributes in za ',nattr
         write(*,*)'Attribute list of za ',attrlist
         write(1,*)'Number of global attributes in za ',nattr
         write(1,*)'Attribute list of za ',attrlist
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zaattrinfo
!
      write(1,27)
      write(*,*)'Testing he5_zaattrinfo Global attribute'
      write(*,*)'======================================='
      write(1,*)'Testing he5_zaattrinfo Global attribute'
      write(1,*)'======================================='
      status= he5_zaattrinfo(zaid, attrlist, n, size)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zaattrinfo(zaid,attrlist,n,size)'
         write(*,*)'Value returned by he5_zaattrinfo ',status
         write(*,*)'Number type of attributes ',n,' Size ',size
         write(1,*)'status=he5_zaattrinfo(zaid,attrlist,n,size)'
         write(1,*)'Value returned by he5_zaattrinfo ',status
         write(1,*)'Number type of attributes ',n,' Size ',size
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zardattr
!
      write(1,27)
      write(*,*)'Testing he5_zardattr, Global attribute '
      write(*,*)'======================================'
      write(1,*)'Testing he5_zardattr, Global attribute '
      write(1,*)'======================================'

      status= he5_zardattr(zaid, attrlist, rdattr)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zardattr(zaid,attrlist,rdattr)'
         write(*,*)'Value returned by he5_zardattr ',status
         write(*,*)'attribute ',rdattr
         write(1,*)'status=he5_zardattr(zaid,attrlist,rdattr)'
         write(1,*)'Value returned by he5_zardattr ',status
         write(1,*)'attribute ',rdattr
      endif
      write(*,*)' '
      write(1,*)' '

!     Test Case -- he5_zainqgattrs
!
      write(1,27)
      write(*,*)'Testing he5_zainqgattrs Group attributes '
      write(*,*)'==================================== '
      write(1,*)'Testing he5_zainqgattrs Group attributes '
      write(1,*)'==================================== '

      nattr = he5_zainqgattrs(zaid,attrlist,strbufsz2)
      if (nattr .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Number of group attributes in za ',nattr
         write(*,*)'Attribute list of za ',attrlist
         write(1,*)'Number of group attributes in za ',nattr
         write(1,*)'Attribute list of za ',attrlist
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zagattrinfo
!
      write(1,27)
      write(*,*)'Testing he5_zagattrinfo Group attribute'
      write(*,*)'======================================='
      write(1,*)'Testing he5_zagattrinfo Group attribute'
      write(1,*)'======================================='
      status= he5_zagattrinfo(zaid, attrlist, n, size)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zagattrinfo(zaid,attrlist,n,size)'
         write(*,*)'Value returned by he5_zagattrinfo ',status
         write(*,*)'Number type of attributes ',n,' Size ',size
         write(1,*)'status=he5_zagattrinfo(zaid,attrlist,n,size)'
         write(1,*)'Value returned by he5_zagattrinfo ',status
         write(1,*)'Number type of attributes ',n,' Size ',size
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zardgattr
!
      write(1,27)
      write(*,*)'Testing he5_zardgattr, Group attribute '
      write(*,*)'======================================'
      write(1,*)'Testing he5_zardgattr, Group attribute '
      write(1,*)'======================================'

       status= he5_zardgattr(zaid,'group',rdgnlattr)
       if (status .lt. 0) then
          write(*,230)
          write(1,230)
       else
          write(*,*)'  '
          write(*,240)
          write(1,*)'  '
          write(1,240)
          write(*,*)'status=he5_zardgattr(zaid,attrlist,rdgnlattr)'
          write(*,*)'Value returned by he5_zardgattr ',status
          write(*,*)'attribute ',rdgnlattr
          write(1,*)'status=he5_zardgattr(zaid,attrlist,rdgnlattr)'
          write(1,*)'Value returned by he5_zardgattr ',status
          write(1,*)'attribute ',rdgnlattr
       endif
       write(*,*)' '
       write(1,*)' '

! Test Case -- he5_zainqlattrs
!
      write(1,27)
      write(*,*)'Testing he5_zainqlattrs Local attributes '
      write(*,*)'==================================== '
      write(1,*)'Testing he5_zainqlattrs Local attributes '
      write(1,*)'==================================== '

      nattr=he5_zainqlattrs(zaid2,'Sensor1',attrlist,strbufsz2)
      if (nattr .lt. 0) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zainqlattrs(... "Sensor1" ...)'
         write(*,*)'Number of local attributes in field ',nattr
         write(*,*)'Attribute list of field ',attrlist
         write(1,*)'zainqlattrs(... "Sensor1" ...)'
         write(1,*)'Number of local attributes in field ',nattr
         write(1,*)'Attribute list of field ',attrlist
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zalattrinfo
!
      write(1,27)
      write(*,*)'Testing he5_zalattrinfo Local attribute'
      write(*,*)'======================================='
      write(1,*)'Testing he5_zalattrinfo Local attribute'
      write(1,*)'======================================='
      status=he5_zalattrinfo(zaid2,'Sensor1','local',n,size)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zalattrinfo(... "Sensor1" ...)'
         write(*,*)'Value returned by he5_zalattrinfo ',status
         write(*,*)'Number type of attributes ',n,' Size ',size
         write(1,*)'zalattrinfo(... "Sensor1" ...)'
         write(1,*)'Value returned by he5_zalattrinfo ',status
         write(1,*)'Number type of attributes ',n,' Size ',size
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zaidtype
!
      write(1,27)
      write(*,*)'Testing he5_zaidtype, Inquire Datatype '
      write(*,*)'======================================='
      write(1,*)'Testing he5_zaidtype, Inquire Datatype '
      write(1,*)'======================================='

      status= he5_zaidtype(zaid2,'Sensor1','local', 
     1HE5_HDFE_LOCATTRGROUP,dtype,classid, order, size)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaidtype(zaid2,"Sensor1","local", 
     1HE5_HDFE_LOCATTRGROUP,dtype, classid, order, size)'
         write(*,*)'Value returned by he5_zaidtype ',status
         write(*,*)'Datatype of local attribute ',dtype
         write(*,*)'Class id and order ',classid, order
         write(*,*)'Size of attribute ',size
         write(1,*)'status= he5_zaidtype(zaid2,"Sensor1","local", 
     1HE5_HDFE_LOCATTRGROUP,dtype, classid, order, size)'
         write(1,*)'Value returned by he5_zaidtype ',status
         write(1,*)'Datatype of local attribute ',dtype
         write(1,*)'Class id and order ',classid, order
         write(1,*)'Size of attribute ',size
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zardlattr
!
      write(1,27)
      write(*,*)'Testing he5_zardlattr, Local attribute '
      write(*,*)'======================================'
      write(1,*)'Testing he5_zardlattr, Local attribute '
      write(1,*)'======================================'

      status=he5_zardlattr(zaid2,'Sensor1','local',rdgnlattr)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zardlattr(zaid2,"Sensor1","local", 
     1rdgnlattr)'
         write(*,*)'Value returned by he5_zardlattr ',status
         write(*,*)'attribute ',rdgnlattr
         write(1,*)'status=he5_zardlattr(zaid2,"Sensor1","local", 
     1rdgnlattr)'
         write(1,*)'Value returned by he5_zardlattr ',status
         write(1,*)'attribute ',rdgnlattr
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zagetfill
!
      write(1,27)
      write(*,*)'Testing he5_zagetfill '
      write(*,*)'====================='
      write(1,*)'Testing he5_zagetfill '
      write(1,*)'====================='
      status= he5_zagetfill(zaid,'Conduction', rdfilval)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zagetfill(zaid,"Conduction",rdfilval)'
         write(*,*)'Value returned by he5_zagetfill ',status
         write(*,*)'Value of fill ',rdfilval
         write(1,*)'status=he5_zagetfill(zaid,"Conduction",rdfilval)'
         write(1,*)'Value returned by he5_zagetfill ',status
         write(1,*)'Value of fill ',rdfilval
      endif
      write(*,*)' '
      write(1,*)' '



! Test Case -- he5_zacompinfo
!
      write(1,27)
      write(*,*)'Testing he5_zacompinfo '
      write(*,*)'======================='
      write(1,*)'Testing he5_zacompinfo '
      write(1,*)'======================='
      status=he5_zacompinfo(zaid,'CompChunk',compcode,rdcompparm)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zacompinfo(zaid,"CompChunk",compcode, 
     1rdcompparm)'
         write(*,*)'Status returned by he5_zacompinfo ',status
         write(*,*)'Compression code ',compcode
         write(*,*)'Compression parameter ',rdcompparm(1)
         write(1,*)'status=he5_zacompinfo(zaid,"CompChunk",compcode, 
     1rdcompparm)'
         write(1,*)'Status returned by he5_zacompinfo ',status
         write(1,*)'Compression code ',compcode
         write(1,*)'Compression parameter ',rdcompparm(1)
      endif
      write(*,*)' '
      write(1,*)' '



      status= he5_zadetach(zaid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid2)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid2)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid2)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zaclose(zafid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaclose(zafid)'
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      zafid=he5_zaopen('za.he5',HE5F_ACC_RDWR)
      if (zafid .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zafid=he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_zaopen ',zafid
         write(1,*)'zafid=he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_zaopen ',zafid
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zainqza
!
      write(1,27)
      write(*,*)'Testing he5_zainqza '
      write(*,*)'======================'
      write(1,*)'Testing he5_zainqza '
      write(1,*)'======================'

      nza=he5_zainqza('za.he5',zalist,strbufsz2)
      if (nza .lt. 0) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Retrieve information on zas in 
     1file za.he5'
         write(*,*)'Number of zas in file ', nza
         write(*,*)'List of zas ',zalist
         write(1,*)'Retrieve information on zas in 
     1file za.he5'
         write(1,*)'Number of zas in file ', nza
         write(1,*)'List of zas ',zalist
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zaclose(zafid)
      if (status .lt. 0) then
         write(*,230)
         write(1,230)       
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaclose(zafid)'
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '

      close(unit=1)
   27 format(' ')
      stop
      end

      program     he5_za_readdimscaleF_32

      implicit    none

      include     'hdfeos5.inc'

      integer     status
      integer     i, j, jj
      integer     he5_zaopen
      integer     he5_zaattach
      integer     he5_zawrfld
      integer     he5_zawrattr
      integer     he5_zawrgattr
      integer     he5_ehwrglatt
      integer     he5_zawrlattr 
      integer     he5_zadetach
      integer     he5_zaclose
      integer     HE5_ZAdscaleattrinfo, HE5_ZAreaddscaleattr
      integer     HE5_ZAgetdimscale, HE5_ZAinqdscaleattrs
      integer     ntype
      integer     zafid,zaid1
      real*4      datbuf_f(1) 
      integer*4   datbuf_i(3)
      integer*4   nbands
      integer     bands(3)
      integer*4   datbuf_i2(2) 
      integer     count(2)
      integer         attr_int(25)
      real*4          attr_flt(25)
      real*8          attr_dbl(25)
      character       attr_char(25)
      integer         dimsize
      integer         bufsize, nattr 
      integer         data(30)
      integer         FAIL
      parameter       (FAIL=-1)
      character*100   attrlist
      character*100   strbufsize
      character*15    attrname(10)
      integer         numtype

!  /*
!   * Open the HDF zaath file, "za.he5".
!   */

      zafid = HE5_ZAopen("za.he5", HE5F_ACC_RDWR)
 
!  /*
!   * If the zaath file cannot be found, HE5_ZAopen will return -1 for the file
!   * handle (zafid).  We there check that this is not the case before
!   * proceeding with the other routines.
!   * 
!   * The HE5_ZAattach routine returns the handle to the existing zaath "ZA1",
!   * ZAid.  If the zaath is not found, HE5_ZAattach returns -1 for the handle.
!   */ 

      if (zafid .ne. FAIL) then
     
         ZAid1 = HE5_ZAattach(zafid, "ZA1")

!      /* the field Pollution has Time,YDim,XDim dimensions. 
!	 xdim = 120
!	 ydim = 200
!	 Time dim is set to 10
!      */

         if (ZAid1 .eq. FAIL) then
            
            write(*,*) 'Error: Cannot attach to zaath  ZA1'
            status = HE5_ZAclose(zafid)
            stop
         endif

         bufsize = HE5_ZAgetdimscale(ZAid1, "Spectra", "Bands", 
     1        dimsize, numtype, data)
         if (bufsize .eq. -1) then
	
            write(*,*) 'Error:Cannot get Dimension Scale size of Bands',
     1           ' dimemnsion in field Spectra'
            status = HE5_ZAdetach(ZAid1)
            status = HE5_ZAclose(zafid)
            stop
            
         else
            
            write(*,*) 'bufsize = ',bufsize
            write(*,*) 'dimsize = ',dimsize
            write(*,*) 'numtype = ',numtype
            
            write(*,*) 'Values are:'
            do i = 1,dimsize
               write(*,*) 'DimscaleValue[',i,'] = ',data(i)
            enddo
         endif
         
         nattr = HE5_ZAinqdscaleattrs(ZAid1, "Bands", attrlist, 
     1        strbufsize)
         if ( nattr .lt. 0 ) then
            
            write(*,*) 'Error: Cannot get Dimension Scale attribute',
     1           ' list for Bands'
            status = HE5_ZAdetach(ZAid1)
            status = HE5_ZAclose(zafid)
            stop
         endif
         write(*,*) ' '
         write(*,*) 'Dimension scale for Bands Attribute:'

         attrname(1) = 'label'
         attrname(2) = 'unit'
         attrname(3) = 'format'
         attrname(4) = 'MissingValue'
         attrname(5) = 'IntValues'
         do j = 1,5
            attr_char = ''
            count(1)= 0
            count(2)= 0

            status = HE5_ZAdscaleattrinfo(ZAid1,"Bands", attrname(j), 
     1        ntype, count)
                              
            if( ntype .eq. 0) then
               status = HE5_ZAreaddscaleattr(ZAid1,"Bands", attrname(j), 
     1              attr_int)
            endif

            if( ntype .eq. 10) then
               status = HE5_ZAreaddscaleattr(ZAid1,"Bands", attrname(j), 
     1              attr_flt)
            endif
            
            if( ntype .eq. 11) then
               status = HE5_ZAreaddscaleattr(ZAid1,"Bands", attrname(j), 
     1              attr_dbl)
            endif
            
            if( ntype .eq. 57) then
               status = HE5_ZAreaddscaleattr(ZAid1,"Bands", attrname(j), 
     1              attr_char)
            endif

            write(*,*) ' '
            write(*,*) 'Status returned by HE5_ZAreaddscaleattr() :', 
     1           status
            write(*,*) 'Attribute Name: ',attrname(j)
            write(*,*) 'Number of attribute elements: ', count(1),
     1     '   ',count(2)
            write(*,*) 'Data type of attribute: ', ntype
            
            if( ntype .eq. 0) then
               do jj = 1,count(1)
                  write(*,*) 'Attrvalue[',jj,']: ', attr_int(jj)
               enddo
            endif
            
            if( ntype .eq. 10) then
               do jj = 1,count(1)
                  write(*,*) 'Attrvalue[',jj,']: ',attr_flt(jj)
               enddo
            endif

            if( ntype .eq. 11) then
               do jj = 1,count(1)
                  write(*,*) 'Attrvalue[',jj,']: ',attr_dbl(jj)
               enddo
            endif

            if( ntype .eq. 57) then
               write(*,*) 'Attrvalue: ', attr_char
            endif
         enddo
      endif

      status = HE5_ZAdetach(ZAid1)
      
      status = HE5_ZAclose(zafid)
      
      stop
      end

!  In this program we (1) open the "za.he5" file, (2) attach to
!  the "ZA1" za, and (3) write data to the "Spectra" field 

      program        he5_za_writedataF_64

      implicit       none

      include        'hdfeos5.inc'

      integer        status
      integer        he5_zaopen 
      integer        he5_zaattach 
      integer        he5_zawrite
      integer        he5_zawrattr
      integer        he5_zadetach
      integer        he5_zaclose
      integer        zafid, zaid 
      integer        i, j , k

      integer*4      attr(4)
      integer*8      start(3)
      integer*8      stride(3)
      integer*8      count(3)
 
      real*8         plane(800)

      integer        FAIL
      parameter      (FAIL=-1)
      
	 
!     Open HDF-EOS file, "za.he5"
!     ---------------------------
      zafid = he5_zaopen("za.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_zaopen():  ',zafid

      if (zafid .NE. FAIL) then
		 zaid = he5_zaattach(zafid, "ZA1")
         write(*,*) 'ZA ID returned by he5_zaattach():  ',zaid

		 if (zaid .NE. FAIL) then

!     Write Spectra one plane at a time 
!     Value is 100 * track index + band index (0-based)
!     -------------------------------------------------
			start(1)  = 0
			start(2)  = 0
			count(1)  = 20
			count(2)  = 40
			count(3)  = 1
			stride(1) = 1
			stride(2) = 1
			stride(3) = 1
	    
			do i=1,15
			   start(3) = i - 1
			   do j=1,40
				  do k=1,20
					 plane((j-1)*20+k) = (j-1)*100 + i-1
				  enddo
			   enddo
			   status = he5_zawrite(zaid,"Spectra",start,
     1              stride,count,plane)
			enddo
	write(*,*) 'Status returned by he5_zawrite(): ',status

			
!     Write User defined Attribute
!     ----------------------------
			attr(1)  = 3
			attr(2)  = 5
			attr(3)  = 7
			attr(4)  = 11
            count(1) = 4
			status = he5_zawrattr(zaid,"TestAttr",HE5T_NATIVE_INT,
     1           count,attr)
	      
		 endif
	  endif
	  
!     Detach from the za
!     ------------------
      status = he5_zadetach(zaid)
      write(*,*) 'Status returned by he5_zadetach():  ',status

!     Close the file
!     --------------
      status = he5_zaclose(zafid)
      write(*,*) 'Status returned by he5_zaclose():  ',status
	  
      stop
      end

!----------------------------------------------------------------------------
!     Copyright (C) 2002   Emergent IT Inc. and Raytheon Systems Company    |
!----------------------------------------------------------------------------
! testza64.f                                                                |
! In this program we create, define and write a simple za hdfeos file       |
! using the za interface                                                    |
!----------------------------------------------------------------------------

      program   testza64
 
      implicit  none
 
      include   'hdfeos5.inc'
 
      integer   status
      integer   index1
      integer   index2
      integer   zafid
      integer   zaid
      integer   zaid2
      integer   rank
      integer   n, nt
      integer   dtype
      integer   classid
      integer   order
      integer   rdattr(4)
      integer   global_attr(4)
      integer   compparm(5)
      integer   cnkrank
      integer   rdcompparm(5)
      integer   compcode
      integer   ntyped(4)
      integer   rnkd(4)

      integer   he5_zaopen
      integer   he5_zacreate
      integer   he5_zaattach
      integer   he5_zadefdim
      integer   he5_zadefine
      integer   he5_zadefchunk
      integer   he5_zadefcomp
      integer   he5_zasetfill
      integer   he5_zawrattr
      integer   he5_zawrlattr
      integer   he5_zawrite
      integer   he5_zaread
      integer   he5_zawrgattr
      integer   he5_zardattr
      integer   he5_zardgattr
      integer   he5_zardlattr
      integer   he5_zainfo 
      integer   he5_zacompinfo
      integer   he5_zaattrinfo
      integer   he5_zagattrinfo
      integer   he5_zalattrinfo
      integer   he5_zagetfill
      integer   he5_zaidtype
      integer   he5_zadetach
      integer   he5_zaclose 

      integer*8 he5_zainqza
      integer*8 he5_zanentries
      integer*8 he5_zainqdims
      integer*8 he5_zadiminfo
      integer*8 he5_zainqattrs
      integer*8 he5_zainqgattrs
      integer*8 he5_zainqlattrs
      integer*8 he5_zainquire
      integer*8 size
      integer*8 strbufsize
      integer*8 ndims
      integer*8 chunkdims(1)
      integer*8 start(2)
      integer*8 stride(2)
      integer*8 dataedge(2)
      integer*8 istart(2)
      integer*8 iedge(2)
      integer*8 dedge(2)
      integer*8 sd_start(2)
      integer*8 sd_stride(2)
      integer*8 sd_edge(2)
      integer*8 rd_start(2)
      integer*8 rd_stride(2)
      integer*8 rd_edge(2)
      integer*8 dimsize
      integer*8 nattr
      integer*8 nza
      integer*8 nmaps
      integer*8 strbufsz2
      integer*8 nflds
      integer*8 count(1)
      integer*8 zero
      integer*8 dims(2)
      integer*8 dims2(3)
      integer*8 sddims(2)
      integer*8 dim1
      integer*8 dim2
      integer*8 dim3
      integer*8 dim4

      real      grpattr(3)
      real      locattr(3)
      real      rdgnlattr(3)
      real      ray1(100,40)
      real      ray2(40,100)
      real      ray4(40,100)
      real      ray3(40,40)
      real      temp(40,100)
      real      raycnt
      real      fillvalue
      real      rdfilval
      real      tempbuf(4200)


      character*(256)  dimname
      character*(256)  fieldlist
      character*(256)  attrlist
      character*(256)  zalist
      character*(256)  dimens
      character*(256)  maxdims

      dim1          = 30
      dim2          = 40
      dim3          = 50
      dim4          = 100
      count(1)      = 3
      compparm(1)   = 6
      compparm(2)   = 0
      compparm(3)   = 0
      compparm(4)   = 0
      compparm(5)   = 0
      cnkrank       = 1
      chunkdims(1)  = 10
      rdcompparm(1) = 1
      rdcompparm(2) = 1
      rdcompparm(3) = 1
      rdcompparm(4) = 1
      rdcompparm(5) = 1
      compcode      = -1
      raycnt        = -799.0
      global_attr(1)= 11
      global_attr(2)= 33
      global_attr(3)= 66
      global_attr(4)= 99
      grpattr(1)    = 21.7
      grpattr(2)    = 24.3
      grpattr(3)    = 26.3
      locattr(3)    = 21.7
      locattr(2)    = 24.3
      locattr(1)    = 26.3
      start(1)      = 10
      start(2)      = 10
      stride(1)     = 1
      stride(2)     = 1
      sd_start(1)   = 0
      sd_start(2)   = 0
      sd_stride(1)  = 1
      sd_stride(2)  = 1
      sd_edge(1)    = 100
      sd_edge(2)    = 40
      rd_start(1)   = 0
      rd_start(2)   = 0
      rd_stride(1)  = 1
      rd_stride(2)  = 1
      rd_edge(1)    = 40
      rd_edge(2)    = 100
      dataedge(1)   = 20
      dataedge(2)   = 50
      istart(1)     = 0
      istart(2)     = 0
      iedge(1)      = 30
      iedge(2)      = 30
      dedge(1)      = 40
      dedge(2)      = 40
      rank          = 2
      fillvalue     = 16.0
      zero          = 0

!
! This section of the program just fills some arrays with data that will be
! used later in the program
!
      do 110 index1=1,100
         do 100 index2=1,40
            ray1(index1, index2)=raycnt
            ray2(index2, index1)=raycnt + 1.0
            ray4(index2,index1) = raycnt
            raycnt = raycnt +1.
  100    continue
  110 continue

      do 170 index1=1,40
         do 160 index2=1,40
            ray3(index1, index2)=raycnt
            raycnt = raycnt+1.25
  160    continue
  170 continue


  230 format('********Error unexpected**********')
  240 format('***********Passed Test*********')

      open(unit=1, file="testza64_f.txtout", status = "UNKNOWN")

      write(*,*)'Testing he5_za FORTRAN 77 interface'
      write(*,*)'======================================'
      write(1,*)'Testing he5_za FORTRAN 77 interface'
      write(1,*)'======================================'
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zaopen
!
      write(*,*)'Testing he5_zaopen '
      write(*,*)'====================='
      write(1,*)'Testing he5_zaopen '
      write(1,*)'====================='
      zafid=he5_zaopen('za.he5',HE5F_ACC_TRUNC)
      if (zafid .lt. zero) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	zafid= he5_zaopen("za.he5",HE5F_ACC_TRUNC)'
         write(*,*)'	Value returned by he5_zaopen ', zafid
         write(1,*)'	zafid= he5_zaopen("za.he5",HE5F_ACC_TRUNC)'
         write(1,*)'	Value returned by he5_zaopen ', zafid
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zacreate
!
      write(1,27)
      write(*,*)'Testing he5_zacreate '
      write(*,*)'====================='
      write(1,*)'Testing he5_zacreate '
      write(1,*)'====================='
      zaid=he5_zacreate(zafid,'Simplef')
      if (zaid .lt. zero) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid=he5_zacreate(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zacreate ', zaid
         write(1,*)'zaid= he5_zacreate(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zacreate ', zaid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid2=he5_zacreate(zafid,'Indexedf')
      if (zaid2 .lt. zero) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid2= he5_zacreate(zafid, "Indexedf")'
         write(*,*)'Value returned by he5_zacreate ', zaid2
         write(1,*)'zaid2= he5_zacreate(zafid, "Indexedf")'
         write(1,*)'Value returned by he5_zacreate ', zaid2
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zadefdim
!
      write(1,27)
      write(*,*)'Testing he5_zadefdim '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadefdim '
      write(1,*)'====================='
      status=he5_zadefdim(zaid,'DataTrack',dim4)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_zadefdim(zaid, "DataTrack", 100)'
         write(*,*)'	Value returned by he5_zadefdim ',status
         write(1,*)'	status= he5_zadefdim(zaid, "DataTrack", 100)'
         write(1,*)'	Value returned by he5_zadefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefdim(zaid,'DataXtrack',dim2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_zadefdim(zaid, "DataXtrack", 40)'
         write(*,*)'	Value returned by he5_zadefdim ',status
         write(1,*)'	status= he5_zadefdim(zaid, "DataXtrack", 40)'
         write(1,*)'	Value returned by he5_zadefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefdim(zaid2,'DataTrack',dim2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_zadefdim(zaid2, "DataTrack", 40)'
         write(*,*)'	Value returned by he5_zadefdim ', status
         write(1,*)'	status= he5_zadefdim(zaid2, "DataTrack", 40)'
         write(1,*)'	Value returned by he5_zadefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefdim(zaid2,'DataXtrack',dim2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'	status= he5_zadefdim(zaid2, "DataXtrack", 40)'
         write(*,*)'	Value returned by he5_zadefdim ', status
         write(1,*)'	status= he5_zadefdim(zaid2, "DataXtrack", 40)'
         write(1,*)'	Value returned by he5_zadefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefdim(zaid2,'Timedim',dim2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define dimension Timedim '
         write(*,*)'	Value returned by he5_zadefdim ', status
         write(1,*)'Define dimension Timedim '
         write(1,*)'	Value returned by he5_zadefdim ', status
      endif

      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zadefine
!
      write(1,27)
      write(*,*)'Testing he5_zadefine '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadefine '
      write(1,*)'====================='

      status=he5_zadefine(zaid,'SideA','DataXtrack,DataTrack',
     1' ', HE5T_NATIVE_FLOAT)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
        
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define data field SideA '
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'Define data field SideA '
         write(1,*)'Value returned by he5_zadefine ',status
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case  -- he5_zasetfill
!
      write(1,27)
      write(*,*)'Testing he5_zasetfill '
      write(*,*)'====================='
      write(1,*)'Testing he5_zasetfill '
      write(1,*)'====================='
      status= he5_zasetfill(zaid,'Temperature',
     1HE5T_NATIVE_FLOAT, fillvalue)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zasetfill(zaid,"Temperature",
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(*,*)'Value returned by he5_zasetfill ',status
         write(1,*)'status=he5_zasetfill(zaid,"Temperature",
     1HE5T_NATIVE_FLOAT, fillvalue)'
         write(1,*)'Value returned by he5_zasetfill ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefine(zaid,'Temperature',
     1'DataXtrack,DataTrack',' ',HE5T_NATIVE_FLOAT)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define data field Temperature '
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'Define data field Temperature '
         write(1,*)'Value returned by he5_zadefine ',status
         write(*,*)' '
         write(1,*)' '
      endif

      status= he5_zasetfill(zaid,'Conduction',
     1HE5T_NATIVE_FLOAT,fillvalue)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zasetfill(zaid,"Conduction",
     1HE5T_NATIVE_FLOAT,fillvalue)'
         write(*,*)'Value returned by he5_zasetfill ',status
         write(1,*)'status=he5_zasetfill(zaid,"Conduction",
     1HE5T_NATIVE_FLOAT,fillvalue)'
         write(1,*)'Value returned by he5_zasetfill ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefine(zaid,'Conduction',
     1'DataXtrack,DataTrack',' ',HE5T_NATIVE_FLOAT)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadefine(zaid,"Conduction",
     1"DataXtrack,DataTrack","",HE5T_NATIVE_FLOAT)'
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'status= he5_zadefine(zaid,"Conduction",
     1"DataXtrack,DataTrack","",HE5T_NATIVE_FLOAT)'
         write(1,*)'Value returned by he5_zadefine ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadefine(zaid2,'Sensor1',
     1'DataXtrack,DataTrack',' ',HE5T_NATIVE_FLOAT)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zadefine(zaid2, "Sensor1",
     1"DataTrack,DataXtrack","",HE5T_NATIVE_FLOAT)'
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'status= he5_zadefine(zaid2, "Sensor1",
     1"DataTrack,DataXtrack","",HE5T_NATIVE_FLOAT)'
         write(1,*)'Value returned by he5_zadefine ',status
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zadefchunk
!
      write(1,27)
      write(*,*)'Testing he5_zadefchunk'
      write(*,*)'======================'
      write(1,*)'Testing he5_zadefchunk'
      write(1,*)'======================'
      status=he5_zadefchunk(zaid,cnkrank,chunkdims)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadefchunk(zaid, cnkrank, chunkdims)'
         write(*,*)'Value returned by he5_zadefchunk ',status
         write(1,*)'status= he5_zadefchunk(zaid, cnkrank, chunkdims)'
         write(1,*)'Value returned by he5_zadefchunk ',status
      endif
      write(*,*)' '
      write(1,*)' '
    
! Test Case -- he5_zadefcomp
!
      write(1,27)
      write(*,*)'Testing he5_zadefcomp'
      write(*,*)'====================='
      write(1,*)'Testing he5_zadefcomp'
      write(1,*)'====================='
      status=he5_zadefcomp(zaid,HE5_HDFE_COMP_DEFLATE,compparm)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadefcomp(zaid,HE5_HDFE_COMP_DEFLATE,
     1compparm)'
         write(*,*)'Value returned by he5_zadefcomp ',status
         write(1,*)'status= he5_zadefcomp(zaid,HE5_HDFE_COMP_DEFLATE,
     1compparm)'
         write(1,*)'Value returned by he5_zadefcomp ',status
      endif
      write(*,*)' '
      write(1,*)' '


      status=he5_zadefine(zaid,'CompChunk','DataTrack',
     1' ',HE5T_NATIVE_FLOAT)
      if (status .lt. zero) then
         write(*,230)
         write(1,230) 
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Define data field CompChunk '
         write(*,*)'Value returned by he5_zadefine ',status
         write(1,*)'Define data field CompChunk '
         write(1,*)'Value returned by he5_zadefine ',status
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zadetach
!
      write(1,27)
      write(*,*)'Testing he5_zadetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadetach '
      write(1,*)'====================='
      status=he5_zadetach(zaid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zadetach(zaid2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid2)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid2)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      zaid=he5_zaattach(zafid,'Simplef')
      if (zaid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zaattach ',zaid
         write(1,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zaattach ',zaid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid2=he5_zaattach(zafid,'Indexedf')
      if (zaid2 .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(*,*)'Value returned by he5_zaattach ',zaid2
         write(1,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(1,*)'Value returned by he5_zaattach ',zaid2
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zadetach
!
      write(1,27)
      write(*,*)'Testing he5_zadetach '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadetach '
      write(1,*)'====================='
      status= he5_zadetach(zaid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid2)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid2)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zaclose(zafid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)       
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaclose(zafid)'
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      zafid=he5_zaopen('za.he5',HE5F_ACC_RDWR)
      if (zafid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zafid=he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_zaopen ',zafid
         write(1,*)'zafid=he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_zaopen ',zafid
      endif
      write(*,*)' '
      write(1,*)' '
 
! Test Case -- he5_zaattach
!
      write(1,27)
      write(*,*)'Testing he5_zaattach '
      write(*,*)'====================='
      write(1,*)'Testing he5_zaattach '
      write(1,*)'====================='

      zaid=he5_zaattach(zafid,'Simplef')
      if (zaid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zaattach ',zaid
         write(1,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zaattach ',zaid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid2=he5_zaattach(zafid,'Indexedf')
      if (zaid2 .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(*,*)'Value returned by he5_zaattach ',zaid2
         write(1,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(1,*)'Value returned by he5_zaattach ',zaid2
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zawrite
!
      write(1,27)
      write(*,*)'Testing he5_zawrite '
      write(*,*)'==================='
      write(1,*)'Testing he5_zawrite '
      write(1,*)'==================='

      status=he5_zawrite(zaid,'SideA',sd_start,stride, 
     1rd_edge, ray4)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Write data field SideA '
         write(*,*)'Value returned by he5_zawrite ',status
         write(1,*)'Write data field SideA '
         write(1,*)'Value returned by he5_zawrite ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zawrite(zaid,'Temperature',start,stride, 
     1dataedge, ray4)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrite(zaid,"Temperature",start, 
     1stride,dataedge, ray1)'
         write(*,*)'Value returned by he5_zawrite ',status
         write(1,*)'status=he5_zawrite(zaid,"Temperature",start, 
     1stride,dataedge, ray1)'
         write(1,*)'Value returned by he5_zawrite ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=he5_zawrite(zaid,'Conduction',start,stride, 
     1dataedge, ray2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrite(zaid,"Conduction",start, 
     1stride,dataedge, ray2)'
         write(*,*)'Value returned by he5_zawrite ',status
         write(1,*)'status=he5_zawrite(zaid,"Conduction",start, 
     1stride,dataedge, ray2)'
         write(1,*)'Value returned by he5_zawrite ',status
      endif
      write(*,*)' '
      write(1,*)' '


      iedge(1)=40
      iedge(2)=40
      status=he5_zawrite(zaid2,'Sensor1',istart,stride, 
     1iedge,ray3)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zawrite(zaid2, "Sensor1", 
     1istart, stride, iedge, ray3)'
         write(*,*)'Value returned by he5_zawrite ',status
         write(1,*)'status= he5_zawrite(zaid2, "Sensor1", 
     1istart, stride, iedge, ray3)'
         write(1,*)'Value returned by he5_zawrite ',status
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zawrlattr
!
      write(1,27)
      write(*,*)'Testing he5_zawrlattr, Local Attribute '
      write(*,*)'================================== '
      write(1,*)'Testing he5_zawrlattr, Local Attribute '
      write(1,*)'================================== '
      status=he5_zawrlattr(zaid2,'Sensor1','local',
     1HE5T_NATIVE_FLOAT,count,locattr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrlattr(zaid2,"Sensor1","local",
     1HE5T_NATIVE_FLOAT,count,locattr)'
         write(*,*)'Value returned by he5_zawrlattr ',status
         write(1,*)'status=he5_zawrlattr(zaid2,"Sensor1", "local", 
     1HE5T_NATIVE_FLOAT,count,locattr)'
         write(1,*)'Value returned by he5_zawrlattr ',status
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zawrattr
!
      count(1) = 4

      write(1,27)
      write(*,*)'Testing he5_zawrattr, Global Attribute '
      write(*,*)'====================================== '
      write(1,*)'Testing he5_zawrattr, Global Attribute '
      write(1,*)'======================================= '
      status=he5_zawrattr(zaid,'Drift',HE5T_NATIVE_INT,count, 
     1global_attr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrattr(zaid, "Drift", 
     1HE5T_NATIVE_INT, count, global_attr)'
         write(*,*)'Value returned by he5_zawrattr ',status
         write(1,*)'status=he5_zawrattr(zaid, "Drift", 
     1HE5T_NATIVE_INT, count, global_attr)'
         write(1,*)'Value returned by he5_zawrattr ',status
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zawrgattr
!
      count(1) = 3
     
      write(1,27)
      write(*,*)'Testing he5_zawrgattr, Group Attribute '
      write(*,*)'====================================== '
      write(1,*)'Testing he5_zawrgattr, Group Attribute '
      write(1,*)'====================================== '
      status=he5_zawrgattr(zaid,'group',HE5T_NATIVE_FLOAT, 
     1count,grpattr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zawrgattr(zaid, "group", 
     1HE5T_NATIVE_FLOAT,count,grpgattr)'
         write(*,*)'Value returned by he5_zawrgattr ',status
         write(1,*)'status=he5_zawrgattr(zaid, "group", 
     1HE5T_NATIVE_FLOAT,count,grpattr)'
         write(1,*)'Value returned by he5_zawrgattr ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
      write(*,*)'status= he5_zadetach(zaid)'
      write(*,*)'Value returned by he5_zadetach ',status
      write(1,*)'status= he5_zadetach(zaid)'
      write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid2)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid2)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zaclose
!
      write(1,27)
      write(*,*)'Testing he5_zaclose '
      write(*,*)'==================='
      write(1,*)'Testing he5_zaclose '
      write(1,*)'==================='
      status= he5_zaclose(zafid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      zafid= he5_zaopen('za.he5',HE5F_ACC_RDWR)
      if (zafid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_zaopen ', zafid
         write(1,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_zaopen ', zafid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid= he5_zaattach(zafid,'Simplef')
      if (zaid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zaattach ',zaid
         write(1,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zaattach ',zaid
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zaclose(zafid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaclose(zafid)'
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      zafid= he5_zaopen('za.he5',HE5F_ACC_RDWR)
      if (zafid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_zaopen ',zafid
         write(1,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_zaopen ',zafid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid=he5_zaattach(zafid,'Simplef')
      if (zaid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(*,*)'Value returned by he5_zaattach ',zaid
         write(1,*)'zaid= he5_zaattach(zafid, "Simplef")'
         write(1,*)'Value returned by he5_zaattach ',zaid
      endif
      write(*,*)' '
      write(1,*)' '

      zaid2=he5_zaattach(zafid,'Indexedf')
      if (zaid2 .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(*,*)'Value returned by he5_zaattach ',zaid2
         write(1,*)'zaid2= he5_zaattach(zafid, "Indexedf")'
         write(1,*)'Value returned by he5_zaattach ',zaid2
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zanentries
!
      write(1,27)
      write(*,*)'Testing he5_zanentries '
      write(*,*)'====================='
      write(1,*)'Testing he5_zanentries '
      write(1,*)'====================='

      nmaps=he5_zanentries(zaid,1,strbufsize)
      if (nmaps .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'nmaps= he5_zanentries(zaid, 1, strbufsize)'
         write(*,*)'Number of dimension mappings ',nmaps
         write(*,*)'Size of strbufsize ',strbufsize
         write(1,*)'nmaps= he5_zanentries(zaid, 1, strbufsize)'
         write(1,*)'Number of dimension mappings ',nmaps
         write(1,*)'Size of strbufsize ',strbufsize
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zainqdims
!
      write(1,27)
      write(*,*)'Testing he5_zainqdims '
      write(*,*)'====================='
      write(1,*)'Testing he5_zainqdims '
      write(1,*)'====================='
      ndims=he5_zainqdims(zaid,dimname,dims)
      if (ndims .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'ndims= he5_zainqdims(zaid, dimname, dims)'
         write(*,*)'Number of dimesions ',ndims
         write(*,*)'Names of dimensions ',dimname
         write(*,*)'Size of dimensions ',dims
         write(1,*)'ndims= he5_zainqdims(zaid, dimname, dims)'
         write(1,*)'Number of dimesions ',ndims
         write(1,*)'Names of dimensions ',dimname
         write(1,*)'Size of dimensions ',dims
      endif
      write(*,*)' '
      write(1,*)' '

      ndims= he5_zainqdims(zaid2, dimname, dims2)
      if (ndims .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'ndims=he5_zainqdims(zaid2,dimname,dims2)'
         write(*,*)'Number of dimesions ',ndims
         write(*,*)'Names of dimensions ',dimname
         write(*,*)'Size of dimensions ',dims2
         write(1,*)'ndims=he5_zainqdims(zaid2,dimname,dims2)'
         write(1,*)'Number of dimesions ',ndims
         write(1,*)'Names of dimensions ',dimname
         write(1,*)'Size of dimensions ',dims2
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zainquire
!
      write(1,27)
      write(*,*)'Testing he5_zainquire '
      write(*,*)'======================'
      write(1,*)'Testing he5_zainquire '
      write(1,*)'======================'
      nflds=he5_zainquire(zaid,fieldlist,rnkd,ntyped)
      if (nflds .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'nflds=he5_zainquire(zaid,fieldlist,rnkd,ntyped)'
         write(*,*)'Number of data fields in za ',nflds
         write(*,*)'Names of data fields ',fieldlist
         write(*,*)'Rank of fields ',rnkd
         write(*,*)'Number type of fields ',ntyped
         write(1,*)'nflds=he5_zainquire(zaid,fieldlist,rnkd,ntyped)'
         write(1,*)'Number of data fields in za ',nflds
         write(1,*)'Names of data fields ',fieldlist
         write(1,*)'Rank of fields ',rnkd
         write(1,*)'Number type of fields ',ntyped
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zadiminfo
!
      write(1,27)
      write(*,*)'Testing he5_zadiminfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_zadiminfo '
      write(1,*)'====================='
      dimsize= he5_zadiminfo(zaid,'DataTrack')
      if (dimsize .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'dimsize= he5_zadiminfo(zaid, "DataTrack")'
         write(*,*)'Size of dimension DataTrack ',dimsize
         write(1,*)'dimsize= he5_zadiminfo(zaid, "DataTrack")'
         write(1,*)'Size of dimension DataTrack ',dimsize
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zaread
!
      write(1,27)
      write(*,*)'Testing he5_zaread '
      write(*,*)'==================='
      write(1,*)'Testing he5_zaread '
      write(1,*)'==================='

      rd_start(1)=0
      rd_start(2)=0
      rd_stride(1)=1
      rd_stride(2)=1
      rd_edge(1)=40
      rd_edge(2)=100
      status= he5_zaread(zaid,'Conduction',rd_start,
     1rd_stride,rd_edge,temp)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Value returned by he5_zaread ',status
         write(*,*)'status= he5_zaread(zaid, "Conduction", 
     1rd_start,rd_stride, rd_edge, temp)'
         write(1,*)'status= he5_zaread(zaid, "Conduction", 
     1rd_start,rd_stride, rd_edge, temp)'
         write(1,*)'Value returned by he5_zaread ',status
         do 190 index1=10,15
            do 180 index2=10,15
               write(*,*)'value of conduction ',temp(index1,index2)
               write(1,*)'value of conduction ',temp(index1,index2)
  180       continue
  190    continue
      endif

      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zainfo
!
      write(1,27)
      write(*,*)'Testing he5_zainfo '
      write(*,*)'====================='
      write(1,*)'Testing he5_zainfo '
      write(1,*)'====================='
      status=he5_zainfo(zaid,'SideA',rank,sddims,nt,
     1dimens,maxdims)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zainfo(zaid, "SideA", 
     1rank, sddims, nt, dimens, maxdims)'
         write(*,*)'Value returned by he5_zainfo ',status
         write(*,*)'Rank of field sideA ',rank
         write(*,*)'dimension list of field sideA ',dimens
         write(*,*)'Size of sideA dimensions ',sddims
         write(*,*)'number type of field sideA ',nt
         write(1,*)'status= he5_zainfo(zaid, "SideA", 
     1rank, sddims, nt, dimens, maxdims)'
         write(1,*)'Value returned by he5_zainfo ',status
         write(1,*)'Rank of field sideA ',rank
         write(1,*)'dimension list of field sideA ',dimens
         write(1,*)'Size of sideA dimensions ',sddims
         write(1,*)'number type of field sideA ',nt
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zainqattrs
!
      write(1,27)
      write(*,*)'Testing he5_zainqattrs Global attributes '
      write(*,*)'==================================== '
      write(1,*)'Testing he5_zainqattrs Global attributes '
      write(1,*)'==================================== '

      nattr = he5_zainqattrs(zaid,attrlist,strbufsz2)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Number of global attributes in za ',nattr
         write(*,*)'Attribute list of za ',attrlist
         write(1,*)'Number of global attributes in za ',nattr
         write(1,*)'Attribute list of za ',attrlist
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zaattrinfo
!
      write(1,27)
      write(*,*)'Testing he5_zaattrinfo Global attribute'
      write(*,*)'======================================='
      write(1,*)'Testing he5_zaattrinfo Global attribute'
      write(1,*)'======================================='
      status= he5_zaattrinfo(zaid, attrlist, n, size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zaattrinfo(zaid,attrlist,n,size)'
         write(*,*)'Value returned by he5_zaattrinfo ',status
         write(*,*)'Number type of attributes ',n,' Size ',size
         write(1,*)'status=he5_zaattrinfo(zaid,attrlist,n,size)'
         write(1,*)'Value returned by he5_zaattrinfo ',status
         write(1,*)'Number type of attributes ',n,' Size ',size
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zardattr
!
      write(1,27)
      write(*,*)'Testing he5_zardattr, Global attribute '
      write(*,*)'======================================'
      write(1,*)'Testing he5_zardattr, Global attribute '
      write(1,*)'======================================'

      status= he5_zardattr(zaid, attrlist, rdattr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zardattr(zaid,attrlist,rdattr)'
         write(*,*)'Value returned by he5_zardattr ',status
         write(*,*)'attribute ',rdattr
         write(1,*)'status=he5_zardattr(zaid,attrlist,rdattr)'
         write(1,*)'Value returned by he5_zardattr ',status
         write(1,*)'attribute ',rdattr
      endif
      write(*,*)' '
      write(1,*)' '

!     Test Case -- he5_zainqgattrs
!
      write(1,27)
      write(*,*)'Testing he5_zainqgattrs Group attributes '
      write(*,*)'==================================== '
      write(1,*)'Testing he5_zainqgattrs Group attributes '
      write(1,*)'==================================== '

      nattr = he5_zainqgattrs(zaid,attrlist,strbufsz2)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Number of group attributes in za ',nattr
         write(*,*)'Attribute list of za ',attrlist
         write(1,*)'Number of group attributes in za ',nattr
         write(1,*)'Attribute list of za ',attrlist
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zagattrinfo
!
      write(1,27)
      write(*,*)'Testing he5_zagattrinfo Group attribute'
      write(*,*)'======================================='
      write(1,*)'Testing he5_zagattrinfo Group attribute'
      write(1,*)'======================================='
      status= he5_zagattrinfo(zaid, attrlist, n, size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zagattrinfo(zaid,attrlist,n,size)'
         write(*,*)'Value returned by he5_zagattrinfo ',status
         write(*,*)'Number type of attributes ',n,' Size ',size
         write(1,*)'status=he5_zagattrinfo(zaid,attrlist,n,size)'
         write(1,*)'Value returned by he5_zagattrinfo ',status
         write(1,*)'Number type of attributes ',n,' Size ',size
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zardgattr
!
      write(1,27)
      write(*,*)'Testing he5_zardgattr, Group attribute '
      write(*,*)'======================================'
      write(1,*)'Testing he5_zardgattr, Group attribute '
      write(1,*)'======================================'

       status= he5_zardgattr(zaid,'group',rdgnlattr)
       if (status .lt. zero) then
          write(*,230)
          write(1,230)
       else
          write(*,*)'  '
          write(*,240)
          write(1,*)'  '
          write(1,240)
          write(*,*)'status=he5_zardgattr(zaid,attrlist,rdgnlattr)'
          write(*,*)'Value returned by he5_zardgattr ',status
          write(*,*)'attribute ',rdgnlattr
          write(1,*)'status=he5_zardgattr(zaid,attrlist,rdgnlattr)'
          write(1,*)'Value returned by he5_zardgattr ',status
          write(1,*)'attribute ',rdgnlattr
       endif
       write(*,*)' '
       write(1,*)' '

! Test Case -- he5_zainqlattrs
!
      write(1,27)
      write(*,*)'Testing he5_zainqlattrs Local attributes '
      write(*,*)'==================================== '
      write(1,*)'Testing he5_zainqlattrs Local attributes '
      write(1,*)'==================================== '

      nattr=he5_zainqlattrs(zaid2,'Sensor1',attrlist,strbufsz2)
      if (nattr .lt. zero) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zainqlattrs(... "Sensor1" ...)'
         write(*,*)'Number of local attributes in field ',nattr
         write(*,*)'Attribute list of field ',attrlist
         write(1,*)'zainqlattrs(... "Sensor1" ...)'
         write(1,*)'Number of local attributes in field ',nattr
         write(1,*)'Attribute list of field ',attrlist
         write(*,*)' '
         write(1,*)' '
      endif

! Test Case -- he5_zalattrinfo
!
      write(1,27)
      write(*,*)'Testing he5_zalattrinfo Local attribute'
      write(*,*)'======================================='
      write(1,*)'Testing he5_zalattrinfo Local attribute'
      write(1,*)'======================================='
      status=he5_zalattrinfo(zaid2,'Sensor1','local',n,size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zalattrinfo(... "Sensor1" ...)'
         write(*,*)'Value returned by he5_zalattrinfo ',status
         write(*,*)'Number type of attributes ',n,' Size ',size
         write(1,*)'zalattrinfo(... "Sensor1" ...)'
         write(1,*)'Value returned by he5_zalattrinfo ',status
         write(1,*)'Number type of attributes ',n,' Size ',size
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zaidtype
!
      write(1,27)
      write(*,*)'Testing he5_zaidtype, Inquire Datatype '
      write(*,*)'======================================='
      write(1,*)'Testing he5_zaidtype, Inquire Datatype '
      write(1,*)'======================================='

      status= he5_zaidtype(zaid2,'Sensor1','local', 
     1HE5_HDFE_LOCATTRGROUP,dtype,classid, order, size)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaidtype(zaid2,"Sensor1","local", 
     1HE5_HDFE_LOCATTRGROUP,dtype, classid, order, size)'
         write(*,*)'Value returned by he5_zaidtype ',status
         write(*,*)'Datatype of local attribute ',dtype
         write(*,*)'Class id and order ',classid, order
         write(*,*)'Size of attribute ',size
         write(1,*)'status= he5_zaidtype(zaid2,"Sensor1","local", 
     1HE5_HDFE_LOCATTRGROUP,dtype, classid, order, size)'
         write(1,*)'Value returned by he5_zaidtype ',status
         write(1,*)'Datatype of local attribute ',dtype
         write(1,*)'Class id and order ',classid, order
         write(1,*)'Size of attribute ',size
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zardlattr
!
      write(1,27)
      write(*,*)'Testing he5_zardlattr, Local attribute '
      write(*,*)'======================================'
      write(1,*)'Testing he5_zardlattr, Local attribute '
      write(1,*)'======================================'

      status=he5_zardlattr(zaid2,'Sensor1','local',rdgnlattr)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zardlattr(zaid2,"Sensor1","local", 
     1rdgnlattr)'
         write(*,*)'Value returned by he5_zardlattr ',status
         write(*,*)'attribute ',rdgnlattr
         write(1,*)'status=he5_zardlattr(zaid2,"Sensor1","local", 
     1rdgnlattr)'
         write(1,*)'Value returned by he5_zardlattr ',status
         write(1,*)'attribute ',rdgnlattr
      endif
      write(*,*)' '
      write(1,*)' '

! Test Case -- he5_zagetfill
!
      write(1,27)
      write(*,*)'Testing he5_zagetfill '
      write(*,*)'====================='
      write(1,*)'Testing he5_zagetfill '
      write(1,*)'====================='
      status= he5_zagetfill(zaid,'Conduction', rdfilval)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zagetfill(zaid,"Conduction",rdfilval)'
         write(*,*)'Value returned by he5_zagetfill ',status
         write(*,*)'Value of fill ',rdfilval
         write(1,*)'status=he5_zagetfill(zaid,"Conduction",rdfilval)'
         write(1,*)'Value returned by he5_zagetfill ',status
         write(1,*)'Value of fill ',rdfilval
      endif
      write(*,*)' '
      write(1,*)' '



! Test Case -- he5_zacompinfo
!
      write(1,27)
      write(*,*)'Testing he5_zacompinfo '
      write(*,*)'======================='
      write(1,*)'Testing he5_zacompinfo '
      write(1,*)'======================='
      status=he5_zacompinfo(zaid,'CompChunk',compcode,rdcompparm)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status=he5_zacompinfo(zaid,"CompChunk",compcode, 
     1rdcompparm)'
         write(*,*)'Status returned by he5_zacompinfo ',status
         write(*,*)'Compression code ',compcode
         write(*,*)'Compression parameter ',rdcompparm(1)
         write(1,*)'status=he5_zacompinfo(zaid,"CompChunk",compcode, 
     1rdcompparm)'
         write(1,*)'Status returned by he5_zacompinfo ',status
         write(1,*)'Compression code ',compcode
         write(1,*)'Compression parameter ',rdcompparm(1)
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zadetach(zaid2)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)         
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zadetach(zaid2)'
         write(*,*)'Value returned by he5_zadetach ',status
         write(1,*)'status= he5_zadetach(zaid2)'
         write(1,*)'Value returned by he5_zadetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zaclose(zafid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaclose(zafid)'
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      zafid= he5_zaopen('za.he5',HE5F_ACC_RDWR)
      if (zafid .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(*,*)'Value returned by he5_zaopen ',zafid
         write(1,*)'zafid= he5_zaopen("za.he5",HE5F_ACC_RDWR)'
         write(1,*)'Value returned by he5_zaopen ',zafid
      endif
      write(*,*)' '
      write(1,*)' '


! Test Case -- he5_zainqza
!
      write(1,27)
      write(*,*)'Testing he5_zainqza '
      write(*,*)'======================'
      write(1,*)'Testing he5_zainqza '
      write(1,*)'======================'

      nza=he5_zainqza('za.he5',zalist,strbufsz2)
      if (nza .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'Retrieve information on zas in 
     1file za.he5'
         write(*,*)'Number of zas in file ', nza
         write(*,*)'List of zas ',zalist
         write(1,*)'Retrieve information on zas in 
     1file za.he5'
         write(1,*)'Number of zas in file ', nza
         write(1,*)'List of zas ',zalist
      endif
      write(*,*)' '
      write(1,*)' '

      status= he5_zaclose(zafid)
      if (status .lt. zero) then
         write(*,230)
         write(1,230)
      else
         write(*,*)'  '
         write(*,240)
         write(1,*)'  '
         write(1,240)
         write(*,*)'status= he5_zaclose(zafid)'
         write(*,*)'Value returned by he5_zaclose ',status
         write(1,*)'status= he5_zaclose(zafid)'
         write(1,*)'Value returned by he5_zaclose ',status
      endif
      write(*,*)' '
      write(1,*)' '

      close(unit=1)
   27 format(' ')
      stop
      end

      program       he5_pt_datainfoF_32

      implicit      none

      include       'hdfeos5.inc'

      integer       status
      integer       ptfid 
      integer       ptid       
      integer       he5_ptopen
      integer       he5_ptattach
      integer       he5_ptinqdatatype
      integer       he5_ptdetach 
      integer       he5_ptclose
      integer       dtype
      integer       classid
      integer       order
      integer       fieldgroup

      integer*4     size

      character*1   null_char_0
      character*80  fieldname
      character*80  attrname

      null_char_0  = '0'

c     Open the HDF point file, "point.he5"
c     ------------------------------------
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDONLY)
      write(*,*) 'File ID returned by he5_ptopen():  ',ptfid

c     Read Simple Point 
c     ----------------- 
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid

      fieldgroup = HE5_HDFE_DATAGROUP
      fieldname  = 'Observations'

      status = he5_ptinqdatatype(ptid,fieldname,null_char_0,fieldgroup,
     1dtype,classid,order,size)
      print *,'Status returned from he5_ptinqdatatype():  ',status
      print *,'datatype:     ',dtype
      print *,'class ID:     ',classid
      print *,'order:        ',order
      print *,'size:         ',size


      fieldgroup   = HE5_HDFE_ATTRGROUP
      attrname     = 'GlobalAttribute_int'

      status = he5_ptinqdatatype(ptid,null_char_0,attrname,fieldgroup,
     1dtype,classid,order,size)
      print *,'Status returned from he5_ptinqdatatype():  ',status
      print *,'datatype:     ',dtype
      print *,'class ID:     ',classid
      print *,'order:        ',order
      print *,'size:         ',size


      fieldgroup   = HE5_HDFE_GRPATTRGROUP
      attrname     = 'GroupAttribute'

      status = he5_ptinqdatatype(ptid,null_char_0,attrname,fieldgroup,
     1dtype,classid,order,size)
      print *,'Status returned from he5_ptinqdatatype():  ',status
      print *,'datatype:     ',dtype
      print *,'class ID:     ',classid
      print *,'order:        ',order
      print *,'size:         ',size


      fieldname    = 'Observations'
      fieldgroup   = HE5_HDFE_LOCATTRGROUP
      attrname     = 'LocalAttribute'

      status = he5_ptinqdatatype(ptid,fieldname,attrname,fieldgroup,
     1dtype,classid,order,size)
      print *,'Status returned from he5_ptinqdatatype():  ',status
      print *,'datatype:     ',dtype
      print *,'class ID:     ',classid
      print *,'order:        ',order
      print *,'size:         ',size


c     Close out the point interface
c     -----------------------------
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status

      status = he5_ptclose(ptfid)
      write(*,*) 'Status returned by he5_ptclose():  ',status

      stop
      end


 

      program       he5_pt_readattrsF_64

      implicit      none

      include       'hdfeos5.inc'

      integer       status
      integer       ptfid 
      integer       ptid
      integer       he5_ptopen
      integer       he5_ptattach
      integer       he5_ptinqattrs
      integer       he5_ptinqgrpattrs
      integer       he5_ptinqlocattrs
      integer       he5_ptattrinfo
      integer       he5_ptgrpattrinfo
      integer       he5_ptlocattrinfo
      integer       he5_ptreadattr
      integer       he5_ptreadgrpattr
      integer       he5_ptreadlocattr
      integer       he5_ptdetach 
      integer       he5_ptclose
      integer       attr
      integer       attr1(5)
      integer       attr2(5)
      integer       ntype

      integer*8     sz
      integer*8     strbufsize
      integer*8     nattr

      real*4        flt      

      character*1   null_char_0
      character*80  attrname
      character*80  levelname
      character*240 attrlist

      null_char_0  = '0'

c     Open the HDF-EOS point file, "point.he5"
c     ----------------------------------------
      ptfid = he5_ptopen('point.he5',HE5F_ACC_RDONLY)
      write(*,*) 'File ID returned by he5_ptopen():  ',ptfid

c     Read FixedBuoy Point 
c     -------------------- 
      ptid = he5_ptattach(ptfid, "FixedBuoy Point")
      write(*,*) 'Point ID returned by he5_ptattach():  ',ptid

c     Global Attributes
c     -----------------
      attrname       = 'GlobalAttribute_int'
             
      print *,'Global Attribute:   '
      status   = he5_ptreadattr(ptid,attrname,attr)
      write(*,*) 'Status returned by he5_ptreadattr():  ',status
      print *,'Attribute value:    ',attr

     
      nattr   = he5_ptinqattrs(ptid,null_char_0,strbufsize)
      print *,'Number of attributes:  ',nattr
      print *,'Size (in bytes) of attribute list:  ',strbufsize

      nattr   = he5_ptinqattrs(ptid,attrlist,strbufsize)
      print *,'Number of attributes:  ',nattr
      print *,'Attribute list:  ',attrlist

      attrname       = 'GlobalAttribute_int'

      status   = he5_ptattrinfo(ptid,attrname,ntype,sz)
      write(*,*) 'Status returned by he5_ptattrinfo():  ',status
      print *,'Data type of attribute:        ',ntype
      print *,'Number of attribute elements:  ',sz

      print *,'   '
      attrname       = 'GlobalAttribute_float'
      print *,'attrname:    ',attrname

      status   = he5_ptattrinfo(ptid,attrname,ntype,sz)
      write(*,*) 'Status returned by he5_ptattrinfo():  ',status
      print *,'Data type of attribute:        ',ntype
      print *,'Number of attribute elements:  ',sz

      status   = he5_ptreadattr(ptid,attrname,flt)
      write(*,*) 'Status returned by he5_ptreadattr():  ',status
      print *,'Attribute value:    ',flt

      attrname       = 'GroupAttribute'

c     Global Attributes
c     -----------------
      print *, 'Group Attribute:'
      status = he5_ptreadgrpattr(ptid,attrname,attr1)
      print *,'Status returned by he5_ptreadgrpattr():  ',status
      print *,'Attribute values:  ',attr1


      nattr = he5_ptinqgrpattrs(ptid,null_char_0,strbufsize)
      print *,'Number of attributes:               ',nattr
      print *,'Size (in bytes) of attribute list:  ',strbufsize
      nattr = he5_ptinqgrpattrs(ptid,attrlist,strbufsize)
      print *,'Attribute list:  ',attrlist

      attrname       = 'GroupAttribute'

      status   = he5_ptgrpattrinfo(ptid,attrname,ntype,sz)
      write(*,*) 'Status returned by he5_ptgrpattrinfo():  ',status
      print *,'Data type of attribute:        ',ntype
      print *,'Number of attribute elements:  ',sz
     
c     Local Attributes
c     ----------------
      print *, 'Local Attribute:'

      attrname       = 'LocalAttribute'
      levelname      = 'Observations'

      status = he5_ptreadlocattr(ptid,levelname,attrname,attr2)
      print *,'Status returned by he5_ptreadlocattr():  ',status
      print *,'Attribute values:  ',attr2

      nattr = he5_ptinqlocattrs(ptid,levelname,null_char_0,strbufsize)
      print *,'Status returned by he5_ptinqlocattrs():  ',status
      print *,'Number of attributes:               ',nattr
      print *,'Size (in bytes) of attribute list:  ',strbufsize

      nattr = he5_ptinqlocattrs(ptid,levelname,attrlist,strbufsize)
      print *,'Attribute list:  ',attrlist

      status = he5_ptlocattrinfo(ptid,levelname,attrname,ntype,sz)
      print *,'Data type of attribute:        ',ntype
      print *,'Number of attribute elements:  ',sz


c.....Close out the point interface
      status = he5_ptdetach(ptid)
      write(*,*) 'Status returned by he5_ptdetach():  ',status

      status = he5_ptclose(ptfid)
      write(*,*) 'Status returned by he5_ptclose():  ',status

      stop
      end

c     In this program we (1) open an HDF-EOS file, (2) create the 
c     swath interface, and (3) define the swath field dimensions
c     ===========================================================
      
      program    he5_sw_setupF_32

      implicit   none

      include    'hdfeos5.inc'

      integer    status
      integer    he5_swopen
      integer    he5_swcreate
      integer    he5_swdefdim
      integer    he5_swdefmap
      integer    he5_swdefimap
      integer    he5_swdetach
      integer    he5_swclose
      integer    swfid, swid

      integer*4  dtrack, extdata
      integer*4  offset, incr
      integer*4  indx(12) 

      data indx  /0,1,3,6,7,8,11,12,14,24,32,39/

c     Open the HDF-EOS file, "swath.he5" using "TRUNC" file access code 
c     -----------------------------------------------------------------
      swfid = he5_swopen('swath.he5',HE5F_ACC_TRUNC)
      write(*,*) 'File ID returned by he5_swopen():  ',swfid

c     Create the swath, "Swath1", within the file 
c     -------------------------------------------
      swid = he5_swcreate(swfid, "Swath1")
      write(*,*) 'Swath ID returned by he5_swcreate():  ',swid
    
c     Define Geolocation and Data dimensions
c     --------------------------------------
c     ----------------------------------------------------------------------
c     Typically, many fields within a swath share the same dimension. The
c     swath interface therefore provides a way of defining dimensions that
c     will then be used to define swath fields.  A dimension is defined with
c     a name and a size and is connected to the particular swath through the
c     swath id.  In this example, we define the geo- location track and
c     cross track dimensions with size 20 and 10 respectively and two
c     dimensions corresponding to these but with twice the resolution.
c     Also, we define "Bands" and "unlimited" dimensions.
c     ----------------------------------------------------------------------
      dtrack = 20
      status = he5_swdefdim(swid, "GeoTrack", dtrack)
      write(*,*) 'Status returned by he5_swdefdim():  ',status

      dtrack = 10
      status = he5_swdefdim(swid, "GeoXtrack", dtrack)
      write(*,*) 'Status returned by he5_swdefdim():  ',status

      dtrack = 40
      status = he5_swdefdim(swid, "Res2tr", dtrack)
      write(*,*) 'Status returned by he5_swdefdim():  ',status

      dtrack = 20
      status = he5_swdefdim(swid, "Res2xtr", dtrack)
      write(*,*) 'Status returned by he5_swdefdim():  ',status

      dtrack = 15
      status = he5_swdefdim(swid, "Bands", dtrack)
      write(*,*) 'Status returned by he5_swdefdim():  ',status

      dtrack = 12
      status = he5_swdefdim(swid, "IndxTrack", dtrack)
      write(*,*) 'Status returned by he5_swdefdim():  ',status

      dtrack = 4
      status = he5_swdefdim(swid, "ProfDim", dtrack)
      write(*,*) 'Status returned by he5_swdefdim():  ',status

c     Define "External" dimension
c     ---------------------------
      extdata = 60
      status = he5_swdefdim(swid, "ExtDim", extdata)
      write(*,*) 'Status returned by he5_swdefdim():  ',status

c     Define Unlimited (appendable) dimension
c     ---------------------------------------
      status = he5_swdefdim(swid, "Unlim", HE5S_UNLIMITED_F)
      write(*,*) 'Status returned by he5_swdefdim():  ',status

c     ----------------------------------------------------------------------
c     Once the dimensions are defined, the relationship (mapping)between the
c     geolocation dimensions, such as track and cross track, and the data
c     dimensions, must be established.  This is done through the SWdefdimmap
c     routine.  It takes as input the swath id, the names of the dimensions
c     designating the geolocation and data dimensions, respectively, and the
c     offset and increment defining the relation.
c     
c     In the first example we relate the "GeoTrack" and "Res2tr" dimensions
c     with an offset of 0 and an increment of 2.  Thus the ith element of
c     "Geotrack" corresponds to the 2 * ith element of "Res2tr".
c   
c     In the second example, the ith element of "GeoXtrack" corresponds to 
c     the 2 * ith + 1 element of "Res2xtr".
c     -----------------------------------------------------------------------  
      
c     Define dimension mappings
c     -------------------------
      offset = 0
      incr   = 2
      status = he5_swdefmap(swid, "GeoTrack", 
     1     "Res2tr", offset, incr)
      write(*,*) 'Status returned by he5_swdefmap():  ',status

      offset = 1
      status = he5_swdefmap(swid, "GeoXtrack", 
     1     "Res2xtr", offset, incr)
      write(*,*) 'Status returned by he5_swdefmap():  ',status

c     Define indexed dimension mapping
c     --------------------------------
      status = he5_swdefimap(swid, "IndxTrack", 
     1     "Res2tr", indx)
      write(*,*) 'Status returned by he5_swdefimap():  ',status

c     Detach from the swath
c     ---------------------
      status = he5_swdetach(swid)
      write(*,*) 'Status returned by he5_swdetach():  ',status

c     Close the swath file
c     --------------------
      status = he5_swclose(swfid)
      write(*,*) 'Status returned by he5_swclose():  ',status

      stop
      end

      program     he5_sw_writedimscaleF_32
! This code creates fields and with just one call to HE5_SWdefdimscale creates dimmension scales
! for all fields that share the same dimension (both geofoelds and datafields). You need to call
! he5_sw_setupF_32 only before calling the he5_sw_definefields_and_all_dimscalesF_32
      implicit    none

      include     'hdfeos5.inc'

      integer     status
      integer     i, j
      integer     he5_swopen
      integer     he5_swattach
      integer     he5_swsetfill
      integer     he5_swdefgfld
      integer     he5_prdefine
      integer     he5_swdefdfld
      integer     he5_swdefchunk
      integer     he5_swdefcomp
      integer     he5_swdetach
      integer     he5_swclose
      integer     he5_szip_can_encode
      integer     HE5_SWsetdimscale
      integer     HE5_SWwritedscaleattr
      integer     HE5_SWdefdimscale

      integer     swfid,swid1
      integer*4   datbuf_i1
      integer*4   datbuf_i(15)
      integer*4   count(2)
      integer*4   nbands
      integer     bands(3)
      integer*4   datbuf_i2(3)
      integer     xdim, ydim, ntime
      integer     data(15)
      integer     data2(20)
      integer     FAIL
      parameter   (FAIL=-1)
      integer     nscanline
      real*8      fillval1
      integer     fillval2
      integer     chunkrank
      integer     canenc
      integer*4   chunkdims(3)
      integer*4   chunk_dims(3)
      integer     compparm(1)
      integer     comp_code 
      integer     comp_level(1)

      fillval1 = -1.11111    
      fillval1 = -9999
   

      do i=1,15
         data(i) = i*2-1
      enddo
      do i=1,20
         data2(i) = i*3-1
      enddo

      swfid = HE5_SWopen("swath.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_swopen(): ',swfid
!  /*
!   * If the swath file cannot be found, HE5_SWopen will return -1 for the file
!   * handle (swfid).  We there check that this is not the case before
!   * proceeding with the other routines.
!   * 
!   * The HE5_SWattach routine returns the handle to the existing swath "Swath1",
!   * SWid.  If the swath is not found, HE5_SWattach returns -1 for the handle.
!   */ 

      if (swfid .ne. FAIL) then
 
         SWid1 = HE5_SWattach(swfid, "Swath1")
         write(*,*) 'Swath ID returned by he5_swattach(): ',swid1

!      /* the field Spectra has Bands,Res2tr,Res2xtr dimensions. 
!	 xdim = 120
!	 ydim = 200
!	 Time dim is set to 10
!      */

         if (SWid1 .eq. -1) then
            
            write(*,*) 'Error: Cannot attach to swath Swath1. Stpped.'
            status = HE5_SWclose(swfid)
            stop
            
         endif

!	  /*
!	   * We define seven fields.  The first three, "Time", "Longitude"
!	   * and "Latitude" are geolocation fields and thus we use the
!	   * geolocation dimensions "GeoTrack" and "GeoXtrack" in the field
!	   * definitions.
!	   * 
!	   * The next four fields are data fields.  Note that either
!	   * geolocation or data dimensions can be used.
!	   */
	  
        status = he5_swsetfill(SWid1,"Time",HE5T_NATIVE_DOUBLE,
     1    fillval1)
	write(*,*) 'Status returned by HE5_SWsetfillvalue',
     1   '(...,Time,...) :    ', status
	  
        status = he5_swdefgfld(SWid1, "Time", "GeoTrack", 
     1     " ", HE5T_NATIVE_DOUBLE, 0)
	write(*,*) 'Status returned by HE5_SWdefgeofield',
     1   '(...,Time,...) :    ', status
	  
	status = he5_swdefgfld(SWid1, "Longitude", 
     1     "GeoTrack,GeoXtrack", " ", HE5T_NATIVE_FLOAT, 0)
	write(*,*) 'Status returned by HE5_SWdefgeofield',
     1   '(...,Longitude,...) :    ', status
	  
	status = he5_swdefgfld(SWid1, "Latitude", 
     1     "GeoTrack,GeoXtrack", " ", HE5T_NATIVE_FLOAT, 0)
	write(*,*) 'Status returned by HE5_SWdefgeofield',
     1   '(...,Latitude,...) :    ', status
        status = he5_swsetfill(SWid1,"Test_string",HE5T_NATIVE_CHAR,
     1           'missing')	  
	write(*,*) 'Status returned by HE5_SWsetfillvalue',
     1   '(...,Test_string,...) :    ', status
	  
	status = he5_swdefdfld(SWid1, "Test_string", "GeoXtrack", 
     1     " ", HE5T_CHARSTRING, 0)
	write(*,*) 'Status returned by HE5_SWdefdatafield',
     1   '(...,Test_string,...) :    ', status
	  
	status = he5_swsetfill(SWid1,"Density",
     1     HE5T_NATIVE_INT, fillval2)
	write(*,*) 'Status returned by HE5_SWsetfillvalue',
     1   '(...,Density,...) :    ', status
	  
	status = he5_swdefdfld(SWid1, "Density", "GeoTrack", 
     1     " ", HE5T_NATIVE_INT, 0)
	write(*,*) 'Status returned by HE5_SWdefdatafield',
     1   '(...Density,...) :    ', status
	  
	status = he5_swdefdfld(SWid1, "Temperature", 
     1      "GeoTrack,GeoXtrack", " ", HE5T_NATIVE_FLOAT, 0)
     	write(*,*) 'Status returned by HE5_SWdefdatafield',
     1   '(...Temperature,...) :    ', status

	chunkrank = 1
	comp_level(1) =0	  
	chunk_dims(1) = 40
	  
	status = he5_swdefchunk(SWid1, chunkrank, chunk_dims)
	write(*,*) 'Status returned by HE5_SWdefchunk() :    ',
     1   status
	  
	status = HE5_SWdefcomp(SWid1,HE5_HDFE_COMP_NONE,comp_level)
	status = he5_swdefdfld(SWid1, "Pressure", "Res2tr", " ", 
     1    HE5T_NATIVE_FLOAT, 0)
	write(*,*) '"Status returned by HE5_SWdefdatafield',
     1   '(...,Pressure,...):    ',status
	  
c	  /* Define Appendable Field */
c	  /* ----------------------- */
c	  
c	  /*           First, define chunking          */
c	  /* (the appendable dataset must be chunked)  */
c	  /* ----------------------------------------  */

        chunkrank = 3
        chunk_dims(1) = 20
        chunk_dims(2) = 40
        chunk_dims(3) = 15
        compparm(1) = 6
        
        status = HE5_SWdefchunk(SWid1, chunkrank, chunk_dims)
        write(*,*) 'Status returned by HE5_SWdefchunk() :    ',
     1       status
	  
c	  /* Second, define compression scheme */
c	  /* --------------------------------- */ 
c	  
c	  /* set the value of compression code: */
c	  /*  HDFE_COMP_NONE                  0 */
c	  /*  HDFE_COMP_RLE                   1 */   
c	  /*  HDFE_COMP_NBIT                  2 */   
c	  /*  HDFE_COMP_SKPHUFF               3 */   
c	  /*  HDFE_COMP_DEFLATE               4 */           
c	  /*  HDFE_COMP_SZIP_CHIP             5 */
c	  /*  HDFE_COMP_SZIP_K13              6 */
c	  /*  HDFE_COMP_SZIP_EC               7 */
c	  /*  HDFE_COMP_SZIP_NN               8 */
c	  /*  HDFE_COMP_SZIP_K13orEC          9 */
c	  /*  HDFE_COMP_SZIP_K13orNN          10 */
c	  /*  HDFE_COMP_SHUF_DEFLATE          11 */
c	  /*  HDFE_COMP_SHUF_SZIP_CHIP        12 */
c	  /*  HDFE_COMP_SHUF_SZIP_K13         13 */
c	  /*  HDFE_COMP_SHUF_SZIP_EC          14 */
c	  /*  HDFE_COMP_SHUF_SZIP_NN          15 */
c	  /*  HDFE_COMP_SHUF_SZIP_K13orEC     16 */
c	  /*  HDFE_COMP_SHUF_SZIP_K13orNN     17 */
	  
        comp_code = 16
        
        canenc = he5_szip_can_encode()
        if (canenc .ne. 0) then	  
           status = HE5_SWdefcomp(SWid1,
     1          HE5_HDFE_COMP_SHUF_SZIP_K13orEC,compparm)
           write(*,*) 'Status returned by he5_swdefcomp():  ',
     1          status
        else
           write(*,*) 'SZIP encoder is not available.'
           write(*,*) 'The data compression test is skipped.'
        endif
        
        
        status = he5_swdefdfld(SWid1, "Spectra", 
     1       "Res2xtr,Res2tr,Bands", " ", HE5T_NATIVE_FLOAT, 0)
c     status = he5_swdefdfld(SWid1, "Spectra", 
c     1           "Bands,Res2tr,Res2xtr", " ", HE5T_NATIVE_FLOAT, 0)
        write(*,*) '"Status returned by HE5_SWdefdatafield',
     1       '(...,Spectra,...) :    ',status
	  
c     Define Profile Field
c     -----------------------  
        status = he5_prdefine(SWid1, "Profile-2000", 
     1       "ProfDim", " ", HE5T_NATIVE_INT)
        write(*,*) 'Status returned by he5_prdefine():  ',status
        
        chunk_dims(1) = 20
        chunkrank = 1

        status = HE5_SWdefchunk(SWid1, chunkrank, chunk_dims)
        write(*,*) 'Status returned by HE5_SWdefchunk() :   ',status
        
c     Define Appendable Field
c     -----------------------  
        status = he5_swdefdfld(SWid1, "Count", "GeoTrack",
     1       "Unlim", HE5T_NATIVE_INT, 0)	      
        
      endif
      
      
c     Detach from the swath
c     ---------------------      
      status = he5_swdetach(SWid1)
      write(*,*) 'Status returned by he5_swdetach():  ',status 
      
c     Close the file
c     --------------      
      status = he5_swclose(swfid)
      write(*,*) 'Status returned by he5_swclose():  ',status  

      swfid = HE5_SWopen("swath.he5", HE5F_ACC_RDWR)
      SWid1 = HE5_SWattach(swfid, "Swath1")


      if (SWid1 .NE. FAIL) then
c     /*define one call dimscale setup for "GeoTrack" in all fields in Swath1 */
         nscanline = 20
         status = HE5_SWdefdimscale2(SWid1, "GeoTrack", "geotrack",
     1		nscanline, HE5T_NATIVE_INT, data2)
         if (status .EQ. -1) then
            write(*,*) 'Error: Cannot define Dimension Scale',
     1           ' for GeoTrack  dimemnsion '
            status = HE5_SWdetach(SWid1)
            status = HE5_SWclose(swfid)
            stop
         else
            write(*,*) 'Status returned by HE5_SWdefdimscale(): ',
     1          'GeoTrack: ', status
            
         endif

         count(1)= 12
         status = HE5_SWwritedscaleattr(SWid1, "GeoTrack", "label", 
     1        HE5T_NATIVE_CHAR, count, "GeoTrack Dim")
         if (status .EQ.  -1) then
            write(*,*) 'Error: Cannot define Dimension Scale label',
     1           ' strs for GeoTrack dimemnsion'
            status = HE5_SWdetach(SWid1)
            status = HE5_SWclose(swfid)
            stop
         else
            write(*,*) 'Status returned by ',
     1           'HE5_SWwritedscaleattr(): label: ',status
         endif

c	  /*define one call dimscale setup for "Bnds" in all fields in Swath1 */
	  nbands = 15
	  status = HE5_SWdefdimscale(SWid1, "Bands", 
     1         nbands, HE5T_NATIVE_INT, data)
	  if (status  .EQ.  -1) then
             write(*,*) 'Error: Cannot define Dimension Scale label',
     1           ' strs for Bands dimemnsion'
	      status = HE5_SWdetach(SWid1)
	      status = HE5_SWclose(swfid)
	      stop
           else
	      write(*,*) 'Status returned by HE5_SWdefdimscale():',
     1             'Bands: ',status
           endif

	  count(1)= 9
	  status = HE5_SWwritedscaleattr(SWid1, "Bands", "label", 
     1         HE5T_NATIVE_CHAR, count, "Bands Dim")
	  if (status  .EQ.  -1) then
             write(*,*) 'Error: Cannot define Dimension Scale label',
     1            ' strs for Bands dimemnsion'
             status = HE5_SWdetach(SWid1)
             status = HE5_SWclose(swfid)
	     stop
	  else
	      write(*,*) 'Status returned by HE5_SWwritedscaleattr():',
     1            'label: ' ,status
           endif

	  count(1) = 4
	  status = HE5_SWwritedscaleattr(SWid1, "Bands", "unit", 
     1         HE5T_NATIVE_CHAR, count, "None")
	  if (status  .EQ.  -1) then
	      write(*,*) '"Error: Cannot define Dimension Scale',
     1            ' unit strs for Bands dimemnsion'
	      status = HE5_SWdetach(SWid1)
	      status = HE5_SWclose(swfid)
	      STOP
	  else
	      write(*,*) 'Status returned by HE5_SWwritedscaleattr():',
     1            ' unit: ',status
           endif

	  count(1)= 2
	  status = HE5_SWwritedscaleattr(SWid1, "Bands", "format", 
     1         HE5T_NATIVE_CHAR, count, "I2")
	  if (status  .EQ.  -1) then
	      write(*,*) 'Error: Cannot define Dimension Scale',
     1           ' format strs for Bands dimemnsion'
	      status = HE5_SWdetach(SWid1)
	      status = HE5_SWclose(swfid)
	      stop
	  else
	      write(*,*) 'Status returned by HE5_SWwritedscaleattr(): ',
     1            'format: ',status
           endif

	  datbuf_i1 = -999
	  count(1) = 1

	  status = he5_swwritedscaleattr(SWid1, "Bands", "MissingValue", 
     1         HE5T_NATIVE_INT, count, datbuf_i1)
	  if (status  .EQ.  -1) then
	      write(*,*) 'Error: Cannot define Dimension Scale ',
     1            'MissingValue for Bands dimemnsion'
	      status = HE5_SWdetach(SWid1)
	      status = HE5_SWclose(swfid)
              stop
	  else
	      write(*,*) 'Status returned by HE5_SWwritedscaleattr(): ',
     1            'MissingValue: ',status
           endif

	  datbuf_i2(1) = -999
	  datbuf_i2(2) = 0
	  datbuf_i2(3) = 999
	  count(1) = 3

	  status = HE5_SWwritedscaleattr(SWid1, "Bands", "IntValues", 
     1         HE5T_NATIVE_INT, count, datbuf_i2)
	  if (status  .EQ.  -1) then
	      write(*,*) 'Error: Cannot define Dimension Scale',
     1            ' IntValues for Bands dimemnsion'
	      status = HE5_SWdetach(SWid1)
	      status = HE5_SWclose(swfid)
	      stop
	  else
	      write(*,*) 'Status returned by HE5_SWwritedscaleattr():',
     1            ' IntValues: ',status
           endif
	endif
       status = HE5_SWdetach(SWid1)
      status = HE5_SWclose(swfid)
  
      stop
      end PROGRAM

      program     he5_gd_writedimscaleF_32

      implicit    none

      include     'hdfeos5.inc'

      integer     status
      integer     i, j
      integer     he5_gdopen
      integer     he5_gdattach
      integer     he5_gdwrfld
      integer     he5_gdwrattr
      integer     he5_gdwrgattr
      integer     he5_ehwrglatt
      integer     he5_gdwrlattr 
      integer     he5_gddetach
      integer     he5_gdclose
      integer     HE5_GDsetdimscale
      integer     HE5_GDwritedscaleattr
      integer     he5_gddeffld

      integer     gdfid,gdid1,gdid2,gdid3
      real*4      datbuf_f(1) 
      integer*4   datbuf_i(3)
      real*4      veg1(120),veg2(200), temp1(100),temp2(100)
      real*4      geospecf(4)
      integer*4   nbands
      integer     bands(3)
      integer*4   datbuf_i2(2)
      integer     count(2)
      integer     xdim, ydim, ntime
      integer     data(10)
      integer     FAIL
      parameter   (FAIL=-1)

      integer     lon= 20;
      real*4      lonarray[20];

      do j=1,20
         lonarray(j)=1.1 * (j+1)*2
      enddo

!  /*
!   * We first open the HDF-EOS grid file, "Grid.h5".  Because this file
!   * already exist and we wish to write to it, we use the H5F_ACC_RDWR access
!   * code in the open statement.  The HE5_GDopen routine returns the grid file
!   * id, gdfid, which is used to identify the file in subsequent routines.
!   */ 
      do j=1,10
         data(j)=(j+1)*2
      enddo

      gdfid = HE5_GDopen("grid.he5", HE5F_ACC_RDWR)
      write(*,*) 'File ID returned by he5_gdopen(): ',gdfid
!  /*
!   * If the grid file cannot be found, HE5_GDopen will return -1 for the file
!   * handle (gdfid).  We there check that this is not the case before
!   * proceeding with the other routines.
!   * 
!   * The HE5_GDattach routine returns the handle to the existing grid "Grid1",
!   * GDid.  If the grid is not found, HE5_GDattach returns -1 for the handle.
!   */ 

      if (gdfid .ne. FAIL) then
 
         GDid1 = HE5_GDattach(gdfid, "UTMGrid")
         write(*,*) 'Grid ID returned by he5_gdattach(): ',gdid1

!   /* the field Pollution has Time,YDim,XDim dimensions. 
!    * xdim = 120
!    * ydim = 200
!    * Time dim is set to 10
!    */

         if (GDid1 .eq. -1) then
            
            write(*,*) 'Error: Cannot attach to grid UTMGrid. Stpped.'
            status = HE5_GDclose(gdfid)
            stop
            
         endif
         
         xdim = 120
         ydim = 200 
         ntime = 10
         
         status = HE5_GDsetdimscale2(GDid1, "Pollution", "XDim", 
     1       "lon", lon, HE5T_NATIVE_FLOAT, lonarray)
         write(*,*) 'Status returned by HE5_GDsetdimscale: ',status
         
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale for XDim',
     1                ' dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         status = HE5_GDsetdimscale(GDid1, "Pollution", "Time", ntime,
     1                               HE5T_NATIVE_INT, data)
         write(*,*) 'Status returned by HE5_GDsetdimscale: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale for Time',
     1           ' dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         status = HE5_GDsetdimscale(GDid1, "Vegetation", "XDim", xdim,
     1                               HE5T_NATIVE_DOUBLE, veg1)
         write(*,*) 'Status returned by HE5_GDsetdimscale: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale for XDim',
     1                 ' dimemnsion in field Vegetation'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif

         status = HE5_GDsetdimscale2(GDid1, "Vegetation", "YDim", "lat", ydim,
     1                               HE5T_NATIVE_DOUBLE, veg2)
         write(*,*) 'Status returned by HE5_GDsetdimscale: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale for XDim',
     1                 ' dimemnsion in field Vegetation'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif

         count(1)= 12
         status = HE5_GDwritedscaleattr(GDid1, "XDim", "label", 
     1                         HE5T_NATIVE_CHAR, count, "X Dimension")
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale strs for XDim',
     1                ' dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         count(1)= 6
         status = HE5_GDwritedscaleattr(GDid1, "XDim", "unit", 
     1                              HE5T_NATIVE_CHAR, count, "meters")
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale strs for XDim',
     1                 ' dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         count(1)= 4
         status = HE5_GDwritedscaleattr(GDid1, "XDim", "format", 
     1                                 HE5T_NATIVE_CHAR, count, "F7.2")
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale strs for XDim',
     1                 ' dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status =  HE5_GDclose(gdfid)
            stop
         endif
         
         datbuf_f(1) =  -999.0
         count(1)= 1
         status = HE5_GDwritedscaleattr(GDid1, "XDim", "MissingValue",
     1                               HE5T_NATIVE_FLOAT, count, datbuf_f)
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale strs for XDim',
     1                 ' dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         datbuf_i(1) =  -999
         datbuf_i(2) =  0
         datbuf_i(3) =  999


         count(1)= 3
         status = HE5_GDwritedscaleattr(GDid1, "XDim", "IntValues", 
     1                               HE5T_NATIVE_INT, count, datbuf_i)
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error:Cannot set Dimension Scale strs for XDim',
     1         ' dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         count(1)= 8
         status = HE5_GDwritedscaleattr(GDid1, "Time", "label", 
     1                             HE5T_NATIVE_CHAR, count, "Time Dim")
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale strs for',
     1                ' Time dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         count(1)= 1
         status = HE5_GDwritedscaleattr(GDid1, "Time", "unit", 
     1                                 HE5T_NATIVE_CHAR, count, "s")
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale strs for',
     1                ' Time dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         count(1)= 4
         status = HE5_GDwritedscaleattr(GDid1, "Time", "format", 
     1                                HE5T_NATIVE_CHAR, count, "F2.3")
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale strs for',
     1                ' Time dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         datbuf_i2(1) =  -999
         datbuf_i2(2) =  999
         count(1) = 2
         status = HE5_GDwritedscaleattr(GDid1, "Time", "MissingValue", 
     1                                HE5T_NATIVE_INT, count, datbuf_i2)
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale strs for',
     1                ' Time dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid1)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         status = HE5_GDdetach(GDid1)
         write(*,*) 'Status returned by he5_gddetach(): ',status

! -----------------------------------------------------------------

!         /* the field Spectra has Bands,YDim,XDim dimensions. 
!	 xdim = 100
!	 ydim = 100
!	 Bands dim is set to 3
!         */
!         
         GDid2 = HE5_GDattach(gdfid, "PolarGrid")
         write(*,*) 'Grid ID returned by he5_gdattach(): ',gdid2
         if (GDid2 .eq. -1) then
            
            write(*,*) 'Error: Cannot attach to grid PolarGrid'
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         ydim = 100
         nbands = 3
         
         status = HE5_GDsetdimscale(GDid2, "Spectra", "YDim", ydim, 
     1                              HE5T_NATIVE_DOUBLE, temp1)
         write(*,*) 'Status returned by HE5_GDsetdimscale: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale for YDim',
     1                 ' dimemnsion in field Spectra'
            status = HE5_GDdetach(GDid2)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         bands(1) = 5
         bands(2) = 8
         bands(3) = 9

         status = HE5_GDsetdimscale(GDid2, "Spectra", "Bands", 
     1                               nbands, HE5T_NATIVE_INT, bands)
         write(*,*) 'Status returned by HE5_GDsetdimscale: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale for',
     1                ' Bands dimemnsion in field Spectra'
            status = HE5_GDdetach(GDid2)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         count(1)= 5
         status = HE5_GDwritedscaleattr(GDid2, "YDim", "Label", 
     1                              HE5T_NATIVE_CHAR, count, "Y Dim")
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale strs for',
     1                ' XDim dimemnsion in field Pollution'
            status = HE5_GDdetach(GDid2)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         count(1) = 4
         status = HE5_GDwritedscaleattr(GDid2, "Bands", "Units", 
     1                                HE5T_NATIVE_CHAR, count, "None")
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
            write(*,*) 'Error: Cannot set Dimension Scale strs for',
     1                ' Time dimemnsion in field Pollution '
            status = HE5_GDdetach(GDid2)
            status = HE5_GDclose(gdfid)
            stop
         endif
         
         status = HE5_GDdetach(GDid2)
! -----------------------------------------------------------------         
         xdim = 60
         ydim = 40

         GDid3 = HE5_GDattach(gdfid, "GEOGrid")
         write(*,*) 'Grid ID returned by he5_gdattach(): ',GDid3
         if (GDid3 .eq. -1) then
            
	    write(*,*) 'Error: Cannot attach to grid GEOGrid'
            status = HE5_GDclose(gdfid)
	    stop
         endif


!     Define Fields
!     -------------	  
         status = he5_gddeffld(gdid3, "GeoSpectra", "XDim,YDim",
     1     " ", HE5T_NATIVE_FLOAT, 0)
         write(*,*) 'Status returned by he5_gddeffld(): ',status

         status = HE5_GDsetdimscale(GDid3, "GeoSpectra", "YDim", 
     1                         ydim, HE5T_NATIVE_DOUBLE, GeoSpecf)
         write(*,*) 'Status returned by HE5_GDsetdimscale: ',status
         if (status .eq. -1) then
            
	    write(*,*) 'Error: Cannot set Dimension Scale for',
     1                ' YDim dimemnsion in field GeoSpectra'
            status = HE5_GDdetach(GDid3)
            status = HE5_GDclose(gdfid)
	    stop
         endif
         
         count(1) = 15
         status = HE5_GDwritedscaleattr(GDid3, "YDim", "Units", 
     1                    HE5T_NATIVE_CHAR, count, "Decimal Degrees")
         write(*,*) 'Status returned by HE5_GDwritedscaleattr: ',status
         if (status .eq. -1) then
            
	    write(*,*) 'Error: Cannot set Dimension Scale strs for',
     1                ' YDim dimemnsion in field GeoSpectra'
            status = HE5_GDdetach(GDid3)
            status = HE5_GDclose(gdfid)
	    stop
         endif
         
         
         status = HE5_GDdetach(GDid3)
         write(*,*) 'Status returned by he5_gddetach(): ',status
         status = HE5_GDclose(gdfid)
         write(*,*) 'Status returned by he5_gdclose(): ',status

      endif
      stop
      end

#!/bin/csh -f
#-----------------------------------------------------------------------------
# file:         hediff.csh
#
# description:
#       Shell script to compare two hdf output files, removing
#       differences caused by time/date stamps, host names
#       missing leading zeros, and other values that change 
#       over time
#
# usage:
#       hediff.csh sample_hefile_name.he5 hefile_name.he5...
#
# author:
#       Abe Taaheri
#
# history:
#       11-Jul-2014 AT  Initial version for hdfeos5
#
#
#   Inputs:
#     $1 = sample_hefile_name.he5
#     $2 = hefile_name.he5
#
#
  if ( ! -r $1 ) then
	echo "ERROR - unable to read input file $1"
	exit -1
  endif
#
  if ( ! -r $2 ) then
	echo "ERROR - unable to read input file $2"
	exit -1
  endif
#
#    set filen ="`basename $2 .he5`"
  set filen1 = "$1"
  set filen2 = "$2"
#
  set sample_temp = "/tmp/$$.sample"
  set out_temp    = "/tmp/$$.out"
  set sample_temp_orig = "/tmp/$$.sample_orig"
  set out_temp_orig    = "/tmp/$$.out_orig"
#
# dump he5 files onto ascii files
#
${HDFBIN}/h5dump $2 > &! ${sample_temp_orig}
${HDFBIN}/h5dump $1 > &! ${out_temp_orig}

     \rm -f $sample_temp $out_temp
     sed -e "/netcdf/d" \
			$sample_temp_orig > $sample_temp
     sed -e "/netcdf/d" \
                        $out_temp_orig > $out_temp


diff -bw $out_temp $sample_temp
\rm -f $sample_temp $out_temp
\rm -f $sample_temp_orig $out_temp_orig

echo " diff of $filen1 and $filen2 done"
